*************************************************************
*
* fafcvars.F
*   Author: Michael Rauch <rauch@particle.uni-karlsruhe.de>
*   Created:       September 2010
*   Last modified: September 2010
*
* Copy VBFNLO variables into FormCalc variables
*
*************************************************************

      subroutine fafcvars

      implicit none

#include "model.h"
#include "VBFNLO/utilities/scales.inc"

      integer t,g

ccc from koppln.inc
      double precision  vbfalfas, xmt, vbfalfa, xmz, xmw, sin2w, xmh, vbfgf
      common /bkopin/   vbfalfas, xmt, vbfalfa, xmz, xmw, sin2w, xmh, vbfgf
      double precision  clr, xm2, xmg, b, v, a
      COMMON /BKOPOU/   CLR(4,5,-1:1),XM2(6),XMG(6),B(6,6,6),
     1                  V(4,5),A(4,5)

c  xmb = mb pole mass,   BMASS_H = mb(m_H) etc.
      double precision xmb, BMASS_H, xmc, CMASS_H 
      common /quarkmasses/ xmb, BMASS_H, xmc, CMASS_H 

c set masses which are originally parameters in model.h
      MZ = xmz
      MZ2 = MZ**2
      GammaZ = xmg(2)/sqrt(xm2(2))
      MW = xmw
      MW2 = MW**2
      GammaW = xmg(3)/sqrt(xm2(3))
      CW = MW/MZ
      CW2 = CW**2
      SW2 = 1 - CW2
      Alfa = vbfalfa
      Alfa2 = Alfa**2
      Alfas = als(1,1)
      Alfas2 = Alfas**2
      GS = sqrt(4*pi*Alfas)
      gf = vbfgf
      MT = xmt
      MT2 = MT**2
      MB = xmb
      MB2 = MB**2
      MH = xmh
      MH2 = MH**2
      GammaH = xmg(6)/sqrt(xm2(6))

c settings from FormCalc model_sm.F
c CKM matrix is unity
      CKMlambda = 0
      CKMA = 0
      CKMrhoeta = 0

      CKM(1,1) = 1
      CKM(2,2) = 1
      CKM(3,3) = 1
      CKM(2,1) = 0
      CKM(3,1) = 0
      CKM(1,2) = 0
      CKM(3,2) = 0
      CKM(1,3) = 0
      CKM(2,3) = 0

c fermion masses
      Mf(1,1) = 0
      Mf(2,1) = ME
      Mf(3,1) = MU
      Mf(4,1) = MD
      Mf(1,2) = 0
      Mf(2,2) = MM
      Mf(3,2) = MC
      Mf(4,2) = MS
      Mf(1,3) = 0
      Mf(2,3) = ML
      Mf(3,3) = MT
      Mf(4,3) = MB
      Mf2(1,1) = 0
      Mf2(2,1) = ME2
      Mf2(3,1) = MU2
      Mf2(4,1) = MD2
      Mf2(1,2) = 0
      Mf2(2,2) = MM2
      Mf2(3,2) = MC2
      Mf2(4,2) = MS2
      Mf2(1,3) = 0
      Mf2(2,3) = ML2
      Mf2(3,3) = MT2
      Mf2(4,3) = MB2

      do t=1,4
        do g=1,3
          Yf(t,g) = Mf(t,g)
        enddo
      enddo

      EL = sqrt(4*pi*Alfa)
      SW = sqrt(SW2)

      end
