* model.h
* common blocks for the model parameters
* this file is part of FormCalc
* last modified 18 Oct 09 th


	double precision pi, degree, sqrt2, hbar_c2

	parameter (pi = 3.1415926535897932384626433832795029D0)
	parameter (degree = pi/180D0)
	parameter (sqrt2 = 1.41421356237309504880168872421D0)

	parameter (hbar_c2 = 3.8937966D8)
*         = hbar c^2 in picobarn

	double complex bogus, cI

	parameter (bogus = (-1D123, -2D123))
*	  some weird number likely to noticeably distort the final result;
*	  used for initializing arrays to check that all components
*	  have been calculated

	parameter (cI = (0D0, 1D0))

	double precision Divergence
	common /renorm/ Divergence


* SM parameters

	double precision sin12, sin23, sin13, delta13
	parameter (sin12 = .2243D0)
	parameter (sin23 = .0413D0)
	parameter (sin13 = .0037D0)
	parameter (delta13 = 60*degree)

	double precision MZ, MZ2, MW, MW2, CW, CW2, SW2

	double precision GF, Alfa, Alfa2, AlfaMZ, AlfasMZ
c	parameter (Alfa = sqrt2/pi*GF*MW2*SW2, Alfa2 = Alfa**2)
	parameter (AlfaMZ = 1/127.934D0)
	parameter (AlfasMZ = .118D0)

	double precision ME, ME2, MM, MM2, ML, ML2
	parameter (ME = 0d0, ME2 = ME**2)
	parameter (MM = 0d0, MM2 = MM**2)
	parameter (ML = 0d0, ML2 = ML**2)
cmr	parameter (ME = .51099907D-3, ME2 = ME**2)
cmr	parameter (MM = 105.658389D-3, MM2 = MM**2)
cmr	parameter (ML = 1777D-3, ML2 = ML**2)

	double precision MU, MU2, MC, MC2, MT, MT2
	parameter (MU = 0d0, MU2 = MU**2)
	parameter (MC = 0D0, MC2 = MC**2)
cmr	parameter (MU = 53.8D-3, MU2 = MU**2)
cmr	parameter (MC = 1.50D0, MC2 = MC**2)

	double precision MD, MD2, MS, MS2, MB, MB2, MBatMB
	parameter (MD = 0d0, MD2 = MD**2)
	parameter (MS = 0d0, MS2 = MS**2)
cmr	parameter (MD = 53.8D-3, MD2 = MD**2)
cmr	parameter (MS = 150D-3, MS2 = MS**2)
	parameter (MBatMB = 4.25D0)

	double complex CKM(3,3), CKMrhoeta
	double precision CKMlambda, CKMA
	double precision Mf(4,3), Mf2(4,3), Yf(4,3)
	double precision MH, MH2
	double precision EL, GS, Alfas, Alfas2, AlfasMT, SW
	logical sm_digest

        double precision GammaW, GammaZ, GammaH

	common /sm_para/ CKM, CKMrhoeta, CKMlambda, CKMA
	common /sm_para/ Mf, Mf2, Yf
	common /sm_para/ MH, MH2
	common /sm_para/ EL, GS, Alfas, Alfas2, AlfasMT, SW
	common /sm_para/ sm_digest

        common /sm_para2/ mz, mz2, mw, mw2 
        common /sm_para2/ cw, cw2, sw2, alfa, alfa2, gf
        common /sm_para2/ mt, mt2, mb, mb2
        common /sm_para2/ GammaW, GammaZ, GammaH

#ifndef CKMC
#define CKMC(i,j) DCONJG(CKM(i,j))
#endif

