******************************************************************************
c
c    begin function m2s_qqVV
c
c*****************************************************************************
c
c       Adapted from m2s_wbfzh by D. Zeppenfeld
c
c
      real*8 function m2s_qqWZkk(
     &      bos,  !in:  XX Boson identifier,X=1 photon, X=2 Z, X=3,4 W+-, X=6 H
     &      nlo,  !in:  Born only for nlo=0, +interference for 1
     &      xi,   !in:  Feynman x parameters of incoming fermions
     &      p,    !in:  momenta associated with external fermions
     &      v,    !in:  momenta associated with gauge boson dec. fermions
     &      rn    !in:  random number array
     &                        )
      implicit none
c
c declare input/output variables
c
#include "VBFNLO/utilities/global.inc"
#include "VBFNLO/utilities/scales.inc"
#include "VBFNLO/utilities/process.inc"
#include "VBFNLO/utilities/lha.inc"


      integer bos, nlo
      double precision xi(nx), p(0:3,max_p), v(0:3,n_v), qww(0:3), rn(1)
      double precision udwv, duwv,RandomNumber, res(4), weight, rnumb

c declare local variables
 
      real*8 q_sf
      integer init/0/, I, J, mu, nu, id, iflav(2)
      save init
      real*8  pbar(0:3,6)
 
c declare variables for summation process

      INTEGER ires

      integer FSIGN(2+n_v), physToDiag(2), nmin, nmax, nproc(4)
      save nmax, nproc

c
c declare parton distribution variables
c
      real*8 pdf(-6:6,2)
c



      do mu = 0,3
         do i = 1,2
            pbar(mu,i)=p(mu,i)
!           print*, "pdf(",i," ,1):", pdf(i,1)
!           print*, "pdf(",i," ,2):", pdf(i,2)	    
         enddo
      enddo


      do mu = 0,3             ! kinematics for WV --> 4 lepton decay
            pbar(mu,3) = v(mu,1) ! e
            pbar(mu,4) = v(mu,2) ! ve
            pbar(mu,5) = v(mu,3) ! mu-
            pbar(mu,6) = v(mu,4) ! mu+
      enddo
      

       do i=1,4
         res(i)=0
       enddo
!      print*, pbar
      
c
c call PDF subroutine in order to determine parton
c distributions in the incoming (anti)protons.
c
      q_sf = sqrt(mufsq(1,1))
      call pdfproton( xi(1), q_sf, pdf(-6,1) ) ! f_a(x1)
      q_sf = sqrt(mufsq(2,1))
      call pdfproton( xi(2), q_sf, pdf(-6,2) ) ! f_a(x2)
      
      
      
      do i=-6, 6
         pdf(i,1) = pdf(i,1)/xi(1)
         pdf(i,2) = pdf(i,2)/xi(2)

!         print*, "pdf(",i," ,1):", pdf(i,1)
!         print*, "pdf(",i," ,2):", pdf(i,2)
      enddo

      
!      print*, pdf(-2,2), pdf(2,1), pdf(-2,2)*pdf(2,1)
  !    stop#
!        print*, v

!      print*, tmp
      select case (process)
      
      case (WmZkk) 
        if ((lha.or.hepmc).and..not.doNLO) then
           helicity(1)= 1
           helicity(2)=-1
           helicity(3)= 1
           helicity(4)=-1
        endif      
      
       if(with_kk) then
#ifdef WITH_KK
         call SUDWMZ_kk(pbar,udwv)      
#endif
       else
        call SUDWMZkk(pbar,udwv)
       endif
  
        res(1) = res(1) + udwv * pdf(-2,1) * pdf(1,2) ! u~d
        res(2) = res(2) + udwv * pdf(-4,1) * pdf(3,2) ! c~s
        iflav(1)=-2
	iflav(2)=1
	do i=1,2
	call fillColoredPartons_WZkk(iflav,i)
	enddo
        call switchmom( pbar(0,1), pbar(0,2) )
      
       if(with_kk) then
#ifdef WITH_KK
         call SUDWMZ_kk(pbar,duwv)      
#endif
       else
        call SUDWMZkk(pbar,duwv)
       endif

        res(3) = res(3) + duwv * pdf(-2,2) * pdf(1,1) ! du~
        res(4) = res(4) + duwv * pdf(-4,2) * pdf(3,1) ! sc~
        iflav(1)=1
	iflav(2)=-2
	do i=3,4
	call fillColoredPartons_WZkk(iflav,i)
	enddo
        call switchmom( pbar(0,1), pbar(0,2) )


      case (WpZkk) 

        if ((lha.or.hepmc).and..not.doNLO) then
           helicity(1)=-1
           helicity(2)= 1
           helicity(3)= 1
           helicity(4)=-1
        endif

       if(with_kk) then
#ifdef WITH_KK
         call SUDWPZL_kk(pbar,udwv)      
#endif
       else
        call SUDWPZLkk(pbar,udwv)
       endif
      
        res(1) = res(1) + udwv * pdf(2,1) * pdf(-1,2) ! ud~
        res(2) = res(2) + udwv * pdf(4,1) * pdf(-3,2) ! cs~

        iflav(1)=2
	iflav(2)=-1
	do i=1, 2
           call fillColoredPartons_WZkk(iflav,i)
        enddo
       call switchmom( pbar(0,1), pbar(0,2) )
	
       if(with_kk) then
#ifdef WITH_KK
         call SUDWPZL_kk(pbar,duwv)      
#endif
       else
        call SUDWPZLkk(pbar,duwv)
       endif

        res(3) = res(3) + duwv * pdf(2,2) * pdf(-1,1) ! d~u
        res(4) = res(4) + duwv * pdf(4,2) * pdf(-3,1) ! s~c
        iflav(1)=-1
	iflav(2)=2
	do i=3,4
	call fillColoredPartons_WZkk(iflav,i)	
	enddo
       call switchmom( pbar(0,1), pbar(0,2) )      
!      print*, duwv, udwv
      end select

      m2s_qqWZkk =res(1)+res(2)+res(3)+res(4)

      if ((lha.or.hepmc).and..not.doNLO) then
         i=0
         weight=0.d0
         rnumb=RandomNumber()
         do while((i.le.4).and.(weight.le.rnumb*m2s_qqWZkk))
            i=i+1
            weight=weight+res(i)
            iprocess=i

         enddo
      endif

    
      RETURN
      END

c*****************************************************************************
c
c    end function m2s_qqVV
c
c*****************************************************************************
*****************************************************************************
c
c    begin  subroutine fillColoredPartons_VV
c
c*****************************************************************************

      subroutine fillColoredPartons_WZkk(iflav,listposition)

c  assigns values to the variables in the common block localHEPUP
c  in particular, this subroutine assigns values to those variables that 
c  will be stored in the lookup tables generated by writeHEPUPtable.  
c  As the name suggests, this routine only stores the information for the 
c  colored partons.  Particles without color will be dealt with in the 
c  subroutine fillColorless.

      IMPLICIT NONE

c  include files
#include "VBFNLO/utilities/global.inc"
#include "VBFNLO/utilities/lha.inc"
#include "VBFNLO/utilities/process.inc"

c  input parameters
      INTEGER iflav(2),id1,id2,id3,id4,listposition !2 quark flavors and subprocess number

c  local variables
      INTEGER i
      
      id1=iflav(1)
      id2=iflav(2)
   
      select case(process)
      case(WPZkk,WMZkk) 
         lnup(listposition)=8

	 
      case default
         print*,'wrong process number in fillColoredPartons_VV: ',process
         stop
      end select

      listup(1,listposition)=-1   !incoming quarks
      listup(2,listposition)=-1
 
      lidup(1,listposition)=id1     ! the 2 quarks
      lidup(2,listposition)=id2

      if (id1.gt.0) then
        licolup(1,1,listposition)=501
        licolup(2,1,listposition)=0
        licolup(1,2,listposition)=0
        licolup(2,2,listposition)=501
      else
        licolup(1,1,listposition)=0
        licolup(2,1,listposition)=501
        licolup(1,2,listposition)=501
        licolup(2,2,listposition)=0
      endif
      END
