      subroutine call_qqZqq(
     &                   bos,   !in:  Boson identifier, 2 = Z, 6=H, 34=W+W-
     &                   nlo,   !in:  Born only for nlo=0, +interference for 1
     &                   p,	!in:  momenta associated with external fermions
     &                   v,	!in:  momenta associated with Z/H dec. fermions 
     &                  m2s,
     &                  ps_number)                         !out: amplitude squared
      
      implicit none

#include "VBFNLO/utilities/global.inc"

      integer bos, nlo, ps_number
      real*8  p(0:3,max_p), v(0:3,max_v), m2s   
      
      integer FSIGN(4+max_v), physToDiag(4)     
      real*8 pbar(0:3,4+max_v), polcol      
      real*8 bornflav(max_p), realflav(max_p+1),bflavborntwofl(max_p)

      real*8 uucc, uuss, ddcc, ddss, udsc, ducs
      integer i, mu, flavcombi, n
      parameter (n=3)
      double precision tree(6)      
      common/flavREW/bornflav, realflav, flavcombi      
      
      polcol = 1d0/(4d0*N**2)
      
      if (bornflav(1).gt.0.and.bornflav(2).gt.0) then

C*******************  q1 q3 ---> q2 q4  W W  **********************

c   physToDiag(ext.momentum label) = Feynman diagram label

      physToDiag(1)=1    !physToDiag(1/2) are labels of incoming quarks
      physToDiag(2)=3
      physToDiag(3)=2    !physToDiag(3/4) are labels of outgoing quarks.
      physToDiag(4)=4

      fsign(1) = 1
      fsign(2) = 1
      fsign(3) = 1
      fsign(4) = 1

      elseif (bornflav(1).gt.0.and.bornflav(2).lt.0) then

C******************* q1 qb4 ---> q2 qb3 W  W  **********************
c      
      physToDiag(1)=1    !physToDiag(1/2) are labels of incoming quarks
      physToDiag(2)=4
      physToDiag(3)=2    !physToDiag(3/4) are labels of outgoing quarks.
      physToDiag(4)=3
c
      fsign(1) =  1
      fsign(2) =  1
      fsign(3) = -1
      fsign(4) = -1      
      

      elseif (bornflav(1).lt.0.and.bornflav(2).gt.0) then

C******************* qbar2 q3 ---> qbar1 q4 W W  **********************
      
      physToDiag(1)=2    !physToDiag(1/2) are labels of incoming quarks
      physToDiag(2)=3
      physToDiag(3)=1    !physToDiag(3/4) are labels of outgoing quarks.
      physToDiag(4)=4
c
      fsign(1) = -1
      fsign(2) = -1
      fsign(3) =  1
      fsign(4) =  1


      elseif (bornflav(1).lt.0.and.bornflav(2).lt.0) then

C*******************  qbar2 qb4 ---> qbar1 qb3 W W  **********************

      physToDiag(1)=2    !physToDiag(1/2) are labels of incoming quarks
      physToDiag(2)=4
      physToDiag(3)=1    !physToDiag(3/4) are labels of outgoing quarks.
      physToDiag(4)=3
c
      fsign(1) = -1
      fsign(2) = -1
      fsign(3) = -1
      fsign(4) = -1      

      else
         
         write(*,*) 'wrong value of bornflav(1) and bornflav(2)'
         write(*,*) 'bornflav(1) = ',bornflav(1)
         write(*,*) 'bornflav(2) = ',bornflav(2)

      endif
            
C*****************  end of process evaluation  **********************

c get the amplitude squared:
      do mu = 0,3
         do i = 1,4
            pbar(mu,physToDiag(i))=p(mu,i)
         enddo
      enddo	 

      do i=1, n_p
      if( abs(bornflav(i)).gt.2) then
        bflavborntwofl(i)=sign(abs(bornflav(i))-2,bornflav(i))
      else
        bflavborntwofl(i)= bornflav(i)
      endif
      enddo 
!       
!       print*,'lala', pbar



      if((abs(bflavborntwofl(1))-abs(bflavborntwofl(3)).eq.0).and.(abs(bflavborntwofl(2))-abs(bflavborntwofl(4)).eq.0)) then
         if (abs(bflavborntwofl(1)).eq.abs(bflavborntwofl(2))) then
             if(abs(bflavborntwofl(1)).eq.1) then
               flavcombi=4
!                print*, flavcombi
!       call qqhqq(pbar,fsign,0,0,
!      1            uucc,uuss,ddcc,ddss,udsc,ducs)           
!                amp2=ddss*polcol
! (pbar,sign,nlo,bosdec,flavcombi, uucc,uuss,ddcc,ddss,udsc,ducs)
!                print*, 'ddss'
             elseif (abs(bflavborntwofl(1)).eq.2) then
               flavcombi=1
!                         print*, flavcombi      
!       call qqhqq(pbar,fsign,0,0,
!      1            uucc,uuss,ddcc,ddss,udsc,ducs)            
!                amp2=uucc*polcol
!                print*, 'uucc'
             endif

         elseif(abs(bflavborntwofl(1)).ne.abs(bflavborntwofl(2))) then !ud, du
             if(abs(bflavborntwofl(1)).eq.1) then
               flavcombi=3
!                               print*, flavcombi
!       call qqhqq(pbar,fsign,0,0,
!      1            uucc,uuss,ddcc,ddss,udsc,ducs)   
!                amp2=ddcc*polcol
!                print*, 'ddcc'
             elseif (abs(bflavborntwofl(1)).eq.2) then
               flavcombi=2
! !                               print*, flavcombi
!       call qqhqq(pbar,fsign,0,0,
!      1            uucc,uuss,ddcc,ddss,udsc,ducs)   
!                amp2=uuss*polcol
!                print*, 'uuss'
             endif
         endif

      elseif((abs(bflavborntwofl(1))-abs(bflavborntwofl(3)).ne.0).and.(abs(bflavborntwofl(2))-abs(bflavborntwofl(4)).ne.0)) then  !charged currents
             if(abs(bflavborntwofl(1)).eq.1) then
               flavcombi=6
!                               print*, flavcombi
!       call qqhqq(pbar,fsign,0,0,
!      1            uucc,uuss,ddcc,ddss,udsc,ducs)   
!                amp2=ducs*polcol!*8d0
!                print*, 'ducs'
             elseif (abs(bflavborntwofl(1)).eq.2) then
               flavcombi=5
!                               print*, flavcombi
!       call qqhqq(pbar,fsign,0,0,
!      1            uucc,uuss,ddcc,ddss,udsc,ducs)   
!                amp2=udsc*polcol!*8d0 !8 random helicity summation
!                print*, 'udsc'
             endif

      else
        write(*,*) "flavour combination not found, stop"
        write(*,*) bornflav, flavcombi
        write(*,*) 'uborn2flav',bflavborntwofl

      endif
      



      if (bos.eq.2) then
         do mu = 0,3             ! kinematics for Z-->l+l- decay
            pbar(mu,5) = v(mu,2) ! ebar
            pbar(mu,6) = v(mu,1) ! e
         enddo
         fsign(5) = -1
         fsign(6) = 1
         call qqzqq(pbar,fsign, nlo,
     1              uucc,uuss,ddcc,ddss,udsc,ducs)  
      elseif (bos.eq.1) then
         do mu = 0,3 
            pbar(mu,5) = v(mu,n_v) ! photon
            pbar(mu,6) = 0d0
         enddo
         fsign(5) = -1
         fsign(6) = 0
         call qqAqq(pbar,fsign, nlo,
     1              uucc,uuss,ddcc,ddss,udsc,ducs)         

      elseif (bos.eq.6) then
         do mu = 0,3
            pbar(mu,5) = 0      ! dummy momentum
            pbar(mu,6) = 0
            do i = 1,n_v
               pbar(mu,6) = pbar(mu,6) + v(mu,i) ! Higgs momentum
            enddo
         enddo
         fsign(5) = 0
         fsign(6) = 1       
         call qqhqq(pbar,fsign, nlo, 
     1              uucc,uuss,ddcc,ddss,udsc,ducs,tree)
!       elseif (bos.eq.61 .or. bos.eq.16) then   ! HAjj
!          do mu=0,3
!             pbar(mu,1)=p(mu,1)
!             pbar(mu,2)=p(mu,3)
!             pbar(mu,3)=p(mu,2)
!             pbar(mu,4)=p(mu,4)
!          enddo
!          do mu = 0,3
!             pbar(mu,5) = 0      ! dummy momentum
!             pbar(mu,6) = 0
!             do i = 1,n_v-1
!                pbar(mu,6) = pbar(mu,6) + v(mu,i) ! Higgs momentum
!             enddo
!          enddo
!          fsign(5) = 0
!          fsign(6) = 1
!          do mu=0,3
!             pA(mu)=v(mu,n_v)
!          enddo
!          CALL HAjj_ME(pbar,pA,fsign, nlo, 
!      1              uucc,uuss,ddcc,ddss,udsc,ducs)
      elseif (bos.eq.34 .or. bos.eq.43) then         ! W+W- to 4 leptons
         do mu = 0,3             ! kinematics for H-->WW -->4 lepton decay
            pbar(mu,5) = v(mu,2) ! l+
            pbar(mu,6) = v(mu,1) ! nu
            pbar(mu,7) = v(mu,3) ! nubar
            pbar(mu,8) = v(mu,4) ! l-
         enddo
         fsign(5) = -1
         fsign(6) = 1
         fsign(7) = -1
         fsign(8) = 1
c         call qqhqq(pbar,fsign, nlo, 
c     1              uucc,uuss,ddcc,ddss,udsc,ducs,tree)
         if (lwarn) then
            call qqwwqq_comp(pbar,fsign, nlo,
     1                       uucc,uuss,ddcc,ddss,udsc,ducs)
         endif
         call qqwwqq(pbar,fsign, nlo, 1,
     1                    uucc,uuss,ddcc,ddss,udsc,ducs)
c         call qqwwqq_comp(pbar,fsign, nlo, 
c     1                    uucc,uuss,ddcc,ddss,udsc,ducs)
      elseif (bos.eq.22) then         ! ZZ to 4 leptons
         do mu = 0,3             ! kinematics for H-->ZZ -->4 lepton decay
            pbar(mu,5) = v(mu,1) ! l+
            pbar(mu,6) = v(mu,2) ! l-
            pbar(mu,7) = v(mu,3) ! l"+
            pbar(mu,8) = v(mu,4) ! l"-
         enddo
         fsign(5) = -1
         fsign(6) = 1
         fsign(7) = -1
         fsign(8) = 1
         if (lwarn) then
c            call qqzzqq_comp(pbar,fsign, nlo,  bos,
c     1                       uucc,uuss,ddcc,ddss,udsc,ducs)
         endif
         call qqzzqq(pbar,fsign, nlo, 1,bos,
     1                    uucc,uuss,ddcc,ddss,udsc,ducs)

c        call qqzzqq_comp(pbar,fsign, nlo, bos,
c     1                    uucc,uuss,ddcc,ddss,udsc,ducs)

#ifdef WITH_SPIN2
      elseif (bos.eq.11) then         ! qq(-->spin-2)-->qq gamma gamma
         do mu = 0,3             
            pbar(mu,5) = v(mu,1) ! photon 1
            pbar(mu,6) = v(mu,2) ! photon 2
         enddo

         fsign(5) = 1
         fsign(6) = 1

         call qqsp2aaqq(pbar,fsign, nlo, 1,bos,
     1                    uucc,uuss,ddcc,ddss,udsc,ducs)
#endif

      elseif (bos.eq.21) then         ! ZZ to 2 leptons + 2 neutrinos
         do mu = 0,3             ! kinematics for H-->ZZ-->2l 2v decay
            pbar(mu,5) = v(mu,1) ! l+
            pbar(mu,6) = v(mu,2) ! l-
            pbar(mu,7) = v(mu,3) ! v
            pbar(mu,8) = v(mu,4) ! v~
         enddo
         fsign(5) = -1
         fsign(6) =  1
         fsign(7) =  1
         fsign(8) = -1
         if (lwarn) then
c            call qqzzqq_comp(pbar,fsign, nlo,  bos,
c     1                       uucc,uuss,ddcc,ddss,udsc,ducs)
         endif
        
	call qqzzqq(pbar,fsign, nlo, 1,bos,
     1                    uucc,uuss,ddcc,ddss,udsc,ducs) 

c        call qqzzqq_comp(pbar,fsign, nlo, bos,
c     1                    uucc,uuss,ddcc,ddss,udsc,ducs)
      elseif (bos.eq.211) then         ! ZA to 2 leptons + A 
         do mu = 0,3  ! kinematics for qq-->ZA-->2l A decay
            pbar(mu,5) = v(mu,1) ! l+
            pbar(mu,6) = v(mu,2) ! l-
            pbar(mu,7) = v(mu,3) ! v
         enddo
         fsign(5) = -1
         fsign(6) =  1
         fsign(7) =  1
cjp
	call qqzaqq(pbar,fsign, nlo, 1,bos,ps_number
     1                    uucc,uuss,ddcc,ddss,udsc,ducs) 

      else
         print*," Invalid entry BOS = ",bos
         print*," in call of wbf_zh. Must be 2,6, 34/43, 22 or 21"
         stop
      endif
      
      select case (flavcombi)
      case(1) 
         m2s=polcol*uucc
      case(2) 
         m2s=polcol*uuss
      case(3) 
         m2s=polcol*ddcc
      case(4) 
         m2s=polcol*ddss
      case(5) 
         m2s=polcol*udsc
      case(6) 
         m2s=polcol*ducs
      end select
     
ccc      if(m2s.eq.0d0) then

ccc      print*,flavcombi
ccc      print*,  uucc,uuss,ddcc,ddss,udsc,ducs
ccc      print*, pbar,fsign
ccc      endif      
      
      end
