c -----------------------------------------------------------------

      subroutine AAA_ATOAAA_anomal(v,N,h,aaa,nA)

      IMPLICIT NONE

      DOUBLE PRECISION P(0:3,2:5), v(0:3,4)
      complex*16 aaa(0:5)
      integer lsign(2:5,8),ll,mu,nu,h,N
      integer nA 


      do mu = 0,3
         P(mu,2) = v(mu,1) !A1
         P(mu,3) = v(mu,2) !A2
         P(mu,4) = v(mu,3) !A3
      enddo

      call AAA_ATOAAA1_anomal(P,N,lsign(2,h),aaa,nA)



      end
c ------------------------------------------------------------
       
      subroutine AAA_ATOAAA1_anomal(P,N,lsign,aaa,nA)
C  
C Generated by MadGraph II Version 3.0. Updated 02/19/04                
C RETURNS AMPLITUDE SQUARED SUMMED/AVG OVER COLORS
C FOR THE POINT WITH EXTERNAL LINES W(0:6,NEXTERNAL)
C  
C FOR PROCESS : a -> a a a  
C  
      IMPLICIT NONE
C  
C CONSTANTS
C  
      INTEGER    NGRAPHS 
      PARAMETER (NGRAPHS=   4) 
      INTEGER    NWAVEFUNCS
      PARAMETER (NWAVEFUNCS=   7) 
      REAL*8     ZERO
      PARAMETER (ZERO=0D0)
C  
C ARGUMENTS 
C  
      REAL*8 P(0:3,2:5), Q(0:3)
      INTEGER N
      complex*16 aaa(0:5)
      integer lsign(2:5)
      integer nA

C  
C LOCAL VARIABLES 
C  
      INTEGER I,J,mu
      COMPLEX*16 AMP(NGRAPHS)
      COMPLEX*16 W(6,NWAVEFUNCS)

c  lepton spinors and Z/A polarization vectors
#include "tensor.inc"

      logical lswitch
      parameter (lswitch=.true.)

C  
C GLOBAL VARIABLES
C  
#include "VBFNLO/utilities/coupl.inc"
                                                                          
C ----------
C BEGIN CODE
C ----------
      if (lswitch) then      ! read in Z states from common block
         do i=1,6
            w(i,2)  = atau1(i,N) !A1
            w(i,3)  = atau2(i,N) !A2
            w(i,4)  = atau3(i,N) !A3
         enddo
      endif

      do mu = 0,3
         q(mu) = p(mu,2)+p(mu,3)+p(mu,4)
      enddo
      do mu=0,3
      CALL TRIBOSVCARTX(Q(0),ZERO ,ZERO, MU,-1,W(1,1   ))
c      CALL VXXXXX(qa1(0,1),ZERO,ie,1,W(1,2   )) !A1
c      CALL VXXXXX(qa2(0,1),ZERO,iu,1,W(1,3   )) !A2
c      CALL VXXXXX(qa3(0,1),ZERO,it,1,W(1,4   )) !A3 

c considering anomalous couplings there are 3 extra graphs with Higgs (AAH-coupling)
      CALL jhaa_anomal3(W(1,1   ),W(1,2   ),W(1,5   ))
      CALL aah_anomal3(W(1,3   ),W(1,4   ),W(1,5   ),AMP(1   )) !A -> A1 H -> A2 A3

      CALL jhaa_anomal3(W(1,1   ),W(1,3   ),W(1,6   ))
      CALL aah_anomal3(W(1,2    ),W(1,4   ),W(1,6   ),AMP(2   )) !A -> A2 H -> A1 A3


      CALL jhaa_anomal3(W(1,1   ),W(1,4   ),W(1,7   ))
      CALL aah_anomal3(W(1,2   ),W(1,3   ),W(1,7   ),AMP(3   )) !A -> A3 H -> A1 A2


c considering anomalous couplings there is one extra graph with neutral quartic-vector-boson-coupling
      CALL aaaa_anomal4(W(1,1   ),W(1,2   ),W(1,3   ),W(1,4   ),AMP(4   ))


      
      aaa(mu) = +AMP( 1)+AMP( 2)+AMP( 3)+AMP( 4)


      enddo
      aaa(4)=dcmplx(q(0),q(3))
      aaa(5)=dcmplx(q(1),q(2))
      return
      END

c -------------------------------------------------------------------

      subroutine AAA_ZTOAAA_anomal(v,N,h,aaa,nA)

      IMPLICIT NONE

      DOUBLE PRECISION P(0:3,2:5), v(0:3,4)
      complex*16 aaa(0:5)
      integer lsign(2:5,8),ll,mu,nu,h,N
      integer nA 


      do mu = 0,3
         P(mu,2) = v(mu,1)
         P(mu,3) = v(mu,2)
         P(mu,4) = v(mu,3)
      enddo

      call AAA_ZTOAAA1_anomal(P,N,lsign(2,h),aaa,nA)


      end

c ------------------------------------------------------------------
       
      subroutine AAA_ZTOAAA1_anomal(P,N,lsign,aaa,nA)
C  
C Generated by MadGraph II Version 3.0. Updated 02/19/04                
C RETURNS AMPLITUDE SQUARED SUMMED/AVG OVER COLORS
C FOR THE POINT WITH EXTERNAL LINES W(0:6,NEXTERNAL)
C  
C FOR PROCESS : z -> a a a  
C  
      IMPLICIT NONE
C  
C CONSTANTS
C  
      INTEGER    NGRAPHS
      PARAMETER (NGRAPHS=  14) 
      INTEGER    NWAVEFUNCS
      PARAMETER (NWAVEFUNCS=  19) 
      REAL*8     ZERO
      PARAMETER (ZERO=0D0)
C  
C ARGUMENTS 
C  
      REAL*8 P(0:3,2:5), Q(0:3)
      INTEGER N
      double complex aaa(0:5)
      INTEGER lsign(2:5)
      integer nA
C  
C LOCAL VARIABLES 
C  
      INTEGER I,J,mu
      COMPLEX*16 AMP(NGRAPHS)
      COMPLEX*16 W(6,NWAVEFUNCS)

c  lepton spinors and Z/A polarization vectors
#include "tensor.inc"

      logical lswitch
      parameter (lswitch=.true.)

C  
C GLOBAL VARIABLES
C  
#include "VBFNLO/utilities/coupl.inc"
                                                                         
C ----------
C BEGIN CODE
C ----------
      if (lswitch) then      ! read in Z states from common block
         do i=1,6
            w(i,2)  = atau1(i,N) !A1
            w(i,3)  = atau2(i,N) !A2
            w(i,4)  = atau3(i,N) !A3
         enddo
      endif

      do mu = 0,3
         q(mu) = p(mu,2)+p(mu,3)+p(mu,4)
      enddo
      do mu = 0,3
      CALL TRIBOSVCARTX(Q(0),ZMASS ,ZWIDTH, MU,-1,W(1,1   )) 


c considering anomalous couplings there are 3 extra graphs with Higgs (AAH-, AZH-coupling)
      CALL jhaz_anomal3(W(1,2   ),W(1,1   ),W(1,5   ))
      CALL aah_anomal3(W(1,3   ),W(1,4   ),W(1,5   ),AMP(1   )) !Z -> A1 H -> A2 A3

      CALL jhaz_anomal3(W(1,3   ),W(1,1   ),W(1,6   ))
      CALL aah_anomal3(W(1,2   ),W(1,4   ),W(1,6   ),AMP(2   )) !Z -> A2 H -> A1 A3

      CALL jhaz_anomal3(W(1,4   ),W(1,1   ),W(1,7   ))
      CALL aah_anomal3(W(1,2   ),W(1,3   ),W(1,7   ),AMP(3   )) !Z -> A3 H -> A1 A2

c considering anomalous couplings there is one extra graph with neutral quartic-vector-boson-coupling
      CALL aaaz_anomal4(W(1,2   ),W(1,3   ),W(1,4   ),W(1,1   ),AMP(4   ))




      aaa(mu) = +AMP( 1)+AMP( 2)+AMP( 3)+AMP( 4)

      enddo
      aaa(4) = dcmplx(q(0),q(3))
      aaa(5) = dcmplx(q(1),q(2))
      return
      END

