c
c this is the modified version of WWwtowww.F that includes
c anomalous couplings
c

C-------------------------------------------------------------------------------
C
C	THIS FILE CONTAINS SUBROUTINES TO CALCULATE LEPTONIC TENSORS
C	FOR A PROCESS W+/- --> WWW --> LEPTONS
C	
C  LIST OF SUBROUTINES:
C
C    W+ --> WWW --> LEPTONS
C	SUBROUTINE WWW_WPTOWWW		! passes helicity set to next routine
C	SUBROUTINE WWW_WPTOWWW1		! madgraph generated amplitude
C
C    W- --> WWW --> LEPTONS
C	SUBROUTINE WWW_WMTOWWW		! passes helicity set to next routine
C	SUBROUTINE WWW_WMTOWWW1		! madgraph generated amplitude
C
C-------------------------------------------------------------------------------


C-------------------------------------------------------------------------------

      SUBROUTINE WWW_WPTOWWW_anomal(P,N,H,WPWWW,NW)
c Leptonic tensor for process 
c     W+ --> W+ W- W+ --> ve e+ mu- vm~ vt ta+
c computed for fixed helicity set h

      IMPLICIT NONE

C ARGUMENTS

      DOUBLE PRECISION P(0:3,2:7)
      INTEGER N,H,NW
      DOUBLE COMPLEX WPWWW(0:5)
C
C LOCAL VARIABLES
C

      INTEGER LSIGN(2:7,2),L
      DATA(LSIGN(L,1),L=2,7)/-1,-1,-1,-1,-1,-1/	! H=1
      DATA(LSIGN(L,2),L=2,7)/-1,-1,-1,-1,+1,+1/	! H=2

      CALL WWW_WPTOWWW1_anomal(P,N,LSIGN(2,H),WPWWW(0),NW)    ! HELICITY COMBINATION #H IS SELECTED
							! ONLY HELICITY SET H=1 NEEDED HERE

      END

C------------------------------------------------------------------------------

C-------------------------------------------------------------------------------

      SUBROUTINE WWW_WPTOWWW1_anomal(P,N,LSIGN,WPWWW,NW)
C  
C Generated by MadGraph II, SLIGHTLY CHANGED
C RETURNS AMPLITUDE
C FOR PROCESS : w+ -> ve e+ mu- vm~ vt ta+
C  
      IMPLICIT NONE
C  
C CONSTANTS
C  
      INTEGER    NGRAPHS
      PARAMETER (NGRAPHS=53)
      INTEGER    NWAVEFUNCS
      PARAMETER (NWAVEFUNCS=88)
      DOUBLE PRECISION     ZERO
      PARAMETER (ZERO=0D0)
C  
C ARGUMENTS 
C  
      DOUBLE PRECISION P(0:3,2:7)
      INTEGER N
      INTEGER LSIGN(2:7)
      DOUBLE COMPLEX WPWWW(0:5)
      INTEGER NW
C  
C LOCAL VARIABLES 
C  
      DOUBLE PRECISION Q(0:3)
      INTEGER I,MU
      DOUBLE COMPLEX AMP(NGRAPHS)
      DOUBLE COMPLEX W(18,NWAVEFUNCS)

      LOGICAL LSWITCH
      PARAMETER(LSWITCH =.true.)

!LEPTON SPINORS + POLARISATION VECTORS GENERATED IN M2S_QQWWW
#include "tensor.inc"

C
C GLOBAL VARIABLES
C
#include "VBFNLO/utilities/coupl.inc"

C ------------------------------------------------------------------------------
C BEGIN CODE
C ------------------------------------------------------------------------------

      IF(LSWITCH) THEN                                    !READ IN LEPTON WF FROM COMMON BLOCK
         DO I=1,6
            W(I,2) = WVE1(I,N)
            W(I,3) = WEP1(I,N)
            W(I,4) = WMU1(I,N)
            W(I,5) = WVM1(I,N)
            W(I,6) = WVT(I,N)
            W(I,7) = WTP(I,N)
            W(I,8) = WP1(I,N)
            W(I,16)= W1M(I,N)

         ENDDO
      ENDIF

      DO MU=0,3
         Q(MU) = P(MU,2) + P(MU,3) + P(MU,4) + P(MU,5) + P(MU,6) + P(MU,7)
      ENDDO

c      moved to m2s_qqWWW.F
c      call anomal_formfactor_4v(q)

      IF(.NOT.LSWITCH) THEN
         CALL OXXXXX(P(0,2   ),ZERO ,+1*LSIGN(2   ),+1,W(1,2   ))        
         CALL IXXXXX(P(0,3   ),ZERO ,-1*LSIGN(3   ),-1,W(1,3   ))        
         CALL OXXXXX(P(0,4   ),ZERO ,+1*LSIGN(4   ),+1,W(1,4   ))        
         CALL IXXXXX(P(0,5   ),ZERO ,-1*LSIGN(5   ),-1,W(1,5   ))        
         CALL OXXXXX(P(0,6   ),ZERO ,+1*LSIGN(6   ),+1,W(1,6   ))        
         CALL IXXXXX(P(0,7   ),LMASS,-1*LSIGN(7   ),-1,W(1,7   ))       

         CALL JIOXXX(W(1,3   ),W(1,2   ),GWF ,WMASS   ,WWIDTH  ,W(1,8   ))    
         CALL JIOXXX(W(1,5   ),W(1,4   ),GWF ,WMASS   ,WWIDTH  ,W(1,16  ))    
c         print*,' ve  ',(wve(i,N)/w(i,2),i=1,6)
c         print*,' ep  ',(wep(i,N)/w(i,3),i=1,6)
c         print*,' mu  ',(wmu(i,N)/w(i,4),i=1,6)
c         print*,' vm  ',(wvm(i,N)/w(i,5),i=1,6)
c         print*,' vt  ',(wvt(i,N)/w(i,6),i=1,6)
c         print*,' tp  ',(wtp(i,N)/w(i,7),i=1,6)
c         print*,' wp1 ',(wp1(i,N)/w(i,8),i=1,6)
c         print*,' wm1 ',(wm1(i,N)/w(i,13),i=1,6)
      ENDIF

      IF(NW.EQ.1) THEN
         DO MU=0,3
            CALL TRIPLEWVCARTX(Q(0),WMASS,WWIDTH,MU,-1,W(1,1))
            CALL jaww_anomal3(W(1,16  ),W(1,8   ),W(1,19 ))                                                          
            CALL jwpawm_anomal3(W(1,19  ),W(1,1   ),W(1,20 ))                                                          
            CALL IOVXXX(W(1,7) ,W(1,6) ,W(1,20),GWF ,AMP(6))              !W+ -> AW+ -> WWW
            CALL jzww_anomal3(W(1,16  ),W(1,8   ),W(1,18 ))                                                          
            CALL jwpzwm_anomal3(W(1,18  ),W(1,1   ),W(1,21 ))                                                          
            CALL IOVXXX(W(1,7) ,W(1,6) ,W(1,21),GWF ,AMP(7))              !W+ -> ZW+ -> WWW
            CALL jhww_anomal3(W(1,16  ),W(1,8   ),W(1,22 ))                                                          
            CALL JIOXXX(W(1,7   ),W(1,6  ),GWF ,WMASS   ,WWIDTH  ,W(1,23  ))    
            CALL wwh_anomal3(W(1,1  ),W(1,23   ),W(1,22  ),AMP(8   ))     !W+ -> HW+ -> WWW
            CALL jaww_anomal3(W(1,1   ),W(1,8   ),W(1,32 ))                                                          
            CALL jwpawm_anomal3(W(1,32  ),W(1,16  ),W(1,38 ))                                                          
            CALL IOVXXX(W(1,7) ,W(1,6) ,W(1,38),GWF ,AMP(17))             !W+ -> W+A -> WWW
            CALL jzww_anomal3(W(1,1   ),W(1,8   ),W(1,29 ))                                                          
            CALL jwpzwm_anomal3(W(1,29  ),W(1,16  ),W(1,39 ))                                                          
            CALL IOVXXX(W(1,7) ,W(1,6) ,W(1,39),GWF ,AMP(18))             !W+ -> W+Z -> WWW
            CALL jhww_anomal3(W(1,1   ),W(1,8   ),W(1,40 ))                                                          
            CALL JIOXXX(W(1,7   ),W(1,6  ),GWF ,WMASS   ,WWIDTH  ,W(1,41  ))    
            CALL wwh_anomal3(W(1,16  ),W(1,41   ),W(1,40  ),AMP(19   ))   !W+ -> W+H -> WWW
            CALL JIOXXX(W(1,7),W(1,6),GWF,WMASS,WWIDTH,W(1,45))
            CALL wwww_anomal4(W(1,1),W(1,8),W(1,16),W(1,45), AMP(24))     !W+ -> WWW

            WPWWW(MU) = - AMP(6) - AMP(17)  !A CONTRIBUTION
     &                  - AMP(7) - AMP(18)  !Z CONTRIBUTION
     &                  - AMP(8) - AMP(19)  !H CONTRIBUTION
     &                  - AMP(24)           !QUARTIC COUPLING

         ENDDO
      ELSEIF(NW.EQ.0) THEN

      DO MU=0,3
      CALL TRIPLEWVCARTX(Q(0),WMASS,WWIDTH,MU,-1,W(1,1))
      CALL FVOXXX(W(1,4   ),W(1,8   ),GWF ,ZERO    ,ZERO    ,W(1,9   ))    
      CALL JIOXXX(W(1,5   ),W(1,9   ),GZN ,ZMASS   ,ZWIDTH  ,W(1,10  ))    
      CALL FVOXXX(W(1,6   ),W(1,10  ),GZN ,ZERO    ,ZERO    ,W(1,11  ))    
      CALL IOVXXX(W(1,7   ),W(1,11  ),W(1,1   ),GWF ,AMP(1   ))            
      CALL jwpzwm_anomal3(W(1,10  ),W(1,1   ),W(1,12 )) 
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,12  ),GWF ,AMP(2   ))            
      CALL FVIXXX(W(1,7   ),W(1,10  ),GZL ,LMASS   ,ZERO    ,W(1,13  ))    
      CALL IOVXXX(W(1,13  ),W(1,6   ),W(1,1   ),GWF ,AMP(3   ))            
      CALL FVOXXX(W(1,9   ),W(1,1   ),GWF ,ZERO    ,ZERO    ,W(1,14  ))    
      CALL JIOXXX(W(1,5   ),W(1,14  ),GWF ,WMASS   ,WWIDTH  ,W(1,15  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,15  ),GWF ,AMP(4   ))            
C      CALL JIOXXX(W(1,5   ),W(1,4   ),GWF ,WMASS   ,WWIDTH  ,W(1,16  ))    
      CALL FVIXXX(W(1,7   ),W(1,1   ),GWF ,ZERO    ,ZERO    ,W(1,17  ))    
      CALL jzww_anomal3(W(1,16  ),W(1,8   ),W(1,18 ))   
      CALL IOVXXX(W(1,17  ),W(1,6   ),W(1,18  ),GZN ,AMP(5   ))            
      CALL jaww_anomal3(W(1,16  ),W(1,8   ),W(1,19 ))   
      CALL jwpawm_anomal3(W(1,19  ),W(1,1   ),W(1,20 )) 
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,20  ),GWF ,AMP(6   ))            
      CALL jwpzwm_anomal3(W(1,18  ),W(1,1   ),W(1,21 ))   
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,21  ),GWF ,AMP(7   ))            
      CALL jhww_anomal3(W(1,16  ),W(1,8   ),W(1,22 ))     
      CALL JIOXXX(W(1,7   ),W(1,6  ),GWF ,WMASS   ,WWIDTH  ,W(1,23  ))    
      CALL wwh_anomal3(W(1,1  ),W(1,23   ),W(1,22  ),AMP(8   ))
      CALL FVIXXX(W(1,7   ),W(1,16  ),GWF ,ZERO    ,ZERO    ,W(1,24  ))    
      CALL FVIXXX(W(1,24  ),W(1,8   ),GWF ,LMASS   ,ZERO    ,W(1,25  ))    
      CALL IOVXXX(W(1,25  ),W(1,6   ),W(1,1   ),GWF ,AMP(9   ))            
      CALL FVIXXX(W(1,7   ),W(1,19  ),GAL ,LMASS   ,ZERO    ,W(1,26  ))    
      CALL IOVXXX(W(1,26  ),W(1,6   ),W(1,1   ),GWF ,AMP(10  ))            
      CALL FVIXXX(W(1,7   ),W(1,18  ),GZL ,LMASS   ,ZERO    ,W(1,27  ))    
      CALL IOVXXX(W(1,27  ),W(1,6   ),W(1,1   ),GWF ,AMP(11  ))            
c      CALL FSIXXX(W(1,7   ),W(1,22  ),GHTAU ,LMASS   ,ZERO   ,W(1,28 ))  !H coupled to tau
c      CALL IOVXXX(W(1,28  ),W(1,6   ),W(1,1   ),GWF ,AMP(12  ))          !H coupled to tau   
      CALL jzww_anomal3(W(1,1   ),W(1,8   ),W(1,29 ))                
      CALL FVIXXX(W(1,5   ),W(1,29  ),GZN ,ZERO    ,ZERO    ,W(1,30  ))    
      CALL JIOXXX(W(1,30  ),W(1,4   ),GWF ,WMASS   ,WWIDTH  ,W(1,31  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,31  ),GWF ,AMP(13  ))            
      CALL jaww_anomal3(W(1,1   ),W(1,8   ),W(1,32 ))              
      CALL FVOXXX(W(1,4   ),W(1,32  ),GAL ,ZERO    ,ZERO    ,W(1,33  ))    
      CALL JIOXXX(W(1,5   ),W(1,33  ),GWF ,WMASS   ,WWIDTH  ,W(1,34  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,34  ),GWF ,AMP(14  ))            
      CALL FVOXXX(W(1,4   ),W(1,29  ),GZL ,ZERO    ,ZERO    ,W(1,35  ))    
      CALL JIOXXX(W(1,5   ),W(1,35  ),GWF ,WMASS   ,WWIDTH  ,W(1,36  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,36  ),GWF ,AMP(15  ))            
      CALL FVIXXX(W(1,17  ),W(1,8   ),GWF ,LMASS   ,ZERO    ,W(1,37  ))    
      CALL IOVXXX(W(1,37  ),W(1,6   ),W(1,16  ),GWF ,AMP(16  ))            
      CALL jwpawm_anomal3(W(1,32  ),W(1,16  ),W(1,38 ))      
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,38  ),GWF ,AMP(17  ))            
      CALL jwpzwm_anomal3(W(1,29  ),W(1,16  ),W(1,39 ))      
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,39  ),GWF ,AMP(18  ))            
      CALL jhww_anomal3(W(1,1   ),W(1,8   ),W(1,40 ))           
      CALL JIOXXX(W(1,7   ),W(1,6  ),GWF ,WMASS   ,WWIDTH  ,W(1,41  ))    
      CALL wwh_anomal3(W(1,16  ),W(1,41   ),W(1,40  ),AMP(19   ))
      CALL IOVXXX(W(1,24  ),W(1,6   ),W(1,29  ),GZN ,AMP(20  ))            
      CALL FVIXXX(W(1,7   ),W(1,32  ),GAL ,LMASS   ,ZERO    ,W(1,42  ))    
      CALL IOVXXX(W(1,42  ),W(1,6   ),W(1,16  ),GWF ,AMP(21  ))            
      CALL FVIXXX(W(1,7   ),W(1,29  ),GZL ,LMASS   ,ZERO    ,W(1,43  ))    
      CALL IOVXXX(W(1,43  ),W(1,6   ),W(1,16  ),GWF ,AMP(22  ))            
c      CALL FSIXXX(W(1,7   ),W(1,40  ),GHTAU ,LMASS   ,ZERO    ,W(1,44 ))  !H coupled to tau
c      CALL IOVXXX(W(1,44  ),W(1,6   ),W(1,16  ),GWF ,AMP(23  ))           !H coupled to tau 

c      CALL JWWWXX(W(1,16),W(1,8),W(1,1),GWWZ,GWWA,WMASS,WWIDTH,W(1,45))
c      CALL IOVXXX(W(1,7),W(1,6),W(1,45),GWF,AMP(24))            
      CALL JIOXXX(W(1,7),W(1,6),GWF,WMASS,WWIDTH,W(1,45))
c      CALL WWWWXX(W(1,1),W(1,8),W(1,16),W(1,45),GWWA,GWWZ,AMP(24))              !W+ -> WWW
      CALL wwww_anomal4(W(1,1),W(1,8),W(1,16),W(1,45), AMP(24))              !W+ -> WWW

      CALL FVIXXX(W(1,5   ),W(1,8   ),GWF ,ZERO    ,ZERO    ,W(1,46  ))    
      CALL JIOXXX(W(1,46  ),W(1,4   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,47  ))    
      CALL IOVXXX(W(1,17  ),W(1,6   ),W(1,47  ),GZN ,AMP(25  ))            
      CALL JIOXXX(W(1,46  ),W(1,4   ),GAL ,ZERO    ,AWIDTH  ,W(1,48  ))    
      CALL jwpawm_anomal3(W(1,48  ),W(1,1   ),W(1,49 ))                 
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,49  ),GWF ,AMP(26  ))            
      CALL jwpzwm_anomal3(W(1,47  ),W(1,1   ),W(1,50 ))   
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,50  ),GWF ,AMP(27  ))            
      CALL FVIXXX(W(1,7   ),W(1,48  ),GAL ,LMASS   ,ZERO    ,W(1,51  ))    
      CALL IOVXXX(W(1,51  ),W(1,6   ),W(1,1   ),GWF ,AMP(28  ))            
      CALL FVIXXX(W(1,7   ),W(1,47  ),GZL ,LMASS   ,ZERO    ,W(1,52  ))    
      CALL IOVXXX(W(1,52  ),W(1,6   ),W(1,1   ),GWF ,AMP(29  ))            
      CALL FVIXXX(W(1,46  ),W(1,1   ),GWF ,ZERO    ,ZERO    ,W(1,53  ))    
      CALL JIOXXX(W(1,53  ),W(1,4   ),GWF ,WMASS   ,WWIDTH  ,W(1,54  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,54  ),GWF ,AMP(30  ))            
      CALL FVOXXX(W(1,2   ),W(1,16  ),GWF ,ZERO    ,ZERO    ,W(1,55  ))    
      CALL JIOXXX(W(1,3   ),W(1,55  ),GZL ,ZMASS   ,ZWIDTH  ,W(1,56  ))    
      CALL IOVXXX(W(1,17  ),W(1,6   ),W(1,56  ),GZN ,AMP(31  ))            
      CALL JIOXXX(W(1,3   ),W(1,55  ),GAL ,ZERO    ,AWIDTH  ,W(1,57  ))    
      CALL jwpawm_anomal3(W(1,57  ),W(1,1   ),W(1,58 ))
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,58  ),GWF ,AMP(32  ))            
      CALL jwpzwm_anomal3(W(1,56  ),W(1,1   ),W(1,59 ))  
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,59  ),GWF ,AMP(33  ))            
      CALL FVIXXX(W(1,7   ),W(1,57  ),GAL ,LMASS   ,ZERO    ,W(1,60  ))    
      CALL IOVXXX(W(1,60  ),W(1,6   ),W(1,1   ),GWF ,AMP(34  ))            
      CALL FVIXXX(W(1,7   ),W(1,56  ),GZL ,LMASS   ,ZERO    ,W(1,61  ))    
      CALL IOVXXX(W(1,61  ),W(1,6   ),W(1,1   ),GWF ,AMP(35  ))            
      CALL FVIXXX(W(1,3   ),W(1,1   ),GWF ,ZERO    ,ZERO    ,W(1,62  ))    
      CALL JIOXXX(W(1,62  ),W(1,2   ),GZN ,ZMASS   ,ZWIDTH  ,W(1,63  ))    
      CALL FVIXXX(W(1,5   ),W(1,63  ),GZN ,ZERO    ,ZERO    ,W(1,64  ))    
      CALL JIOXXX(W(1,64  ),W(1,4   ),GWF ,WMASS   ,WWIDTH  ,W(1,65  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,65  ),GWF ,AMP(36  ))            
      CALL FVOXXX(W(1,4   ),W(1,63  ),GZL ,ZERO    ,ZERO    ,W(1,66  ))    
      CALL JIOXXX(W(1,5   ),W(1,66  ),GWF ,WMASS   ,WWIDTH  ,W(1,67  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,67  ),GWF ,AMP(37  ))            
      CALL JIOXXX(W(1,62  ),W(1,55  ),GWF ,WMASS   ,WWIDTH  ,W(1,68  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,68  ),GWF ,AMP(38  ))            
      CALL jwpzwm_anomal3(W(1,63  ),W(1,16  ),W(1,69 ))
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,69  ),GWF ,AMP(39  ))            
      CALL IOVXXX(W(1,24  ),W(1,6   ),W(1,63  ),GZN ,AMP(40  ))            
      CALL FVIXXX(W(1,7   ),W(1,63  ),GZL ,LMASS   ,ZERO    ,W(1,70  ))    
      CALL IOVXXX(W(1,70  ),W(1,6   ),W(1,16  ),GWF ,AMP(41  ))            
      CALL FVIXXX(W(1,3   ),W(1,16  ),GWF ,ZERO    ,ZERO    ,W(1,71  ))    
      CALL JIOXXX(W(1,71  ),W(1,2   ),GZN ,ZMASS   ,ZWIDTH  ,W(1,72  ))    
      CALL IOVXXX(W(1,17  ),W(1,6   ),W(1,72  ),GZN ,AMP(42  ))            
      CALL jwpzwm_anomal3(W(1,72  ),W(1,1   ),W(1,73 )) 
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,73  ),GWF ,AMP(43  ))            
      CALL FVIXXX(W(1,7   ),W(1,72  ),GZL ,LMASS   ,ZERO    ,W(1,74  ))    
      CALL IOVXXX(W(1,74  ),W(1,6   ),W(1,1   ),GWF ,AMP(44  ))            
      CALL FVOXXX(W(1,2   ),W(1,1   ),GWF ,ZERO    ,ZERO    ,W(1,75  ))    
      CALL JIOXXX(W(1,3   ),W(1,75  ),GZL ,ZMASS   ,ZWIDTH  ,W(1,76  ))    
      CALL FVIXXX(W(1,5   ),W(1,76  ),GZN ,ZERO    ,ZERO    ,W(1,77  ))    
      CALL JIOXXX(W(1,77  ),W(1,4   ),GWF ,WMASS   ,WWIDTH  ,W(1,78  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,78  ),GWF ,AMP(45  ))            
      CALL JIOXXX(W(1,3   ),W(1,75  ),GAL ,ZERO    ,AWIDTH  ,W(1,79  ))    
      CALL FVOXXX(W(1,4   ),W(1,79  ),GAL ,ZERO    ,ZERO    ,W(1,80  ))    
      CALL JIOXXX(W(1,5   ),W(1,80  ),GWF ,WMASS   ,WWIDTH  ,W(1,81  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,81  ),GWF ,AMP(46  ))            
      CALL FVOXXX(W(1,4   ),W(1,76  ),GZL ,ZERO    ,ZERO    ,W(1,82  ))    
      CALL JIOXXX(W(1,5   ),W(1,82  ),GWF ,WMASS   ,WWIDTH  ,W(1,83  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,83  ),GWF ,AMP(47  ))            
      CALL JIOXXX(W(1,71  ),W(1,75  ),GWF ,WMASS   ,WWIDTH  ,W(1,84  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,84  ),GWF ,AMP(48  ))            
      CALL jwpawm_anomal3(W(1,79  ),W(1,16  ),W(1,85 ))   
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,85  ),GWF ,AMP(49  ))            
      CALL jwpzwm_anomal3(W(1,76  ),W(1,16  ),W(1,86 ))     
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,86  ),GWF ,AMP(50  ))            
      CALL IOVXXX(W(1,24  ),W(1,6   ),W(1,76  ),GZN ,AMP(51  ))            
      CALL FVIXXX(W(1,7   ),W(1,79  ),GAL ,LMASS   ,ZERO    ,W(1,87  ))    
      CALL IOVXXX(W(1,87  ),W(1,6   ),W(1,16  ),GWF ,AMP(52  ))            
      CALL FVIXXX(W(1,7   ),W(1,76  ),GZL ,LMASS   ,ZERO    ,W(1,88  ))    
      CALL IOVXXX(W(1,88  ),W(1,6   ),W(1,16  ),GWF ,AMP(53  ))            

      WPWWW(MU) = -AMP(   1)-AMP(   2)-AMP(   3)-AMP(   4)-AMP(   5)
     &             -AMP(   6)-AMP(   7)-AMP(   9)-AMP(  10)
     &             -AMP(  11)-AMP(  13)-AMP(  14)-AMP(  15)
     &             -AMP(  16)-AMP(  17)-AMP(  18)-AMP(  20)
     &             -AMP(  21)-AMP(  22)-AMP(  24)-AMP(  25)
     &             -AMP(  26)-AMP(  27)-AMP(  28)-AMP(  29)-AMP(  30)
     &             -AMP(  31)-AMP(  32)-AMP(  33)-AMP(  34)-AMP(  35)
     &             -AMP(  36)-AMP(  37)-AMP(  38)-AMP(  39)-AMP(  40)
     &             -AMP(  41)-AMP(  42)-AMP(  43)-AMP(  44)-AMP(  45)
     &             -AMP(  46)-AMP(  47)-AMP(  48)-AMP(  49)-AMP(  50)
     &             -AMP(  51)-AMP(  52)-AMP(  53)
     &             -AMP(   8)-AMP(  19) !H coupled to WW
!     &             -AMP(  12)-AMP(  23) !H coupled to tau
      ENDDO
      ENDIF        ! NW

      WPWWW(4) = DCMPLX(Q(0),Q(3))
      WPWWW(5) = DCMPLX(Q(1),Q(2))

      RETURN
      END

C-------------------------------------------------------------------------------

C-------------------------------------------------------------------------------

      SUBROUTINE WWW_WMTOWWW_anomal(P,N,H,WMWWW,NW)
c Leptonic tensor for process 
c     W- --> W+ W- W- --> ve e+ mu- vm~ ta- vt~
c computed for fixed helicity set h

      IMPLICIT NONE

C ARGUMENTS

      DOUBLE PRECISION P(0:3,2:7)
      INTEGER N,H
      DOUBLE COMPLEX WMWWW(0:5)
      INTEGER NW
C
C LOCAL VARIABLES
C

      INTEGER LSIGN(2:7,2),L
      DATA(LSIGN(L,1),L=2,7)/-1,-1,-1,-1,-1,-1/	! H=1
      DATA(LSIGN(L,2),L=2,7)/-1,-1,-1,-1,+1,+1/	! H=2

      CALL WWW_WMTOWWW1_anomal(P,N,LSIGN(2,H),WMWWW(0),NW)    ! HELICITY COMBINATION #H IS SELECTED
							! HERE ONE ONLY NEEDS HELICITY SET H=1
      END

C-------------------------------------------------------------------------------

C-------------------------------------------------------------------------------

      SUBROUTINE WWW_WMTOWWW1_anomal(P,N,LSIGN,WMWWW,NW)
C  
C Generated by MadGraph II, SLIGHTLY CHANGED
C RETURNS AMPLITUDE
C FOR PROCESS : w- -> ve e+ mu- vm~ ta- vt~
C  
      IMPLICIT NONE
C  
C CONSTANTS
C  
      INTEGER    NGRAPHS
      PARAMETER (NGRAPHS=  53) 
      INTEGER    NWAVEFUNCS
      PARAMETER (NWAVEFUNCS=  81) 
      DOUBLE PRECISION     ZERO
      PARAMETER (ZERO=0D0)
C  
C ARGUMENTS 
C  
      DOUBLE PRECISION P(0:3,2:7)
      INTEGER N
      INTEGER LSIGN(2:7)
      DOUBLE COMPLEX WMWWW(0:5)
      INTEGER NW
C  
C LOCAL VARIABLES 
C  
      DOUBLE PRECISION Q(0:3)
      INTEGER I,MU
      DOUBLE COMPLEX AMP(NGRAPHS)
      DOUBLE COMPLEX W(18,NWAVEFUNCS)

      LOGICAL LSWITCH
      PARAMETER(LSWITCH=.true.)

!LEPTON SPINORS + POLARISATION VECTORS GENERATED IN M2S_QQWWW
#include "tensor.inc"

C
C GLOBAL VARIABLES
C
#include "VBFNLO/utilities/coupl.inc"

C ------------------------------------------------------------------------------
C BEGIN CODE
C ------------------------------------------------------------------------------

      IF(LSWITCH) THEN                                    !READ LEPTON WF FROM COMMMON BLOCK
         DO I=1,6
            W(I,2) = WVE2(I,N)
            W(I,3) = WEP2(I,N)
            W(I,4) = WMU2(I,N)
            W(I,5) = WVM2(I,N)
            W(I,6) = WTM(I,N)
            W(I,7) = WVTBAR(I,N)
            W(I,8) = W1P(I,N)
            W(I,28)= WM1(I,N)
         ENDDO
      ENDIF

      DO MU=0,3
         Q(MU) = P(MU,2) +  P(MU,3) +  P(MU,4) +  P(MU,5) +  P(MU,6) +  P(MU,7)
      ENDDO

c      moved to m2s_qqWWW.F
c      call anomal_formfactor_4v(q)

      IF(.NOT.LSWITCH) THEN
         CALL OXXXXX(P(0,2   ),ZERO ,+1*LSIGN(2   ),+1,W(1,2   ))        
         CALL IXXXXX(P(0,3   ),ZERO ,-1*LSIGN(3   ),-1,W(1,3   ))        
         CALL OXXXXX(P(0,4   ),ZERO ,+1*LSIGN(4   ),+1,W(1,4   ))        
         CALL IXXXXX(P(0,5   ),ZERO ,-1*LSIGN(5   ),-1,W(1,5   ))        
         CALL OXXXXX(P(0,6   ),LMASS,+1*LSIGN(6   ),+1,W(1,6   ))       
         CALL IXXXXX(P(0,7   ),ZERO ,-1*LSIGN(7   ),-1,W(1,7   ))        

         CALL JIOXXX(W(1,3   ),W(1,2   ),GWF ,WMASS   ,WWIDTH  ,W(1,8   ))    
         CALL JIOXXX(W(1,5   ),W(1,4   ),GWF ,WMASS   ,WWIDTH  ,W(1,28  ))    
c         print*,' ve  ',(wve(i,N)/w(i,2),i=1,6)
c         print*,' ep  ',(wep(i,N)/w(i,3),i=1,6)
c         print*,' mu  ',(wmu(i,N)/w(i,4),i=1,6)
c         print*,' vm  ',(wvm(i,N)/w(i,5),i=1,6)
c         print*,' tm  ',(wtm(i,N)/w(i,6),i=1,6)
c         print*,' vt~ ',(wvtbar(i,N)/w(i,7),i=1,6)
c         print*,' wp1 ',(wp1(i,N)/w(i,8),i=1,6)
c         print*,' wm1 ',(wm1(i,N)/w(i,13),i=1,6)
      ENDIF

      IF(NW.EQ.1) THEN
         DO MU=0,3
            CALL TRIPLEWVCARTX(Q(0),WMASS,WWIDTH,MU,-1,W(1,1))
            CALL jaww_anomal3(W(1,28  ),W(1,8   ),W(1,30 ))  
            CALL jwmwpa_anomal3(W(1,1   ),W(1,30  ),W(1,33 ))
            CALL IOVXXX(W(1,7) ,W(1,6) ,W(1,33),GWF,AMP(16))              !W- -> W-A -> WWW
            CALL jzww_anomal3(W(1,28  ),W(1,8   ),W(1,31 )) 
            CALL jwmwpz_anomal3(W(1,1   ),W(1,31  ),W(1,34 ))  
            CALL IOVXXX(W(1,7) ,W(1,6) ,W(1,34),GWF,AMP(17))              !W- -> W-Z -> WWW
            CALL jhww_anomal3(W(1,28  ),W(1,8   ),W(1,32 ))    
            CALL JIOXXX(W(1,7   ),W(1,6  ),GWF ,WMASS   ,WWIDTH  ,W(1,35  ))    
            CALL wwh_anomal3(W(1,1  ),W(1,35   ),W(1,32  ),AMP(18   ))    !W- -> W-H -> WWW
            CALL jaww_anomal3(W(1,28  ),W(1,1   ),W(1,38 ))  
            CALL jwmwpa_anomal3(W(1,8   ),W(1,38  ),W(1,47 ))  
            CALL IOVXXX(W(1,7) ,W(1,6) ,W(1,47),GWF ,AMP(25))             !W- -> A W- -> WWW
            CALL jzww_anomal3(W(1,28  ),W(1,1   ),W(1,41 )) 
            CALL jwmwpz_anomal3(W(1,8   ),W(1,41  ),W(1,48 ))  
            CALL IOVXXX(W(1,7) ,W(1,6) ,W(1,48),GWF,AMP(26))              !W- -> Z W- -> WWW
            CALL jhww_anomal3(W(1,28  ),W(1,1   ),W(1,49 ))
            CALL JIOXXX(W(1,7   ),W(1,6  ),GWF ,WMASS   ,WWIDTH  ,W(1,50  ))    
            CALL wwh_anomal3(W(1,8  ),W(1,50   ),W(1,49  ),AMP(27  ))     !W- -> H W- -> WWW
            CALL JIOXXX(W(1,7),W(1,6),GWF,WMASS,WWIDTH,W(1,52))
            CALL wwww_anomal4(W(1,28),W(1,8),W(1,52),W(1,1) ,AMP(32))              !W- -> WWW

            WMWWW(MU) = - AMP(16) - AMP(25)  !A CONTRIBUTION
     &                  - AMP(17) - AMP(26)  !Z CONTRIBUTION
     &                  - AMP(18) - AMP(27)  !H CONTRIBUTION
     &                  - AMP(32)            !QUARTIC COUPLING

         ENDDO
      ELSEIF(NW.EQ.0) THEN

      DO MU=0,3
      CALL TRIPLEWVCARTX(Q(0),WMASS,WWIDTH,MU,-1,W(1,1))
      CALL FVOXXX(W(1,4   ),W(1,8   ),GWF ,ZERO    ,ZERO    ,W(1,9   ))    
      CALL JIOXXX(W(1,5   ),W(1,9   ),GZN ,ZMASS   ,ZWIDTH  ,W(1,10  ))    
      CALL FVOXXX(W(1,6   ),W(1,10  ),GZL ,LMASS   ,ZERO    ,W(1,11  ))    
      CALL IOVXXX(W(1,7   ),W(1,11  ),W(1,1   ),GWF ,AMP(1   ))            
      CALL jwmwpz_anomal3(W(1,1   ),W(1,10  ),W(1,12 )) 
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,12  ),GWF ,AMP(2   ))            
      CALL FVIXXX(W(1,7   ),W(1,10  ),GZN ,ZERO    ,ZERO    ,W(1,13  ))    
      CALL IOVXXX(W(1,13  ),W(1,6   ),W(1,1   ),GWF ,AMP(3   ))            
      CALL FVIXXX(W(1,5   ),W(1,1   ),GWF ,ZERO    ,ZERO    ,W(1,14  ))    
      CALL JIOXXX(W(1,14  ),W(1,4   ),GAL ,ZERO    ,AWIDTH  ,W(1,15  ))    
      CALL FVIXXX(W(1,3   ),W(1,15  ),GAL ,ZERO    ,ZERO    ,W(1,16  ))    
      CALL JIOXXX(W(1,16  ),W(1,2   ),GWF ,WMASS   ,WWIDTH  ,W(1,17  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,17  ),GWF ,AMP(4   ))            
      CALL JIOXXX(W(1,14  ),W(1,4   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,18  ))    
      CALL FVIXXX(W(1,3   ),W(1,18  ),GZL ,ZERO    ,ZERO    ,W(1,19  ))    
      CALL JIOXXX(W(1,19  ),W(1,2   ),GWF ,WMASS   ,WWIDTH  ,W(1,20  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,20  ),GWF ,AMP(5   ))            
      CALL FVOXXX(W(1,2   ),W(1,18  ),GZN ,ZERO    ,ZERO    ,W(1,21  ))    
      CALL JIOXXX(W(1,3   ),W(1,21  ),GWF ,WMASS   ,WWIDTH  ,W(1,22  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,22  ),GWF ,AMP(6   ))            
      CALL jwmwpa_anomal3(W(1,8   ),W(1,15  ),W(1,23 )) 
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,23  ),GWF ,AMP(7   ))            
      CALL jwmwpz_anomal3(W(1,8   ),W(1,18  ),W(1,24 )) 
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,24  ),GWF ,AMP(8   ))            
      CALL FVIXXX(W(1,7   ),W(1,18  ),GZN ,ZERO    ,ZERO    ,W(1,25  ))    
      CALL IOVXXX(W(1,25  ),W(1,6   ),W(1,8   ),GWF ,AMP(9   ))            
      CALL FVIXXX(W(1,7   ),W(1,8   ),GWF ,LMASS   ,ZERO    ,W(1,26  ))    
      CALL IOVXXX(W(1,26  ),W(1,6   ),W(1,15  ),GAL ,AMP(10  ))            
      CALL IOVXXX(W(1,26  ),W(1,6   ),W(1,18  ),GZL ,AMP(11  ))            
      CALL JIOXXX(W(1,14  ),W(1,9   ),GWF ,WMASS   ,WWIDTH  ,W(1,27  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,27  ),GWF ,AMP(12  ))            
C      CALL JIOXXX(W(1,5   ),W(1,4   ),GWF ,WMASS   ,WWIDTH  ,W(1,28  ))    
      CALL FVIXXX(W(1,7   ),W(1,1   ),GWF ,LMASS   ,ZERO    ,W(1,29  ))    
      CALL jaww_anomal3(W(1,28  ),W(1,8   ),W(1,30 )) 
      CALL IOVXXX(W(1,29  ),W(1,6   ),W(1,30  ),GAL ,AMP(13  ))            
      CALL jzww_anomal3(W(1,28  ),W(1,8   ),W(1,31 ))    
      CALL IOVXXX(W(1,29  ),W(1,6   ),W(1,31  ),GZL ,AMP(14  ))            
      CALL jhww_anomal3(W(1,28  ),W(1,8   ),W(1,32 ))     
c      CALL IOSXXX(W(1,29  ),W(1,6   ),W(1,32  ),GHTAU ,AMP(15  ))    !H coupled to tau      
      CALL jwmwpa_anomal3(W(1,1   ),W(1,30  ),W(1,33 ))  
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,33  ),GWF ,AMP(16  ))            
      CALL jwmwpz_anomal3(W(1,1   ),W(1,31  ),W(1,34 )) 
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,34  ),GWF ,AMP(17  ))            
      CALL JIOXXX(W(1,7   ),W(1,6  ),GWF ,WMASS   ,WWIDTH  ,W(1,35  ))    
      CALL wwh_anomal3(W(1,1  ),W(1,35   ),W(1,32  ),AMP(18   ))
      CALL FVIXXX(W(1,26  ),W(1,28  ),GWF ,ZERO    ,ZERO    ,W(1,36  ))    
      CALL IOVXXX(W(1,36  ),W(1,6   ),W(1,1   ),GWF ,AMP(19  ))            
      CALL FVIXXX(W(1,7   ),W(1,31  ),GZN ,ZERO    ,ZERO    ,W(1,37  ))    
      CALL IOVXXX(W(1,37  ),W(1,6   ),W(1,1   ),GWF ,AMP(20  ))            
      CALL jaww_anomal3(W(1,28  ),W(1,1   ),W(1,38 ))    
      CALL FVIXXX(W(1,3   ),W(1,38  ),GAL ,ZERO    ,ZERO    ,W(1,39  ))    
      CALL JIOXXX(W(1,39  ),W(1,2   ),GWF ,WMASS   ,WWIDTH  ,W(1,40  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,40  ),GWF ,AMP(21  ))            
      CALL jzww_anomal3(W(1,28  ),W(1,1   ),W(1,41 )) 
      CALL FVIXXX(W(1,3   ),W(1,41  ),GZL ,ZERO    ,ZERO    ,W(1,42  ))    
      CALL JIOXXX(W(1,42  ),W(1,2   ),GWF ,WMASS   ,WWIDTH  ,W(1,43  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,43  ),GWF ,AMP(22  ))            
      CALL FVOXXX(W(1,2   ),W(1,41  ),GZN ,ZERO    ,ZERO    ,W(1,44  ))    
      CALL JIOXXX(W(1,3   ),W(1,44  ),GWF ,WMASS   ,WWIDTH  ,W(1,45  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,45  ),GWF ,AMP(23  ))            
      CALL FVIXXX(W(1,29  ),W(1,28  ),GWF ,ZERO    ,ZERO    ,W(1,46  ))    
      CALL IOVXXX(W(1,46  ),W(1,6   ),W(1,8   ),GWF ,AMP(24  ))            
      CALL jwmwpa_anomal3(W(1,8   ),W(1,38  ),W(1,47 )) 
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,47  ),GWF ,AMP(25  ))            
      CALL jwmwpz_anomal3(W(1,8   ),W(1,41  ),W(1,48 )) 
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,48  ),GWF ,AMP(26  ))            
      CALL jhww_anomal3(W(1,28  ),W(1,1   ),W(1,49 ))  
      CALL JIOXXX(W(1,7   ),W(1,6  ),GWF ,WMASS   ,WWIDTH  ,W(1,50  ))    
      CALL wwh_anomal3(W(1,8  ),W(1,50   ),W(1,49  ),AMP(27  ))
      CALL FVIXXX(W(1,7   ),W(1,41  ),GZN ,ZERO    ,ZERO    ,W(1,51  ))    
      CALL IOVXXX(W(1,51  ),W(1,6   ),W(1,8   ),GWF ,AMP(28  ))            
      CALL IOVXXX(W(1,26  ),W(1,6   ),W(1,38  ),GAL ,AMP(29  ))            
      CALL IOVXXX(W(1,26  ),W(1,6   ),W(1,41  ),GZL ,AMP(30  ))            
c      CALL IOSXXX(W(1,26  ),W(1,6   ),W(1,49  ),GHTAU ,AMP(31  ))   !H coupled to tau       

c      CALL JWWWXX(W(1,1   ),W(1,28  ),W(1,8   ),GWWA ,GWWZ ,WMASS,WWIDTH,W(1,52  ))                                             
c      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,52  ),GWF ,AMP(32  ))            
      CALL JIOXXX(W(1,7),W(1,6),GWF,WMASS,WWIDTH,W(1,52))
c      CALL WWWWXX(W(1,28),W(1,8),W(1,52),W(1,1),GWWA,GWWZ,AMP(32))              !W- -> WWW
      CALL wwww_anomal4(W(1,28),W(1,8),W(1,52),W(1,1) ,AMP(32))              !W- -> WWW

      CALL FVIXXX(W(1,5   ),W(1,8   ),GWF ,ZERO    ,ZERO    ,W(1,53  ))    
      CALL JIOXXX(W(1,53  ),W(1,4   ),GAL ,ZERO    ,AWIDTH  ,W(1,54  ))    
      CALL IOVXXX(W(1,29  ),W(1,6   ),W(1,54  ),GAL ,AMP(33  ))            
      CALL JIOXXX(W(1,53  ),W(1,4   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,55  ))    
      CALL IOVXXX(W(1,29  ),W(1,6   ),W(1,55  ),GZL ,AMP(34  ))            
      CALL jwmwpa_anomal3(W(1,1   ),W(1,54  ),W(1,56 )) 
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,56  ),GWF ,AMP(35  ))            
      CALL jwmwpz_anomal3(W(1,1   ),W(1,55  ),W(1,57 ))   
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,57  ),GWF ,AMP(36  ))            
      CALL FVIXXX(W(1,7   ),W(1,55  ),GZN ,ZERO    ,ZERO    ,W(1,58  ))    
      CALL IOVXXX(W(1,58  ),W(1,6   ),W(1,1   ),GWF ,AMP(37  ))            
      CALL FVOXXX(W(1,4   ),W(1,1   ),GWF ,ZERO    ,ZERO    ,W(1,59  ))    
      CALL JIOXXX(W(1,5   ),W(1,59  ),GZN ,ZMASS   ,ZWIDTH  ,W(1,60  ))    
      CALL FVIXXX(W(1,3   ),W(1,60  ),GZL ,ZERO    ,ZERO    ,W(1,61  ))    
      CALL JIOXXX(W(1,61  ),W(1,2   ),GWF ,WMASS   ,WWIDTH  ,W(1,62  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,62  ),GWF ,AMP(38  ))            
      CALL FVOXXX(W(1,2   ),W(1,60  ),GZN ,ZERO    ,ZERO    ,W(1,63  ))    
      CALL JIOXXX(W(1,3   ),W(1,63  ),GWF ,WMASS   ,WWIDTH  ,W(1,64  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,64  ),GWF ,AMP(39  ))            
      CALL JIOXXX(W(1,53  ),W(1,59  ),GWF ,WMASS   ,WWIDTH  ,W(1,65  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,65  ),GWF ,AMP(40  ))            
      CALL jwmwpz_anomal3(W(1,8   ),W(1,60  ),W(1,66 ))   
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,66  ),GWF ,AMP(41  ))            
      CALL FVIXXX(W(1,7   ),W(1,60  ),GZN ,ZERO    ,ZERO    ,W(1,67  ))    
      CALL IOVXXX(W(1,67  ),W(1,6   ),W(1,8   ),GWF ,AMP(42  ))            
      CALL IOVXXX(W(1,26  ),W(1,6   ),W(1,60  ),GZL ,AMP(43  ))            
      CALL FVOXXX(W(1,2   ),W(1,28  ),GWF ,ZERO    ,ZERO    ,W(1,68  ))    
      CALL JIOXXX(W(1,3   ),W(1,68  ),GAL ,ZERO    ,AWIDTH  ,W(1,69  ))    
      CALL IOVXXX(W(1,29  ),W(1,6   ),W(1,69  ),GAL ,AMP(44  ))            
      CALL JIOXXX(W(1,3   ),W(1,68  ),GZL ,ZMASS   ,ZWIDTH  ,W(1,70  ))    
      CALL IOVXXX(W(1,29  ),W(1,6   ),W(1,70  ),GZL ,AMP(45  ))            
      CALL jwmwpa_anomal3(W(1,1   ),W(1,69  ),W(1,71 ))  
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,71  ),GWF ,AMP(46  ))            
      CALL jwmwpz_anomal3(W(1,1   ),W(1,70  ),W(1,72 ))   
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,72  ),GWF ,AMP(47  ))            
      CALL FVIXXX(W(1,7   ),W(1,70  ),GZN ,ZERO    ,ZERO    ,W(1,73  ))    
      CALL IOVXXX(W(1,73  ),W(1,6   ),W(1,1   ),GWF ,AMP(48  ))            
      CALL FVOXXX(W(1,68  ),W(1,1   ),GWF ,ZERO    ,ZERO    ,W(1,74  ))    
      CALL JIOXXX(W(1,3   ),W(1,74  ),GWF ,WMASS   ,WWIDTH  ,W(1,75  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,75  ),GWF ,AMP(49  ))            
      CALL FVIXXX(W(1,3   ),W(1,28  ),GWF ,ZERO    ,ZERO    ,W(1,76  ))    
      CALL JIOXXX(W(1,76  ),W(1,2   ),GZN ,ZMASS   ,ZWIDTH  ,W(1,77  ))    
      CALL IOVXXX(W(1,29  ),W(1,6   ),W(1,77  ),GZL ,AMP(50  ))            
      CALL jwmwpz_anomal3(W(1,1   ),W(1,77  ),W(1,78 )) 
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,78  ),GWF ,AMP(51  ))            
      CALL FVIXXX(W(1,7   ),W(1,77  ),GZN ,ZERO    ,ZERO    ,W(1,79  ))    
      CALL IOVXXX(W(1,79  ),W(1,6   ),W(1,1   ),GWF ,AMP(52  ))            
      CALL FVIXXX(W(1,76  ),W(1,1   ),GWF ,ZERO    ,ZERO    ,W(1,80  ))    
      CALL JIOXXX(W(1,80  ),W(1,2   ),GWF ,WMASS   ,WWIDTH  ,W(1,81  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,81  ),GWF ,AMP(53  ))            

      WMWWW(MU) = -AMP(   1)-AMP(   2)-AMP(   3)-AMP(   4)-AMP(   5)
     &             -AMP(   6)-AMP(   7)-AMP(   8)-AMP(   9)-AMP(  10)
     &             -AMP(  11)-AMP(  12)-AMP(  13)-AMP(  14)
     &             -AMP(  16)-AMP(  17)-AMP(  19)-AMP(  20)
     &             -AMP(  21)-AMP(  22)-AMP(  23)-AMP(  24)-AMP(  25)
     &             -AMP(  26)-AMP(  28)-AMP(  29)-AMP(  30)
     &             -AMP(  32)-AMP(  33)-AMP(  34)-AMP(  35)
     &             -AMP(  36)-AMP(  37)-AMP(  38)-AMP(  39)-AMP(  40)
     &             -AMP(  41)-AMP(  42)-AMP(  43)-AMP(  44)-AMP(  45)
     &             -AMP(  46)-AMP(  47)-AMP(  48)-AMP(  49)-AMP(  50)
     &             -AMP(  51)-AMP(  52)-AMP(  53)
     &             -AMP(  18)-AMP(  27) !H coupled to WW
!     &             -AMP(  15)-AMP(  31) !H coupled to tau
      ENDDO

      ENDIF  ! NW

      WMWWW(4) = DCMPLX(Q(0),Q(3))
      WMWWW(5) = DCMPLX(Q(1),Q(2))

      RETURN
      END

