c ------------------------------------------------------------

      subroutine ZTOWWZ_kk(P,N,h,wwz,NW)

      IMPLICIT NONE

      DOUBLE PRECISION P(0:3,2:7)
      complex*16 wwz(0:5),wwzkk(0:5)
      integer lsign(2:7,2),ll,mu,nu,h,N,i
      integer NW ! = 0: all diagrams, = 1: no non resonant diagrams

      ! possible lepton helicities:
      data (lsign(ll,1),ll=2,7) / -1, -1, -1, -1, -1, -1/  !h=1
      data (lsign(ll,2),ll=2,7) / -1, -1, -1, -1, +1, +1/  !h=2

      call ZTOWWZ1_kk(P,N,lsign(2,h),wwz(0),NW)

      ! helicity combi nr.h is selected

      end

c ------------------------------------------------------------

      SUBROUTINE ZTOWWZ1_kk(P,N,lsign,wwz,NW)
C
C Generated by MadGraph II Version 3.0. Updated 02/19/04
C RETURNS AMPLITUDE SQUARED SUMMED/AVG OVER COLORS
C FOR THE POINT WITH EXTERNAL LINES W(0:6,NEXTERNAL)
C
C FOR PROCESS : z -> ve e+ mu- vm~ ta- ta+ 
C 
      IMPLICIT NONE
C
C CONSTANTS
C 
      INTEGER    NGRAPHS
      PARAMETER (NGRAPHS=  75)
      INTEGER    NWAVEFUNCS
      PARAMETER (NWAVEFUNCS=  119)
      DOUBLE PRECISION     ZERO
      PARAMETER (ZERO=0D0)
C
C ARGUMENTS
C 
      DOUBLE PRECISION P(0:3,2:7), Q(0:3)
      INTEGER N
      COMPLEX*16 wwz(0:5)
      INTEGER lsign(2:7)
      integer NW ! = 0: all diagrams, = 1: no non resonant diagrams
C
C LOCAL VARIABLES
C 
      INTEGER I,J, mu
      COMPLEX*16 AMP(NGRAPHS)
      COMPLEX*16 W(6,NWAVEFUNCS)

c  lepton spinors and W+-, Z/A polarization vectors
	include "tensor.inc"

      logical lswitch
      parameter (lswitch=.true.)

C
C GLOBAL VARIABLES
C 
	include "VBFNLO/utilities/coupl.inc"
C
c Call Kaluza-Klein couplings
c 
	include "VBFNLO/utilities/kkcoupl.inc"
      COMPLEX*16 KK1(6,1:kkw),KK2(6,1:kkw),AMPK1(1:kkw),AMPK2(1:kkw)
	COMPLEX*16 kkh1(6,1:kkh), AMPKH(1:kkh),h1(6), AMPH
	COMPLEX*16 KK3(6,1:kkw),KK4(6,1:kkw)
      INTEGER k

C ----------
C BEGIN CODE
C ----------

      if (lswitch) then      ! read in lepton an W states from common block
         do i=1,6
            w(i,2)  = wve(i,N)
            w(i,3)  = wep(i,N)
            w(i,4)  = wmu(i,N)
            w(i,5)  = wvm(i,N)
            w(i,6)  = ztm(i,N)
            w(i,7)  = ztp(i,N)
            w(i,8)  = wp(i,N)
            w(i,29) = wm(i,N)
		w(i,118)   = atau(i,N)
		w(i,119)   = ztau(i,N)
         enddo
      endif

      do mu = 0,3
         q(mu) = p(mu,2)+p(mu,3)+p(mu,4)+p(mu,5)+p(mu,6)+p(mu,7)
      enddo

      do mu = 0,3
      CALL TRIBOSVCARTX(Q(0),ZMASS ,ZWIDTH, MU,-1,W(1,1   ))
c Standard model graphs from Madgraph             
c      CALL JIOXXX(W(1,3   ),W(1,2   ),GWF ,WMASS   ,WWIDTH  ,W(1,8   ))    !wp
      CALL FVOXXX(W(1,4   ),W(1,8   ),GWF ,ZERO    ,ZERO    ,W(1,9   ))    
      CALL JIOXXX(W(1,5   ),W(1,9   ),GZN ,ZMASS   ,ZWIDTH  ,W(1,10  ))    
      CALL FVIXXX(W(1,7   ),W(1,1   ),GZL ,LMASS   ,ZERO    ,W(1,11  ))    
      CALL IOVXXX(W(1,11  ),W(1,6   ),W(1,10  ),GZL ,AMP(1   ))       
      CALL FVIXXX(W(1,7   ),W(1,10  ),GZL ,LMASS   ,ZERO    ,W(1,12  ))    
      CALL IOVXXX(W(1,12  ),W(1,6   ),W(1,1   ),GZL ,AMP(2   ))            
      CALL FVIXXX(W(1,5   ),W(1,1   ),GZN ,ZERO    ,ZERO    ,W(1,13  ))    
      CALL JIOXXX(W(1,13  ),W(1,4   ),GWF ,WMASS   ,WWIDTH  ,W(1,14  ))    
      CALL FVIXXX(W(1,3   ),W(1,14  ),GWF ,ZERO    ,ZERO    ,W(1,15  ))    
      CALL JIOXXX(W(1,15  ),W(1,2   ),GZN ,ZMASS   ,ZWIDTH  ,W(1,16  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,16  ),GZL ,AMP(3   ))            
      CALL FVOXXX(W(1,2   ),W(1,14  ),GWF ,ZERO    ,ZERO    ,W(1,17  ))    
      CALL JIOXXX(W(1,3   ),W(1,17  ),GAL ,ZERO    ,AWIDTH  ,W(1,18  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,18  ),GAL ,AMP(4   ))            
      CALL JIOXXX(W(1,3   ),W(1,17  ),GZL ,ZMASS   ,ZWIDTH  ,W(1,19  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,19  ),GZL ,AMP(5   ))            
      CALL FVIXXX(W(1,13  ),W(1,8   ),GWF ,ZERO    ,ZERO    ,W(1,20  ))    
      CALL JIOXXX(W(1,20  ),W(1,4   ),GAL ,ZERO    ,AWIDTH  ,W(1,21  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,21  ),GAL ,AMP(6   ))            
      CALL JIOXXX(W(1,20  ),W(1,4   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,22  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,22  ),GZL ,AMP(7   ))            
      CALL FVOXXX(W(1,9   ),W(1,1   ),GZN ,ZERO    ,ZERO    ,W(1,23  ))    
      CALL JIOXXX(W(1,5   ),W(1,23  ),GZN ,ZMASS   ,ZWIDTH  ,W(1,24  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,24  ),GZL ,AMP(8   ))            
      CALL JVVXXX(W(1,14  ),W(1,8   ),GWWA ,ZERO    ,AWIDTH  ,W(1,         
     &     25  ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,25  ),GAL ,AMP(9   ))            
      CALL JVVXXX(W(1,14  ),W(1,8   ),GWWZ ,ZMASS   ,ZWIDTH  ,W(1,         
     &     26  ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,26  ),GZL ,AMP(10  ))            
      CALL FVIXXX(W(1,7   ),W(1,14  ),GWF ,ZERO    ,ZERO    ,W(1,27  ))    
      CALL IOVXXX(W(1,27  ),W(1,6   ),W(1,8   ),GWF ,AMP(11  ))            
      CALL JIOXXX(W(1,13  ),W(1,9   ),GZN ,ZMASS   ,ZWIDTH  ,W(1,28  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,28  ),GZL ,AMP(12  ))            
c      CALL JIOXXX(W(1,5   ),W(1,4   ),GWF ,WMASS   ,WWIDTH  ,W(1,29  ))   ! wm 
      CALL JVVXXX(W(1,29  ),W(1,8   ),GWWA ,ZERO    ,AWIDTH  ,W(1,         
     &     30  ))                                                          
      CALL IOVXXX(W(1,11  ),W(1,6   ),W(1,30  ),GAL ,AMP(13  ))            
      CALL JVVXXX(W(1,29  ),W(1,8   ),GWWZ ,ZMASS   ,ZWIDTH  ,W(1,         
     &     31  ))                                                          
      CALL IOVXXX(W(1,11  ),W(1,6   ),W(1,31  ),GZL ,AMP(14  ))            
      CALL FVIXXX(W(1,7   ),W(1,29  ),GWF ,ZERO    ,ZERO    ,W(1,32  ))    
      CALL FVIXXX(W(1,32  ),W(1,8   ),GWF ,LMASS   ,ZERO    ,W(1,33  ))    
      CALL IOVXXX(W(1,33  ),W(1,6   ),W(1,1   ),GZL ,AMP(15  ))            
      CALL FVIXXX(W(1,7   ),W(1,30  ),GAL ,LMASS   ,ZERO    ,W(1,34  ))    
      CALL IOVXXX(W(1,34  ),W(1,6   ),W(1,1   ),GZL ,AMP(16  ))            
      CALL FVIXXX(W(1,7   ),W(1,31  ),GZL ,LMASS   ,ZERO    ,W(1,35  ))    
      CALL IOVXXX(W(1,35  ),W(1,6   ),W(1,1   ),GZL ,AMP(17  ))            
      CALL JVVXXX(W(1,1   ),W(1,29  ),GWWZ ,WMASS   ,WWIDTH  ,W(1,         
     &     36  ))                                                          
      CALL FVIXXX(W(1,3   ),W(1,36  ),GWF ,ZERO    ,ZERO    ,W(1,37  ))    
      CALL JIOXXX(W(1,37  ),W(1,2   ),GZN ,ZMASS   ,ZWIDTH  ,W(1,38  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,38  ),GZL ,AMP(18  ))            
      CALL FVOXXX(W(1,2   ),W(1,36  ),GWF ,ZERO    ,ZERO    ,W(1,39  ))    
      CALL JIOXXX(W(1,3   ),W(1,39  ),GAL ,ZERO    ,AWIDTH  ,W(1,40  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,40  ),GAL ,AMP(19  ))            
      CALL JIOXXX(W(1,3   ),W(1,39  ),GZL ,ZMASS   ,ZWIDTH  ,W(1,41  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,41  ),GZL ,AMP(20  ))            
      CALL JVVXXX(W(1,8   ),W(1,1   ),GWWZ ,WMASS   ,WWIDTH  ,W(1,         
     &     42  ))                                                          
      CALL FVIXXX(W(1,5   ),W(1,42  ),GWF ,ZERO    ,ZERO    ,W(1,43  ))    
      CALL JIOXXX(W(1,43  ),W(1,4   ),GAL ,ZERO    ,AWIDTH  ,W(1,44  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,44  ),GAL ,AMP(21  ))            
      CALL JIOXXX(W(1,43  ),W(1,4   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,45  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,45  ),GZL ,AMP(22  ))            
      CALL FVOXXX(W(1,4   ),W(1,42  ),GWF ,ZERO    ,ZERO    ,W(1,46  ))    
      CALL JIOXXX(W(1,5   ),W(1,46  ),GZN ,ZMASS   ,ZWIDTH  ,W(1,47  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,47  ),GZL ,AMP(23  ))            

      CALL W3W3XX(W(1,29  ),W(1,1   ),W(1,8   ),W(1,118  ),1.d0,			!
     & GWWAZ_k(0,0,0,0) ,AMP(24  ))                                           !redone 4 vertices
      CALL W3W3XX(W(1,29  ),W(1,1   ),W(1,8   ),W(1,119  ),1.d0,		     	!
     & GWWZZ_k(0,0,0,0) ,AMP(25  ))  							!

      CALL FVIXXX(W(1,11  ),W(1,29  ),GWF ,ZERO    ,ZERO    ,W(1,50  ))    
      CALL IOVXXX(W(1,50  ),W(1,6   ),W(1,8   ),GWF ,AMP(26  ))            
      CALL JVVXXX(W(1,36  ),W(1,8   ),GWWA ,ZERO    ,AWIDTH  ,W(1,         
     &     51  ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,51  ),GAL ,AMP(27  ))            
      CALL JVVXXX(W(1,36  ),W(1,8   ),GWWZ ,ZMASS   ,ZWIDTH  ,W(1,         
     &     52  ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,52  ),GZL ,AMP(28  ))            
      CALL FVIXXX(W(1,32  ),W(1,1   ),GZN ,ZERO    ,ZERO    ,W(1,53  ))    
      CALL IOVXXX(W(1,53  ),W(1,6   ),W(1,8   ),GWF ,AMP(29  ))            
      CALL FVIXXX(W(1,7   ),W(1,36  ),GWF ,ZERO    ,ZERO    ,W(1,54  ))    
      CALL IOVXXX(W(1,54  ),W(1,6   ),W(1,8   ),GWF ,AMP(30  ))            
      CALL JVVXXX(W(1,29  ),W(1,42  ),GWWA ,ZERO    ,AWIDTH  ,W(1,         
     &     55  ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,55  ),GAL ,AMP(31  ))            
      CALL JVVXXX(W(1,29  ),W(1,42  ),GWWZ ,ZMASS   ,ZWIDTH  ,W(1,         
     &     56  ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,56  ),GZL ,AMP(32  ))            
      CALL IOVXXX(W(1,32  ),W(1,6   ),W(1,42  ),GWF ,AMP(33  ))            
      CALL FVIXXX(W(1,5   ),W(1,8   ),GWF ,ZERO    ,ZERO    ,W(1,57  ))    
      CALL JIOXXX(W(1,57  ),W(1,4   ),GAL ,ZERO    ,AWIDTH  ,W(1,58  ))    
      CALL IOVXXX(W(1,11  ),W(1,6   ),W(1,58  ),GAL ,AMP(34  ))            
      CALL JIOXXX(W(1,57  ),W(1,4   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,59  ))    
      CALL IOVXXX(W(1,11  ),W(1,6   ),W(1,59  ),GZL ,AMP(35  ))            
      CALL FVIXXX(W(1,7   ),W(1,58  ),GAL ,LMASS   ,ZERO    ,W(1,60  ))    
      CALL IOVXXX(W(1,60  ),W(1,6   ),W(1,1   ),GZL ,AMP(36  ))            
      CALL FVIXXX(W(1,7   ),W(1,59  ),GZL ,LMASS   ,ZERO    ,W(1,61  ))    
      CALL IOVXXX(W(1,61  ),W(1,6   ),W(1,1   ),GZL ,AMP(37  ))            
      CALL FVOXXX(W(1,4   ),W(1,1   ),GZL ,ZERO    ,ZERO    ,W(1,62  ))    
      CALL JIOXXX(W(1,5   ),W(1,62  ),GWF ,WMASS   ,WWIDTH  ,W(1,63  ))    
      CALL FVIXXX(W(1,3   ),W(1,63  ),GWF ,ZERO    ,ZERO    ,W(1,64  ))    
      CALL JIOXXX(W(1,64  ),W(1,2   ),GZN ,ZMASS   ,ZWIDTH  ,W(1,65  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,65  ),GZL ,AMP(38  ))            
      CALL FVOXXX(W(1,2   ),W(1,63  ),GWF ,ZERO    ,ZERO    ,W(1,66  ))    
      CALL JIOXXX(W(1,3   ),W(1,66  ),GAL ,ZERO    ,AWIDTH  ,W(1,67  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,67  ),GAL ,AMP(39  ))            
      CALL JIOXXX(W(1,3   ),W(1,66  ),GZL ,ZMASS   ,ZWIDTH  ,W(1,68  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,68  ),GZL ,AMP(40  ))            
      CALL FVIXXX(W(1,57  ),W(1,1   ),GZL ,ZERO    ,ZERO    ,W(1,69  ))    
      CALL JIOXXX(W(1,69  ),W(1,4   ),GAL ,ZERO    ,AWIDTH  ,W(1,70  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,70  ),GAL ,AMP(41  ))            
      CALL JIOXXX(W(1,69  ),W(1,4   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,71  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,71  ),GZL ,AMP(42  ))            
      CALL FVOXXX(W(1,62  ),W(1,8   ),GWF ,ZERO    ,ZERO    ,W(1,72  ))    
      CALL JIOXXX(W(1,5   ),W(1,72  ),GZN ,ZMASS   ,ZWIDTH  ,W(1,73  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,73  ),GZL ,AMP(43  ))            
      CALL JVVXXX(W(1,63  ),W(1,8   ),GWWA ,ZERO    ,AWIDTH  ,W(1,         
     &     74  ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,74  ),GAL ,AMP(44  ))            
      CALL JVVXXX(W(1,63  ),W(1,8   ),GWWZ ,ZMASS   ,ZWIDTH  ,W(1,         
     &     75  ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,75  ),GZL ,AMP(45  ))            
      CALL FVIXXX(W(1,7   ),W(1,63  ),GWF ,ZERO    ,ZERO    ,W(1,76  ))    
      CALL IOVXXX(W(1,76  ),W(1,6   ),W(1,8   ),GWF ,AMP(46  ))            
      CALL JIOXXX(W(1,57  ),W(1,62  ),GAL ,ZERO    ,AWIDTH  ,W(1,77  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,77  ),GAL ,AMP(47  ))            
      CALL JIOXXX(W(1,57  ),W(1,62  ),GZL ,ZMASS   ,ZWIDTH  ,W(1,78  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,78  ),GZL ,AMP(48  ))            
      CALL FVOXXX(W(1,2   ),W(1,29  ),GWF ,ZERO    ,ZERO    ,W(1,79  ))    
      CALL JIOXXX(W(1,3   ),W(1,79  ),GAL ,ZERO    ,AWIDTH  ,W(1,80  ))    
      CALL IOVXXX(W(1,11  ),W(1,6   ),W(1,80  ),GAL ,AMP(49  ))            
      CALL JIOXXX(W(1,3   ),W(1,79  ),GZL ,ZMASS   ,ZWIDTH  ,W(1,81  ))    
      CALL IOVXXX(W(1,11  ),W(1,6   ),W(1,81  ),GZL ,AMP(50  ))            
      CALL FVIXXX(W(1,7   ),W(1,80  ),GAL ,LMASS   ,ZERO    ,W(1,82  ))    
      CALL IOVXXX(W(1,82  ),W(1,6   ),W(1,1   ),GZL ,AMP(51  ))            
      CALL FVIXXX(W(1,7   ),W(1,81  ),GZL ,LMASS   ,ZERO    ,W(1,83  ))    
      CALL IOVXXX(W(1,83  ),W(1,6   ),W(1,1   ),GZL ,AMP(52  ))            
      CALL FVIXXX(W(1,3   ),W(1,1   ),GZL ,ZERO    ,ZERO    ,W(1,84  ))    
      CALL FVIXXX(W(1,84  ),W(1,29  ),GWF ,ZERO    ,ZERO    ,W(1,85  ))    
      CALL JIOXXX(W(1,85  ),W(1,2   ),GZN ,ZMASS   ,ZWIDTH  ,W(1,86  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,86  ),GZL ,AMP(53  ))            
      CALL FVOXXX(W(1,79  ),W(1,1   ),GZL ,ZERO    ,ZERO    ,W(1,87  ))    
      CALL JIOXXX(W(1,3   ),W(1,87  ),GAL ,ZERO    ,AWIDTH  ,W(1,88  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,88  ),GAL ,AMP(54  ))            
      CALL JIOXXX(W(1,3   ),W(1,87  ),GZL ,ZMASS   ,ZWIDTH  ,W(1,89  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,89  ),GZL ,AMP(55  ))            
      CALL JIOXXX(W(1,84  ),W(1,2   ),GWF ,WMASS   ,WWIDTH  ,W(1,90  ))    
      CALL FVIXXX(W(1,5   ),W(1,90  ),GWF ,ZERO    ,ZERO    ,W(1,91  ))    
      CALL JIOXXX(W(1,91  ),W(1,4   ),GAL ,ZERO    ,AWIDTH  ,W(1,92  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,92  ),GAL ,AMP(56  ))            
      CALL JIOXXX(W(1,91  ),W(1,4   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,93  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,93  ),GZL ,AMP(57  ))            
      CALL FVOXXX(W(1,4   ),W(1,90  ),GWF ,ZERO    ,ZERO    ,W(1,94  ))    
      CALL JIOXXX(W(1,5   ),W(1,94  ),GZN ,ZMASS   ,ZWIDTH  ,W(1,95  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,95  ),GZL ,AMP(58  ))            
      CALL JIOXXX(W(1,84  ),W(1,79  ),GAL ,ZERO    ,AWIDTH  ,W(1,96  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,96  ),GAL ,AMP(59  ))            
      CALL JIOXXX(W(1,84  ),W(1,79  ),GZL ,ZMASS   ,ZWIDTH  ,W(1,97  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,97  ),GZL ,AMP(60  ))            
      CALL JVVXXX(W(1,29  ),W(1,90  ),GWWA ,ZERO    ,AWIDTH  ,W(1,         
     &     98  ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,98  ),GAL ,AMP(61  ))            
      CALL JVVXXX(W(1,29  ),W(1,90  ),GWWZ ,ZMASS   ,ZWIDTH  ,W(1,         
     &     99  ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,99  ),GZL ,AMP(62  ))            
      CALL IOVXXX(W(1,32  ),W(1,6   ),W(1,90  ),GWF ,AMP(63  ))            
      CALL FVIXXX(W(1,3   ),W(1,29  ),GWF ,ZERO    ,ZERO    ,W(1,100 ))    
      CALL JIOXXX(W(1,100 ),W(1,2   ),GZN ,ZMASS   ,ZWIDTH  ,W(1,101 ))    
      CALL IOVXXX(W(1,11  ),W(1,6   ),W(1,101 ),GZL ,AMP(64  ))            
      CALL FVIXXX(W(1,7   ),W(1,101 ),GZL ,LMASS   ,ZERO    ,W(1,102 ))    
      CALL IOVXXX(W(1,102 ),W(1,6   ),W(1,1   ),GZL ,AMP(65  ))            
      CALL FVIXXX(W(1,100 ),W(1,1   ),GZN ,ZERO    ,ZERO    ,W(1,103 ))    
      CALL JIOXXX(W(1,103 ),W(1,2   ),GZN ,ZMASS   ,ZWIDTH  ,W(1,104 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,104 ),GZL ,AMP(66  ))            
      CALL FVOXXX(W(1,2   ),W(1,1   ),GZN ,ZERO    ,ZERO    ,W(1,105 ))    
      CALL FVOXXX(W(1,105 ),W(1,29  ),GWF ,ZERO    ,ZERO    ,W(1,106 ))    
      CALL JIOXXX(W(1,3   ),W(1,106 ),GAL ,ZERO    ,AWIDTH  ,W(1,107 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,107 ),GAL ,AMP(67  ))            
      CALL JIOXXX(W(1,3   ),W(1,106 ),GZL ,ZMASS   ,ZWIDTH  ,W(1,108 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,108 ),GZL ,AMP(68  ))            
      CALL JIOXXX(W(1,3   ),W(1,105 ),GWF ,WMASS   ,WWIDTH  ,W(1,109 ))    
      CALL FVIXXX(W(1,5   ),W(1,109 ),GWF ,ZERO    ,ZERO    ,W(1,110 ))    
      CALL JIOXXX(W(1,110 ),W(1,4   ),GAL ,ZERO    ,AWIDTH  ,W(1,111 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,111 ),GAL ,AMP(69  ))            
      CALL JIOXXX(W(1,110 ),W(1,4   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,112 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,112 ),GZL ,AMP(70  ))            
      CALL FVOXXX(W(1,4   ),W(1,109 ),GWF ,ZERO    ,ZERO    ,W(1,113 ))    
      CALL JIOXXX(W(1,5   ),W(1,113 ),GZN ,ZMASS   ,ZWIDTH  ,W(1,114 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,114 ),GZL ,AMP(71  ))            
      CALL JIOXXX(W(1,100 ),W(1,105 ),GZN ,ZMASS   ,ZWIDTH  ,W(1,115 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,115 ),GZL ,AMP(72  ))            
      CALL JVVXXX(W(1,29  ),W(1,109 ),GWWA ,ZERO    ,AWIDTH  ,W(1,         
     &     116 ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,116 ),GAL ,AMP(73  ))            
      CALL JVVXXX(W(1,29  ),W(1,109 ),GWWZ ,ZMASS   ,ZWIDTH  ,W(1,         
     &     117 ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,117 ),GZL ,AMP(74  ))            
      CALL IOVXXX(W(1,32  ),W(1,6   ),W(1,109 ),GWF ,AMP(75  ))            

c KK gauge boson graphs
      do k=1,kkhw
      CALL JVVXXX(W(1,1),W(1,29), gwwz_k(k,0,0), w1mass_k(k), 
     &	w1width_k(k), KK1(1,k)) ! like Graph 28
      CALL VVVXXX(KK1(1,k),W(1,8),w(1,119), gwwz_k(k,0,0), AMPK1(k))

      CALL JVVXXX(W(1,8),W(1,1), gwwz_k(k,0,0), w1mass_k(k),
     &	w1width_k(k), KK2(1,k)) ! like Graph 32
      CALL VVVXXX(W(1,29),KK2(1,k),w(1,119), gwwz_k(k,0,0), AMPK2(k))
	enddo
	

cc higgs graphs
      if(hswitchwwz) then
c higgs SM graph
	CALL HVVXXX(W(1,29), W(1,8), gwwh, hmass, hwidth, h1(1))
	CALL VVSXXX(W(1,1), W(1,119),h1(1), gzzh, AMPH)
c higgs KK graph
      do k=1,kkhh
	CALL HVVXXX(W(1,29), W(1,8), gwwh_k(0,0,k), h1mass_k(k), 
     &	h1width_k(k), kkh1(1,k))
	CALL VVSXXX(W(1,1), W(1,119),kkh1(1,k), gzzh_k(0,0,k), AMPKH(k))
      enddo
      endif

      wwz(mu) = -AMP(   1)-AMP(   2)-AMP(   3)-AMP(   4)-AMP(   5)
     &             -AMP(   6)-AMP(   7)-AMP(   8)-AMP(   9)-AMP(  10)
     &             -AMP(  11)-AMP(  12)-AMP(  13)-AMP(  14)-AMP(  15)
     &             -AMP(  16)-AMP(  17)-AMP(  18)-AMP(  19)-AMP(  20)
     &             -AMP(  21)-AMP(  22)-AMP(  23)-AMP(  24)-AMP(  25) !4 vertices
     &             -AMP(  26)-AMP(  27)-AMP(  28)-AMP(  29)-AMP(  30)
     &             -AMP(  31)-AMP(  32)-AMP(  33)-AMP(  34)-AMP(  35)
     &             -AMP(  36)-AMP(  37)-AMP(  38)-AMP(  39)-AMP(  40)
     &             -AMP(  41)-AMP(  42)-AMP(  43)-AMP(  44)-AMP(  45)
     &             -AMP(  46)-AMP(  47)-AMP(  48)-AMP(  49)-AMP(  50)
     &             -AMP(  51)-AMP(  52)-AMP(  53)-AMP(  54)-AMP(  55)
     &             -AMP(  56)-AMP(  57)-AMP(  58)-AMP(  59)-AMP(  60)
     &             -AMP(  61)-AMP(  62)-AMP(  63)-AMP(  64)-AMP(  65)
     &             -AMP(  66)-AMP(  67)-AMP(  68)-AMP(  69)-AMP(  70)
     &             -AMP(  71)-AMP(  72)-AMP(  73)-AMP(  74)-AMP(  75) 
      do k=1,kkhw
      wwz(mu)=wwz(mu)-AMPK1(k)-AMPK2(k)
      enddo

	if (hswitchwwz) then
	wwz(mu)=wwz(mu)-AMPH
	do k=1,kkhh
	wwz(mu)=wwz(mu)-AMPKH(k)
	enddo
	endif
      enddo !mu

      wwz(4) = dcmplx(q(0),q(3))
      wwz(5) = dcmplx(q(1),q(2))

      END
c-----------------------------------------------------------------

      subroutine ATOWWZ_kk(P,N,h,wwz,NW)

      IMPLICIT NONE

      DOUBLE PRECISION P(0:3,2:7)
      complex*16 wwz(0:5)
      integer lsign(2:7,2),ll,mu,nu,h,N
      integer NW ! = 0: all diagrams, = 1: no non resonant diagrams

      ! possible lepton helicities:
      data (lsign(ll,1),ll=2,7) / -1, -1, -1, -1, -1, -1/  !h=1
      data (lsign(ll,2),ll=2,7) / -1, -1, -1, -1, +1, +1/  !h=2

      call ATOWWZ1_kk(P,N,lsign(2,h),wwz(0),NW)

      ! helicity combi nr.h is selected

      end

c ------------------------------------------------------------

      SUBROUTINE ATOWWZ1_kk(P,N,lsign,wwz,NW)
C
C Generated by MadGraph II Version 3.0. Updated 02/19/04
C RETURNS AMPLITUDE SQUARED SUMMED/AVG OVER COLORS
C FOR THE POINT WITH EXTERNAL LINES W(0:6,NEXTERNAL)
C
C FOR PROCESS : a -> ve e+ mu- vm~ ta- ta+ 
C
      IMPLICIT NONE
C
C CONSTANTS
C
      INTEGER    NGRAPHS
      PARAMETER (NGRAPHS=  54)
      INTEGER    NWAVEFUNCS
      PARAMETER (NWAVEFUNCS=  87)
      DOUBLE PRECISION     ZERO
      PARAMETER (ZERO=0D0)
C
C ARGUMENTS
C
      DOUBLE PRECISION P(0:3,2:7), Q(0:3)
      INTEGER N
      COMPLEX*16 wwz(0:5)
      INTEGER lsign(2:7)
      integer NW ! = 0: all diagrams, = 1: no non resonant diagrams
C
C LOCAL VARIABLES
C
      INTEGER I,J, mu
      COMPLEX*16 AMP(NGRAPHS)
      COMPLEX*16 W(6,NWAVEFUNCS)

c  lepton spinors and W+-, Z/A polarization vectors
	include "tensor.inc"

      logical lswitch
      parameter (lswitch=.true.)

C
C GLOBAL VARIABLES
C 
	include "VBFNLO/utilities/coupl.inc"
	include "VBFNLO/utilities/kkcoupl.inc"
C
C ----------
C BEGIN CODE
C ----------
      if (lswitch) then      ! read in lepton an W states from common block
         do i=1,6
            w(i,2)  = wve(i,N)
            w(i,3)  = wep(i,N)
            w(i,4)  = wmu(i,N)
            w(i,5)  = wvm(i,N)
            w(i,6)  = ztm(i,N)
            w(i,7)  = ztp(i,N)
            w(i,8)  = wp(i,N)
            w(i,13) = wm(i,N)
		w(i,86)   = atau(i,N)
		w(i,87)   = ztau(i,N)
         enddo
      endif

      do mu = 0,3
         q(mu) = p(mu,2)+p(mu,3)+p(mu,4)+p(mu,5)+p(mu,6)+p(mu,7)
      enddo

      do mu = 0,3
      CALL TRIBOSVCARTX(Q(0),ZERO ,ZERO, MU,-1,W(1,1   )) 
      CALL FVOXXX(W(1,4   ),W(1,8   ),GWF ,ZERO    ,ZERO    ,W(1,9   ))    
      CALL JIOXXX(W(1,5   ),W(1,9   ),GZN ,ZMASS   ,ZWIDTH  ,W(1,10  ))    
      CALL FVIXXX(W(1,7   ),W(1,1   ),GAL ,LMASS   ,ZERO    ,W(1,11  ))    
      CALL IOVXXX(W(1,11  ),W(1,6   ),W(1,10  ),GZL ,AMP(1   ))            
      CALL FVIXXX(W(1,7   ),W(1,10  ),GZL ,LMASS   ,ZERO    ,W(1,12  ))    
      CALL IOVXXX(W(1,12  ),W(1,6   ),W(1,1   ),GAL ,AMP(2   ))            
c      CALL JIOXXX(W(1,5   ),W(1,4   ),GWF ,WMASS   ,WWIDTH  ,W(1,13  ))   !wm 
      CALL JVVXXX(W(1,13  ),W(1,8   ),GWWA ,ZERO    ,AWIDTH  ,W(1,         
     &     14  ))                                                          
      CALL IOVXXX(W(1,11  ),W(1,6   ),W(1,14  ),GAL ,AMP(3   ))            
      CALL JVVXXX(W(1,13  ),W(1,8   ),GWWZ ,ZMASS   ,ZWIDTH  ,W(1,         
     &     15  ))                                                          
      CALL IOVXXX(W(1,11  ),W(1,6   ),W(1,15  ),GZL ,AMP(4   ))            
      CALL FVIXXX(W(1,7   ),W(1,13  ),GWF ,ZERO    ,ZERO    ,W(1,16  ))    
      CALL FVIXXX(W(1,16  ),W(1,8   ),GWF ,LMASS   ,ZERO    ,W(1,17  ))    
      CALL IOVXXX(W(1,17  ),W(1,6   ),W(1,1   ),GAL ,AMP(5   ))            
      CALL FVIXXX(W(1,7   ),W(1,14  ),GAL ,LMASS   ,ZERO    ,W(1,18  ))    
      CALL IOVXXX(W(1,18  ),W(1,6   ),W(1,1   ),GAL ,AMP(6   ))            
      CALL FVIXXX(W(1,7   ),W(1,15  ),GZL ,LMASS   ,ZERO    ,W(1,19  ))    
      CALL IOVXXX(W(1,19  ),W(1,6   ),W(1,1   ),GAL ,AMP(7   ))            
      CALL JVVXXX(W(1,1   ),W(1,13  ),GWWA ,WMASS   ,WWIDTH  ,W(1,         
     &     20  ))                                                          
      CALL FVIXXX(W(1,3   ),W(1,20  ),GWF ,ZERO    ,ZERO    ,W(1,21  ))    
      CALL JIOXXX(W(1,21  ),W(1,2   ),GZN ,ZMASS   ,ZWIDTH  ,W(1,22  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,22  ),GZL ,AMP(8   ))            
      CALL FVOXXX(W(1,2   ),W(1,20  ),GWF ,ZERO    ,ZERO    ,W(1,23  ))    
      CALL JIOXXX(W(1,3   ),W(1,23  ),GAL ,ZERO    ,AWIDTH  ,W(1,24  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,24  ),GAL ,AMP(9   ))            
      CALL JIOXXX(W(1,3   ),W(1,23  ),GZL ,ZMASS   ,ZWIDTH  ,W(1,25  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,25  ),GZL ,AMP(10  ))            
      CALL JVVXXX(W(1,8   ),W(1,1   ),GWWA ,WMASS   ,WWIDTH  ,W(1,         
     &     26  ))                                                          
      CALL FVIXXX(W(1,5   ),W(1,26  ),GWF ,ZERO    ,ZERO    ,W(1,27  ))    
      CALL JIOXXX(W(1,27  ),W(1,4   ),GAL ,ZERO    ,AWIDTH  ,W(1,28  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,28  ),GAL ,AMP(11  ))            
      CALL JIOXXX(W(1,27  ),W(1,4   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,29  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,29  ),GZL ,AMP(12  ))            
      CALL FVOXXX(W(1,4   ),W(1,26  ),GWF ,ZERO    ,ZERO    ,W(1,30  ))    
      CALL JIOXXX(W(1,5   ),W(1,30  ),GZN ,ZMASS   ,ZWIDTH  ,W(1,31  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,31  ),GZL ,AMP(13  ))            
          
      CALL W3W3XX(W(1,13  ),W(1,1   ),W(1,8   ),w(1,86  ),1.d0,		!
     & GWWAA_k(0,0,0,0) ,AMP(14))							!redone 4 vertices
      CALL W3W3XX(W(1,13  ),w(1,87  ),W(1,8   ),W(1,1   ),1.d0,		!
     & GWWAZ_k(0,0,0,0) ,AMP(15))							!

      CALL FVIXXX(W(1,11  ),W(1,13  ),GWF ,ZERO    ,ZERO    ,W(1,34  ))    
      CALL IOVXXX(W(1,34  ),W(1,6   ),W(1,8   ),GWF ,AMP(16  ))            
      CALL JVVXXX(W(1,20  ),W(1,8   ),GWWA ,ZERO    ,AWIDTH  ,W(1,         
     &     35  ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,35  ),GAL ,AMP(17  ))            
      CALL JVVXXX(W(1,20  ),W(1,8   ),GWWZ ,ZMASS   ,ZWIDTH  ,W(1,         
     &     36  ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,36  ),GZL ,AMP(18  ))            
      CALL FVIXXX(W(1,7   ),W(1,20  ),GWF ,ZERO    ,ZERO    ,W(1,37  ))    
      CALL IOVXXX(W(1,37  ),W(1,6   ),W(1,8   ),GWF ,AMP(19  ))            
      CALL JVVXXX(W(1,13  ),W(1,26  ),GWWA ,ZERO    ,AWIDTH  ,W(1,         
     &     38  ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,38  ),GAL ,AMP(20  ))            
      CALL JVVXXX(W(1,13  ),W(1,26  ),GWWZ ,ZMASS   ,ZWIDTH  ,W(1,         
     &     39  ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,39  ),GZL ,AMP(21  ))            
      CALL IOVXXX(W(1,16  ),W(1,6   ),W(1,26  ),GWF ,AMP(22  ))            
      CALL FVIXXX(W(1,5   ),W(1,8   ),GWF ,ZERO    ,ZERO    ,W(1,40  ))    
      CALL JIOXXX(W(1,40  ),W(1,4   ),GAL ,ZERO    ,AWIDTH  ,W(1,41  ))    
      CALL IOVXXX(W(1,11  ),W(1,6   ),W(1,41  ),GAL ,AMP(23  ))            
      CALL JIOXXX(W(1,40  ),W(1,4   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,42  ))    
      CALL IOVXXX(W(1,11  ),W(1,6   ),W(1,42  ),GZL ,AMP(24  ))            
      CALL FVIXXX(W(1,7   ),W(1,41  ),GAL ,LMASS   ,ZERO    ,W(1,43  ))    
      CALL IOVXXX(W(1,43  ),W(1,6   ),W(1,1   ),GAL ,AMP(25  ))            
      CALL FVIXXX(W(1,7   ),W(1,42  ),GZL ,LMASS   ,ZERO    ,W(1,44  ))    
      CALL IOVXXX(W(1,44  ),W(1,6   ),W(1,1   ),GAL ,AMP(26  ))            
      CALL FVOXXX(W(1,4   ),W(1,1   ),GAL ,ZERO    ,ZERO    ,W(1,45  ))    
      CALL JIOXXX(W(1,5   ),W(1,45  ),GWF ,WMASS   ,WWIDTH  ,W(1,46  ))    
      CALL FVIXXX(W(1,3   ),W(1,46  ),GWF ,ZERO    ,ZERO    ,W(1,47  ))    
      CALL JIOXXX(W(1,47  ),W(1,2   ),GZN ,ZMASS   ,ZWIDTH  ,W(1,48  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,48  ),GZL ,AMP(27  ))            
      CALL FVOXXX(W(1,2   ),W(1,46  ),GWF ,ZERO    ,ZERO    ,W(1,49  ))    
      CALL JIOXXX(W(1,3   ),W(1,49  ),GAL ,ZERO    ,AWIDTH  ,W(1,50  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,50  ),GAL ,AMP(28  ))            
      CALL JIOXXX(W(1,3   ),W(1,49  ),GZL ,ZMASS   ,ZWIDTH  ,W(1,51  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,51  ),GZL ,AMP(29  ))            
      CALL FVIXXX(W(1,40  ),W(1,1   ),GAL ,ZERO    ,ZERO    ,W(1,52  ))    
      CALL JIOXXX(W(1,52  ),W(1,4   ),GAL ,ZERO    ,AWIDTH  ,W(1,53  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,53  ),GAL ,AMP(30  ))            
      CALL JIOXXX(W(1,52  ),W(1,4   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,54  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,54  ),GZL ,AMP(31  ))            
      CALL FVOXXX(W(1,45  ),W(1,8   ),GWF ,ZERO    ,ZERO    ,W(1,55  ))    
      CALL JIOXXX(W(1,5   ),W(1,55  ),GZN ,ZMASS   ,ZWIDTH  ,W(1,56  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,56  ),GZL ,AMP(32  ))            
      CALL JVVXXX(W(1,46  ),W(1,8   ),GWWA ,ZERO    ,AWIDTH  ,W(1,         
     &     57  ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,57  ),GAL ,AMP(33  ))            
      CALL JVVXXX(W(1,46  ),W(1,8   ),GWWZ ,ZMASS   ,ZWIDTH  ,W(1,         
     &     58  ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,58  ),GZL ,AMP(34  ))            
      CALL FVIXXX(W(1,7   ),W(1,46  ),GWF ,ZERO    ,ZERO    ,W(1,59  ))    
      CALL IOVXXX(W(1,59  ),W(1,6   ),W(1,8   ),GWF ,AMP(35  ))            
      CALL JIOXXX(W(1,40  ),W(1,45  ),GAL ,ZERO    ,AWIDTH  ,W(1,60  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,60  ),GAL ,AMP(36  ))            
      CALL JIOXXX(W(1,40  ),W(1,45  ),GZL ,ZMASS   ,ZWIDTH  ,W(1,61  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,61  ),GZL ,AMP(37  ))            
      CALL FVOXXX(W(1,2   ),W(1,13  ),GWF ,ZERO    ,ZERO    ,W(1,62  ))    
      CALL JIOXXX(W(1,3   ),W(1,62  ),GAL ,ZERO    ,AWIDTH  ,W(1,63  ))    
      CALL IOVXXX(W(1,11  ),W(1,6   ),W(1,63  ),GAL ,AMP(38  ))            
      CALL JIOXXX(W(1,3   ),W(1,62  ),GZL ,ZMASS   ,ZWIDTH  ,W(1,64  ))    
      CALL IOVXXX(W(1,11  ),W(1,6   ),W(1,64  ),GZL ,AMP(39  ))            
      CALL FVIXXX(W(1,7   ),W(1,63  ),GAL ,LMASS   ,ZERO    ,W(1,65  ))    
      CALL IOVXXX(W(1,65  ),W(1,6   ),W(1,1   ),GAL ,AMP(40  ))            
      CALL FVIXXX(W(1,7   ),W(1,64  ),GZL ,LMASS   ,ZERO    ,W(1,66  ))    
      CALL IOVXXX(W(1,66  ),W(1,6   ),W(1,1   ),GAL ,AMP(41  ))            
      CALL FVIXXX(W(1,3   ),W(1,1   ),GAL ,ZERO    ,ZERO    ,W(1,67  ))    
      CALL FVIXXX(W(1,67  ),W(1,13  ),GWF ,ZERO    ,ZERO    ,W(1,68  ))    
      CALL JIOXXX(W(1,68  ),W(1,2   ),GZN ,ZMASS   ,ZWIDTH  ,W(1,69  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,69  ),GZL ,AMP(42  ))            
      CALL FVOXXX(W(1,62  ),W(1,1   ),GAL ,ZERO    ,ZERO    ,W(1,70  ))    
      CALL JIOXXX(W(1,3   ),W(1,70  ),GAL ,ZERO    ,AWIDTH  ,W(1,71  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,71  ),GAL ,AMP(43  ))            
      CALL JIOXXX(W(1,3   ),W(1,70  ),GZL ,ZMASS   ,ZWIDTH  ,W(1,72  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,72  ),GZL ,AMP(44  ))            
      CALL JIOXXX(W(1,67  ),W(1,2   ),GWF ,WMASS   ,WWIDTH  ,W(1,73  ))    
      CALL FVIXXX(W(1,5   ),W(1,73  ),GWF ,ZERO    ,ZERO    ,W(1,74  ))    
      CALL JIOXXX(W(1,74  ),W(1,4   ),GAL ,ZERO    ,AWIDTH  ,W(1,75  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,75  ),GAL ,AMP(45  ))            
      CALL JIOXXX(W(1,74  ),W(1,4   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,76  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,76  ),GZL ,AMP(46  ))            
      CALL FVOXXX(W(1,4   ),W(1,73  ),GWF ,ZERO    ,ZERO    ,W(1,77  ))    
      CALL JIOXXX(W(1,5   ),W(1,77  ),GZN ,ZMASS   ,ZWIDTH  ,W(1,78  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,78  ),GZL ,AMP(47  ))            
      CALL JIOXXX(W(1,67  ),W(1,62  ),GAL ,ZERO    ,AWIDTH  ,W(1,79  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,79  ),GAL ,AMP(48  ))            
      CALL JIOXXX(W(1,67  ),W(1,62  ),GZL ,ZMASS   ,ZWIDTH  ,W(1,80  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,80  ),GZL ,AMP(49  ))            
      CALL JVVXXX(W(1,13  ),W(1,73  ),GWWA ,ZERO    ,AWIDTH  ,W(1,         
     &     81  ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,81  ),GAL ,AMP(50  ))            
      CALL JVVXXX(W(1,13  ),W(1,73  ),GWWZ ,ZMASS   ,ZWIDTH  ,W(1,         
     &     82  ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,82  ),GZL ,AMP(51  ))            
      CALL IOVXXX(W(1,16  ),W(1,6   ),W(1,73  ),GWF ,AMP(52  ))            
      CALL FVIXXX(W(1,3   ),W(1,13  ),GWF ,ZERO    ,ZERO    ,W(1,83  ))    
      CALL JIOXXX(W(1,83  ),W(1,2   ),GZN ,ZMASS   ,ZWIDTH  ,W(1,84  ))    
      CALL IOVXXX(W(1,11  ),W(1,6   ),W(1,84  ),GZL ,AMP(53  ))            
      CALL FVIXXX(W(1,7   ),W(1,84  ),GZL ,LMASS   ,ZERO    ,W(1,85  ))    
      CALL IOVXXX(W(1,85  ),W(1,6   ),W(1,1   ),GAL ,AMP(54  ))            
      wwz(   mu) = -AMP(   1)-AMP(   2)-AMP(   3)-AMP(   4)-AMP(   5)
     &             -AMP(   6)-AMP(   7)-AMP(   8)-AMP(   9)-AMP(  10)
     &             -AMP(  11)-AMP(  12)-AMP(  13)-AMP(  14)-AMP(  15) !4 vertices
     &             -AMP(  16)-AMP(  17)-AMP(  18)-AMP(  19)-AMP(  20)
     &             -AMP(  21)-AMP(  22)-AMP(  23)-AMP(  24)-AMP(  25)
     &             -AMP(  26)-AMP(  27)-AMP(  28)-AMP(  29)-AMP(  30)
     &             -AMP(  31)-AMP(  32)-AMP(  33)-AMP(  34)-AMP(  35)
     &             -AMP(  36)-AMP(  37)-AMP(  38)-AMP(  39)-AMP(  40)
     &             -AMP(  41)-AMP(  42)-AMP(  43)-AMP(  44)-AMP(  45)
     &             -AMP(  46)-AMP(  47)-AMP(  48)-AMP(  49)-AMP(  50)
     &             -AMP(  51)-AMP(  52)-AMP(  53)-AMP(  54)

      enddo !mu
      wwz(4) = dcmplx(q(0),q(3))
      wwz(5) = dcmplx(q(1),q(2))

      END
