c ------------------------------------------------------------

      subroutine WPTOWZA_anomal(P,N,h,wza,NW)

      IMPLICIT NONE

      DOUBLE PRECISION P(0:3,2:6)
      complex*16 wza(0:5)
      integer lsign(2:6,4),ll,mu,nu,h,N
      integer NW ! = 0: all diagrams, = 1: no non resonant diagrams

      ! possible lepton helicities:
      data (lsign(ll,1),ll=2,6) / -1, -1, -1, -1, +1/  !h=1
      data (lsign(ll,2),ll=2,6) / -1, -1, +1, +1, +1/  !h=2
      data (lsign(ll,3),ll=2,6) / -1, -1, -1, -1, -1/  !h=3
      data (lsign(ll,4),ll=2,6) / -1, -1, +1, +1, -1/  !h=4

      call WPTOWZA1_anomal(P,N,lsign(2,h),wza(0),NW)

      ! helicity combi nr.h is selected

      end

c ------------------------------------------------------------

      SUBROUTINE WPTOWZA1_anomal(P,N,lsign,wza,NW)
C  
C Generated by MadGraph II                                              
C MadGraph StandAlone Version
C RETURNS AMPLITUDE SQUARED SUMMED/AVG OVER COLORS
C AND HELICITIES
C FOR THE POINT IN PHASE SPACE P(0:3,NEXTERNAL)
C  
C FOR PROCESS : w+ -> ve e+ mu- mu+ a  
C  
C Crossing   1 is w+ ve~ -> e+ mu- mu+ a  
      IMPLICIT NONE
C  
C CONSTANTS
C  
      INTEGER    NGRAPHS
      PARAMETER (NGRAPHS=  33) 
      INTEGER    NWAVEFUNCS 
      PARAMETER (NWAVEFUNCS=  49) 
      DOUBLE PRECISION     ZERO
      PARAMETER (ZERO=0D0)
C  
C ARGUMENTS 
C  
      DOUBLE PRECISION P(0:3,2:6), Q(0:3)
      INTEGER N
      COMPLEX*16 wza(0:5)
      INTEGER lsign(2:6)
      integer NW ! = 0: all diagrams, = 1: no non resonant diagrams
C
C LOCAL VARIABLES
C
      INTEGER I,J, mu
      COMPLEX*16 AMP(NGRAPHS)
      COMPLEX*16 W(6,NWAVEFUNCS)
c  lepton spinors and W+-, Z/A polarization vectors
#include "tensor.inc"

      logical lswitch
      parameter (lswitch=.true.)

C
C GLOBAL VARIABLES
C
#include "VBFNLO/utilities/coupl.inc"
C
C ----------
C BEGIN CODE
C ----------
      if (lswitch) then      ! read in lepton an W states from common block
         do i=1,6
            w(i,2)  = wve(i,N)
            w(i,3)  = wep(i,N)
            w(i,4)  = wmu(i,N)
            w(i,5)  = wmp(i,N)
            w(i,6)  = wa(i,N)
            w(i,7)  = wp(i,N)
            w(i,17) = ztau(i,N)
            w(i,15) = atau(i,N)
         enddo
      endif

      do mu = 0,3
         q(mu) = p(mu,2)+p(mu,3)+p(mu,4)+p(mu,5)+p(mu,6)
      enddo
c
      if (.not.lswitch) then
         CALL OXXXXX(P(0,2   ),ZERO , lsign(2),+1,W(1,2   )) !ve
         CALL IXXXXX(P(0,3   ),ZERO ,-lsign(3),-1,W(1,3   )) !e+
         CALL OXXXXX(P(0,4   ),ZERO , lsign(4),+1,W(1,4   )) !mu-
         CALL IXXXXX(P(0,5   ),ZERO ,-lsign(5),-1,W(1,5   )) !mu+
         CALL VXXXXX(P(0,6   ),ZERO , +1  ,+1,W(1,6   )) !A
         CALL JIOXXX(W(1,3   ),W(1,2   ),GWF ,WMASS   ,WWIDTH  ,W(1,7   ))
         CALL JIOXXX(W(1,5   ),W(1,4   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,17  ))
         CALL JIOXXX(W(1,5   ),W(1,4   ),GAL ,ZERO    ,ZERO    ,W(1,15  ))
         print*," ve ",(wve(i,N)/w(i,2),i=1,6)
         print*," ep ",(wep(i,N)/w(i,3),i=1,6)
         print*," mu ",(wmu(i,N)/w(i,4),i=1,6)
         print*," mp ",(wmp(i,N)/w(i,5),i=1,6)
         print*," A  ",( wa(i,N)/w(i,6),i=1,6)
      endif
      do mu = 0,3
      CALL TRIBOSVCARTX(Q(0),WMASS ,WWIDTH, MU,-1,W(1,1   ))
      CALL FVOXXX(W(1,4   ),W(1,7   ),GWF ,ZERO    ,ZERO    ,W(1,8   ))    
      CALL JIOXXX(W(1,5   ),W(1,8   ),GWF ,WMASS   ,WWIDTH  ,W(1,9   )) 
   
c      CALL VVVXXX(W(1,1   ),W(1,9   ),W(1,6   ),GWWA ,AMP(1   ))  
      CALL wwa_anomal3(W(1,1   ),W(1,9   ),W(1,6   ),AMP(1   ))  
         
      CALL FVIXXX(W(1,5   ),W(1,1   ),GWF ,ZERO    ,ZERO    ,W(1,10  ))    
      CALL JIOXXX(W(1,10  ),W(1,4   ),GWF ,WMASS   ,WWIDTH  ,W(1,11  ))    
      CALL FVOXXX(W(1,2   ),W(1,11  ),GWF ,ZERO    ,ZERO    ,W(1,12  ))    
      CALL IOVXXX(W(1,3   ),W(1,12  ),W(1,6   ),GAL ,AMP(2   ))            
      CALL FVIXXX(W(1,10  ),W(1,7   ),GWF ,ZERO    ,ZERO    ,W(1,13  ))    
      CALL IOVXXX(W(1,13  ),W(1,4   ),W(1,6   ),GAL ,AMP(3   ))            
      CALL FVOXXX(W(1,8   ),W(1,1   ),GWF ,ZERO    ,ZERO    ,W(1,14  ))    
      CALL IOVXXX(W(1,5   ),W(1,14  ),W(1,6   ),GAL ,AMP(4   ))  
          
c      CALL VVVXXX(W(1,11  ),W(1,7   ),W(1,6   ),GWWA ,AMP(5   ))  
      CALL wwa_anomal3(W(1,11  ),W(1,7   ),W(1,6   ),AMP(5   ))  
         
c      CALL JVVXXX(W(1,7   ),W(1,15  ),GWWA ,WMASS   ,WWIDTH  ,W(1,         
c     &     16  ))    
      CALL jwmwpa_anomal3(W(1,7   ),W(1,15  ),W(1,16  )) 
                                                      
c      CALL VVVXXX(W(1,1   ),W(1,16  ),W(1,6   ),GWWA ,AMP(6   ))  
      CALL wwa_anomal3(W(1,1   ),W(1,16  ),W(1,6   ),AMP(6   ))  
         
c      CALL JVVXXX(W(1,7   ),W(1,17  ),GWWZ ,WMASS   ,WWIDTH  ,W(1,         
c     &     18  )) 
      CALL jwmwpz_anomal3(W(1,7   ),W(1,17  ),W(1,18  )) 
                                                         
c      CALL VVVXXX(W(1,1   ),W(1,18  ),W(1,6   ),GWWA ,AMP(7   )) 
      CALL wwa_anomal3(W(1,1   ),W(1,18  ),W(1,6   ),AMP(7   )) 
          
c      CALL JVVXXX(W(1,15  ),W(1,1   ),GWWA ,WMASS   ,WWIDTH  ,W(1,         
c     &     19  )) 
      CALL jwpawm_anomal3(W(1,15  ),W(1,1   ),W(1,19  )) 
                                                         
      CALL FVOXXX(W(1,2   ),W(1,19  ),GWF ,ZERO    ,ZERO    ,W(1,20  ))    
      CALL IOVXXX(W(1,3   ),W(1,20  ),W(1,6   ),GAL ,AMP(8   ))  
          
c      CALL JVVXXX(W(1,17  ),W(1,1   ),GWWZ ,WMASS   ,WWIDTH  ,W(1,         
c     &     21  ))    
      CALL jwpzwm_anomal3(W(1,17  ),W(1,1   ),W(1,21  ))    
                                                      
      CALL FVOXXX(W(1,2   ),W(1,21  ),GWF ,ZERO    ,ZERO    ,W(1,22  ))    
      CALL IOVXXX(W(1,3   ),W(1,22  ),W(1,6   ),GAL ,AMP(9   ))  
          
c      CALL JVVXXX(W(1,1   ),W(1,7   ),GWWA ,ZERO    ,AWIDTH  ,W(1,         
c     &     23  )) 
      CALL jaww_anomal3(W(1,1   ),W(1,7   ),W(1,23  )) 
                                                         
      CALL FVIXXX(W(1,5   ),W(1,23  ),GAL ,ZERO    ,ZERO    ,W(1,24  ))    
      CALL IOVXXX(W(1,24  ),W(1,4   ),W(1,6   ),GAL ,AMP(10  ))  
          
c      CALL JVVXXX(W(1,1   ),W(1,7   ),GWWZ ,ZMASS   ,ZWIDTH  ,W(1,         
c     &     25  ))  
      CALL jzww_anomal3(W(1,1   ),W(1,7   ),W(1,25  ))  
                                                        
      CALL FVIXXX(W(1,5   ),W(1,25  ),GZL ,ZERO    ,ZERO    ,W(1,26  ))    
      CALL IOVXXX(W(1,26  ),W(1,4   ),W(1,6   ),GAL ,AMP(11  ))            
      CALL FVOXXX(W(1,4   ),W(1,23  ),GAL ,ZERO    ,ZERO    ,W(1,27  ))    
      CALL IOVXXX(W(1,5   ),W(1,27  ),W(1,6   ),GAL ,AMP(12  ))            
      CALL FVOXXX(W(1,4   ),W(1,25  ),GZL ,ZERO    ,ZERO    ,W(1,28  ))    
      CALL IOVXXX(W(1,5   ),W(1,28  ),W(1,6   ),GAL ,AMP(13  ))  
          
c      CALL W3W3XX(W(1,1   ),W(1,15  ),W(1,7   ),W(1,6   ),GWWA ,GWWA ,     
c     &     AMP(14  ))   
      CALL wwaa_anomal4(W(1,1   ),W(1,15  ),W(1,7   ),W(1,6   ),AMP(14  )) 
                                                   
c      CALL W3W3XX(W(1,1   ),W(1,17  ),W(1,7   ),W(1,6   ),GWWZ ,GWWA ,     
c     &     AMP(15  ))  
      CALL wwza_anomal4(W(1,1   ),W(1,17  ),W(1,7   ),W(1,6   ),AMP(15  ))  
                                                    
c      CALL VVVXXX(W(1,19  ),W(1,7   ),W(1,6   ),GWWA ,AMP(16  ))
      CALL wwa_anomal3(W(1,19  ),W(1,7   ),W(1,6   ),AMP(16  ))
           
c      CALL VVVXXX(W(1,21  ),W(1,7   ),W(1,6   ),GWWA ,AMP(17  )) 
      CALL wwa_anomal3(W(1,21  ),W(1,7   ),W(1,6   ),AMP(17  )) 
          
      CALL FVOXXX(W(1,2   ),W(1,17  ),GZN ,ZERO    ,ZERO    ,W(1,29  ))    
      CALL JIOXXX(W(1,3   ),W(1,29  ),GWF ,WMASS   ,WWIDTH  ,W(1,30  ))  
  
c      CALL VVVXXX(W(1,1   ),W(1,30  ),W(1,6   ),GWWA ,AMP(18  ))   
      CALL wwa_anomal3(W(1,1   ),W(1,30  ),W(1,6   ),AMP(18  )) 
        
      CALL FVOXXX(W(1,29  ),W(1,1   ),GWF ,ZERO    ,ZERO    ,W(1,31  ))    
      CALL IOVXXX(W(1,3   ),W(1,31  ),W(1,6   ),GAL ,AMP(19  ))            
      CALL FVIXXX(W(1,3   ),W(1,1   ),GWF ,ZERO    ,ZERO    ,W(1,32  ))    
      CALL JIOXXX(W(1,32  ),W(1,2   ),GZN ,ZMASS   ,ZWIDTH  ,W(1,33  ))    
      CALL FVIXXX(W(1,5   ),W(1,33  ),GZL ,ZERO    ,ZERO    ,W(1,34  ))    
      CALL IOVXXX(W(1,34  ),W(1,4   ),W(1,6   ),GAL ,AMP(20  ))            
      CALL FVOXXX(W(1,4   ),W(1,33  ),GZL ,ZERO    ,ZERO    ,W(1,35  ))    
      CALL IOVXXX(W(1,5   ),W(1,35  ),W(1,6   ),GAL ,AMP(21  ))            
      CALL FVIXXX(W(1,3   ),W(1,15  ),GAL ,ZERO    ,ZERO    ,W(1,36  ))    
      CALL JIOXXX(W(1,36  ),W(1,2   ),GWF ,WMASS   ,WWIDTH  ,W(1,37  )) 
   
c      CALL VVVXXX(W(1,1   ),W(1,37  ),W(1,6   ),GWWA ,AMP(22  ))  
      CALL wwa_anomal3(W(1,1   ),W(1,37  ),W(1,6   ),AMP(22  ))  
         
      CALL FVIXXX(W(1,3   ),W(1,17  ),GZL ,ZERO    ,ZERO    ,W(1,38  ))    
      CALL JIOXXX(W(1,38  ),W(1,2   ),GWF ,WMASS   ,WWIDTH  ,W(1,39  ))  
  
c      CALL VVVXXX(W(1,1   ),W(1,39  ),W(1,6   ),GWWA ,AMP(23  ))   
      CALL wwa_anomal3(W(1,1   ),W(1,39  ),W(1,6   ),AMP(23  )) 
        
      CALL FVOXXX(W(1,2   ),W(1,1   ),GWF ,ZERO    ,ZERO    ,W(1,40  ))    
      CALL FVOXXX(W(1,40  ),W(1,15  ),GAL ,ZERO    ,ZERO    ,W(1,41  ))    
      CALL IOVXXX(W(1,3   ),W(1,41  ),W(1,6   ),GAL ,AMP(24  ))            
      CALL FVOXXX(W(1,40  ),W(1,17  ),GZL ,ZERO    ,ZERO    ,W(1,42  ))    
      CALL IOVXXX(W(1,3   ),W(1,42  ),W(1,6   ),GAL ,AMP(25  ))            
      CALL JIOXXX(W(1,3   ),W(1,40  ),GAL ,ZERO    ,AWIDTH  ,W(1,43  ))    
      CALL FVIXXX(W(1,5   ),W(1,43  ),GAL ,ZERO    ,ZERO    ,W(1,44  ))    
      CALL IOVXXX(W(1,44  ),W(1,4   ),W(1,6   ),GAL ,AMP(26  ))            
      CALL JIOXXX(W(1,3   ),W(1,40  ),GZL ,ZMASS   ,ZWIDTH  ,W(1,45  ))    
      CALL FVIXXX(W(1,5   ),W(1,45  ),GZL ,ZERO    ,ZERO    ,W(1,46  ))    
      CALL IOVXXX(W(1,46  ),W(1,4   ),W(1,6   ),GAL ,AMP(27  ))            
      CALL FVOXXX(W(1,4   ),W(1,43  ),GAL ,ZERO    ,ZERO    ,W(1,47  ))    
      CALL IOVXXX(W(1,5   ),W(1,47  ),W(1,6   ),GAL ,AMP(28  ))            
      CALL FVOXXX(W(1,4   ),W(1,45  ),GZL ,ZERO    ,ZERO    ,W(1,48  ))    
      CALL IOVXXX(W(1,5   ),W(1,48  ),W(1,6   ),GAL ,AMP(29  ))            
      CALL IOVXXX(W(1,36  ),W(1,40  ),W(1,6   ),GAL ,AMP(30  ))            
      CALL IOVXXX(W(1,38  ),W(1,40  ),W(1,6   ),GAL ,AMP(31  ))  

c due to anomalous couplings there are 2 extra graphs with a Higgs (WWH-, AAH-, AZH-coupling)
      CALL jhww_anomal3(W(1,1   ),W(1,7   ),W(1,49  ))
      CALL azh_anomal3(W(1,6   ),W(1,17  ),W(1,49  ),AMP(32  ))
      CALL aah_anomal3(W(1,6   ),W(1,15  ),W(1,49  ),AMP(33  ))

          
      wza(  mu) = +AMP(   1)+AMP(   2)+AMP(   3)+AMP(   4)+AMP(   5)
     &             +AMP(   6)+AMP(   7)+AMP(   8)+AMP(   9)+AMP(  10)
     &             +AMP(  11)+AMP(  12)+AMP(  13)+AMP(  14)+AMP(  15)
     &             +AMP(  16)+AMP(  17)+AMP(  18)+AMP(  19)+AMP(  20)
     &             +AMP(  21)+AMP(  22)+AMP(  23)+AMP(  24)+AMP(  25)
     &             +AMP(  26)+AMP(  27)+AMP(  28)+AMP(  29)+AMP(  30)
     &             +AMP(  31)
     &             +AMP(  32)+AMP(  33) !new Higgs graphs

      enddo
      wza(4) = dcmplx(q(0),q(3))
      wza(5) = dcmplx(q(1),q(2))
c
      END

c ------------------------------------------------------------

      subroutine WMTOWZA_anomal(P,N,h,wza,NW)

      IMPLICIT NONE

      DOUBLE PRECISION P(0:3,2:6)
      complex*16 wza(0:5)
      integer lsign(2:6,4),ll,mu,nu,h,N
      integer NW ! = 0: all diagrams, = 1: no non resonant diagrams

      ! possible lepton helicities:
      data (lsign(ll,1),ll=2,6) / -1, -1, -1, -1, +1/  !h=1
      data (lsign(ll,2),ll=2,6) / -1, -1, +1, +1, +1/  !h=2
      data (lsign(ll,3),ll=2,6) / -1, -1, -1, -1, -1/  !h=3
      data (lsign(ll,4),ll=2,6) / -1, -1, +1, +1, -1/  !h=4

      call WMTOWZA1_anomal(P,N,lsign(2,h),wza(0),NW)

      ! helicity combi nr.h is selected

      end

c ------------------------------------------------------------

      SUBROUTINE WMTOWZA1_anomal(P,N,lsign,wza,NW)
C  
C Generated by MadGraph II                                              
C MadGraph StandAlone Version
C RETURNS AMPLITUDE SQUARED SUMMED/AVG OVER COLORS
C AND HELICITIES
C FOR THE POINT IN PHASE SPACE P(0:3,NEXTERNAL)
C  
C FOR PROCESS : w- -> e- ve~ mu- mu+ a  
C  
C Crossing   1 is w- e+ -> ve~ mu- mu+ a  
      IMPLICIT NONE
C  
C CONSTANTS
C  
      INTEGER    NGRAPHS
      PARAMETER (NGRAPHS=  33) 
      INTEGER    NWAVEFUNCS 
      PARAMETER (NWAVEFUNCS=  49) 
      DOUBLE PRECISION     ZERO
      PARAMETER (ZERO=0D0)
C  
C ARGUMENTS 
C  
      DOUBLE PRECISION P(0:3,2:6), Q(0:3)
      INTEGER N
      COMPLEX*16 wza(0:5)
      INTEGER lsign(2:6)
      integer NW ! = 0: all diagrams, = 1: no non resonant diagrams
C
C LOCAL VARIABLES
C
      INTEGER I,J, mu
      COMPLEX*16 AMP(NGRAPHS)
      COMPLEX*16 W(6,NWAVEFUNCS)
c  lepton spinors and W+-, Z/A polarization vectors
#include "tensor.inc"

      logical lswitch
      parameter (lswitch=.true.)

C
C GLOBAL VARIABLES
C
#include "VBFNLO/utilities/coupl.inc"
C
C ----------
C BEGIN CODE
C ----------
      if (lswitch) then      ! read in lepton an W states from common block
         do i=1,6
            w(i,2)  = wve(i,N)
            w(i,3)  = wep(i,N)
            w(i,4)  = wmu(i,N)
            w(i,5)  = wmp(i,N)
            w(i,6)  = wa(i,N)
            w(i,7)  = wp(i,N)
            w(i,10) = ztau(i,N)
            w(i,8)  = atau(i,N)
         enddo
      endif

      do mu = 0,3
         q(mu) = p(mu,2)+p(mu,3)+p(mu,4)+p(mu,5)+p(mu,6)
      enddo
c
      if (.not.lswitch) then
         CALL OXXXXX(P(0,2   ),ZERO , lsign(2),+1,W(1,2   )) !e-
         CALL IXXXXX(P(0,3   ),ZERO ,-lsign(3),-1,W(1,3   )) !ve~
         CALL OXXXXX(P(0,4   ),ZERO , lsign(4),+1,W(1,4   )) !mu-
         CALL IXXXXX(P(0,5   ),ZERO ,-lsign(5),-1,W(1,5   )) !mu+
         CALL VXXXXX(P(0,6   ),ZERO , +1  ,+1,W(1,6   )) !A
         CALL JIOXXX(W(1,3   ),W(1,2   ),GWF ,WMASS   ,WWIDTH  ,W(1,7   ))
         CALL JIOXXX(W(1,5   ),W(1,4   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,10  ))
         CALL JIOXXX(W(1,5   ),W(1,4   ),GAL ,ZERO    ,ZERO    ,W(1,8   ))
         print*," ve ",(wve(i,N)/w(i,2),i=1,6)
         print*," ep ",(wep(i,N)/w(i,3),i=1,6)
         print*," mu ",(wmu(i,N)/w(i,4),i=1,6)
         print*," mp ",(wmp(i,N)/w(i,5),i=1,6)
         print*," A  ",( wa(i,N)/w(i,6),i=1,6)
      endif
      do mu = 0,3
      CALL TRIBOSVCARTX(Q(0),WMASS ,WWIDTH, MU,-1,W(1,1   ))

c      CALL JVVXXX(W(1,8   ),W(1,7   ),GWWA ,WMASS   ,WWIDTH  ,W(1,9   ))
      CALL jwpawm_anomal3(W(1,8   ),W(1,7   ),W(1,9   ))

c      CALL VVVXXX(W(1,9   ),W(1,1   ),W(1,6   ),GWWA ,AMP(1   ))   
      CALL wwa_anomal3(W(1,9   ),W(1,1   ),W(1,6   ),AMP(1   ))  
        
c      CALL JVVXXX(W(1,10  ),W(1,7   ),GWWZ ,WMASS   ,WWIDTH  ,W(1,11  ))
      CALL jwpzwm_anomal3(W(1,10  ),W(1,7   ),W(1,11  ))

c      CALL VVVXXX(W(1,11  ),W(1,1   ),W(1,6   ),GWWA ,AMP(2   ))  
      CALL wwa_anomal3(W(1,11  ),W(1,1   ),W(1,6   ),AMP(2   ))  
         
c      CALL JVVXXX(W(1,1   ),W(1,8   ),GWWA ,WMASS   ,WWIDTH  ,W(1,12  ))
      CALL jwmwpa_anomal3(W(1,1   ),W(1,8   ),W(1,12  ))

      CALL FVIXXX(W(1,3   ),W(1,12  ),GWF ,ZERO    ,ZERO    ,W(1,13  ))    
      CALL IOVXXX(W(1,13  ),W(1,2   ),W(1,6   ),GAL ,AMP(3   ))      
      
c      CALL JVVXXX(W(1,1   ),W(1,10  ),GWWZ ,WMASS   ,WWIDTH  ,W(1,14  ))
      CALL jwmwpz_anomal3(W(1,1   ),W(1,10  ),W(1,14  ))

      CALL FVIXXX(W(1,3   ),W(1,14  ),GWF ,ZERO    ,ZERO    ,W(1,15  ))    
      CALL IOVXXX(W(1,15  ),W(1,2   ),W(1,6   ),GAL ,AMP(4   ))     
       
c      CALL JVVXXX(W(1,7   ),W(1,1   ),GWWA ,ZERO    ,AWIDTH  ,W(1,16  ))
      CALL jaww_anomal3(W(1,7   ),W(1,1   ),W(1,16  ))

      CALL FVIXXX(W(1,5   ),W(1,16  ),GAL ,ZERO    ,ZERO    ,W(1,17  ))    
      CALL IOVXXX(W(1,17  ),W(1,4   ),W(1,6   ),GAL ,AMP(5   ))       
     
c      CALL JVVXXX(W(1,7   ),W(1,1   ),GWWZ ,ZMASS   ,ZWIDTH  ,W(1,18  ))
      CALL jzww_anomal3(W(1,7   ),W(1,1   ),W(1,18  ))

      CALL FVIXXX(W(1,5   ),W(1,18  ),GZL ,ZERO    ,ZERO    ,W(1,19  ))    
      CALL IOVXXX(W(1,19  ),W(1,4   ),W(1,6   ),GAL ,AMP(6   ))            
      CALL FVOXXX(W(1,4   ),W(1,16  ),GAL ,ZERO    ,ZERO    ,W(1,20  ))    
      CALL IOVXXX(W(1,5   ),W(1,20  ),W(1,6   ),GAL ,AMP(7   ))            
      CALL FVOXXX(W(1,4   ),W(1,18  ),GZL ,ZERO    ,ZERO    ,W(1,21  ))    
      CALL IOVXXX(W(1,5   ),W(1,21  ),W(1,6   ),GAL ,AMP(8   )) 
           
c      CALL W3W3XX(W(1,7   ),W(1,8   ),W(1,1   ),W(1,6   ),GWWA ,GWWA ,AMP(9   ))
      CALL wwaa_anomal4(W(1,7   ),W(1,8   ),W(1,1   ),W(1,6   ),AMP(9   ))

c      CALL W3W3XX(W(1,7   ),W(1,10  ),W(1,1   ),W(1,6   ),GWWZ ,GWWA ,AMP(10  ))
      CALL wwza_anomal4(W(1,7   ),W(1,10  ),W(1,1   ),W(1,6   ),AMP(10  ))

c      CALL VVVXXX(W(1,7   ),W(1,12  ),W(1,6   ),GWWA ,AMP(11  ))   
      CALL wwa_anomal3(W(1,7   ),W(1,12  ),W(1,6   ),AMP(11  )) 
        
c      CALL VVVXXX(W(1,7   ),W(1,14  ),W(1,6   ),GWWA ,AMP(12  ))  
      CALL wwa_anomal3(W(1,7   ),W(1,14  ),W(1,6   ),AMP(12  )) 
         
      CALL FVIXXX(W(1,5   ),W(1,7   ),GWF ,ZERO    ,ZERO    ,W(1,22  ))    
      CALL JIOXXX(W(1,22  ),W(1,4   ),GWF ,WMASS   ,WWIDTH  ,W(1,23  ))  
  
c      CALL VVVXXX(W(1,23  ),W(1,1   ),W(1,6   ),GWWA ,AMP(13  ))    
      CALL wwa_anomal3(W(1,23  ),W(1,1   ),W(1,6   ),AMP(13  ))  
       
      CALL FVOXXX(W(1,4   ),W(1,1   ),GWF ,ZERO    ,ZERO    ,W(1,24  ))    
      CALL JIOXXX(W(1,5   ),W(1,24  ),GWF ,WMASS   ,WWIDTH  ,W(1,25  ))    
      CALL FVIXXX(W(1,3   ),W(1,25  ),GWF ,ZERO    ,ZERO    ,W(1,26  ))    
      CALL IOVXXX(W(1,26  ),W(1,2   ),W(1,6   ),GAL ,AMP(14  ))            
      CALL FVIXXX(W(1,22  ),W(1,1   ),GWF ,ZERO    ,ZERO    ,W(1,27  ))    
      CALL IOVXXX(W(1,27  ),W(1,4   ),W(1,6   ),GAL ,AMP(15  ))            
      CALL FVOXXX(W(1,24  ),W(1,7   ),GWF ,ZERO    ,ZERO    ,W(1,28  ))    
      CALL IOVXXX(W(1,5   ),W(1,28  ),W(1,6   ),GAL ,AMP(16  ))    
        
c      CALL VVVXXX(W(1,7   ),W(1,25  ),W(1,6   ),GWWA ,AMP(17  ))  
      CALL wwa_anomal3(W(1,7   ),W(1,25  ),W(1,6   ),AMP(17  )) 
         
      CALL FVOXXX(W(1,2   ),W(1,8   ),GAL ,ZERO    ,ZERO    ,W(1,29  ))    
      CALL JIOXXX(W(1,3   ),W(1,29  ),GWF ,WMASS   ,WWIDTH  ,W(1,30  )) 
   
c      CALL VVVXXX(W(1,30  ),W(1,1   ),W(1,6   ),GWWA ,AMP(18  ))  
      CALL wwa_anomal3(W(1,30  ),W(1,1   ),W(1,6   ),AMP(18  )) 
         
      CALL FVOXXX(W(1,2   ),W(1,10  ),GZL ,ZERO    ,ZERO    ,W(1,31  ))    
      CALL JIOXXX(W(1,3   ),W(1,31  ),GWF ,WMASS   ,WWIDTH  ,W(1,32  )) 
   
c      CALL VVVXXX(W(1,32  ),W(1,1   ),W(1,6   ),GWWA ,AMP(19  ))   
      CALL wwa_anomal3(W(1,32  ),W(1,1   ),W(1,6   ),AMP(19  ))
        
      CALL FVIXXX(W(1,3   ),W(1,1   ),GWF ,ZERO    ,ZERO    ,W(1,33  ))    
      CALL FVIXXX(W(1,33  ),W(1,8   ),GAL ,ZERO    ,ZERO    ,W(1,34  ))    
      CALL IOVXXX(W(1,34  ),W(1,2   ),W(1,6   ),GAL ,AMP(20  ))            
      CALL FVIXXX(W(1,33  ),W(1,10  ),GZL ,ZERO    ,ZERO    ,W(1,35  ))    
      CALL IOVXXX(W(1,35  ),W(1,2   ),W(1,6   ),GAL ,AMP(21  ))            
      CALL JIOXXX(W(1,33  ),W(1,2   ),GAL ,ZERO    ,AWIDTH  ,W(1,36  ))    
      CALL FVIXXX(W(1,5   ),W(1,36  ),GAL ,ZERO    ,ZERO    ,W(1,37  ))    
      CALL IOVXXX(W(1,37  ),W(1,4   ),W(1,6   ),GAL ,AMP(22  ))            
      CALL JIOXXX(W(1,33  ),W(1,2   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,38  ))    
      CALL FVIXXX(W(1,5   ),W(1,38  ),GZL ,ZERO    ,ZERO    ,W(1,39  ))    
      CALL IOVXXX(W(1,39  ),W(1,4   ),W(1,6   ),GAL ,AMP(23  ))            
      CALL FVOXXX(W(1,4   ),W(1,36  ),GAL ,ZERO    ,ZERO    ,W(1,40  ))    
      CALL IOVXXX(W(1,5   ),W(1,40  ),W(1,6   ),GAL ,AMP(24  ))            
      CALL FVOXXX(W(1,4   ),W(1,38  ),GZL ,ZERO    ,ZERO    ,W(1,41  ))    
      CALL IOVXXX(W(1,5   ),W(1,41  ),W(1,6   ),GAL ,AMP(25  ))            
      CALL IOVXXX(W(1,33  ),W(1,29  ),W(1,6   ),GAL ,AMP(26  ))            
      CALL IOVXXX(W(1,33  ),W(1,31  ),W(1,6   ),GAL ,AMP(27  ))            
      CALL FVIXXX(W(1,3   ),W(1,10  ),GZN ,ZERO    ,ZERO    ,W(1,42  ))    
      CALL JIOXXX(W(1,42  ),W(1,2   ),GWF ,WMASS   ,WWIDTH  ,W(1,43  ))  
  
c      CALL VVVXXX(W(1,43  ),W(1,1   ),W(1,6   ),GWWA ,AMP(28  ))  
      CALL wwa_anomal3(W(1,43  ),W(1,1   ),W(1,6   ),AMP(28  )) 
         
      CALL FVIXXX(W(1,42  ),W(1,1   ),GWF ,ZERO    ,ZERO    ,W(1,44  ))    
      CALL IOVXXX(W(1,44  ),W(1,2   ),W(1,6   ),GAL ,AMP(29  ))            
      CALL FVOXXX(W(1,2   ),W(1,1   ),GWF ,ZERO    ,ZERO    ,W(1,45  ))    
      CALL JIOXXX(W(1,3   ),W(1,45  ),GZN ,ZMASS   ,ZWIDTH  ,W(1,46  ))    
      CALL FVIXXX(W(1,5   ),W(1,46  ),GZL ,ZERO    ,ZERO    ,W(1,47  ))    
      CALL IOVXXX(W(1,47  ),W(1,4   ),W(1,6   ),GAL ,AMP(30  ))            
      CALL FVOXXX(W(1,4   ),W(1,46  ),GZL ,ZERO    ,ZERO    ,W(1,48  ))    
      CALL IOVXXX(W(1,5   ),W(1,48  ),W(1,6   ),GAL ,AMP(31  ))    

c due to anomalous couplings there are 2 extra graphs with a Higgs (WWH-, AAH-, AZH-coupling)
      CALL jhww_anomal3(W(1,7   ),W(1,1   ),W(1,49  ))
      CALL azh_anomal3(W(1,6   ),W(1,10  ),W(1,49  ),AMP(32  ))
      CALL aah_anomal3(W(1,6   ),W(1,8   ),W(1,49  ),AMP(33  ))


      wza(  mu) = +AMP(   1)+AMP(   2)+AMP(   3)+AMP(   4)+AMP(   5)
     &             +AMP(   6)+AMP(   7)+AMP(   8)+AMP(   9)+AMP(  10)
     &             +AMP(  11)+AMP(  12)+AMP(  13)+AMP(  14)+AMP(  15)
     &             +AMP(  16)+AMP(  17)+AMP(  18)+AMP(  19)+AMP(  20)
     &             +AMP(  21)+AMP(  22)+AMP(  23)+AMP(  24)+AMP(  25)
     &             +AMP(  26)+AMP(  27)+AMP(  28)+AMP(  29)+AMP(  30)
     &             +AMP(  31)
     &             +AMP(  32)+AMP(  33) !new Higgs graphs

      enddo
      wza(4) = dcmplx(q(0),q(3))
      wza(5) = dcmplx(q(1),q(2))
c
      END

