c ------------------------------------------------------------

      SUBROUTINE ZAA_ATOZA(v,N,h,atoza,nA)

      IMPLICIT NONE

      DOUBLE PRECISION P(0:3,2:5), v(0:3,4)
      complex*16 atoza(0:5)
      integer lsign(2:5,8),ll,mu,h,N
      integer nA ! discriminate between the two photons

      !possible lepton helicities: 
      data (lsign(ll,1),ll=2,5) / -1, +1, +1, +1/  !h=1
      data (lsign(ll,2),ll=2,5) / -1, +1, -1, +1/  !h=2
      data (lsign(ll,3),ll=2,5) / -1, +1, +1, -1/  !h=3
      data (lsign(ll,4),ll=2,5) / -1, +1, -1, -1/  !h=4
      data (lsign(ll,5),ll=2,5) / +1, -1, +1, +1/  !h=5
      data (lsign(ll,6),ll=2,5) / +1, -1, -1, +1/  !h=6
      data (lsign(ll,7),ll=2,5) / +1, -1, +1, -1/  !h=7
      data (lsign(ll,8),ll=2,5) / +1, -1, -1, -1/  !h=8

      do mu = 0,3
         P(mu,2) = v(mu,1)
         P(mu,3) = v(mu,2)
         if (nA.eq.1) then
            P(mu,4) = v(mu,3)
         elseif (nA.eq.2) then
            P(mu,4) = v(mu,4)
         endif
      enddo

      call ZAA_ATOZA1(P,N,lsign(2,h),atoza,nA)

      ! helicity combi nr.h is selected

      end

      subroutine ZAA_ATOZA1(P,N,lsign,atoza,nA)
C  
C Generated by MadGraph II Version 3.0. Updated 02/19/04                
C RETURNS AMPLITUDE SQUARED SUMMED/AVG OVER COLORS
C FOR THE POINT WITH EXTERNAL LINES W(0:6,NEXTERNAL)
C  
C FOR PROCESS : a -> e- e+ a  
C  
      IMPLICIT NONE
C  
C CONSTANTS
C  
      INTEGER    NGRAPHS
      PARAMETER (NGRAPHS=   2) 
      INTEGER    NWAVEFUNCS
      PARAMETER (NWAVEFUNCS=   6) 
      REAL*8     ZERO
      PARAMETER (ZERO=0D0)
C  
C ARGUMENTS 
C  
      REAL*8 P(0:3,2:5), Q(0:3)
      INTEGER N
      complex*16 atoza(0:5)
      integer lsign(2:5)
      integer nA
C  
C LOCAL VARIABLES 
C  
      INTEGER I,J,mu
      COMPLEX*16 AMP(NGRAPHS)
      COMPLEX*16 W(6,NWAVEFUNCS)
c  lepton spinors and W+-, Z/A polarization vectors
#include "tensor.inc"

      logical lswitch
      parameter (lswitch=.true.)

C  
C GLOBAL VARIABLES
C  
#include "VBFNLO/utilities/coupl.inc"
C                                                                          
C ----------
C BEGIN CODE
C ----------
      if (lswitch) then      ! read in lepton and A states from common block
         do i=1,6
            w(i,2)  = zem(i,N)
            w(i,3)  = zep(i,N)
            if (nA.eq.1) then
               w(i,4)  = atau1(i,N)
            elseif (nA.eq.2) then
               w(i,4)  = atau2(i,N)
            endif
         enddo
      endif

      do mu = 0,3
         q(mu) = p(mu,2)+p(mu,3)+p(mu,4)
      enddo
      do mu = 0,3
      CALL TRIBOSVCARTX(Q(0),ZERO,ZERO,MU,-1,W(1,1   ))
      CALL FVIXXX(W(1,3   ),W(1,1   ),GAL ,ZERO    ,ZERO    ,W(1,5   ))    
      CALL IOVXXX(W(1,5   ),W(1,2   ),W(1,4   ),GAL ,AMP(1   ))            
      CALL FVOXXX(W(1,2   ),W(1,1   ),GAL ,ZERO    ,ZERO    ,W(1,6   ))    
      CALL IOVXXX(W(1,3   ),W(1,6   ),W(1,4   ),GAL ,AMP(2   ))            
      atoza(mu) = +AMP(1)+AMP(2)
      enddo
      atoza(4) = dcmplx(q(0),q(3))
      atoza(5) = dcmplx(q(1),q(2))
      return
      END

c ------------------------------------------------------------

      SUBROUTINE ZAA_ZTOZA(v,N,h,ztoza,nA)

      IMPLICIT NONE

      DOUBLE PRECISION P(0:3,2:5), v(0:3,6)
      complex*16 ztoza(0:5)
      integer lsign(2:5,8),ll,mu,h,N
      integer nA ! discriminate between the two photons

      !possible lepton helicities: 
      data (lsign(ll,1),ll=2,5) / -1, +1, +1, +1/  !h=1
      data (lsign(ll,2),ll=2,5) / -1, +1, -1, +1/  !h=2
      data (lsign(ll,3),ll=2,5) / -1, +1, +1, -1/  !h=3
      data (lsign(ll,4),ll=2,5) / -1, +1, -1, -1/  !h=4
      data (lsign(ll,5),ll=2,5) / +1, -1, +1, +1/  !h=5
      data (lsign(ll,6),ll=2,5) / +1, -1, -1, +1/  !h=6
      data (lsign(ll,7),ll=2,5) / +1, -1, +1, -1/  !h=7
      data (lsign(ll,8),ll=2,5) / +1, -1, -1, -1/  !h=8

      do mu = 0,3
         P(mu,2) = v(mu,1)
         P(mu,3) = v(mu,2)
         if (nA.eq.1) then
            P(mu,4) = v(mu,3)
         elseif (nA.eq.2) then
            P(mu,4) = v(mu,4)
         endif
      enddo

      call ZAA_ZTOZA1(P,N,lsign(2,h),ztoza,nA)

      ! helicity combi nr.h is selected

      end

c ----------------------------------------------------------       

      subroutine ZAA_ZTOZA1(P,N,lsign,ztoza,nA)
C  
C Generated by MadGraph II Version 3.0. Updated 02/19/04                
C RETURNS AMPLITUDE SQUARED SUMMED/AVG OVER COLORS
C FOR THE POINT WITH EXTERNAL LINES W(0:6,NEXTERNAL)
C  
C FOR PROCESS : z -> e- e+ a  
C  
      IMPLICIT NONE
C  
C CONSTANTS
C  
      INTEGER    NGRAPHS
      PARAMETER (NGRAPHS=  2) 
      INTEGER    NWAVEFUNCS
      PARAMETER (NWAVEFUNCS=   6) 
      REAL*8     ZERO
      PARAMETER (ZERO=0D0)
C  
C ARGUMENTS 
C  
      REAL*8 P(0:3,2:5),Q(0:3)
      INTEGER N
      complex*16 ztoza(0:5)
      integer lsign(2:5)
      integer nA
C  
C LOCAL VARIABLES 
C  
      INTEGER I,J,mu
      COMPLEX*16 AMP(NGRAPHS)
      COMPLEX*16 W(6,NWAVEFUNCS)
c  lepton spinors and W+-, Z/A polarization vectors
#include "tensor.inc"

      logical lswitch
      parameter (lswitch=.true.)

C  
C GLOBAL VARIABLES
C  
#include "VBFNLO/utilities/coupl.inc"          
C
C ----------
C BEGIN CODE
C ----------
      if (lswitch) then      ! read in lepton and A states from common block
         do i=1,6
            w(i,2)  = zem(i,N)
            w(i,3)  = zep(i,N)
            if (nA.eq.1) then
               w(i,4)  = atau1(i,N)
            elseif (nA.eq.2) then
               w(i,4)  = atau2(i,N)
            endif
         enddo
      endif

      do mu = 0,3
         q(mu) = p(mu,2)+p(mu,3)+p(mu,4)
      enddo
      do mu = 0,3
      CALL TRIBOSVCARTX(Q(0),ZMASS,ZWIDTH,MU,-1,W(1,1   ))
      CALL FVIXXX(W(1,3   ),W(1,1   ),GZL ,ZERO    ,ZERO    ,W(1,5   ))    
      CALL IOVXXX(W(1,5   ),W(1,2   ),W(1,4   ),GAL ,AMP(1   ))            
      CALL FVOXXX(W(1,2   ),W(1,1   ),GZL ,ZERO    ,ZERO    ,W(1,6   ))    
      CALL IOVXXX(W(1,3   ),W(1,6   ),W(1,4   ),GAL ,AMP(2   ))            
      ztoza(mu) = +AMP(1)+AMP(2)
      enddo
      ztoza(4) = dcmplx(q(0),q(3))
      ztoza(5) = dcmplx(q(1),q(2))
      return
      END
