c
c in this file leptonic tensors needed for qq -> ZZW, ZZW -> 6l
c are computed for specific helicities (h)
c
c ------------------------------------------------------------
c ------------------------------------------------------------

      subroutine WPTOZZW(P,N,h,ZZW,NW)

      IMPLICIT NONE

      DOUBLE PRECISION P(0:3,2:7)
      COMPLEX*16 ZZW(0:5)
      integer lsign(2:7,8),ll,mu,nu,h,N
      integer NW ! = 0: all diagrams, = 1: no non resonant diagrams

      !possible lepton helicities
      data (lsign(ll,1),ll=2,7) / -1, -1, -1, -1, -1, -1/  !h=1
      data (lsign(ll,2),ll=2,7) / -1, -1,  1,  1, -1, -1/  !h=2
      data (lsign(ll,3),ll=2,7) /  1,  1, -1, -1, -1, -1/  !h=3
      data (lsign(ll,4),ll=2,7) /  1,  1,  1,  1, -1, -1/  !h=4

      call WPTOZZW1(P,N,lsign(2,h),zzw(0),NW)

      ! helicity combi Nr. h is selected

      end

c-------------------------------------------------------------------

      SUBROUTINE WPTOZZW1(P,N,lsign,zzw,NW)  
C  
C Generated by MadGraph II Version 3.0. Updated 02/19/04                
C RETURNS AMPLITUDE SQUARED SUMMED/AVG OVER COLORS
C AND HELICITIES
C FOR THE POINT IN PHASE SPACE P(0:3,NEXTERNAL)
C  
C FOR PROCESS : w+ -> e- e+ mu- mu+ vt ta+  
C  
C Crossing   1 is w+ e+ -> e+ mu- mu+ vt ta+  
C  
      IMPLICIT NONE
C  
C CONSTANTS
C  
      INTEGER    NGRAPHS 
      PARAMETER (NGRAPHS= 106) 
      INTEGER    NWAVEFUNCS
      PARAMETER (NWAVEFUNCS= 84) 
      DOUBLE PRECISION     ZERO
      PARAMETER (ZERO=0D0)
C  
C ARGUMENTS 
C  
      DOUBLE PRECISION P(0:3,2:7), Q(0:3)
      INTEGER N
      COMPLEX*16 zzw(0:5)
      INTEGER lsign(2:7)
      integer NW ! = 0: all diagrams, = 1: no non resonant diagrams
C  
C LOCAL VARIABLES 
C  
      INTEGER I,J, mu
      COMPLEX*16 AMP(NGRAPHS)
      COMPLEX*16 W(6,NWAVEFUNCS)
c  lepton spinors and polarization vectors
#include "tensor.inc"

      logical lswitch
      parameter (lswitch=.true.)
C  
C GLOBAL VARIABLES
C  
#include "VBFNLO/utilities/coupl.inc"                                  
C                                                                          
C ----------
C BEGIN CODE
C ----------
      if (lswitch) then
         do i=1,6
            w(i,2)  = zem(i,N)
            w(i,3)  = zep(i,N)
            w(i,4)  = zmm(i,N)
            w(i,5)  = zmp(i,N)
            w(i,6)  = ztm(i,N)
            w(i,7)  = ztp(i,N)
            w(i,8)  = ae(i,N)
            w(i,12) = ze(i,N)
            w(i,24) = wbos(i,N)
            w(i,34) = zmu(i,N)
            w(i,36) = amu(i,N)
         enddo
      endif

      do mu = 0,3
         q(mu) = p(mu,2)+p(mu,3)+p(mu,4)+p(mu,5)+p(mu,6)+p(mu,7)
      enddo

      if (.not.lswitch) then        
         CALL OXXXXX(P(0,2), ZERO , lsign(2),+1,W(1,2   ))        
         CALL IXXXXX(P(0,3), ZERO ,-lsign(3),-1,W(1,3   ))        
         CALL OXXXXX(P(0,4), ZERO , lsign(4),+1,W(1,4   ))        
         CALL IXXXXX(P(0,5), ZERO ,-lsign(5),-1,W(1,5   ))        
         CALL OXXXXX(P(0,6), ZERO , lsign(6),+1,W(1,6   ))       
         CALL IXXXXX(P(0,7), ZERO ,-lsign(7),-1,W(1,7   ))
         CALL JIOXXX(W(1,3   ),W(1,2   ),GAL ,ZERO    ,ZERO    ,W(1,8))
         CALL JIOXXX(W(1,3   ),W(1,2   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,12))
         CALL JIOXXX(W(1,7   ),W(1,6   ),GWF ,WMASS   ,WWIDTH  ,W(1,24))
         CALL JIOXXX(W(1,5   ),W(1,4   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,34))
         CALL JIOXXX(W(1,5   ),W(1,4   ),GAL ,ZERO    ,ZERO    ,W(1,36)) 
      endif 

      do mu = 0,3
      call TRIBOSVCARTX(Q(0), WMASS, WWIDTH, MU, -1, W(1,1))      
      CALL FVOXXX(W(1,4   ),W(1,8   ),GAL ,ZERO    ,ZERO    ,W(1,9   ))    
      CALL JIOXXX(W(1,5   ),W(1,9   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,10  ))    
      CALL FVOXXX(W(1,6   ),W(1,10  ),GZN ,ZERO    ,ZERO    ,W(1,11  ))    
      CALL IOVXXX(W(1,7   ),W(1,11  ),W(1,1   ),GWF ,AMP(1   ))            
      CALL FVOXXX(W(1,4   ),W(1,12  ),GZL ,ZERO    ,ZERO    ,W(1,13  ))    
      CALL JIOXXX(W(1,5   ),W(1,13  ),GZL ,ZMASS   ,ZWIDTH  ,W(1,14  ))    
      CALL FVOXXX(W(1,6   ),W(1,14  ),GZN ,ZERO    ,ZERO    ,W(1,15  ))    
      CALL IOVXXX(W(1,7   ),W(1,15  ),W(1,1   ),GWF ,AMP(2   ))            
      CALL JIOXXX(W(1,5   ),W(1,9   ),GAL ,ZERO    ,ZERO    ,W(1,16  ))    
      CALL JVVXXX(W(1,16  ),W(1,1   ),GWWA ,WMASS   ,WWIDTH  ,W(1,         
     &     17  ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,17  ),GWF ,AMP(3   ))            
      CALL JVVXXX(W(1,10  ),W(1,1   ),GWWZ ,WMASS   ,WWIDTH  ,W(1,         
     &     18  ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,18  ),GWF ,AMP(4   ))            
      CALL JIOXXX(W(1,5   ),W(1,13  ),GAL ,ZERO    ,ZERO    ,W(1,19  ))    
      CALL JVVXXX(W(1,19  ),W(1,1   ),GWWA ,WMASS   ,WWIDTH  ,W(1,         
     &     20  ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,20  ),GWF ,AMP(5   ))            
      CALL JVVXXX(W(1,14  ),W(1,1   ),GWWZ ,WMASS   ,WWIDTH  ,W(1,         
     &     21  ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,21  ),GWF ,AMP(6   ))            
      CALL FVOXXX(W(1,6   ),W(1,1   ),GWF ,LMASS   ,ZERO    ,W(1,22  ))    
      CALL IOVXXX(W(1,7   ),W(1,22  ),W(1,16  ),GAL ,AMP(7   ))            
      CALL IOVXXX(W(1,7   ),W(1,22  ),W(1,10  ),GZL ,AMP(8   ))            
      CALL IOVXXX(W(1,7   ),W(1,22  ),W(1,19  ),GAL ,AMP(9   ))            
      CALL IOVXXX(W(1,7   ),W(1,22  ),W(1,14  ),GZL ,AMP(10  ))            
      CALL FVIXXX(W(1,5   ),W(1,1   ),GWF ,ZERO    ,ZERO    ,W(1,23  ))    
      CALL JIOXXX(W(1,23  ),W(1,4   ),GWF ,WMASS   ,WWIDTH  ,W(1,25  ))    
      CALL FVOXXX(W(1,2   ),W(1,24  ),GWF ,ZERO    ,ZERO    ,W(1,26  ))    
      CALL IOVXXX(W(1,3   ),W(1,26  ),W(1,25  ),GWF ,AMP(11  ))            
      CALL FVIXXX(W(1,23  ),W(1,12  ),GZN ,ZERO    ,ZERO    ,W(1,27  ))    
      CALL IOVXXX(W(1,27  ),W(1,4   ),W(1,24  ),GWF ,AMP(12  ))            
      CALL VVVXXX(W(1,25  ),W(1,24  ),W(1,8   ),GWWA ,AMP(13  ))           
      CALL VVVXXX(W(1,25  ),W(1,24  ),W(1,12  ),GWWZ ,AMP(14  ))           
      CALL FVOXXX(W(1,6   ),W(1,12  ),GZN ,ZERO    ,ZERO    ,W(1,28  ))    
      CALL JIOXXX(W(1,7   ),W(1,28  ),GWF ,WMASS   ,WWIDTH  ,W(1,29  ))    
      CALL IOVXXX(W(1,23  ),W(1,4   ),W(1,29  ),GWF ,AMP(15  ))            
      CALL FVIXXX(W(1,7   ),W(1,8   ),GAL ,LMASS   ,ZERO    ,W(1,30  ))    
      CALL IOVXXX(W(1,30  ),W(1,6   ),W(1,25  ),GWF ,AMP(16  ))            
      CALL FVIXXX(W(1,7   ),W(1,12  ),GZL ,LMASS   ,ZERO    ,W(1,31  ))    
      CALL IOVXXX(W(1,31  ),W(1,6   ),W(1,25  ),GWF ,AMP(17  ))            
      CALL JIOXXX(W(1,23  ),W(1,9   ),GWF ,WMASS   ,WWIDTH  ,W(1,32  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,32  ),GWF ,AMP(18  ))            
      CALL JIOXXX(W(1,23  ),W(1,13  ),GWF ,WMASS   ,WWIDTH  ,W(1,33  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,33  ),GWF ,AMP(19  ))            
      CALL HVVXXX(W(1,34  ),W(1,12  ),GZZH ,HMASS   ,HWIDTH  ,W(1,         
     &     35  ))                                                          
      CALL VVSXXX(W(1,1   ),W(1,24  ),W(1,35  ),GWWH ,AMP(20  ))           
      CALL IOVXXX(W(1,30  ),W(1,22  ),W(1,36  ),GAL ,AMP(21  ))            
      CALL IOVXXX(W(1,30  ),W(1,22  ),W(1,34  ),GZL ,AMP(22  ))            
      CALL IOVXXX(W(1,31  ),W(1,22  ),W(1,36  ),GAL ,AMP(23  ))            
      CALL IOVXXX(W(1,31  ),W(1,22  ),W(1,34  ),GZL ,AMP(24  ))            
      CALL FVIXXX(W(1,7   ),W(1,36  ),GAL ,LMASS   ,ZERO    ,W(1,37  ))    
      CALL IOVXXX(W(1,37  ),W(1,22  ),W(1,8   ),GAL ,AMP(25  ))            
      CALL FVIXXX(W(1,7   ),W(1,34  ),GZL ,LMASS   ,ZERO    ,W(1,38  ))    
      CALL IOVXXX(W(1,38  ),W(1,22  ),W(1,8   ),GAL ,AMP(26  ))            
      CALL IOVXXX(W(1,37  ),W(1,22  ),W(1,12  ),GZL ,AMP(27  ))            
      CALL IOVXXX(W(1,38  ),W(1,22  ),W(1,12  ),GZL ,AMP(28  ))            
      CALL HIOXXX(W(1,7   ),W(1,22  ),GHTAU ,HMASS   ,HWIDTH  ,W(1,        
     &     39  ))                                                          
      CALL VVSXXX(W(1,34  ),W(1,12  ),W(1,39  ),GZZH ,AMP(29  ))           
      CALL JVVXXX(W(1,36  ),W(1,1   ),GWWA ,WMASS   ,WWIDTH  ,W(1,         
     &     40  ))                                                          
      CALL IOVXXX(W(1,3   ),W(1,26  ),W(1,40  ),GWF ,AMP(30  ))            
      CALL JVVXXX(W(1,34  ),W(1,1   ),GWWZ ,WMASS   ,WWIDTH  ,W(1,         
     &     41  ))                                                          
      CALL IOVXXX(W(1,3   ),W(1,26  ),W(1,41  ),GWF ,AMP(31  ))            
      CALL JVVXXX(W(1,8   ),W(1,1   ),GWWA ,WMASS   ,WWIDTH  ,W(1,         
     &     42  ))                                                          
      CALL FVIXXX(W(1,5   ),W(1,42  ),GWF ,ZERO    ,ZERO    ,W(1,43  ))    
      CALL JIOXXX(W(1,43  ),W(1,4   ),GWF ,WMASS   ,WWIDTH  ,W(1,44  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,44  ),GWF ,AMP(32  ))            
      CALL JVVXXX(W(1,12  ),W(1,1   ),GWWZ ,WMASS   ,WWIDTH  ,W(1,         
     &     45  ))                                                          
      CALL FVIXXX(W(1,5   ),W(1,45  ),GWF ,ZERO    ,ZERO    ,W(1,46  ))    
      CALL JIOXXX(W(1,46  ),W(1,4   ),GWF ,WMASS   ,WWIDTH  ,W(1,47  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,47  ),GWF ,AMP(33  ))            
      CALL FVIXXX(W(1,7   ),W(1,1   ),GWF ,ZERO    ,ZERO    ,W(1,48  ))    
      CALL IOVXXX(W(1,48  ),W(1,28  ),W(1,34  ),GZN ,AMP(34  ))            
      CALL VVVXXX(W(1,40  ),W(1,24  ),W(1,8   ),GWWA ,AMP(35  ))           
      CALL VVVXXX(W(1,41  ),W(1,24  ),W(1,8   ),GWWA ,AMP(36  ))           
      CALL VVVXXX(W(1,40  ),W(1,24  ),W(1,12  ),GWWZ ,AMP(37  ))           
      CALL VVVXXX(W(1,41  ),W(1,24  ),W(1,12  ),GWWZ ,AMP(38  ))           
      CALL VVVXXX(W(1,1   ),W(1,29  ),W(1,36  ),GWWA ,AMP(39  ))           
      CALL VVVXXX(W(1,1   ),W(1,29  ),W(1,34  ),GWWZ ,AMP(40  ))           
      CALL IOVXXX(W(1,37  ),W(1,28  ),W(1,1   ),GWF ,AMP(41  ))            
      CALL IOVXXX(W(1,38  ),W(1,28  ),W(1,1   ),GWF ,AMP(42  ))            
      CALL IOVXXX(W(1,30  ),W(1,6   ),W(1,40  ),GWF ,AMP(43  ))            
      CALL IOVXXX(W(1,30  ),W(1,6   ),W(1,41  ),GWF ,AMP(44  ))            
      CALL IOVXXX(W(1,31  ),W(1,6   ),W(1,40  ),GWF ,AMP(45  ))            
      CALL IOVXXX(W(1,31  ),W(1,6   ),W(1,41  ),GWF ,AMP(46  ))            
      CALL FVOXXX(W(1,6   ),W(1,34  ),GZN ,ZERO    ,ZERO    ,W(1,49  ))    
      CALL IOVXXX(W(1,48  ),W(1,49  ),W(1,12  ),GZN ,AMP(47  ))            
      CALL JVVXXX(W(1,36  ),W(1,42  ),GWWA ,WMASS   ,WWIDTH  ,W(1,         
     &     50  ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,50  ),GWF ,AMP(48  ))            
      CALL JVVXXX(W(1,34  ),W(1,42  ),GWWZ ,WMASS   ,WWIDTH  ,W(1,         
     &     51  ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,51  ),GWF ,AMP(49  ))            
      CALL JVVXXX(W(1,36  ),W(1,45  ),GWWA ,WMASS   ,WWIDTH  ,W(1,         
     &     52  ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,52  ),GWF ,AMP(50  ))            
      CALL JVVXXX(W(1,34  ),W(1,45  ),GWWZ ,WMASS   ,WWIDTH  ,W(1,         
     &     53  ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,53  ),GWF ,AMP(51  ))            
      CALL IOVXXX(W(1,30  ),W(1,49  ),W(1,1   ),GWF ,AMP(52  ))            
      CALL IOVXXX(W(1,31  ),W(1,49  ),W(1,1   ),GWF ,AMP(53  ))            
      CALL FVOXXX(W(1,6   ),W(1,42  ),GWF ,LMASS   ,ZERO    ,W(1,54  ))    
      CALL IOVXXX(W(1,7   ),W(1,54  ),W(1,36  ),GAL ,AMP(54  ))            
      CALL IOVXXX(W(1,7   ),W(1,54  ),W(1,34  ),GZL ,AMP(55  ))            
      CALL FVOXXX(W(1,6   ),W(1,45  ),GWF ,LMASS   ,ZERO    ,W(1,55  ))    
      CALL IOVXXX(W(1,7   ),W(1,55  ),W(1,36  ),GAL ,AMP(56  ))            
      CALL IOVXXX(W(1,7   ),W(1,55  ),W(1,34  ),GZL ,AMP(57  ))            
      CALL IOVXXX(W(1,7   ),W(1,49  ),W(1,42  ),GWF ,AMP(58  ))            
      CALL IOVXXX(W(1,7   ),W(1,49  ),W(1,45  ),GWF ,AMP(59  ))            
      CALL W3W3XX(W(1,1   ),W(1,36  ),W(1,24  ),W(1,8   ),GWWA ,GWWA ,     
     &     AMP(60  ))                                                      
      CALL W3W3XX(W(1,1   ),W(1,34  ),W(1,24  ),W(1,8   ),GWWZ ,GWWA ,     
     &     AMP(61  ))                                                      
      CALL W3W3XX(W(1,1   ),W(1,12  ),W(1,24  ),W(1,36  ),GWWZ ,GWWA ,     
     &     AMP(62  ))                                                      
      CALL W3W3XX(W(1,1   ),W(1,34  ),W(1,24  ),W(1,12  ),GWWZ ,GWWZ ,     
     &     AMP(63  ))                                                      
      CALL FVIXXX(W(1,5   ),W(1,8   ),GAL ,ZERO    ,ZERO    ,W(1,56  ))    
      CALL JIOXXX(W(1,56  ),W(1,4   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,57  ))    
      CALL IOVXXX(W(1,48  ),W(1,6   ),W(1,57  ),GZN ,AMP(64  ))            
      CALL FVIXXX(W(1,5   ),W(1,12  ),GZL ,ZERO    ,ZERO    ,W(1,58  ))    
      CALL JIOXXX(W(1,58  ),W(1,4   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,59  ))    
      CALL IOVXXX(W(1,48  ),W(1,6   ),W(1,59  ),GZN ,AMP(65  ))            
      CALL JIOXXX(W(1,56  ),W(1,4   ),GAL ,ZERO    ,ZERO    ,W(1,60  ))    
      CALL VVVXXX(W(1,1   ),W(1,24  ),W(1,60  ),GWWA ,AMP(66  ))           
      CALL VVVXXX(W(1,1   ),W(1,24  ),W(1,57  ),GWWZ ,AMP(67  ))           
      CALL JIOXXX(W(1,58  ),W(1,4   ),GAL ,ZERO    ,ZERO    ,W(1,61  ))    
      CALL VVVXXX(W(1,1   ),W(1,24  ),W(1,61  ),GWWA ,AMP(68  ))           
      CALL VVVXXX(W(1,1   ),W(1,24  ),W(1,59  ),GWWZ ,AMP(69  ))           
      CALL JIOXXX(W(1,7   ),W(1,22  ),GAL ,ZERO    ,ZERO    ,W(1,62  ))    
      CALL IOVXXX(W(1,56  ),W(1,4   ),W(1,62  ),GAL ,AMP(70  ))            
      CALL JIOXXX(W(1,7   ),W(1,22  ),GZL ,ZMASS   ,ZWIDTH  ,W(1,63  ))    
      CALL IOVXXX(W(1,56  ),W(1,4   ),W(1,63  ),GZL ,AMP(71  ))            
      CALL IOVXXX(W(1,58  ),W(1,4   ),W(1,62  ),GAL ,AMP(72  ))            
      CALL IOVXXX(W(1,58  ),W(1,4   ),W(1,63  ),GZL ,AMP(73  ))            
      CALL FVIXXX(W(1,56  ),W(1,1   ),GWF ,ZERO    ,ZERO    ,W(1,64  ))    
      CALL IOVXXX(W(1,64  ),W(1,4   ),W(1,24  ),GWF ,AMP(74  ))            
      CALL FVIXXX(W(1,58  ),W(1,1   ),GWF ,ZERO    ,ZERO    ,W(1,65  ))    
      CALL IOVXXX(W(1,65  ),W(1,4   ),W(1,24  ),GWF ,AMP(75  ))            
      CALL FVOXXX(W(1,2   ),W(1,36  ),GAL ,ZERO    ,ZERO    ,W(1,66  ))    
      CALL JIOXXX(W(1,48  ),W(1,6   ),GZN ,ZMASS   ,ZWIDTH  ,W(1,67  ))    
      CALL IOVXXX(W(1,3   ),W(1,66  ),W(1,67  ),GZL ,AMP(76  ))            
      CALL FVOXXX(W(1,2   ),W(1,34  ),GZL ,ZERO    ,ZERO    ,W(1,68  ))    
      CALL IOVXXX(W(1,3   ),W(1,68  ),W(1,67  ),GZL ,AMP(77  ))            
      CALL JVVXXX(W(1,1   ),W(1,24  ),GWWA ,ZERO    ,ZERO    ,W(1,         
     &     69  ))                                                          
      CALL IOVXXX(W(1,3   ),W(1,66  ),W(1,69  ),GAL ,AMP(78  ))            
      CALL JVVXXX(W(1,1   ),W(1,24  ),GWWZ ,ZMASS   ,ZWIDTH  ,W(1,         
     &     70  ))                                                          
      CALL IOVXXX(W(1,3   ),W(1,66  ),W(1,70  ),GZL ,AMP(79  ))            
      CALL IOVXXX(W(1,3   ),W(1,68  ),W(1,69  ),GAL ,AMP(80  ))            
      CALL IOVXXX(W(1,3   ),W(1,68  ),W(1,70  ),GZL ,AMP(81  ))            
      CALL FVIXXX(W(1,3   ),W(1,62  ),GAL ,ZERO    ,ZERO    ,W(1,71  ))    
      CALL IOVXXX(W(1,71  ),W(1,2   ),W(1,36  ),GAL ,AMP(82  ))            
      CALL FVIXXX(W(1,3   ),W(1,63  ),GZL ,ZERO    ,ZERO    ,W(1,72  ))    
      CALL IOVXXX(W(1,72  ),W(1,2   ),W(1,36  ),GAL ,AMP(83  ))            
      CALL IOVXXX(W(1,71  ),W(1,2   ),W(1,34  ),GZL ,AMP(84  ))            
      CALL IOVXXX(W(1,72  ),W(1,2   ),W(1,34  ),GZL ,AMP(85  ))            
      CALL FVIXXX(W(1,3   ),W(1,1   ),GWF ,ZERO    ,ZERO    ,W(1,73  ))    
      CALL FVIXXX(W(1,73  ),W(1,34  ),GZN ,ZERO    ,ZERO    ,W(1,74  ))    
      CALL IOVXXX(W(1,74  ),W(1,2   ),W(1,24  ),GWF ,AMP(86  ))            
      CALL JIOXXX(W(1,73  ),W(1,2   ),GWF ,WMASS   ,WWIDTH  ,W(1,75  ))    
      CALL FVIXXX(W(1,5   ),W(1,75  ),GWF ,ZERO    ,ZERO    ,W(1,76  ))    
      CALL JIOXXX(W(1,76  ),W(1,4   ),GWF ,WMASS   ,WWIDTH  ,W(1,77  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,77  ),GWF ,AMP(87  ))            
      CALL IOVXXX(W(1,73  ),W(1,66  ),W(1,24  ),GWF ,AMP(88  ))            
      CALL IOVXXX(W(1,73  ),W(1,68  ),W(1,24  ),GWF ,AMP(89  ))            
      CALL JVVXXX(W(1,36  ),W(1,75  ),GWWA ,WMASS   ,WWIDTH  ,W(1,         
     &     78  ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,78  ),GWF ,AMP(90  ))            
      CALL JVVXXX(W(1,34  ),W(1,75  ),GWWZ ,WMASS   ,WWIDTH  ,W(1,         
     &     79  ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,79  ),GWF ,AMP(91  ))            
      CALL FVOXXX(W(1,6   ),W(1,75  ),GWF ,LMASS   ,ZERO    ,W(1,80  ))    
      CALL IOVXXX(W(1,7   ),W(1,80  ),W(1,36  ),GAL ,AMP(92  ))            
      CALL IOVXXX(W(1,7   ),W(1,80  ),W(1,34  ),GZL ,AMP(93  ))            
      CALL IOVXXX(W(1,7   ),W(1,49  ),W(1,75  ),GWF ,AMP(94  ))            
      CALL FVIXXX(W(1,3   ),W(1,36  ),GAL ,ZERO    ,ZERO    ,W(1,81  ))    
      CALL IOVXXX(W(1,81  ),W(1,2   ),W(1,67  ),GZL ,AMP(95  ))            
      CALL FVIXXX(W(1,3   ),W(1,34  ),GZL ,ZERO    ,ZERO    ,W(1,82  ))    
      CALL IOVXXX(W(1,82  ),W(1,2   ),W(1,67  ),GZL ,AMP(96  ))            
      CALL IOVXXX(W(1,81  ),W(1,2   ),W(1,69  ),GAL ,AMP(97  ))            
      CALL IOVXXX(W(1,81  ),W(1,2   ),W(1,70  ),GZL ,AMP(98  ))            
      CALL IOVXXX(W(1,82  ),W(1,2   ),W(1,69  ),GAL ,AMP(99  ))            
      CALL IOVXXX(W(1,82  ),W(1,2   ),W(1,70  ),GZL ,AMP(100 ))            
      CALL FVOXXX(W(1,2   ),W(1,62  ),GAL ,ZERO    ,ZERO    ,W(1,83  ))    
      CALL IOVXXX(W(1,3   ),W(1,83  ),W(1,36  ),GAL ,AMP(101 ))            
      CALL FVOXXX(W(1,2   ),W(1,63  ),GZL ,ZERO    ,ZERO    ,W(1,84  ))    
      CALL IOVXXX(W(1,3   ),W(1,84  ),W(1,36  ),GAL ,AMP(102 ))            
      CALL IOVXXX(W(1,3   ),W(1,83  ),W(1,34  ),GZL ,AMP(103 ))            
      CALL IOVXXX(W(1,3   ),W(1,84  ),W(1,34  ),GZL ,AMP(104 ))            
      CALL IOVXXX(W(1,81  ),W(1,26  ),W(1,1   ),GWF ,AMP(105 ))            
      CALL IOVXXX(W(1,82  ),W(1,26  ),W(1,1   ),GWF ,AMP(106 ))        
         if (NW.eq.0) then      
            zzw(mu) = -AMP(   1)-AMP(   2)-AMP(   3)-AMP(   4)-AMP(   5)
     &                -AMP(   6)-AMP(   7)-AMP(   8)-AMP(   9)-AMP(  10)
     &                -AMP(  11)-AMP(  12)-AMP(  13)-AMP(  14)-AMP(  15)
     &                -AMP(  16)-AMP(  17)-AMP(  18)-AMP(  19)
     &                -AMP(  21)-AMP(  22)-AMP(  23)-AMP(  24)-AMP(  25)
     &                -AMP(  26)-AMP(  27)-AMP(  28)-AMP(  29)-AMP(  30)
     &                -AMP(  31)-AMP(  32)-AMP(  33)-AMP(  34)-AMP(  35)
     &                -AMP(  36)-AMP(  37)-AMP(  38)-AMP(  39)-AMP(  40)
     &                -AMP(  41)-AMP(  42)-AMP(  43)-AMP(  44)-AMP(  45)
     &                -AMP(  46)-AMP(  47)-AMP(  48)-AMP(  49)-AMP(  50)
     &                -AMP(  51)-AMP(  52)-AMP(  53)-AMP(  54)-AMP(  55)
     &                -AMP(  56)-AMP(  57)-AMP(  58)-AMP(  59)-AMP(  60)
     &                -AMP(  61)-AMP(  62)-AMP(  63)-AMP(  64)-AMP(  65)
     &                -AMP(  66)-AMP(  67)-AMP(  68)-AMP(  69)-AMP(  70)
     &                -AMP(  71)-AMP(  72)-AMP(  73)-AMP(  74)-AMP(  75)
     &                -AMP(  76)-AMP(  77)-AMP(  78)-AMP(  79)-AMP(  80)
     &                -AMP(  81)-AMP(  82)-AMP(  83)-AMP(  84)-AMP(  85)
     &                -AMP(  86)-AMP(  87)-AMP(  88)-AMP(  89)-AMP(  90)
     &                -AMP(  91)-AMP(  92)-AMP(  93)-AMP(  94)-AMP(  95)
     &                -AMP(  96)-AMP(  97)-AMP(  98)-AMP(  99)-AMP( 100)
     &                -AMP( 101)-AMP( 102)-AMP( 103)-AMP( 104)-AMP( 105)
     &                -AMP( 106) 
     &                -AMP(  20) !H -> ZZ
         else if (NW.eq.1) then
            zzw(mu) =  -AMP(20)      !H -> ZZ
     &                 -AMP(38)-AMP(51)-AMP(63)
         endif
      enddo
      zzw(4) = dcmplx(q(0),q(3))
      zzw(5) = dcmplx(q(1),q(2))

      END

c ----------------------------------------------------------------------

      subroutine WMTOZZW(P,N,h,ZZW,NW)

      IMPLICIT NONE

      DOUBLE PRECISION P(0:3,2:7)
      COMPLEX*16 ZZW(0:5)
      integer lsign(2:7,8),ll,mu,nu,h,N
      integer NW ! = 0: all diagrams, = 1: no non resonant diagrams

      !possible lepton helicities
      data (lsign(ll,1),ll=2,7) / -1, -1, -1, -1, -1, -1/  !h=1
      data (lsign(ll,2),ll=2,7) / -1, -1,  1,  1, -1, -1/  !h=2
      data (lsign(ll,3),ll=2,7) /  1,  1, -1, -1, -1, -1/  !h=3
      data (lsign(ll,4),ll=2,7) /  1,  1,  1,  1, -1, -1/  !h=4

      call WMTOZZW1(P,N,lsign(2,h),zzw(0),NW)

      ! helicity combi Nr. h is selected

      end

c-------------------------------------------------------------------

      SUBROUTINE WMTOZZW1(P,N,lsign,zzw,NW)  
C  
C Generated by MadGraph II Version 3.0. Updated 02/19/04                
C RETURNS AMPLITUDE SQUARED SUMMED/AVG OVER COLORS
C FOR THE POINT WITH EXTERNAL LINES W(0:6,NEXTERNAL)
C  
C FOR PROCESS : w- -> e- e+ mu- mu+ ta- vt~  
C
      IMPLICIT NONE
C  
C CONSTANTS
C  
      INTEGER    NGRAPHS 
      PARAMETER (NGRAPHS= 106) 
      INTEGER    NWAVEFUNCS
      PARAMETER (NWAVEFUNCS= 91) 
      DOUBLE PRECISION     ZERO
      PARAMETER (ZERO=0D0)
C  
C ARGUMENTS 
C  
      DOUBLE PRECISION P(0:3,2:7), Q(0:3)
      INTEGER N
      COMPLEX*16 zzw(0:5)
      INTEGER lsign(2:7)
      integer NW ! = 0: all diagrams, = 1: no non resonant diagrams
C  
C LOCAL VARIABLES 
C  
      INTEGER I,J, mu
      COMPLEX*16 AMP(NGRAPHS)
      COMPLEX*16 W(6,NWAVEFUNCS)
c  lepton spinors and polarization vectors
#include "tensor.inc"

      logical lswitch
      parameter (lswitch=.true.)
C  
C GLOBAL VARIABLES
C  
#include "VBFNLO/utilities/coupl.inc"                                  
C                                                                          
C ----------
C BEGIN CODE
C ----------
      if (lswitch) then
         do i=1,6
            w(i,2)  = zem(i,N)
            w(i,3)  = zep(i,N)
            w(i,4)  = zmm(i,N)
            w(i,5)  = zmp(i,N)
            w(i,6)  = ztm(i,N)
            w(i,7)  = ztp(i,N)
            w(i,8)  = ae(i,N)
            w(i,14) = ze(i,N)
            w(i,32) = wbos(i,N)
            w(i,29) = zmu(i,N)
            w(i,35) = amu(i,N)
         enddo
      endif

      do mu = 0,3
         q(mu) = p(mu,2)+p(mu,3)+p(mu,4)+p(mu,5)+p(mu,6)+p(mu,7)
      enddo

      if (.not.lswitch) then        
         CALL OXXXXX(P(0,2), ZERO , lsign(2),+1,W(1,2   ))        
         CALL IXXXXX(P(0,3), ZERO ,-lsign(3),-1,W(1,3   ))        
         CALL OXXXXX(P(0,4), ZERO , lsign(4),+1,W(1,4   ))        
         CALL IXXXXX(P(0,5), ZERO ,-lsign(5),-1,W(1,5   ))        
         CALL OXXXXX(P(0,6), ZERO , lsign(6),+1,W(1,6   ))       
         CALL IXXXXX(P(0,7), ZERO ,-lsign(7),-1,W(1,7   ))
         CALL JIOXXX(W(1,3   ),W(1,2   ),GAL ,ZERO    ,ZERO    ,W(1,8))
         CALL JIOXXX(W(1,3   ),W(1,2   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,14))    
         CALL JIOXXX(W(1,7   ),W(1,6   ),GWF ,WMASS   ,WWIDTH  ,W(1,32))    
         CALL JIOXXX(W(1,5   ),W(1,4   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,29)) 
         CALL JIOXXX(W(1,5   ),W(1,4   ),GAL ,ZERO    ,ZERO    ,W(1,35)) 
      endif 

      do mu = 0,3
      call TRIBOSVCARTX(Q(0), WMASS, WWIDTH, MU, -1, W(1,1))         
      CALL FVOXXX(W(1,4   ),W(1,8   ),GAL ,ZERO    ,ZERO    ,W(1,9   ))    
      CALL JIOXXX(W(1,5   ),W(1,9   ),GAL ,ZERO    ,ZERO    ,W(1,10  ))    
      CALL FVOXXX(W(1,6   ),W(1,10  ),GAL ,LMASS   ,ZERO    ,W(1,11  ))    
      CALL IOVXXX(W(1,7   ),W(1,11  ),W(1,1   ),GWF ,AMP(1   ))            
      CALL JIOXXX(W(1,5   ),W(1,9   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,12  ))    
      CALL FVOXXX(W(1,6   ),W(1,12  ),GZL ,LMASS   ,ZERO    ,W(1,13  ))    
      CALL IOVXXX(W(1,7   ),W(1,13  ),W(1,1   ),GWF ,AMP(2   ))              
      CALL FVOXXX(W(1,4   ),W(1,14  ),GZL ,ZERO    ,ZERO    ,W(1,15  ))    
      CALL JIOXXX(W(1,5   ),W(1,15  ),GAL ,ZERO    ,ZERO    ,W(1,16  ))    
      CALL FVOXXX(W(1,6   ),W(1,16  ),GAL ,LMASS   ,ZERO    ,W(1,17  ))    
      CALL IOVXXX(W(1,7   ),W(1,17  ),W(1,1   ),GWF ,AMP(3   ))            
      CALL JIOXXX(W(1,5   ),W(1,15  ),GZL ,ZMASS   ,ZWIDTH  ,W(1,18  ))    
      CALL FVOXXX(W(1,6   ),W(1,18  ),GZL ,LMASS   ,ZERO    ,W(1,19  ))    
      CALL IOVXXX(W(1,7   ),W(1,19  ),W(1,1   ),GWF ,AMP(4   ))            
      CALL JVVXXX(W(1,1   ),W(1,10  ),GWWA ,WMASS   ,WWIDTH  ,W(1,         
     &     20  ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,20  ),GWF ,AMP(5   ))            
      CALL JVVXXX(W(1,1   ),W(1,12  ),GWWZ ,WMASS   ,WWIDTH  ,W(1,         
     &     21  ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,21  ),GWF ,AMP(6   ))            
      CALL JVVXXX(W(1,1   ),W(1,16  ),GWWA ,WMASS   ,WWIDTH  ,W(1,         
     &     22  ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,22  ),GWF ,AMP(7   ))            
      CALL JVVXXX(W(1,1   ),W(1,18  ),GWWZ ,WMASS   ,WWIDTH  ,W(1,         
     &     23  ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,23  ),GWF ,AMP(8   ))            
      CALL FVOXXX(W(1,6   ),W(1,1   ),GWF ,ZERO    ,ZERO    ,W(1,24  ))    
      CALL IOVXXX(W(1,7   ),W(1,24  ),W(1,12  ),GZN ,AMP(9   ))            
      CALL IOVXXX(W(1,7   ),W(1,24  ),W(1,18  ),GZN ,AMP(10  ))            
      CALL FVOXXX(W(1,9   ),W(1,1   ),GWF ,ZERO    ,ZERO    ,W(1,25  ))    
      CALL JIOXXX(W(1,5   ),W(1,25  ),GWF ,WMASS   ,WWIDTH  ,W(1,26  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,26  ),GWF ,AMP(11  ))            
      CALL FVOXXX(W(1,15  ),W(1,1   ),GWF ,ZERO    ,ZERO    ,W(1,27  ))    
      CALL JIOXXX(W(1,5   ),W(1,27  ),GWF ,WMASS   ,WWIDTH  ,W(1,28  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,28  ),GWF ,AMP(12  ))            
      CALL FVIXXX(W(1,7   ),W(1,1   ),GWF ,LMASS   ,ZERO    ,W(1,30  ))    
      CALL HVVXXX(W(1,29  ),W(1,14  ),GZZH ,HMASS   ,HWIDTH  ,W(1,         
     &     31  ))                                                          
      CALL IOSXXX(W(1,30  ),W(1,6   ),W(1,31  ),GHTAU ,AMP(13  ))          
      CALL VVSXXX(W(1,32  ),W(1,1   ),W(1,31  ),GWWH ,AMP(14  ))           
      CALL FVIXXX(W(1,7   ),W(1,14  ),GZN ,ZERO    ,ZERO    ,W(1,33  ))    
      CALL IOVXXX(W(1,33  ),W(1,24  ),W(1,29  ),GZN ,AMP(15  ))            
      CALL FVIXXX(W(1,7   ),W(1,29  ),GZN ,ZERO    ,ZERO    ,W(1,34  ))    
      CALL IOVXXX(W(1,34  ),W(1,24  ),W(1,14  ),GZN ,AMP(16  ))               
      CALL JVVXXX(W(1,1   ),W(1,35  ),GWWA ,WMASS   ,WWIDTH  ,W(1,         
     &     36  ))                                                          
      CALL FVIXXX(W(1,3   ),W(1,32  ),GWF ,ZERO    ,ZERO    ,W(1,37  ))    
      CALL IOVXXX(W(1,37  ),W(1,2   ),W(1,36  ),GWF ,AMP(17  ))            
      CALL JVVXXX(W(1,1   ),W(1,29  ),GWWZ ,WMASS   ,WWIDTH  ,W(1,         
     &     38  ))                                                          
      CALL IOVXXX(W(1,37  ),W(1,2   ),W(1,38  ),GWF ,AMP(18  ))            
      CALL JVVXXX(W(1,1   ),W(1,8   ),GWWA ,WMASS   ,WWIDTH  ,W(1,         
     &     39  ))                                                          
      CALL FVOXXX(W(1,4   ),W(1,39  ),GWF ,ZERO    ,ZERO    ,W(1,40  ))    
      CALL JIOXXX(W(1,5   ),W(1,40  ),GWF ,WMASS   ,WWIDTH  ,W(1,41  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,41  ),GWF ,AMP(19  ))            
      CALL JVVXXX(W(1,1   ),W(1,14  ),GWWZ ,WMASS   ,WWIDTH  ,W(1,         
     &     42  ))                                                          
      CALL FVOXXX(W(1,4   ),W(1,42  ),GWF ,ZERO    ,ZERO    ,W(1,43  ))    
      CALL JIOXXX(W(1,5   ),W(1,43  ),GWF ,WMASS   ,WWIDTH  ,W(1,44  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,44  ),GWF ,AMP(20  ))            
      CALL FVOXXX(W(1,6   ),W(1,8   ),GAL ,LMASS   ,ZERO    ,W(1,45  ))    
      CALL IOVXXX(W(1,30  ),W(1,45  ),W(1,35  ),GAL ,AMP(21  ))            
      CALL IOVXXX(W(1,30  ),W(1,45  ),W(1,29  ),GZL ,AMP(22  ))            
      CALL FVOXXX(W(1,6   ),W(1,14  ),GZL ,LMASS   ,ZERO    ,W(1,46  ))    
      CALL IOVXXX(W(1,30  ),W(1,46  ),W(1,35  ),GAL ,AMP(23  ))            
      CALL IOVXXX(W(1,30  ),W(1,46  ),W(1,29  ),GZL ,AMP(24  ))            
      CALL VVVXXX(W(1,32  ),W(1,36  ),W(1,8   ),GWWA ,AMP(25  ))           
      CALL VVVXXX(W(1,32  ),W(1,38  ),W(1,8   ),GWWA ,AMP(26  ))           
      CALL VVVXXX(W(1,32  ),W(1,36  ),W(1,14  ),GWWZ ,AMP(27  ))           
      CALL VVVXXX(W(1,32  ),W(1,38  ),W(1,14  ),GWWZ ,AMP(28  ))           
      CALL JIOXXX(W(1,7   ),W(1,45  ),GWF ,WMASS   ,WWIDTH  ,W(1,47  ))    
      CALL VVVXXX(W(1,47  ),W(1,1   ),W(1,35  ),GWWA ,AMP(29  ))           
      CALL VVVXXX(W(1,47  ),W(1,1   ),W(1,29  ),GWWZ ,AMP(30  ))           
      CALL JIOXXX(W(1,7   ),W(1,46  ),GWF ,WMASS   ,WWIDTH  ,W(1,48  ))    
      CALL VVVXXX(W(1,48  ),W(1,1   ),W(1,35  ),GWWA ,AMP(31  ))           
      CALL VVVXXX(W(1,48  ),W(1,1   ),W(1,29  ),GWWZ ,AMP(32  ))           
      CALL IOVXXX(W(1,34  ),W(1,45  ),W(1,1   ),GWF ,AMP(33  ))            
      CALL IOVXXX(W(1,34  ),W(1,46  ),W(1,1   ),GWF ,AMP(34  ))            
      CALL IOVXXX(W(1,33  ),W(1,6   ),W(1,36  ),GWF ,AMP(35  ))            
      CALL IOVXXX(W(1,33  ),W(1,6   ),W(1,38  ),GWF ,AMP(36  ))            
      CALL FVOXXX(W(1,6   ),W(1,35  ),GAL ,LMASS   ,ZERO    ,W(1,49  ))    
      CALL IOVXXX(W(1,30  ),W(1,49  ),W(1,8   ),GAL ,AMP(37  ))            
      CALL FVOXXX(W(1,6   ),W(1,29  ),GZL ,LMASS   ,ZERO    ,W(1,50  ))    
      CALL IOVXXX(W(1,30  ),W(1,50  ),W(1,8   ),GAL ,AMP(38  ))            
      CALL IOVXXX(W(1,30  ),W(1,49  ),W(1,14  ),GZL ,AMP(39  ))            
      CALL IOVXXX(W(1,30  ),W(1,50  ),W(1,14  ),GZL ,AMP(40  ))            
      CALL JVVXXX(W(1,39  ),W(1,35  ),GWWA ,WMASS   ,WWIDTH  ,W(1,         
     &     51  ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,51  ),GWF ,AMP(41  ))            
      CALL JVVXXX(W(1,39  ),W(1,29  ),GWWZ ,WMASS   ,WWIDTH  ,W(1,         
     &     52  ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,52  ),GWF ,AMP(42  ))            
      CALL JVVXXX(W(1,42  ),W(1,35  ),GWWA ,WMASS   ,WWIDTH  ,W(1,         
     &     53  ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,53  ),GWF ,AMP(43  ))            
      CALL JVVXXX(W(1,42  ),W(1,29  ),GWWZ ,WMASS   ,WWIDTH  ,W(1,         
     &     54  ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,54  ),GWF ,AMP(44  ))            
      CALL IOVXXX(W(1,33  ),W(1,49  ),W(1,1   ),GWF ,AMP(45  ))            
      CALL IOVXXX(W(1,33  ),W(1,50  ),W(1,1   ),GWF ,AMP(46  ))            
      CALL FVOXXX(W(1,6   ),W(1,39  ),GWF ,ZERO    ,ZERO    ,W(1,55  ))    
      CALL IOVXXX(W(1,7   ),W(1,55  ),W(1,29  ),GZN ,AMP(47  ))            
      CALL FVOXXX(W(1,6   ),W(1,42  ),GWF ,ZERO    ,ZERO    ,W(1,56  ))    
      CALL IOVXXX(W(1,7   ),W(1,56  ),W(1,29  ),GZN ,AMP(48  ))            
      CALL IOVXXX(W(1,7   ),W(1,49  ),W(1,39  ),GWF ,AMP(49  ))            
      CALL IOVXXX(W(1,7   ),W(1,50  ),W(1,39  ),GWF ,AMP(50  ))            
      CALL IOVXXX(W(1,7   ),W(1,49  ),W(1,42  ),GWF ,AMP(51  ))            
      CALL IOVXXX(W(1,7   ),W(1,50  ),W(1,42  ),GWF ,AMP(52  ))            
      CALL W3W3XX(W(1,32  ),W(1,35  ),W(1,1   ),W(1,8   ),GWWA ,GWWA ,     
     &     AMP(53  ))                                                      
      CALL W3W3XX(W(1,32  ),W(1,29  ),W(1,1   ),W(1,8   ),GWWZ ,GWWA ,     
     &     AMP(54  ))                                                      
      CALL W3W3XX(W(1,32  ),W(1,14  ),W(1,1   ),W(1,35  ),GWWZ ,GWWA ,     
     &     AMP(55  ))                                                      
      CALL W3W3XX(W(1,32  ),W(1,29  ),W(1,1   ),W(1,14  ),GWWZ ,GWWZ ,     
     &     AMP(56  ))                                                      
      CALL FVIXXX(W(1,5   ),W(1,8   ),GAL ,ZERO    ,ZERO    ,W(1,57  ))    
      CALL JIOXXX(W(1,57  ),W(1,4   ),GAL ,ZERO    ,ZERO    ,W(1,58  ))    
      CALL IOVXXX(W(1,30  ),W(1,6   ),W(1,58  ),GAL ,AMP(57  ))            
      CALL JIOXXX(W(1,57  ),W(1,4   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,59  ))    
      CALL IOVXXX(W(1,30  ),W(1,6   ),W(1,59  ),GZL ,AMP(58  ))            
      CALL FVIXXX(W(1,5   ),W(1,14  ),GZL ,ZERO    ,ZERO    ,W(1,60  ))    
      CALL JIOXXX(W(1,60  ),W(1,4   ),GAL ,ZERO    ,ZERO    ,W(1,61  ))    
      CALL IOVXXX(W(1,30  ),W(1,6   ),W(1,61  ),GAL ,AMP(59  ))            
      CALL JIOXXX(W(1,60  ),W(1,4   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,62  ))    
      CALL IOVXXX(W(1,30  ),W(1,6   ),W(1,62  ),GZL ,AMP(60  ))            
      CALL VVVXXX(W(1,32  ),W(1,1   ),W(1,58  ),GWWA ,AMP(61  ))           
      CALL VVVXXX(W(1,32  ),W(1,1   ),W(1,59  ),GWWZ ,AMP(62  ))           
      CALL VVVXXX(W(1,32  ),W(1,1   ),W(1,61  ),GWWA ,AMP(63  ))           
      CALL VVVXXX(W(1,32  ),W(1,1   ),W(1,62  ),GWWZ ,AMP(64  ))           
      CALL JIOXXX(W(1,7   ),W(1,24  ),GZN ,ZMASS   ,ZWIDTH  ,W(1,63  ))    
      CALL IOVXXX(W(1,57  ),W(1,4   ),W(1,63  ),GZL ,AMP(65  ))            
      CALL IOVXXX(W(1,60  ),W(1,4   ),W(1,63  ),GZL ,AMP(66  ))            
      CALL FVOXXX(W(1,4   ),W(1,1   ),GWF ,ZERO    ,ZERO    ,W(1,64  ))    
      CALL JIOXXX(W(1,5   ),W(1,64  ),GWF ,WMASS   ,WWIDTH  ,W(1,65  ))    
      CALL FVOXXX(W(1,2   ),W(1,65  ),GWF ,ZERO    ,ZERO    ,W(1,66  ))    
      CALL IOVXXX(W(1,3   ),W(1,66  ),W(1,32  ),GWF ,AMP(67  ))            
      CALL FVOXXX(W(1,64  ),W(1,14  ),GZN ,ZERO    ,ZERO    ,W(1,67  ))    
      CALL JIOXXX(W(1,5   ),W(1,67  ),GWF ,WMASS   ,WWIDTH  ,W(1,68  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,68  ),GWF ,AMP(68  ))            
      CALL JIOXXX(W(1,57  ),W(1,64  ),GWF ,WMASS   ,WWIDTH  ,W(1,69  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,69  ),GWF ,AMP(69  ))            
      CALL JIOXXX(W(1,60  ),W(1,64  ),GWF ,WMASS   ,WWIDTH  ,W(1,70  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,70  ),GWF ,AMP(70  ))            
      CALL JVVXXX(W(1,65  ),W(1,8   ),GWWA ,WMASS   ,WWIDTH  ,W(1,         
     &     71  ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,71  ),GWF ,AMP(71  ))            
      CALL JVVXXX(W(1,65  ),W(1,14  ),GWWZ ,WMASS   ,WWIDTH  ,W(1,         
     &     72  ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,72  ),GWF ,AMP(72  ))            
      CALL IOVXXX(W(1,7   ),W(1,45  ),W(1,65  ),GWF ,AMP(73  ))            
      CALL IOVXXX(W(1,7   ),W(1,46  ),W(1,65  ),GWF ,AMP(74  ))            
      CALL FVOXXX(W(1,6   ),W(1,65  ),GWF ,ZERO    ,ZERO    ,W(1,73  ))    
      CALL IOVXXX(W(1,7   ),W(1,73  ),W(1,14  ),GZN ,AMP(75  ))            
      CALL FVOXXX(W(1,2   ),W(1,35  ),GAL ,ZERO    ,ZERO    ,W(1,74  ))    
      CALL JIOXXX(W(1,30  ),W(1,6   ),GAL ,ZERO    ,ZERO    ,W(1,75  ))    
      CALL IOVXXX(W(1,3   ),W(1,74  ),W(1,75  ),GAL ,AMP(76  ))            
      CALL JIOXXX(W(1,30  ),W(1,6   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,76  ))    
      CALL IOVXXX(W(1,3   ),W(1,74  ),W(1,76  ),GZL ,AMP(77  ))            
      CALL FVOXXX(W(1,2   ),W(1,29  ),GZL ,ZERO    ,ZERO    ,W(1,77  ))    
      CALL IOVXXX(W(1,3   ),W(1,77  ),W(1,75  ),GAL ,AMP(78  ))            
      CALL IOVXXX(W(1,3   ),W(1,77  ),W(1,76  ),GZL ,AMP(79  ))            
      CALL JVVXXX(W(1,32  ),W(1,1   ),GWWA ,ZERO    ,ZERO    ,W(1,         
     &     78  ))                                                          
      CALL IOVXXX(W(1,3   ),W(1,74  ),W(1,78  ),GAL ,AMP(80  ))            
      CALL JVVXXX(W(1,32  ),W(1,1   ),GWWZ ,ZMASS   ,ZWIDTH  ,W(1,         
     &     79  ))                                                          
      CALL IOVXXX(W(1,3   ),W(1,74  ),W(1,79  ),GZL ,AMP(81  ))            
      CALL IOVXXX(W(1,3   ),W(1,77  ),W(1,78  ),GAL ,AMP(82  ))            
      CALL IOVXXX(W(1,3   ),W(1,77  ),W(1,79  ),GZL ,AMP(83  ))            
      CALL FVIXXX(W(1,3   ),W(1,63  ),GZL ,ZERO    ,ZERO    ,W(1,80  ))    
      CALL IOVXXX(W(1,80  ),W(1,2   ),W(1,35  ),GAL ,AMP(84  ))            
      CALL IOVXXX(W(1,80  ),W(1,2   ),W(1,29  ),GZL ,AMP(85  ))            
      CALL IOVXXX(W(1,37  ),W(1,74  ),W(1,1   ),GWF ,AMP(86  ))            
      CALL IOVXXX(W(1,37  ),W(1,77  ),W(1,1   ),GWF ,AMP(87  ))            
      CALL FVIXXX(W(1,3   ),W(1,35  ),GAL ,ZERO    ,ZERO    ,W(1,81  ))    
      CALL IOVXXX(W(1,81  ),W(1,2   ),W(1,75  ),GAL ,AMP(88  ))            
      CALL IOVXXX(W(1,81  ),W(1,2   ),W(1,76  ),GZL ,AMP(89  ))            
      CALL FVIXXX(W(1,3   ),W(1,29  ),GZL ,ZERO    ,ZERO    ,W(1,82  ))    
      CALL IOVXXX(W(1,82  ),W(1,2   ),W(1,75  ),GAL ,AMP(90  ))            
      CALL IOVXXX(W(1,82  ),W(1,2   ),W(1,76  ),GZL ,AMP(91  ))            
      CALL IOVXXX(W(1,81  ),W(1,2   ),W(1,78  ),GAL ,AMP(92  ))            
      CALL IOVXXX(W(1,81  ),W(1,2   ),W(1,79  ),GZL ,AMP(93  ))            
      CALL IOVXXX(W(1,82  ),W(1,2   ),W(1,78  ),GAL ,AMP(94  ))            
      CALL IOVXXX(W(1,82  ),W(1,2   ),W(1,79  ),GZL ,AMP(95  ))            
      CALL FVOXXX(W(1,2   ),W(1,63  ),GZL ,ZERO    ,ZERO    ,W(1,83  ))    
      CALL IOVXXX(W(1,3   ),W(1,83  ),W(1,35  ),GAL ,AMP(96  ))            
      CALL IOVXXX(W(1,3   ),W(1,83  ),W(1,29  ),GZL ,AMP(97  ))            
      CALL FVOXXX(W(1,2   ),W(1,1   ),GWF ,ZERO    ,ZERO    ,W(1,84  ))    
      CALL FVOXXX(W(1,84  ),W(1,29  ),GZN ,ZERO    ,ZERO    ,W(1,85  ))    
      CALL IOVXXX(W(1,3   ),W(1,85  ),W(1,32  ),GWF ,AMP(98  ))            
      CALL JIOXXX(W(1,3   ),W(1,84  ),GWF ,WMASS   ,WWIDTH  ,W(1,86  ))    
      CALL FVOXXX(W(1,4   ),W(1,86  ),GWF ,ZERO    ,ZERO    ,W(1,87  ))    
      CALL JIOXXX(W(1,5   ),W(1,87  ),GWF ,WMASS   ,WWIDTH  ,W(1,88  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,88  ),GWF ,AMP(99  ))            
      CALL IOVXXX(W(1,81  ),W(1,84  ),W(1,32  ),GWF ,AMP(100 ))            
      CALL IOVXXX(W(1,82  ),W(1,84  ),W(1,32  ),GWF ,AMP(101 ))            
      CALL JVVXXX(W(1,86  ),W(1,35  ),GWWA ,WMASS   ,WWIDTH  ,W(1,         
     &     89  ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,89  ),GWF ,AMP(102 ))            
      CALL JVVXXX(W(1,86  ),W(1,29  ),GWWZ ,WMASS   ,WWIDTH  ,W(1,         
     &     90  ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,90  ),GWF ,AMP(103 ))            
      CALL FVOXXX(W(1,6   ),W(1,86  ),GWF ,ZERO    ,ZERO    ,W(1,91  ))    
      CALL IOVXXX(W(1,7   ),W(1,91  ),W(1,29  ),GZN ,AMP(104 ))            
      CALL IOVXXX(W(1,7   ),W(1,49  ),W(1,86  ),GWF ,AMP(105 ))            
      CALL IOVXXX(W(1,7   ),W(1,50  ),W(1,86  ),GWF ,AMP(106 ))          
      if (NW.eq.0) then 
      zzw(mu) =    -AMP(   1)-AMP(   2)-AMP(   3)-AMP(   4)-AMP(   5)
     &             -AMP(   6)-AMP(   7)-AMP(   8)-AMP(   9)-AMP(  10)
     &             -AMP(  11)-AMP(  12)-AMP(  13)-AMP(  14)-AMP(  15)
     &             -AMP(  16)-AMP(  17)-AMP(  18)-AMP(  19)-AMP(  20)
     &             -AMP(  21)-AMP(  22)-AMP(  23)-AMP(  24)-AMP(  25)
     &             -AMP(  26)-AMP(  27)-AMP(  28)-AMP(  29)-AMP(  30)
     &             -AMP(  31)-AMP(  32)-AMP(  33)-AMP(  34)-AMP(  35)
     &             -AMP(  36)-AMP(  37)-AMP(  38)-AMP(  39)-AMP(  40)
     &             -AMP(  41)-AMP(  42)-AMP(  43)-AMP(  44)-AMP(  45)
     &             -AMP(  46)-AMP(  47)-AMP(  48)-AMP(  49)-AMP(  50)
     &             -AMP(  51)-AMP(  52)-AMP(  53)-AMP(  54)-AMP(  55)
     &             -AMP(  56)-AMP(  57)-AMP(  58)-AMP(  59)-AMP(  60)
     &             -AMP(  61)-AMP(  62)-AMP(  63)-AMP(  64)-AMP(  65)
     &             -AMP(  66)-AMP(  67)-AMP(  68)-AMP(  69)-AMP(  70)
     &             -AMP(  71)-AMP(  72)-AMP(  73)-AMP(  74)-AMP(  75)
     &             -AMP(  76)-AMP(  77)-AMP(  78)-AMP(  79)-AMP(  80)
     &             -AMP(  81)-AMP(  82)-AMP(  83)-AMP(  84)-AMP(  85)
     &             -AMP(  86)-AMP(  87)-AMP(  88)-AMP(  89)-AMP(  90)
     &             -AMP(  91)-AMP(  92)-AMP(  93)-AMP(  94)-AMP(  95)
     &             -AMP(  96)-AMP(  97)-AMP(  98)-AMP(  99)-AMP( 100)
     &             -AMP( 101)-AMP( 102)-AMP( 103)-AMP( 104)-AMP( 105)
     &             -AMP( 106) 
      else if (NW.eq.1) then
         zzw(mu) = -AMP(  14) !H -> ZZ
     &             -AMP(  56)-AMP(  44)-AMP(  28)
      endif
      enddo
      zzw(4) = dcmplx(q(0),q(3))
      zzw(5) = dcmplx(q(1),q(2))

      END

c ----------------------------------------------------------------------
