      subroutine WWtoHH(Q1,Q2,P,aa)
C  
C Generated by MadGraph II                                              
C RETURNS AMPLITUDE SQUARED SUMMED/AVG OVER COLORS
C AND HELICITIES
C FOR THE POINT IN PHASE SPACE P(0:3,NEXTERNAL)
C  
C FOR PROCESS : w+ w- -> h h  
C  
      IMPLICIT NONE
C  
C CONSTANTS
C  
      INTEGER    NGRAPHS
      PARAMETER (NGRAPHS=  4) 
      INTEGER    NWAVEFUNCS
      PARAMETER (NWAVEFUNCS=  7) 
      REAL*8     ZERO
      PARAMETER (ZERO=0D0)
C  
C ARGUMENTS 
C  
      REAL*8 Q1(0:3), Q2(0:3), P(0:3,3:4)
      complex*16 aa(0:3,0:3)
C  
C LOCAL VARIABLES 
C  
      INTEGER I,J, MU, NU
      COMPLEX*16 AMP(NGRAPHS)
      COMPLEX*16 W(6,NWAVEFUNCS),WX1(6),WX2(6)
      INTEGER NHEL(3:4), ihel
      DATA (NHEL(IHEL),IHEL=3,4) / +1,+1/ ! do not care
      Save NHEL
c  lepton spinors and W+- polarization vectors
#include "tensor.inc"

      logical lswitch
      parameter (lswitch=.true.)
C  
C GLOBAL VARIABLES
C  
#include "VBFNLO/utilities/coupl.inc"
C                                                                          
C ----------
C BEGIN CODE
C ----------
      if (lswitch) then      ! read in lepton and W states from common block
         do i=1,6
            w(i,3) = wp(i)
            w(i,4) = wm(i)
         enddo
      endif

      DO MU = 0,3
         DO NU = 0,3
            CALL VCARTX(Q1(0),WMASS ,WWIDTH, MU,-1,W(1,1   ))        
            CALL VCARTX(Q2(0),WMASS ,WWIDTH, NU,-1,W(1,2   )) 
            if (.not.lswitch) then
               CALL SXXXXX(P(0,3   ),1,W(1,3   ))
               CALL SXXXXX(P(0,4   ),1,W(1,4   ))
            endif
            
            CALL JVSXXX(W(1,2   ),W(1,3   ),GWWH ,WMASS   ,WWIDTH  ,W(1,         
     &           5   ))                                                          
            CALL VVSXXX(W(1,1   ),W(1,5   ),W(1,4   ),GWWH ,AMP(1   ))           
            CALL JVSXXX(W(1,1   ),W(1,3   ),GWWH ,WMASS   ,WWIDTH  ,W(1,         
     &           6   ))                                                          
            CALL VVSXXX(W(1,6   ),W(1,2   ),W(1,4   ),GWWH ,AMP(2   ))           
            CALL HVVXXX(W(1,1   ),W(1,2   ),GWWH ,HMASS   ,HWIDTH  ,W(1,         
     &           7   ))                                                          
            CALL SSSXXX(W(1,4   ),W(1,3   ),W(1,7   ),GHHH ,AMP(3   ))           
            CALL VVSSXX(W(1,1   ),W(1,2   ),W(1,3   ),W(1,4   ),GWWHH ,          
     &           AMP(4   ))                                                      
            
            AA(MU,NU)  = +AMP(   1)+AMP(   2)+AMP(   3)+AMP(   4)
         enddo
      enddo
      END


      subroutine ZZtoHH(Q1,Q2,P,aa)
C  
C Generated by MadGraph II                                              
C RETURNS AMPLITUDE SQUARED SUMMED/AVG OVER COLORS
C AND HELICITIES
C FOR THE POINT IN PHASE SPACE P(0:3,NEXTERNAL)
C  
C FOR PROCESS : z z -> h h  
C  
      IMPLICIT NONE
C  
C CONSTANTS
C  
      INTEGER    NGRAPHS
      PARAMETER (NGRAPHS=  4) 
      INTEGER    NWAVEFUNCS
      PARAMETER (NWAVEFUNCS=  7) 
      REAL*8     ZERO
      PARAMETER (ZERO=0D0)
C  
C ARGUMENTS 
C  
      REAL*8 Q1(0:3), Q2(0:3), P(0:3,3:4)
      complex*16 aa(0:3,0:3)
C  
C LOCAL VARIABLES 
C  
      INTEGER I,J, MU, NU
      COMPLEX*16 AMP(NGRAPHS)
      COMPLEX*16 W(6,NWAVEFUNCS),WX1(6),WX2(6)
      INTEGER NHEL(3:4), ihel
      DATA (NHEL(IHEL),IHEL=3,4) / +1,+1/ ! do not care
      Save NHEL
c  lepton spinors and Z polarization vectors
#include "tensor.inc"

      logical lswitch
      parameter (lswitch=.true.)
C  
C GLOBAL VARIABLES
C  
#include "VBFNLO/utilities/coupl.inc"
C                                                                          
C ----------
C BEGIN CODE
C ----------
      if (lswitch) then      ! read in lepton and Z states from common block
         do i=1,6
            w(i,3) = wp(i)
            w(i,4) = wm(i)
         enddo
      endif

      DO MU = 0,3
         DO NU = 0,3
            CALL VCARTX(Q1(0),ZMASS ,ZWIDTH, MU,-1,W(1,1   ))        
            CALL VCARTX(Q2(0),ZMASS ,ZWIDTH, NU,-1,W(1,2   )) 
            if (.not.lswitch) then
               CALL SXXXXX(P(0,3   ),1,W(1,3   ))                         
               CALL SXXXXX(P(0,4   ),1,W(1,4   ))   
            endif
            
            CALL JVSXXX(W(1,2   ),W(1,3   ),GZZH ,ZMASS   ,ZWIDTH  ,W(1,         
     &           5   ))                                                          
            CALL VVSXXX(W(1,1   ),W(1,5   ),W(1,4   ),GZZH ,AMP(1   ))           
            CALL JVSXXX(W(1,1   ),W(1,3   ),GZZH ,ZMASS   ,ZWIDTH  ,W(1,         
     &           6   ))                                                          
            CALL VVSXXX(W(1,2   ),W(1,6   ),W(1,4   ),GZZH ,AMP(2   ))           
            CALL HVVXXX(W(1,1   ),W(1,2   ),GZZH ,HMASS   ,HWIDTH  ,W(1,         
     &           7   ))                                                          
            CALL SSSXXX(W(1,4   ),W(1,3   ),W(1,7   ),GHHH ,AMP(3   ))           
            CALL VVSSXX(W(1,1   ),W(1,2   ),W(1,3   ),W(1,4   ),GZZHH ,          
     &           AMP(4   ))                          
                          
            AA(MU,NU)  = +AMP(   1)+AMP(   2)+AMP(   3)+AMP(   4)
         enddo
      enddo
      END

