      subroutine vwmtowma_anomal(q1,q2,P,h,zwtowa1,awtowa1)
      
      IMPLICIT NONE

      REAL*8 Q1(0:3), Q2(0:3), P(0:3,3:5)
      complex*16 zwtowa1(0:3,0:3), awtowa1(0:3,0:3)
      integer lsign(3:6,2),ll,mu,nu,h
      

!     possible lepton helicities:
      data (lsign(ll,1),ll=3,5) /  -1,  -1, -1/ !h=1
      data (lsign(ll,2),ll=3,5) /  -1,  -1,  1/ !h=2

!     helicity combi nr.h is selected
      
      call awmtowma_anomal(q1,q2,P,lsign(3,h),awtowa1(0,0))
      call zwmtowma_anomal(q1,q2,P,lsign(3,h),zwtowa1(0,0))
	
      end
c------------------------------------------------------------

      subroutine awmtowma_anomal(Q1,Q2,P,lsign,awtowa1)     
C  
C Generated by MadGraph II                                              
C RETURNS AMPLITUDE SQUARED SUMMED/AVG OVER COLORS
C FOR THE POINT WITH EXTERNAL LINES W(0:6,NEXTERNAL)
C  
C FOR PROCESS : a w- -> e- ve~ a  
C  
      IMPLICIT NONE
C  
C CONSTANTS
C  
      INTEGER    NGRAPHS
      PARAMETER (NGRAPHS=   8)
      INTEGER    NWAVEFUNCS   
      PARAMETER (NWAVEFUNCS=  14)
      REAL*8     ZERO
      PARAMETER (ZERO=0D0)
C  
C ARGUMENTS 
C  
      REAL*8 Q1(0:3), Q2(0:3), P(0:3,3:5)
      complex*16 awtowa1(0:3,0:3)
      integer lsign(3:5)
C  
C LOCAL VARIABLES 
C  
      INTEGER I,J,MU,NU
      COMPLEX*16 AMP(NGRAPHS,0:3,0:3)
      COMPLEX*16 W(6,NWAVEFUNCS)


c     lepton spinors and A polarization vector
#include "tensorw.inc"
#include "VBFNLO/utilities/coupl.inc"
 


C ----------
C     BEGIN CODE
C     ----------


      do i=1,6
         w(i,3) = wl(i)
         w(i,4) = wn(i)

         w(i,5) = ea(i)
         w(i,10) = we(i)
      enddo

c$$$         CALL OXXXXX(P(0,3   ),ZERO ,lsign(3   ),+1,W(1,3   ))!e-  
c$$$         CALL IXXXXX(P(0,4   ),ZERO ,-lsign(4   ),-1,W(1,4   ))!ve~  
c$$$         CALL VXXXXX(P(0,5   ),ZERO ,-lsign(5   ),+1,W(1,5   ))!a
c$$$         CALL JIOXXX(W(1,4   ),W(1,3),GWF ,WMASS   ,WWIDTH  ,W(1,10  )) 


      Do MU = 0,3
         Do NU = 0,3

      CALL VCARTX(Q1(0),ZERO,ZERO,MU,-1,W(1,1   ))       
      CALL VCARTX(Q2(0),WMASS,WWIDTH,NU,-1,W(1,2   ))   
        
      CALL FVOXXX(W(1,3   ),W(1,1   ),GAL ,ZERO    ,ZERO    ,W(1,6   ))    
      CALL JIOXXX(W(1,4   ),W(1,6   ),GWF ,WMASS   ,WWIDTH  ,W(1,7   ))    

c      CALL VVVXXX(W(1,7   ),W(1,2   ),W(1,5   ),GWWA ,AMP(1,mu,nu))    
      CALL wwa_anomal3(W(1,7  ),W(1,2  ),W(1,5   ),AMP(1,mu,nu  ))  

      CALL FVIXXX(W(1,4   ),W(1,2   ),GWF ,ZERO    ,ZERO    ,W(1,8   ))    
      CALL FVOXXX(W(1,3   ),W(1,5   ),GAL ,ZERO    ,ZERO    ,W(1,9   ))    
      CALL IOVXXX(W(1,8   ),W(1,9   ),W(1,1   ),GAL ,AMP(2,mu,nu))         
      CALL IOVXXX(W(1,8   ),W(1,6   ),W(1,5   ),GAL ,AMP(3,mu,nu))        

c      CALL JVVXXX(W(1,2   ),W(1,5   ),GWWA ,WMASS   ,WWIDTH  ,W(1,       
c     &     11  ))                                                    
      CALL jwmwpa_anomal3(W(1,2  ),W(1,5  ),W(1,11  ))

c      CALL VVVXXX(W(1,10  ),W(1,11  ),W(1,1   ),GWWA ,AMP(4,mu,nu)) 
      CALL wwa_anomal3(W(1,10  ),W(1,11  ),W(1,1   ),AMP(4,mu,nu  ))  

c      CALL JVVXXX(W(1,2   ),W(1,1   ),GWWA ,WMASS   ,WWIDTH  ,W(1,      
c     &     12  ))                    
      CALL jwmwpa_anomal3(W(1,2  ),W(1,1  ),W(1,12  ))
             
      CALL FVIXXX(W(1,4   ),W(1,12  ),GWF ,ZERO    ,ZERO    ,W(1,13  ))    
      CALL IOVXXX(W(1,13  ),W(1,3   ),W(1,5   ),GAL ,AMP(5,mu,nu))
            
c      CALL JW3WXX(W(1,1   ),W(1,2   ),W(1,5   ),GWWA ,GWWA ,WMASS   ,     
c     &     WWIDTH  ,W(1,14  ))                                            
c      CALL IOVXXX(W(1,4   ),W(1,3   ),W(1,14  ),GWF ,AMP(6,mu,nu))        
      CALL wwaa_anomal4(W(1,10 ), W(1,1 ), W(1,2 ), W(1,5 ), AMP(6,mu,nu))

c      CALL VVVXXX(W(1,10  ),W(1,12  ),W(1,5   ),GWWA ,AMP(7,mu,nu))  
      CALL wwa_anomal3(W(1,10   ),W(1,12  ),W(1,5  ),AMP(7,mu,nu  ))       

c considering anomalous couplings, we get two extra graphs with AZH- and AAH-vertex
      CALL jhww_anomal3(W(1,10   ),W(1,2  ),W(1,14  ))    
      CALL aah_anomal3(W(1,1  ),W(1,5   ),W(1,14  ),AMP(8,mu,nu))  

      awtowa1(MU,NU) = -AMP(1,mu,nu)-AMP(2,mu,nu)-AMP(3,mu,nu)-AMP(4,mu,nu)
     &     -AMP(5,mu,nu)-AMP(6,mu,nu)-AMP(7,mu,nu)
     &     -AMP(8,mu,nu)        !new diagrams with AAH-couplings
c      awtowa1(MU,NU) = - awtowa1(MU,NU)
c      awtowa1(MU,NU) = dcmplx(zero,zero)
         Enddo !NU
      Enddo !MU

      END

c-------------------------------------------------------------
      subroutine zwmtowma_anomal(Q1,Q2,P,lsign,zwtowa1)   
C  
C Generated by MadGraph II                                              
C RETURNS AMPLITUDE SQUARED SUMMED/AVG OVER COLORS
C FOR THE POINT WITH EXTERNAL LINES W(0:6,NEXTERNAL)
C  
C FOR PROCESS : z w- -> e- ve~ a  
C  
      IMPLICIT NONE
C  
C CONSTANTS
C  
      INTEGER    NGRAPHS
      PARAMETER (NGRAPHS=   10) 

      INTEGER    NWAVEFUNCS 
      PARAMETER (NWAVEFUNCS=  15) 
      REAL*8     ZERO
      PARAMETER (ZERO=0D0)
C  
C ARGUMENTS 
C     
      external dotrr
      double precision Q1(0:3), Q2(0:3), P(0:3,3:5),dotrr,m2
      complex*16 zwtowa1(0:3,0:3)
      integer lsign(3:5)
      double complex ratio
C  
C LOCAL VARIABLES 
C  
      INTEGER I,J,MU,NU
      COMPLEX*16 AMP(NGRAPHS)
      COMPLEX*16 W(6,NWAVEFUNCS),dummy
c     lepton spinors and A polarization vector
#include "tensorw.inc"
#include "VBFNLO/utilities/coupl.inc"

C                                                                          
C ----------
C BEGIN CODE
C     ----------


      do i=1,6
         w(i,3) = wl(i)
         w(i,4) = wn(i)

         w(i,5) = ea(i)
         w(i,12) = we(i)
      enddo

c$$$         CALL OXXXXX(P(0,3   ),ZERO ,lsign(3   ),+1,W(1,3   )) !e-
c$$$         CALL IXXXXX(P(0,4   ),ZERO ,-lsign(4   ),-1,W(1,4   )) !ve~  
c$$$         CALL VXXXXX(P(0,5   ),ZERO ,lsign(5   ),+1,W(1,5   )) !a
c$$$         CALL JIOXXX(W(1,4   ),W(1,3 ),GWF ,WMASS   ,WWIDTH  ,W(1,12  ))

c      m2 = dotrr(q1,q1)
c      ratio = m2/(dcmplx( m2-zmass**2, zmass*zwidth ))
      
      Do MU = 0,3
         Do NU = 0,3
      CALL VCARTX(Q1(0),ZMASS,ZWIDTH,MU,-1,W(1,1   ))       
      CALL VCARTX(Q2(0),WMASS,WWIDTH,NU,-1,W(1,2   )) 
      
      CALL FVIXXX(W(1,4   ),W(1,1   ),GZN ,ZERO    ,ZERO    ,W(1,6   ))   
 
c     CALL JVVXXX(W(1,2   ),W(1,5   ),GWWA ,WMASS   ,WWIDTH  ,W(1,         
c    &     7   ))                        
      CALL jwmwpa_anomal3(W(1,2  ),W(1,5  ),W(1,7  ))             
 
      CALL IOVXXX(W(1,6   ),W(1,3   ),W(1,7   ),GWF ,AMP(1   ))            
      CALL FVOXXX(W(1,3   ),W(1,5   ),GAL ,ZERO    ,ZERO    ,W(1,8   ))    
      CALL IOVXXX(W(1,6   ),W(1,8   ),W(1,2   ),GWF ,AMP(2   ))    
      CALL FVOXXX(W(1,3   ),W(1,1   ),GZL ,ZERO    ,ZERO    ,W(1,9   ))    
      CALL JIOXXX(W(1,4   ),W(1,9   ),GWF ,WMASS   ,WWIDTH  ,W(1,10  ))    

c      CALL VVVXXX(W(1,10  ),W(1,2   ),W(1,5   ),GWWA ,AMP(3   ))  
      CALL wwa_anomal3(W(1,10   ),W(1,2  ),W(1,5  ),AMP(3  )) 

      CALL FVIXXX(W(1,4   ),W(1,2   ),GWF ,ZERO    ,ZERO    ,W(1,11  ))    
      CALL IOVXXX(W(1,11  ),W(1,8   ),W(1,1   ),GZL ,AMP(4   ))       
      CALL IOVXXX(W(1,11  ),W(1,9   ),W(1,5   ),GAL ,AMP(5   ))            

c      CALL VVVXXX(W(1,12  ),W(1,7   ),W(1,1   ),GWWZ ,AMP(6   ))
      CALL wwz_anomal3(W(1,12   ),W(1,7  ),W(1,1  ),AMP(6  )) 

c      CALL JVVXXX(W(1,2   ),W(1,1   ),GWWZ ,WMASS   ,WWIDTH  ,W(1,     
c     &     13  ))       
      CALL jwmwpz_anomal3(W(1,2  ),W(1,1  ),W(1,13  ))

      CALL FVIXXX(W(1,4   ),W(1,13  ),GWF ,ZERO    ,ZERO    ,W(1,14  ))    
      CALL IOVXXX(W(1,14  ),W(1,3   ),W(1,5   ),GAL ,AMP(7   ))  

c      CALL JW3WXX(W(1,1   ),W(1,2   ),W(1,5   ),GWWZ ,GWWA ,WMASS   ,     
c     &     WWIDTH  ,W(1,15  ))                                            
c      CALL IOVXXX(W(1,4   ),W(1,3   ),W(1,15  ),GWF ,AMP(8   )) 
      CALL wwza_anomal4(W(1,12 ), W(1,1 ), W(1,2 ), W(1,5 ), AMP(8))

c      CALL VVVXXX(W(1,12  ),W(1,13  ),W(1,5   ),GWWA ,AMP(9   )) 
      CALL wwa_anomal3(W(1,12   ),W(1,13  ),W(1,5  ),AMP(9  )) 
          
c considering anomalous couplings, we get an extra graph with a AZH-vertex
      CALL jhww_anomal3(W(1,12   ),W(1,2  ),W(1,15  ))  
      CALL azh_anomal3(W(1,5  ),W(1,1   ),W(1,15  ),AMP(10  ))  

      zwtowa1(MU,NU) = -AMP(   1)-AMP(   2)-AMP(   3)-AMP(   4)
     &     -AMP(   5) -AMP(   6)-AMP(   7)-AMP(   8)-AMP(   9)
     &     -AMP(   10)          !new diagrams with AZH-couplings
c      zwtowa1(MU,NU) = -zwtowa1(MU,NU)
c      zwtowa1(MU,NU) = dcmplx(zero,zero)
         Enddo !NU
      Enddo !MU
C      CALL GAUGECHECK(JAMP,ZTEMP,EIGEN_VEC,EIGEN_VAL,NCOLOR,NEIGEN) 
      END
       
       

c------------------------------------------------------------
      subroutine wmtowma_anomal(P,V,h,wtowa1)
C  
C Generated by MadGraph II                                              
C RETURNS AMPLITUDE SQUARED SUMMED/AVG OVER COLORS
C FOR THE POINT WITH EXTERNAL LINES W(0:6,NEXTERNAL)
C  
C FOR PROCESS : w- -> e- ve~ a  
C  
      IMPLICIT NONE
C  
C CONSTANTS
C  
      INTEGER    NGRAPHS,    NEIGEN 
      PARAMETER (NGRAPHS=   2,NEIGEN=  1) 
      INTEGER    NWAVEFUNCS     , NCOLOR
      PARAMETER (NWAVEFUNCS=   6, NCOLOR=   1) 
      REAL*8     ZERO
      PARAMETER (ZERO=0D0)
C  
C ARGUMENTS 
C  
      REAL*8 V(0:3,3:5), P(0:3), q(0:3)
      complex*16 wtowa1(0:5)
      integer h
C  
C LOCAL VARIABLES 
C  
      INTEGER I,J,MU,NU,lsign(3:5)
      COMPLEX*16 AMP(NGRAPHS)
      COMPLEX*16 W(6,NWAVEFUNCS)                            

c     lepton spinors and A polarization vector
#include "tensorw.inc"
#include "VBFNLO/utilities/coupl.inc"
C                                                                          
C ----------
C BEGIN CODE
C ----------



      do i=1,6
         w(i,2) = wl(i)
         w(i,3) = wn(i)
         w(i,4) = ea(i)
         w(i,5) = we(i)
      enddo

c$$$         lsign(3) = -1
c$$$         lsign(4) = -1
c$$$         lsign(5) = (-1)**h
c$$$
c$$$         CALL OXXXXX(V(0,3   ),ZERO ,lsign(3   ),+1,W(1,2   )) !e-
c$$$         CALL IXXXXX(V(0,4   ),ZERO ,-lsign(4   ),-1,W(1,3   )) !ve!  
c$$$         CALL VXXXXX(V(0,5   ),ZERO ,lsign(5   ),+1,W(1,4   )) !a
c$$$         CALL JIOXXX(W(1,3   ),W(1,2   ),GWF ,WMASS   ,WWIDTH  ,W(1,5))

      
      do mu = 0,3
         CALL VCARTX(P(0   ),WMASS ,WWIDTH,MU,-1,W(1,1   ))  

c         CALL VVVXXX(W(1,5   ),W(1,1   ),W(1,4   ),GWWA ,AMP(1   ))      
         CALL wwa_anomal3(W(1,5   ),W(1,1  ),W(1,4  ),AMP(1  )) 

         CALL FVIXXX(W(1,3   ),W(1,1   ),GWF ,ZERO    ,ZERO    ,W(1,6 ))  
         CALL IOVXXX(W(1,6   ),W(1,2   ),W(1,4   ),GAL ,AMP(2   ))         
         wtowa1(mu) = -AMP(   1)-AMP(   2)
c         wtowa1(mu) = -wtowa1(mu) 
c         wtowa1(mu) = dcmplx(zero,zero)
c$$$  print*,"w1",(w(i,1),i=1,6)
c$$$  c         print*,"w2",(w(i,2),i=1,6)
c$$$  print*,"w3",(w(i,3),i=1,6)
c$$$  c         print*,"w5",(w(i,5),i=1,6)
c$$$  print*,"w6",(w(i,6),i=1,6)
c$$$  print*,"amp2",-AMP(   2)

      enddo
      wtowa1(4) = dcmplx(p(0),p(3))
      wtowa1(5) = dcmplx(p(1),p(2))
c      wtowa1(4) = dcmplx(zero,zero)
c      wtowa1(5) = dcmplx(zero,zero)
C     CALL GAUGECHECK(JAMP,ZTEMP,EIGEN_VEC,EIGEN_VAL,NCOLOR,NEIGEN) 
      END
      

c------------------------------------------------------------

      subroutine vwptowpa_anomal(q1,q2,P,h,zwtowa1,awtowa1)
      
      IMPLICIT NONE

      REAL*8 Q1(0:3), Q2(0:3), P(0:3,3:5)
      complex*16 zwtowa1(0:3,0:3), awtowa1(0:3,0:3)
      integer lsign(3:5,2),ll,mu,nu,h
      

!     possible lepton helicities:
      data (lsign(ll,1),ll=3,5) /  -1,  -1, -1/ !h=1
      data (lsign(ll,2),ll=3,5) /  -1,  -1,  1/ !h=2

!     helicity combi nr.h is selected
      
      call awptowpa_anomal(q1,q2,P,lsign(3,h),awtowa1(0,0))
      call zwptowpa_anomal(q1,q2,P,lsign(3,h),zwtowa1(0,0))
     
      end


c-------------------------------------------------------------------
       
      subroutine awptowpa_anomal(Q1,Q2,P,lsign,awtowa1)     
C  
C Generated by MadGraph II                                              
C RETURNS AMPLITUDE SQUARED SUMMED/AVG OVER COLORS
C FOR THE POINT WITH EXTERNAL LINES W(0:6,NEXTERNAL)
C  
C FOR PROCESS : a w+ -> e+ ve a  
C  
      IMPLICIT NONE  

C  
C CONSTANTS
C  
      INTEGER    NGRAPHS 
      PARAMETER (NGRAPHS=   8) 
      INTEGER    NWAVEFUNCS   
      PARAMETER (NWAVEFUNCS=  14) 
      REAL*8     ZERO
      PARAMETER (ZERO=0D0)
C  
C ARGUMENTS 
C  
      REAL*8 Q1(0:3), Q2(0:3), P(0:3,3:5)
      complex*16 awtowa1(0:3,0:3)
      integer lsign(3:5)
C  
C LOCAL VARIABLES 
C  
      INTEGER I,J,MU,NU
      COMPLEX*16 AMP(NGRAPHS,0:3,0:3)
      COMPLEX*16 W(6,NWAVEFUNCS)
C  
C GLOBAL VARIABLES
C  
c  lepton spinors and A polarization vector
#include "tensorw.inc"
#include "VBFNLO/utilities/coupl.inc"
 
C ----------
C BEGIN CODE
C ----------


      do i=1,6
         w(i,3) = wl(i)
         w(i,4) = wn(i)

         w(i,5) = ea(i)
         w(i,10) = we(i)
      enddo

c$$$         CALL IXXXXX(P(0,3   ),ZERO ,-lsign(3   ),-1,W(1,3   ))	!e+        
c$$$         CALL OXXXXX(P(0,4   ),ZERO ,lsign(4   ),+1,W(1,4   )) !ve
c$$$
c$$$         CALL VXXXXX(P(0,5   ),ZERO ,-lsign(5   ),+1,W(1,5   ))	!a
c$$$         CALL JIOXXX(W(1,3   ),W(1,4   ),GWF ,WMASS   ,WWIDTH  ,W(1,10)) 


      Do MU = 0,3
         Do NU = 0,3

      CALL VCARTX(Q1(0),ZERO,ZERO,MU,-1,W(1,1   ))       
      CALL VCARTX(Q2(0),WMASS,WWIDTH,NU,-1,W(1,2   ))     
      
      CALL FVIXXX(W(1,3   ),W(1,1   ),GAL ,ZERO    ,ZERO    ,W(1,6   ))    
      CALL JIOXXX(W(1,6   ),W(1,4   ),GWF ,WMASS   ,WWIDTH  ,W(1,7   ))    

c      CALL VVVXXX(W(1,2   ),W(1,7   ),W(1,5   ),GWWA ,AMP(1,mu,nu))  
      CALL wwa_anomal3(W(1,2   ),W(1,7  ),W(1,5  ),AMP(1,mu,nu  ))      

      CALL FVOXXX(W(1,4   ),W(1,2   ),GWF ,ZERO    ,ZERO    ,W(1,8   ))    
      CALL FVIXXX(W(1,3   ),W(1,5   ),GAL ,ZERO    ,ZERO    ,W(1,9   ))    
      CALL IOVXXX(W(1,9   ),W(1,8   ),W(1,1   ),GAL ,AMP(2,mu,nu))        
      CALL IOVXXX(W(1,6   ),W(1,8   ),W(1,5   ),GAL ,AMP(3,mu,nu))         

c      CALL JVVXXX(W(1,5   ),W(1,2   ),GWWA ,WMASS   ,WWIDTH  ,W(1,        
c     &     11  ))                                                        
      CALL jwpawm_anomal3(W(1,5   ),W(1,2  ),W(1,11  ))  

c      CALL VVVXXX(W(1,11  ),W(1,10  ),W(1,1   ),GWWA ,AMP(4,mu,nu))     
      CALL wwa_anomal3(W(1,11  ),W(1,10  ),W(1,1   ),AMP(4,mu,nu))
   
c      CALL JVVXXX(W(1,1   ),W(1,2   ),GWWA ,WMASS   ,WWIDTH  ,W(1,        
c     &     12  ))                                                         
      CALL jwpawm_anomal3(W(1,1   ),W(1,2  ),W(1,12  ))

      CALL FVOXXX(W(1,4   ),W(1,12  ),GWF ,ZERO    ,ZERO    ,W(1,13  ))    
      CALL IOVXXX(W(1,3   ),W(1,13  ),W(1,5   ),GAL ,AMP(5,mu,nu))   
      
c      CALL JW3WXX(W(1,1   ),W(1,2   ),W(1,5   ),GWWA ,GWWA ,WMASS   ,     
c     &     WWIDTH  ,W(1,14  ))                                            
c      CALL IOVXXX(W(1,3   ),W(1,4   ),W(1,14  ),GWF ,AMP(6,mu,nu))   
      CALL wwaa_anomal4(W(1,2 ), W(1,1 ), W(1,10 ), W(1,5 ), AMP(6,mu,nu))

c      CALL VVVXXX(W(1,12  ),W(1,10  ),W(1,5   ),GWWA ,AMP(7,mu,nu))  
      CALL wwa_anomal3(W(1,12   ),W(1,10  ),W(1,5  ),AMP(7,mu,nu  )) 
        
c considering anomalous couplings, we an extra graphs with a AAH-vertex
      CALL jhww_anomal3(W(1,2   ),W(1,10  ),W(1,14  ))    
      CALL aah_anomal3(W(1,1  ),W(1,5   ),W(1,14  ),AMP(8,mu,nu  ))  

      awtowa1(MU,NU) = +AMP(1,mu,nu)+AMP(2,mu,nu)+AMP(3,mu,nu)+AMP(4,mu,nu)
     &     +AMP(5,mu,nu)+AMP(6,mu,nu)+AMP(7,mu,nu)
     &     +AMP(8,mu,nu)        !new diagrams with AAH-couplings
c      awtowa1(MU,NU) = dcmplx(zero,zero)
         Enddo !NU
      Enddo !MU
C      CALL GAUGECHECK(JAMP,ZTEMP,EIGEN_VEC,EIGEN_VAL,NCOLOR,NEIGEN) 
      END

c---------------------------------------------------------------------

      subroutine zwptowpa_anomal(Q1,Q2,P,lsign,zwtowa1)    
C  
C Generated by MadGraph II                                              
C RETURNS AMPLITUDE SQUARED SUMMED/AVG OVER COLORS
C FOR THE POINT WITH EXTERNAL LINES W(0:6,NEXTERNAL)
C  
C FOR PROCESS : z w+ -> e+ ve a  
C  
      IMPLICIT NONE
C  
C CONSTANTS
C  
      INTEGER    NGRAPHS 
      PARAMETER (NGRAPHS=   10) 
      INTEGER    NWAVEFUNCS   
      PARAMETER (NWAVEFUNCS=  15 ) 
      REAL*8     ZERO
      PARAMETER (ZERO=0D0)
C  
C ARGUMENTS 
C  
      external dotrr
      double precision Q1(0:3), Q2(0:3), P(0:3,3:5),dotrr,m2
      complex*16 zwtowa1(0:3,0:3)
      integer lsign(3:5)
C  
C LOCAL VARIABLES 
C  
      INTEGER I,J,MU,NU
      COMPLEX*16 AMP(NGRAPHS)
      COMPLEX*16 W(6,NWAVEFUNCS)
      double complex ratio
C  
C GLOBAL VARIABLES
C  
c  lepton spinors and A polarization vector
#include "tensorw.inc"
#include "VBFNLO/utilities/coupl.inc"

C                                                                          
C ----------
C BEGIN CODE
C ----------

      do i=1,6
         w(i,3) = wl(i)
         w(i,4) = wn(i)

         w(i,5) = ea(i)
         w(i,12) = we(i)
      enddo

c$$$         CALL IXXXXX(P(0,3   ),ZERO ,-lsign(3   ),-1,W(1,3   ))	!e+ 
c$$$         CALL OXXXXX(P(0,4   ),ZERO ,lsign(4   ),+1,W(1,4   )) !ve
c$$$
c$$$         CALL VXXXXX(P(0,5   ),ZERO ,-lsign(5   ),+1,W(1,5   ))	!a
c$$$         CALL JIOXXX(W(1,3   ),W(1,4 ),GWF ,WMASS   ,WWIDTH  ,W(1,12  ))



      Do MU = 0,3
         Do NU = 0,3

      CALL VCARTX(Q1(0),ZMASS,ZWIDTH,MU,-1,W(1,1   ))       
      CALL VCARTX(Q2(0),WMASS,WWIDTH,NU,-1,W(1,2   )) 

      CALL FVOXXX(W(1,4   ),W(1,1   ),GZN ,ZERO    ,ZERO    ,W(1,6   ))    

c      CALL JVVXXX(W(1,5   ),W(1,2   ),GWWA ,WMASS   ,WWIDTH  ,W(1,  
c     &     7   ))                   
      CALL jwpawm_anomal3(W(1,5   ),W(1,2  ),W(1,7  ))        

      CALL IOVXXX(W(1,3   ),W(1,6   ),W(1,7   ),GWF ,AMP(1   ))            
      CALL FVIXXX(W(1,3   ),W(1,5   ),GAL ,ZERO    ,ZERO    ,W(1,8   ))    
      CALL IOVXXX(W(1,8   ),W(1,6   ),W(1,2   ),GWF ,AMP(2   ))   
      CALL FVIXXX(W(1,3   ),W(1,1   ),GZL ,ZERO    ,ZERO    ,W(1,9   ))    
      CALL JIOXXX(W(1,9   ),W(1,4   ),GWF ,WMASS   ,WWIDTH  ,W(1,10  ))    

c      CALL VVVXXX(W(1,2   ),W(1,10  ),W(1,5   ),GWWA ,AMP(3   ))   s
      CALL wwa_anomal3(W(1,2   ),W(1,10  ),W(1,5  ),AMP(3  ))  
        
      CALL FVOXXX(W(1,4   ),W(1,2   ),GWF ,ZERO    ,ZERO    ,W(1,11  ))    
      CALL IOVXXX(W(1,8   ),W(1,11  ),W(1,1   ),GZL ,AMP(4   )) 
      CALL IOVXXX(W(1,9   ),W(1,11  ),W(1,5   ),GAL ,AMP(5   ))         

c      CALL VVVXXX(W(1,7   ),W(1,12  ),W(1,1   ),GWWZ ,AMP(6   ))  
      CALL wwz_anomal3(W(1,7   ),W(1,12  ),W(1,1  ),AMP(6  ))  
         
c      CALL JVVXXX(W(1,1   ),W(1,2   ),GWWZ ,WMASS   ,WWIDTH  ,W(1,      
c     &     13  )) 
      CALL jwpzwm_anomal3(W(1,1   ),W(1,2  ),W(1,13  ))   
                                                         
      CALL FVOXXX(W(1,4   ),W(1,13  ),GWF ,ZERO    ,ZERO    ,W(1,14  ))    
      CALL IOVXXX(W(1,3   ),W(1,14  ),W(1,5   ),GAL ,AMP(7   ))   

c      CALL JW3WXX(W(1,1   ),W(1,2   ),W(1,5   ),GWWA ,GWWZ ,WMASS   ,     
c     &     WWIDTH  ,W(1,15  ))                                            
c      CALL IOVXXX(W(1,3   ),W(1,4   ),W(1,15  ),GWF ,AMP(8   ))   
      CALL wwza_anomal4(W(1,2 ), W(1,1 ), W(1,12 ), W(1,5 ), AMP(8))

c      CALL VVVXXX(W(1,13  ),W(1,12  ),W(1,5   ),GWWA ,AMP(9   )) 
      CALL wwa_anomal3(W(1,13   ),W(1,12  ),W(1,5  ),AMP(9  ))  
      
c considering anomalous couplings, we an extra graphs with a AAH-vertex
      CALL jhww_anomal3(W(1,2   ),W(1,12  ),W(1,15  ))    
      CALL azh_anomal3(W(1,5  ),W(1,1   ),W(1,15  ),AMP(10  ))

      zwtowa1(MU,NU) = +AMP(   1)+AMP(   2)+AMP(   3)+AMP(   4)+AMP(   5)
     &     +AMP(   6)+AMP(   7)+AMP(   8)+AMP(   9)
     &     +AMP(10 )            !new diagrams with AAH-couplings
c      zwtowa1(MU,NU) = dcmplx(zero,zero)
         Enddo !NU
      Enddo !MU
C      CALL GAUGECHECK(JAMP,ZTEMP,EIGEN_VEC,EIGEN_VAL,NCOLOR,NEIGEN) 
      END
c------------------------------------------------------------------------

       
      subroutine wptowpa_anomal(P,V,h,wtowa1)
C  
C Generated by MadGraph II                                              
C RETURNS AMPLITUDE SQUARED SUMMED/AVG OVER COLORS
C FOR THE POINT WITH EXTERNAL LINES W(0:6,NEXTERNAL)
C  
C FOR PROCESS : w+ -> w+ a  
C  
      IMPLICIT NONE
C  
C CONSTANTS
C  
      INTEGER    NGRAPHS 
      PARAMETER (NGRAPHS=   2) 
      INTEGER    NWAVEFUNCS  
      PARAMETER (NWAVEFUNCS=   6) 
      REAL*8     ZERO
      PARAMETER (ZERO=0D0)

C  
C ARGUMENTS 
C  
      REAL*8 V(0:3,3:5), P(0:3), q(0:3)
      complex*16 wtowa1(0:5)
      integer h
C  
C LOCAL VARIABLES 
C  
      INTEGER I,J,MU,NU,lsign(3:5)
      COMPLEX*16 AMP(NGRAPHS)
      COMPLEX*16 W(6,NWAVEFUNCS)

c  lepton spinors and A polarization vector
#include "tensorw.inc"
#include "VBFNLO/utilities/coupl.inc"
                                
C                                                                          
C ----------
C BEGIN CODE
C ----------



      do i=1,6
         w(i,2) = wl(i)
         w(i,3) = wn(i)
         w(i,4) = ea(i)
         w(i,5) = we(i)
      enddo

c$$$         lsign(3) = -1
c$$$         lsign(4) = -1
c$$$         lsign(5) = (-1)**h
c$$$
c$$$         CALL IXXXXX(V(0,3   ),ZERO ,-lsign(3   ),-1,W(1,2   ))	!e+        
c$$$         CALL OXXXXX(V(0,4   ),ZERO ,lsign(4   ),+1,W(1,3   )) !ve
c$$$         CALL VXXXXX(V(0,5   ),ZERO ,-lsign(5   ),+1,W(1,4   ))	!a
c$$$         CALL JIOXXX(W(1,2   ),W(1,3   ),GWF ,WMASS   ,WWIDTH  ,W(1,5   ))



      DO MU = 0,3
         CALL VCARTX(P(0),WMASS,WWIDTH,MU,-1,W(1,1   ))  
c         CALL VVVXXX(W(1,1   ),W(1,5   ),W(1,4   ),GWWA ,AMP(1   ))
         CALL wwa_anomal3(W(1,1   ),W(1,5  ),W(1,4  ),AMP(1  ))    
         CALL FVOXXX(W(1,3   ),W(1,1   ),GWF ,ZERO    ,ZERO    ,W(1,6   )) 
         CALL IOVXXX(W(1,2   ),W(1,6   ),W(1,4   ),GAL ,AMP(2   ))
         
         wtowa1(MU) = +AMP(   1)+AMP(   2)
      ENDDO !MU
      wtowa1(4) = dcmplx(p(0),p(3))
      wtowa1(5) = dcmplx(p(1),p(2))
C      CALL GAUGECHECK(JAMP,ZTEMP,EIGEN_VEC,EIGEN_VAL,NCOLOR,NEIGEN) 
      END

c-----------------------------------------------------------------------
       
      subroutine calc_wwtoa_anomal(idb,iu,Q,P,wwtoa1)
C  Input:   Q(*)        one of the two incoming boson momenta 
c           idb = 1      Q = q1 = W+ momentum
c           idb = 2      Q = q2 = W- momentum
c  OUPTPUT: wwtoa1(mu,nu)  lepton tensor for w w--> A 
C  
C Generated by MadGraph II                                              
C RETURNS AMPLITUDE SQUARED SUMMED/AVG OVER COLORS
C FOR THE POINT WITH EXTERNAL LINES W(0:6,NEXTERNAL)
C  
C FOR PROCESS : w- w+ -> a  
C  
      IMPLICIT NONE
C  
C CONSTANTS
C  
      INTEGER    NGRAPHS
      PARAMETER (NGRAPHS=   1)
      INTEGER    NWAVEFUNCS   
      PARAMETER (NWAVEFUNCS=   3)
      REAL*8     ZERO
      PARAMETER (ZERO=0D0)

C  
C ARGUMENTS 
C  
      REAL*8 P(0:3,3:5),Q(0:3)
      complex*16 wwtoa1(0:3,0:3)
      integer idb
  
C LOCAL VARIABLES 
C  
      INTEGER I,J,MU,NU
      COMPLEX*16 AMP(NGRAPHS)
      COMPLEX*16 W(18,NWAVEFUNCS)
      real*8 Q1(0:3), Q2(0:3)

c  A polarization vector
#include "tensorw.inc"      
#include "VBFNLO/utilities/coupl.inc"

C
C ----------
C BEGIN CODE
C ----------

      if (idb.eq.1) then
         do mu = 0,3
            q1(mu)  = q(mu)
	    q2(mu)  = qa(mu)-q(mu)
         enddo
      elseif (idb.eq.2) then
         do mu = 0,3
            q2(mu)  = q(mu)
            q1(mu)  = qa(mu)-q(mu)
         enddo
      endif


      do i = 1,6
         w(i,3) = ea(i)
      enddo
c         CALL VXXXXX(P(0,5   ),ZERO ,iu,+1,W(1,3   ))


      DO MU = 0,3
         DO NU = 0,3

            CALL VCARTX(q1(0),WMASS ,WWIDTH,MU,-1,W(1,1   ))       
            CALL VCARTX(q2(0),WMASS ,WWIDTH,NU,-1,W(1,2   ))          
c            CALL VVVXXX(W(1,1   ),W(1,2   ),W(1,3   ),GWWA ,AMP(1   ))    
            CALL wwa_anomal3(W(1,1   ),W(1,2  ),W(1,3  ),AMP(1  ))  
            wwtoa1(MU,NU) = +AMP(   1)
c            PRINT *,MU,NU,wwtoa1(MU,NU)
         Enddo !NU
      Enddo !MU
C      CALL GAUGECHECK(JAMP,ZTEMP,EIGEN_VEC,EIGEN_VAL,NCOLOR,NEIGEN) 
      END
       
       
