cfc      subroutine wwtoza(q1,q2,P,h,ww)
cfc      subroutine WWtoZA1(q1,q2,P,lsign,ww)

cfc      subroutine wwtozan(q1,q2,P,h,ww)
cfc      subroutine WWtoZAN1(Q1,Q2,P,lsign,ww)

cfc      subroutine vvtoza(q1,q2,P,h,aa,az,za,zz)
cfc      subroutine AAtoZA1(q1,q2,P,lsign,aa)
cfc      subroutine ZAtoZA1(q1,q2,P,lsign,za)
cfc      subroutine ZZtoZA1(q1,q2,P,lsign,zz)

cfc      subroutine vtolla(p,h,alla,zlla)
cfc      subroutine ZtoLLA1(Q,P,lsign,zlla)
cfc      subroutine AtoLLA1(Q,P,lsign,alla)

c
c in this file leptonic tensors needed for qq -> qq ZA, Z -> 2lA
c and Z -> 2vA are computed for specific helicities (h)
c		
c ------------------------------------------------------------

      subroutine wwtoza(q1,q2,P,h,ww)
	
      IMPLICIT NONE

      REAL*8 Q1(0:3), Q2(0:3), P(0:3,3:6)
      complex*16 ww(0:3,0:3)
      integer lsign(3:6,4),ll,mu,nu,h

	! possible lepton helicities:
	data (lsign(ll,1),ll=3,6) / -1, -1, -1, -1/  !h=1
	data (lsign(ll,2),ll=3,6) / -1, -1,  1,  1/  !h=2
	data (lsign(ll,3),ll=3,6) /  1,  1, -1, -1/  !h=3
	data (lsign(ll,4),ll=3,6) /  1,  1,  1,  1/  !h=4
	
	call WWtoZA1(q1,q2,P,lsign(3,h),ww(0,0))
	
	! helicity combi nr.h is selected
	
	end
		
c ------------------------------------------------------------

      subroutine WWtoZA1(q1,q2,P,lsign,ww)
C     
C     Generated by MadGraph5_aMC@NLO v. 2.1.2, 2014-07-03
C     By the MadGraph5_aMC@NLO Development Team
C     Visit launchpad.net/madgraph5 and amcatnlo.web.cern.ch
C     
C     Process: w+ w- > e+ e- a QCD=0 
C     
      IMPLICIT NONE
C     
C     CONSTANTS
C     
      INTEGER    NGRAPHS
      PARAMETER (NGRAPHS=14)
      INTEGER    NWAVEFUNCS,     NCOLOR
      PARAMETER (NWAVEFUNCS=11, NCOLOR=1)
      REAL*8     ZERO
      PARAMETER (ZERO=0D0)
C     
C     ARGUMENTS 
C     
      REAL*8 P(0:3,3:6)
      REAL*8 Q1(0:3),Q2(0:3)
      INTEGER lsign(3:6)
      COMPLEX*16 ww(0:3,0:3)
C     
C     LOCAL VARIABLES 
C     
      INTEGER I,MU,NU
      COMPLEX*16 AMP(NGRAPHS)
      COMPLEX*16 W(6,NWAVEFUNCS)
C  
C GLOBAL VARIABLES
C  
#include "tensorz.inc" 
#include "VBFNLO/utilities/coupl.inc"

      logical lswitch
      parameter (lswitch=.true.)   

C     ----------
C     BEGIN CODE
C     ----------

      DO MU = 0,3
        DO NU = 0,3

      if (lswitch) then
      	do i = 1,6
	 w(i,3) = lep(i)
	 w(i,4) = lem(i)
	 w(i,5) = ea(i)
	 w(i,10) = ae(i)
         w(i,11)= ze(i)
      	enddo
      else 
c incoming
c        CALL VXXXXX(Q1(0),WMASS,NHEL(1),-1*IC(1),W(1,1))
c        CALL VXXXXX(Q2(02),WMASS,NHEL(2),-1*IC(2),W(1,2))
c outgoing
c        CALL IXXXXX(P(0,3),ZERO,NHEL(3),-1*IC(3),W(1,3))
c        CALL OXXXXX(P(0,4),ZERO,NHEL(4),+1*IC(4),W(1,4))
c        CALL VXXXXX(P(0,5),ZERO,NHEL(5),+1*IC(5),W(1,5))
c diagrams
c        CALL JIOXXX(W(1,3),W(1,4),GAL,ZERO,AWIDTH,W(1,10)) !d 7
c        CALL JIOXXX(W(1,3),W(1,4),GZL,ZMASS,ZWIDTH,W(1,11)) !d 8

      endif
      CALL VCARTX(Q1(0),WMASS ,wwidth, MU,-1,W(1,1   ))      
      CALL VCARTX(Q2(0),WMASS ,wwidth, NU,-1,W(1,2   )) 

      CALL FVIXXX(W(1,3),W(1,5),GAL,ZERO,ZERO,W(1,7))
      CALL JVVXXX(W(1,1),W(1,2),GWWA,ZERO,AWIDTH,W(1,6))

C     Amplitude(s) for diagram number 1
      CALL IOVXXX(W(1,7),W(1,4),W(1,6),GAL,AMP(1))
      CALL JVVXXX(W(1,1),W(1,2),GWWZ,ZMASS,ZWIDTH,W(1,8))
C     Amplitude(s) for diagram number 2
      CALL IOVXXX(W(1,7),W(1,4),W(1,8),GZL,AMP(2))
      CALL FVOXXX(W(1,4),W(1,5),GAL,ZERO,ZERO,W(1,9))
C     Amplitude(s) for diagram number 3
      CALL IOVXXX(W(1,3),W(1,9),W(1,6),GAL,AMP(3))
C     Amplitude(s) for diagram number 4
      CALL IOVXXX(W(1,3),W(1,9),W(1,8),GZL,AMP(4))
      CALL FVIXXX(W(1,3),W(1,1),GWF,ZERO,ZERO,W(1,8))
      CALL JVVXXX(W(1,2),W(1,5),GWWA,WMASS,WWIDTH,W(1,6))
C     Amplitude(s) for diagram number 5
      CALL IOVXXX(W(1,8),W(1,4),W(1,6),GWF,AMP(5))
C     Amplitude(s) for diagram number 6
      CALL IOVXXX(W(1,8),W(1,9),W(1,2),GWF,AMP(6))
      CALL JVVXXX(W(1,5),W(1,1),GWWA,WMASS,WWIDTH,W(1,8))
      CALL FVOXXX(W(1,4),W(1,2),GWF,ZERO,ZERO,W(1,9))
C     Amplitude(s) for diagram number 7
      CALL IOVXXX(W(1,3),W(1,9),W(1,8),GWF,AMP(7))
C     Amplitude(s) for diagram number 8
      CALL VVVXXX(W(1,8),W(1,2),W(1,10),GWWA,AMP(8))
C     Amplitude(s) for diagram number 9
      CALL VVVXXX(W(1,8),W(1,2),W(1,11),GWWZ,AMP(9))
C     Amplitude(s) for diagram number 10
      CALL IOVXXX(W(1,7),W(1,9),W(1,1),GWF,AMP(10))
C     Amplitude(s) for diagram number 11
      CALL VVVXXX(W(1,1),W(1,6),W(1,10),GWWA,AMP(11))
C     Amplitude(s) for diagram number 12
      CALL VVVXXX(W(1,1),W(1,6),W(1,11),GWWZ,AMP(12))
      CALL JW3WXX(W(1,2),W(1,5),W(1,1),GWWA*GWWA,1D0,ZERO,AWIDTH,W(1
     $ ,11))
C     Amplitude(s) for diagram number 13
      CALL IOVXXX(W(1,3),W(1,4),W(1,11),GAL,AMP(13))
      CALL JW3WXX(W(1,2),W(1,5),W(1,1),GWWZ*GWWA,1D0,ZMASS,ZWIDTH,W(1
     $ ,11))
C     Amplitude(s) for diagram number 14
      CALL IOVXXX(W(1,3),W(1,4),W(1,11),GZL,AMP(14))

      WW(MU,NU)=+AMP(1)+AMP(2)+AMP(3)+AMP(4)+AMP(5)+AMP(6)+AMP(7)+AMP(8)
     $ +AMP(9)+AMP(10)+AMP(11)+AMP(12)+AMP(13)+AMP(14)

        ENDDO
      ENDDO

      END

c ------------------------------------------------------------
c ------------------------------------------------------------

      subroutine wwtozan(q1,q2,P,h,ww)
	
      IMPLICIT NONE

      REAL*8 Q1(0:3), Q2(0:3), P(0:3,3:6)
      complex*16 ww(0:3,0:3)
      integer lsign(3:6,4),ll,mu,nu,h
      

	! possible lepton helicities: (not used in code, definition of h should be changed when using this)
        data (lsign(ll,1),ll=3,6) / -1, -1, -1, -1/  !h=1 -> zero
	data (lsign(ll,2),ll=3,6) / -1, -1,  1,  1/  !h=2
	data (lsign(ll,3),ll=3,6) /  1,  1, -1, -1/  !h=3 -> zero
	data (lsign(ll,4),ll=3,6) /  1,  1,  1,  1/  !h=4
	
	call WWtoZAN1(q1,q2,P,lsign(3,h),ww)
	
	end
		
c ------------------------------------------------------------

      subroutine WWtoZAN1(Q1,Q2,P,lsign,ww)
C     
C     Generated by MadGraph5_aMC@NLO v. 2.1.2, 2014-07-03
C     By the MadGraph5_aMC@NLO Development Team
C     Visit launchpad.net/madgraph5 and amcatnlo.web.cern.ch
C     
C     Process: w+ w- > ve ve~ a QCD=0
c   fc Order matters?
C     
      IMPLICIT NONE
C     
C     CONSTANTS
C     
      INTEGER    NGRAPHS
      PARAMETER (NGRAPHS=6)
      INTEGER    NWAVEFUNCS,     NCOLOR
      PARAMETER (NWAVEFUNCS=9, NCOLOR=1)
      REAL*8     ZERO
      PARAMETER (ZERO=0D0)
C     
C     ARGUMENTS 
C     
      REAL*8 P(0:3,3:6)
      REAL*8 Q1(0:3),Q2(0:3)
      INTEGER lsign(3:6)
      COMPLEX*16 ww(0:3,0:3)
C     
C     LOCAL VARIABLES 
C     
      INTEGER I,MU,NU
      COMPLEX*16 AMP(NGRAPHS)
      COMPLEX*16 W(6,NWAVEFUNCS)
C     
C     GLOBAL VARIABLES
C    
#include "tensorz.inc"
#include "VBFNLO/utilities/coupl.inc"

      logical lswitch
      parameter (lswitch=.true.)   

C     ----------
C     BEGIN CODE
C     ----------

      DO MU = 0,3
        DO NU = 0,3

      if (lswitch) then
      	do i = 1,6
	 w(i,3) = lum(i) 
	 w(i,4) = lup(i)
	 w(i,5) = ea(i) 
! !          w(i,7)= -ze(i)  ! fc what about the sign here
      	enddo
      else
c incoming            
c        CALL VXXXXX(P(0,1),WMASS,NHEL(1),-1*IC(1),W(1,1))
c        CALL VXXXXX(P(0,2),WMASS,NHEL(2),-1*IC(2),W(1,2))
c outgoing
c        CALL OXXXXX(P(0,3),ZERO,NHEL(3),+1*IC(3),W(1,3))
c        CALL IXXXXX(P(0,4),ZERO,NHEL(4),-1*IC(4),W(1,4))
c        CALL VXXXXX(P(0,5),ZERO,NHEL(5),+1*IC(5),W(1,5))         
      endif

      CALL VCARTX(Q1(0),WMASS ,wwidth, MU,-1,W(1,1))        
      CALL VCARTX(Q2(0),WMASS ,wwidth, NU,-1,W(1,2))
      
      CALL FVOXXX(W(1,3),W(1,1),GWF,ZERO,ZERO,W(1,6))
      CALL FVIXXX(W(1,4),W(1,2),GWF,ZERO,ZERO,W(1,7))
C     Amplitude(s) for diagram number 1
      CALL IOVXXX(W(1,7),W(1,6),W(1,5),GAL,AMP(1))
      CALL JVVXXX(W(1,2),W(1,5),GWWA,WMASS,WWIDTH,W(1,8))
C     Amplitude(s) for diagram number 2
      CALL IOVXXX(W(1,4),W(1,6),W(1,8),GWF,AMP(2))
      CALL JVVXXX(W(1,5),W(1,1),GWWA,WMASS,WWIDTH,W(1,6))
C     Amplitude(s) for diagram number 3
      CALL IOVXXX(W(1,7),W(1,3),W(1,6),GWF,AMP(3))
      CALL JIOXXX(W(1,4),W(1,3),GZN,ZMASS,ZWIDTH,W(1,7))
C     Amplitude(s) for diagram number 4
      CALL VVVXXX(W(1,6),W(1,2),W(1,7),GWWZ,AMP(4))
C     Amplitude(s) for diagram number 5
      CALL VVVXXX(W(1,1),W(1,8),W(1,7),GWWZ,AMP(5))
      CALL JW3WXX(W(1,2),W(1,5),W(1,1),GWWZ*GWWA,1D0,ZMASS,ZWIDTH,W(1
     $ ,7))
C     Amplitude(s) for diagram number 6
      CALL IOVXXX(W(1,4),W(1,3),W(1,7),GZN,AMP(6))

      WW(MU,NU)=-AMP(1)-AMP(2)-AMP(3)-AMP(4)-AMP(5)-AMP(6)

        ENDDO
      ENDDO

      END


c ------------------------------------------------------------
c ------------------------------------------------------------

      subroutine vvtoza(q1,q2,P,h,aa,az,za,zz)
	
      IMPLICIT NONE

      REAL*8 Q1(0:3), Q2(0:3), P(0:3,3:6)
      complex*16 aa(0:3,0:3)
      complex*16 az(0:3,0:3)
      complex*16 za(0:3,0:3)
      complex*16 za_o(0:3,0:3)
      complex*16 zz(0:3,0:3)
      integer lsign(3:6,4),h,ll,mu,nu

	! possible lepton helicities:
	data (lsign(ll,1),ll=3,6) / -1, -1, -1, -1/
	data (lsign(ll,2),ll=3,6) / -1, -1,  1,  1/
	data (lsign(ll,3),ll=3,6) /  1,  1, -1, -1/
	data (lsign(ll,4),ll=3,6) /  1,  1,  1,  1/
	
	call AAtoZA1(q1,q2,P,lsign(3,h),aa(0,0))
	call AZtoZA1(q1,q2,P,lsign(3,h),az(0,0))
	call AZtoZA1(q2,q1,P,lsign(3,h),za(0,0))
	call ZZtoZA1(q1,q2,P,lsign(3,h),zz(0,0))
		
	end
		
c ------------------------------------------------------------

      subroutine AAtoZA1(q1,q2,P,lsign,aa)
C     
C     Generated by MadGraph5_aMC@NLO v. 2.1.2, 2014-07-03
C     By the MadGraph5_aMC@NLO Development Team
C     Visit launchpad.net/madgraph5 and amcatnlo.web.cern.ch
C     
C     Process: a a > e+ e- a QCD=0 
C     
      IMPLICIT NONE
C     
C     CONSTANTS
C     
      INTEGER    NGRAPHS
      PARAMETER (NGRAPHS=6)
      INTEGER    NWAVEFUNCS
      PARAMETER (NWAVEFUNCS=9)
      REAL*8     ZERO
      PARAMETER (ZERO=0D0)
C     
C     ARGUMENTS 
C     
      REAL*8 P(0:3,3:6)
      REAL*8 Q1(0:3),Q2(0:3)
      INTEGER lsign(3:6)
      COMPLEX*16 aa(0:3,0:3)
C     
C     LOCAL VARIABLES 
C    
      INTEGER I,MU,NU
      COMPLEX*16 AMP(NGRAPHS)
      COMPLEX*16 W(6,NWAVEFUNCS)
C     
C     GLOBAL VARIABLES
C     
#include "tensorz.inc"
#include "VBFNLO/utilities/coupl.inc"

      logical lswitch
      parameter (lswitch=.true.)  

C     ----------
C     BEGIN CODE
C     ----------
      
      DO MU = 0,3
        DO NU = 0,3

       if (lswitch) then
         do i = 1,6
	   w(i,3) = lep(i) 
	   w(i,4) = lem(i)
	   w(i,5) = ea(i)  
      	 enddo
       else
c incoming
c        CALL VXXXXX(P(0,1),ZERO,NHEL(1),-1*IC(1),W(1,1))
c        CALL VXXXXX(P(0,2),ZERO,NHEL(2),-1*IC(2),W(1,2))
c outgoing
c        CALL IXXXXX(P(0,3),ZERO,NHEL(3),-1*IC(3),W(1,3))
c        CALL OXXXXX(P(0,4),ZERO,NHEL(4),+1*IC(4),W(1,4))
c        CALL VXXXXX(P(0,5),ZERO,NHEL(5),+1*IC(5),W(1,5))
      endif

      CALL VCARTX(Q1(0),ZERO,AWIDTH, MU,-1,W(1,1))        
      CALL VCARTX(Q2(0),ZERO,AWIDTH, NU,-1,W(1,2))

      CALL FVIXXX(W(1,3),W(1,1),GAL,ZERO,ZERO,W(1,6))
      CALL FVOXXX(W(1,4),W(1,2),GAL,ZERO,ZERO,W(1,7))
      
C     Amplitude(s) for diagram number 1
      CALL IOVXXX(W(1,6),W(1,7),W(1,5),GAL,AMP(1))
      CALL FVOXXX(W(1,4),W(1,5),GAL,ZERO,ZERO,W(1,8))
C     Amplitude(s) for diagram number 2
      CALL IOVXXX(W(1,6),W(1,8),W(1,2),GAL,AMP(2))
      CALL FVOXXX(W(1,4),W(1,1),GAL,ZERO,ZERO,W(1,6))
      CALL FVIXXX(W(1,3),W(1,2),GAL,ZERO,ZERO,W(1,4))
C     Amplitude(s) for diagram number 3
      CALL IOVXXX(W(1,4),W(1,6),W(1,5),GAL,AMP(3))
      CALL FVIXXX(W(1,3),W(1,5),GAL,ZERO,ZERO,W(1,9))
C     Amplitude(s) for diagram number 4
      CALL IOVXXX(W(1,9),W(1,6),W(1,2),GAL,AMP(4))
C     Amplitude(s) for diagram number 5
      CALL IOVXXX(W(1,4),W(1,8),W(1,1),GAL,AMP(5))
C     Amplitude(s) for diagram number 6
      CALL IOVXXX(W(1,9),W(1,7),W(1,1),GAL,AMP(6))
      
      aa(MU,NU)=+AMP(1)+AMP(2)+AMP(3)+AMP(4)+AMP(5)+AMP(6)

        ENDDO
      ENDDO

      END



      subroutine AZtoZA1(q1,q2,P,lsign,az)
C   
C     Generated by MadGraph5_aMC@NLO v. 2.1.2, 2014-07-03
C     By the MadGraph5_aMC@NLO Development Team
C     Visit launchpad.net/madgraph5 and amcatnlo.web.cern.ch
C
C     Process: a z > e+ e- a QCD=0    
C
C     
      IMPLICIT NONE
C     
C     CONSTANTS
C     
      INTEGER    NGRAPHS
      PARAMETER (NGRAPHS=6)
      INTEGER    NWAVEFUNCS
      PARAMETER (NWAVEFUNCS=9)
      REAL*8     ZERO
      PARAMETER (ZERO=0D0)
C     
C     ARGUMENTS 
C     
      REAL*8 P(0:3,3:6)
      REAL*8 Q1(0:3),Q2(0:3)
      INTEGER lsign(3:6)
      COMPLEX*16 az(0:3,0:3)
C     
C     LOCAL VARIABLES 
C     
      INTEGER I,MU,NU
      COMPLEX*16 AMP(NGRAPHS)
      COMPLEX*16 W(6,NWAVEFUNCS)
C     
C     GLOBAL VARIABLES
C     
#include "tensorz.inc" 
#include "VBFNLO/utilities/coupl.inc"

      logical lswitch
      parameter (lswitch=.true.)  

C     ----------
C     BEGIN CODE
C     ----------

      DO MU = 0,3
        DO NU = 0,3

C     ----------
C     BEGIN CODE
C     ----------
c      CALL VXXXXX(P(0,1),ZERO,NHEL(1),-1*IC(1),W(1,1))
c      CALL VXXXXX(P(0,2),ZMASS,NHEL(2),-1*IC(2),W(1,2))
c      CALL IXXXXX(P(0,3),ZERO,NHEL(3),-1*IC(3),W(1,3))
c      CALL OXXXXX(P(0,4),ZERO,NHEL(4),+1*IC(4),W(1,4))
c      CALL VXXXXX(P(0,5),ZERO,NHEL(5),+1*IC(5),W(1,5))

      if (lswitch) then
        do i = 1,6
	 w(i,3) = lep(i) 
	 w(i,4) = lem(i)
	 w(i,5) = ea(i)
      	enddo
      else
      endif

      CALL VCARTX(Q1(0),zero  ,zero, MU,-1,W(1,1   ))        
      CALL VCARTX(Q2(0),zMASS ,zwidth, NU,-1,W(1,2   )) 
 

      CALL FVIXXX(W(1,3),W(1,1),GAL,ZERO,ZERO,W(1,6))
      CALL FVOXXX(W(1,4),W(1,2),GZL,ZERO,ZERO,W(1,7))

C     Amplitude(s) for diagram number 1
      CALL IOVXXX(W(1,6),W(1,7),W(1,5),GAL,AMP(1))
      CALL FVOXXX(W(1,4),W(1,5),GAL,ZERO,ZERO,W(1,8))
C     Amplitude(s) for diagram number 2
      CALL IOVXXX(W(1,6),W(1,8),W(1,2),GZL,AMP(2))
      CALL FVOXXX(W(1,4),W(1,1),GAL,ZERO,ZERO,W(1,6))
      CALL FVIXXX(W(1,3),W(1,2),GZL,ZERO,ZERO,W(1,4))
C     Amplitude(s) for diagram number 3
      CALL IOVXXX(W(1,4),W(1,6),W(1,5),GAL,AMP(3))
      CALL FVIXXX(W(1,3),W(1,5),GAL,ZERO,ZERO,W(1,9))
C     Amplitude(s) for diagram number 4
      CALL IOVXXX(W(1,9),W(1,6),W(1,2),GZL,AMP(4))
C     Amplitude(s) for diagram number 5
      CALL IOVXXX(W(1,4),W(1,8),W(1,1),GAL,AMP(5))
C     Amplitude(s) for diagram number 6
      CALL IOVXXX(W(1,9),W(1,7),W(1,1),GAL,AMP(6))
C     JAMPs contributing to orders ALL_ORDERS=1
      az(MU,NU)=+AMP(1)+AMP(2)+AMP(3)+AMP(4)+AMP(5)+AMP(6)

       enddo
       enddo
       end


c ------------------------------------------------------------

      subroutine ZZtoZA1(q1,q2,P,lsign,zz)
C     
C     Generated by MadGraph5_aMC@NLO v. 2.1.2, 2014-07-03
C     By the MadGraph5_aMC@NLO Development Team
C     Visit launchpad.net/madgraph5 and amcatnlo.web.cern.ch
C     
C     Process: z z > e+ e- a QCD=0
C     
      IMPLICIT NONE
C     
C     CONSTANTS
C     
      INTEGER    NGRAPHS
      PARAMETER (NGRAPHS=6)
      INTEGER    NWAVEFUNCS
      PARAMETER (NWAVEFUNCS=9)
      REAL*8     ZERO
      PARAMETER (ZERO=0D0)
C     
C     ARGUMENTS 
C     
      REAL*8 P(0:3,3:6)
      REAL*8 Q1(0:3),Q2(0:3)
      INTEGER lsign(3:6)
      COMPLEX*16 zz(0:3,0:3)
C     
C     LOCAL VARIABLES 
C     
      INTEGER I,MU,NU
      COMPLEX*16 AMP(NGRAPHS)
      COMPLEX*16 W(6,NWAVEFUNCS)
C     
C     GLOBAL VARIABLES
C     
#include "tensorz.inc"
#include "VBFNLO/utilities/coupl.inc"

      logical lswitch
      parameter (lswitch=.true.)  

C     ----------
C     BEGIN CODE
C     ----------

      DO MU = 0,3
        DO NU = 0,3

      if (lswitch) then
        do i = 1,6
	 w(i,3) = lep(i) 
	 w(i,4) = lem(i)
	 w(i,5) = ea(i)
      	enddo
      else
c incoming
c        CALL VXXXXX(P(0,1),ZMASS,NHEL(1),-1*IC(1),W(1,1))
c        CALL VXXXXX(P(0,2),ZMASS,NHEL(2),-1*IC(2),W(1,2))
c outgoing
c        CALL IXXXXX(P(0,3),ZERO,NHEL(3),-1*IC(3),W(1,3))
c        CALL OXXXXX(P(0,4),ZERO,NHEL(4),+1*IC(4),W(1,4))
c        CALL VXXXXX(P(0,5),ZERO,NHEL(5),+1*IC(5),W(1,5))
      endif

      CALL VCARTX(Q1(0),ZMASS,ZWIDTH, MU,-1,W(1,1))        
      CALL VCARTX(Q2(0),ZMASS,ZWIDTH, NU,-1,W(1,2))

      CALL FVIXXX(W(1,3),W(1,1),GZL,ZERO,ZERO,W(1,6))
      CALL FVOXXX(W(1,4),W(1,2),GZL,ZERO,ZERO,W(1,7))
C     Amplitude(s) for diagram number 1
      CALL IOVXXX(W(1,6),W(1,7),W(1,5),GAL,AMP(1))
      CALL FVOXXX(W(1,4),W(1,5),GAL,ZERO,ZERO,W(1,8))
C     Amplitude(s) for diagram number 2
      CALL IOVXXX(W(1,6),W(1,8),W(1,2),GZL,AMP(2))
      CALL FVOXXX(W(1,4),W(1,1),GZL,ZERO,ZERO,W(1,6))
      CALL FVIXXX(W(1,3),W(1,2),GZL,ZERO,ZERO,W(1,4))
C     Amplitude(s) for diagram number 3
      CALL IOVXXX(W(1,4),W(1,6),W(1,5),GAL,AMP(3))
      CALL FVIXXX(W(1,3),W(1,5),GAL,ZERO,ZERO,W(1,9))
C     Amplitude(s) for diagram number 4
      CALL IOVXXX(W(1,9),W(1,6),W(1,2),GZL,AMP(4))
C     Amplitude(s) for diagram number 5
      CALL IOVXXX(W(1,4),W(1,8),W(1,1),GZL,AMP(5))
C     Amplitude(s) for diagram number 6
      CALL IOVXXX(W(1,9),W(1,7),W(1,1),GZL,AMP(6))

      zz(MU,NU)=+AMP(1)+AMP(2)+AMP(3)+AMP(4)+AMP(5)+AMP(6)

        ENDDO
      ENDDO

      END


c ------------------------------------------------------------	
c ------------------------------------------------------------	

      subroutine vtolla(p,h,alla,zlla)
	
      IMPLICIT NONE

      REAL*8 P(0:3,2:4), Q1(0:3)
      complex*16 alla(0:5),zlla(0:5)
      integer lsign(2:5,4),h,ll,mu   

	! possible lepton helicities:
	data (lsign(ll,1),ll=2,5) / -1, -1, -1, -1/  !h=1
	data (lsign(ll,2),ll=2,5) / -1, -1,  1,  1/  !h=2
	data (lsign(ll,3),ll=2,5) /  1,  1, -1, -1/  !h=3
	data (lsign(ll,4),ll=2,5) /  1,  1,  1,  1/  !h=4

        do mu=0,3
          Q1(mu)=P(mu,2)+P(mu,3)+P(mu,4)
        enddo

	call ZtoLLA1(q1,P,lsign(2,h),zlla)
	call AtoLLA1(q1,P,lsign(2,h),alla)
		
			
	end
		
c ------------------------------------------------------------

      subroutine ZtoLLA1(Q,P,lsign,zlla)
C     
C     Generated by MadGraph5_aMC@NLO v. 2.1.2, 2014-07-03
C     By the MadGraph5_aMC@NLO Development Team
C     Visit launchpad.net/madgraph5 and amcatnlo.web.cern.ch
C     
C     Process: z > e+ e- a QCD=0
C     
      IMPLICIT NONE
C     
C     CONSTANTS
C     
      INTEGER    NGRAPHS
      PARAMETER (NGRAPHS=2)
      INTEGER    NWAVEFUNCS
      PARAMETER (NWAVEFUNCS=5)
      REAL*8     ZERO
      PARAMETER (ZERO=0D0)
C     
C     ARGUMENTS 
C     
      REAL*8 P(0:3,2:4)
      REAL*8 Q(0:3)
      INTEGER lsign(3:6)
      COMPLEX*16 zlla(0:5)
C     
C     LOCAL VARIABLES 
C     
      INTEGER I,MU,NU
      COMPLEX*16 AMP(NGRAPHS)
      COMPLEX*16 W(18,NWAVEFUNCS)
C     
C     GLOBAL VARIABLES
C     
#include "tensorz.inc"
#include "VBFNLO/utilities/coupl.inc" 

      logical lswitch
      parameter (lswitch=.true.)  

C     ----------
C     BEGIN CODE
C     ----------

      DO MU = 0,3

      if (lswitch) then
        do i = 1,6
	 w(i,2) = lep(i) 
	 w(i,3) = lem(i)
	 w(i,4) = ea(i)
      	enddo
      else
c incoming
c        CALL VXXXXX(P(0,1),ZMASS,NHEL(1),-1*IC(1),W(1,1))
c outgoing
c        CALL IXXXXX(P(0,2),ZERO,NHEL(2),-1*IC(2),W(1,2))
c        CALL OXXXXX(P(0,3),ZERO,NHEL(3),+1*IC(3),W(1,3))
c        CALL VXXXXX(P(0,4),ZERO,NHEL(4),+1*IC(4),W(1,4))
      endif
 
c
      CALL VCARTX(Q(0),ZMASS,ZWIDTH, MU,-1,W(1,1))

      CALL FVIXXX(W(1,2),W(1,4),GAL,ZERO,ZERO,W(1,5))
C     Amplitude(s) for diagram number 1
      CALL IOVXXX(W(1,5),W(1,3),W(1,1),GZL,AMP(1))
      CALL FVOXXX(W(1,3),W(1,4),GAL,ZERO,ZERO,W(1,5))
C     Amplitude(s) for diagram number 2
      CALL IOVXXX(W(1,2),W(1,5),W(1,1),GZL,AMP(2))

      zlla(MU)=+AMP(1)+AMP(2)
     
      ENDDO

cfc added new
      zlla(4) = dcmplx(q(0),q(3))
      zlla(5) = dcmplx(q(1),q(2))
      return
      END
c ------------------------------------------------------------

      subroutine AtoLLA1(Q,P,lsign,alla)
C     
C     Generated by MadGraph5_aMC@NLO v. 2.1.2, 2014-07-03
C     By the MadGraph5_aMC@NLO Development Team
C     Visit launchpad.net/madgraph5 and amcatnlo.web.cern.ch
C     
C     Process: a > e+ e- a QCD=0
C     
      IMPLICIT NONE
C     
C     CONSTANTS
C     
      INTEGER    NGRAPHS
      PARAMETER (NGRAPHS=2)
      INTEGER    NWAVEFUNCS
      PARAMETER (NWAVEFUNCS=5)
      REAL*8     ZERO
      PARAMETER (ZERO=0D0)
C     
C     ARGUMENTS 
C     
      REAL*8 P(0:3,2:4)
      REAL*8 Q(0:3)
      INTEGER lsign(3:6)
      COMPLEX*16 alla(0:5)
C     
C     LOCAL VARIABLES 
C     
      INTEGER I,MU,NU
      COMPLEX*16 AMP(NGRAPHS)
      COMPLEX*16 W(18,NWAVEFUNCS)
C     
C     GLOBAL VARIABLES
C     
#include "tensorz.inc" 
#include "VBFNLO/utilities/coupl.inc" 

      logical lswitch
      parameter (lswitch=.true.)  

C     ----------
C     BEGIN CODE
C     ----------

      DO MU = 0,3

      if (lswitch) then
        do i = 1,6
	 w(i,2) = lep(i) 
	 w(i,3) = lem(i)
	 w(i,4) = ea(i)
      	enddo
      else
c incoming
c        CALL VXXXXX(P(0,1),ZMASS,NHEL(1),-1*IC(1),W(1,1))
c outgoing
c        CALL IXXXXX(P(0,2),ZERO,NHEL(2),-1*IC(2),W(1,2))
c        CALL OXXXXX(P(0,3),ZERO,NHEL(3),+1*IC(3),W(1,3))
c        CALL VXXXXX(P(0,4),ZERO,NHEL(4),+1*IC(4),W(1,4))
      endif




      CALL VCARTX(Q(0),ZERO,AWIDTH, MU,-1,W(1,1))

      CALL FVIXXX(W(1,2),W(1,4),GAL,ZERO,ZERO,W(1,5))
C     Amplitude(s) for diagram number 1
      CALL IOVXXX(W(1,5),W(1,3),W(1,1),GAL,AMP(1))
      CALL FVOXXX(W(1,3),W(1,4),GAL,ZERO,ZERO,W(1,5))
C     Amplitude(s) for diagram number 2
      CALL IOVXXX(W(1,2),W(1,5),W(1,1),GAL,AMP(2))

      alla(MU)=+AMP(1)+AMP(2)
     
      ENDDO

c fc added new
      alla(4) = dcmplx(q(0),q(3))
      alla(5) = dcmplx(q(1),q(2))

      return
      END

        

