C
C modified from tozz.F by Jessica Frank
C Only resonant Higgs diagrams are included.
C These routines are called for process 196 (Sp2jj_ZZ_ll) 
C or process 197 (Sp2jj_ZZ_lnu) with a Higgs instead of
C a spin-2 resonanance if spin2=false is set in vbfnlo.dat.

      subroutine wwtozz_Hres(q1,q2,P,h,ww)
	
      IMPLICIT NONE

      REAL*8 Q1(0:3), Q2(0:3), P(0:3,3:6)
      complex*16 ww(0:3,0:3)
      integer lsign(3:6,4),ll,mu,nu,h
      

	! possible lepton helicities:
	data (lsign(ll,1),ll=3,6) / -1, -1, -1, -1/  !h=1
	data (lsign(ll,2),ll=3,6) / -1, -1,  1,  1/  !h=2
	data (lsign(ll,3),ll=3,6) /  1,  1, -1, -1/  !h=3
	data (lsign(ll,4),ll=3,6) /  1,  1,  1,  1/  !h=4
	
	call WWtoZZ1_Hres(q1,q2,P,lsign(3,h),ww(0,0))
	
	! helicity combi nr.h is selected
	
	end
		
c ------------------------------------------------------------	

      subroutine WWtoZZ1_Hres(q1,q2,P,lsign,ww)
C  
C Generated by MadGraph II Version 3.0. Updated 02/19/04                
C RETURNS AMPLITUDE SQUARED SUMMED/AVG OVER COLORS
C FOR THE POINT WITH EXTERNAL LINES W(0:6,NEXTERNAL)
C  
C FOR PROCESS : w+ w- -> e+ e- mu+ mu-  
C  
      IMPLICIT NONE
C  
C CONSTANTS
C  
      INTEGER    NGRAPHS
      PARAMETER (NGRAPHS=  49) 
      INTEGER    NWAVEFUNCS 
      PARAMETER (NWAVEFUNCS=  51) 
      REAL*8     ZERO
      PARAMETER (ZERO=0D0)
C  
C ARGUMENTS 
C  
      REAL*8 Q1(0:3), Q2(0:3), P(0:3,3:6)
      complex*16 ww(0:3,0:3)
      integer lsign(3:6)
C  
C LOCAL VARIABLES 
C  
      INTEGER I,J,MU, NU
      COMPLEX*16 AMP(NGRAPHS)
      COMPLEX*16 W(6,NWAVEFUNCS)

c for histograms
      REAL*8 p1inimom0, p1inimom1, p1inimom2, p1inimom3
      REAL*8 p2inimom0, p2inimom1, p2inimom2, p2inimom3

      COMMON /histpinimom/ p1inimom0, p1inimom1, p1inimom2, p1inimom3,
     &                     p2inimom0, p2inimom1, p2inimom2, p2inimom3
c
c  lepton spinors and Z polarization vectors
#include "tensorz.inc"
C  
C  
C GLOBAL VARIABLES
C  
#include "VBFNLO/utilities/coupl.inc"
   
      logical lswitch
      parameter (lswitch=.true.)
C                                                                          
C ----------
C BEGIN CODE
C ----------
  
      if (lswitch) then
      	do i = 1,6
	 w(i,3) = lep(i)
	 w(i,4) = lem(i)
	 w(i,5) = lup(i)
	 w(i,6) = lum(i)
	
         w(i,8)  = au(i)
         w(i,10) = zu(i)
         w(i,23) = ze(i)
         w(i,25) = ae(i)
      	enddo
      else 
      	CALL IXXXXX(P(0,3   ),ZERO ,-lsign(3   ),-1,W(1,3   ))	 
      	CALL OXXXXX(P(0,4   ),ZERO ,+lsign(4   ),+1,W(1,4   ))	 
     	CALL IXXXXX(P(0,5   ),ZERO ,-lsign(5   ),-1,W(1,5   ))	 
      	CALL OXXXXX(P(0,6   ),ZERO ,+lsign(6   ),+1,W(1,6   ))	 

  
        CALL JIOXXX(W(1,3   ),W(1,4   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,23  ))	   
   
      endif

      DO MU = 0,3
         DO NU = 0,3
      
      CALL VCARTX(Q1(0),WMASS ,wwidth, MU,-1,W(1,1   ))        
      CALL VCARTX(Q2(0),WMASS ,wwidth, NU,-1,W(1,2   )) 

c in common block for histograms only

      p1inimom0=dreal(W(5,1))
      p1inimom1=dreal(W(6,1))
      p1inimom2=dimag(W(6,1))
      p1inimom3=dimag(W(5,1))
      p2inimom0=dreal(W(5,2))
      p2inimom1=dreal(W(6,2))
      p2inimom2=dimag(W(6,2))
      p2inimom3=dimag(W(5,2))
         
      CALL HVVXXX(W(1,1   ),W(1,2   ),GWWH ,HMASS   ,HWIDTH  ,W(1,         
     &     48  ))                                                          
      CALL JVSXXX(W(1,23  ),W(1,48  ),GZZH ,ZMASS   ,ZWIDTH  ,W(1,         
     &     49  ))                                                          
      CALL IOVXXX(W(1,5   ),W(1,6   ),W(1,49  ),GZL ,AMP(37  ))            
     
      WW(MU,NU) = AMP(37) 
     
            ENDDO
      ENDDO

      END
c ------------------------------------------------------------	

      subroutine wwtozzn_Hres(q1,q2,P,h,ww)
	
      IMPLICIT NONE

      REAL*8 Q1(0:3), Q2(0:3), P(0:3,3:6)
      complex*16 ww(0:3,0:3)
      integer lsign(3:6,4),ll,mu,nu,h
      

	! possible lepton helicities:
	data (lsign(ll,1),ll=3,6) / -1, -1, -1, -1/  !h=1 -> zero
	data (lsign(ll,2),ll=3,6) / -1, -1,  1,  1/  !h=2
	data (lsign(ll,3),ll=3,6) /  1,  1, -1, -1/  !h=3 -> zero
	data (lsign(ll,4),ll=3,6) /  1,  1,  1,  1/  !h=4
	
	call WWtoZZN1_Hres(q1,q2,P,lsign(3,h),ww)
	
	end
		
c ------------------------------------------------------------	

      subroutine WWtoZZN1_Hres(q1,q2,P,lsign,ww)
C  
C  
C Generated by MadGraph II Version 3.0. Updated 02/19/04                
C RETURNS AMPLITUDE SQUARED SUMMED/AVG OVER COLORS
C FOR THE POINT WITH EXTERNAL LINES W(0:6,NEXTERNAL)
C  
C FOR PROCESS : w+ w- -> e+ e- vm vm~  
C  
      IMPLICIT NONE
C  
C CONSTANTS
C  
      INTEGER    NGRAPHS
      PARAMETER (NGRAPHS=  28) 
      INTEGER    NWAVEFUNCS    
      PARAMETER (NWAVEFUNCS=  41) 
      REAL*8     ZERO
      PARAMETER (ZERO=0D0)
C  
C ARGUMENTS 
C  
      REAL*8 Q1(0:3), Q2(0:3), P(0:3,3:6)
      complex*16 ww(0:3,0:3)
      integer lsign(3:6)
C  
C LOCAL VARIABLES 
C  
      INTEGER I,J,MU, NU
      COMPLEX*16 AMP(NGRAPHS)
      COMPLEX*16 W(6,NWAVEFUNCS)
C  
C GLOBAL VARIABLES
C  
c  lepton spinors and Z polarization vectors
#include "tensorz.inc"
#include "VBFNLO/utilities/coupl.inc"
   
      logical lswitch
      parameter (lswitch=.true.)
C                                                                          
C  
C ----------
C BEGIN CODE
C ----------
   
      if (lswitch) then
      	do i = 1,4
	 w(i,3) = lep(i)
	 w(i,4) = lem(i)
	 w(i,6) = lup(i)
	 w(i,5) = lum(i)
		
         w(i,8)  = -zu(i)
         w(i,20) =  ae(i)
         w(i,22) =  ze(i)
      	enddo
      	do i = 5,6
	 w(i,3) = lep(i)
	 w(i,4) = lem(i)
	 w(i,6) = lup(i)
	 w(i,5) = lum(i)
		
         w(i,8)  = zu(i)
         w(i,20) = ae(i)
         w(i,22) = ze(i)
      	enddo
      else 
      	CALL IXXXXX(P(0,3   ),ZERO ,-lsign(3   ),-1,W(1,3   ))	 
      	CALL OXXXXX(P(0,4   ),ZERO ,+lsign(4   ),+1,W(1,4   ))	 
     	CALL OXXXXX(P(0,5   ),ZERO ,+lsign(5   ),+1,W(1,5   ))	 
      	CALL IXXXXX(P(0,6   ),ZERO ,-lsign(6   ),-1,W(1,6   ))	 

	 CALL JIOXXX(W(1,3   ),W(1,4   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,22  ))    
      endif

      DO MU = 0,3
         DO NU = 0,3
      
      CALL VCARTX(Q1(0),WMASS ,wwidth, MU,-1,W(1,1   ))        
      CALL VCARTX(Q2(0),WMASS ,wwidth, NU,-1,W(1,2   )) 
          
      CALL HVVXXX(W(1,1   ),W(1,2   ),GWWH ,HMASS   ,HWIDTH  ,W(1,         
     &     39  ))                                                          
      CALL JVSXXX(W(1,22  ),W(1,39  ),GZZH ,ZMASS   ,ZWIDTH  ,W(1,         
     &     40  ))                                                          
      CALL IOVXXX(W(1,6   ),W(1,5   ),W(1,40  ),GZN ,AMP(24  ))            
                                                   
      
      ww(mu,nu) = -AMP(  24)
     
            ENDDO
      ENDDO

      END


c ------------------------------------------------------------	

c ------------------------------------------------------------	

      subroutine vvtozz_Hres(q1,q2,P,h,aa,az,za,zz)
	
      IMPLICIT NONE

      REAL*8 Q1(0:3), Q2(0:3), P(0:3,3:6)
      complex*16 aa(0:3,0:3)
      complex*16 az(0:3,0:3)
      complex*16 za(0:3,0:3)
      complex*16 zz(0:3,0:3)
      integer lsign(3:6,4),h,ll,mu,nu
      

	! possible lepton helicities:
	data (lsign(ll,1),ll=3,6) / -1, -1, -1, -1/
	data (lsign(ll,2),ll=3,6) / -1, -1,  1,  1/
	data (lsign(ll,3),ll=3,6) /  1,  1, -1, -1/
	data (lsign(ll,4),ll=3,6) /  1,  1,  1,  1/
	
	call AAtoZZ1_Hres(q1,q2,P,lsign(3,h),aa(0,0))
	call AZtoZZ1_Hres(q1,q2,P,lsign(3,h),az(0,0))
	call AZtoZZ1_Hres(q2,q1,P,lsign(3,h),za(0,0))
	call ZZtoZZ1_Hres(q1,q2,P,lsign(3,h),zz(0,0))
		
	end
		
c ------------------------------------------------------------	
       
      subroutine AAtoZZ1_Hres(q1,q2,P,lsign,aa)
C  
C Generated by MadGraph II Version 3.0. Updated 02/19/04                
C RETURNS AMPLITUDE SQUARED SUMMED/AVG OVER COLORS
C FOR THE POINT WITH EXTERNAL LINES W(0:6,NEXTERNAL)
C  
C FOR PROCESS : a a -> e+ e- mu+ mu-  
C  
      IMPLICIT NONE 
      REAL*8 Q1(0:3), Q2(0:3), P(0:3,3:6)
      complex*16 aa(0:3,0:3)
      integer lsign(3:6) 
      INTEGER I,J, mu,nu
#include "tensorz.inc"

      DO MU = 0,3
         DO NU = 0,3

       aa(mu,nu) = 0.0d0

	   enddo
        enddo
	
	end
	
				
c ------------------------------------------------------------
	
       
      subroutine AZtoZZ1_Hres(q1,q2,P,lsign,az)
C  
C Generated by MadGraph II Version 3.0. Updated 02/19/04                
C RETURNS AMPLITUDE SQUARED SUMMED/AVG OVER COLORS
C FOR THE POINT WITH EXTERNAL LINES W(0:6,NEXTERNAL)
C  
C FOR PROCESS : a z -> e+ e- mu+ mu-  
C  
      IMPLICIT NONE
      REAL*8 Q1(0:3), Q2(0:3), P(0:3,3:6)
      complex*16 az(0:3,0:3)
      integer lsign(3:6)
      INTEGER I,J,mu,nu
#include "tensorz.inc"

      DO MU = 0,3
         DO NU = 0,3

      az(mu,nu) = 0.0d0
	
	  enddo
       enddo	

      END

c ------------------------------------------------------------	
c       
      subroutine ZZtoZZ1_Hres(q1,q2,P,lsign,zz)
C  
C Generated by MadGraph II Version 3.0. Updated 02/19/04                
C RETURNS AMPLITUDE SQUARED SUMMED/AVG OVER COLORS
C FOR THE POINT WITH EXTERNAL LINES W(0:6,NEXTERNAL)
C  
C FOR PROCESS : z z -> e+ e- mu+ mu-  
C  
      IMPLICIT NONE
C  
C CONSTANTS
C  
      INTEGER    NGRAPHS 
      PARAMETER (NGRAPHS=  43) 
      INTEGER    NWAVEFUNCS   
      PARAMETER (NWAVEFUNCS=  54) 
      REAL*8     ZERO
      PARAMETER (ZERO=0D0)
C  
C ARGUMENTS 
C  
      REAL*8 Q1(0:3), Q2(0:3), P(0:3,3:6)
      complex*16 zz(0:3,0:3)
      integer lsign(3:6)
C  
C  
C LOCAL VARIABLES 
C  
      INTEGER I,J,mu,nu
      COMPLEX*16 AMP(NGRAPHS)
      COMPLEX*16 W(6,NWAVEFUNCS)
C  
c  lepton spinors and Z polarization vectors
#include "tensorz.inc"
C  
C  
C GLOBAL VARIABLES
C  
#include "VBFNLO/utilities/coupl.inc"
C   
      logical lswitch
      parameter (lswitch=.true.)
C                                                                          
C ----------
C BEGIN CODE
C ----------

      if (lswitch) then
      	do i = 1,6
	 w(i,3) = lep(i)
	 w(i,4) = lem(i)
	 w(i,5) = lup(i)
	 w(i,6) = lum(i)
	
         w(i,20) = au(i)
         w(i,22) = zu(i)
         w(i,45) = ae(i)
         w(i,46) = ze(i)
      	enddo
      else 
      	CALL IXXXXX(P(0,3   ),ZERO ,-lsign(3   ),-1,W(1,3   ))	 
      	CALL OXXXXX(P(0,4   ),ZERO ,+lsign(4   ),+1,W(1,4   ))	 
     	CALL IXXXXX(P(0,5   ),ZERO ,-lsign(5   ),-1,W(1,5   ))	 
      	CALL OXXXXX(P(0,6   ),ZERO ,+lsign(6   ),+1,W(1,6   ))	 

      	CALL JIOXXX(W(1,3   ),W(1,4   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,46  ))    
      endif

      DO MU = 0,3
         DO NU = 0,3
      
      CALL VCARTX(Q1(0),ZMASS ,zwidth, MU,-1,W(1,1   ))        
      CALL VCARTX(Q2(0),ZMASS ,zwidth, NU,-1,W(1,2   )) 
      
      CALL HVVXXX(W(1,1   ),W(1,2   ),GZZH ,HMASS   ,HWIDTH  ,W(1,         
     &     53  ))                                                          
      CALL JVSXXX(W(1,46  ),W(1,53  ),GZZH ,ZMASS   ,ZWIDTH  ,W(1,         
     &     54  ))                                                          
      CALL IOVXXX(W(1,5   ),W(1,6   ),W(1,54  ),GZL ,AMP(43  ))                 

      zz(mu,nu)  = AMP(  43)
 
	  enddo
       enddo

      END
c ------------------------------------------------------------	

      subroutine vvtozzn_Hres(q1,q2,P,h,aa,az,za,zz)
	
      IMPLICIT NONE

      REAL*8 Q1(0:3), Q2(0:3), P(0:3,3:6)
      complex*16 aa(0:3,0:3)
      complex*16 az(0:3,0:3)
      complex*16 za(0:3,0:3)
      complex*16 zz(0:3,0:3)
      integer lsign(3:6,4),h,ll,mu,nu
      

	! possible lepton helicities:
	data (lsign(ll,1),ll=3,6) / -1, -1, -1, -1/ ! zero
	data (lsign(ll,2),ll=3,6) / -1, -1,  1,  1/
	data (lsign(ll,3),ll=3,6) /  1,  1, -1, -1/ ! zero
	data (lsign(ll,4),ll=3,6) /  1,  1,  1,  1/
	
	call AAtoZZN1_Hres(q1,q2,P,lsign(3,h),aa(0,0))
	call AZtoZZN1_Hres(q1,q2,P,lsign(3,h),az(0,0))
	call AZtoZZN1_Hres(q2,q1,P,lsign(3,h),za(0,0))
	call ZZtoZZN1_Hres(q1,q2,P,lsign(3,h),zz(0,0))
		
	end
		
      
c ------------------------------------------------------------	
       
      subroutine AAtoZZN1_Hres(q1,q2,P,lsign,aa)
C  
C Generated by MadGraph II Version 3.0. Updated 02/19/04                
C RETURNS AMPLITUDE SQUARED SUMMED/AVG OVER COLORS
C FOR THE POINT WITH EXTERNAL LINES W(0:6,NEXTERNAL)
C  
C FOR PROCESS : a a -> e+ e- vm vm~  
C  
      IMPLICIT NONE

      REAL*8 Q1(0:3), Q2(0:3), P(0:3,3:6)
      complex*16 aa(0:3,0:3)
      integer lsign(3:6)

      INTEGER I,J, mu,nu

#include "tensorz.inc"
   
      DO MU = 0,3
         DO NU = 0,3
   
      aa(mu,nu) = 0.0d0

	enddo
      enddo
      
      end	
      
      			
c ------------------------------------------------------------
	
       
      subroutine AZtoZZN1_Hres(q1,q2,P,lsign,az)
C  
C Generated by MadGraph II Version 3.0. Updated 02/19/04                
C RETURNS AMPLITUDE SQUARED SUMMED/AVG OVER COLORS
C FOR THE POINT WITH EXTERNAL LINES W(0:6,NEXTERNAL)
C  
C FOR PROCESS : a z -> e+ e- vm vm~  
C  
      IMPLICIT NONE

      REAL*8 Q1(0:3), Q2(0:3), P(0:3,3:6)
      complex*16 az(0:3,0:3)
      integer lsign(3:6)

      INTEGER I,J,mu,nu

#include "tensorz.inc"

      DO MU = 0,3
         DO NU = 0,3
 
      az(mu,nu) = 0.0d0
		
	  enddo
       enddo	

      END

c ------------------------------------------------------------	
c       
      subroutine ZZtoZZN1_Hres(q1,q2,P,lsign,zz)
C  
C  
C Generated by MadGraph II Version 3.0. Updated 02/19/04                
C RETURNS AMPLITUDE SQUARED SUMMED/AVG OVER COLORS
C FOR THE POINT WITH EXTERNAL LINES W(0:6,NEXTERNAL)
C  
C FOR PROCESS : z z -> e+ e- vm vm~  
C  
      IMPLICIT NONE
C  
C CONSTANTS
C  
      INTEGER    NGRAPHS
      PARAMETER (NGRAPHS=  23) 
      INTEGER    NWAVEFUNCS    
      PARAMETER (NWAVEFUNCS=  38) 
      REAL*8     ZERO
      PARAMETER (ZERO=0D0)
C  
C ARGUMENTS 
C  
      REAL*8 Q1(0:3), Q2(0:3), P(0:3,3:6)
      complex*16 zz(0:3,0:3)
      integer lsign(3:6)
C  
C LOCAL VARIABLES 
C  
      INTEGER I,J,mu,nu
      COMPLEX*16 AMP(NGRAPHS)
      COMPLEX*16 W(6,NWAVEFUNCS)
C  
C GLOBAL VARIABLES
#include "VBFNLO/utilities/coupl.inc"
#include "tensorz.inc"
C   
      logical lswitch
      parameter (lswitch=.true.)
C  
C                                                                          
C ----------
C BEGIN CODE
C ----------

      if (lswitch) then
      	do i = 1,4
	 w(i,3) = lep(i)
	 w(i,4) = lem(i)
	 w(i,6) = lup(i)
	 w(i,5) = lum(i)
	
         w(i,16) =  - zu(i)
         w(i,32) =   ze(i)
       	enddo
      	do i = 5,6
	 w(i,3) = lep(i)
	 w(i,4) = lem(i)
	 w(i,6) = lup(i)
	 w(i,5) = lum(i)
	
         w(i,16) =   zu(i)
         w(i,32) =   ze(i)
       	enddo
      else 
      	CALL IXXXXX(P(0,3   ),ZERO ,-lsign(3   ),-1,W(1,3   ))	 
      	CALL OXXXXX(P(0,4   ),ZERO ,+lsign(4   ),+1,W(1,4   ))	 
     	CALL OXXXXX(P(0,5   ),ZERO ,+lsign(5   ),+1,W(1,5   ))	 
      	CALL IXXXXX(P(0,6   ),ZERO ,-lsign(6   ),-1,W(1,6   ))	 

      	CALL JIOXXX(W(1,3   ),W(1,4   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,32  ))    
      endif

      DO MU = 0,3
         DO NU = 0,3
      
      CALL VCARTX(Q1(0),ZMASS ,zwidth, MU,-1,W(1,1   ))        
      CALL VCARTX(Q2(0),ZMASS ,zwidth, NU,-1,W(1,2   )) 
          
      CALL HVVXXX(W(1,1   ),W(1,2   ),GZZH ,HMASS   ,HWIDTH  ,W(1,         
     &     37  ))                                                          
      CALL JVSXXX(W(1,32  ),W(1,37  ),GZZH ,ZMASS   ,ZWIDTH  ,W(1,         
     &     38  ))                                                          
      CALL IOVXXX(W(1,6   ),W(1,5   ),W(1,38  ),GZN ,AMP(23  ))            
      
      zz(mu,nu)= -AMP(  23)
 
	  enddo
       enddo

      END
