c ************************************************************************************
c Author: Francisco Campanario
c E-mail: francam@particle.uni-karlsruhe.de
c************************************************************************************
c************************************************************************************
c    Declaration of variables 
c************************************************************************************
c***********************************************************************************

        subroutine FermionBoxT(m,p1,p2,p3,p4,mup1,mup2,mup3,mup4,mus
     -   q,gauge,comp,result,resultgauge,Div)
       implicit none
       Real*8   p1(0:3),p2(0:3),p3(0:3),p4(0:3)
       Real*8   p12(0:3),p14(0:3),p23(0:3),p34(0:3)
       Complex*16 mup1(0:3),mup2(0:3),mup3(0:3),mup4(0:3)
       Complex*16 mup1test(0:3),mup2test(0:3),mup3test(0:3),mup4test(0:3)
       Complex*16 result,resulttemp,resulttemp2
       Real*8 musq,m,resultgauge,temp1,temp2,temp3,temp4
       complex*16 rg1,rg2,rg3,rg4
       integer gauge,i,comp,Div

       If (Div.eq.0) then
          call FermionBox(m,p1,p2,p3,p4,mup1,mup2,mup3,mup4,mus
     -   q,gauge,comp,result,resultgauge)
       else
         call FermionBox_Div(m,p1,p2,p3,p4,mup1,mup2,mup3,mup4,mus
     -   q,gauge,comp,result,resultgauge,Div)
       endif
       end





        subroutine FermionBox(m,p1,p2,p3,p4,mup1,mup2,mup3,mup4,mus
     -   q,gauge,comp,result,resultgauge)
       implicit none
       Real*8   p1(0:3),p2(0:3),p3(0:3),p4(0:3)
       Real*8   p12(0:3),p14(0:3),p23(0:3),p34(0:3)
       Complex*16 mup1(0:3),mup2(0:3),mup3(0:3),mup4(0:3)
       Complex*16 mup1test(0:3),mup2test(0:3),mup3test(0:3),mup4test(0:3)
       Complex*16 result,resulttemp,resulttemp2
       Real*8 musq,m,resultgauge,temp1,temp2,temp3,temp4
       complex*16 rg1,rg2,rg3,rg4
       integer gauge,i,comp

        resultgauge=1d99

       call  FermionBoxEven(m,p1,p2,p3,p4,mup1,mup2,mup3,mup4
     &   ,musq,comp,result)

       if (gauge.gt.0) then
       
         do  i=0,3
            mup1test(i)=p1(i)
            mup2test(i)=p2(i)
            mup3test(i)=p3(i)
            mup4test(i)=p4(i)
            p12(i)= p1(i)+p2(i)
            p14(i)= p1(i)+p4(i)
            p23(i)= p2(i)+p3(i)
            p34(i)= p3(i)+p4(i)
         enddo
       
c Call for Gauge

          call fermionBoxEven(m,p1,p2,p3,p4,mup1test,mup2,mup3,mup4,musq,-1,rg1)
          call fermionBoxEven(m,p1,p2,p3,p4,mup1,mup2test,mup3,mup4,musq,-1,rg2)
          call fermionBoxEven(m,p1,p2,p3,p4,mup1,mup2,mup3test,mup4,musq,-1,rg3)
          call fermionBoxEven(m,p1,p2,p3,p4,mup1,mup2,mup3,mup4test,musq,-1,rg4)
c Gauge 1
          call fermionVertEven(m,p12,p3,p4,mup2,mup3,mup4,musq,resulttemp) 
          call fermionVertEven(m,p2,p3,p14,mup2,mup3,mup4,musq,resulttemp2) 
          if (abs(rg1).gt.1d-7) then
          temp1=abs(rg1/(-resulttemp+resulttemp2) -1d0)
          else
          temp1=abs(rg1-(-resulttemp+resulttemp2))   
          endif

c Gauge 2
          call fermionVertEven(m,p1,p23,p4,mup1,mup3,mup4,musq,resulttemp) 
          call fermionVertEven(m,p12,p3,p4,mup1,mup3,mup4,musq,resulttemp2) 
         if (abs(rg2).gt.1d-7) then
          temp2=abs(rg2/(-resulttemp+resulttemp2) -1d0) 
          else
          temp2=abs(rg2 -(-resulttemp+resulttemp2) ) 
          endif

c$$$        print*, "ver1",resulttemp
c$$$       print*, "ver2", resulttemp2
c$$$      
c$$$        IF (temp2.GT.1D66) THEN
c$$$           print*, ' m',m
c$$$           print*, 'musq',musq
c$$$         do i=0,3
c$$$            write(*,'(A3,I1,A2,F25.16)') "p1(",i,")=",p1(i)
c$$$        enddo
c$$$         do i=0,3
c$$$            write(*,'(A3,I1,A2,F25.16)') "p2(",i,")=",p2(i)
c$$$        enddo
c$$$         do i=0,3
c$$$            write(*,'(A3,I1,A2,F25.16)') "p3(",i,")=",p3(i)
c$$$        enddo
c$$$         do i=0,3
c$$$            write(*,'(A3,I1,A2,F25.16)') "p4(",i,")=",p4(i)
c$$$         enddo 
c$$$         do i=0,3
c$$$            write(*,'(A3,I1,A2,F25.16)') "p5(",i,")=",0d0
c$$$        enddo
c$$$         do i=0,3
c$$$            write(*,'(A3,I1,A2,F25.16)') "p6(",i,")=",0d0
c$$$         enddo
c$$$   
c$$$        do i=0,3
c$$$            write(*,'(A5,I1,A2,F25.16,F25.16)') "mup1(",i,")=",mup1(i)
c$$$        enddo
c$$$         do i=0,3
c$$$            write(*,'(A9,I1,A2,F25.16,F25.16)') "mup2(",i,")=",mup2(i)
c$$$        enddo
c$$$         do i=0,3
c$$$            write(*,'(A5,I1,A2,F25.16,F25.16)') "mup3(",i,")=",mup3(i)
c$$$        enddo
c$$$         do i=0,3
c$$$            write(*,'(A7,I1,A2,F25.16,F25.16)') "mup456(",i,")=",mup4(i)
c$$$        enddo
c$$$        endif
c Gauge 3
          call fermionVertEven(m,p1,p2,p34,mup1,mup2,mup4,musq,resulttemp) 
          call fermionVertEven(m,p1,p23,p4,mup1,mup2,mup4,musq,resulttemp2) 
         if (abs(rg3).gt.1d-7) then
          temp3=abs(rg3/(-resulttemp+resulttemp2) -1d0 )
          else
             temp3=abs(rg3-(-resulttemp+resulttemp2) )
         endif

c Gauge 4
          call fermionVertEven(m,p2,p3,p14,mup2,mup3,mup1,musq,resulttemp) 
          call fermionVertEven(m,p1,p2,p34,mup1,mup2,mup3,musq,resulttemp2)
          if (abs(rg4).gt.1d-7) then
          temp4=abs(rg4/(-resulttemp+resulttemp2) -1d0)
          else
          temp4=abs(rg4-(-resulttemp+resulttemp2))
          endif
      
c	read(*,*)

          resultgauge=max(temp1,temp2,temp3,temp4)
        
        endif
         
        end


       subroutine FermionBoxEven(m,p1,p2,p3,p4,mup1,mup2,mup3,mup4,mus
     -   q,comp,result)
c ************************************************************************************
c determine the fermion looop
c Note: No couplings are assigned
c Note: To make it shorter in the promgram: mu_p2,...->mup2,... 
c Notation of External momenta: p1+p2+p3+p4=0 
c mu_p1,mu_p2,mu_p3,mu_p4 should be think as external current 
c************************************************************************************
c************************************************************************************
c************************************************************************************
c************************************************************************************
c    Declaration of variables 
c************************************************************************************
c************************************************************************************
c************************************************************************************
c************************************************************************************
       IMPLICIT NONE
      Real*8   p1(0:3),p2(0:3),p3(0:3),p4(0:3)
       Real*8   p1sq, p1p2, p1p3, p1p4, p2sq, p2p3, p2p4, p3sq, 
     -          p3p4, p4sq
       Real*8   s12, s13, s14, s23, s24, s34
       Complex*16   p1mup1, p1mup2, p1mup3, p1mup4, p2mup1, p2mup2, 
     -          p2mup3, p2mup4, p3mup1, p3mup2, p3mup3, p3mup4, 
     -          p4mup1, p4mup2, p4mup3, p4mup4
       Complex*16   mup1mup2, mup1mup3, mup1mup4, mup2mup3, mup2mup4, 
     -          mup3mup4
       Real*8 dotrr
       Complex*16 B0fin,C0fin,D0fin
       Complex*16 A0fin,B0t1,C0fin1M,D0finG
       EXTERNAL dotrr,A0fin,B0t1,C0fin1M,D0finG,B0fin,C0fin,D0fin
       Complex*16 A0,B012,B013,B014,B023,B024,B034
      Real*8 A0R,A0I,B012R,B013R,B014R,B023R,B024R,B034R
      Real*8 B012I,B013I,B014I,B023I,B024I,B034I
      Real*8 B12R(2,2),B13R(2,2),B14R(2,2),B23R(2,2),B24R(2,2),B34R(2,2)
      Real*8 B12I(2,2),B13I(2,2),B14I(2,2),B23I(2,2),B24I(2,2),B34I(2,2)
       Complex*16 C0123,C0124,C0134,C0234
       Real*8 C0123R,C0124R,C0134R,C0234R
       Real*8 C0123I,C0124I,C0134I,C0234I
       Real*8 C123R(6,3),C124R(6,3),C134R(6,3),C234R(6,3)
       Real*8 C123I(6,3),C124I(6,3),C134I(6,3),C234I(6,3)
       Complex*16 D01234
        Real*8 D01234R
       Real*8 D01234I
       Real*8 D1234R(22,4)
        Real*8 D1234I(22,4)
      Complex*16 F(135)
      Real*8 FI(135),FR(135),P(52)
      Complex*16 mup1(0:3),mup2(0:3),mup3(0:3),mup4(0:3)
      Complex*16 dotrc,dotcc,result,resultn(535)
       Real*8 musq,m,msq
      EXTERNAL   dotrc,dotcc
      Integer alpha,comp
      common/Ffermionbox/F
      common/Pfermionbox/P
      Save/Ffermionbox/
      Save/Pfermionbox/
c************************************************************************************
c************************************************************************************
c************************************************************************************
c************************************************************************************
c************************************************************************************
c************************************************************************************
c************************************************************************************
c************************************************************************************
c       Definition of the scalar products. Not inlcueded the contraction of the
c       moments with the external currents  
c************************************************************************************
c************************************************************************************
c************************************************************************************
c************************************************************************************
c************************************************************************************
c************************************************************************************
c************************************************************************************
       msq=m*m
       p1sq = dotrr(p1,p1)
       p1p2 = dotrr(p1,p2)
       p1p3 = dotrr(p1,p3)
       p1p4 = dotrr(p1,p4)
       p2sq = dotrr(p2,p2)
       p2p3 = dotrr(p2,p3)
       p2p4 = dotrr(p2,p4)
       p3sq = dotrr(p3,p3)
       p3p4 = dotrr(p3,p4)
       p4sq = dotrr(p4,p4)
       s12 = (p1sq +p2sq+ 2*p1p2) 
       s13 = (p1sq +p3sq+ 2*p1p3) 
       s14 = (p1sq +p4sq+ 2*p1p4) 
       s23 = (p2sq +p3sq+ 2*p2p3) 
       s24 = (p2sq +p4sq+ 2*p2p4) 
       s34 = (p3sq +p4sq+ 2*p3p4) 
c       Write(*,'(a5,F20.10)')," p1sq ", p1sq 
c       Write(*,'(a5,F20.10)')," p1p2 ", p1p2
c       Write(*,'(a5,F20.10)')," p1p3 ", p1p3
c       Write(*,'(a5,F20.10)')," p1p4 ", p1p4
c       Write(*,'(a5,F20.10)')," p2sq ", p2sq 
c       Write(*,'(a5,F20.10)')," p2p3 ", p2p3
c       Write(*,'(a5,F20.10)')," p2p4 ", p2p4
c       Write(*,'(a5,F20.10)')," p3sq ", p3sq 
c       Write(*,'(a5,F20.10)')," p3p4 ", p3p4
c       Write(*,'(a5,F20.10)')," p4sq ", p4sq 
c************************************************************************************
c************************************************************************************
c************************************************************************************
c************************************************************************************
c************************************************************************************
c************************************************************************************
c************************************************************************************
c************************************************************************************

       if(comp.ge.1) then


        if(m.gt.1d-6) then
c    Calling C_ij,D_ij Functions    
c************************************************************************************
c************************************************************************************
c************************************************************************************
c************************************************************************************
c************************************************************************************
        A0=A0fin(m,musq)  
        A0R=Dble(A0)   
        A0I=DImag(A0)   
       B012=B0t1(m,p1sq,musq)  
       B013=B0t1(m,s12,musq)   
       B014=B0t1(m,p4sq,musq)   
       B023=B0t1(m,p2sq,musq)  
       B024=B0t1(m,s23,musq)   
       B034=B0t1(m,p3sq,musq)  
c************************************************************************************
       call tens_red2_Re_1M(m,p1sq,A0R,A0I,B012,B012R,B012I,B12R,B12I)
     -    
       call tens_red2_Re_1M(m,s12,A0R,A0I,B013,B013R,B013I,B13R,B13I) 
     -   
       call tens_red2_Re_1M(m,p4sq,A0R,A0I,B014,B014R,B014I,B14R,B14I)
     -    
       call tens_red2_Re_1M(m,p2sq,A0R,A0I,B023,B023R,B023I,B23R,B23I)
     -    
       call tens_red2_Re_1M(m,s23,A0R,A0I,B024,B024R,B024I,B24R,B24I) 
     -   
       call tens_red2_Re_1M(m,p3sq,A0R,A0I,B034,B034R,B034I,B34R,B34I)
     -    
c************************************************************************************
      C0123=C0fin1M(m,p1sq,p2sq,s12) 
      C0124=C0fin1M(m,p1sq,s23,p4sq)  
      C0134=C0fin1M(m,s12,p3sq,p4sq)  
      C0234=C0fin1M(m,p2sq,p3sq,s23) 
c************************************************************************************
c************************************************************************************
c************************************************************************************
       call tens_red3_new_Re_Com_1MRank3(m,p1sq,p2sq,s12,B023R,B013R,B
     -   012R,B23R,B13R,B12R,B023I,B013I,B012I,B23I,B13I,B12I,C0123,C
     -   0123R,C0123I,C123R,C123I) 
       call tens_red3_new_Re_Com_1MRank3(m,p1sq,s23,p4sq,B024R,B014R,B
     -   012R,B24R,B14R,B12R,B024I,B014I,B012I,B24I,B14I,B12I,C0124,C
     -   0124R,C0124I,C124R,C124I) 
       call tens_red3_new_Re_Com_1MRank3(m,s12,p3sq,p4sq,B034R,B014R,B
     -   013R,B34R,B14R,B13R,B034I,B014I,B013I,B34I,B14I,B13I,C0134,C
     -   0134R,C0134I,C134R,C134I) 
       call tens_red3_new_Re_Com_1MRank3(m,p2sq,p3sq,s23,B034R,B024R,B
     -   023R,B34R,B24R,B23R,B034I,B024I,B023I,B34I,B24I,B23I,C0234,C
     -   0234R,C0234I,C234R,C234I) 
c************************************************************************************
c************************************************************************************
cMK call D0finG because D04 is buggy !!!
       D01234=D0finG(m,m,m,m,s12,s23,p1sq,p2sq,p3sq,p4sq,musq)
c************************************************************************************
c************************************************************************************
       call tens_red4_new_Re_Com_1MRank4(m,p1sq,p2sq,p3sq,p1p2,p1p3,p2
     -   p3,C0234R,C0134R,C0124R,C0123R,C234R,C134R,C124R,C123R,C0234
     -   I,C0134I,C0124I,C0123I,C234I,C134I,C124I,C123I,D01234,D01234
     -   R,D01234I,D1234R,D1234I)
c************************************************************************************
c************************************************************************************
c************************************************************************************
c************************************************************************************
      elseif(m.lt.1d-6) then
c************************************************************************************
c************************************************************************************
c************************************************************************************
c************************************************************************************
c    Calling C_ij,D_ij Functions    
c************************************************************************************
c************************************************************************************
c************************************************************************************
c************************************************************************************
       B012=B0fin(p1sq,musq)   
       B013=B0fin(s12,musq)   
       B014=B0fin(p4sq,musq)   
       B023=B0fin(p2sq,musq)  
       B024=B0fin(s23,musq)   
       B034=B0fin(p3sq,musq)  
       call tens_red2_Re(p1sq,B012,B012R,B012I,B12R,B12I) 
       call tens_red2_Re(s12,B013,B013R,B013I,B13R,B13I) 
       call tens_red2_Re(p4sq,B014,B014R,B014I,B14R,B14I) 
       call tens_red2_Re(p2sq,B023,B023R,B023I,B23R,B23I) 
       call tens_red2_Re(s23,B024,B024R,B024I,B24R,B24I) 
       call tens_red2_Re(p3sq,B034,B034R,B034I,B34R,B34I) 
c************************************************************************************
c************************************************************************************
c************************************************************************************
      C0123=C0fin(p1sq,p2sq,s12,musq) 
      C0124=C0fin(p1sq,s23,p4sq,musq)  
      C0134=C0fin(s12,p3sq,p4sq,musq)  
      C0234=C0fin(p2sq,p3sq,s23,musq) 
c************************************************************************************
c************************************************************************************
       call tens_red3_new_Re_ComRank3(p1sq,p2sq,s12,B023R,B013R,B012R,
     -   B23R,B13R,B12R,B023I,B013I,B012I,B23I,B13I,B12I,C0123,C0123R
     -   ,C0123I,C123R,C123I) 
       call tens_red3_new_Re_ComRank3(p1sq,s23,p4sq,B024R,B014R,B012R,
     -   B24R,B14R,B12R,B024I,B014I,B012I,B24I,B14I,B12I,C0124,C0124R
     -   ,C0124I,C124R,C124I) 
       call tens_red3_new_Re_ComRank3(s12,p3sq,p4sq,B034R,B014R,B013R,
     -   B34R,B14R,B13R,B034I,B014I,B013I,B34I,B14I,B13I,C0134,C0134R
     -   ,C0134I,C134R,C134I) 
       call tens_red3_new_Re_ComRank3(p2sq,p3sq,s23,B034R,B024R,B023R,
     -   B34R,B24R,B23R,B034I,B024I,B023I,B34I,B24I,B23I,C0234,C0234R
     -   ,C0234I,C234R,C234I) 
c************************************************************************************
c************************************************************************************
         D01234=D0fin(s12,s23,p1sq,p2sq,p3sq,p4sq,musq)
c       Print*," D0",D0
c************************************************************************************
c************************************************************************************
       call tens_red4_new_Re_ComRank4(p1sq,p2sq,p3sq,p1p2,p1p3,p2p3,C0
     -   234R,C0134R,C0124R,C0123R,C234R,C134R,C124R,C123R,C0234I,C01
     -   34I,C0124I,C0123I,C234I,C134I,C124I,C123I,D01234,D01234R,D01
     -   234I,D1234R,D1234I)
         endif
c       Definition of the F,P functions:Independent of the currents    
c************************************************************************************
c************************************************************************************
c************************************************************************************
c************************************************************************************
c************************************************************************************
       P(1) = p1sq*p3sq+p2sq*p4sq-s12*s23
       P(2) = p1sq+p2sq+p3sq+p4sq-2*s23
       P(3) = -p1sq-p2sq+s12
       P(4) = -p1sq-p4sq+s23
       P(5) = -p3sq-p4sq+s12
       P(6) = -p2sq-p3sq+s23
       FR(1) = 2*(B013R+B024R)-8*(C124R(4,2)+C234R(4,2))+32*D1234R(22,
     -   4)+D01234R*P(1)+4*D1234R(7,2)*P(2)+C0123R*P(3)+C0124R*P(4)+C
     -   0134R*P(5)+C0234R*P(6)
       FI(1) = 2*(B013I+B024I)-8*(C124I(4,2)+C234I(4,2))+32*D1234I(22,
     -   4)+D01234I*P(1)+4*D1234I(7,2)*P(2)+C0123I*P(3)+C0124I*P(4)+C
     -   0134I*P(5)+C0234I*P(6)
       F(1)=DCMPLX(FR(1),FI(1))
       P(7) = -(p1sq*p3sq)-p2sq*p4sq+s12*s23
       P(8) = s12+s23
       P(9) = p1sq+p2sq+p3sq+p4sq-2*P(8)
       P(10) = p1sq+p2sq-s12
       P(11) = p1sq+p4sq-s23
       P(12) = p3sq+p4sq-s12
       P(13) = p2sq+p3sq-s23
       FR(2) = -2*(B013R+B024R)+32*D1234R(22,4)+D01234R*P(7)-4*D1234R(
     -   7,2)*P(9)+C0123R*P(10)+C0124R*P(11)+C0134R*P(12)+C0234R*P(13
     -   )
       FI(2) = -2*(B013I+B024I)+32*D1234I(22,4)+D01234I*P(7)-4*D1234I(
     -   7,2)*P(9)+C0123I*P(10)+C0124I*P(11)+C0134I*P(12)+C0234I*P(13
     -   )
       F(2)=DCMPLX(FR(2),FI(2))
       P(14) = p1sq+p2sq+p3sq+p4sq-2*s12
       FR(3) = 2*(B013R+B024R)-8*(C123R(4,2)+C134R(4,2))+32*D1234R(22,
     -   4)+D01234R*P(1)+C0123R*P(3)+C0124R*P(4)+C0134R*P(5)+C0234R*P
     -   (6)+4*D1234R(7,2)*P(14)
       FI(3) = 2*(B013I+B024I)-8*(C123I(4,2)+C134I(4,2))+32*D1234I(22,
     -   4)+D01234I*P(1)+C0123I*P(3)+C0124I*P(4)+C0134I*P(5)+C0234I*P
     -   (6)+4*D1234I(7,2)*P(14)
       F(3)=DCMPLX(FR(3),FI(3))
       P(15) = p1sq-s12
       P(16) = p2sq+2*P(15)
       FR(4) = 4*(C0124R-C0134R+C124R(1,1)-3*C134R(1,1)-2*C134R(1,2)+4
     -   *D1234R(7,2)+12*D1234R(11,3)+8*D1234R(16,4)+D1234R(1,2)*P(10
     -   )+D01234R*P(15)+D1234R(1,1)*P(16))
       FI(4) = 4*(C0124I-C0134I+C124I(1,1)-3*C134I(1,1)-2*C134I(1,2)+4
     -   *D1234I(7,2)+12*D1234I(11,3)+8*D1234I(16,4)+D1234I(1,2)*P(10
     -   )+D01234I*P(15)+D1234I(1,1)*P(16))
       F(4)=DCMPLX(FR(4),FI(4))
       P(17) = p4sq-s12
       P(18) = p3sq+2*P(17)
       FR(5) = 4*(-C0123R+C0124R-3*C123R(1,1)-2*C123R(1,2)+C124R(1,1)+
     -   4*D1234R(7,2)+12*D1234R(11,3)+8*D1234R(16,4)+D1234R(1,2)*P(1
     -   2)+D01234R*P(17)+D1234R(1,1)*P(18))
       FI(5) = 4*(-C0123I+C0124I-3*C123I(1,1)-2*C123I(1,2)+C124I(1,1)+
     -   4*D1234I(7,2)+12*D1234I(11,3)+8*D1234I(16,4)+D1234I(1,2)*P(1
     -   2)+D01234I*P(17)+D1234I(1,1)*P(18))
       F(5)=DCMPLX(FR(5),FI(5))
       FR(6) = -8*(C124R(1,1)+C124R(1,2)-4*(D1234R(11,3)+D1234R(16,4))
     -   )+4*(D1234R(1,1)+D1234R(1,2))*P(13)
       FI(6) = -8*(C124I(1,1)+C124I(1,2)-4*(D1234I(11,3)+D1234I(16,4))
     -   )+4*(D1234I(1,1)+D1234I(1,2))*P(13)
       F(6)=DCMPLX(FR(6),FI(6))
       P(19) = p1sq+p4sq
       P(20) = s23-2*P(19)
       FR(7) = -4*(C0123R+C0134R+C123R(1,1)+C134R(1,1)-16*D1234R(11,3)
     -   -8*(D1234R(7,2)+D1234R(16,4))-D1234R(1,2)*P(11)-D01234R*P(19
     -   )+D1234R(1,1)*P(20))
       FI(7) = -4*(C0123I+C0134I+C123I(1,1)+C134I(1,1)-16*D1234I(11,3)
     -   -8*(D1234I(7,2)+D1234I(16,4))-D1234I(1,2)*P(11)-D01234I*P(19
     -   )+D1234I(1,1)*P(20))
       F(7)=DCMPLX(FR(7),FI(7))
       P(21) = p3sq-s23
       P(22) = 2*P(15)+P(21)
       P(23) = p1sq+p3sq-s12-s23
       FR(8) = -4*(C0124R-C0134R+C124R(1,1)-C134R(1,1)-4*D1234R(7,2)-1
     -   2*D1234R(11,3)-8*D1234R(16,4)+D01234R*P(15)+D1234R(1,1)*P(22
     -   )+D1234R(1,2)*P(23))
       FI(8) = -4*(C0124I-C0134I+C124I(1,1)-C134I(1,1)-4*D1234I(7,2)-1
     -   2*D1234I(11,3)-8*D1234I(16,4)+D01234I*P(15)+D1234I(1,1)*P(22
     -   )+D1234I(1,2)*P(23))
       F(8)=DCMPLX(FR(8),FI(8))
       P(24) = p2sq-s23
       P(25) = 2*P(17)+P(24)
       P(26) = p2sq+p4sq-s12-s23
       FR(9) = 4*(C0123R-C0124R+C123R(1,1)-C124R(1,1)+4*D1234R(7,2)+12
     -   *D1234R(11,3)+8*D1234R(16,4)-D01234R*P(17)-D1234R(1,1)*P(25)
     -   -D1234R(1,2)*P(26))
       FI(9) = 4*(C0123I-C0124I+C123I(1,1)-C124I(1,1)+4*D1234I(7,2)+12
     -   *D1234I(11,3)+8*D1234I(16,4)-D01234I*P(17)-D1234I(1,1)*P(25)
     -   -D1234I(1,2)*P(26))
       F(9)=DCMPLX(FR(9),FI(9))
       P(27) = p4sq+s12
       P(28) = 2*p1sq-P(27)
       P(29) = 2*p1sq+p2sq-p4sq-s12+s23
       P(30) = p2sq+p3sq-s23+2*P(15)
       FR(10) = 2*(C0123R+C0124R-6*C134R(1,1)-4*C134R(1,2)+8*(D1234R(7
     -   ,2)+D1234R(12,3))+16*(D1234R(11,3)+D1234R(19,4))-2*(C0134R-D
     -   1234R(4,2)*P(10))+D01234R*P(28)+D1234R(1,1)*P(29)+D1234R(2,1
     -   )*P(30))
       FI(10) = 2*(C0123I+C0124I-6*C134I(1,1)-4*C134I(1,2)+8*(D1234I(7
     -   ,2)+D1234I(12,3))+16*(D1234I(11,3)+D1234I(19,4))-2*(C0134I-D
     -   1234I(4,2)*P(10))+D01234I*P(28)+D1234I(1,1)*P(29)+D1234I(2,1
     -   )*P(30))
       F(10)=DCMPLX(FR(10),FI(10))
       P(31) = 2*p1sq+p4sq-s12
       P(32) = 2*p1sq+p2sq+p4sq-s12-s23
       P(33) = p2sq-p3sq+s23+2*P(15)
       FR(11) = 2*(-C0123R+C0124R-6*C134R(1,1)-4*C134R(1,2)+8*(D1234R(
     -   7,2)+D1234R(11,3))+16*(D1234R(12,3)+D1234R(19,4))-2*(C0134R-
     -   C124R(2,1)-D1234R(4,2)*P(10))+D01234R*P(31)+D1234R(1,1)*P(32
     -   )+D1234R(2,1)*P(33))
       FI(11) = 2*(-C0123I+C0124I-6*C134I(1,1)-4*C134I(1,2)+8*(D1234I(
     -   7,2)+D1234I(11,3))+16*(D1234I(12,3)+D1234I(19,4))-2*(C0134I-
     -   C124I(2,1)-D1234I(4,2)*P(10))+D01234I*P(31)+D1234I(1,1)*P(32
     -   )+D1234I(2,1)*P(33))
       F(11)=DCMPLX(FR(11),FI(11))
       P(34) = p2sq-p4sq+s12-s23
       P(35) = p2sq+p3sq-s23+2*P(17)
       FR(12) = 2*(-C0123R+C0124R-4*(C123R(3,2)-D1234R(7,2))+8*(D1234R
     -   (11,3)+D1234R(12,3))+16*D1234R(19,4)-2*(C123R(1,1)+C123R(2,1
     -   )-C124R(1,1)-D1234R(4,2)*P(12))+D01234R*P(17)-D1234R(1,1)*P(
     -   34)+D1234R(2,1)*P(35))
       FI(12) = 2*(-C0123I+C0124I-4*(C123I(3,2)-D1234I(7,2))+8*(D1234I
     -   (11,3)+D1234I(12,3))+16*D1234I(19,4)-2*(C123I(1,1)+C123I(2,1
     -   )-C124I(1,1)-D1234I(4,2)*P(12))+D01234I*P(17)-D1234I(1,1)*P(
     -   34)+D1234I(2,1)*P(35))
       F(12)=DCMPLX(FR(12),FI(12))
       P(36) = -p2sq+p3sq+s23+2*P(17)
       FR(13) = 2*(-C0123R+C0124R-4*(C123R(2,1)+C123R(3,2)-D1234R(7,2)
     -   )+16*(D1234R(12,3)+D1234R(19,4))+2*(C124R(2,1)+D1234R(4,2)*P
     -   (12))+D01234R*P(17)+D1234R(1,1)*P(26)+D1234R(2,1)*P(36))
       FI(13) = 2*(-C0123I+C0124I-4*(C123I(2,1)+C123I(3,2)-D1234I(7,2)
     -   )+16*(D1234I(12,3)+D1234I(19,4))+2*(C124I(2,1)+D1234I(4,2)*P
     -   (12))+D01234I*P(17)+D1234I(1,1)*P(26)+D1234I(2,1)*P(36))
       F(13)=DCMPLX(FR(13),FI(13))
       FR(14) = 2*(-C0123R+C0124R-2*C124R(2,1)-4*(C124R(3,2)+D1234R(7,
     -   2))+8*D1234R(12,3)+16*D1234R(19,4)+(D1234R(2,1)+2*D1234R(4,2
     -   ))*P(13)+D01234R*P(17)+D1234R(1,1)*P(26))
       FI(14) = 2*(-C0123I+C0124I-2*C124I(2,1)-4*(C124I(3,2)+D1234I(7,
     -   2))+8*D1234I(12,3)+16*D1234I(19,4)+(D1234I(2,1)+2*D1234I(4,2
     -   ))*P(13)+D01234I*P(17)+D1234I(1,1)*P(26))
       F(14)=DCMPLX(FR(14),FI(14))
       FR(15) = 2*(C0123R-C0124R+2*(C123R(1,1)-C124R(1,1)-C124R(2,1))-
     -   4*(C124R(3,2)-D1234R(7,2))+8*(D1234R(11,3)+D1234R(12,3))+16*
     -   D1234R(19,4)+(D1234R(2,1)+2*D1234R(4,2))*P(13)-D01234R*P(17)
     -   +D1234R(1,1)*P(34))
       FI(15) = 2*(C0123I-C0124I+2*(C123I(1,1)-C124I(1,1)-C124I(2,1))-
     -   4*(C124I(3,2)-D1234I(7,2))+8*(D1234I(11,3)+D1234I(12,3))+16*
     -   D1234I(19,4)+(D1234I(2,1)+2*D1234I(4,2))*P(13)-D01234I*P(17)
     -   +D1234I(1,1)*P(34))
       F(15)=DCMPLX(FR(15),FI(15))
       P(37) = 2*p1sq+p4sq+s12
       P(38) = 2*p1sq-p2sq+p4sq+s12-s23
       P(39) = p2sq-p3sq-s23+2*P(19)
       FR(16) = 2*(-C0123R-C0124R+16*(D1234R(7,2)+D1234R(11,3)+D1234R(
     -   12,3)+D1234R(19,4))-2*(C0134R+C134R(1,1)-D1234R(4,2)*P(11))+
     -   D01234R*P(37)+D1234R(1,1)*P(38)+D1234R(2,1)*P(39))
       FI(16) = 2*(-C0123I-C0124I+16*(D1234I(7,2)+D1234I(11,3)+D1234I(
     -   12,3)+D1234I(19,4))-2*(C0134I+C134I(1,1)-D1234I(4,2)*P(11))+
     -   D01234I*P(37)+D1234I(1,1)*P(38)+D1234I(2,1)*P(39))
       F(16)=DCMPLX(FR(16),FI(16))
       P(40) = -p2sq+p3sq-s23+2*P(19)
       FR(17) = 2*(-C0123R+C0124R+8*(D1234R(7,2)+D1234R(11,3))+16*(D12
     -   34R(12,3)+D1234R(19,4))-2*(C0134R+C123R(2,1)+C134R(1,1)-D123
     -   4R(4,2)*P(11))+D01234R*P(31)+D1234R(1,1)*P(32)+D1234R(2,1)*P
     -   (40))
       FI(17) = 2*(-C0123I+C0124I+8*(D1234I(7,2)+D1234I(11,3))+16*(D12
     -   34I(12,3)+D1234I(19,4))-2*(C0134I+C123I(2,1)+C134I(1,1)-D123
     -   4I(4,2)*P(11))+D01234I*P(31)+D1234I(1,1)*P(32)+D1234I(2,1)*P
     -   (40))
       F(17)=DCMPLX(FR(17),FI(17))
       P(41) = -2*p1sq+p4sq+s12
       P(42) = -2*p1sq+p2sq+p4sq+s12+s23
       FR(18) = -2*(C0123R+C0124R-8*(D1234R(7,2)+D1234R(12,3))-16*(D12
     -   34R(11,3)+D1234R(19,4))-2*(C0134R-C123R(1,1)-C124R(1,1)+C134
     -   R(1,1)-D1234R(4,2)*P(23))+D1234R(2,1)*P(30)-D01234R*P(41)-D1
     -   234R(1,1)*P(42))
       FI(18) = -2*(C0123I+C0124I-8*(D1234I(7,2)+D1234I(12,3))-16*(D12
     -   34I(11,3)+D1234I(19,4))-2*(C0134I-C123I(1,1)-C124I(1,1)+C134
     -   I(1,1)-D1234I(4,2)*P(23))+D1234I(2,1)*P(30)-D01234I*P(41)-D1
     -   234I(1,1)*P(42))
       F(18)=DCMPLX(FR(18),FI(18))
       P(43) = p2sq-p3sq+s23-2*P(15)
       FR(19) = 2*(C0123R-C0124R+16*(D1234R(12,3)+D1234R(19,4))+2*(C01
     -   34R-C124R(2,1)+C134R(1,1)-D1234R(4,2)*P(23))-D01234R*P(31)-D
     -   1234R(1,1)*P(32)+D1234R(2,1)*P(43))
       FI(19) = 2*(C0123I-C0124I+16*(D1234I(12,3)+D1234I(19,4))+2*(C01
     -   34I-C124I(2,1)+C134I(1,1)-D1234I(4,2)*P(23))-D01234I*P(31)-D
     -   1234I(1,1)*P(32)+D1234I(2,1)*P(43))
       F(19)=DCMPLX(FR(19),FI(19))
       FR(20) = 2*(C0123R-C0124R+2*C123R(2,1)+4*D1234R(7,2)+8*(D1234R(
     -   11,3)+D1234R(12,3))+16*D1234R(19,4)-D01234R*P(17)-(D1234R(1,
     -   1)+2*D1234R(4,2))*P(26)-D1234R(2,1)*P(35))
       FI(20) = 2*(C0123I-C0124I+2*C123I(2,1)+4*D1234I(7,2)+8*(D1234I(
     -   11,3)+D1234I(12,3))+16*D1234I(19,4)-D01234I*P(17)-(D1234I(1,
     -   1)+2*D1234I(4,2))*P(26)-D1234I(2,1)*P(35))
       F(20)=DCMPLX(FR(20),FI(20))
       P(44) = -p2sq+p3sq+s23-2*P(17)
       FR(21) = 2*(C0123R-C0124R-2*C124R(2,1)+4*D1234R(7,2)+8*D1234R(1
     -   1,3)+16*(D1234R(12,3)+D1234R(19,4))-D01234R*P(17)-(D1234R(1,
     -   1)+2*D1234R(4,2))*P(26)+D1234R(2,1)*P(44))
       FI(21) = 2*(C0123I-C0124I-2*C124I(2,1)+4*D1234I(7,2)+8*D1234I(1
     -   1,3)+16*(D1234I(12,3)+D1234I(19,4))-D01234I*P(17)-(D1234I(1,
     -   1)+2*D1234I(4,2))*P(26)+D1234I(2,1)*P(44))
       F(21)=DCMPLX(FR(21),FI(21))
       P(45) = 2*p1sq+p2sq-s12
       FR(22) = -4*(C0134R+C0234R-D01234R*p1sq+3*C134R(1,1)+2*C134R(1,
     -   2)+C234R(1,1)-4*D1234R(7,2)-12*D1234R(12,3)-8*D1234R(17,4)-D
     -   1234R(2,2)*P(10)-D1234R(2,1)*P(45))
       FI(22) = -4*(C0134I+C0234I-D01234I*p1sq+3*C134I(1,1)+2*C134I(1,
     -   2)+C234I(1,1)-4*D1234I(7,2)-12*D1234I(12,3)-8*D1234I(17,4)-D
     -   1234I(2,2)*P(10)-D1234I(2,1)*P(45))
       F(22)=DCMPLX(FR(22),FI(22))
       FR(23) = 4*(-C123R(2,1)-2*C123R(2,2)+C124R(2,1)+4*D1234R(12,3)+
     -   8*D1234R(17,4)+D1234R(2,2)*P(12)+D1234R(2,1)*P(17))
       FI(23) = 4*(-C123I(2,1)-2*C123I(2,2)+C124I(2,1)+4*D1234I(12,3)+
     -   8*D1234I(17,4)+D1234I(2,2)*P(12)+D1234I(2,1)*P(17))
       F(23)=DCMPLX(FR(23),FI(23))
       FR(24) = 4*(C123R(2,1)-C124R(2,1)-2*C124R(2,2)+4*D1234R(12,3)+8
     -   *D1234R(17,4)+D1234R(2,2)*P(13)+D1234R(2,1)*P(24))
       FI(24) = 4*(C123I(2,1)-C124I(2,1)-2*C124I(2,2)+4*D1234I(12,3)+8
     -   *D1234I(17,4)+D1234I(2,2)*P(13)+D1234I(2,1)*P(24))
       F(24)=DCMPLX(FR(24),FI(24))
       P(46) = 2*p1sq+p4sq-s23
       FR(25) = -4*(C0134R+C0234R-D01234R*p1sq+C134R(1,1)+3*C234R(1,1)
     -   +2*C234R(1,2)-4*D1234R(7,2)-12*D1234R(12,3)-8*D1234R(17,4)-D
     -   1234R(2,2)*P(11)-D1234R(2,1)*P(46))
       FI(25) = -4*(C0134I+C0234I-D01234I*p1sq+C134I(1,1)+3*C234I(1,1)
     -   +2*C234I(1,2)-4*D1234I(7,2)-12*D1234I(12,3)-8*D1234I(17,4)-D
     -   1234I(2,2)*P(11)-D1234I(2,1)*P(46))
       F(25)=DCMPLX(FR(25),FI(25))
       P(47) = -2*p1sq+s12+s23
       FR(26) = 4*(C0134R+C0234R-D01234R*p1sq-C123R(2,1)-C124R(2,1)+C1
     -   34R(1,1)+C234R(1,1)+8*(D1234R(12,3)+D1234R(17,4))-D1234R(2,2
     -   )*P(23)+D1234R(2,1)*P(47))
       FI(26) = 4*(C0134I+C0234I-D01234I*p1sq-C123I(2,1)-C124I(2,1)+C1
     -   34I(1,1)+C234I(1,1)+8*(D1234I(12,3)+D1234I(17,4))-D1234I(2,2
     -   )*P(23)+D1234I(2,1)*P(47))
       F(26)=DCMPLX(FR(26),FI(26))
       FR(27) = 32*(D1234R(12,3)+D1234R(17,4))-4*(D1234R(2,1)+D1234R(2
     -   ,2))*P(26)
       FI(27) = 32*(D1234I(12,3)+D1234I(17,4))-4*(D1234I(2,1)+D1234I(2
     -   ,2))*P(26)
       F(27)=DCMPLX(FR(27),FI(27))
       FR(28) = 2*(C0124R-C0134R-2*(C134R(1,1)+C134R(2,1))-4*(C134R(3,
     -   2)-D1234R(7,2))+8*(D1234R(11,3)+D1234R(13,3))+16*D1234R(20,4
     -   )+(D1234R(1,1)+2*D1234R(5,2))*P(10)+D01234R*P(15)+D1234R(3,1
     -   )*P(30))
       FI(28) = 2*(C0124I-C0134I-2*(C134I(1,1)+C134I(2,1))-4*(C134I(3,
     -   2)-D1234I(7,2))+8*(D1234I(11,3)+D1234I(13,3))+16*D1234I(20,4
     -   )+(D1234I(1,1)+2*D1234I(5,2))*P(10)+D01234I*P(15)+D1234I(3,1
     -   )*P(30))
       F(28)=DCMPLX(FR(28),FI(28))
       FR(29) = 2*(C0124R-C0134R-2*(-C124R(2,1)+C134R(1,1))-4*(C134R(2
     -   ,1)+C134R(3,2)-D1234R(7,2))+8*D1234R(11,3)+16*(D1234R(13,3)+
     -   D1234R(20,4))+(D1234R(1,1)+2*D1234R(5,2))*P(10)+D01234R*P(15
     -   )+D1234R(3,1)*P(33))
       FI(29) = 2*(C0124I-C0134I-2*(-C124I(2,1)+C134I(1,1))-4*(C134I(2
     -   ,1)+C134I(3,2)-D1234I(7,2))+8*D1234I(11,3)+16*(D1234I(13,3)+
     -   D1234I(20,4))+(D1234I(1,1)+2*D1234I(5,2))*P(10)+D01234I*P(15
     -   )+D1234I(3,1)*P(33))
       F(29)=DCMPLX(FR(29),FI(29))
       P(48) = p1sq-p2sq-s12
       FR(30) = 2*(C0124R-C0134R+8*D1234R(13,3)+16*D1234R(20,4)+2*(C12
     -   4R(1,1)+D1234R(5,2)*P(12))+D01234R*P(15)+D1234R(3,1)*P(35)+D
     -   1234R(1,1)*P(48))
       FI(30) = 2*(C0124I-C0134I+8*D1234I(13,3)+16*D1234I(20,4)+2*(C12
     -   4I(1,1)+D1234I(5,2)*P(12))+D01234I*P(15)+D1234I(3,1)*P(35)+D
     -   1234I(1,1)*P(48))
       F(30)=DCMPLX(FR(30),FI(30))
       P(49) = p1sq+s12
       P(50) = p1sq-p2sq+s12
       FR(31) = 2*(C0124R+C0134R+16*(D1234R(13,3)+D1234R(20,4))+2*(C12
     -   4R(2,1)+D1234R(5,2)*P(12))+D1234R(3,1)*P(36)-D01234R*P(49)-D
     -   1234R(1,1)*P(50))
       FI(31) = 2*(C0124I+C0134I+16*(D1234I(13,3)+D1234I(20,4))+2*(C12
     -   4I(2,1)+D1234I(5,2)*P(12))+D1234I(3,1)*P(36)-D01234I*P(49)-D
     -   1234I(1,1)*P(50))
       F(31)=DCMPLX(FR(31),FI(31))
       FR(32) = 2*(C0124R-C0134R-2*(C124R(2,1)+C134R(1,1))-4*(C124R(3,
     -   2)+D1234R(7,2))+8*D1234R(13,3)+16*D1234R(20,4)+D1234R(1,1)*P
     -   (10)+(D1234R(3,1)+2*D1234R(5,2))*P(13)+D01234R*P(15))
       FI(32) = 2*(C0124I-C0134I-2*(C124I(2,1)+C134I(1,1))-4*(C124I(3,
     -   2)+D1234I(7,2))+8*D1234I(13,3)+16*D1234I(20,4)+D1234I(1,1)*P
     -   (10)+(D1234I(3,1)+2*D1234I(5,2))*P(13)+D01234I*P(15))
       F(32)=DCMPLX(FR(32),FI(32))
       P(51) = -p1sq+p2sq+s12
       FR(33) = 2*(-C0124R+C0134R-2*(C124R(1,1)+C124R(2,1))-4*(C124R(3
     -   ,2)-D1234R(7,2))+8*(D1234R(11,3)+D1234R(13,3))+16*D1234R(20,
     -   4)+(D1234R(3,1)+2*D1234R(5,2))*P(13)-D01234R*P(15)+D1234R(1,
     -   1)*P(51))
       FI(33) = 2*(-C0124I+C0134I-2*(C124I(1,1)+C124I(2,1))-4*(C124I(3
     -   ,2)-D1234I(7,2))+8*(D1234I(11,3)+D1234I(13,3))+16*D1234I(20,
     -   4)+(D1234I(3,1)+2*D1234I(5,2))*P(13)-D01234I*P(15)+D1234I(1,
     -   1)*P(51))
       F(33)=DCMPLX(FR(33),FI(33))
       FR(34) = 2*(-C0124R-C0134R+8*(D1234R(7,2)+D1234R(11,3))+16*(D12
     -   34R(13,3)+D1234R(20,4))-2*(C134R(2,1)-D1234R(5,2)*P(11))+D12
     -   34R(3,1)*P(39)+D01234R*P(49)+D1234R(1,1)*P(50))
       FI(34) = 2*(-C0124I-C0134I+8*(D1234I(7,2)+D1234I(11,3))+16*(D12
     -   34I(13,3)+D1234I(20,4))-2*(C134I(2,1)-D1234I(5,2)*P(11))+D12
     -   34I(3,1)*P(39)+D01234I*P(49)+D1234I(1,1)*P(50))
       F(34)=DCMPLX(FR(34),FI(34))
       FR(35) = 2*(C0124R-C0134R+16*(D1234R(13,3)+D1234R(20,4))+D1234R
     -   (1,1)*P(10)-2*(C134R(1,1)-D1234R(5,2)*P(11))+D01234R*P(15)+D
     -   1234R(3,1)*P(40))
       FI(35) = 2*(C0124I-C0134I+16*(D1234I(13,3)+D1234I(20,4))+D1234I
     -   (1,1)*P(10)-2*(C134I(1,1)-D1234I(5,2)*P(11))+D01234I*P(15)+D
     -   1234I(3,1)*P(40))
       F(35)=DCMPLX(FR(35),FI(35))
       FR(36) = -2*(C0124R-C0134R-4*D1234R(7,2)-8*(D1234R(11,3)+D1234R
     -   (13,3))-16*D1234R(20,4)+D01234R*P(15)+2*(C124R(1,1)-C134R(2,
     -   1)+D1234R(5,2)*P(23))+D1234R(3,1)*P(30)-D1234R(1,1)*P(51))
       FI(36) = -2*(C0124I-C0134I-4*D1234I(7,2)-8*(D1234I(11,3)+D1234I
     -   (13,3))-16*D1234I(20,4)+D01234I*P(15)+2*(C124I(1,1)-C134I(2,
     -   1)+D1234I(5,2)*P(23))+D1234I(3,1)*P(30)-D1234I(1,1)*P(51))
       F(36)=DCMPLX(FR(36),FI(36))
       FR(37) = 2*(-C0124R+C0134R+4*D1234R(7,2)+16*(D1234R(13,3)+D1234
     -   R(20,4))-D1234R(1,1)*P(10)-D01234R*P(15)+2*(-C124R(2,1)+C134
     -   R(1,1)-D1234R(5,2)*P(23))+D1234R(3,1)*P(43))
       FI(37) = 2*(-C0124I+C0134I+4*D1234I(7,2)+16*(D1234I(13,3)+D1234
     -   I(20,4))-D1234I(1,1)*P(10)-D01234I*P(15)+2*(-C124I(2,1)+C134
     -   I(1,1)-D1234I(5,2)*P(23))+D1234I(3,1)*P(43))
       F(37)=DCMPLX(FR(37),FI(37))
       FR(38) = -2*(C0124R-C0134R-8*D1234R(13,3)-16*D1234R(20,4)+D1234
     -   R(1,1)*P(10)+D01234R*P(15)-2*(C134R(1,1)-D1234R(5,2)*P(26))+
     -   D1234R(3,1)*P(35))
       FI(38) = -2*(C0124I-C0134I-8*D1234I(13,3)-16*D1234I(20,4)+D1234
     -   I(1,1)*P(10)+D01234I*P(15)-2*(C134I(1,1)-D1234I(5,2)*P(26))+
     -   D1234I(3,1)*P(35))
       F(38)=DCMPLX(FR(38),FI(38))
       FR(39) = 2*(-C0124R-C0134R+8*(D1234R(7,2)+D1234R(11,3))+16*(D12
     -   34R(13,3)+D1234R(20,4))-2*(C124R(2,1)+D1234R(5,2)*P(26))+D12
     -   34R(3,1)*P(44)+D01234R*P(49)+D1234R(1,1)*P(50))
       FI(39) = 2*(-C0124I-C0134I+8*(D1234I(7,2)+D1234I(11,3))+16*(D12
     -   34I(13,3)+D1234I(20,4))-2*(C124I(2,1)+D1234I(5,2)*P(26))+D12
     -   34I(3,1)*P(44)+D01234I*P(49)+D1234I(1,1)*P(50))
       F(39)=DCMPLX(FR(39),FI(39))
       FR(40) = 2*(-C0134R-C0234R+D01234R*p1sq-2*(C134R(1,1)+C134R(2,1
     -   )+C234R(2,1))-4*(C134R(3,2)-D1234R(7,2))+8*(D1234R(12,3)+D12
     -   34R(13,3))+16*D1234R(21,4)+(D1234R(2,1)+2*D1234R(6,2))*P(10)
     -   +D1234R(3,1)*P(32))
       FI(40) = 2*(-C0134I-C0234I+D01234I*p1sq-2*(C134I(1,1)+C134I(2,1
     -   )+C234I(2,1))-4*(C134I(3,2)-D1234I(7,2))+8*(D1234I(12,3)+D12
     -   34I(13,3))+16*D1234I(21,4)+(D1234I(2,1)+2*D1234I(6,2))*P(10)
     -   +D1234I(3,1)*P(32))
       F(40)=DCMPLX(FR(40),FI(40))
       FR(41) = 2*(-C0134R-C0234R+D01234R*p1sq-2*C134R(1,1)-4*(C134R(2
     -   ,1)+C134R(3,2)-D1234R(7,2))+8*D1234R(12,3)+16*(D1234R(13,3)+
     -   D1234R(21,4))+(D1234R(2,1)+2*D1234R(6,2))*P(10)+D1234R(3,1)*
     -   P(29))
       FI(41) = 2*(-C0134I-C0234I+D01234I*p1sq-2*C134I(1,1)-4*(C134I(2
     -   ,1)+C134I(3,2)-D1234I(7,2))+8*D1234I(12,3)+16*(D1234I(13,3)+
     -   D1234I(21,4))+(D1234I(2,1)+2*D1234I(6,2))*P(10)+D1234I(3,1)*
     -   P(29))
       F(41)=DCMPLX(FR(41),FI(41))
       FR(42) = 2*(-C0134R-C0234R+D01234R*p1sq+16*D1234R(21,4)+2*(C124
     -   R(2,1)+D1234R(6,2)*P(12))+D1234R(3,1)*P(26)+D1234R(2,1)*P(48
     -   ))
       FI(42) = 2*(-C0134I-C0234I+D01234I*p1sq+16*D1234I(21,4)+2*(C124
     -   I(2,1)+D1234I(6,2)*P(12))+D1234I(3,1)*P(26)+D1234I(2,1)*P(48
     -   ))
       F(42)=DCMPLX(FR(42),FI(42))
       FR(43) = 2*(C0134R+C0234R-D01234R*p1sq+8*D1234R(13,3)+16*D1234R
     -   (21,4)+2*(C124R(2,1)+C234R(1,1)+D1234R(6,2)*P(12))-D1234R(3,
     -   1)*P(34)-D1234R(2,1)*P(50))
       FI(43) = 2*(C0134I+C0234I-D01234I*p1sq+8*D1234I(13,3)+16*D1234I
     -   (21,4)+2*(C124I(2,1)+C234I(1,1)+D1234I(6,2)*P(12))-D1234I(3,
     -   1)*P(34)-D1234I(2,1)*P(50))
       F(43)=DCMPLX(FR(43),FI(43))
       FR(44) = 2*(C0134R+C0234R-D01234R*p1sq-4*C124R(2,2)+8*D1234R(12
     -   ,3)+16*D1234R(21,4)-2*(C124R(2,1)-D1234R(6,2)*P(13))+D1234R(
     -   3,1)*P(26)+D1234R(2,1)*P(51))
       FI(44) = 2*(C0134I+C0234I-D01234I*p1sq-4*C124I(2,2)+8*D1234I(12
     -   ,3)+16*D1234I(21,4)-2*(C124I(2,1)-D1234I(6,2)*P(13))+D1234I(
     -   3,1)*P(26)+D1234I(2,1)*P(51))
       F(44)=DCMPLX(FR(44),FI(44))
       FR(45) = 2*(-C0134R-C0234R+D01234R*p1sq-4*C124R(2,2)+8*D1234R(1
     -   3,3)+16*D1234R(21,4)+D1234R(2,1)*P(10)-2*(C124R(2,1)+C134R(1
     -   ,1)-D1234R(6,2)*P(13))+D1234R(3,1)*P(34))
       FI(45) = 2*(-C0134I-C0234I+D01234I*p1sq-4*C124I(2,2)+8*D1234I(1
     -   3,3)+16*D1234I(21,4)+D1234I(2,1)*P(10)-2*(C124I(2,1)+C134I(1
     -   ,1)-D1234I(6,2)*P(13))+D1234I(3,1)*P(34))
       F(45)=DCMPLX(FR(45),FI(45))
       FR(46) = 2*(-C0134R-C0234R+D01234R*p1sq-4*(C234R(3,2)-D1234R(7,
     -   2))+8*(D1234R(12,3)+D1234R(13,3))+16*D1234R(21,4)-2*(C134R(2
     -   ,1)+C234R(1,1)+C234R(2,1)-D1234R(6,2)*P(11))+D1234R(3,1)*P(3
     -   2)+D1234R(2,1)*P(50))
       FI(46) = 2*(-C0134I-C0234I+D01234I*p1sq-4*(C234I(3,2)-D1234I(7,
     -   2))+8*(D1234I(12,3)+D1234I(13,3))+16*D1234I(21,4)-2*(C134I(2
     -   ,1)+C234I(1,1)+C234I(2,1)-D1234I(6,2)*P(11))+D1234I(3,1)*P(3
     -   2)+D1234I(2,1)*P(50))
       F(46)=DCMPLX(FR(46),FI(46))
       FR(47) = 2*(-C0134R-C0234R+D01234R*p1sq-4*(C234R(2,1)+C234R(3,2
     -   )-D1234R(7,2))+16*(D1234R(13,3)+D1234R(21,4))+D1234R(2,1)*P(
     -   10)-2*(C134R(1,1)-D1234R(6,2)*P(11))+D1234R(3,1)*P(38))
       FI(47) = 2*(-C0134I-C0234I+D01234I*p1sq-4*(C234I(2,1)+C234I(3,2
     -   )-D1234I(7,2))+16*(D1234I(13,3)+D1234I(21,4))+D1234I(2,1)*P(
     -   10)-2*(C134I(1,1)-D1234I(6,2)*P(11))+D1234I(3,1)*P(38))
       F(47)=DCMPLX(FR(47),FI(47))
       FR(48) = 2*(C0134R+C0234R-D01234R*p1sq+8*D1234R(12,3)+16*D1234R
     -   (21,4)-2*(C124R(2,1)-C134R(2,1)-C234R(2,1)+D1234R(6,2)*P(23)
     -   )-D1234R(3,1)*P(32)+D1234R(2,1)*P(51))
       FI(48) = 2*(C0134I+C0234I-D01234I*p1sq+8*D1234I(12,3)+16*D1234I
     -   (21,4)-2*(C124I(2,1)-C134I(2,1)-C234I(2,1)+D1234I(6,2)*P(23)
     -   )-D1234I(3,1)*P(32)+D1234I(2,1)*P(51))
       F(48)=DCMPLX(FR(48),FI(48))
       FR(49) = 2*(C0134R+C0234R-D01234R*p1sq+16*(D1234R(13,3)+D1234R(
     -   21,4))-D1234R(2,1)*P(10)+2*(-C124R(2,1)+C134R(1,1)-D1234R(6,
     -   2)*P(23))+D1234R(3,1)*P(42))
       FI(49) = 2*(C0134I+C0234I-D01234I*p1sq+16*(D1234I(13,3)+D1234I(
     -   21,4))-D1234I(2,1)*P(10)+2*(-C124I(2,1)+C134I(1,1)-D1234I(6,
     -   2)*P(23))+D1234I(3,1)*P(42))
       F(49)=DCMPLX(FR(49),FI(49))
       FR(50) = 2*(C0134R+C0234R-D01234R*p1sq+2*C134R(1,1)-4*D1234R(7,
     -   2)+8*D1234R(13,3)+16*D1234R(21,4)-D1234R(2,1)*P(10)-(D1234R(
     -   3,1)+2*D1234R(6,2))*P(26))
       FI(50) = 2*(C0134I+C0234I-D01234I*p1sq+2*C134I(1,1)-4*D1234I(7,
     -   2)+8*D1234I(13,3)+16*D1234I(21,4)-D1234I(2,1)*P(10)-(D1234I(
     -   3,1)+2*D1234I(6,2))*P(26))
       F(50)=DCMPLX(FR(50),FI(50))
       FR(51) = -2*(C0134R+C0234R-D01234R*p1sq+2*C234R(1,1)-4*D1234R(7
     -   ,2)-8*(D1234R(12,3)+D1234R(13,3))-16*D1234R(21,4)+(D1234R(3,
     -   1)+2*D1234R(6,2))*P(26)-D1234R(2,1)*P(50))
       FI(51) = -2*(C0134I+C0234I-D01234I*p1sq+2*C234I(1,1)-4*D1234I(7
     -   ,2)-8*(D1234I(12,3)+D1234I(13,3))-16*D1234I(21,4)+(D1234I(3,
     -   1)+2*D1234I(6,2))*P(26)-D1234I(2,1)*P(50))
       F(51)=DCMPLX(FR(51),FI(51))
       FR(52) = -8*(C134R(2,1)+C134R(2,2)-4*(D1234R(13,3)+D1234R(18,4)
     -   ))+4*(D1234R(3,1)+D1234R(3,2))*P(10)
       FI(52) = -8*(C134I(2,1)+C134I(2,2)-4*(D1234I(13,3)+D1234I(18,4)
     -   ))+4*(D1234I(3,1)+D1234I(3,2))*P(10)
       F(52)=DCMPLX(FR(52),FI(52))
       FR(53) = 4*(C124R(2,1)+C234R(2,1)-s12*D1234R(3,1)+8*D1234R(18,4
     -   )+D1234R(3,2)*P(12))
       FI(53) = 4*(C124I(2,1)+C234I(2,1)-s12*D1234I(3,1)+8*D1234I(18,4
     -   )+D1234I(3,2)*P(12))
       F(53)=DCMPLX(FR(53),FI(53))
       FR(54) = 4*(-C124R(2,1)-2*C124R(2,2)-C134R(2,1)+p2sq*D1234R(3,1
     -   )+4*D1234R(13,3)+8*D1234R(18,4)+D1234R(3,2)*P(13))
       FI(54) = 4*(-C124I(2,1)-2*C124I(2,2)-C134I(2,1)+p2sq*D1234I(3,1
     -   )+4*D1234I(13,3)+8*D1234I(18,4)+D1234I(3,2)*P(13))
       F(54)=DCMPLX(FR(54),FI(54))
       FR(55) = 4*(-C134R(2,1)-C234R(2,1)-2*C234R(2,2)+p1sq*D1234R(3,1
     -   )+4*D1234R(13,3)+8*D1234R(18,4)+D1234R(3,2)*P(11))
       FI(55) = 4*(-C134I(2,1)-C234I(2,1)-2*C234I(2,2)+p1sq*D1234I(3,1
     -   )+4*D1234I(13,3)+8*D1234I(18,4)+D1234I(3,2)*P(11))
       F(55)=DCMPLX(FR(55),FI(55))
       FR(56) = -4*(C124R(2,1)-C134R(2,1)-4*D1234R(13,3)-8*D1234R(18,4
     -   )+D1234R(3,1)*P(15)+D1234R(3,2)*P(23))
       FI(56) = -4*(C124I(2,1)-C134I(2,1)-4*D1234I(13,3)-8*D1234I(18,4
     -   )+D1234I(3,1)*P(15)+D1234I(3,2)*P(23))
       F(56)=DCMPLX(FR(56),FI(56))
       P(52) = p2sq-s12
       FR(57) = 4*(C134R(2,1)-C234R(2,1)+4*D1234R(13,3)+8*D1234R(18,4)
     -   -D1234R(3,2)*P(26)-D1234R(3,1)*P(52))
       FI(57) = 4*(C134I(2,1)-C234I(2,1)+4*D1234I(13,3)+8*D1234I(18,4)
     -   -D1234I(3,2)*P(26)-D1234I(3,1)*P(52))
       F(57)=DCMPLX(FR(57),FI(57))
       FR(58) = 32*(D1234R(1,1)+3*(D1234R(1,2)+D1234R(1,3))+D1234R(1,4
     -   ))
       FI(58) = 32*(D1234I(1,1)+3*(D1234I(1,2)+D1234I(1,3))+D1234I(1,4
     -   ))
       F(58)=DCMPLX(FR(58),FI(58))
       FR(59) = 16*(D1234R(1,1)+D1234R(1,3)+D1234R(2,1)+4*D1234R(4,2)+
     -   5*D1234R(4,3)+2*(D1234R(1,2)+D1234R(4,4)))
       FI(59) = 16*(D1234I(1,1)+D1234I(1,3)+D1234I(2,1)+4*D1234I(4,2)+
     -   5*D1234I(4,3)+2*(D1234I(1,2)+D1234I(4,4)))
       F(59)=DCMPLX(FR(59),FI(59))
       FR(60) = 16*(D1234R(1,1)+D1234R(1,3)+D1234R(3,1)+4*D1234R(5,2)+
     -   5*D1234R(5,3)+2*(D1234R(1,2)+D1234R(5,4)))
       FI(60) = 16*(D1234I(1,1)+D1234I(1,3)+D1234I(3,1)+4*D1234I(5,2)+
     -   5*D1234I(5,3)+2*(D1234I(1,2)+D1234I(5,4)))
       F(60)=DCMPLX(FR(60),FI(60))
       FR(61) = 16*(D1234R(1,1)+D1234R(1,3)+4*D1234R(4,3)+2*(D1234R(1,
     -   2)+D1234R(4,2)+D1234R(4,4)))
       FI(61) = 16*(D1234I(1,1)+D1234I(1,3)+4*D1234I(4,3)+2*(D1234I(1,
     -   2)+D1234I(4,2)+D1234I(4,4)))
       F(61)=DCMPLX(FR(61),FI(61))
       FR(62) = 16*(D1234R(2,1)+D1234R(2,2)+3*(D1234R(4,2)+D1234R(6,3)
     -   )+2*(D1234R(4,3)+D1234R(6,4)))
       FI(62) = 16*(D1234I(2,1)+D1234I(2,2)+3*(D1234I(4,2)+D1234I(6,3)
     -   )+2*(D1234I(4,3)+D1234I(6,4)))
       F(62)=DCMPLX(FR(62),FI(62))
       FR(63) = 8*(D1234R(1,1)+D1234R(1,2)+D1234R(3,1)+3*D1234R(5,2)+2
     -   *(D1234R(4,2)+D1234R(4,3)+D1234R(5,3)+D1234R(6,2)+2*D1234R(7
     -   ,4)+3*D1234R(10,3)))
       FI(63) = 8*(D1234I(1,1)+D1234I(1,2)+D1234I(3,1)+3*D1234I(5,2)+2
     -   *(D1234I(4,2)+D1234I(4,3)+D1234I(5,3)+D1234I(6,2)+2*D1234I(7
     -   ,4)+3*D1234I(10,3)))
       F(63)=DCMPLX(FR(63),FI(63))
       FR(64) = 32*(D1234R(1,1)+D1234R(1,3)+D1234R(4,2)+2*(D1234R(1,2)
     -   +D1234R(4,3))+D1234R(4,4))
       FI(64) = 32*(D1234I(1,1)+D1234I(1,3)+D1234I(4,2)+2*(D1234I(1,2)
     -   +D1234I(4,3))+D1234I(4,4))
       F(64)=DCMPLX(FR(64),FI(64))
       FR(65) = 16*(D1234R(1,1)+D1234R(1,2)+D1234R(2,1)+D1234R(2,2)+4*
     -   D1234R(4,2)+3*(D1234R(4,3)+D1234R(6,3))+2*D1234R(6,4))
       FI(65) = 16*(D1234I(1,1)+D1234I(1,2)+D1234I(2,1)+D1234I(2,2)+4*
     -   D1234I(4,2)+3*(D1234I(4,3)+D1234I(6,3))+2*D1234I(6,4))
       F(65)=DCMPLX(FR(65),FI(65))
       FR(66) = 8*(D1234R(1,1)+D1234R(1,2)+D1234R(2,1)+3*D1234R(4,2)+2
     -   *(D1234R(3,1)+D1234R(4,3)+D1234R(6,2)+2*(D1234R(5,3)+D1234R(
     -   7,4))+3*(D1234R(5,2)+D1234R(10,3))))
       FI(66) = 8*(D1234I(1,1)+D1234I(1,2)+D1234I(2,1)+3*D1234I(4,2)+2
     -   *(D1234I(3,1)+D1234I(4,3)+D1234I(6,2)+2*(D1234I(5,3)+D1234I(
     -   7,4))+3*(D1234I(5,2)+D1234I(10,3))))
       F(66)=DCMPLX(FR(66),FI(66))
       FR(67) = 16*(D1234R(2,1)+4*D1234R(4,2)+5*D1234R(4,3)+2*D1234R(4
     -   ,4))
       FI(67) = 16*(D1234I(2,1)+4*D1234I(4,2)+5*D1234I(4,3)+2*D1234I(4
     -   ,4))
       F(67)=DCMPLX(FR(67),FI(67))
       FR(68) = 16*(D1234R(2,1)+D1234R(4,3)+4*D1234R(6,3)+2*(D1234R(2,
     -   2)+D1234R(4,2)+D1234R(6,4)))
       FI(68) = 16*(D1234I(2,1)+D1234I(4,3)+4*D1234I(6,3)+2*(D1234I(2,
     -   2)+D1234I(4,2)+D1234I(6,4)))
       F(68)=DCMPLX(FR(68),FI(68))
       FR(69) = 8*(D1234R(2,1)+D1234R(3,1)+3*D1234R(4,2)+2*D1234R(4,3)
     -   +D1234R(5,2)+4*(D1234R(6,2)+D1234R(7,4))+8*D1234R(10,3))
       FI(69) = 8*(D1234I(2,1)+D1234I(3,1)+3*D1234I(4,2)+2*D1234I(4,3)
     -   +D1234I(5,2)+4*(D1234I(6,2)+D1234I(7,4))+8*D1234I(10,3))
       F(69)=DCMPLX(FR(69),FI(69))
       FR(70) = 16*(D1234R(1,1)+D1234R(1,2)+3*(D1234R(4,2)+D1234R(4,3)
     -   )+2*(D1234R(6,3)+D1234R(6,4)))
       FI(70) = 16*(D1234I(1,1)+D1234I(1,2)+3*(D1234I(4,2)+D1234I(4,3)
     -   )+2*(D1234I(6,3)+D1234I(6,4)))
       F(70)=DCMPLX(FR(70),FI(70))
       FR(71) = 16*(D1234R(2,1)+D1234R(2,3)+4*D1234R(6,3)+2*(D1234R(2,
     -   2)+D1234R(4,2)+D1234R(9,4)))
       FI(71) = 16*(D1234I(2,1)+D1234I(2,3)+4*D1234I(6,3)+2*(D1234I(2,
     -   2)+D1234I(4,2)+D1234I(9,4)))
       F(71)=DCMPLX(FR(71),FI(71))
       FR(72) = 8*(D1234R(2,1)+D1234R(2,2)+D1234R(3,1)+3*D1234R(6,2)+2
     -   *(D1234R(4,2)+D1234R(5,2)+D1234R(6,3)+D1234R(8,3)+3*D1234R(1
     -   0,3)+2*D1234R(10,4)))
       FI(72) = 8*(D1234I(2,1)+D1234I(2,2)+D1234I(3,1)+3*D1234I(6,2)+2
     -   *(D1234I(4,2)+D1234I(5,2)+D1234I(6,3)+D1234I(8,3)+3*D1234I(1
     -   0,3)+2*D1234I(10,4)))
       F(72)=DCMPLX(FR(72),FI(72))
       FR(73) = 16*(D1234R(2,2)+D1234R(4,2)+D1234R(4,3)+3*D1234R(6,3)+
     -   2*D1234R(6,4))
       FI(73) = 16*(D1234I(2,2)+D1234I(4,2)+D1234I(4,3)+3*D1234I(6,3)+
     -   2*D1234I(6,4))
       F(73)=DCMPLX(FR(73),FI(73))
       FR(74) = 32*(D1234R(2,2)+D1234R(2,3)+D1234R(6,3)+D1234R(9,4))
       FI(74) = 32*(D1234I(2,2)+D1234I(2,3)+D1234I(6,3)+D1234I(9,4))
       F(74)=DCMPLX(FR(74),FI(74))
       FR(75) = 8*(D1234R(2,2)+D1234R(4,2)+2*(D1234R(6,2)+D1234R(6,3)+
     -   D1234R(10,3)+2*(D1234R(8,3)+D1234R(10,4))))
       FI(75) = 8*(D1234I(2,2)+D1234I(4,2)+2*(D1234I(6,2)+D1234I(6,3)+
     -   D1234I(10,3)+2*(D1234I(8,3)+D1234I(10,4))))
       F(75)=DCMPLX(FR(75),FI(75))
       FR(76) = 16*(D1234R(2,1)+D1234R(4,2)+3*(D1234R(2,2)+D1234R(6,3)
     -   )+2*(D1234R(2,3)+D1234R(9,4)))
       FI(76) = 16*(D1234I(2,1)+D1234I(4,2)+3*(D1234I(2,2)+D1234I(6,3)
     -   )+2*(D1234I(2,3)+D1234I(9,4)))
       F(76)=DCMPLX(FR(76),FI(76))
       FR(77) = 8*(D1234R(2,1)+D1234R(3,1)+D1234R(4,2)+5*D1234R(6,2)+2
     -   *(D1234R(2,2)+D1234R(6,3))+4*(D1234R(8,3)+D1234R(10,3)+D1234
     -   R(10,4)))
       FI(77) = 8*(D1234I(2,1)+D1234I(3,1)+D1234I(4,2)+5*D1234I(6,2)+2
     -   *(D1234I(2,2)+D1234I(6,3))+4*(D1234I(8,3)+D1234I(10,3)+D1234
     -   I(10,4)))
       F(77)=DCMPLX(FR(77),FI(77))
       FR(78) = 16*(D1234R(2,2)+D1234R(2,3)+D1234R(4,2)+3*D1234R(6,3)+
     -   2*D1234R(9,4))
       FI(78) = 16*(D1234I(2,2)+D1234I(2,3)+D1234I(4,2)+3*D1234I(6,3)+
     -   2*D1234I(9,4))
       F(78)=DCMPLX(FR(78),FI(78))
       FR(79) = 32*(D1234R(2,2)+2*D1234R(2,3)+D1234R(2,4))
       FI(79) = 32*(D1234I(2,2)+2*D1234I(2,3)+D1234I(2,4))
       F(79)=DCMPLX(FR(79),FI(79))
       FR(80) = 16*(D1234R(2,2)+D1234R(2,3)+D1234R(6,2)+3*D1234R(8,3)+
     -   2*D1234R(13,4))
       FI(80) = 16*(D1234I(2,2)+D1234I(2,3)+D1234I(6,2)+3*D1234I(8,3)+
     -   2*D1234I(13,4))
       F(80)=DCMPLX(FR(80),FI(80))
       FR(81) = 32*(D1234R(5,2)+2*D1234R(5,3)+D1234R(5,4))
       FI(81) = 32*(D1234I(5,2)+2*D1234I(5,3)+D1234I(5,4))
       F(81)=DCMPLX(FR(81),FI(81))
       FR(82) = -8*(D1234R(1,1)+D1234R(1,2)-D1234R(3,1)-3*D1234R(5,2)-
     -   2*(D1234R(5,3)+D1234R(6,2)+2*D1234R(7,4)+3*D1234R(10,3)))
       FI(82) = -8*(D1234I(1,1)+D1234I(1,2)-D1234I(3,1)-3*D1234I(5,2)-
     -   2*(D1234I(5,3)+D1234I(6,2)+2*D1234I(7,4)+3*D1234I(10,3)))
       F(82)=DCMPLX(FR(82),FI(82))
       FR(83) = 16*(D1234R(3,2)+D1234R(5,2)+D1234R(5,3)+3*D1234R(7,3)+
     -   2*D1234R(8,4))
       FI(83) = 16*(D1234I(3,2)+D1234I(5,2)+D1234I(5,3)+3*D1234I(7,3)+
     -   2*D1234I(8,4))
       F(83)=DCMPLX(FR(83),FI(83))
       FR(84) = 16*(D1234R(1,1)+D1234R(1,3)+4*D1234R(5,3)+2*(D1234R(1,
     -   2)+D1234R(5,2)+D1234R(5,4)))
       FI(84) = 16*(D1234I(1,1)+D1234I(1,3)+4*D1234I(5,3)+2*(D1234I(1,
     -   2)+D1234I(5,2)+D1234I(5,4)))
       F(84)=DCMPLX(FR(84),FI(84))
       FR(85) = 8*(D1234R(1,1)+D1234R(1,2)+D1234R(2,1)+3*D1234R(4,2)+2
     -   *(D1234R(4,3)+D1234R(5,2)+D1234R(5,3)+D1234R(6,2)+2*D1234R(7
     -   ,4)+3*D1234R(10,3)))
       FI(85) = 8*(D1234I(1,1)+D1234I(1,2)+D1234I(2,1)+3*D1234I(4,2)+2
     -   *(D1234I(4,3)+D1234I(5,2)+D1234I(5,3)+D1234I(6,2)+2*D1234I(7
     -   ,4)+3*D1234I(10,3)))
       F(85)=DCMPLX(FR(85),FI(85))
       FR(86) = 16*(D1234R(3,1)+D1234R(3,2)+3*(D1234R(5,2)+D1234R(7,3)
     -   )+2*(D1234R(5,3)+D1234R(8,4)))
       FI(86) = 16*(D1234I(3,1)+D1234I(3,2)+3*(D1234I(5,2)+D1234I(7,3)
     -   )+2*(D1234I(5,3)+D1234I(8,4)))
       F(86)=DCMPLX(FR(86),FI(86))
       FR(87) = 16*(D1234R(3,1)+4*D1234R(5,2)+5*D1234R(5,3)+2*D1234R(5
     -   ,4))
       FI(87) = 16*(D1234I(3,1)+4*D1234I(5,2)+5*D1234I(5,3)+2*D1234I(5
     -   ,4))
       F(87)=DCMPLX(FR(87),FI(87))
       FR(88) = 8*(D1234R(2,1)+D1234R(3,1)+D1234R(4,2)+3*D1234R(5,2)+2
     -   *D1234R(5,3)+4*(D1234R(6,2)+D1234R(7,4))+8*D1234R(10,3))
       FI(88) = 8*(D1234I(2,1)+D1234I(3,1)+D1234I(4,2)+3*D1234I(5,2)+2
     -   *D1234I(5,3)+4*(D1234I(6,2)+D1234I(7,4))+8*D1234I(10,3))
       F(88)=DCMPLX(FR(88),FI(88))
       FR(89) = 16*(D1234R(3,1)+D1234R(5,3)+4*D1234R(7,3)+2*(D1234R(3,
     -   2)+D1234R(5,2)+D1234R(8,4)))
       FI(89) = 16*(D1234I(3,1)+D1234I(5,3)+4*D1234I(7,3)+2*(D1234I(3,
     -   2)+D1234I(5,2)+D1234I(8,4)))
       F(89)=DCMPLX(FR(89),FI(89))
       FR(90) = 8*(D1234R(1,1)+D1234R(1,2)+2*(D1234R(4,2)+D1234R(4,3)+
     -   D1234R(5,2)+D1234R(5,3)+2*(D1234R(7,4)+D1234R(10,3))))
       FI(90) = 8*(D1234I(1,1)+D1234I(1,2)+2*(D1234I(4,2)+D1234I(4,3)+
     -   D1234I(5,2)+D1234I(5,3)+2*(D1234I(7,4)+D1234I(10,3))))
       F(90)=DCMPLX(FR(90),FI(90))
       FR(91) = 8*(D1234R(2,1)+D1234R(2,2)+2*(D1234R(4,2)+D1234R(6,2)+
     -   D1234R(6,3)+D1234R(8,3)+2*(D1234R(10,3)+D1234R(10,4))))
       FI(91) = 8*(D1234I(2,1)+D1234I(2,2)+2*(D1234I(4,2)+D1234I(6,2)+
     -   D1234I(6,3)+D1234I(8,3)+2*(D1234I(10,3)+D1234I(10,4))))
       F(91)=DCMPLX(FR(91),FI(91))
       FR(92) = 8*(D1234R(3,1)+D1234R(3,2)+2*(D1234R(5,2)+D1234R(6,2)+
     -   D1234R(7,3)+D1234R(9,3)+2*(D1234R(10,3)+D1234R(11,4))))
       FI(92) = 8*(D1234I(3,1)+D1234I(3,2)+2*(D1234I(5,2)+D1234I(6,2)+
     -   D1234I(7,3)+D1234I(9,3)+2*(D1234I(10,3)+D1234I(11,4))))
       F(92)=DCMPLX(FR(92),FI(92))
       FR(93) = 8*(D1234R(1,1)+D1234R(1,2)+4*(D1234R(5,2)+D1234R(5,3)+
     -   D1234R(7,4)+D1234R(10,3)))
       FI(93) = 8*(D1234I(1,1)+D1234I(1,2)+4*(D1234I(5,2)+D1234I(5,3)+
     -   D1234I(7,4)+D1234I(10,3)))
       F(93)=DCMPLX(FR(93),FI(93))
       FR(94) = 8*(D1234R(3,1)+3*D1234R(6,2)+2*(D1234R(5,2)+D1234R(8,3
     -   ))+6*D1234R(10,3)+4*D1234R(10,4))
       FI(94) = 8*(D1234I(3,1)+3*D1234I(6,2)+2*(D1234I(5,2)+D1234I(8,3
     -   ))+6*D1234I(10,3)+4*D1234I(10,4))
       F(94)=DCMPLX(FR(94),FI(94))
       FR(95) = 8*(D1234R(3,1)+D1234R(6,2)+2*(D1234R(3,2)+D1234R(5,2)+
     -   D1234R(9,3)+D1234R(10,3)+2*(D1234R(7,3)+D1234R(11,4))))
       FI(95) = 8*(D1234I(3,1)+D1234I(6,2)+2*(D1234I(3,2)+D1234I(5,2)+
     -   D1234I(9,3)+D1234I(10,3)+2*(D1234I(7,3)+D1234I(11,4))))
       F(95)=DCMPLX(FR(95),FI(95))
       FR(96) = -8*(D1234R(3,1)+D1234R(5,2)-2*(D1234R(6,2)+2*D1234R(7,
     -   4)+3*D1234R(10,3)))
       FI(96) = -8*(D1234I(3,1)+D1234I(5,2)-2*(D1234I(6,2)+2*D1234I(7,
     -   4)+3*D1234I(10,3)))
       F(96)=DCMPLX(FR(96),FI(96))
       FR(97) = -8*(D1234R(2,1)+D1234R(4,2)-2*(D1234R(6,2)+D1234R(10,3
     -   )+2*(D1234R(8,3)+D1234R(10,4))))
       FI(97) = -8*(D1234I(2,1)+D1234I(4,2)-2*(D1234I(6,2)+D1234I(10,3
     -   )+2*(D1234I(8,3)+D1234I(10,4))))
       F(97)=DCMPLX(FR(97),FI(97))
       FR(98) = 8*(-D1234R(3,1)+D1234R(6,2)+2*(D1234R(10,3)+2*(D1234R(
     -   9,3)+D1234R(11,4))))
       FI(98) = 8*(-D1234I(3,1)+D1234I(6,2)+2*(D1234I(10,3)+2*(D1234I(
     -   9,3)+D1234I(11,4))))
       F(98)=DCMPLX(FR(98),FI(98))
       FR(99) = 8*(D1234R(2,1)+3*D1234R(4,2)+2*(D1234R(4,3)+D1234R(6,2
     -   )+2*D1234R(7,4)+3*D1234R(10,3)))
       FI(99) = 8*(D1234I(2,1)+3*D1234I(4,2)+2*(D1234I(4,3)+D1234I(6,2
     -   )+2*D1234I(7,4)+3*D1234I(10,3)))
       F(99)=DCMPLX(FR(99),FI(99))
       FR(100) = 8*(D1234R(2,1)+D1234R(4,2)+2*(D1234R(2,2)+D1234R(6,2)
     -   +D1234R(6,3)+D1234R(10,3)+2*(D1234R(8,3)+D1234R(10,4))))
       FI(100) = 8*(D1234I(2,1)+D1234I(4,2)+2*(D1234I(2,2)+D1234I(6,2)
     -   +D1234I(6,3)+D1234I(10,3)+2*(D1234I(8,3)+D1234I(10,4))))
       F(100)=DCMPLX(FR(100),FI(100))
       FR(101) = 8*(D1234R(3,1)+D1234R(3,2)+4*(D1234R(6,2)+D1234R(9,3)
     -   +D1234R(10,3)+D1234R(11,4)))
       FI(101) = 8*(D1234I(3,1)+D1234I(3,2)+4*(D1234I(6,2)+D1234I(9,3)
     -   +D1234I(10,3)+D1234I(11,4)))
       F(101)=DCMPLX(FR(101),FI(101))
       FR(102) = 8*(D1234R(3,1)+3*D1234R(5,2)+2*(D1234R(5,3)+D1234R(6,
     -   2)+2*D1234R(7,4)+3*D1234R(10,3)))
       FI(102) = 8*(D1234I(3,1)+3*D1234I(5,2)+2*(D1234I(5,3)+D1234I(6,
     -   2)+2*D1234I(7,4)+3*D1234I(10,3)))
       F(102)=DCMPLX(FR(102),FI(102))
       FR(103) = 8*(D1234R(2,1)+D1234R(2,2)+4*(D1234R(6,2)+D1234R(8,3)
     -   +D1234R(10,3)+D1234R(10,4)))
       FI(103) = 8*(D1234I(2,1)+D1234I(2,2)+4*(D1234I(6,2)+D1234I(8,3)
     -   +D1234I(10,3)+D1234I(10,4)))
       F(103)=DCMPLX(FR(103),FI(103))
       FR(104) = 8*(D1234R(3,1)+D1234R(5,2)+2*(D1234R(3,2)+D1234R(6,2)
     -   +D1234R(7,3)+D1234R(10,3)+2*(D1234R(9,3)+D1234R(11,4))))
       FI(104) = 8*(D1234I(3,1)+D1234I(5,2)+2*(D1234I(3,2)+D1234I(6,2)
     -   +D1234I(7,3)+D1234I(10,3)+2*(D1234I(9,3)+D1234I(11,4))))
       F(104)=DCMPLX(FR(104),FI(104))
       FR(105) = -8*(D1234R(2,1)+D1234R(4,2)-2*(D1234R(3,1)+D1234R(6,2
     -   )+2*(D1234R(5,3)+D1234R(7,4))+3*(D1234R(5,2)+D1234R(10,3))))
       FI(105) = -8*(D1234I(2,1)+D1234I(4,2)-2*(D1234I(3,1)+D1234I(6,2
     -   )+2*(D1234I(5,3)+D1234I(7,4))+3*(D1234I(5,2)+D1234I(10,3))))
       F(105)=DCMPLX(FR(105),FI(105))
       FR(106) = 8*(D1234R(3,1)+2*D1234R(5,2)+5*D1234R(6,2)+6*D1234R(1
     -   0,3)+4*(D1234R(8,3)+D1234R(10,4)))
       FI(106) = 8*(D1234I(3,1)+2*D1234I(5,2)+5*D1234I(6,2)+6*D1234I(1
     -   0,3)+4*(D1234I(8,3)+D1234I(10,4)))
       F(106)=DCMPLX(FR(106),FI(106))
       FR(107) = 8*(D1234R(3,1)+4*D1234R(3,2)+D1234R(5,2)+2*(D1234R(6,
     -   2)+D1234R(10,3)+2*(D1234R(7,3)+D1234R(9,3)+D1234R(11,4))))
       FI(107) = 8*(D1234I(3,1)+4*D1234I(3,2)+D1234I(5,2)+2*(D1234I(6,
     -   2)+D1234I(10,3)+2*(D1234I(7,3)+D1234I(9,3)+D1234I(11,4))))
       F(107)=DCMPLX(FR(107),FI(107))
       FR(108) = 8*(D1234R(2,2)+D1234R(4,2)+2*(D1234R(6,3)+D1234R(8,3)
     -   +D1234R(10,3)+2*D1234R(10,4)))
       FI(108) = 8*(D1234I(2,2)+D1234I(4,2)+2*(D1234I(6,3)+D1234I(8,3)
     -   +D1234I(10,3)+2*D1234I(10,4)))
       F(108)=DCMPLX(FR(108),FI(108))
       FR(109) = 16*(D1234R(2,2)+D1234R(2,3)+2*(D1234R(8,3)+D1234R(13,
     -   4)))
       FI(109) = 16*(D1234I(2,2)+D1234I(2,3)+2*(D1234I(8,3)+D1234I(13,
     -   4)))
       F(109)=DCMPLX(FR(109),FI(109))
       FR(110) = 16*(D1234R(6,2)+D1234R(9,3)+2*(D1234R(8,3)+D1234R(14,
     -   4)))
       FI(110) = 16*(D1234I(6,2)+D1234I(9,3)+2*(D1234I(8,3)+D1234I(14,
     -   4)))
       F(110)=DCMPLX(FR(110),FI(110))
       FR(111) = 8*(D1234R(2,1)-D1234R(3,1)+D1234R(4,2)+D1234R(6,2)+2*
     -   D1234R(8,3)+4*(D1234R(10,3)+D1234R(10,4)))
       FI(111) = 8*(D1234I(2,1)-D1234I(3,1)+D1234I(4,2)+D1234I(6,2)+2*
     -   D1234I(8,3)+4*(D1234I(10,3)+D1234I(10,4)))
       F(111)=DCMPLX(FR(111),FI(111))
       FR(112) = 16*(D1234R(6,2)+3*D1234R(8,3)+2*D1234R(13,4))
       FI(112) = 16*(D1234I(6,2)+3*D1234I(8,3)+2*D1234I(13,4))
       F(112)=DCMPLX(FR(112),FI(112))
       FR(113) = 16*(D1234R(6,2)+D1234R(8,3)+2*(D1234R(9,3)+D1234R(14,
     -   4)))
       FI(113) = 16*(D1234I(6,2)+D1234I(8,3)+2*(D1234I(9,3)+D1234I(14,
     -   4)))
       F(113)=DCMPLX(FR(113),FI(113))
       FR(114) = -8*(D1234R(2,1)+D1234R(2,2)-D1234R(3,1)-3*D1234R(6,2)
     -   -2*(D1234R(5,2)+D1234R(8,3))-6*D1234R(10,3)-4*D1234R(10,4))
       FI(114) = -8*(D1234I(2,1)+D1234I(2,2)-D1234I(3,1)-3*D1234I(6,2)
     -   -2*(D1234I(5,2)+D1234I(8,3))-6*D1234I(10,3)-4*D1234I(10,4))
       F(114)=DCMPLX(FR(114),FI(114))
       FR(115) = 32*(D1234R(6,2)+2*D1234R(8,3)+D1234R(13,4))
       FI(115) = 32*(D1234I(6,2)+2*D1234I(8,3)+D1234I(13,4))
       F(115)=DCMPLX(FR(115),FI(115))
       FR(116) = 16*(D1234R(3,2)+D1234R(6,2)+D1234R(8,3)+3*D1234R(9,3)
     -   +2*D1234R(14,4))
       FI(116) = 16*(D1234I(3,2)+D1234I(6,2)+D1234I(8,3)+3*D1234I(9,3)
     -   +2*D1234I(14,4))
       F(116)=DCMPLX(FR(116),FI(116))
       FR(117) = 16*(D1234R(5,2)+D1234R(5,3)+2*(D1234R(7,3)+D1234R(8,4
     -   )))
       FI(117) = 16*(D1234I(5,2)+D1234I(5,3)+2*(D1234I(7,3)+D1234I(8,4
     -   )))
       F(117)=DCMPLX(FR(117),FI(117))
       FR(118) = 8*(D1234R(3,2)+D1234R(6,2)+2*(D1234R(7,3)+D1234R(9,3)
     -   +D1234R(10,3)+2*D1234R(11,4)))
       FI(118) = 8*(D1234I(3,2)+D1234I(6,2)+2*(D1234I(7,3)+D1234I(9,3)
     -   +D1234I(10,3)+2*D1234I(11,4)))
       F(118)=DCMPLX(FR(118),FI(118))
       FR(119) = 16*(D1234R(3,2)+D1234R(3,3)+2*(D1234R(7,3)+D1234R(12,
     -   4)))
       FI(119) = 16*(D1234I(3,2)+D1234I(3,3)+2*(D1234I(7,3)+D1234I(12,
     -   4)))
       F(119)=DCMPLX(FR(119),FI(119))
       FR(120) = 16*(D1234R(3,2)+3*D1234R(7,3)+2*D1234R(8,4))
       FI(120) = 16*(D1234I(3,2)+3*D1234I(7,3)+2*D1234I(8,4))
       F(120)=DCMPLX(FR(120),FI(120))
       FR(121) = 8*(-D1234R(5,2)+D1234R(6,2)+2*(D1234R(3,2)+D1234R(7,3
     -   ))+4*(D1234R(9,3)+D1234R(11,4)))
       FI(121) = 8*(-D1234I(5,2)+D1234I(6,2)+2*(D1234I(3,2)+D1234I(7,3
     -   ))+4*(D1234I(9,3)+D1234I(11,4)))
       F(121)=DCMPLX(FR(121),FI(121))
       FR(122) = 16*(D1234R(3,2)+D1234R(7,3)+2*(D1234R(3,3)+D1234R(12,
     -   4)))
       FI(122) = 16*(D1234I(3,2)+D1234I(7,3)+2*(D1234I(3,3)+D1234I(12,
     -   4)))
       F(122)=DCMPLX(FR(122),FI(122))
       FR(123) = 8*(D1234R(3,2)+D1234R(5,2)+2*(D1234R(6,2)+D1234R(7,3)
     -   +D1234R(10,3)+2*(D1234R(9,3)+D1234R(11,4))))
       FI(123) = 8*(D1234I(3,2)+D1234I(5,2)+2*(D1234I(6,2)+D1234I(7,3)
     -   +D1234I(10,3)+2*(D1234I(9,3)+D1234I(11,4))))
       F(123)=DCMPLX(FR(123),FI(123))
       FR(124) = 32*(D1234R(3,2)+D1234R(3,3)+D1234R(7,3)+D1234R(12,4))
       FI(124) = 32*(D1234I(3,2)+D1234I(3,3)+D1234I(7,3)+D1234I(12,4))
       F(124)=DCMPLX(FR(124),FI(124))
       FR(125) = 8*(-D1234R(3,2)+D1234R(6,2)+2*(D1234R(9,3)+D1234R(10,
     -   3)+2*D1234R(11,4)))
       FI(125) = 8*(-D1234I(3,2)+D1234I(6,2)+2*(D1234I(9,3)+D1234I(10,
     -   3)+2*D1234I(11,4)))
       F(125)=DCMPLX(FR(125),FI(125))
       FR(126) = 16*(D1234R(8,3)+D1234R(9,3)+2*D1234R(14,4))
       FI(126) = 16*(D1234I(8,3)+D1234I(9,3)+2*D1234I(14,4))
       F(126)=DCMPLX(FR(126),FI(126))
       FR(127) = 32*(D1234R(9,3)+D1234R(15,4))
       FI(127) = 32*(D1234I(9,3)+D1234I(15,4))
       F(127)=DCMPLX(FR(127),FI(127))
       FR(128) = 8*(D1234R(3,2)+D1234R(5,2)+2*(D1234R(7,3)+D1234R(9,3)
     -   +D1234R(10,3)+2*D1234R(11,4)))
       FI(128) = 8*(D1234I(3,2)+D1234I(5,2)+2*(D1234I(7,3)+D1234I(9,3)
     -   +D1234I(10,3)+2*D1234I(11,4)))
       F(128)=DCMPLX(FR(128),FI(128))
       FR(129) = 16*(D1234R(3,2)+D1234R(3,3)+2*(D1234R(9,3)+D1234R(15,
     -   4)))
       FI(129) = 16*(D1234I(3,2)+D1234I(3,3)+2*(D1234I(9,3)+D1234I(15,
     -   4)))
       F(129)=DCMPLX(FR(129),FI(129))
       FR(130) = 8*(D1234R(5,2)-D1234R(6,2)+2*(D1234R(3,2)+D1234R(9,3)
     -   )+4*(D1234R(7,3)+D1234R(11,4)))
       FI(130) = 8*(D1234I(5,2)-D1234I(6,2)+2*(D1234I(3,2)+D1234I(9,3)
     -   )+4*(D1234I(7,3)+D1234I(11,4)))
       F(130)=DCMPLX(FR(130),FI(130))
       FR(131) = 16*(D1234R(3,2)+3*D1234R(9,3)+2*D1234R(14,4))
       FI(131) = 16*(D1234I(3,2)+3*D1234I(9,3)+2*D1234I(14,4))
       F(131)=DCMPLX(FR(131),FI(131))
       FR(132) = 16*(D1234R(3,2)+D1234R(9,3)+2*(D1234R(3,3)+D1234R(15,
     -   4)))
       FI(132) = 16*(D1234I(3,2)+D1234I(9,3)+2*(D1234I(3,3)+D1234I(15,
     -   4)))
       F(132)=DCMPLX(FR(132),FI(132))
       FR(133) = 16*(D1234R(3,3)+D1234R(7,3)+2*D1234R(12,4))
       FI(133) = 16*(D1234I(3,3)+D1234I(7,3)+2*D1234I(12,4))
       F(133)=DCMPLX(FR(133),FI(133))
       FR(134) = 16*(D1234R(3,3)+D1234R(9,3)+2*D1234R(15,4))
       FI(134) = 16*(D1234I(3,3)+D1234I(9,3)+2*D1234I(15,4))
       F(134)=DCMPLX(FR(134),FI(134))
       FR(135) = 32*(D1234R(3,3)+D1234R(3,4))
       FI(135) = 32*(D1234I(3,3)+D1234I(3,4))
       F(135)=DCMPLX(FR(135),FI(135))

       endif
c************************************************************************************
c************************************************************************************
c************************************************************************************
c************************************************************************************
c               PART THAT DEPENDS ON THE EXTERNAL CURRENT
c************************************************************************************
c************************************************************************************
c************************************************************************************
       p1mup1 = dotrc(p1,mup1)
       p1mup2 = dotrc(p1,mup2)
       p1mup3 = dotrc(p1,mup3)
       p1mup4 = dotrc(p1,mup4)
       p2mup1 = dotrc(p2,mup1)
       p2mup2 = dotrc(p2,mup2)
       p2mup3 = dotrc(p2,mup3)
       p2mup4 = dotrc(p2,mup4)
       p3mup1 = dotrc(p3,mup1)
       p3mup2 = dotrc(p3,mup2)
       p3mup3 = dotrc(p3,mup3)
       p3mup4 = dotrc(p3,mup4)
       p4mup1 = dotrc(p4,mup1)
       p4mup2 = dotrc(p4,mup2)
       p4mup3 = dotrc(p4,mup3)
       p4mup4 = dotrc(p4,mup4)
       mup1mup2 = dotcc(mup1,mup2)
       mup1mup3 = dotcc(mup1,mup3)
       mup1mup4 = dotcc(mup1,mup4)
       mup2mup3 = dotcc(mup2,mup3)
       mup2mup4 = dotcc(mup2,mup4)
       mup3mup4 = dotcc(mup3,mup4)
c************************************************************************************
c************************************************************************************
c************************************************************************************
c       Amplitude                         
c************************************************************************************
c************************************************************************************
c************************************************************************************
c************************************************************************************


       result = mup1mup4*mup2mup3*F(1)+mup1mup3*mup2mup4*F(2)+mup1mup2
     -   *mup3mup4*F(3)+mup1mup2*p1mup3*p1mup4*F(4)+mup3mup4*p1mup1*p
     -   1mup2*F(5)+mup2mup3*p1mup1*p1mup4*F(6)+mup1mup4*p1mup2*p1mup
     -   3*F(7)+mup2mup4*p1mup1*p1mup3*F(8)+mup1mup3*p1mup2*p1mup4*F(
     -   9)+mup1mup2*p1mup4*p2mup3*F(10)+mup1mup2*p1mup3*p2mup4*F(11)
     -   +mup3mup4*p1mup1*p2mup2*F(12)+mup3mup4*p1mup2*p2mup1*F(13)+m
     -   up2mup3*p1mup4*p2mup1*F(14)+mup2mup3*p1mup1*p2mup4*F(15)+mup
     -   1mup4*p1mup2*p2mup3*F(16)+mup1mup4*p1mup3*p2mup2*F(17)+mup2m
     -   up4*p1mup1*p2mup3*F(18)+mup2mup4*p1mup3*p2mup1*F(19)+mup1mup
     -   3*p1mup4*p2mup2*F(20)+mup1mup3*p1mup2*p2mup4*F(21)+mup1mup2*
     -   p2mup3*p2mup4*F(22)+mup3mup4*p2mup1*p2mup2*F(23)+mup2mup3*p2
     -   mup1*p2mup4*F(24)+mup1mup4*p2mup2*p2mup3*F(25)+mup2mup4*p2mu
     -   p1*p2mup3*F(26)+mup1mup3*p2mup2*p2mup4*F(27)+mup1mup2*p1mup4
     -   *p3mup3*F(28)+mup1mup2*p1mup3*p3mup4*F(29)+mup3mup4*p1mup1*p
     -   3mup2*F(30)+mup3mup4*p1mup2*p3mup1*F(31)+mup2mup3*p1mup4*p3m
     -   up1*F(32)+mup2mup3*p1mup1*p3mup4*F(33)+mup1mup4*p1mup2*p3mup
     -   3*F(34)+mup1mup4*p1mup3*p3mup2*F(35)+mup2mup4*p1mup1*p3mup3*
     -   F(36)+mup2mup4*p1mup3*p3mup1*F(37)+mup1mup3*p1mup4*p3mup2*F(
     -   38)+mup1mup3*p1mup2*p3mup4*F(39)+mup1mup2*p2mup4*p3mup3*F(40
     -   )+mup1mup2*p2mup3*p3mup4*F(41)+mup3mup4*p2mup1*p3mup2*F(42)+
     -   mup3mup4*p2mup2*p3mup1*F(43)+mup2mup3*p2mup1*p3mup4*F(44)+mu
     -   p2mup3*p2mup4*p3mup1*F(45)+mup1mup4*p2mup2*p3mup3*F(46)+mup1
     -   mup4*p2mup3*p3mup2*F(47)+mup2mup4*p2mup1*p3mup3*F(48)+mup2mu
     -   p4*p2mup3*p3mup1*F(49)+mup1mup3*p2mup4*p3mup2*F(50)+mup1mup3
     -   *p2mup2*p3mup4*F(51)+mup1mup2*p3mup3*p3mup4*F(52)+mup3mup4*p
     -   3mup1*p3mup2*F(53)+mup2mup3*p3mup1*p3mup4*F(54)+mup1mup4*p3m
     -   up2*p3mup3*F(55)+mup2mup4*p3mup1*p3mup3*F(56)+mup1mup3*p3mup
     -   2*p3mup4*F(57)+p1mup1*p1mup2*p1mup3*(p1mup4*F(58)+p2mup4*F(5
     -   9)+p3mup4*F(60))+p1mup1*p1mup3*p2mup2*(p1mup4*F(61)+p2mup4*F
     -   (62)+p3mup4*F(63))+p1mup1*p1mup2*p2mup3*(p1mup4*F(64)+p2mup4
     -   *F(65)+p3mup4*F(66))+p1mup2*p1mup3*p2mup1*(p1mup4*F(67)+p2mu
     -   p4*F(68)+p3mup4*F(69))+p1mup1*p2mup2*p2mup3*(p1mup4*F(70)+p2
     -   mup4*F(71)+p3mup4*F(72))+p1mup3*p2mup1*p2mup2*(p1mup4*F(73)+
     -   p2mup4*F(74)+p3mup4*F(75))+p1mup2*p2mup1*p2mup3*(p1mup4*F(62
     -   )+p2mup4*F(76)+p3mup4*F(77))+p2mup1*p2mup2*p2mup3*(p1mup4*F(
     -   78)+p2mup4*F(79)+p3mup4*F(80))+p1mup1*p1mup3*p3mup2*(p1mup4*
     -   F(81)+p2mup4*F(82)+p3mup4*F(83))+p1mup1*p1mup2*p3mup3*(p1mup
     -   4*F(84)+p2mup4*F(85)+p3mup4*F(86))+p1mup2*p1mup3*p3mup1*(p1m
     -   up4*F(87)+p2mup4*F(88)+p3mup4*F(89))+p1mup1*p2mup2*p3mup3*(p
     -   1mup4*F(90)+p2mup4*F(91)+p3mup4*F(92))+p1mup1*p2mup3*p3mup2*
     -   (p1mup4*F(93)+p2mup4*F(94)+p3mup4*F(95))+p1mup3*p2mup1*p3mup
     -   2*(p1mup4*F(96)+p2mup4*F(97)+p3mup4*F(98))+p1mup2*p2mup1*p3m
     -   up3*(p1mup4*F(99)+p2mup4*F(100)+p3mup4*F(101))+p1mup3*p2mup2
     -   *p3mup1*(p1mup4*F(102)+p2mup4*F(103)+p3mup4*F(104))+p1mup2*p
     -   2mup3*p3mup1*(p1mup4*F(105)+p2mup4*F(106)+p3mup4*F(107))+p2m
     -   up1*p2mup2*p3mup3*(p1mup4*F(108)+p2mup4*F(109)+p3mup4*F(110)
     -   )+p2mup1*p2mup3*p3mup2*(p1mup4*F(111)+p2mup4*F(112)+p3mup4*F
     -   (113))+p2mup2*p2mup3*p3mup1*(p1mup4*F(114)+p2mup4*F(115)+p3m
     -   up4*F(116))+p1mup1*p3mup2*p3mup3*(p1mup4*F(117)+p2mup4*F(118
     -   )+p3mup4*F(119))+p1mup3*p3mup1*p3mup2*(p1mup4*F(120)+p2mup4*
     -   F(121)+p3mup4*F(122))+p1mup2*p3mup1*p3mup3*(p1mup4*F(83)+p2m
     -   up4*F(123)+p3mup4*F(124))+p2mup1*p3mup2*p3mup3*(p1mup4*F(125
     -   )+p2mup4*F(126)+p3mup4*F(127))+p2mup2*p3mup1*p3mup3*(p2mup4*
     -   F(113)+p1mup4*F(128)+p3mup4*F(129))+p2mup3*p3mup1*p3mup2*(p1
     -   mup4*F(130)+p2mup4*F(131)+p3mup4*F(132))+p3mup1*p3mup2*p3mup
     -   3*(p1mup4*F(133)+p2mup4*F(134)+p3mup4*F(135))
c************************************************************************************
c************************************************************************************
c************************************************************************************
c The Finite virtual piece should be multiplied for (-1)  since 
c I have multiplied by (-I) to get the F"s and k"s without (I) factor
c . The factorization from the B_ij is Fact=(I/(4\[Pi])^2 (4 \[Pi])^Eps Gamma[1+Eps] (musq)^(-Eps))
c  c So, I*I=(-1)!!!
       result =-result
       Return
       End
