       subroutine gluonboxHiggsEven(m,p1,p2,p3,p4,mup1,mup2,mup3,resul
     -   t)
c !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
c
c
c
c
c
c
c
c
c !!! This routine includes an additional factor 3*m compared to the Higgs vertex routine.!!!
c
c
c
c
c
c
c
c
c
c !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

c Author: Francisco Campanario
c date: 2008-09-15
c determine box of 
c p1(gluon)    ---->------->--------->--------->---   p4(B) p4^2=M_h
c                $                   $              
c                $                   $              
c                $                   $              
c                V                   V              
c                $                   $              
c                $                   $              
c               p2                   p3             
c              mu_p2                 mu_p3           
c              p2^2=0                p3^2=0           
c Note: No couplings are assigned
c Note: To make it shorter in the promgram: mu_p2,...->mup2,... 
c Notation of External momenta: p1+p2+p3+p4=0 
c mu_p1,mu_p2,mu_p3,mu_p4 should be think as external current 
c musq is the renormalization scale energy  
c************************************************************************************
c************************************************************************************
c************************************************************************************
c    Declaration of variables 
c************************************************************************************
c************************************************************************************
c************************************************************************************
c************************************************************************************
       IMPLICIT NONE
      Real*8   p1(0:3),p2(0:3),p3(0:3),p4(0:3)
       Real*8   p1sq, p1p2, p1p3, p1p4, p2sq, p2p3, p2p4, p3sq, 
     -          p3p4, p4sq
       Real*8   s12, s13, s14, s23, s24, s34
       Complex*16   p1mup1, p1mup2, p1mup3, p2mup1, p2mup2, p2mup3, 
     -          p3mup1, p3mup2, p3mup3, p4mup1, p4mup2, p4mup3
       Complex*16   mup1mup2, mup1mup3, mup2mup3
       Real*8 dotrr
       Complex*16 B0tM,C0fin1M,D04 
       EXTERNAL dotrr,B0tM,C0fin1M,D04
       Complex*16 B012,B013,B014,B023,B024,B034
      Real*8 B012R,B013R,B014R,B023R,B024R,B034R
      Real*8 B012I,B013I,B014I,B023I,B024I,B034I
       Complex*16 C0123,C0124,C0134,C0234
       Real*8 C0123R,C0124R,C0134R,C0234R
       Real*8 C0123I,C0124I,C0134I,C0234I
       Real*8 C123R(4,2),C124R(4,2),C134R(4,2),C234R(4,2)
       Real*8 C123I(4,2),C124I(4,2),C134I(4,2),C234I(4,2)
       Complex*16 D01234
        Real*8 D01234R
       Real*8 D01234I
       Real*8 D1234R(13,3)
        Real*8 D1234I(13,3)
      Complex*16 F(36)
      Real*8 FI(36),FR(36),P(9)
      Complex*16 mup1(0:3),mup2(0:3),mup3(0:3)
      Complex*16 dotrc,dotcc,result
       Real*8 p5t,m,msq
      EXTERNAL   dotrc,dotcc
      Integer alpha
      Save F
c************************************************************************************
c************************************************************************************
c************************************************************************************
c************************************************************************************
c************************************************************************************
c************************************************************************************
c************************************************************************************
c************************************************************************************
c       Definition of the scalar products. Not inlcueded the contraction of the
c       moments with the external currents  
c************************************************************************************
c************************************************************************************
c************************************************************************************
c************************************************************************************
c************************************************************************************
c************************************************************************************
c************************************************************************************
       msq=m*m
       p1sq = dotrr(p1,p1)
       p1p2 = dotrr(p1,p2)
       p1p3 = dotrr(p1,p3)
       p1p4 = dotrr(p1,p4)
       p2sq = dotrr(p2,p2)
       p2p3 = dotrr(p2,p3)
       p2p4 = dotrr(p2,p4)
       p3sq = dotrr(p3,p3)
       p3p4 = dotrr(p3,p4)
       p4sq = dotrr(p4,p4)
       s12 = (p1sq +p2sq+ 2*p1p2) 
       s13 = (p1sq +p3sq+ 2*p1p3) 
       s14 = (p1sq +p4sq+ 2*p1p4) 
       s23 = (p2sq +p3sq+ 2*p2p3) 
       s24 = (p2sq +p4sq+ 2*p2p4) 
       s34 = (p3sq +p4sq+ 2*p3p4) 
c       Write(*,'(a5,F20.10)')," p1sq ", p1sq 
c       Write(*,'(a5,F20.10)')," p1p2 ", p1p2
c       Write(*,'(a5,F20.10)')," p1p3 ", p1p3
c       Write(*,'(a5,F20.10)')," p1p4 ", p1p4
c       Write(*,'(a5,F20.10)')," p2sq ", p2sq 
c       Write(*,'(a5,F20.10)')," p2p3 ", p2p3
c       Write(*,'(a5,F20.10)')," p2p4 ", p2p4
c       Write(*,'(a5,F20.10)')," p3sq ", p3sq 
c       Write(*,'(a5,F20.10)')," p3p4 ", p3p4
c       Write(*,'(a5,F20.10)')," p4sq ", p4sq 
c************************************************************************************
c************************************************************************************
c************************************************************************************
c************************************************************************************
c************************************************************************************
c************************************************************************************
c************************************************************************************
c************************************************************************************
c    Calling C_ij,D_ij Functions    
c************************************************************************************
c************************************************************************************
c************************************************************************************
c************************************************************************************
c************************************************************************************
       B012=B0tM(m,p1sq)  
       B013=B0tM(m,s12)   
       B014=B0tM(m,p4sq)   
       B023=B0tM(m,p2sq)  
       B024=B0tM(m,s23)   
       B034=B0tM(m,p3sq)  
       B012R=Dble(B012)          
       B013R=Dble(B013) 
       B014R=Dble(B014)   
       B023R=Dble(B023 ) 
       B024R=Dble(B024)  
       B034R=Dble(B034)  
       B012I=DIMAG(B012)          
       B013I=DIMAG(B013) 
       B014I=DIMAG(B014)   
       B023I=DIMAG(B023) 
       B024I=DIMAG(B024)  
       B034I=DIMAG(B034)  
c************************************************************************************
c************************************************************************************
      C0123=C0fin1M(m,p1sq,p2sq,s12) 
      C0124=C0fin1M(m,p1sq,s23,p4sq)  
      C0134=C0fin1M(m,s12,p3sq,p4sq)  
      C0234=C0fin1M(m,p2sq,p3sq,s23) 
c************************************************************************************
c************************************************************************************
c************************************************************************************
       call tens_red3_new_Re_Com_1M(m,p1sq,p2sq,s12,B023,B013,B012,C01
     -   23,C0123R,C0123I,C123R,C123I) 
       call tens_red3_new_Re_Com_1M(m,p1sq,s23,p4sq,B024,B014,B012,C01
     -   24,C0124R,C0124I,C124R,C124I) 
       call tens_red3_new_Re_Com_1M(m,s12,p3sq,p4sq,B034,B014,B013,C01
     -   34,C0134R,C0134I,C134R,C134I) 
       call tens_red3_new_Re_Com_1M(m,p2sq,p3sq,s23,B034,B024,B023,C02
     -   34,C0234R,C0234I,C234R,C234I) 
c************************************************************************************
c************************************************************************************
       D01234=D04(p1sq,p2sq,p3sq,p4sq,s12,s23,m,m,m,m)
c************************************************************************************
c************************************************************************************
       call tens_red4_new_Re_Com_1M(m,p1sq,p2sq,p3sq,p1p2,p1p3,p2p3,C0
     -   234R,C0134R,C0124R,C0123R,C234R,C134R,C124R,C123R,C0234I,C01
     -   34I,C0124I,C0123I,C234I,C134I,C124I,C123I,D01234,D01234R,D01
     -   234I,D1234R,D1234I)
c************************************************************************************
c************************************************************************************
c************************************************************************************
c************************************************************************************
c       Definition of the F,P functions:Independent of the currents    
c************************************************************************************
c************************************************************************************
c************************************************************************************
c************************************************************************************
c************************************************************************************
       P(1) = p1sq+p2sq-s12
       FR(1) = 12*msq*(C0134R+2*C134R(2,1)-4*D1234R(7,2)-8*D1234R(13,3
     -   ))-6*msq*(D01234R+2*D1234R(3,1))*P(1)
       FI(1) = 12*msq*(C0134I+2*C134I(2,1)-4*D1234I(7,2)-8*D1234I(13,3
     -   ))-6*msq*(D01234I+2*D1234I(3,1))*P(1)
       F(1)=DCMPLX(FR(1),FI(1))
       P(2) = 2*p1sq+p2sq-p4sq-s12+s23
       FR(2) = 6*msq*(4*(C0134R+C134R(1,1))-16*(D1234R(7,2)+D1234R(12,
     -   3))-2*D1234R(2,1)*P(1)-D01234R*P(2))
       FI(2) = 6*msq*(4*(C0134I+C134I(1,1))-16*(D1234I(7,2)+D1234I(12,
     -   3))-2*D1234I(2,1)*P(1)-D01234I*P(2))
       F(2)=DCMPLX(FR(2),FI(2))
       P(3) = p1sq-s12
       P(4) = p2sq-p3sq+s23+2*P(3)
       FR(3) = -6*msq*(2*(C0124R-2*(C0134R+C134R(1,1))+8*(D1234R(7,2)+
     -   D1234R(11,3))+D1234R(1,1)*P(1))+D01234R*P(4))
       FI(3) = -6*msq*(2*(C0124I-2*(C0134I+C134I(1,1))+8*(D1234I(7,2)+
     -   D1234I(11,3))+D1234I(1,1)*P(1))+D01234I*P(4))
       F(3)=DCMPLX(FR(3),FI(3))
       P(5) = p2sq+p4sq-s12-s23
       FR(4) = 6*msq*(-8*(D1234R(7,2)+2*D1234R(12,3))+(D01234R+2*D1234
     -   R(2,1))*P(5))
       FI(4) = 6*msq*(-8*(D1234I(7,2)+2*D1234I(12,3))+(D01234I+2*D1234
     -   I(2,1))*P(5))
       F(4)=DCMPLX(FR(4),FI(4))
       P(6) = p4sq-s12
       P(7) = p2sq-p3sq-s23+2*P(6)
       FR(5) = 6*msq*(2*(C0124R-8*(D1234R(7,2)+D1234R(11,3))+D1234R(1,
     -   1)*P(5))+D01234R*P(7))
       FI(5) = 6*msq*(2*(C0124I-8*(D1234I(7,2)+D1234I(11,3))+D1234I(1,
     -   1)*P(5))+D01234I*P(7))
       F(5)=DCMPLX(FR(5),FI(5))
       FR(6) = 6*msq*(-16*D1234R(13,3)+D01234R*P(1)-2*(C0134R-D1234R(3
     -   ,1)*P(5)))
       FI(6) = 6*msq*(-16*D1234I(13,3)+D01234I*P(1)-2*(C0134I-D1234I(3
     -   ,1)*P(5)))
       F(6)=DCMPLX(FR(6),FI(6))
       P(8) = -p2sq-p4sq+s12+s23
       P(9) = p2sq+p3sq-s23
       FR(7) = 6*msq*(4*C124R(2,1)-16*D1234R(12,3)+D01234R*P(8)-2*D123
     -   4R(2,1)*P(9))
       FI(7) = 6*msq*(4*C124I(2,1)-16*D1234I(12,3)+D01234I*P(8)-2*D123
     -   4I(2,1)*P(9))
       F(7)=DCMPLX(FR(7),FI(7))
       FR(8) = 12*msq*(C0124R+2*C124R(1,1)-4*D1234R(7,2)-8*D1234R(11,3
     -   ))-6*msq*(D01234R+2*D1234R(1,1))*P(9)
       FI(8) = 12*msq*(C0124I+2*C124I(1,1)-4*D1234I(7,2)-8*D1234I(11,3
     -   ))-6*msq*(D01234I+2*D1234I(1,1))*P(9)
       F(8)=DCMPLX(FR(8),FI(8))
       FR(9) = 6*msq*(4*C124R(2,1)-16*D1234R(13,3)-D01234R*P(1)+2*(C01
     -   34R-D1234R(3,1)*P(9)))
       FI(9) = 6*msq*(4*C124I(2,1)-16*D1234I(13,3)-D01234I*P(1)+2*(C01
     -   34I-D1234I(3,1)*P(9)))
       F(9)=DCMPLX(FR(9),FI(9))
       FR(10) = -48*msq*(D01234R+4*D1234R(1,1)+5*D1234R(1,2)+2*D1234R(
     -   1,3))
       FI(10) = -48*msq*(D01234I+4*D1234I(1,1)+5*D1234I(1,2)+2*D1234I(
     -   1,3))
       F(10)=DCMPLX(FR(10),FI(10))
       FR(11) = -48*msq*(D01234R+D1234R(2,1)+3*(D1234R(1,1)+D1234R(4,2
     -   ))+2*(D1234R(1,2)+D1234R(4,3)))
       FI(11) = -48*msq*(D01234I+D1234I(2,1)+3*(D1234I(1,1)+D1234I(4,2
     -   ))+2*(D1234I(1,2)+D1234I(4,3)))
       F(11)=DCMPLX(FR(11),FI(11))
       FR(12) = -24*msq*(D01234R+D1234R(1,1)+4*(D1234R(3,1)+2*D1234R(5
     -   ,2)+D1234R(5,3)))
       FI(12) = -24*msq*(D01234I+D1234I(1,1)+4*(D1234I(3,1)+2*D1234I(5
     -   ,2)+D1234I(5,3)))
       F(12)=DCMPLX(FR(12),FI(12))
       FR(13) = -24*msq*(D01234R+3*D1234R(1,1)+2*(D1234R(1,2)+D1234R(3
     -   ,1)+3*D1234R(5,2)+2*D1234R(5,3)))
       FI(13) = -24*msq*(D01234I+3*D1234I(1,1)+2*(D1234I(1,2)+D1234I(3
     -   ,1)+3*D1234I(5,2)+2*D1234I(5,3)))
       F(13)=DCMPLX(FR(13),FI(13))
       FR(14) = -24*msq*(D01234R+D1234R(1,1)+4*(D1234R(2,1)+2*D1234R(4
     -   ,2)+D1234R(4,3)))
       FI(14) = -24*msq*(D01234I+D1234I(1,1)+4*(D1234I(2,1)+2*D1234I(4
     -   ,2)+D1234I(4,3)))
       F(14)=DCMPLX(FR(14),FI(14))
       FR(15) = -24*msq*(D01234R+3*D1234R(1,1)+2*(D1234R(1,2)+D1234R(2
     -   ,1)+3*D1234R(4,2)+2*D1234R(4,3)))
       FI(15) = -24*msq*(D01234I+3*D1234I(1,1)+2*(D1234I(1,2)+D1234I(2
     -   ,1)+3*D1234I(4,2)+2*D1234I(4,3)))
       F(15)=DCMPLX(FR(15),FI(15))
       FR(16) = -24*msq*(D01234R+3*D1234R(2,1)+2*(D1234R(1,1)+D1234R(2
     -   ,2))+6*D1234R(4,2)+4*D1234R(6,3))
       FI(16) = -24*msq*(D01234I+3*D1234I(2,1)+2*(D1234I(1,1)+D1234I(2
     -   ,2))+6*D1234I(4,2)+4*D1234I(6,3))
       F(16)=DCMPLX(FR(16),FI(16))
       FR(17) = -24*msq*(D01234R+5*D1234R(2,1)+4*(D1234R(2,2)+D1234R(4
     -   ,2)+D1234R(6,3)))
       FI(17) = -24*msq*(D01234I+5*D1234I(2,1)+4*(D1234I(2,2)+D1234I(4
     -   ,2)+D1234I(6,3)))
       F(17)=DCMPLX(FR(17),FI(17))
       FR(18) = -12*msq*(D01234R+8*(D1234R(3,1)+D1234R(5,2)+D1234R(6,2
     -   )+D1234R(10,3)))
       FI(18) = -12*msq*(D01234I+8*(D1234I(3,1)+D1234I(5,2)+D1234I(6,2
     -   )+D1234I(10,3)))
       F(18)=DCMPLX(FR(18),FI(18))
       FR(19) = -12*msq*(D01234R+2*(D1234R(1,1)+2*(D1234R(3,1)+D1234R(
     -   6,2)+2*(D1234R(5,2)+D1234R(10,3)))))
       FI(19) = -12*msq*(D01234I+2*(D1234I(1,1)+2*(D1234I(3,1)+D1234I(
     -   6,2)+2*(D1234I(5,2)+D1234I(10,3)))))
       F(19)=DCMPLX(FR(19),FI(19))
       FR(20) = -12*msq*(D01234R+2*(D1234R(2,1)+2*(D1234R(3,1)+D1234R(
     -   5,2)+2*(D1234R(6,2)+D1234R(10,3)))))
       FI(20) = -12*msq*(D01234I+2*(D1234I(2,1)+2*(D1234I(3,1)+D1234I(
     -   5,2)+2*(D1234I(6,2)+D1234I(10,3)))))
       F(20)=DCMPLX(FR(20),FI(20))
       FR(21) = -12*msq*(D01234R+2*(D1234R(1,1)+D1234R(2,1)+D1234R(3,1
     -   )+2*(D1234R(4,2)+D1234R(5,2)+D1234R(6,2)+2*D1234R(10,3))))
       FI(21) = -12*msq*(D01234I+2*(D1234I(1,1)+D1234I(2,1)+D1234I(3,1
     -   )+2*(D1234I(4,2)+D1234I(5,2)+D1234I(6,2)+2*D1234I(10,3))))
       F(21)=DCMPLX(FR(21),FI(21))
       FR(22) = -12*msq*(D01234R+2*D1234R(3,1)+4*(D1234R(2,1)+D1234R(4
     -   ,2))+8*(D1234R(6,2)+D1234R(10,3)))
       FI(22) = -12*msq*(D01234I+2*D1234I(3,1)+4*(D1234I(2,1)+D1234I(4
     -   ,2))+8*(D1234I(6,2)+D1234I(10,3)))
       F(22)=DCMPLX(FR(22),FI(22))
       FR(23) = -48*msq*(D1234R(3,1)+D1234R(5,2)+2*(D1234R(3,2)+D1234R
     -   (7,3)))
       FI(23) = -48*msq*(D1234I(3,1)+D1234I(5,2)+2*(D1234I(3,2)+D1234I
     -   (7,3)))
       F(23)=DCMPLX(FR(23),FI(23))
       FR(24) = -48*msq*(D1234R(3,1)+3*D1234R(5,2)+2*D1234R(5,3))
       FI(24) = -48*msq*(D1234I(3,1)+3*D1234I(5,2)+2*D1234I(5,3))
       F(24)=DCMPLX(FR(24),FI(24))
       FR(25) = -48*msq*(D1234R(3,1)+3*D1234R(6,2)+2*D1234R(8,3))
       FI(25) = -48*msq*(D1234I(3,1)+3*D1234I(6,2)+2*D1234I(8,3))
       F(25)=DCMPLX(FR(25),FI(25))
       FR(26) = -48*msq*(D1234R(2,1)+D1234R(4,2)+2*(D1234R(2,2)+D1234R
     -   (6,3)))
       FI(26) = -48*msq*(D1234I(2,1)+D1234I(4,2)+2*(D1234I(2,2)+D1234I
     -   (6,3)))
       F(26)=DCMPLX(FR(26),FI(26))
       FR(27) = -48*msq*(D1234R(2,1)+3*D1234R(2,2)+2*D1234R(2,3))
       FI(27) = -48*msq*(D1234I(2,1)+3*D1234I(2,2)+2*D1234I(2,3))
       F(27)=DCMPLX(FR(27),FI(27))
       FR(28) = 12*msq*(D01234R-8*(D1234R(6,2)+D1234R(10,3)))
       FI(28) = 12*msq*(D01234I-8*(D1234I(6,2)+D1234I(10,3)))
       F(28)=DCMPLX(FR(28),FI(28))
       FR(29) = -24*msq*(D1234R(3,1)+4*(D1234R(3,2)+D1234R(7,3)))
       FI(29) = -24*msq*(D1234I(3,1)+4*(D1234I(3,2)+D1234I(7,3)))
       F(29)=DCMPLX(FR(29),FI(29))
       FR(30) = -24*msq*(D1234R(3,1)+2*(D1234R(3,2)+D1234R(5,2)+2*D123
     -   4R(7,3)))
       FI(30) = -24*msq*(D1234I(3,1)+2*(D1234I(3,2)+D1234I(5,2)+2*D123
     -   4I(7,3)))
       F(30)=DCMPLX(FR(30),FI(30))
       FR(31) = -24*msq*(D1234R(3,1)+4*(D1234R(3,2)+D1234R(9,3)))
       FI(31) = -24*msq*(D1234I(3,1)+4*(D1234I(3,2)+D1234I(9,3)))
       F(31)=DCMPLX(FR(31),FI(31))
       FR(32) = -24*msq*(D1234R(3,1)+2*(D1234R(3,2)+D1234R(6,2)+2*D123
     -   4R(9,3)))
       FI(32) = -24*msq*(D1234I(3,1)+2*(D1234I(3,2)+D1234I(6,2)+2*D123
     -   4I(9,3)))
       F(32)=DCMPLX(FR(32),FI(32))
       FR(33) = -24*msq*(D1234R(2,1)+4*(D1234R(6,2)+D1234R(8,3)))
       FI(33) = -24*msq*(D1234I(2,1)+4*(D1234I(6,2)+D1234I(8,3)))
       F(33)=DCMPLX(FR(33),FI(33))
       FR(34) = -24*msq*(D1234R(2,1)+2*(D1234R(2,2)+D1234R(6,2)+2*D123
     -   4R(8,3)))
       FI(34) = -24*msq*(D1234I(2,1)+2*(D1234I(2,2)+D1234I(6,2)+2*D123
     -   4I(8,3)))
       F(34)=DCMPLX(FR(34),FI(34))
       FR(35) = -48*msq*(D1234R(3,2)+2*D1234R(3,3))
       FI(35) = -48*msq*(D1234I(3,2)+2*D1234I(3,3))
       F(35)=DCMPLX(FR(35),FI(35))
       FR(36) = -48*msq*(D1234R(6,2)+2*D1234R(9,3))
       FI(36) = -48*msq*(D1234I(6,2)+2*D1234I(9,3))
       F(36)=DCMPLX(FR(36),FI(36))
c************************************************************************************
c************************************************************************************
c************************************************************************************
c************************************************************************************
c               PART THAT DEPENDS ON THE EXTERNAL CURRENT
c************************************************************************************
c************************************************************************************
c************************************************************************************
       p1mup1 = dotrc(p1,mup1)
       p1mup2 = dotrc(p1,mup2)
       p1mup3 = dotrc(p1,mup3)
       p2mup1 = dotrc(p2,mup1)
       p2mup2 = dotrc(p2,mup2)
       p2mup3 = dotrc(p2,mup3)
       p3mup1 = dotrc(p3,mup1)
       p3mup2 = dotrc(p3,mup2)
       p3mup3 = dotrc(p3,mup3)
       p4mup1 = dotrc(p4,mup1)
       p4mup2 = dotrc(p4,mup2)
       p4mup3 = dotrc(p4,mup3)
       mup1mup2 = dotcc(mup1,mup2)
       mup1mup3 = dotcc(mup1,mup3)
       mup2mup3 = dotcc(mup2,mup3)
c************************************************************************************
c************************************************************************************
c************************************************************************************
c       Amplitude                         
c************************************************************************************
c************************************************************************************
c************************************************************************************
c************************************************************************************


       result = mup1mup2*p3mup3*F(1)+mup1mup2*p2mup3*F(2)+mup1mup2*p1m
     -   up3*F(3)+mup1mup3*p2mup2*F(4)+mup1mup3*p1mup2*F(5)+mup1mup3*
     -   p3mup2*F(6)+mup2mup3*p2mup1*F(7)+mup2mup3*p1mup1*F(8)+mup2mu
     -   p3*p3mup1*F(9)+p1mup1*p1mup2*p1mup3*F(10)+p1mup1*p1mup2*p2mu
     -   p3*F(11)+p1mup2*p1mup3*p3mup1*F(12)+p1mup1*p1mup2*p3mup3*F(1
     -   3)+p1mup2*p1mup3*p2mup1*F(14)+p1mup1*p1mup3*p2mup2*F(15)+p1m
     -   up1*p2mup2*p2mup3*F(16)+p1mup2*p2mup1*p2mup3*F(17)+p1mup2*p2
     -   mup3*p3mup1*F(18)+p1mup1*p2mup3*p3mup2*F(19)+p1mup3*p2mup2*p
     -   3mup1*F(20)+p1mup1*p2mup2*p3mup3*F(21)+p1mup2*p2mup1*p3mup3*
     -   F(22)+p1mup2*p3mup1*p3mup3*F(23)+p1mup1*p1mup3*p3mup2*F(24)+
     -   p2mup2*p2mup3*p3mup1*F(25)+p1mup3*p2mup1*p2mup2*F(26)+p2mup1
     -   *p2mup2*p2mup3*F(27)+p1mup3*p2mup1*p3mup2*F(28)+p1mup3*p3mup
     -   1*p3mup2*F(29)+p1mup1*p3mup2*p3mup3*F(30)+p2mup3*p3mup1*p3mu
     -   p2*F(31)+p2mup2*p3mup1*p3mup3*F(32)+p2mup1*p2mup3*p3mup2*F(3
     -   3)+p2mup1*p2mup2*p3mup3*F(34)+p3mup1*p3mup2*p3mup3*F(35)+p2m
     -   up1*p3mup2*p3mup3*F(36)
c************************************************************************************
c************************************************************************************
c************************************************************************************
       Return
       End
