
      subroutine def_ps_qqDY(bos1)


      implicit none

#include "VBFNLO/utilities/global.inc"
#include "VBFNLO/utilities/kkcoupl.inc"

      integer bos(1), i, bos1

c set up variables in common block BLIPSI for call of LIPSVVJ

      REAL*8 RM2,RMG,RM2MIN,RM2MAX, S,rm2x, rmgx
      REAL*8  RM2MINX1, RM2MAXX1
      COMMON /BLIPSI/ RM2,RMG,RM2MIN,RM2MAX,
     1                RM2MINX1, RM2MAXX1, S, rm2x, rmgx

      DOUBLE PRECISION CLR,XM2,XMG,B,V,A
      COMMON /BKOPOU/ CLR(4,5,-1:1),XM2(6),XMG(6),B(6,6,6),V(4,5),A(4,5)

      s = ecm**2

      bos(1) = bos1
 

         rm2 = xm2(bos(1))        ! mass squared
         rmg = xmg(bos(1))        ! mass * decay width
         if (bos(i).eq.2) then
            rm2min = 1d-3
            rm2max = s/2d0
	    rm2x= z1mass_k(1)**2
	    rmgx=z1mass_k(1)*z1width_k(1)
         else
            rm2min = 1d-3           ! minimal/maximal value of mass squared
            rm2max = s/2d0          ! for tan mapping
	    rm2x= w1mass_k(1)**2
	    rmgx=w1mass_k(1)*w1width_k(1)	    	    
         endif

!       if (with_kk)then
!       rm2minx1 = ((rm2x- 15d0*rmgx)/sqrt(rm2x) )**2
!       rm2maxx1 = ((rm2x+15d0*rmgx)/sqrt(rm2x) )**2       
!       else 
      rm2minx1 = ((rm2- 15d0*rmg)/sqrt(rm2) )**2
      rm2maxx1 = ((rm2+15d0*rmg)/sqrt(rm2) )**2    
!       endif



 60   format ( " machine energy = ", f10.1, "  GeV" )
 70   format ( " integration range for boson ",i3," = ",f10.3,
     1         "  to ",f12.3," GeV" )
 72   format ( " boson has mass ",f8.2," GeV and width ",
     1         f10.4," GeV" )
      if (.not.ldoblha) then
        write(6,*)
        write(6,*) "--------------------PHASE SPACE--------------------"
        write(6,*)

           write(6,72) sqrt(rm2),rmg/sqrt(rm2)
           write(6,70) bos(1),sqrt(rm2min),sqrt(rm2max)

        write(6,*)
!         write(6,10) ptjmin
!         write(6,30) yjmin
!         write(6,40) yjmax
        write(6,60) sqrt(s)
        write(6,*)
        write(6,*) "---------------------------------------------------"
        write(6,*)
      endif

      end


c
c phase space generator for pp --> t + q
c
c       Franziska Schissler: schissler@particle.uni-karlsruhe.de
c       Initial version:  2011 March 05
C
C  INPUT:   RD        random number array (between 0 and 1)
C           RN        additional random number which will not be driven by
C                     MONACO = azimuthal angle
C
C  OUTPUT:  K1,K2     4-vectors for 2 incoming partons
C           X1,X2     corresponding values of Feynman x
C           Q(0:4,2)  4-vectors for the vector boson resonances V1 and V2,
C                     the 4th component contains the mass**2
C           D(0:3,4)  4-vectors for the 4 decay leptons, assumed massless
C                     V1(Q(*,1)) --> D(*,1)+D(*,2)
C                     V2(Q(*,2)) --> D(*,3)+D(*,4)
C           P(*,N)    4-vectors for the N jets, assumed massless (except top)
C           W         the weight of the phase space point
C
C
C  INPUT INFORMATION on the phase space region is transferred via the
C    common block /BLIPSI/
C

c      REAL*8 RM2,RMG,RM2MIN,RM2MAX, S,M2MIN, YJMIN,YJMAX,PTJMIN,EJMIN
c      INTEGER INFOJ, iwidth
C           S         center of mass energy**2 of the machine
c      COMMON /BLIPSI/ RM2(0:2),RMG(0:2),RM2MIN(0:2),RM2MAX(0:2),
c     1                S,M2MIN,YJMIN(N1),YJMAX(N1),PTJMIN(N1),EJMIN(N1),
c     2                INFOJ(N1), iwidth(0:2)
C
      subroutine lipsdy(rd,rn,k1,k2,p,x1,x2,w)
 
      implicit none

#include "VBFNLO/utilities/global.inc"
#include "VBFNLO/utilities/process.inc"
#include "VBFNLO/utilities/cuts.inc"
c received from global.inc:
c     nrand = phase space dim - 2 - phi
c     ecm   = collider energy


      logical mdebug, lhist, lhist1
      parameter(mdebug=.false.)

      integer hmem
      common /PAWC/ hmem
      real*8 alfas, xmt, alfa, xmz, xmw, sin2w, xmh, gf, alfas_lo
      common /bkopin/ alfas, xmt, alfa, xmz, xmw, sin2w, xmh, gf, alfas_lo
      REAL*8 RM2,RMG,RM2MIN,RM2MAX, S,YJMIN,YJMAX,PTJMIN
      REAL*8  RM2MINX1, RM2MAXX1, rm2x, rmgx
      COMMON /BLIPSI/ RM2,RMG,RM2MIN,RM2MAX,
     1                RM2MINX1, RM2MAXX1, S, rm2x, rmgx     


      integer n1, itn
      double precision tpi
      parameter (n1=2, tpi=2D0*PI )!n1=max_p-nx
      double precision rd(*),rn,k1(0:3),k2(0:3),p(0:3,n1),x1,x2,w    

c only local variables ---------------------------------
      integer i, mu
      double precision pT, pTmax, pL, ycm, ycm_border, ET, abs_p
      double precision coshycm, sinhycm, temp, test, k(0:4)
      double precision taumin, y, y_border, tau, phi
c      double precision border, pT, pL, E3, E4, test  !temp variables

      double precision xxwidth, xxm, nrandl, px(4), abs_pX, phiX, sinthetaX,
     &                 costhetax
      parameter (nrandl=(1+3)*3 )
      real*8 xminx, xmaxx, delxx, tanxx, xx, RM2MINX, RM2MAXX ,qsq    
      real*8 xminx_kk, xmaxx_kk, RM2MINX_kk, RM2MAXX_kk ,qsq_kk 
      real*8 xxm_kk, xxwidth_kk

      parameter ( xxwidth = 10d1, xxm = 90d1 )      
      LOGICAL RESONANCE
      EXTERNAL RESONANCE
      LOGICAL untested
      PARAMETER (Untested=.false.)
      
      if(untested) then
         if(ptlmin(1).gt.40d0) then  
            rm2min=ptlmin(1)*1.95d0
     
         elseif (mllmin.gt.ptlmin(1).and.mllmin.gt.30d0) then 
            rm2min=mllmin
         endif
      endif
 !     print*, rm2min
      s = ecm**2

      w=1d0

!       if (mllmin.gt.300.or.mllminall.gt.300) then

!         if ( rd(1) .le.  0.2d0 ) then
!            if (.not. Resonance(rm2, rmg, rm2min, rm2minx1,
!      1                     (rd(1))/0.2d0, W, qsq)) return
!            W = W/0.2d0
!  
!         else 
!	if ( rd(1) .le.  0.7d0) then

!            if (.not. Resonance(rm2, rmg, rm2min, rm2maxx1,
!      1                     (rd(1)-0.7d0)/0.7d0, W, qsq)) return	     
!            W = W/0.7d0
! 	else
!            if (.not. Resonance(rm2x, rmgx, rm2maxx1, rm2max,
!      1                     (rd(1)-0.7d0)/0.3d0, W, qsq)) return
!            W = W/0.3d0	
!  	endif
	
!          if(.not. Resonance(rm2x, rmgx, rm2min, rm2max, rd(1), w, qsq)) return	  
!       else
	  
          if(.not. Resonance(rm2, rmg, rm2min, rm2max, rd(1), w, qsq)) return
!       endif
      
!      ELSE ! 2 -> Y
c Generate y, tau -> x1, x2, shat from RD(1) and RD(2) first **************
          tau = qsq/s           !rd(1)
          W = W / s
          y_border = log(1/tau)
          y = y_border*( RD(2) - 0.5d0 )
          W = W * y_border      !(prop density)^-1 of y

          x1 = sqrt(tau) * exp(y)
          x2 = sqrt(tau) * exp(-y)

c generate incoming momenta in lab frame out of x1 x2
          k1(0) = 0.5d0 * x1 * ecm
          k1(1) = 0d0
          k1(2) = 0d0
          k1(3) = 0.5d0 * x1 * ecm
          
          k2(0) = 0.5d0 * x2 * ecm
          k2(1) = 0d0
          k2(2) = 0d0
          k2(3) = - 0.5d0 * x2 * ecm
          
          do mu = 0, 3
             K(mu) = k1(mu)+k2(mu)
          enddo
          
          K(4) = K(0)**2 - K(1)**2 - K(2)**2 - K(3)**2



          call TwoBodyDecay0(rd(3), rn, K(0), K(4),p(0,1),p(0,2),W)
     
     
     
         W = W * 1.d0/2d0/K(4)        ! Flux
         W = W * TPI                  ! (2*pi)^(4-3) from delta- and ps-int
         W = W * 3.89379304d11        ! conversion into fb

!      ENDIF

c generate phase space for decay of X -> V1 + A3 out of rd(6-7)


c ============================= rest passiert im Hauptprogramm    

      if (mdebug) then
         print*, rd(1), rd(2), rd(3)
         print*, "y     = ", y
         print*, "tau   = ", tau
         print*, "ycm   = ", ycm
         print*, "phi   = ", phi
         print*, "x1    = ", x1
         print*, "x2    = ", x2
         print*, "wgt   = ", w
         print*, "---------------------------"

         print*, "--- momenta conservation ? ---"
         do mu=0,3
            test = k1(mu)+k2(mu)-p(mu,1)-p(mu,2)
            print*, test
         enddo
         print*, "-----------------------"

      endif

      return
      end subroutine

