      subroutine read_pwg(p,v,bornlike)
      implicit none
      
#include "global.inc"
#include "process.inc"      


c     4-momenta of the partons involved in the basic QCD 2->2(+1)+X process.
c     The partons are the incoming quarks/gluons + the 2 tagging jets + 
c     the real emission (for NLO only)
      real*8 p(0:3,n_p+1) !Since there might be an additional gluon compared to born!! 

c     Additional particles like a higgs boson, or any decay products 
c     (also hadronic ones). in short: everything which is not a parton 
c     involved in the basic QCD 2->2(+1)+X process.
      real*8 v(0:3,n_v) 
      
      integer numparticles,i, j, st, mu
      character * 50 text
      real*8 unimportant, alfas_pwg
      real*8 momenta(0:6,n_p+n_v+1), mass !4 momenta(0:3), quarktype(4), colour(5+6anti), number
      real*8 bornflav(max_p), realflav(max_p)
      common/flavREW/bornflav, realflav
      real*8 px,py,pz,E,mom(0:3)
      logical upline, lowline, initial
      common/uplow/ upline, lowline, initial
      logical bornlike
     

      read(333,*) numparticles!, unimportant, unimportant, unimportant, unimportant, alfas_pwg
      
      
      do mu=0,3
         do i=1,n_v
            v(mu,i)=0d0
         enddo
         do i=1,n_p+n_v+1
            momenta(mu,i)=0d0
         enddo         
         do i=1,n_p+1
            p(mu,i)=0d0
         enddo         
      enddo
         
      select case (process)
c     ON SHELL HIGGS PRODUCTION      
      case(Hjj)
      if (numparticles.eq.n_p+n_v) then
ccccc REAL EMISSION EVENTS ccccccccccccccccccccccc   
      bornlike=.false.
      E=0d0
      px=0d0
      py=0d0
      pz=0d0
         do i=1, numparticles-1      
            read(333,*) momenta(4,i),unimportant, unimportant, unimportant, momenta(5,i), momenta(6,i),
     &      momenta(1,i), momenta(2,i), momenta(3,i), unimportant, mass
c   energy out of invariant mass     
            if(mass.lt.5d0) then ! b-quarks are treated massless
               mass=0d0
               momenta(0,i)=sqrt(momenta(1,i)**2+momenta(2,i)**2+momenta(3,i)**2)
            else
               momenta(0,i)=sqrt(mass**2+momenta(1,i)**2+momenta(2,i)**2+momenta(3,i)**2)   
            endif
            
            if(i.le.2) then !last momentum from momentum conservation, therefore subtract all p,E of initial state particles
               px=px-momenta(1,i)
               py=py-momenta(2,i)
               pz=pz-momenta(3,i)   
               E=E-momenta(0,i)                         
            elseif(i.gt.2) then !last momentum from momentum conservation, therefore add all p,E of final state particles
               px=px+momenta(1,i)
               py=py+momenta(2,i)
               pz=pz+momenta(3,i)      
               E=E+momenta(0,i)                
            endif
         enddo
         read(333,*) momenta(4,numparticles),unimportant, unimportant, 
     &        unimportant, momenta(5,numparticles), 
     &        momenta(6,numparticles),unimportant, unimportant, 
     &        unimportant, unimportant, mass
         momenta(1,numparticles)= -px
         momenta(2,numparticles)= -py
         momenta(3,numparticles)= -pz
            if(mass.lt.5d0) then !b quark is treated massless!
               mass=0d0
               momenta(0,numparticles)=sqrt(momenta(1,numparticles)**2+
     &              momenta(2,numparticles)**2+momenta(3,numparticles)**2)
            else
               momenta(0,numparticles)=sqrt(mass*2+
     &              momenta(1,numparticles)**2+
     &              momenta(2,numparticles)**2+
     &              momenta(3,numparticles)**2)            
            endif   
         E=E+momenta(0,numparticles) 

            
         momenta(0,1)=momenta(0,1)+E/2.  !make sure that energy & momenta are conserved
         momenta(0,2)=momenta(0,2)+E/2.
         momenta(3,1)=momenta(3,1)+E/2.
         momenta(3,2)=momenta(3,2)-E/2.

            
         !where is the gloun??
         upline=.false. 
         lowline=.false.
         initial=.false.       
         if (momenta(4,1).eq.21) then
             upline=.true. 
             initial=.true.
             momenta(4,1)=0 !gloun has ID 0
         elseif(momenta(4,2).eq.21) then
             lowline=.true.
             initial=.true.       
             momenta(4,2)=0 !gloun has ID 0             
         elseif(momenta(4,numparticles).eq.21) then         
             if((momenta(5,numparticles).eq.momenta(5,1)).or.    !color matches
     &           (momenta(6,numparticles).eq.momenta(6,1)) )then     ! or anticolor matches to first parton
                upline=.true.
             elseif((momenta(5,numparticles).eq.momenta(5,2)).or.   ! second parton
     &              (momenta(6,numparticles).eq.momenta(6,2))) then
                lowline=.true.
             else
                write(*,*) "Error with final state gluons, STOP"         
                stop
             endif
c            switch to gloun=0 is done when changed to initial state!!             
         else
             write(*,*) "No gluon found!! STOP"
             stop
         endif   
        
ccccc BORNLIKE EVENTS ccccccccccccccccccccccc        
      elseif (numparticles.eq.n_p+n_v-1) then
         bornlike=.true.    
         upline=.false. 
         lowline=.false.
         initial=.false.        
         px=0d0
         py=0d0
         pz=0d0
         E=0d0
         do i=1, numparticles-1
            read(333,*) momenta(4,i),unimportant, unimportant, 
     &           unimportant, momenta(5,i), momenta(6,i),
     &      momenta(1,i), momenta(2,i), momenta(3,i), unimportant, mass
            if(mass.lt.5d0) then
               mass=0d0
               momenta(0,i)=sqrt(momenta(1,i)**2+momenta(2,i)**2+
     &              momenta(3,i)**2)
            else
               momenta(0,i)=sqrt(mass**2+momenta(1,i)**2+
     &              momenta(2,i)**2+momenta(3,i)**2)   
            endif
         
            if(i.le.2) then !last momentum from momentum conservation, therefore subtract all p,E of initial state particles
               px=px-momenta(1,i)
               py=py-momenta(2,i)
               pz=pz-momenta(3,i) 
               E=E-momenta(0,i)
            endif               
            if(i.gt.2) then !last momentum from momentum conservation, therefore add all p,E of final state particles
               px=px+momenta(1,i)
               py=py+momenta(2,i)
               pz=pz+momenta(3,i)           
               E=E+momenta(0,i)
            endif
        enddo
      
        read(333,*) momenta(4,numparticles),unimportant, unimportant, 
     &       unimportant, momenta(5,numparticles), 
     &       momenta(6,numparticles),unimportant, unimportant, 
     &       unimportant, unimportant, mass
     
        momenta(1,numparticles)= -px
        momenta(2,numparticles)= -py
        momenta(3,numparticles)= -pz
        
        if(mass.lt.5d0) then
            mass=0d0
            momenta(0,numparticles)=sqrt(momenta(1,numparticles)**2+
     &           momenta(2,numparticles)**2+momenta(3,numparticles)**2)
        else
            momenta(0,numparticles)=sqrt(mass*2+
     &           momenta(1,numparticles)**2+momenta(2,numparticles)**2+
     &           momenta(3,numparticles)**2)            
        endif        

        E=E+momenta(0,numparticles) 
           
        momenta(0,1)=momenta(0,1)+E/2.
        momenta(0,2)=momenta(0,2)+E/2.
        momenta(3,1)=momenta(3,1)+E/2.
        momenta(3,2)=momenta(3,2)-E/2.

      else
         write(*,*) 'unknown number of particles, STOP'
         stop 
      endif

               
c write all falvours down  
      if(bornlike) then
         do i=1,2
           bornflav(i)=momenta(4,i) 
           if (bornflav(i).eq.5) bornflav(i)=3 !change b to s quark, only factor, no problem in ratio         
           if (bornflav(i).eq.-5) bornflav(i)=-3 !change b to s quark, only factor, no problem in ratio            
         enddo             
         do i=3,n_p
           bornflav(i)=momenta(4,i+n_v-1) 
           if (bornflav(i).eq.5) bornflav(i)=3 !change b to s quark, only factor, no problem in ratio         
           if (bornflav(i).eq.-5) bornflav(i)=-3 !change b to s quark, only factor, no problem in ratio            
         enddo
      else
         do i=1,2
           realflav(i)=momenta(4,i) 
           if (realflav(i).eq.5) realflav(i)=3 !change b to s quark, only factor, no problem in ratio         
           if (realflav(i).eq.-5) realflav(i)=-3 !change b to s quark, only factor, no problem in ratio            
         enddo             
         do i=3,n_p+1
           realflav(i)=momenta(4,i+n_v-1)  
           if (realflav(i).eq.5) realflav(i)=3 !change b to s quark, only factor, no problem in ratio         
           if (realflav(i).eq.-5) realflav(i)=-3 !change b to s quark, only factor, no problem in ratio            
         enddo      
      endif             

c write all momenta into vbfnlo format      
      do mu=0,3
         do i=1,2
           p(mu,i)=momenta(mu,i) 
         enddo   
         do i=1,n_v-1
           v(mu,i)=momenta(mu,i+2) 
         enddo            
         do i=3,n_p+1
           p(mu,i)=momenta(mu,i+n_v-1) 
         enddo             
      enddo 


 
c     HIGGS DECAY PRODUCTS IN LHA-FILE  
      case default
      
      if (numparticles.eq.n_p+n_v+1) then
ccccc REAL EMISSION EVENTS ccccccccccccccccccccccc   
         bornlike=.false.      
         px=0d0
         py=0d0
         pz=0d0
         E=0d0
         do i=1, numparticles-1    
            read(333,*) momenta(4,i),unimportant, unimportant, 
     &           unimportant, momenta(5,i), momenta(6,i),
     &      momenta(1,i), momenta(2,i), momenta(3,i), unimportant, mass
            if(mass.lt.5d0) then
               mass=0d0
               momenta(0,i)=sqrt(momenta(1,i)**2+momenta(2,i)**2+
     &              momenta(3,i)**2)
            else
               momenta(0,i)=sqrt(mass**2+momenta(1,i)**2+
     &              momenta(2,i)**2+momenta(3,i)**2)   
            endif
            if(i.le.2) then !last momentum from momentum conservation, therefore subtract all p,E of initial state particles
               px=px-momenta(1,i)
               py=py-momenta(2,i)
               pz=pz-momenta(3,i)  
               E=E-momenta(0,i)
            endif               
            if(i.gt.2) then !last momentum from momentum conservation, therefore add all p,E of final state particles
               px=px+momenta(1,i)
               py=py+momenta(2,i)
               pz=pz+momenta(3,i)   
               E=E+momenta(0,i)
            endif
         enddo
         read(333,*) momenta(4,numparticles),unimportant, unimportant, 
     &        unimportant, momenta(5,numparticles), 
     &        momenta(6,numparticles),unimportant, unimportant, 
     &        unimportant, unimportant, mass
         momenta(1,numparticles)= -px
         momenta(2,numparticles)= -py
         momenta(3,numparticles)= -pz
         if(mass.lt.5d0) then
            mass=0d0
            momenta(0,numparticles)=sqrt(momenta(1,numparticles)**2+
     &           momenta(2,numparticles)**2+momenta(3,numparticles)**2)
         else
            momenta(0,numparticles)=sqrt(mass*2+
     &           momenta(1,numparticles)**2+momenta(2,numparticles)**2+
     &           momenta(3,numparticles)**2)            
         endif   
         E=E+momenta(0,numparticles) 
            
         momenta(0,1)=momenta(0,1)+E/2.  !make sure that energy & momenta are conserved
         momenta(0,2)=momenta(0,2)+E/2.
         momenta(3,1)=momenta(3,1)+E/2.
         momenta(3,2)=momenta(3,2)-E/2.            
         !where is the gloun??
         upline=.false. 
         lowline=.false.
         initial=.false.  
         if (momenta(4,1).eq.21) then
             upline=.true. 
             initial=.true.
             momenta(4,1)=0
         elseif(momenta(4,2).eq.21) then
             lowline=.true.
             initial=.true.  
             momenta(4,2)=0
         elseif(momenta(4,numparticles).eq.21) then
             if((momenta(5,numparticles).eq.momenta(5,1)).or.
     &           (momenta(5,numparticles).eq.momenta(5,numparticles-2)).or. !color matches
     &           (momenta(6,numparticles).eq.momenta(6,1)).or.
     &           (momenta(6,numparticles).eq.momenta(6,numparticles-2))) then ! or anticolor matches
                upline=.true.
             elseif((momenta(5,numparticles).eq.momenta(5,2)).or.
     &               (momenta(5,numparticles).eq.momenta(5,numparticles-1)).or.
     &              (momenta(6,numparticles).eq.momenta(6,2)).or.
     &               (momenta(6,numparticles).eq.momenta(6,numparticles-1))) then
                lowline=.true.
             else
                write(*,*) "Error with final state gluons, STOP"         
                stop
             endif
         else
             write(*,*) "No gluon found!! STOP"
             stop
         endif
              
      else if (numparticles.eq.n_p+n_v) then  
ccccc BORNLIKE EVENTS ccccccccccccccccccccccc   
         bornlike=.true.      
         px=0d0
         py=0d0
         pz=0d0
         E=0d0
         do i=1, numparticles-1
            read(333,*) momenta(4,i),unimportant, unimportant, 
     &           unimportant, momenta(5,i), momenta(6,i),
     &         momenta(1,i), momenta(2,i), momenta(3,i), unimportant, mass
            if(mass.lt.5d0) then
               mass=0d0
               momenta(0,i)=sqrt(momenta(1,i)**2+momenta(2,i)**2+momenta(3,i)**2)
            else
               momenta(0,i)=sqrt(mass**2+momenta(1,i)**2+momenta(2,i)**2+momenta(3,i)**2)   
            endif
      
            if(i.le.2) then !last momentum from momentum conservation, therefore subtract all p,E of initial state particles
               px=px-momenta(1,i)
               py=py-momenta(2,i)
               pz=pz-momenta(3,i) 
               E =E-momenta(0,i)
            endif               
           if(i.gt.2) then !last momentum from momentum conservation, therefore add all p,E of final state particles
               px=px+momenta(1,i)
               py=py+momenta(2,i)
               pz=pz+momenta(3,i)  
               E=E+momenta(0,i)
            endif
         enddo
         read(333,*) momenta(4,numparticles),unimportant, unimportant, 
     &        unimportant, momenta(5,numparticles), momenta(6,numparticles),
     &        unimportant, unimportant, unimportant, unimportant, mass
         momenta(1,numparticles)= -px
         momenta(2,numparticles)= -py
         momenta(3,numparticles)= -pz
      
         if(mass.lt.1d-5) then
           mass=0d0
           momenta(0,numparticles)=sqrt(momenta(1,numparticles)**2+
     &          momenta(2,numparticles)**2+momenta(3,numparticles)**2)
         else
           momenta(0,numparticles)=sqrt(mass*2+
     &           momenta(1,numparticles)**2+momenta(2,numparticles)**2+momenta(3,numparticles)**2)            
         endif        
      
         E=E+momenta(0,numparticles) 

            
         momenta(0,1)=momenta(0,1)+E/2.  !make sure that energy & momenta are conserved
         momenta(0,2)=momenta(0,2)+E/2.
         momenta(3,1)=momenta(3,1)+E/2.
         momenta(3,2)=momenta(3,2)-E/2.
      else
         write(*,*) 'unknown number of particles, STOP'
         stop 
      endif
      
c write all falvours down  
      if(bornlike) then
         do i=1,2
            bornflav(i)=momenta(4,i) 
            if (bornflav(i).eq.5) bornflav(i)=3 !change b to s quark, only factor, no problem in ratio         
            if (bornflav(i).eq.-5) bornflav(i)=-3 !change b to s quark, only factor, no problem in ratio                  
         enddo             
         do i=3,n_p
            bornflav(i)=momenta(4,i+n_v)  
            if (bornflav(i).eq.5) bornflav(i)=3 !change b to s quark, only factor, no problem in ratio
            if (bornflav(i).eq.-5) bornflav(i)=-3 !change b to s quark, only factor, no problem in ratio         
         enddo
      else
         do i=1,2
            realflav(i)=momenta(4,i) 
            if (realflav(i).eq.5) realflav(i)=3 !change b to s quark, only factor, no problem in ratio        
            if (realflav(i).eq.-5) realflav(i)=-3 !change b to s quark, only factor, no problem in ratio             
         enddo             
         do i=3,n_p+1
            realflav(i)=momenta(4,i+n_v)  
            if (realflav(i).eq.5) realflav(i)=3 !change b to s quark, only factor, no problem in ratio         
            if (realflav(i).eq.-5) realflav(i)=-3 !change b to s quark, only factor, no problem in ratio                  
         enddo      
      endif      
c  make it all initial
!       if((.not.bornlike).and.(.not.initial)) then
!           if(upline) then
!              call switch_momenta(momenta(0,1),momenta(0,n_p+n_v+1)) !allways change the momentum and flavour of the gloun
!              call switch_flavour(realflav(1),realflav(n_p+1))
!           elseif(lowline) then
!              call switch_momenta(momenta(0,2),momenta(0,n_p+n_v+1))
!              call switch_flavour(realflav(2),realflav(n_p+1))          
!           else
!              write(*,*) "Not bornlike, not initial and no up- or lowline!! STOP"
!              stop
!           endif
!       endif     
c write all momenta into vbfnlo format      
      do mu=0,3
         do i=1,2
            p(mu,i)=momenta(mu,i) 
         enddo   
         do i=1,n_v
            v(mu,i)=momenta(mu,i+2) 
         enddo            
         do i=3,n_p+1
            p(mu,i)=momenta(mu,i+n_v) 
         enddo             
      enddo      
      end select

      text=' '

      read(333,'(a)') text 
                
      if(text(1:7).eq.'</event') then
               return
      elseif(text.eq.'# Start extra-info-previous-event') then
         read(333,'(a)') text
         do while(text(1:7).ne.'</event')
         read(333,'(a)') text         
         enddo
         return
      else
         write(*,*) "Error, no </event>"      
      endif


      
999   continue
      write(*,*) 'Error while reading file pwgevents2.lhe. STOP!'
      write(*,*) j
      stop
      
      end

c! ! !       subroutine switch_momenta(p1,p2)
c! ! !       
c! ! !       implicit none
c! ! !       
c! ! !       real*8 p1(0:3), p2(0:3), temp(0:3)
c! ! !       integer mu
c! ! ! 
c! ! ! 
c! ! !          temp(0)=p1(0)
c! ! !          p1(0)=p2(0)
c! ! !          p2(0)=temp(0)
c! ! !       do mu=1,3
c! ! !          temp(mu)=-p1(mu)
c! ! !          p1(mu)=-p2(mu)
c! ! !          p2(mu)=temp(mu)
c! ! !       enddo
c! ! !          
c! ! !       
c! ! !       end
c! ! ! 
c! ! !       subroutine switch_flavour(flav1,flav2)
c! ! !       
c! ! !       implicit none
c! ! !       
c! ! !       real*8 flav1,flav2,temp
c! ! ! 
c! ! !       temp=flav1
c! ! !       flav1=-flav2
c! ! !       flav2=-temp
c! ! !       if(abs(flav1).eq.21) then
c! ! !          flav1=0!21
c! ! !       elseif(abs(flav2).eq.21) then
c! ! !          flav2=0!21
c! ! !       else
c! ! !          write(*,*) "No gloun found in switch_flavour, STOP!"
c! ! !          write(*,*) flav1,flav2
c! ! !          stop
c! ! !       endif
c! ! !       
c! ! !       end
