c     leptonic test tensors for WWZ, W+ > had

      subroutine ATOWWZ_mg_had(P,N,h,wwztens,NW)

      IMPLICIT NONE

      DOUBLE PRECISION P(0:3,2:7)
      complex*16 wwztens(0:5)
      integer lsign(2:7,2),ll,mu,nu,h,N
      integer NW ! = 0: all diagrams, = 1: no non resonant diagrams

      ! possible lepton helicities:
      data (lsign(ll,1),ll=2,7) / -1, -1, -1, -1, -1, -1/  !h=1
      data (lsign(ll,2),ll=2,7) / -1, -1, -1, -1, +1, +1/  !h=2

      call ATOWWZ1_mg_had(P,N,lsign(2,h),wwztens(0),NW)

      ! helicity combi nr.h is selected

      end

c ------------------------------------------------------------

      SUBROUTINE ATOWWZ1_mg_had(P,N,lsign,wwztens,NW)
C
C Generated by MadGraph II Version 3.0. Updated 02/19/04
C RETURNS AMPLITUDE SQUARED SUMMED/AVG OVER COLORS
C FOR THE POINT WITH EXTERNAL LINES W(0:6,NEXTERNAL)
C
C FOR PROCESS : a -> ve e+ mu- vm~ ta- ta+ 
C
      IMPLICIT NONE
C
C CONSTANTS
C
      INTEGER    NGRAPHS
      PARAMETER (NGRAPHS=  78)
      INTEGER    NWAVEFUNCS
      PARAMETER (NWAVEFUNCS= 117)
      DOUBLE PRECISION     ZERO
      PARAMETER (ZERO=0D0)
C
C ARGUMENTS
C
      DOUBLE PRECISION P(0:3,2:7), Q(0:3)
      INTEGER N
      COMPLEX*16 wwztens(0:5)
      INTEGER lsign(2:7)
      integer NW ! = 0: all diagrams, = 1: no non resonant diagrams
C
C LOCAL VARIABLES
C
      INTEGER I,J, mu
      COMPLEX*16 AMP(NGRAPHS)
      COMPLEX*16 W(6,NWAVEFUNCS)

c  lepton spinors and W+-, Z/A polarization vectors
#include "tensor.inc"

      logical lswitch
      parameter (lswitch=.true.)

C
C GLOBAL VARIABLES
C
#include "VBFNLO/utilities/coupl.inc"
#include "VBFNLO/utilities/global.inc"
#include "VBFNLO/utilities/coupl_haddecay.inc"
#include "VBFNLO/utilities/process.inc"
C
C ----------
C BEGIN CODE
C ----------
      if (lswitch) then      ! read in lepton an W states from common block
         do i=1,6
            w(i,2)  = wve(i,N)
            w(i,3)  = wep(i,N)
            w(i,4)  = wmu(i,N)
            w(i,5)  = wvm(i,N)
            w(i,6)  = ztm(i,N)
            w(i,7)  = ztp(i,N)
         enddo
      endif

      do mu = 0,3
         q(mu) = p(mu,2)+p(mu,3)+p(mu,4)+p(mu,5)+p(mu,6)+p(mu,7)
      enddo

      do mu = 0,3
      CALL TRIBOSVCARTX(Q(0),ZERO ,ZERO, MU,-1,W(1,1   )) 

      if (procid.eq.WPhadWMZ) then

      CALL JIOXXX(W(1,3   ),W(1,2   ),GWF ,WMASS   ,WWIDTH  ,W(1,8   ))    
      CALL FVOXXX(W(1,4   ),W(1,8   ),GWF ,ZERO    ,ZERO    ,W(1,9   ))    
      CALL JIOXXX(W(1,5   ),W(1,9   ),GZN ,ZMASS   ,ZWIDTH  ,W(1,10  ))    
      CALL FVOXXX(W(1,6   ),W(1,10  ),GZL ,LMASS   ,ZERO    ,W(1,11  ))    
      CALL IOVXXX(W(1,7   ),W(1,11  ),W(1,1   ),GAL ,AMP(1   ))            
      CALL FVIXXX(W(1,7   ),W(1,10  ),GZL ,LMASS   ,ZERO    ,W(1,12  ))    
      CALL IOVXXX(W(1,12  ),W(1,6   ),W(1,1   ),GAL ,AMP(2   ))            
      CALL JIOXXX(W(1,5   ),W(1,4   ),GWF ,WMASS   ,WWIDTH  ,W(1,13  ))    
      CALL FVIXXX(W(1,7   ),W(1,1   ),GAL ,LMASS   ,ZERO    ,W(1,14  ))    
      CALL JVVXXX(W(1,13  ),W(1,8   ),GWWA ,ZERO    ,AWIDTH  ,W(1,         
     &     15  ))                                                          
      CALL IOVXXX(W(1,14  ),W(1,6   ),W(1,15  ),GAL ,AMP(3   ))            
      CALL JVVXXX(W(1,13  ),W(1,8   ),GWWZ ,ZMASS   ,ZWIDTH  ,W(1,         
     &     16  ))                                                          
      CALL IOVXXX(W(1,14  ),W(1,6   ),W(1,16  ),GZL ,AMP(4   ))            
      CALL HVVXXX(W(1,13  ),W(1,8   ),GWWH ,HMASS   ,HWIDTH  ,W(1,         
     &     17  ))                                                          
      CALL IOSXXX(W(1,14  ),W(1,6   ),W(1,17  ),GHTAU ,AMP(5   ))          
      CALL FVIXXX(W(1,7   ),W(1,13  ),GWF ,ZERO    ,ZERO    ,W(1,18  ))    
      CALL FVIXXX(W(1,18  ),W(1,8   ),GWF ,LMASS   ,ZERO    ,W(1,19  ))    
      CALL IOVXXX(W(1,19  ),W(1,6   ),W(1,1   ),GAL ,AMP(6   ))            
      CALL FVIXXX(W(1,7   ),W(1,15  ),GAL ,LMASS   ,ZERO    ,W(1,20  ))    
      CALL IOVXXX(W(1,20  ),W(1,6   ),W(1,1   ),GAL ,AMP(7   ))            
      CALL FVIXXX(W(1,7   ),W(1,16  ),GZL ,LMASS   ,ZERO    ,W(1,21  ))    
      CALL IOVXXX(W(1,21  ),W(1,6   ),W(1,1   ),GAL ,AMP(8   ))            
      CALL FSIXXX(W(1,7   ),W(1,17  ),GHTAU ,LMASS   ,ZERO    ,W(1,        
     &     22  ))                                                          
      CALL IOVXXX(W(1,22  ),W(1,6   ),W(1,1   ),GAL ,AMP(9   ))            
      CALL JVVXXX(W(1,1   ),W(1,13  ),GWWA ,WMASS   ,WWIDTH  ,W(1,         
     &     23  ))                                                          
      CALL FVIXXX(W(1,3   ),W(1,23  ),GWF ,ZERO    ,ZERO    ,W(1,24  ))    
      CALL JIOXXX(W(1,24  ),W(1,2   ),GAU ,ZERO    ,AWIDTH  ,W(1,25  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,25  ),GAL ,AMP(10  ))            
      CALL JIOXXX(W(1,24  ),W(1,2   ),GZU ,ZMASS   ,ZWIDTH  ,W(1,26  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,26  ),GZL ,AMP(11  ))            
      CALL FVOXXX(W(1,2   ),W(1,23  ),GWF ,ZERO    ,ZERO    ,W(1,27  ))    
      CALL JIOXXX(W(1,3   ),W(1,27  ),GAD ,ZERO    ,AWIDTH  ,W(1,28  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,28  ),GAL ,AMP(12  ))            
      CALL JIOXXX(W(1,3   ),W(1,27  ),GZD ,ZMASS   ,ZWIDTH  ,W(1,29  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,29  ),GZL ,AMP(13  ))            
      CALL JVVXXX(W(1,8   ),W(1,1   ),GWWA ,WMASS   ,WWIDTH  ,W(1,         
     &     30  ))                                                          
      CALL FVIXXX(W(1,5   ),W(1,30  ),GWF ,ZERO    ,ZERO    ,W(1,31  ))    
      CALL JIOXXX(W(1,31  ),W(1,4   ),GAL ,ZERO    ,AWIDTH  ,W(1,32  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,32  ),GAL ,AMP(14  ))            
      CALL JIOXXX(W(1,31  ),W(1,4   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,33  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,33  ),GZL ,AMP(15  ))            
      CALL FVOXXX(W(1,4   ),W(1,30  ),GWF ,ZERO    ,ZERO    ,W(1,34  ))    
      CALL JIOXXX(W(1,5   ),W(1,34  ),GZN ,ZMASS   ,ZWIDTH  ,W(1,35  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,35  ),GZL ,AMP(16  ))            
      CALL FVIXXX(W(1,14  ),W(1,13  ),GWF ,ZERO    ,ZERO    ,W(1,36  ))    
      CALL IOVXXX(W(1,36  ),W(1,6   ),W(1,8   ),GWF ,AMP(17  ))            
      CALL JVVXXX(W(1,23  ),W(1,8   ),GWWA ,ZERO    ,AWIDTH  ,W(1,         
     &     37  ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,37  ),GAL ,AMP(18  ))            
      CALL JVVXXX(W(1,23  ),W(1,8   ),GWWZ ,ZMASS   ,ZWIDTH  ,W(1,         
     &     38  ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,38  ),GZL ,AMP(19  ))            
      CALL HVVXXX(W(1,23  ),W(1,8   ),GWWH ,HMASS   ,HWIDTH  ,W(1,         
     &     39  ))                                                          
      CALL IOSXXX(W(1,7   ),W(1,6   ),W(1,39  ),GHTAU ,AMP(20  ))          
      CALL FVIXXX(W(1,7   ),W(1,23  ),GWF ,ZERO    ,ZERO    ,W(1,40  ))    
      CALL IOVXXX(W(1,40  ),W(1,6   ),W(1,8   ),GWF ,AMP(21  ))            
      CALL JVVXXX(W(1,13  ),W(1,30  ),GWWA ,ZERO    ,AWIDTH  ,W(1,         
     &     41  ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,41  ),GAL ,AMP(22  ))            
      CALL JVVXXX(W(1,13  ),W(1,30  ),GWWZ ,ZMASS   ,ZWIDTH  ,W(1,         
     &     42  ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,42  ),GZL ,AMP(23  ))            
      CALL HVVXXX(W(1,13  ),W(1,30  ),GWWH ,HMASS   ,HWIDTH  ,W(1,         
     &     43  ))                                                          
      CALL IOSXXX(W(1,7   ),W(1,6   ),W(1,43  ),GHTAU ,AMP(24  ))          
      CALL IOVXXX(W(1,18  ),W(1,6   ),W(1,30  ),GWF ,AMP(25  ))            
      CALL JW3WXX(W(1,13  ),W(1,1   ),W(1,8   ),GWWA ,GWWA ,ZERO    ,      
     &     AWIDTH  ,W(1,44  ))                                             
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,44  ),GAL ,AMP(26  ))            
      CALL JW3WXX(W(1,13  ),W(1,1   ),W(1,8   ),GWWA ,GWWZ ,ZMASS   ,      
     &     ZWIDTH  ,W(1,45  ))                                             
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,45  ),GZL ,AMP(27  ))            
      CALL FVIXXX(W(1,5   ),W(1,8   ),GWF ,ZERO    ,ZERO    ,W(1,46  ))    
      CALL JIOXXX(W(1,46  ),W(1,4   ),GAL ,ZERO    ,AWIDTH  ,W(1,47  ))    
      CALL IOVXXX(W(1,14  ),W(1,6   ),W(1,47  ),GAL ,AMP(28  ))            
      CALL JIOXXX(W(1,46  ),W(1,4   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,48  ))    
      CALL IOVXXX(W(1,14  ),W(1,6   ),W(1,48  ),GZL ,AMP(29  ))            
      CALL FVIXXX(W(1,7   ),W(1,47  ),GAL ,LMASS   ,ZERO    ,W(1,49  ))    
      CALL IOVXXX(W(1,49  ),W(1,6   ),W(1,1   ),GAL ,AMP(30  ))            
      CALL FVIXXX(W(1,7   ),W(1,48  ),GZL ,LMASS   ,ZERO    ,W(1,50  ))    
      CALL IOVXXX(W(1,50  ),W(1,6   ),W(1,1   ),GAL ,AMP(31  ))            
      CALL FVOXXX(W(1,4   ),W(1,1   ),GAL ,ZERO    ,ZERO    ,W(1,51  ))    
      CALL JIOXXX(W(1,5   ),W(1,51  ),GWF ,WMASS   ,WWIDTH  ,W(1,52  ))    
      CALL FVIXXX(W(1,3   ),W(1,52  ),GWF ,ZERO    ,ZERO    ,W(1,53  ))    
      CALL JIOXXX(W(1,53  ),W(1,2   ),GAU ,ZERO    ,AWIDTH  ,W(1,54  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,54  ),GAL ,AMP(32  ))            
      CALL JIOXXX(W(1,53  ),W(1,2   ),GZU ,ZMASS   ,ZWIDTH  ,W(1,55  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,55  ),GZL ,AMP(33  ))            
      CALL FVOXXX(W(1,2   ),W(1,52  ),GWF ,ZERO    ,ZERO    ,W(1,56  ))    
      CALL JIOXXX(W(1,3   ),W(1,56  ),GAD ,ZERO    ,AWIDTH  ,W(1,57  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,57  ),GAL ,AMP(34  ))            
      CALL JIOXXX(W(1,3   ),W(1,56  ),GZD ,ZMASS   ,ZWIDTH  ,W(1,58  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,58  ),GZL ,AMP(35  ))            
      CALL FVIXXX(W(1,46  ),W(1,1   ),GAL ,ZERO    ,ZERO    ,W(1,59  ))    
      CALL JIOXXX(W(1,59  ),W(1,4   ),GAL ,ZERO    ,AWIDTH  ,W(1,60  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,60  ),GAL ,AMP(36  ))            
      CALL JIOXXX(W(1,59  ),W(1,4   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,61  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,61  ),GZL ,AMP(37  ))            
      CALL FVOXXX(W(1,51  ),W(1,8   ),GWF ,ZERO    ,ZERO    ,W(1,62  ))    
      CALL JIOXXX(W(1,5   ),W(1,62  ),GZN ,ZMASS   ,ZWIDTH  ,W(1,63  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,63  ),GZL ,AMP(38  ))            
      CALL JIOXXX(W(1,46  ),W(1,51  ),GAL ,ZERO    ,AWIDTH  ,W(1,64  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,64  ),GAL ,AMP(39  ))            
      CALL JIOXXX(W(1,46  ),W(1,51  ),GZL ,ZMASS   ,ZWIDTH  ,W(1,65  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,65  ),GZL ,AMP(40  ))            
      CALL JVVXXX(W(1,52  ),W(1,8   ),GWWA ,ZERO    ,AWIDTH  ,W(1,         
     &     66  ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,66  ),GAL ,AMP(41  ))            
      CALL JVVXXX(W(1,52  ),W(1,8   ),GWWZ ,ZMASS   ,ZWIDTH  ,W(1,         
     &     67  ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,67  ),GZL ,AMP(42  ))            
      CALL HVVXXX(W(1,52  ),W(1,8   ),GWWH ,HMASS   ,HWIDTH  ,W(1,         
     &     68  ))                                                          
      CALL IOSXXX(W(1,7   ),W(1,6   ),W(1,68  ),GHTAU ,AMP(43  ))          
      CALL FVIXXX(W(1,7   ),W(1,52  ),GWF ,ZERO    ,ZERO    ,W(1,69  ))    
      CALL IOVXXX(W(1,69  ),W(1,6   ),W(1,8   ),GWF ,AMP(44  ))            
      CALL FVOXXX(W(1,2   ),W(1,13  ),GWF ,ZERO    ,ZERO    ,W(1,70  ))    
      CALL JIOXXX(W(1,3   ),W(1,70  ),GAD ,ZERO    ,AWIDTH  ,W(1,71  ))    
      CALL IOVXXX(W(1,14  ),W(1,6   ),W(1,71  ),GAL ,AMP(45  ))            
      CALL JIOXXX(W(1,3   ),W(1,70  ),GZD ,ZMASS   ,ZWIDTH  ,W(1,72  ))    
      CALL IOVXXX(W(1,14  ),W(1,6   ),W(1,72  ),GZL ,AMP(46  ))            
      CALL FVIXXX(W(1,7   ),W(1,71  ),GAL ,LMASS   ,ZERO    ,W(1,73  ))    
      CALL IOVXXX(W(1,73  ),W(1,6   ),W(1,1   ),GAL ,AMP(47  ))            
      CALL FVIXXX(W(1,7   ),W(1,72  ),GZL ,LMASS   ,ZERO    ,W(1,74  ))    
      CALL IOVXXX(W(1,74  ),W(1,6   ),W(1,1   ),GAL ,AMP(48  ))            
      CALL FVIXXX(W(1,3   ),W(1,1   ),GAD ,ZERO    ,ZERO    ,W(1,75  ))    
      CALL FVIXXX(W(1,75  ),W(1,13  ),GWF ,ZERO    ,ZERO    ,W(1,76  ))    
      CALL JIOXXX(W(1,76  ),W(1,2   ),GAU ,ZERO    ,AWIDTH  ,W(1,77  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,77  ),GAL ,AMP(49  ))            
      CALL JIOXXX(W(1,76  ),W(1,2   ),GZU ,ZMASS   ,ZWIDTH  ,W(1,78  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,78  ),GZL ,AMP(50  ))            
      CALL FVOXXX(W(1,70  ),W(1,1   ),GAD ,ZERO    ,ZERO    ,W(1,79  ))    
      CALL JIOXXX(W(1,3   ),W(1,79  ),GAD ,ZERO    ,AWIDTH  ,W(1,80  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,80  ),GAL ,AMP(51  ))            
      CALL JIOXXX(W(1,3   ),W(1,79  ),GZD ,ZMASS   ,ZWIDTH  ,W(1,81  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,81  ),GZL ,AMP(52  ))            
      CALL JIOXXX(W(1,75  ),W(1,2   ),GWF ,WMASS   ,WWIDTH  ,W(1,82  ))    
      CALL FVIXXX(W(1,5   ),W(1,82  ),GWF ,ZERO    ,ZERO    ,W(1,83  ))    
      CALL JIOXXX(W(1,83  ),W(1,4   ),GAL ,ZERO    ,AWIDTH  ,W(1,84  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,84  ),GAL ,AMP(53  ))            
      CALL JIOXXX(W(1,83  ),W(1,4   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,85  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,85  ),GZL ,AMP(54  ))            
      CALL FVOXXX(W(1,4   ),W(1,82  ),GWF ,ZERO    ,ZERO    ,W(1,86  ))    
      CALL JIOXXX(W(1,5   ),W(1,86  ),GZN ,ZMASS   ,ZWIDTH  ,W(1,87  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,87  ),GZL ,AMP(55  ))            
      CALL JIOXXX(W(1,75  ),W(1,70  ),GAD ,ZERO    ,AWIDTH  ,W(1,88  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,88  ),GAL ,AMP(56  ))            
      CALL JIOXXX(W(1,75  ),W(1,70  ),GZD ,ZMASS   ,ZWIDTH  ,W(1,89  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,89  ),GZL ,AMP(57  ))            
      CALL JVVXXX(W(1,13  ),W(1,82  ),GWWA ,ZERO    ,AWIDTH  ,W(1,         
     &     90  ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,90  ),GAL ,AMP(58  ))            
      CALL JVVXXX(W(1,13  ),W(1,82  ),GWWZ ,ZMASS   ,ZWIDTH  ,W(1,         
     &     91  ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,91  ),GZL ,AMP(59  ))            
      CALL HVVXXX(W(1,13  ),W(1,82  ),GWWH ,HMASS   ,HWIDTH  ,W(1,         
     &     92  ))                                                          
      CALL IOSXXX(W(1,7   ),W(1,6   ),W(1,92  ),GHTAU ,AMP(60  ))          
      CALL IOVXXX(W(1,18  ),W(1,6   ),W(1,82  ),GWF ,AMP(61  ))            
      CALL FVIXXX(W(1,3   ),W(1,13  ),GWF ,ZERO    ,ZERO    ,W(1,93  ))    
      CALL JIOXXX(W(1,93  ),W(1,2   ),GAU ,ZERO    ,AWIDTH  ,W(1,94  ))    
      CALL IOVXXX(W(1,14  ),W(1,6   ),W(1,94  ),GAL ,AMP(62  ))            
      CALL JIOXXX(W(1,93  ),W(1,2   ),GZU ,ZMASS   ,ZWIDTH  ,W(1,95  ))    
      CALL IOVXXX(W(1,14  ),W(1,6   ),W(1,95  ),GZL ,AMP(63  ))            
      CALL FVIXXX(W(1,7   ),W(1,94  ),GAL ,LMASS   ,ZERO    ,W(1,96  ))    
      CALL IOVXXX(W(1,96  ),W(1,6   ),W(1,1   ),GAL ,AMP(64  ))            
      CALL FVIXXX(W(1,7   ),W(1,95  ),GZL ,LMASS   ,ZERO    ,W(1,97  ))    
      CALL IOVXXX(W(1,97  ),W(1,6   ),W(1,1   ),GAL ,AMP(65  ))            
      CALL FVIXXX(W(1,93  ),W(1,1   ),GAU ,ZERO    ,ZERO    ,W(1,98  ))    
      CALL JIOXXX(W(1,98  ),W(1,2   ),GAU ,ZERO    ,AWIDTH  ,W(1,99  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,99  ),GAL ,AMP(66  ))            
      CALL JIOXXX(W(1,98  ),W(1,2   ),GZU ,ZMASS   ,ZWIDTH  ,W(1,100 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,100 ),GZL ,AMP(67  ))            
      CALL FVOXXX(W(1,2   ),W(1,1   ),GAU ,ZERO    ,ZERO    ,W(1,101 ))    
      CALL FVOXXX(W(1,101 ),W(1,13  ),GWF ,ZERO    ,ZERO    ,W(1,102 ))    
      CALL JIOXXX(W(1,3   ),W(1,102 ),GAD ,ZERO    ,AWIDTH  ,W(1,103 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,103 ),GAL ,AMP(68  ))            
      CALL JIOXXX(W(1,3   ),W(1,102 ),GZD ,ZMASS   ,ZWIDTH  ,W(1,104 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,104 ),GZL ,AMP(69  ))            
      CALL JIOXXX(W(1,3   ),W(1,101 ),GWF ,WMASS   ,WWIDTH  ,W(1,105 ))    
      CALL FVIXXX(W(1,5   ),W(1,105 ),GWF ,ZERO    ,ZERO    ,W(1,106 ))    
      CALL JIOXXX(W(1,106 ),W(1,4   ),GAL ,ZERO    ,AWIDTH  ,W(1,107 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,107 ),GAL ,AMP(70  ))            
      CALL JIOXXX(W(1,106 ),W(1,4   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,108 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,108 ),GZL ,AMP(71  ))            
      CALL FVOXXX(W(1,4   ),W(1,105 ),GWF ,ZERO    ,ZERO    ,W(1,109 ))    
      CALL JIOXXX(W(1,5   ),W(1,109 ),GZN ,ZMASS   ,ZWIDTH  ,W(1,110 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,110 ),GZL ,AMP(72  ))            
      CALL JIOXXX(W(1,93  ),W(1,101 ),GAU ,ZERO    ,AWIDTH  ,W(1,111 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,111 ),GAL ,AMP(73  ))            
      CALL JIOXXX(W(1,93  ),W(1,101 ),GZU ,ZMASS   ,ZWIDTH  ,W(1,112 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,112 ),GZL ,AMP(74  ))            
      CALL JVVXXX(W(1,13  ),W(1,105 ),GWWA ,ZERO    ,AWIDTH  ,W(1,         
     &     113 ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,113 ),GAL ,AMP(75  ))            
      CALL JVVXXX(W(1,13  ),W(1,105 ),GWWZ ,ZMASS   ,ZWIDTH  ,W(1,         
     &     114 ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,114 ),GZL ,AMP(76  ))            
      CALL HVVXXX(W(1,13  ),W(1,105 ),GWWH ,HMASS   ,HWIDTH  ,W(1,         
     &     115 ))                                                          
      CALL IOSXXX(W(1,7   ),W(1,6   ),W(1,115 ),GHTAU ,AMP(77  ))          
      CALL IOVXXX(W(1,18  ),W(1,6   ),W(1,105 ),GWF ,AMP(78  ))            

      wwztens(mu) = -AMP(   1)-AMP(   2)-AMP(   3)-AMP(   4)-AMP(   5)
     &             -AMP(   6)-AMP(   7)-AMP(   8)-AMP(   9)-AMP(  10)
     &             -AMP(  11)-AMP(  12)-AMP(  13)-AMP(  14)-AMP(  15)
     &             -AMP(  16)-AMP(  17)-AMP(  18)-AMP(  19)-AMP(  20)
     &             -AMP(  21)-AMP(  22)-AMP(  23)-AMP(  24)-AMP(  25)
     &             -AMP(  26)-AMP(  27)-AMP(  28)-AMP(  29)-AMP(  30)
     &             -AMP(  31)-AMP(  32)-AMP(  33)-AMP(  34)-AMP(  35)
     &             -AMP(  36)-AMP(  37)-AMP(  38)-AMP(  39)-AMP(  40)
     &             -AMP(  41)-AMP(  42)-AMP(  43)-AMP(  44)-AMP(  45)
     &             -AMP(  46)-AMP(  47)-AMP(  48)-AMP(  49)-AMP(  50)
     &             -AMP(  51)-AMP(  52)-AMP(  53)-AMP(  54)-AMP(  55)
     &             -AMP(  56)-AMP(  57)-AMP(  58)-AMP(  59)-AMP(  60)
     &             -AMP(  61)-AMP(  62)-AMP(  63)-AMP(  64)-AMP(  65)
     &             -AMP(  66)-AMP(  67)-AMP(  68)-AMP(  69)-AMP(  70)
     &             -AMP(  71)-AMP(  72)-AMP(  73)-AMP(  74)-AMP(  75)
     &             -AMP(  76)-AMP(  77)-AMP(  78)

      elseif (procid.eq.WPWMhadZ) then

      CALL JIOXXX(W(1,3   ),W(1,2   ),GWF ,WMASS   ,WWIDTH  ,W(1,8   ))    
      CALL FVOXXX(W(1,4   ),W(1,8   ),GWF ,ZERO    ,ZERO    ,W(1,9   ))    
      CALL JIOXXX(W(1,5   ),W(1,9   ),GAU ,ZERO    ,AWIDTH  ,W(1,10  ))    
      CALL FVOXXX(W(1,6   ),W(1,10  ),GAL ,LMASS   ,ZERO    ,W(1,11  ))    
      CALL IOVXXX(W(1,7   ),W(1,11  ),W(1,1   ),GAL ,AMP(1   ))            
      CALL JIOXXX(W(1,5   ),W(1,9   ),GZU ,ZMASS   ,ZWIDTH  ,W(1,12  ))    
      CALL FVOXXX(W(1,6   ),W(1,12  ),GZL ,LMASS   ,ZERO    ,W(1,13  ))    
      CALL IOVXXX(W(1,7   ),W(1,13  ),W(1,1   ),GAL ,AMP(2   ))            
      CALL FVIXXX(W(1,7   ),W(1,10  ),GAL ,LMASS   ,ZERO    ,W(1,14  ))    
      CALL IOVXXX(W(1,14  ),W(1,6   ),W(1,1   ),GAL ,AMP(3   ))            
      CALL FVIXXX(W(1,7   ),W(1,12  ),GZL ,LMASS   ,ZERO    ,W(1,15  ))    
      CALL IOVXXX(W(1,15  ),W(1,6   ),W(1,1   ),GAL ,AMP(4   ))            
      CALL FVIXXX(W(1,5   ),W(1,1   ),GAU ,ZERO    ,ZERO    ,W(1,16  ))    
      CALL JIOXXX(W(1,16  ),W(1,4   ),GWF ,WMASS   ,WWIDTH  ,W(1,17  ))    
      CALL FVIXXX(W(1,3   ),W(1,17  ),GWF ,ZERO    ,ZERO    ,W(1,18  ))    
      CALL JIOXXX(W(1,18  ),W(1,2   ),GZN ,ZMASS   ,ZWIDTH  ,W(1,19  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,19  ),GZL ,AMP(5   ))            
      CALL FVOXXX(W(1,2   ),W(1,17  ),GWF ,ZERO    ,ZERO    ,W(1,20  ))    
      CALL JIOXXX(W(1,3   ),W(1,20  ),GAL ,ZERO    ,AWIDTH  ,W(1,21  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,21  ),GAL ,AMP(6   ))            
      CALL JIOXXX(W(1,3   ),W(1,20  ),GZL ,ZMASS   ,ZWIDTH  ,W(1,22  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,22  ),GZL ,AMP(7   ))            
      CALL FVIXXX(W(1,16  ),W(1,8   ),GWF ,ZERO    ,ZERO    ,W(1,23  ))    
      CALL JIOXXX(W(1,23  ),W(1,4   ),GAD ,ZERO    ,AWIDTH  ,W(1,24  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,24  ),GAL ,AMP(8   ))            
      CALL JIOXXX(W(1,23  ),W(1,4   ),GZD ,ZMASS   ,ZWIDTH  ,W(1,25  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,25  ),GZL ,AMP(9   ))            
      CALL FVOXXX(W(1,9   ),W(1,1   ),GAU ,ZERO    ,ZERO    ,W(1,26  ))    
      CALL JIOXXX(W(1,5   ),W(1,26  ),GAU ,ZERO    ,AWIDTH  ,W(1,27  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,27  ),GAL ,AMP(10  ))            
      CALL JIOXXX(W(1,5   ),W(1,26  ),GZU ,ZMASS   ,ZWIDTH  ,W(1,28  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,28  ),GZL ,AMP(11  ))            
      CALL JVVXXX(W(1,17  ),W(1,8   ),GWWA ,ZERO    ,AWIDTH  ,W(1,         
     &     29  ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,29  ),GAL ,AMP(12  ))            
      CALL JVVXXX(W(1,17  ),W(1,8   ),GWWZ ,ZMASS   ,ZWIDTH  ,W(1,         
     &     30  ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,30  ),GZL ,AMP(13  ))            
      CALL HVVXXX(W(1,17  ),W(1,8   ),GWWH ,HMASS   ,HWIDTH  ,W(1,         
     &     31  ))                                                          
      CALL IOSXXX(W(1,7   ),W(1,6   ),W(1,31  ),GHTAU ,AMP(14  ))          
      CALL FVIXXX(W(1,7   ),W(1,17  ),GWF ,ZERO    ,ZERO    ,W(1,32  ))    
      CALL IOVXXX(W(1,32  ),W(1,6   ),W(1,8   ),GWF ,AMP(15  ))            
      CALL JIOXXX(W(1,16  ),W(1,9   ),GAU ,ZERO    ,AWIDTH  ,W(1,33  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,33  ),GAL ,AMP(16  ))            
      CALL JIOXXX(W(1,16  ),W(1,9   ),GZU ,ZMASS   ,ZWIDTH  ,W(1,34  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,34  ),GZL ,AMP(17  ))            
      CALL JIOXXX(W(1,5   ),W(1,4   ),GWF ,WMASS   ,WWIDTH  ,W(1,35  ))    
      CALL FVIXXX(W(1,7   ),W(1,1   ),GAL ,LMASS   ,ZERO    ,W(1,36  ))    
      CALL JVVXXX(W(1,35  ),W(1,8   ),GWWA ,ZERO    ,AWIDTH  ,W(1,         
     &     37  ))                                                          
      CALL IOVXXX(W(1,36  ),W(1,6   ),W(1,37  ),GAL ,AMP(18  ))            
      CALL JVVXXX(W(1,35  ),W(1,8   ),GWWZ ,ZMASS   ,ZWIDTH  ,W(1,         
     &     38  ))                                                          
      CALL IOVXXX(W(1,36  ),W(1,6   ),W(1,38  ),GZL ,AMP(19  ))            
      CALL HVVXXX(W(1,35  ),W(1,8   ),GWWH ,HMASS   ,HWIDTH  ,W(1,         
     &     39  ))                                                          
      CALL IOSXXX(W(1,36  ),W(1,6   ),W(1,39  ),GHTAU ,AMP(20  ))          
      CALL FVIXXX(W(1,7   ),W(1,35  ),GWF ,ZERO    ,ZERO    ,W(1,40  ))    
      CALL FVIXXX(W(1,40  ),W(1,8   ),GWF ,LMASS   ,ZERO    ,W(1,41  ))    
      CALL IOVXXX(W(1,41  ),W(1,6   ),W(1,1   ),GAL ,AMP(21  ))            
      CALL FVIXXX(W(1,7   ),W(1,37  ),GAL ,LMASS   ,ZERO    ,W(1,42  ))    
      CALL IOVXXX(W(1,42  ),W(1,6   ),W(1,1   ),GAL ,AMP(22  ))            
      CALL FVIXXX(W(1,7   ),W(1,38  ),GZL ,LMASS   ,ZERO    ,W(1,43  ))    
      CALL IOVXXX(W(1,43  ),W(1,6   ),W(1,1   ),GAL ,AMP(23  ))            
      CALL FSIXXX(W(1,7   ),W(1,39  ),GHTAU ,LMASS   ,ZERO    ,W(1,        
     &     44  ))                                                          
      CALL IOVXXX(W(1,44  ),W(1,6   ),W(1,1   ),GAL ,AMP(24  ))            
      CALL JVVXXX(W(1,1   ),W(1,35  ),GWWA ,WMASS   ,WWIDTH  ,W(1,         
     &     45  ))                                                          
      CALL FVIXXX(W(1,3   ),W(1,45  ),GWF ,ZERO    ,ZERO    ,W(1,46  ))    
      CALL JIOXXX(W(1,46  ),W(1,2   ),GZN ,ZMASS   ,ZWIDTH  ,W(1,47  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,47  ),GZL ,AMP(25  ))            
      CALL FVOXXX(W(1,2   ),W(1,45  ),GWF ,ZERO    ,ZERO    ,W(1,48  ))    
      CALL JIOXXX(W(1,3   ),W(1,48  ),GAL ,ZERO    ,AWIDTH  ,W(1,49  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,49  ),GAL ,AMP(26  ))            
      CALL JIOXXX(W(1,3   ),W(1,48  ),GZL ,ZMASS   ,ZWIDTH  ,W(1,50  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,50  ),GZL ,AMP(27  ))            
      CALL JVVXXX(W(1,8   ),W(1,1   ),GWWA ,WMASS   ,WWIDTH  ,W(1,         
     &     51  ))                                                          
      CALL FVIXXX(W(1,5   ),W(1,51  ),GWF ,ZERO    ,ZERO    ,W(1,52  ))    
      CALL JIOXXX(W(1,52  ),W(1,4   ),GAD ,ZERO    ,AWIDTH  ,W(1,53  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,53  ),GAL ,AMP(28  ))            
      CALL JIOXXX(W(1,52  ),W(1,4   ),GZD ,ZMASS   ,ZWIDTH  ,W(1,54  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,54  ),GZL ,AMP(29  ))            
      CALL FVOXXX(W(1,4   ),W(1,51  ),GWF ,ZERO    ,ZERO    ,W(1,55  ))    
      CALL JIOXXX(W(1,5   ),W(1,55  ),GAU ,ZERO    ,AWIDTH  ,W(1,56  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,56  ),GAL ,AMP(30  ))            
      CALL JIOXXX(W(1,5   ),W(1,55  ),GZU ,ZMASS   ,ZWIDTH  ,W(1,57  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,57  ),GZL ,AMP(31  ))            
      CALL FVIXXX(W(1,36  ),W(1,35  ),GWF ,ZERO    ,ZERO    ,W(1,58  ))    
      CALL IOVXXX(W(1,58  ),W(1,6   ),W(1,8   ),GWF ,AMP(32  ))            
      CALL JVVXXX(W(1,45  ),W(1,8   ),GWWA ,ZERO    ,AWIDTH  ,W(1,         
     &     59  ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,59  ),GAL ,AMP(33  ))            
      CALL JVVXXX(W(1,45  ),W(1,8   ),GWWZ ,ZMASS   ,ZWIDTH  ,W(1,         
     &     60  ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,60  ),GZL ,AMP(34  ))            
      CALL HVVXXX(W(1,45  ),W(1,8   ),GWWH ,HMASS   ,HWIDTH  ,W(1,         
     &     61  ))                                                          
      CALL IOSXXX(W(1,7   ),W(1,6   ),W(1,61  ),GHTAU ,AMP(35  ))          
      CALL FVIXXX(W(1,7   ),W(1,45  ),GWF ,ZERO    ,ZERO    ,W(1,62  ))    
      CALL IOVXXX(W(1,62  ),W(1,6   ),W(1,8   ),GWF ,AMP(36  ))            
      CALL JVVXXX(W(1,35  ),W(1,51  ),GWWA ,ZERO    ,AWIDTH  ,W(1,         
     &     63  ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,63  ),GAL ,AMP(37  ))            
      CALL JVVXXX(W(1,35  ),W(1,51  ),GWWZ ,ZMASS   ,ZWIDTH  ,W(1,         
     &     64  ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,64  ),GZL ,AMP(38  ))            
      CALL HVVXXX(W(1,35  ),W(1,51  ),GWWH ,HMASS   ,HWIDTH  ,W(1,         
     &     65  ))                                                          
      CALL IOSXXX(W(1,7   ),W(1,6   ),W(1,65  ),GHTAU ,AMP(39  ))          
      CALL IOVXXX(W(1,40  ),W(1,6   ),W(1,51  ),GWF ,AMP(40  ))            
      CALL JW3WXX(W(1,35  ),W(1,1   ),W(1,8   ),GWWA ,GWWA ,ZERO    ,      
     &     AWIDTH  ,W(1,66  ))                                             
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,66  ),GAL ,AMP(41  ))            
      CALL JW3WXX(W(1,35  ),W(1,1   ),W(1,8   ),GWWA ,GWWZ ,ZMASS   ,      
     &     ZWIDTH  ,W(1,67  ))                                             
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,67  ),GZL ,AMP(42  ))            
      CALL FVIXXX(W(1,5   ),W(1,8   ),GWF ,ZERO    ,ZERO    ,W(1,68  ))    
      CALL JIOXXX(W(1,68  ),W(1,4   ),GAD ,ZERO    ,AWIDTH  ,W(1,69  ))    
      CALL IOVXXX(W(1,36  ),W(1,6   ),W(1,69  ),GAL ,AMP(43  ))            
      CALL JIOXXX(W(1,68  ),W(1,4   ),GZD ,ZMASS   ,ZWIDTH  ,W(1,70  ))    
      CALL IOVXXX(W(1,36  ),W(1,6   ),W(1,70  ),GZL ,AMP(44  ))            
      CALL FVIXXX(W(1,7   ),W(1,69  ),GAL ,LMASS   ,ZERO    ,W(1,71  ))    
      CALL IOVXXX(W(1,71  ),W(1,6   ),W(1,1   ),GAL ,AMP(45  ))            
      CALL FVIXXX(W(1,7   ),W(1,70  ),GZL ,LMASS   ,ZERO    ,W(1,72  ))    
      CALL IOVXXX(W(1,72  ),W(1,6   ),W(1,1   ),GAL ,AMP(46  ))            
      CALL FVOXXX(W(1,4   ),W(1,1   ),GAD ,ZERO    ,ZERO    ,W(1,73  ))    
      CALL JIOXXX(W(1,5   ),W(1,73  ),GWF ,WMASS   ,WWIDTH  ,W(1,74  ))    
      CALL FVIXXX(W(1,3   ),W(1,74  ),GWF ,ZERO    ,ZERO    ,W(1,75  ))    
      CALL JIOXXX(W(1,75  ),W(1,2   ),GZN ,ZMASS   ,ZWIDTH  ,W(1,76  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,76  ),GZL ,AMP(47  ))            
      CALL FVOXXX(W(1,2   ),W(1,74  ),GWF ,ZERO    ,ZERO    ,W(1,77  ))    
      CALL JIOXXX(W(1,3   ),W(1,77  ),GAL ,ZERO    ,AWIDTH  ,W(1,78  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,78  ),GAL ,AMP(48  ))            
      CALL JIOXXX(W(1,3   ),W(1,77  ),GZL ,ZMASS   ,ZWIDTH  ,W(1,79  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,79  ),GZL ,AMP(49  ))            
      CALL FVIXXX(W(1,68  ),W(1,1   ),GAD ,ZERO    ,ZERO    ,W(1,80  ))    
      CALL JIOXXX(W(1,80  ),W(1,4   ),GAD ,ZERO    ,AWIDTH  ,W(1,81  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,81  ),GAL ,AMP(50  ))            
      CALL JIOXXX(W(1,80  ),W(1,4   ),GZD ,ZMASS   ,ZWIDTH  ,W(1,82  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,82  ),GZL ,AMP(51  ))            
      CALL FVOXXX(W(1,73  ),W(1,8   ),GWF ,ZERO    ,ZERO    ,W(1,83  ))    
      CALL JIOXXX(W(1,5   ),W(1,83  ),GAU ,ZERO    ,AWIDTH  ,W(1,84  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,84  ),GAL ,AMP(52  ))            
      CALL JIOXXX(W(1,5   ),W(1,83  ),GZU ,ZMASS   ,ZWIDTH  ,W(1,85  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,85  ),GZL ,AMP(53  ))            
      CALL JIOXXX(W(1,68  ),W(1,73  ),GAD ,ZERO    ,AWIDTH  ,W(1,86  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,86  ),GAL ,AMP(54  ))            
      CALL JIOXXX(W(1,68  ),W(1,73  ),GZD ,ZMASS   ,ZWIDTH  ,W(1,87  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,87  ),GZL ,AMP(55  ))            
      CALL JVVXXX(W(1,74  ),W(1,8   ),GWWA ,ZERO    ,AWIDTH  ,W(1,         
     &     88  ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,88  ),GAL ,AMP(56  ))            
      CALL JVVXXX(W(1,74  ),W(1,8   ),GWWZ ,ZMASS   ,ZWIDTH  ,W(1,         
     &     89  ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,89  ),GZL ,AMP(57  ))            
      CALL HVVXXX(W(1,74  ),W(1,8   ),GWWH ,HMASS   ,HWIDTH  ,W(1,         
     &     90  ))                                                          
      CALL IOSXXX(W(1,7   ),W(1,6   ),W(1,90  ),GHTAU ,AMP(58  ))          
      CALL FVIXXX(W(1,7   ),W(1,74  ),GWF ,ZERO    ,ZERO    ,W(1,91  ))    
      CALL IOVXXX(W(1,91  ),W(1,6   ),W(1,8   ),GWF ,AMP(59  ))            
      CALL FVOXXX(W(1,2   ),W(1,35  ),GWF ,ZERO    ,ZERO    ,W(1,92  ))    
      CALL JIOXXX(W(1,3   ),W(1,92  ),GAL ,ZERO    ,AWIDTH  ,W(1,93  ))    
      CALL IOVXXX(W(1,36  ),W(1,6   ),W(1,93  ),GAL ,AMP(60  ))            
      CALL JIOXXX(W(1,3   ),W(1,92  ),GZL ,ZMASS   ,ZWIDTH  ,W(1,94  ))    
      CALL IOVXXX(W(1,36  ),W(1,6   ),W(1,94  ),GZL ,AMP(61  ))            
      CALL FVIXXX(W(1,7   ),W(1,93  ),GAL ,LMASS   ,ZERO    ,W(1,95  ))    
      CALL IOVXXX(W(1,95  ),W(1,6   ),W(1,1   ),GAL ,AMP(62  ))            
      CALL FVIXXX(W(1,7   ),W(1,94  ),GZL ,LMASS   ,ZERO    ,W(1,96  ))    
      CALL IOVXXX(W(1,96  ),W(1,6   ),W(1,1   ),GAL ,AMP(63  ))            
      CALL FVIXXX(W(1,3   ),W(1,1   ),GAL ,ZERO    ,ZERO    ,W(1,97  ))    
      CALL FVIXXX(W(1,97  ),W(1,35  ),GWF ,ZERO    ,ZERO    ,W(1,98  ))    
      CALL JIOXXX(W(1,98  ),W(1,2   ),GZN ,ZMASS   ,ZWIDTH  ,W(1,99  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,99  ),GZL ,AMP(64  ))            
      CALL FVOXXX(W(1,92  ),W(1,1   ),GAL ,ZERO    ,ZERO    ,W(1,100 ))    
      CALL JIOXXX(W(1,3   ),W(1,100 ),GAL ,ZERO    ,AWIDTH  ,W(1,101 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,101 ),GAL ,AMP(65  ))            
      CALL JIOXXX(W(1,3   ),W(1,100 ),GZL ,ZMASS   ,ZWIDTH  ,W(1,102 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,102 ),GZL ,AMP(66  ))            
      CALL JIOXXX(W(1,97  ),W(1,2   ),GWF ,WMASS   ,WWIDTH  ,W(1,103 ))    
      CALL FVIXXX(W(1,5   ),W(1,103 ),GWF ,ZERO    ,ZERO    ,W(1,104 ))    
      CALL JIOXXX(W(1,104 ),W(1,4   ),GAD ,ZERO    ,AWIDTH  ,W(1,105 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,105 ),GAL ,AMP(67  ))            
      CALL JIOXXX(W(1,104 ),W(1,4   ),GZD ,ZMASS   ,ZWIDTH  ,W(1,106 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,106 ),GZL ,AMP(68  ))            
      CALL FVOXXX(W(1,4   ),W(1,103 ),GWF ,ZERO    ,ZERO    ,W(1,107 ))    
      CALL JIOXXX(W(1,5   ),W(1,107 ),GAU ,ZERO    ,AWIDTH  ,W(1,108 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,108 ),GAL ,AMP(69  ))            
      CALL JIOXXX(W(1,5   ),W(1,107 ),GZU ,ZMASS   ,ZWIDTH  ,W(1,109 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,109 ),GZL ,AMP(70  ))            
      CALL JIOXXX(W(1,97  ),W(1,92  ),GAL ,ZERO    ,AWIDTH  ,W(1,110 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,110 ),GAL ,AMP(71  ))            
      CALL JIOXXX(W(1,97  ),W(1,92  ),GZL ,ZMASS   ,ZWIDTH  ,W(1,111 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,111 ),GZL ,AMP(72  ))            
      CALL JVVXXX(W(1,35  ),W(1,103 ),GWWA ,ZERO    ,AWIDTH  ,W(1,         
     &     112 ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,112 ),GAL ,AMP(73  ))            
      CALL JVVXXX(W(1,35  ),W(1,103 ),GWWZ ,ZMASS   ,ZWIDTH  ,W(1,         
     &     113 ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,113 ),GZL ,AMP(74  ))            
      CALL HVVXXX(W(1,35  ),W(1,103 ),GWWH ,HMASS   ,HWIDTH  ,W(1,         
     &     114 ))                                                          
      CALL IOSXXX(W(1,7   ),W(1,6   ),W(1,114 ),GHTAU ,AMP(75  ))          
      CALL IOVXXX(W(1,40  ),W(1,6   ),W(1,103 ),GWF ,AMP(76  ))            
      CALL FVIXXX(W(1,3   ),W(1,35  ),GWF ,ZERO    ,ZERO    ,W(1,115 ))    
      CALL JIOXXX(W(1,115 ),W(1,2   ),GZN ,ZMASS   ,ZWIDTH  ,W(1,116 ))    
      CALL IOVXXX(W(1,36  ),W(1,6   ),W(1,116 ),GZL ,AMP(77  ))            
      CALL FVIXXX(W(1,7   ),W(1,116 ),GZL ,LMASS   ,ZERO    ,W(1,117 ))    
      CALL IOVXXX(W(1,117 ),W(1,6   ),W(1,1   ),GAL ,AMP(78  ))            

      wwztens(mu) = -AMP(   1)-AMP(   2)-AMP(   3)-AMP(   4)-AMP(   5)
     &             -AMP(   6)-AMP(   7)-AMP(   8)-AMP(   9)-AMP(  10)
     &             -AMP(  11)-AMP(  12)-AMP(  13)-AMP(  14)-AMP(  15)
     &             -AMP(  16)-AMP(  17)-AMP(  18)-AMP(  19)-AMP(  20)
     &             -AMP(  21)-AMP(  22)-AMP(  23)-AMP(  24)-AMP(  25)
     &             -AMP(  26)-AMP(  27)-AMP(  28)-AMP(  29)-AMP(  30)
     &             -AMP(  31)-AMP(  32)-AMP(  33)-AMP(  34)-AMP(  35)
     &             -AMP(  36)-AMP(  37)-AMP(  38)-AMP(  39)-AMP(  40)
     &             -AMP(  41)-AMP(  42)-AMP(  43)-AMP(  44)-AMP(  45)
     &             -AMP(  46)-AMP(  47)-AMP(  48)-AMP(  49)-AMP(  50)
     &             -AMP(  51)-AMP(  52)-AMP(  53)-AMP(  54)-AMP(  55)
     &             -AMP(  56)-AMP(  57)-AMP(  58)-AMP(  59)-AMP(  60)
     &             -AMP(  61)-AMP(  62)-AMP(  63)-AMP(  64)-AMP(  65)
     &             -AMP(  66)-AMP(  67)-AMP(  68)-AMP(  69)-AMP(  70)
     &             -AMP(  71)-AMP(  72)-AMP(  73)-AMP(  74)-AMP(  75)
     &             -AMP(  76)-AMP(  77)-AMP(  78)

      elseif (procid.eq.WWZhad .and. Ztodd) then

      CALL JIOXXX(W(1,3   ),W(1,2   ),GWF ,WMASS   ,WWIDTH  ,W(1,8   ))    
      CALL FVOXXX(W(1,4   ),W(1,8   ),GWF ,ZERO    ,ZERO    ,W(1,9   ))    
      CALL JIOXXX(W(1,5   ),W(1,9   ),GZN ,ZMASS   ,ZWIDTH  ,W(1,10  ))    
      CALL FVOXXX(W(1,6   ),W(1,10  ),GZD ,ZERO    ,ZERO    ,W(1,11  ))    
      CALL IOVXXX(W(1,7   ),W(1,11  ),W(1,1   ),GAD ,AMP(1   ))            
      CALL FVIXXX(W(1,7   ),W(1,10  ),GZD ,ZERO    ,ZERO    ,W(1,12  ))    
      CALL IOVXXX(W(1,12  ),W(1,6   ),W(1,1   ),GAD ,AMP(2   ))            
      CALL JIOXXX(W(1,5   ),W(1,4   ),GWF ,WMASS   ,WWIDTH  ,W(1,13  ))    
      CALL FVIXXX(W(1,7   ),W(1,1   ),GAD ,ZERO    ,ZERO    ,W(1,14  ))    
      CALL JVVXXX(W(1,13  ),W(1,8   ),GWWA ,ZERO    ,AWIDTH  ,W(1,         
     &     15  ))                                                          
      CALL IOVXXX(W(1,14  ),W(1,6   ),W(1,15  ),GAD ,AMP(3   ))            
      CALL JVVXXX(W(1,13  ),W(1,8   ),GWWZ ,ZMASS   ,ZWIDTH  ,W(1,         
     &     16  ))                                                          
      CALL IOVXXX(W(1,14  ),W(1,6   ),W(1,16  ),GZD ,AMP(4   ))            
      CALL FVIXXX(W(1,7   ),W(1,13  ),GWF ,ZERO    ,ZERO    ,W(1,17  ))    
      CALL FVIXXX(W(1,17  ),W(1,8   ),GWF ,ZERO    ,ZERO    ,W(1,18  ))    
      CALL IOVXXX(W(1,18  ),W(1,6   ),W(1,1   ),GAD ,AMP(5   ))            
      CALL FVIXXX(W(1,7   ),W(1,15  ),GAD ,ZERO    ,ZERO    ,W(1,19  ))    
      CALL IOVXXX(W(1,19  ),W(1,6   ),W(1,1   ),GAD ,AMP(6   ))            
      CALL FVIXXX(W(1,7   ),W(1,16  ),GZD ,ZERO    ,ZERO    ,W(1,20  ))    
      CALL IOVXXX(W(1,20  ),W(1,6   ),W(1,1   ),GAD ,AMP(7   ))            
      CALL JVVXXX(W(1,1   ),W(1,13  ),GWWA ,WMASS   ,WWIDTH  ,W(1,         
     &     21  ))                                                          
      CALL FVIXXX(W(1,3   ),W(1,21  ),GWF ,ZERO    ,ZERO    ,W(1,22  ))    
      CALL JIOXXX(W(1,22  ),W(1,2   ),GZN ,ZMASS   ,ZWIDTH  ,W(1,23  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,23  ),GZD ,AMP(8   ))            
      CALL FVOXXX(W(1,2   ),W(1,21  ),GWF ,ZERO    ,ZERO    ,W(1,24  ))    
      CALL JIOXXX(W(1,3   ),W(1,24  ),GAL ,ZERO    ,AWIDTH  ,W(1,25  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,25  ),GAD ,AMP(9   ))            
      CALL JIOXXX(W(1,3   ),W(1,24  ),GZL ,ZMASS   ,ZWIDTH  ,W(1,26  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,26  ),GZD ,AMP(10  ))            
      CALL JVVXXX(W(1,8   ),W(1,1   ),GWWA ,WMASS   ,WWIDTH  ,W(1,         
     &     27  ))                                                          
      CALL FVIXXX(W(1,5   ),W(1,27  ),GWF ,ZERO    ,ZERO    ,W(1,28  ))    
      CALL JIOXXX(W(1,28  ),W(1,4   ),GAL ,ZERO    ,AWIDTH  ,W(1,29  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,29  ),GAD ,AMP(11  ))            
      CALL JIOXXX(W(1,28  ),W(1,4   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,30  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,30  ),GZD ,AMP(12  ))            
      CALL FVOXXX(W(1,4   ),W(1,27  ),GWF ,ZERO    ,ZERO    ,W(1,31  ))    
      CALL JIOXXX(W(1,5   ),W(1,31  ),GZN ,ZMASS   ,ZWIDTH  ,W(1,32  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,32  ),GZD ,AMP(13  ))            
      CALL FVIXXX(W(1,14  ),W(1,13  ),GWF ,ZERO    ,ZERO    ,W(1,33  ))    
      CALL IOVXXX(W(1,33  ),W(1,6   ),W(1,8   ),GWF ,AMP(14  ))            
      CALL JVVXXX(W(1,21  ),W(1,8   ),GWWA ,ZERO    ,AWIDTH  ,W(1,         
     &     34  ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,34  ),GAD ,AMP(15  ))            
      CALL JVVXXX(W(1,21  ),W(1,8   ),GWWZ ,ZMASS   ,ZWIDTH  ,W(1,         
     &     35  ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,35  ),GZD ,AMP(16  ))            
      CALL FVIXXX(W(1,7   ),W(1,21  ),GWF ,ZERO    ,ZERO    ,W(1,36  ))    
      CALL IOVXXX(W(1,36  ),W(1,6   ),W(1,8   ),GWF ,AMP(17  ))            
      CALL FVIXXX(W(1,17  ),W(1,1   ),GAU ,ZERO    ,ZERO    ,W(1,37  ))    
      CALL IOVXXX(W(1,37  ),W(1,6   ),W(1,8   ),GWF ,AMP(18  ))            
      CALL JVVXXX(W(1,13  ),W(1,27  ),GWWA ,ZERO    ,AWIDTH  ,W(1,         
     &     38  ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,38  ),GAD ,AMP(19  ))            
      CALL JVVXXX(W(1,13  ),W(1,27  ),GWWZ ,ZMASS   ,ZWIDTH  ,W(1,         
     &     39  ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,39  ),GZD ,AMP(20  ))            
      CALL IOVXXX(W(1,17  ),W(1,6   ),W(1,27  ),GWF ,AMP(21  ))            
      CALL JW3WXX(W(1,13  ),W(1,1   ),W(1,8   ),GWWA ,GWWA ,ZERO    ,      
     &     AWIDTH  ,W(1,40  ))                                             
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,40  ),GAD ,AMP(22  ))            
      CALL JW3WXX(W(1,13  ),W(1,1   ),W(1,8   ),GWWA ,GWWZ ,ZMASS   ,      
     &     ZWIDTH  ,W(1,41  ))                                             
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,41  ),GZD ,AMP(23  ))            
      CALL FVIXXX(W(1,5   ),W(1,8   ),GWF ,ZERO    ,ZERO    ,W(1,42  ))    
      CALL JIOXXX(W(1,42  ),W(1,4   ),GAL ,ZERO    ,AWIDTH  ,W(1,43  ))    
      CALL IOVXXX(W(1,14  ),W(1,6   ),W(1,43  ),GAD ,AMP(24  ))            
      CALL JIOXXX(W(1,42  ),W(1,4   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,44  ))    
      CALL IOVXXX(W(1,14  ),W(1,6   ),W(1,44  ),GZD ,AMP(25  ))            
      CALL FVIXXX(W(1,7   ),W(1,43  ),GAD ,ZERO    ,ZERO    ,W(1,45  ))    
      CALL IOVXXX(W(1,45  ),W(1,6   ),W(1,1   ),GAD ,AMP(26  ))            
      CALL FVIXXX(W(1,7   ),W(1,44  ),GZD ,ZERO    ,ZERO    ,W(1,46  ))    
      CALL IOVXXX(W(1,46  ),W(1,6   ),W(1,1   ),GAD ,AMP(27  ))            
      CALL FVOXXX(W(1,4   ),W(1,1   ),GAL ,ZERO    ,ZERO    ,W(1,47  ))    
      CALL JIOXXX(W(1,5   ),W(1,47  ),GWF ,WMASS   ,WWIDTH  ,W(1,48  ))    
      CALL FVIXXX(W(1,3   ),W(1,48  ),GWF ,ZERO    ,ZERO    ,W(1,49  ))    
      CALL JIOXXX(W(1,49  ),W(1,2   ),GZN ,ZMASS   ,ZWIDTH  ,W(1,50  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,50  ),GZD ,AMP(28  ))            
      CALL FVOXXX(W(1,2   ),W(1,48  ),GWF ,ZERO    ,ZERO    ,W(1,51  ))    
      CALL JIOXXX(W(1,3   ),W(1,51  ),GAL ,ZERO    ,AWIDTH  ,W(1,52  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,52  ),GAD ,AMP(29  ))            
      CALL JIOXXX(W(1,3   ),W(1,51  ),GZL ,ZMASS   ,ZWIDTH  ,W(1,53  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,53  ),GZD ,AMP(30  ))            
      CALL FVIXXX(W(1,42  ),W(1,1   ),GAL ,ZERO    ,ZERO    ,W(1,54  ))    
      CALL JIOXXX(W(1,54  ),W(1,4   ),GAL ,ZERO    ,AWIDTH  ,W(1,55  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,55  ),GAD ,AMP(31  ))            
      CALL JIOXXX(W(1,54  ),W(1,4   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,56  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,56  ),GZD ,AMP(32  ))            
      CALL FVOXXX(W(1,47  ),W(1,8   ),GWF ,ZERO    ,ZERO    ,W(1,57  ))    
      CALL JIOXXX(W(1,5   ),W(1,57  ),GZN ,ZMASS   ,ZWIDTH  ,W(1,58  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,58  ),GZD ,AMP(33  ))            
      CALL JIOXXX(W(1,42  ),W(1,47  ),GAL ,ZERO    ,AWIDTH  ,W(1,59  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,59  ),GAD ,AMP(34  ))            
      CALL JIOXXX(W(1,42  ),W(1,47  ),GZL ,ZMASS   ,ZWIDTH  ,W(1,60  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,60  ),GZD ,AMP(35  ))            
      CALL JVVXXX(W(1,48  ),W(1,8   ),GWWA ,ZERO    ,AWIDTH  ,W(1,         
     &     61  ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,61  ),GAD ,AMP(36  ))            
      CALL JVVXXX(W(1,48  ),W(1,8   ),GWWZ ,ZMASS   ,ZWIDTH  ,W(1,         
     &     62  ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,62  ),GZD ,AMP(37  ))            
      CALL FVIXXX(W(1,7   ),W(1,48  ),GWF ,ZERO    ,ZERO    ,W(1,63  ))    
      CALL IOVXXX(W(1,63  ),W(1,6   ),W(1,8   ),GWF ,AMP(38  ))            
      CALL FVOXXX(W(1,2   ),W(1,13  ),GWF ,ZERO    ,ZERO    ,W(1,64  ))    
      CALL JIOXXX(W(1,3   ),W(1,64  ),GAL ,ZERO    ,AWIDTH  ,W(1,65  ))    
      CALL IOVXXX(W(1,14  ),W(1,6   ),W(1,65  ),GAD ,AMP(39  ))            
      CALL JIOXXX(W(1,3   ),W(1,64  ),GZL ,ZMASS   ,ZWIDTH  ,W(1,66  ))    
      CALL IOVXXX(W(1,14  ),W(1,6   ),W(1,66  ),GZD ,AMP(40  ))            
      CALL FVIXXX(W(1,7   ),W(1,65  ),GAD ,ZERO    ,ZERO    ,W(1,67  ))    
      CALL IOVXXX(W(1,67  ),W(1,6   ),W(1,1   ),GAD ,AMP(41  ))            
      CALL FVIXXX(W(1,7   ),W(1,66  ),GZD ,ZERO    ,ZERO    ,W(1,68  ))    
      CALL IOVXXX(W(1,68  ),W(1,6   ),W(1,1   ),GAD ,AMP(42  ))            
      CALL FVIXXX(W(1,3   ),W(1,1   ),GAL ,ZERO    ,ZERO    ,W(1,69  ))    
      CALL FVIXXX(W(1,69  ),W(1,13  ),GWF ,ZERO    ,ZERO    ,W(1,70  ))    
      CALL JIOXXX(W(1,70  ),W(1,2   ),GZN ,ZMASS   ,ZWIDTH  ,W(1,71  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,71  ),GZD ,AMP(43  ))            
      CALL FVOXXX(W(1,64  ),W(1,1   ),GAL ,ZERO    ,ZERO    ,W(1,72  ))    
      CALL JIOXXX(W(1,3   ),W(1,72  ),GAL ,ZERO    ,AWIDTH  ,W(1,73  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,73  ),GAD ,AMP(44  ))            
      CALL JIOXXX(W(1,3   ),W(1,72  ),GZL ,ZMASS   ,ZWIDTH  ,W(1,74  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,74  ),GZD ,AMP(45  ))            
      CALL JIOXXX(W(1,69  ),W(1,2   ),GWF ,WMASS   ,WWIDTH  ,W(1,75  ))    
      CALL FVIXXX(W(1,5   ),W(1,75  ),GWF ,ZERO    ,ZERO    ,W(1,76  ))    
      CALL JIOXXX(W(1,76  ),W(1,4   ),GAL ,ZERO    ,AWIDTH  ,W(1,77  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,77  ),GAD ,AMP(46  ))            
      CALL JIOXXX(W(1,76  ),W(1,4   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,78  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,78  ),GZD ,AMP(47  ))            
      CALL FVOXXX(W(1,4   ),W(1,75  ),GWF ,ZERO    ,ZERO    ,W(1,79  ))    
      CALL JIOXXX(W(1,5   ),W(1,79  ),GZN ,ZMASS   ,ZWIDTH  ,W(1,80  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,80  ),GZD ,AMP(48  ))            
      CALL JIOXXX(W(1,69  ),W(1,64  ),GAL ,ZERO    ,AWIDTH  ,W(1,81  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,81  ),GAD ,AMP(49  ))            
      CALL JIOXXX(W(1,69  ),W(1,64  ),GZL ,ZMASS   ,ZWIDTH  ,W(1,82  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,82  ),GZD ,AMP(50  ))            
      CALL JVVXXX(W(1,13  ),W(1,75  ),GWWA ,ZERO    ,AWIDTH  ,W(1,         
     &     83  ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,83  ),GAD ,AMP(51  ))            
      CALL JVVXXX(W(1,13  ),W(1,75  ),GWWZ ,ZMASS   ,ZWIDTH  ,W(1,         
     &     84  ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,84  ),GZD ,AMP(52  ))            
      CALL IOVXXX(W(1,17  ),W(1,6   ),W(1,75  ),GWF ,AMP(53  ))            
      CALL FVIXXX(W(1,3   ),W(1,13  ),GWF ,ZERO    ,ZERO    ,W(1,85  ))    
      CALL JIOXXX(W(1,85  ),W(1,2   ),GZN ,ZMASS   ,ZWIDTH  ,W(1,86  ))    
      CALL IOVXXX(W(1,14  ),W(1,6   ),W(1,86  ),GZD ,AMP(54  ))            
      CALL FVIXXX(W(1,7   ),W(1,86  ),GZD ,ZERO    ,ZERO    ,W(1,87  ))    
      CALL IOVXXX(W(1,87  ),W(1,6   ),W(1,1   ),GAD ,AMP(55  ))            

      wwztens(mu) = -AMP(   1)-AMP(   2)-AMP(   3)-AMP(   4)-AMP(   5)
     &             -AMP(   6)-AMP(   7)-AMP(   8)-AMP(   9)-AMP(  10)
     &             -AMP(  11)-AMP(  12)-AMP(  13)-AMP(  14)-AMP(  15)
     &             -AMP(  16)-AMP(  17)-AMP(  18)-AMP(  19)-AMP(  20)
     &             -AMP(  21)-AMP(  22)-AMP(  23)-AMP(  24)-AMP(  25)
     &             -AMP(  26)-AMP(  27)-AMP(  28)-AMP(  29)-AMP(  30)
     &             -AMP(  31)-AMP(  32)-AMP(  33)-AMP(  34)-AMP(  35)
     &             -AMP(  36)-AMP(  37)-AMP(  38)-AMP(  39)-AMP(  40)
     &             -AMP(  41)-AMP(  42)-AMP(  43)-AMP(  44)-AMP(  45)
     &             -AMP(  46)-AMP(  47)-AMP(  48)-AMP(  49)-AMP(  50)
     &             -AMP(  51)-AMP(  52)-AMP(  53)-AMP(  54)-AMP(  55)

      elseif (procid.eq.WWZhad .and. Ztouu) then

      CALL JIOXXX(W(1,3   ),W(1,2   ),GWF ,WMASS   ,WWIDTH  ,W(1,8   ))    
      CALL FVOXXX(W(1,4   ),W(1,8   ),GWF ,ZERO    ,ZERO    ,W(1,9   ))    
      CALL JIOXXX(W(1,5   ),W(1,9   ),GZN ,ZMASS   ,ZWIDTH  ,W(1,10  ))    
      CALL FVOXXX(W(1,6   ),W(1,10  ),GZU ,ZERO    ,ZERO    ,W(1,11  ))    
      CALL IOVXXX(W(1,7   ),W(1,11  ),W(1,1   ),GAU ,AMP(1   ))            
      CALL FVIXXX(W(1,7   ),W(1,10  ),GZU ,ZERO    ,ZERO    ,W(1,12  ))    
      CALL IOVXXX(W(1,12  ),W(1,6   ),W(1,1   ),GAU ,AMP(2   ))            
      CALL JIOXXX(W(1,5   ),W(1,4   ),GWF ,WMASS   ,WWIDTH  ,W(1,13  ))    
      CALL FVIXXX(W(1,7   ),W(1,1   ),GAU ,ZERO    ,ZERO    ,W(1,14  ))    
      CALL JVVXXX(W(1,13  ),W(1,8   ),GWWA ,ZERO    ,AWIDTH  ,W(1,         
     &     15  ))                                                          
      CALL IOVXXX(W(1,14  ),W(1,6   ),W(1,15  ),GAU ,AMP(3   ))            
      CALL JVVXXX(W(1,13  ),W(1,8   ),GWWZ ,ZMASS   ,ZWIDTH  ,W(1,         
     &     16  ))                                                          
      CALL IOVXXX(W(1,14  ),W(1,6   ),W(1,16  ),GZU ,AMP(4   ))            
      CALL FVIXXX(W(1,7   ),W(1,8   ),GWF ,ZERO    ,ZERO    ,W(1,17  ))    
      CALL FVIXXX(W(1,17  ),W(1,13  ),GWF ,ZERO    ,ZERO    ,W(1,18  ))    
      CALL IOVXXX(W(1,18  ),W(1,6   ),W(1,1   ),GAU ,AMP(5   ))            
      CALL FVIXXX(W(1,7   ),W(1,15  ),GAU ,ZERO    ,ZERO    ,W(1,19  ))    
      CALL IOVXXX(W(1,19  ),W(1,6   ),W(1,1   ),GAU ,AMP(6   ))            
      CALL FVIXXX(W(1,7   ),W(1,16  ),GZU ,ZERO    ,ZERO    ,W(1,20  ))    
      CALL IOVXXX(W(1,20  ),W(1,6   ),W(1,1   ),GAU ,AMP(7   ))            
      CALL JVVXXX(W(1,1   ),W(1,13  ),GWWA ,WMASS   ,WWIDTH  ,W(1,         
     &     21  ))                                                          
      CALL FVIXXX(W(1,3   ),W(1,21  ),GWF ,ZERO    ,ZERO    ,W(1,22  ))    
      CALL JIOXXX(W(1,22  ),W(1,2   ),GZN ,ZMASS   ,ZWIDTH  ,W(1,23  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,23  ),GZU ,AMP(8   ))            
      CALL FVOXXX(W(1,2   ),W(1,21  ),GWF ,ZERO    ,ZERO    ,W(1,24  ))    
      CALL JIOXXX(W(1,3   ),W(1,24  ),GAL ,ZERO    ,AWIDTH  ,W(1,25  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,25  ),GAU ,AMP(9   ))            
      CALL JIOXXX(W(1,3   ),W(1,24  ),GZL ,ZMASS   ,ZWIDTH  ,W(1,26  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,26  ),GZU ,AMP(10  ))            
      CALL JVVXXX(W(1,8   ),W(1,1   ),GWWA ,WMASS   ,WWIDTH  ,W(1,         
     &     27  ))                                                          
      CALL FVIXXX(W(1,5   ),W(1,27  ),GWF ,ZERO    ,ZERO    ,W(1,28  ))    
      CALL JIOXXX(W(1,28  ),W(1,4   ),GAL ,ZERO    ,AWIDTH  ,W(1,29  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,29  ),GAU ,AMP(11  ))            
      CALL JIOXXX(W(1,28  ),W(1,4   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,30  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,30  ),GZU ,AMP(12  ))            
      CALL FVOXXX(W(1,4   ),W(1,27  ),GWF ,ZERO    ,ZERO    ,W(1,31  ))    
      CALL JIOXXX(W(1,5   ),W(1,31  ),GZN ,ZMASS   ,ZWIDTH  ,W(1,32  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,32  ),GZU ,AMP(13  ))            
      CALL JVVXXX(W(1,21  ),W(1,8   ),GWWA ,ZERO    ,AWIDTH  ,W(1,         
     &     33  ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,33  ),GAU ,AMP(14  ))            
      CALL JVVXXX(W(1,21  ),W(1,8   ),GWWZ ,ZMASS   ,ZWIDTH  ,W(1,         
     &     34  ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,34  ),GZU ,AMP(15  ))            
      CALL IOVXXX(W(1,17  ),W(1,6   ),W(1,21  ),GWF ,AMP(16  ))            
      CALL FVIXXX(W(1,14  ),W(1,8   ),GWF ,ZERO    ,ZERO    ,W(1,35  ))    
      CALL IOVXXX(W(1,35  ),W(1,6   ),W(1,13  ),GWF ,AMP(17  ))            
      CALL JVVXXX(W(1,13  ),W(1,27  ),GWWA ,ZERO    ,AWIDTH  ,W(1,         
     &     36  ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,36  ),GAU ,AMP(18  ))            
      CALL JVVXXX(W(1,13  ),W(1,27  ),GWWZ ,ZMASS   ,ZWIDTH  ,W(1,         
     &     37  ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,37  ),GZU ,AMP(19  ))            
      CALL FVIXXX(W(1,17  ),W(1,1   ),GAD ,ZERO    ,ZERO    ,W(1,38  ))    
      CALL IOVXXX(W(1,38  ),W(1,6   ),W(1,13  ),GWF ,AMP(20  ))            
      CALL FVIXXX(W(1,7   ),W(1,27  ),GWF ,ZERO    ,ZERO    ,W(1,39  ))    
      CALL IOVXXX(W(1,39  ),W(1,6   ),W(1,13  ),GWF ,AMP(21  ))            
      CALL JW3WXX(W(1,13  ),W(1,1   ),W(1,8   ),GWWA ,GWWA ,ZERO    ,      
     &     AWIDTH  ,W(1,40  ))                                             
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,40  ),GAU ,AMP(22  ))            
      CALL JW3WXX(W(1,13  ),W(1,1   ),W(1,8   ),GWWA ,GWWZ ,ZMASS   ,      
     &     ZWIDTH  ,W(1,41  ))                                             
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,41  ),GZU ,AMP(23  ))            
      CALL FVIXXX(W(1,5   ),W(1,8   ),GWF ,ZERO    ,ZERO    ,W(1,42  ))    
      CALL JIOXXX(W(1,42  ),W(1,4   ),GAL ,ZERO    ,AWIDTH  ,W(1,43  ))    
      CALL IOVXXX(W(1,14  ),W(1,6   ),W(1,43  ),GAU ,AMP(24  ))            
      CALL JIOXXX(W(1,42  ),W(1,4   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,44  ))    
      CALL IOVXXX(W(1,14  ),W(1,6   ),W(1,44  ),GZU ,AMP(25  ))            
      CALL FVIXXX(W(1,7   ),W(1,43  ),GAU ,ZERO    ,ZERO    ,W(1,45  ))    
      CALL IOVXXX(W(1,45  ),W(1,6   ),W(1,1   ),GAU ,AMP(26  ))            
      CALL FVIXXX(W(1,7   ),W(1,44  ),GZU ,ZERO    ,ZERO    ,W(1,46  ))    
      CALL IOVXXX(W(1,46  ),W(1,6   ),W(1,1   ),GAU ,AMP(27  ))            
      CALL FVOXXX(W(1,4   ),W(1,1   ),GAL ,ZERO    ,ZERO    ,W(1,47  ))    
      CALL JIOXXX(W(1,5   ),W(1,47  ),GWF ,WMASS   ,WWIDTH  ,W(1,48  ))    
      CALL FVIXXX(W(1,3   ),W(1,48  ),GWF ,ZERO    ,ZERO    ,W(1,49  ))    
      CALL JIOXXX(W(1,49  ),W(1,2   ),GZN ,ZMASS   ,ZWIDTH  ,W(1,50  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,50  ),GZU ,AMP(28  ))            
      CALL FVOXXX(W(1,2   ),W(1,48  ),GWF ,ZERO    ,ZERO    ,W(1,51  ))    
      CALL JIOXXX(W(1,3   ),W(1,51  ),GAL ,ZERO    ,AWIDTH  ,W(1,52  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,52  ),GAU ,AMP(29  ))            
      CALL JIOXXX(W(1,3   ),W(1,51  ),GZL ,ZMASS   ,ZWIDTH  ,W(1,53  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,53  ),GZU ,AMP(30  ))            
      CALL FVIXXX(W(1,42  ),W(1,1   ),GAL ,ZERO    ,ZERO    ,W(1,54  ))    
      CALL JIOXXX(W(1,54  ),W(1,4   ),GAL ,ZERO    ,AWIDTH  ,W(1,55  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,55  ),GAU ,AMP(31  ))            
      CALL JIOXXX(W(1,54  ),W(1,4   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,56  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,56  ),GZU ,AMP(32  ))            
      CALL FVOXXX(W(1,47  ),W(1,8   ),GWF ,ZERO    ,ZERO    ,W(1,57  ))    
      CALL JIOXXX(W(1,5   ),W(1,57  ),GZN ,ZMASS   ,ZWIDTH  ,W(1,58  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,58  ),GZU ,AMP(33  ))            
      CALL JIOXXX(W(1,42  ),W(1,47  ),GAL ,ZERO    ,AWIDTH  ,W(1,59  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,59  ),GAU ,AMP(34  ))            
      CALL JIOXXX(W(1,42  ),W(1,47  ),GZL ,ZMASS   ,ZWIDTH  ,W(1,60  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,60  ),GZU ,AMP(35  ))            
      CALL JVVXXX(W(1,48  ),W(1,8   ),GWWA ,ZERO    ,AWIDTH  ,W(1,         
     &     61  ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,61  ),GAU ,AMP(36  ))            
      CALL JVVXXX(W(1,48  ),W(1,8   ),GWWZ ,ZMASS   ,ZWIDTH  ,W(1,         
     &     62  ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,62  ),GZU ,AMP(37  ))            
      CALL IOVXXX(W(1,17  ),W(1,6   ),W(1,48  ),GWF ,AMP(38  ))            
      CALL FVOXXX(W(1,2   ),W(1,13  ),GWF ,ZERO    ,ZERO    ,W(1,63  ))    
      CALL JIOXXX(W(1,3   ),W(1,63  ),GAL ,ZERO    ,AWIDTH  ,W(1,64  ))    
      CALL IOVXXX(W(1,14  ),W(1,6   ),W(1,64  ),GAU ,AMP(39  ))            
      CALL JIOXXX(W(1,3   ),W(1,63  ),GZL ,ZMASS   ,ZWIDTH  ,W(1,65  ))    
      CALL IOVXXX(W(1,14  ),W(1,6   ),W(1,65  ),GZU ,AMP(40  ))            
      CALL FVIXXX(W(1,7   ),W(1,64  ),GAU ,ZERO    ,ZERO    ,W(1,66  ))    
      CALL IOVXXX(W(1,66  ),W(1,6   ),W(1,1   ),GAU ,AMP(41  ))            
      CALL FVIXXX(W(1,7   ),W(1,65  ),GZU ,ZERO    ,ZERO    ,W(1,67  ))    
      CALL IOVXXX(W(1,67  ),W(1,6   ),W(1,1   ),GAU ,AMP(42  ))            
      CALL FVIXXX(W(1,3   ),W(1,1   ),GAL ,ZERO    ,ZERO    ,W(1,68  ))    
      CALL FVIXXX(W(1,68  ),W(1,13  ),GWF ,ZERO    ,ZERO    ,W(1,69  ))    
      CALL JIOXXX(W(1,69  ),W(1,2   ),GZN ,ZMASS   ,ZWIDTH  ,W(1,70  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,70  ),GZU ,AMP(43  ))            
      CALL FVOXXX(W(1,63  ),W(1,1   ),GAL ,ZERO    ,ZERO    ,W(1,71  ))    
      CALL JIOXXX(W(1,3   ),W(1,71  ),GAL ,ZERO    ,AWIDTH  ,W(1,72  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,72  ),GAU ,AMP(44  ))            
      CALL JIOXXX(W(1,3   ),W(1,71  ),GZL ,ZMASS   ,ZWIDTH  ,W(1,73  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,73  ),GZU ,AMP(45  ))            
      CALL JIOXXX(W(1,68  ),W(1,2   ),GWF ,WMASS   ,WWIDTH  ,W(1,74  ))    
      CALL FVIXXX(W(1,5   ),W(1,74  ),GWF ,ZERO    ,ZERO    ,W(1,75  ))    
      CALL JIOXXX(W(1,75  ),W(1,4   ),GAL ,ZERO    ,AWIDTH  ,W(1,76  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,76  ),GAU ,AMP(46  ))            
      CALL JIOXXX(W(1,75  ),W(1,4   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,77  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,77  ),GZU ,AMP(47  ))            
      CALL FVOXXX(W(1,4   ),W(1,74  ),GWF ,ZERO    ,ZERO    ,W(1,78  ))    
      CALL JIOXXX(W(1,5   ),W(1,78  ),GZN ,ZMASS   ,ZWIDTH  ,W(1,79  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,79  ),GZU ,AMP(48  ))            
      CALL JIOXXX(W(1,68  ),W(1,63  ),GAL ,ZERO    ,AWIDTH  ,W(1,80  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,80  ),GAU ,AMP(49  ))            
      CALL JIOXXX(W(1,68  ),W(1,63  ),GZL ,ZMASS   ,ZWIDTH  ,W(1,81  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,81  ),GZU ,AMP(50  ))            
      CALL JVVXXX(W(1,13  ),W(1,74  ),GWWA ,ZERO    ,AWIDTH  ,W(1,         
     &     82  ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,82  ),GAU ,AMP(51  ))            
      CALL JVVXXX(W(1,13  ),W(1,74  ),GWWZ ,ZMASS   ,ZWIDTH  ,W(1,         
     &     83  ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,83  ),GZU ,AMP(52  ))            
      CALL FVIXXX(W(1,7   ),W(1,74  ),GWF ,ZERO    ,ZERO    ,W(1,84  ))    
      CALL IOVXXX(W(1,84  ),W(1,6   ),W(1,13  ),GWF ,AMP(53  ))            
      CALL FVIXXX(W(1,3   ),W(1,13  ),GWF ,ZERO    ,ZERO    ,W(1,85  ))    
      CALL JIOXXX(W(1,85  ),W(1,2   ),GZN ,ZMASS   ,ZWIDTH  ,W(1,86  ))    
      CALL IOVXXX(W(1,14  ),W(1,6   ),W(1,86  ),GZU ,AMP(54  ))            
      CALL FVIXXX(W(1,7   ),W(1,86  ),GZU ,ZERO    ,ZERO    ,W(1,87  ))    
      CALL IOVXXX(W(1,87  ),W(1,6   ),W(1,1   ),GAU ,AMP(55  ))            

      wwztens(mu) = -AMP(   1)-AMP(   2)-AMP(   3)-AMP(   4)-AMP(   5)
     &             -AMP(   6)-AMP(   7)-AMP(   8)-AMP(   9)-AMP(  10)
     &             -AMP(  11)-AMP(  12)-AMP(  13)-AMP(  14)-AMP(  15)
     &             -AMP(  16)-AMP(  17)-AMP(  18)-AMP(  19)-AMP(  20)
     &             -AMP(  21)-AMP(  22)-AMP(  23)-AMP(  24)-AMP(  25)
     &             -AMP(  26)-AMP(  27)-AMP(  28)-AMP(  29)-AMP(  30)
     &             -AMP(  31)-AMP(  32)-AMP(  33)-AMP(  34)-AMP(  35)
     &             -AMP(  36)-AMP(  37)-AMP(  38)-AMP(  39)-AMP(  40)
     &             -AMP(  41)-AMP(  42)-AMP(  43)-AMP(  44)-AMP(  45)
     &             -AMP(  46)-AMP(  47)-AMP(  48)-AMP(  49)-AMP(  50)
     &             -AMP(  51)-AMP(  52)-AMP(  53)-AMP(  54)-AMP(  55)

      else

      wwztens(mu) = dcmplx(0.,0.)

      endif

      enddo
      wwztens(4) = dcmplx(q(0),q(3))
      wwztens(5) = dcmplx(q(1),q(2))
c
      END


c ------------------------------------------------------------

      subroutine ZTOWWZ_mg_had(P,N,h,wwztens,NW)

      IMPLICIT NONE

      DOUBLE PRECISION P(0:3,2:7)
      complex*16 wwztens(0:5)
      integer lsign(2:7,2),ll,mu,nu,h,N
      integer NW ! = 0: all diagrams, = 1: no non resonant diagrams

      ! possible lepton helicities:
      data (lsign(ll,1),ll=2,7) / -1, -1, -1, -1, -1, -1/  !h=1
      data (lsign(ll,2),ll=2,7) / -1, -1, -1, -1, +1, +1/  !h=2

      call ZTOWWZ1_mg_had(P,N,lsign(2,h),wwztens(0),NW)

      ! helicity combi nr.h is selected

      end

c ------------------------------------------------------------

      SUBROUTINE ZTOWWZ1_mg_had(P,N,lsign,wwztens,NW)
C
C Generated by MadGraph II Version 3.0. Updated 02/19/04
C RETURNS AMPLITUDE SQUARED SUMMED/AVG OVER COLORS
C FOR THE POINT WITH EXTERNAL LINES W(0:6,NEXTERNAL)
C
C FOR PROCESS : z -> ve e+ mu- vm~ ta- ta+ 
C
      IMPLICIT NONE
C
C CONSTANTS
C
      INTEGER    NGRAPHS
      PARAMETER (NGRAPHS=  97)
      INTEGER    NWAVEFUNCS
      PARAMETER (NWAVEFUNCS= 141)
      DOUBLE PRECISION     ZERO
      PARAMETER (ZERO=0D0)
C
C ARGUMENTS
C
      DOUBLE PRECISION P(0:3,2:7), Q(0:3)
      INTEGER N
      COMPLEX*16 wwztens(0:5)
      INTEGER lsign(2:7)
      integer NW ! = 0: all diagrams, = 1: no non resonant diagrams
C
C LOCAL VARIABLES
C
      INTEGER I,J, mu
      COMPLEX*16 AMP(NGRAPHS)
      COMPLEX*16 W(6,NWAVEFUNCS)
      common/debug1/W

c  lepton spinors and W+-, Z/A polarization vectors
#include "tensor.inc"

      logical lswitch
      parameter (lswitch=.true.)
c      logical wtest
c      parameter (wtest=.false.)
      double complex dotcc
      external dotcc

C
C GLOBAL VARIABLES
C
#include "VBFNLO/utilities/coupl.inc"
#include "VBFNLO/utilities/global.inc"
#include "VBFNLO/utilities/coupl_haddecay.inc"
#include "VBFNLO/utilities/process.inc"
C
C ----------
C BEGIN CODE
C ----------
      if (lswitch) then      ! read in lepton an W states from common block
         do i=1,6
            w(i,2)  = wve(i,N)
            w(i,3)  = wep(i,N)
            w(i,4)  = wmu(i,N)
            w(i,5)  = wvm(i,N)
            w(i,6)  = ztm(i,N)
            w(i,7)  = ztp(i,N)
         enddo
      endif

      do mu = 0,3
         q(mu) = p(mu,2)+p(mu,3)+p(mu,4)+p(mu,5)+p(mu,6)+p(mu,7)
      enddo

      do mu = 0,3
      CALL TRIBOSVCARTX(Q(0),ZMASS ,ZWIDTH, MU,-1,W(1,1   ))

      if (procid.eq.WPhadWMZ) then

      CALL JIOXXX(W(1,3   ),W(1,2   ),GWF ,WMASS   ,WWIDTH  ,W(1,8   ))    
      CALL FVOXXX(W(1,4   ),W(1,8   ),GWF ,ZERO    ,ZERO    ,W(1,9   ))    
      CALL JIOXXX(W(1,5   ),W(1,9   ),GZN ,ZMASS   ,ZWIDTH  ,W(1,10  ))    
      CALL FVOXXX(W(1,6   ),W(1,10  ),GZL ,LMASS   ,ZERO    ,W(1,11  ))    
      CALL IOVXXX(W(1,7   ),W(1,11  ),W(1,1   ),GZL ,AMP(1   ))            
      CALL HVVXXX(W(1,10  ),W(1,1   ),GZZH ,HMASS   ,HWIDTH  ,W(1,         
     &     12  ))                                                          
      CALL IOSXXX(W(1,7   ),W(1,6   ),W(1,12  ),GHTAU ,AMP(2   ))          
      CALL FVIXXX(W(1,7   ),W(1,10  ),GZL ,LMASS   ,ZERO    ,W(1,13  ))    
      CALL IOVXXX(W(1,13  ),W(1,6   ),W(1,1   ),GZL ,AMP(3   ))            
      CALL FVIXXX(W(1,5   ),W(1,1   ),GZN ,ZERO    ,ZERO    ,W(1,14  ))    
      CALL JIOXXX(W(1,14  ),W(1,4   ),GWF ,WMASS   ,WWIDTH  ,W(1,15  ))    
      CALL FVIXXX(W(1,3   ),W(1,15  ),GWF ,ZERO    ,ZERO    ,W(1,16  ))    
      CALL JIOXXX(W(1,16  ),W(1,2   ),GAU ,ZERO    ,AWIDTH  ,W(1,17  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,17  ),GAL ,AMP(4   ))            
      CALL JIOXXX(W(1,16  ),W(1,2   ),GZU ,ZMASS   ,ZWIDTH  ,W(1,18  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,18  ),GZL ,AMP(5   ))            
      CALL FVOXXX(W(1,2   ),W(1,15  ),GWF ,ZERO    ,ZERO    ,W(1,19  ))    
      CALL JIOXXX(W(1,3   ),W(1,19  ),GAD ,ZERO    ,AWIDTH  ,W(1,20  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,20  ),GAL ,AMP(6   ))            
      CALL JIOXXX(W(1,3   ),W(1,19  ),GZD ,ZMASS   ,ZWIDTH  ,W(1,21  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,21  ),GZL ,AMP(7   ))            
      CALL FVIXXX(W(1,14  ),W(1,8   ),GWF ,ZERO    ,ZERO    ,W(1,22  ))    
      CALL JIOXXX(W(1,22  ),W(1,4   ),GAL ,ZERO    ,AWIDTH  ,W(1,23  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,23  ),GAL ,AMP(8   ))            
      CALL JIOXXX(W(1,22  ),W(1,4   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,24  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,24  ),GZL ,AMP(9   ))            
      CALL FVOXXX(W(1,9   ),W(1,1   ),GZN ,ZERO    ,ZERO    ,W(1,25  ))    
      CALL JIOXXX(W(1,5   ),W(1,25  ),GZN ,ZMASS   ,ZWIDTH  ,W(1,26  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,26  ),GZL ,AMP(10  ))            
      CALL JVVXXX(W(1,15  ),W(1,8   ),GWWA ,ZERO    ,AWIDTH  ,W(1,         
     &     27  ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,27  ),GAL ,AMP(11  ))            
      CALL JVVXXX(W(1,15  ),W(1,8   ),GWWZ ,ZMASS   ,ZWIDTH  ,W(1,         
     &     28  ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,28  ),GZL ,AMP(12  ))            
      CALL HVVXXX(W(1,15  ),W(1,8   ),GWWH ,HMASS   ,HWIDTH  ,W(1,         
     &     29  ))                                                          
      CALL IOSXXX(W(1,7   ),W(1,6   ),W(1,29  ),GHTAU ,AMP(13  ))          
      CALL FVIXXX(W(1,7   ),W(1,15  ),GWF ,ZERO    ,ZERO    ,W(1,30  ))    
      CALL IOVXXX(W(1,30  ),W(1,6   ),W(1,8   ),GWF ,AMP(14  ))            
      CALL JIOXXX(W(1,14  ),W(1,9   ),GZN ,ZMASS   ,ZWIDTH  ,W(1,31  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,31  ),GZL ,AMP(15  ))            
      CALL JIOXXX(W(1,5   ),W(1,4   ),GWF ,WMASS   ,WWIDTH  ,W(1,32  ))    
      CALL FVIXXX(W(1,7   ),W(1,1   ),GZL ,LMASS   ,ZERO    ,W(1,33  ))    
      CALL JVVXXX(W(1,32  ),W(1,8   ),GWWA ,ZERO    ,AWIDTH  ,W(1,         
     &     34  ))                                                          
      CALL IOVXXX(W(1,33  ),W(1,6   ),W(1,34  ),GAL ,AMP(16  ))            
      CALL JVVXXX(W(1,32  ),W(1,8   ),GWWZ ,ZMASS   ,ZWIDTH  ,W(1,         
     &     35  ))                                                          
      CALL IOVXXX(W(1,33  ),W(1,6   ),W(1,35  ),GZL ,AMP(17  ))            
      CALL HVVXXX(W(1,32  ),W(1,8   ),GWWH ,HMASS   ,HWIDTH  ,W(1,         
     &     36  ))                                                          
      CALL IOSXXX(W(1,33  ),W(1,6   ),W(1,36  ),GHTAU ,AMP(18  ))          
      CALL HVVXXX(W(1,35  ),W(1,1   ),GZZH ,HMASS   ,HWIDTH  ,W(1,         
     &     37  ))                                                          
      CALL IOSXXX(W(1,7   ),W(1,6   ),W(1,37  ),GHTAU ,AMP(19  ))          
      CALL JVSXXX(W(1,1   ),W(1,36  ),GZZH ,ZMASS   ,ZWIDTH  ,W(1,         
     &     38  ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,38  ),GZL ,AMP(20  ))            
      CALL FVIXXX(W(1,7   ),W(1,32  ),GWF ,ZERO    ,ZERO    ,W(1,39  ))    
      CALL FVIXXX(W(1,39  ),W(1,8   ),GWF ,LMASS   ,ZERO    ,W(1,40  ))    
      CALL IOVXXX(W(1,40  ),W(1,6   ),W(1,1   ),GZL ,AMP(21  ))            
      CALL FVIXXX(W(1,7   ),W(1,34  ),GAL ,LMASS   ,ZERO    ,W(1,41  ))    
      CALL IOVXXX(W(1,41  ),W(1,6   ),W(1,1   ),GZL ,AMP(22  ))            
      CALL FVIXXX(W(1,7   ),W(1,35  ),GZL ,LMASS   ,ZERO    ,W(1,42  ))    
      CALL IOVXXX(W(1,42  ),W(1,6   ),W(1,1   ),GZL ,AMP(23  ))            
      CALL FSIXXX(W(1,7   ),W(1,36  ),GHTAU ,LMASS   ,ZERO    ,W(1,        
     &     43  ))                                                          
      CALL IOVXXX(W(1,43  ),W(1,6   ),W(1,1   ),GZL ,AMP(24  ))            
      CALL JVVXXX(W(1,1   ),W(1,32  ),GWWZ ,WMASS   ,WWIDTH  ,W(1,         
     &     44  ))                                                          
      CALL FVIXXX(W(1,3   ),W(1,44  ),GWF ,ZERO    ,ZERO    ,W(1,45  ))    
      CALL JIOXXX(W(1,45  ),W(1,2   ),GAU ,ZERO    ,AWIDTH  ,W(1,46  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,46  ),GAL ,AMP(25  ))            
      CALL JIOXXX(W(1,45  ),W(1,2   ),GZU ,ZMASS   ,ZWIDTH  ,W(1,47  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,47  ),GZL ,AMP(26  ))            
      CALL FVOXXX(W(1,2   ),W(1,44  ),GWF ,ZERO    ,ZERO    ,W(1,48  ))    
      CALL JIOXXX(W(1,3   ),W(1,48  ),GAD ,ZERO    ,AWIDTH  ,W(1,49  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,49  ),GAL ,AMP(27  ))            
      CALL JIOXXX(W(1,3   ),W(1,48  ),GZD ,ZMASS   ,ZWIDTH  ,W(1,50  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,50  ),GZL ,AMP(28  ))            
      CALL JVVXXX(W(1,8   ),W(1,1   ),GWWZ ,WMASS   ,WWIDTH  ,W(1,         
     &     51  ))                                                          
      CALL FVIXXX(W(1,5   ),W(1,51  ),GWF ,ZERO    ,ZERO    ,W(1,52  ))    
      CALL JIOXXX(W(1,52  ),W(1,4   ),GAL ,ZERO    ,AWIDTH  ,W(1,53  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,53  ),GAL ,AMP(29  ))            
      CALL JIOXXX(W(1,52  ),W(1,4   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,54  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,54  ),GZL ,AMP(30  ))            
      CALL FVOXXX(W(1,4   ),W(1,51  ),GWF ,ZERO    ,ZERO    ,W(1,55  ))    
      CALL JIOXXX(W(1,5   ),W(1,55  ),GZN ,ZMASS   ,ZWIDTH  ,W(1,56  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,56  ),GZL ,AMP(31  ))            
      CALL FVIXXX(W(1,33  ),W(1,32  ),GWF ,ZERO    ,ZERO    ,W(1,57  ))    
      CALL IOVXXX(W(1,57  ),W(1,6   ),W(1,8   ),GWF ,AMP(32  ))            
      CALL JVVXXX(W(1,44  ),W(1,8   ),GWWA ,ZERO    ,AWIDTH  ,W(1,         
     &     58  ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,58  ),GAL ,AMP(33  ))            
      CALL JVVXXX(W(1,44  ),W(1,8   ),GWWZ ,ZMASS   ,ZWIDTH  ,W(1,         
     &     59  ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,59  ),GZL ,AMP(34  ))            
      CALL HVVXXX(W(1,44  ),W(1,8   ),GWWH ,HMASS   ,HWIDTH  ,W(1,         
     &     60  ))                                                          
      CALL IOSXXX(W(1,7   ),W(1,6   ),W(1,60  ),GHTAU ,AMP(35  ))          
      CALL FVIXXX(W(1,7   ),W(1,44  ),GWF ,ZERO    ,ZERO    ,W(1,61  ))    
      CALL IOVXXX(W(1,61  ),W(1,6   ),W(1,8   ),GWF ,AMP(36  ))            
      CALL FVIXXX(W(1,39  ),W(1,1   ),GZN ,ZERO    ,ZERO    ,W(1,62  ))    
      CALL IOVXXX(W(1,62  ),W(1,6   ),W(1,8   ),GWF ,AMP(37  ))            
      CALL JVVXXX(W(1,32  ),W(1,51  ),GWWA ,ZERO    ,AWIDTH  ,W(1,         
     &     63  ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,63  ),GAL ,AMP(38  ))            
      CALL JVVXXX(W(1,32  ),W(1,51  ),GWWZ ,ZMASS   ,ZWIDTH  ,W(1,         
     &     64  ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,64  ),GZL ,AMP(39  ))            
      CALL HVVXXX(W(1,32  ),W(1,51  ),GWWH ,HMASS   ,HWIDTH  ,W(1,         
     &     65  ))                                                          
      CALL IOSXXX(W(1,7   ),W(1,6   ),W(1,65  ),GHTAU ,AMP(40  ))          
      CALL IOVXXX(W(1,39  ),W(1,6   ),W(1,51  ),GWF ,AMP(41  ))            
      CALL JW3WXX(W(1,32  ),W(1,1   ),W(1,8   ),GWWZ ,GWWA ,ZERO    ,      
     &     AWIDTH  ,W(1,66  ))                                             
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,66  ),GAL ,AMP(42  ))            
      CALL JW3WXX(W(1,32  ),W(1,1   ),W(1,8   ),GWWZ ,GWWZ ,ZMASS   ,      
     &     ZWIDTH  ,W(1,67  ))                                             
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,67  ),GZL ,AMP(43  ))            
      CALL FVIXXX(W(1,5   ),W(1,8   ),GWF ,ZERO    ,ZERO    ,W(1,68  ))    
      CALL JIOXXX(W(1,68  ),W(1,4   ),GAL ,ZERO    ,AWIDTH  ,W(1,69  ))    
      CALL IOVXXX(W(1,33  ),W(1,6   ),W(1,69  ),GAL ,AMP(44  ))            
      CALL JIOXXX(W(1,68  ),W(1,4   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,70  ))    
      CALL IOVXXX(W(1,33  ),W(1,6   ),W(1,70  ),GZL ,AMP(45  ))            
      CALL HVVXXX(W(1,70  ),W(1,1   ),GZZH ,HMASS   ,HWIDTH  ,W(1,         
     &     71  ))                                                          
      CALL IOSXXX(W(1,7   ),W(1,6   ),W(1,71  ),GHTAU ,AMP(46  ))          
      CALL FVIXXX(W(1,7   ),W(1,69  ),GAL ,LMASS   ,ZERO    ,W(1,72  ))    
      CALL IOVXXX(W(1,72  ),W(1,6   ),W(1,1   ),GZL ,AMP(47  ))            
      CALL FVIXXX(W(1,7   ),W(1,70  ),GZL ,LMASS   ,ZERO    ,W(1,73  ))    
      CALL IOVXXX(W(1,73  ),W(1,6   ),W(1,1   ),GZL ,AMP(48  ))            
      CALL FVOXXX(W(1,4   ),W(1,1   ),GZL ,ZERO    ,ZERO    ,W(1,74  ))    
      CALL JIOXXX(W(1,5   ),W(1,74  ),GWF ,WMASS   ,WWIDTH  ,W(1,75  ))    
      CALL FVIXXX(W(1,3   ),W(1,75  ),GWF ,ZERO    ,ZERO    ,W(1,76  ))    
      CALL JIOXXX(W(1,76  ),W(1,2   ),GAU ,ZERO    ,AWIDTH  ,W(1,77  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,77  ),GAL ,AMP(49  ))            
      CALL JIOXXX(W(1,76  ),W(1,2   ),GZU ,ZMASS   ,ZWIDTH  ,W(1,78  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,78  ),GZL ,AMP(50  ))            
      CALL FVOXXX(W(1,2   ),W(1,75  ),GWF ,ZERO    ,ZERO    ,W(1,79  ))    
      CALL JIOXXX(W(1,3   ),W(1,79  ),GAD ,ZERO    ,AWIDTH  ,W(1,80  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,80  ),GAL ,AMP(51  ))            
      CALL JIOXXX(W(1,3   ),W(1,79  ),GZD ,ZMASS   ,ZWIDTH  ,W(1,81  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,81  ),GZL ,AMP(52  ))            
      CALL FVIXXX(W(1,68  ),W(1,1   ),GZL ,ZERO    ,ZERO    ,W(1,82  ))    
      CALL JIOXXX(W(1,82  ),W(1,4   ),GAL ,ZERO    ,AWIDTH  ,W(1,83  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,83  ),GAL ,AMP(53  ))            
      CALL JIOXXX(W(1,82  ),W(1,4   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,84  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,84  ),GZL ,AMP(54  ))            
      CALL FVOXXX(W(1,74  ),W(1,8   ),GWF ,ZERO    ,ZERO    ,W(1,85  ))    
      CALL JIOXXX(W(1,5   ),W(1,85  ),GZN ,ZMASS   ,ZWIDTH  ,W(1,86  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,86  ),GZL ,AMP(55  ))            
      CALL JIOXXX(W(1,68  ),W(1,74  ),GAL ,ZERO    ,AWIDTH  ,W(1,87  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,87  ),GAL ,AMP(56  ))            
      CALL JIOXXX(W(1,68  ),W(1,74  ),GZL ,ZMASS   ,ZWIDTH  ,W(1,88  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,88  ),GZL ,AMP(57  ))            
      CALL JVVXXX(W(1,75  ),W(1,8   ),GWWA ,ZERO    ,AWIDTH  ,W(1,         
     &     89  ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,89  ),GAL ,AMP(58  ))            
      CALL JVVXXX(W(1,75  ),W(1,8   ),GWWZ ,ZMASS   ,ZWIDTH  ,W(1,         
     &     90  ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,90  ),GZL ,AMP(59  ))            
      CALL HVVXXX(W(1,75  ),W(1,8   ),GWWH ,HMASS   ,HWIDTH  ,W(1,         
     &     91  ))                                                          
      CALL IOSXXX(W(1,7   ),W(1,6   ),W(1,91  ),GHTAU ,AMP(60  ))          
      CALL FVIXXX(W(1,7   ),W(1,75  ),GWF ,ZERO    ,ZERO    ,W(1,92  ))    
      CALL IOVXXX(W(1,92  ),W(1,6   ),W(1,8   ),GWF ,AMP(61  ))            
      CALL FVOXXX(W(1,2   ),W(1,32  ),GWF ,ZERO    ,ZERO    ,W(1,93  ))    
      CALL JIOXXX(W(1,3   ),W(1,93  ),GAD ,ZERO    ,AWIDTH  ,W(1,94  ))    
      CALL IOVXXX(W(1,33  ),W(1,6   ),W(1,94  ),GAL ,AMP(62  ))            
      CALL JIOXXX(W(1,3   ),W(1,93  ),GZD ,ZMASS   ,ZWIDTH  ,W(1,95  ))    
      CALL IOVXXX(W(1,33  ),W(1,6   ),W(1,95  ),GZL ,AMP(63  ))            
      CALL HVVXXX(W(1,95  ),W(1,1   ),GZZH ,HMASS   ,HWIDTH  ,W(1,         
     &     96  ))                                                          
      CALL IOSXXX(W(1,7   ),W(1,6   ),W(1,96  ),GHTAU ,AMP(64  ))          
      CALL FVIXXX(W(1,7   ),W(1,94  ),GAL ,LMASS   ,ZERO    ,W(1,97  ))    
      CALL IOVXXX(W(1,97  ),W(1,6   ),W(1,1   ),GZL ,AMP(65  ))            
      CALL FVIXXX(W(1,7   ),W(1,95  ),GZL ,LMASS   ,ZERO    ,W(1,98  ))    
      CALL IOVXXX(W(1,98  ),W(1,6   ),W(1,1   ),GZL ,AMP(66  ))            
      CALL FVIXXX(W(1,3   ),W(1,1   ),GZD ,ZERO    ,ZERO    ,W(1,99  ))    
      CALL FVIXXX(W(1,99  ),W(1,32  ),GWF ,ZERO    ,ZERO    ,W(1,100 ))    
      CALL JIOXXX(W(1,100 ),W(1,2   ),GAU ,ZERO    ,AWIDTH  ,W(1,101 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,101 ),GAL ,AMP(67  ))            
      CALL JIOXXX(W(1,100 ),W(1,2   ),GZU ,ZMASS   ,ZWIDTH  ,W(1,102 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,102 ),GZL ,AMP(68  ))            
      CALL FVOXXX(W(1,93  ),W(1,1   ),GZD ,ZERO    ,ZERO    ,W(1,103 ))    
      CALL JIOXXX(W(1,3   ),W(1,103 ),GAD ,ZERO    ,AWIDTH  ,W(1,104 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,104 ),GAL ,AMP(69  ))            
      CALL JIOXXX(W(1,3   ),W(1,103 ),GZD ,ZMASS   ,ZWIDTH  ,W(1,105 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,105 ),GZL ,AMP(70  ))            
      CALL JIOXXX(W(1,99  ),W(1,2   ),GWF ,WMASS   ,WWIDTH  ,W(1,106 ))    
      CALL FVIXXX(W(1,5   ),W(1,106 ),GWF ,ZERO    ,ZERO    ,W(1,107 ))    
      CALL JIOXXX(W(1,107 ),W(1,4   ),GAL ,ZERO    ,AWIDTH  ,W(1,108 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,108 ),GAL ,AMP(71  ))            
      CALL JIOXXX(W(1,107 ),W(1,4   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,109 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,109 ),GZL ,AMP(72  ))            
      CALL FVOXXX(W(1,4   ),W(1,106 ),GWF ,ZERO    ,ZERO    ,W(1,110 ))    
      CALL JIOXXX(W(1,5   ),W(1,110 ),GZN ,ZMASS   ,ZWIDTH  ,W(1,111 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,111 ),GZL ,AMP(73  ))            
      CALL JIOXXX(W(1,99  ),W(1,93  ),GAD ,ZERO    ,AWIDTH  ,W(1,112 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,112 ),GAL ,AMP(74  ))            
      CALL JIOXXX(W(1,99  ),W(1,93  ),GZD ,ZMASS   ,ZWIDTH  ,W(1,113 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,113 ),GZL ,AMP(75  ))            
      CALL JVVXXX(W(1,32  ),W(1,106 ),GWWA ,ZERO    ,AWIDTH  ,W(1,         
     &     114 ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,114 ),GAL ,AMP(76  ))            
      CALL JVVXXX(W(1,32  ),W(1,106 ),GWWZ ,ZMASS   ,ZWIDTH  ,W(1,         
     &     115 ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,115 ),GZL ,AMP(77  ))            
      CALL HVVXXX(W(1,32  ),W(1,106 ),GWWH ,HMASS   ,HWIDTH  ,W(1,         
     &     116 ))                                                          
      CALL IOSXXX(W(1,7   ),W(1,6   ),W(1,116 ),GHTAU ,AMP(78  ))          
      CALL IOVXXX(W(1,39  ),W(1,6   ),W(1,106 ),GWF ,AMP(79  ))            
      CALL FVIXXX(W(1,3   ),W(1,32  ),GWF ,ZERO    ,ZERO    ,W(1,117 ))    
      CALL JIOXXX(W(1,117 ),W(1,2   ),GAU ,ZERO    ,AWIDTH  ,W(1,118 ))    
      CALL IOVXXX(W(1,33  ),W(1,6   ),W(1,118 ),GAL ,AMP(80  ))            
      CALL JIOXXX(W(1,117 ),W(1,2   ),GZU ,ZMASS   ,ZWIDTH  ,W(1,119 ))    
      CALL IOVXXX(W(1,33  ),W(1,6   ),W(1,119 ),GZL ,AMP(81  ))            
      CALL HVVXXX(W(1,119 ),W(1,1   ),GZZH ,HMASS   ,HWIDTH  ,W(1,         
     &     120 ))                                                          
      CALL IOSXXX(W(1,7   ),W(1,6   ),W(1,120 ),GHTAU ,AMP(82  ))          
      CALL FVIXXX(W(1,7   ),W(1,118 ),GAL ,LMASS   ,ZERO    ,W(1,121 ))    
      CALL IOVXXX(W(1,121 ),W(1,6   ),W(1,1   ),GZL ,AMP(83  ))            
      CALL FVIXXX(W(1,7   ),W(1,119 ),GZL ,LMASS   ,ZERO    ,W(1,122 ))    
      CALL IOVXXX(W(1,122 ),W(1,6   ),W(1,1   ),GZL ,AMP(84  ))            
      CALL FVIXXX(W(1,117 ),W(1,1   ),GZU ,ZERO    ,ZERO    ,W(1,123 ))    
      CALL JIOXXX(W(1,123 ),W(1,2   ),GAU ,ZERO    ,AWIDTH  ,W(1,124 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,124 ),GAL ,AMP(85  ))            
      CALL JIOXXX(W(1,123 ),W(1,2   ),GZU ,ZMASS   ,ZWIDTH  ,W(1,125 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,125 ),GZL ,AMP(86  ))            
      CALL FVOXXX(W(1,2   ),W(1,1   ),GZU ,ZERO    ,ZERO    ,W(1,126 ))    
      CALL FVOXXX(W(1,126 ),W(1,32  ),GWF ,ZERO    ,ZERO    ,W(1,127 ))    
      CALL JIOXXX(W(1,3   ),W(1,127 ),GAD ,ZERO    ,AWIDTH  ,W(1,128 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,128 ),GAL ,AMP(87  ))            
      CALL JIOXXX(W(1,3   ),W(1,127 ),GZD ,ZMASS   ,ZWIDTH  ,W(1,129 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,129 ),GZL ,AMP(88  ))            
      CALL JIOXXX(W(1,3   ),W(1,126 ),GWF ,WMASS   ,WWIDTH  ,W(1,130 ))    
      CALL FVIXXX(W(1,5   ),W(1,130 ),GWF ,ZERO    ,ZERO    ,W(1,131 ))    
      CALL JIOXXX(W(1,131 ),W(1,4   ),GAL ,ZERO    ,AWIDTH  ,W(1,132 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,132 ),GAL ,AMP(89  ))            
      CALL JIOXXX(W(1,131 ),W(1,4   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,133 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,133 ),GZL ,AMP(90  ))            
      CALL FVOXXX(W(1,4   ),W(1,130 ),GWF ,ZERO    ,ZERO    ,W(1,134 ))    
      CALL JIOXXX(W(1,5   ),W(1,134 ),GZN ,ZMASS   ,ZWIDTH  ,W(1,135 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,135 ),GZL ,AMP(91  ))            
      CALL JIOXXX(W(1,117 ),W(1,126 ),GAU ,ZERO    ,AWIDTH  ,W(1,136 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,136 ),GAL ,AMP(92  ))            
      CALL JIOXXX(W(1,117 ),W(1,126 ),GZU ,ZMASS   ,ZWIDTH  ,W(1,137 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,137 ),GZL ,AMP(93  ))            
      CALL JVVXXX(W(1,32  ),W(1,130 ),GWWA ,ZERO    ,AWIDTH  ,W(1,         
     &     138 ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,138 ),GAL ,AMP(94  ))            
      CALL JVVXXX(W(1,32  ),W(1,130 ),GWWZ ,ZMASS   ,ZWIDTH  ,W(1,         
     &     139 ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,139 ),GZL ,AMP(95  ))            
      CALL HVVXXX(W(1,32  ),W(1,130 ),GWWH ,HMASS   ,HWIDTH  ,W(1,         
     &     140 ))                                                          
      CALL IOSXXX(W(1,7   ),W(1,6   ),W(1,140 ),GHTAU ,AMP(96  ))          
      CALL IOVXXX(W(1,39  ),W(1,6   ),W(1,130 ),GWF ,AMP(97  ))            

      wwztens(mu) = -AMP(   1)-AMP(   2)-AMP(   3)-AMP(   4)-AMP(   5)
     &             -AMP(   6)-AMP(   7)-AMP(   8)-AMP(   9)-AMP(  10)
     &             -AMP(  11)-AMP(  12)-AMP(  13)-AMP(  14)-AMP(  15)
     &             -AMP(  16)-AMP(  17)-AMP(  18)-AMP(  19)-AMP(  20)
     &             -AMP(  21)-AMP(  22)-AMP(  23)-AMP(  24)-AMP(  25)
     &             -AMP(  26)-AMP(  27)-AMP(  28)-AMP(  29)-AMP(  30)
     &             -AMP(  31)-AMP(  32)-AMP(  33)-AMP(  34)-AMP(  35)
     &             -AMP(  36)-AMP(  37)-AMP(  38)-AMP(  39)-AMP(  40)
     &             -AMP(  41)-AMP(  42)-AMP(  43)-AMP(  44)-AMP(  45)
     &             -AMP(  46)-AMP(  47)-AMP(  48)-AMP(  49)-AMP(  50)
     &             -AMP(  51)-AMP(  52)-AMP(  53)-AMP(  54)-AMP(  55)
     &             -AMP(  56)-AMP(  57)-AMP(  58)-AMP(  59)-AMP(  60)
     &             -AMP(  61)-AMP(  62)-AMP(  63)-AMP(  64)-AMP(  65)
     &             -AMP(  66)-AMP(  67)-AMP(  68)-AMP(  69)-AMP(  70)
     &             -AMP(  71)-AMP(  72)-AMP(  73)-AMP(  74)-AMP(  75)
     &             -AMP(  76)-AMP(  77)-AMP(  78)-AMP(  79)-AMP(  80)
     &             -AMP(  81)-AMP(  82)-AMP(  83)-AMP(  84)-AMP(  85)
     &             -AMP(  86)-AMP(  87)-AMP(  88)-AMP(  89)-AMP(  90)
     &             -AMP(  91)-AMP(  92)-AMP(  93)-AMP(  94)-AMP(  95)
     &             -AMP(  96)-AMP(  97)

      elseif (procid.eq.WPWMhadZ) then

      CALL JIOXXX(W(1,3   ),W(1,2   ),GWF ,WMASS   ,WWIDTH  ,W(1,8   ))    
      CALL FVOXXX(W(1,4   ),W(1,8   ),GWF ,ZERO    ,ZERO    ,W(1,9   ))    
      CALL JIOXXX(W(1,5   ),W(1,9   ),GAU ,ZERO    ,AWIDTH  ,W(1,10  ))    
      CALL FVOXXX(W(1,6   ),W(1,10  ),GAL ,LMASS   ,ZERO    ,W(1,11  ))    
      CALL IOVXXX(W(1,7   ),W(1,11  ),W(1,1   ),GZL ,AMP(1   ))            
      CALL JIOXXX(W(1,5   ),W(1,9   ),GZU ,ZMASS   ,ZWIDTH  ,W(1,12  ))    
      CALL FVOXXX(W(1,6   ),W(1,12  ),GZL ,LMASS   ,ZERO    ,W(1,13  ))    
      CALL IOVXXX(W(1,7   ),W(1,13  ),W(1,1   ),GZL ,AMP(2   ))            
      CALL HVVXXX(W(1,12  ),W(1,1   ),GZZH ,HMASS   ,HWIDTH  ,W(1,         
     &     14  ))                                                          
      CALL IOSXXX(W(1,7   ),W(1,6   ),W(1,14  ),GHTAU ,AMP(3   ))          
      CALL FVIXXX(W(1,7   ),W(1,10  ),GAL ,LMASS   ,ZERO    ,W(1,15  ))    
      CALL IOVXXX(W(1,15  ),W(1,6   ),W(1,1   ),GZL ,AMP(4   ))            
      CALL FVIXXX(W(1,7   ),W(1,12  ),GZL ,LMASS   ,ZERO    ,W(1,16  ))    
      CALL IOVXXX(W(1,16  ),W(1,6   ),W(1,1   ),GZL ,AMP(5   ))            
      CALL FVIXXX(W(1,5   ),W(1,1   ),GZU ,ZERO    ,ZERO    ,W(1,17  ))    
      CALL JIOXXX(W(1,17  ),W(1,4   ),GWF ,WMASS   ,WWIDTH  ,W(1,18  ))    
      CALL FVIXXX(W(1,3   ),W(1,18  ),GWF ,ZERO    ,ZERO    ,W(1,19  ))    
      CALL JIOXXX(W(1,19  ),W(1,2   ),GZN ,ZMASS   ,ZWIDTH  ,W(1,20  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,20  ),GZL ,AMP(6   ))            
      CALL FVOXXX(W(1,2   ),W(1,18  ),GWF ,ZERO    ,ZERO    ,W(1,21  ))    
      CALL JIOXXX(W(1,3   ),W(1,21  ),GAL ,ZERO    ,AWIDTH  ,W(1,22  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,22  ),GAL ,AMP(7   ))            
      CALL JIOXXX(W(1,3   ),W(1,21  ),GZL ,ZMASS   ,ZWIDTH  ,W(1,23  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,23  ),GZL ,AMP(8   ))            
      CALL FVIXXX(W(1,17  ),W(1,8   ),GWF ,ZERO    ,ZERO    ,W(1,24  ))    
      CALL JIOXXX(W(1,24  ),W(1,4   ),GAD ,ZERO    ,AWIDTH  ,W(1,25  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,25  ),GAL ,AMP(9   ))            
      CALL JIOXXX(W(1,24  ),W(1,4   ),GZD ,ZMASS   ,ZWIDTH  ,W(1,26  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,26  ),GZL ,AMP(10  ))            
      CALL FVOXXX(W(1,9   ),W(1,1   ),GZU ,ZERO    ,ZERO    ,W(1,27  ))    
      CALL JIOXXX(W(1,5   ),W(1,27  ),GAU ,ZERO    ,AWIDTH  ,W(1,28  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,28  ),GAL ,AMP(11  ))            
      CALL JIOXXX(W(1,5   ),W(1,27  ),GZU ,ZMASS   ,ZWIDTH  ,W(1,29  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,29  ),GZL ,AMP(12  ))            
      CALL JVVXXX(W(1,18  ),W(1,8   ),GWWA ,ZERO    ,AWIDTH  ,W(1,         
     &     30  ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,30  ),GAL ,AMP(13  ))            
      CALL JVVXXX(W(1,18  ),W(1,8   ),GWWZ ,ZMASS   ,ZWIDTH  ,W(1,         
     &     31  ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,31  ),GZL ,AMP(14  ))            
      CALL HVVXXX(W(1,18  ),W(1,8   ),GWWH ,HMASS   ,HWIDTH  ,W(1,         
     &     32  ))                                                          
      CALL IOSXXX(W(1,7   ),W(1,6   ),W(1,32  ),GHTAU ,AMP(15  ))          
      CALL FVIXXX(W(1,7   ),W(1,18  ),GWF ,ZERO    ,ZERO    ,W(1,33  ))    
      CALL IOVXXX(W(1,33  ),W(1,6   ),W(1,8   ),GWF ,AMP(16  ))            
      CALL JIOXXX(W(1,17  ),W(1,9   ),GAU ,ZERO    ,AWIDTH  ,W(1,34  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,34  ),GAL ,AMP(17  ))            
      CALL JIOXXX(W(1,17  ),W(1,9   ),GZU ,ZMASS   ,ZWIDTH  ,W(1,35  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,35  ),GZL ,AMP(18  ))            
      CALL JIOXXX(W(1,5   ),W(1,4   ),GWF ,WMASS   ,WWIDTH  ,W(1,36  ))    
      CALL FVIXXX(W(1,7   ),W(1,1   ),GZL ,LMASS   ,ZERO    ,W(1,37  ))    
      CALL JVVXXX(W(1,36  ),W(1,8   ),GWWA ,ZERO    ,AWIDTH  ,W(1,         
     &     38  ))                                                          
      CALL IOVXXX(W(1,37  ),W(1,6   ),W(1,38  ),GAL ,AMP(19  ))            
      CALL JVVXXX(W(1,36  ),W(1,8   ),GWWZ ,ZMASS   ,ZWIDTH  ,W(1,         
     &     39  ))                                                          
      CALL IOVXXX(W(1,37  ),W(1,6   ),W(1,39  ),GZL ,AMP(20  ))            
      CALL HVVXXX(W(1,36  ),W(1,8   ),GWWH ,HMASS   ,HWIDTH  ,W(1,         
     &     40  ))                                                          
      CALL IOSXXX(W(1,37  ),W(1,6   ),W(1,40  ),GHTAU ,AMP(21  ))          
      CALL HVVXXX(W(1,39  ),W(1,1   ),GZZH ,HMASS   ,HWIDTH  ,W(1,         
     &     41  ))                                                          
      CALL IOSXXX(W(1,7   ),W(1,6   ),W(1,41  ),GHTAU ,AMP(22  ))          
      CALL JVSXXX(W(1,1   ),W(1,40  ),GZZH ,ZMASS   ,ZWIDTH  ,W(1,         
     &     42  ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,42  ),GZL ,AMP(23  ))            
      CALL FVIXXX(W(1,7   ),W(1,36  ),GWF ,ZERO    ,ZERO    ,W(1,43  ))    
      CALL FVIXXX(W(1,43  ),W(1,8   ),GWF ,LMASS   ,ZERO    ,W(1,44  ))    
      CALL IOVXXX(W(1,44  ),W(1,6   ),W(1,1   ),GZL ,AMP(24  ))            
      CALL FVIXXX(W(1,7   ),W(1,38  ),GAL ,LMASS   ,ZERO    ,W(1,45  ))    
      CALL IOVXXX(W(1,45  ),W(1,6   ),W(1,1   ),GZL ,AMP(25  ))            
      CALL FVIXXX(W(1,7   ),W(1,39  ),GZL ,LMASS   ,ZERO    ,W(1,46  ))    
      CALL IOVXXX(W(1,46  ),W(1,6   ),W(1,1   ),GZL ,AMP(26  ))            
      CALL FSIXXX(W(1,7   ),W(1,40  ),GHTAU ,LMASS   ,ZERO    ,W(1,        
     &     47  ))                                                          
      CALL IOVXXX(W(1,47  ),W(1,6   ),W(1,1   ),GZL ,AMP(27  ))            
      CALL JVVXXX(W(1,1   ),W(1,36  ),GWWZ ,WMASS   ,WWIDTH  ,W(1,         
     &     48  ))                                                          
      CALL FVIXXX(W(1,3   ),W(1,48  ),GWF ,ZERO    ,ZERO    ,W(1,49  ))    
      CALL JIOXXX(W(1,49  ),W(1,2   ),GZN ,ZMASS   ,ZWIDTH  ,W(1,50  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,50  ),GZL ,AMP(28  ))            
      CALL FVOXXX(W(1,2   ),W(1,48  ),GWF ,ZERO    ,ZERO    ,W(1,51  ))    
      CALL JIOXXX(W(1,3   ),W(1,51  ),GAL ,ZERO    ,AWIDTH  ,W(1,52  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,52  ),GAL ,AMP(29  ))            
      CALL JIOXXX(W(1,3   ),W(1,51  ),GZL ,ZMASS   ,ZWIDTH  ,W(1,53  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,53  ),GZL ,AMP(30  ))            
      CALL JVVXXX(W(1,8   ),W(1,1   ),GWWZ ,WMASS   ,WWIDTH  ,W(1,         
     &     54  ))                                                          
      CALL FVIXXX(W(1,5   ),W(1,54  ),GWF ,ZERO    ,ZERO    ,W(1,55  ))    
      CALL JIOXXX(W(1,55  ),W(1,4   ),GAD ,ZERO    ,AWIDTH  ,W(1,56  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,56  ),GAL ,AMP(31  ))            
      CALL JIOXXX(W(1,55  ),W(1,4   ),GZD ,ZMASS   ,ZWIDTH  ,W(1,57  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,57  ),GZL ,AMP(32  ))            
      CALL FVOXXX(W(1,4   ),W(1,54  ),GWF ,ZERO    ,ZERO    ,W(1,58  ))    
      CALL JIOXXX(W(1,5   ),W(1,58  ),GAU ,ZERO    ,AWIDTH  ,W(1,59  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,59  ),GAL ,AMP(33  ))            
      CALL JIOXXX(W(1,5   ),W(1,58  ),GZU ,ZMASS   ,ZWIDTH  ,W(1,60  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,60  ),GZL ,AMP(34  ))            
      CALL FVIXXX(W(1,37  ),W(1,36  ),GWF ,ZERO    ,ZERO    ,W(1,61  ))    
      CALL IOVXXX(W(1,61  ),W(1,6   ),W(1,8   ),GWF ,AMP(35  ))            
      CALL JVVXXX(W(1,48  ),W(1,8   ),GWWA ,ZERO    ,AWIDTH  ,W(1,         
     &     62  ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,62  ),GAL ,AMP(36  ))            
      CALL JVVXXX(W(1,48  ),W(1,8   ),GWWZ ,ZMASS   ,ZWIDTH  ,W(1,         
     &     63  ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,63  ),GZL ,AMP(37  ))            
      CALL HVVXXX(W(1,48  ),W(1,8   ),GWWH ,HMASS   ,HWIDTH  ,W(1,         
     &     64  ))                                                          
      CALL IOSXXX(W(1,7   ),W(1,6   ),W(1,64  ),GHTAU ,AMP(38  ))          
      CALL FVIXXX(W(1,7   ),W(1,48  ),GWF ,ZERO    ,ZERO    ,W(1,65  ))    
      CALL IOVXXX(W(1,65  ),W(1,6   ),W(1,8   ),GWF ,AMP(39  ))            
      CALL FVIXXX(W(1,43  ),W(1,1   ),GZN ,ZERO    ,ZERO    ,W(1,66  ))    
      CALL IOVXXX(W(1,66  ),W(1,6   ),W(1,8   ),GWF ,AMP(40  ))            
      CALL JVVXXX(W(1,36  ),W(1,54  ),GWWA ,ZERO    ,AWIDTH  ,W(1,         
     &     67  ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,67  ),GAL ,AMP(41  ))            
      CALL JVVXXX(W(1,36  ),W(1,54  ),GWWZ ,ZMASS   ,ZWIDTH  ,W(1,         
     &     68  ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,68  ),GZL ,AMP(42  ))            
      CALL HVVXXX(W(1,36  ),W(1,54  ),GWWH ,HMASS   ,HWIDTH  ,W(1,         
     &     69  ))                                                          
      CALL IOSXXX(W(1,7   ),W(1,6   ),W(1,69  ),GHTAU ,AMP(43  ))          
      CALL IOVXXX(W(1,43  ),W(1,6   ),W(1,54  ),GWF ,AMP(44  ))            
      CALL JW3WXX(W(1,36  ),W(1,1   ),W(1,8   ),GWWZ ,GWWA ,ZERO    ,      
     &     AWIDTH  ,W(1,70  ))                                             
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,70  ),GAL ,AMP(45  ))            
      CALL JW3WXX(W(1,36  ),W(1,1   ),W(1,8   ),GWWZ ,GWWZ ,ZMASS   ,      
     &     ZWIDTH  ,W(1,71  ))                                             
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,71  ),GZL ,AMP(46  ))            
      CALL FVIXXX(W(1,5   ),W(1,8   ),GWF ,ZERO    ,ZERO    ,W(1,72  ))    
      CALL JIOXXX(W(1,72  ),W(1,4   ),GAD ,ZERO    ,AWIDTH  ,W(1,73  ))    
      CALL IOVXXX(W(1,37  ),W(1,6   ),W(1,73  ),GAL ,AMP(47  ))            
      CALL JIOXXX(W(1,72  ),W(1,4   ),GZD ,ZMASS   ,ZWIDTH  ,W(1,74  ))    
      CALL IOVXXX(W(1,37  ),W(1,6   ),W(1,74  ),GZL ,AMP(48  ))            
      CALL HVVXXX(W(1,74  ),W(1,1   ),GZZH ,HMASS   ,HWIDTH  ,W(1,         
     &     75  ))                                                          
      CALL IOSXXX(W(1,7   ),W(1,6   ),W(1,75  ),GHTAU ,AMP(49  ))          
      CALL FVIXXX(W(1,7   ),W(1,73  ),GAL ,LMASS   ,ZERO    ,W(1,76  ))    
      CALL IOVXXX(W(1,76  ),W(1,6   ),W(1,1   ),GZL ,AMP(50  ))            
      CALL FVIXXX(W(1,7   ),W(1,74  ),GZL ,LMASS   ,ZERO    ,W(1,77  ))    
      CALL IOVXXX(W(1,77  ),W(1,6   ),W(1,1   ),GZL ,AMP(51  ))            
      CALL FVOXXX(W(1,4   ),W(1,1   ),GZD ,ZERO    ,ZERO    ,W(1,78  ))    
      CALL JIOXXX(W(1,5   ),W(1,78  ),GWF ,WMASS   ,WWIDTH  ,W(1,79  ))    
      CALL FVIXXX(W(1,3   ),W(1,79  ),GWF ,ZERO    ,ZERO    ,W(1,80  ))    
      CALL JIOXXX(W(1,80  ),W(1,2   ),GZN ,ZMASS   ,ZWIDTH  ,W(1,81  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,81  ),GZL ,AMP(52  ))            
      CALL FVOXXX(W(1,2   ),W(1,79  ),GWF ,ZERO    ,ZERO    ,W(1,82  ))    
      CALL JIOXXX(W(1,3   ),W(1,82  ),GAL ,ZERO    ,AWIDTH  ,W(1,83  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,83  ),GAL ,AMP(53  ))            
      CALL JIOXXX(W(1,3   ),W(1,82  ),GZL ,ZMASS   ,ZWIDTH  ,W(1,84  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,84  ),GZL ,AMP(54  ))            
      CALL FVIXXX(W(1,72  ),W(1,1   ),GZD ,ZERO    ,ZERO    ,W(1,85  ))    
      CALL JIOXXX(W(1,85  ),W(1,4   ),GAD ,ZERO    ,AWIDTH  ,W(1,86  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,86  ),GAL ,AMP(55  ))            
      CALL JIOXXX(W(1,85  ),W(1,4   ),GZD ,ZMASS   ,ZWIDTH  ,W(1,87  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,87  ),GZL ,AMP(56  ))            
      CALL FVOXXX(W(1,78  ),W(1,8   ),GWF ,ZERO    ,ZERO    ,W(1,88  ))    
      CALL JIOXXX(W(1,5   ),W(1,88  ),GAU ,ZERO    ,AWIDTH  ,W(1,89  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,89  ),GAL ,AMP(57  ))            
      CALL JIOXXX(W(1,5   ),W(1,88  ),GZU ,ZMASS   ,ZWIDTH  ,W(1,90  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,90  ),GZL ,AMP(58  ))            
      CALL JIOXXX(W(1,72  ),W(1,78  ),GAD ,ZERO    ,AWIDTH  ,W(1,91  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,91  ),GAL ,AMP(59  ))            
      CALL JIOXXX(W(1,72  ),W(1,78  ),GZD ,ZMASS   ,ZWIDTH  ,W(1,92  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,92  ),GZL ,AMP(60  ))            
      CALL JVVXXX(W(1,79  ),W(1,8   ),GWWA ,ZERO    ,AWIDTH  ,W(1,         
     &     93  ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,93  ),GAL ,AMP(61  ))            
      CALL JVVXXX(W(1,79  ),W(1,8   ),GWWZ ,ZMASS   ,ZWIDTH  ,W(1,         
     &     94  ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,94  ),GZL ,AMP(62  ))            
      CALL HVVXXX(W(1,79  ),W(1,8   ),GWWH ,HMASS   ,HWIDTH  ,W(1,         
     &     95  ))                                                          
      CALL IOSXXX(W(1,7   ),W(1,6   ),W(1,95  ),GHTAU ,AMP(63  ))          
      CALL FVIXXX(W(1,7   ),W(1,79  ),GWF ,ZERO    ,ZERO    ,W(1,96  ))    
      CALL IOVXXX(W(1,96  ),W(1,6   ),W(1,8   ),GWF ,AMP(64  ))            
      CALL FVOXXX(W(1,2   ),W(1,36  ),GWF ,ZERO    ,ZERO    ,W(1,97  ))    
      CALL JIOXXX(W(1,3   ),W(1,97  ),GAL ,ZERO    ,AWIDTH  ,W(1,98  ))    
      CALL IOVXXX(W(1,37  ),W(1,6   ),W(1,98  ),GAL ,AMP(65  ))            
      CALL JIOXXX(W(1,3   ),W(1,97  ),GZL ,ZMASS   ,ZWIDTH  ,W(1,99  ))    
      CALL IOVXXX(W(1,37  ),W(1,6   ),W(1,99  ),GZL ,AMP(66  ))            
      CALL HVVXXX(W(1,99  ),W(1,1   ),GZZH ,HMASS   ,HWIDTH  ,W(1,         
     &     100 ))                                                          
      CALL IOSXXX(W(1,7   ),W(1,6   ),W(1,100 ),GHTAU ,AMP(67  ))          
      CALL FVIXXX(W(1,7   ),W(1,98  ),GAL ,LMASS   ,ZERO    ,W(1,101 ))    
      CALL IOVXXX(W(1,101 ),W(1,6   ),W(1,1   ),GZL ,AMP(68  ))            
      CALL FVIXXX(W(1,7   ),W(1,99  ),GZL ,LMASS   ,ZERO    ,W(1,102 ))    
      CALL IOVXXX(W(1,102 ),W(1,6   ),W(1,1   ),GZL ,AMP(69  ))            
      CALL FVIXXX(W(1,3   ),W(1,1   ),GZL ,ZERO    ,ZERO    ,W(1,103 ))    
      CALL FVIXXX(W(1,103 ),W(1,36  ),GWF ,ZERO    ,ZERO    ,W(1,104 ))    
      CALL JIOXXX(W(1,104 ),W(1,2   ),GZN ,ZMASS   ,ZWIDTH  ,W(1,105 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,105 ),GZL ,AMP(70  ))            
      CALL FVOXXX(W(1,97  ),W(1,1   ),GZL ,ZERO    ,ZERO    ,W(1,106 ))    
      CALL JIOXXX(W(1,3   ),W(1,106 ),GAL ,ZERO    ,AWIDTH  ,W(1,107 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,107 ),GAL ,AMP(71  ))            
      CALL JIOXXX(W(1,3   ),W(1,106 ),GZL ,ZMASS   ,ZWIDTH  ,W(1,108 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,108 ),GZL ,AMP(72  ))            
      CALL JIOXXX(W(1,103 ),W(1,2   ),GWF ,WMASS   ,WWIDTH  ,W(1,109 ))    
      CALL FVIXXX(W(1,5   ),W(1,109 ),GWF ,ZERO    ,ZERO    ,W(1,110 ))    
      CALL JIOXXX(W(1,110 ),W(1,4   ),GAD ,ZERO    ,AWIDTH  ,W(1,111 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,111 ),GAL ,AMP(73  ))            
      CALL JIOXXX(W(1,110 ),W(1,4   ),GZD ,ZMASS   ,ZWIDTH  ,W(1,112 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,112 ),GZL ,AMP(74  ))            
      CALL FVOXXX(W(1,4   ),W(1,109 ),GWF ,ZERO    ,ZERO    ,W(1,113 ))    
      CALL JIOXXX(W(1,5   ),W(1,113 ),GAU ,ZERO    ,AWIDTH  ,W(1,114 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,114 ),GAL ,AMP(75  ))            
      CALL JIOXXX(W(1,5   ),W(1,113 ),GZU ,ZMASS   ,ZWIDTH  ,W(1,115 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,115 ),GZL ,AMP(76  ))            
      CALL JIOXXX(W(1,103 ),W(1,97  ),GAL ,ZERO    ,AWIDTH  ,W(1,116 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,116 ),GAL ,AMP(77  ))            
      CALL JIOXXX(W(1,103 ),W(1,97  ),GZL ,ZMASS   ,ZWIDTH  ,W(1,117 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,117 ),GZL ,AMP(78  ))            
      CALL JVVXXX(W(1,36  ),W(1,109 ),GWWA ,ZERO    ,AWIDTH  ,W(1,         
     &     118 ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,118 ),GAL ,AMP(79  ))            
      CALL JVVXXX(W(1,36  ),W(1,109 ),GWWZ ,ZMASS   ,ZWIDTH  ,W(1,         
     &     119 ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,119 ),GZL ,AMP(80  ))            
      CALL HVVXXX(W(1,36  ),W(1,109 ),GWWH ,HMASS   ,HWIDTH  ,W(1,         
     &     120 ))                                                          
      CALL IOSXXX(W(1,7   ),W(1,6   ),W(1,120 ),GHTAU ,AMP(81  ))          
      CALL IOVXXX(W(1,43  ),W(1,6   ),W(1,109 ),GWF ,AMP(82  ))            
      CALL FVIXXX(W(1,3   ),W(1,36  ),GWF ,ZERO    ,ZERO    ,W(1,121 ))    
      CALL JIOXXX(W(1,121 ),W(1,2   ),GZN ,ZMASS   ,ZWIDTH  ,W(1,122 ))    
      CALL IOVXXX(W(1,37  ),W(1,6   ),W(1,122 ),GZL ,AMP(83  ))            
      CALL HVVXXX(W(1,122 ),W(1,1   ),GZZH ,HMASS   ,HWIDTH  ,W(1,         
     &     123 ))                                                          
      CALL IOSXXX(W(1,7   ),W(1,6   ),W(1,123 ),GHTAU ,AMP(84  ))          
      CALL FVIXXX(W(1,7   ),W(1,122 ),GZL ,LMASS   ,ZERO    ,W(1,124 ))    
      CALL IOVXXX(W(1,124 ),W(1,6   ),W(1,1   ),GZL ,AMP(85  ))            
      CALL FVIXXX(W(1,121 ),W(1,1   ),GZN ,ZERO    ,ZERO    ,W(1,125 ))    
      CALL JIOXXX(W(1,125 ),W(1,2   ),GZN ,ZMASS   ,ZWIDTH  ,W(1,126 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,126 ),GZL ,AMP(86  ))            
      CALL FVOXXX(W(1,2   ),W(1,1   ),GZN ,ZERO    ,ZERO    ,W(1,127 ))    
      CALL FVOXXX(W(1,127 ),W(1,36  ),GWF ,ZERO    ,ZERO    ,W(1,128 ))    
      CALL JIOXXX(W(1,3   ),W(1,128 ),GAL ,ZERO    ,AWIDTH  ,W(1,129 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,129 ),GAL ,AMP(87  ))            
      CALL JIOXXX(W(1,3   ),W(1,128 ),GZL ,ZMASS   ,ZWIDTH  ,W(1,130 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,130 ),GZL ,AMP(88  ))            
      CALL JIOXXX(W(1,3   ),W(1,127 ),GWF ,WMASS   ,WWIDTH  ,W(1,131 ))    
      CALL FVIXXX(W(1,5   ),W(1,131 ),GWF ,ZERO    ,ZERO    ,W(1,132 ))    
      CALL JIOXXX(W(1,132 ),W(1,4   ),GAD ,ZERO    ,AWIDTH  ,W(1,133 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,133 ),GAL ,AMP(89  ))            
      CALL JIOXXX(W(1,132 ),W(1,4   ),GZD ,ZMASS   ,ZWIDTH  ,W(1,134 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,134 ),GZL ,AMP(90  ))            
      CALL FVOXXX(W(1,4   ),W(1,131 ),GWF ,ZERO    ,ZERO    ,W(1,135 ))    
      CALL JIOXXX(W(1,5   ),W(1,135 ),GAU ,ZERO    ,AWIDTH  ,W(1,136 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,136 ),GAL ,AMP(91  ))            
      CALL JIOXXX(W(1,5   ),W(1,135 ),GZU ,ZMASS   ,ZWIDTH  ,W(1,137 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,137 ),GZL ,AMP(92  ))            
      CALL JIOXXX(W(1,121 ),W(1,127 ),GZN ,ZMASS   ,ZWIDTH  ,W(1,138 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,138 ),GZL ,AMP(93  ))            
      CALL JVVXXX(W(1,36  ),W(1,131 ),GWWA ,ZERO    ,AWIDTH  ,W(1,         
     &     139 ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,139 ),GAL ,AMP(94  ))            
      CALL JVVXXX(W(1,36  ),W(1,131 ),GWWZ ,ZMASS   ,ZWIDTH  ,W(1,         
     &     140 ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,140 ),GZL ,AMP(95  ))            
      CALL HVVXXX(W(1,36  ),W(1,131 ),GWWH ,HMASS   ,HWIDTH  ,W(1,         
     &     141 ))                                                          
      CALL IOSXXX(W(1,7   ),W(1,6   ),W(1,141 ),GHTAU ,AMP(96  ))          
      CALL IOVXXX(W(1,43  ),W(1,6   ),W(1,131 ),GWF ,AMP(97  ))            

      wwztens(mu) = -AMP(   1)-AMP(   2)-AMP(   3)-AMP(   4)-AMP(   5)
     &             -AMP(   6)-AMP(   7)-AMP(   8)-AMP(   9)-AMP(  10)
     &             -AMP(  11)-AMP(  12)-AMP(  13)-AMP(  14)-AMP(  15)
     &             -AMP(  16)-AMP(  17)-AMP(  18)-AMP(  19)-AMP(  20)
     &             -AMP(  21)-AMP(  22)-AMP(  23)-AMP(  24)-AMP(  25)
     &             -AMP(  26)-AMP(  27)-AMP(  28)-AMP(  29)-AMP(  30)
     &             -AMP(  31)-AMP(  32)-AMP(  33)-AMP(  34)-AMP(  35)
     &             -AMP(  36)-AMP(  37)-AMP(  38)-AMP(  39)-AMP(  40)
     &             -AMP(  41)-AMP(  42)-AMP(  43)-AMP(  44)-AMP(  45)
     &             -AMP(  46)-AMP(  47)-AMP(  48)-AMP(  49)-AMP(  50)
     &             -AMP(  51)-AMP(  52)-AMP(  53)-AMP(  54)-AMP(  55)
     &             -AMP(  56)-AMP(  57)-AMP(  58)-AMP(  59)-AMP(  60)
     &             -AMP(  61)-AMP(  62)-AMP(  63)-AMP(  64)-AMP(  65)
     &             -AMP(  66)-AMP(  67)-AMP(  68)-AMP(  69)-AMP(  70)
     &             -AMP(  71)-AMP(  72)-AMP(  73)-AMP(  74)-AMP(  75)
     &             -AMP(  76)-AMP(  77)-AMP(  78)-AMP(  79)-AMP(  80)
     &             -AMP(  81)-AMP(  82)-AMP(  83)-AMP(  84)-AMP(  85)
     &             -AMP(  86)-AMP(  87)-AMP(  88)-AMP(  89)-AMP(  90)
     &             -AMP(  91)-AMP(  92)-AMP(  93)-AMP(  94)-AMP(  95)
     &             -AMP(  96)-AMP(  97)

      elseif (procid.eq.WWZhad .and. Ztodd) then

      CALL JIOXXX(W(1,3   ),W(1,2   ),GWF ,WMASS   ,WWIDTH  ,W(1,8   ))    
      CALL FVOXXX(W(1,4   ),W(1,8   ),GWF ,ZERO    ,ZERO    ,W(1,9   ))    
      CALL JIOXXX(W(1,5   ),W(1,9   ),GZN ,ZMASS   ,ZWIDTH  ,W(1,10  ))    
      CALL FVOXXX(W(1,6   ),W(1,10  ),GZD ,ZERO    ,ZERO    ,W(1,11  ))    
      CALL IOVXXX(W(1,7   ),W(1,11  ),W(1,1   ),GZD ,AMP(1   ))            
      CALL FVIXXX(W(1,7   ),W(1,10  ),GZD ,ZERO    ,ZERO    ,W(1,12  ))    
      CALL IOVXXX(W(1,12  ),W(1,6   ),W(1,1   ),GZD ,AMP(2   ))            
      CALL FVIXXX(W(1,5   ),W(1,1   ),GZN ,ZERO    ,ZERO    ,W(1,13  ))    
      CALL JIOXXX(W(1,13  ),W(1,4   ),GWF ,WMASS   ,WWIDTH  ,W(1,14  ))    
      CALL FVIXXX(W(1,3   ),W(1,14  ),GWF ,ZERO    ,ZERO    ,W(1,15  ))    
      CALL JIOXXX(W(1,15  ),W(1,2   ),GZN ,ZMASS   ,ZWIDTH  ,W(1,16  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,16  ),GZD ,AMP(3   ))            
      CALL FVOXXX(W(1,2   ),W(1,14  ),GWF ,ZERO    ,ZERO    ,W(1,17  ))    
      CALL JIOXXX(W(1,3   ),W(1,17  ),GAL ,ZERO    ,AWIDTH  ,W(1,18  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,18  ),GAD ,AMP(4   ))            
      CALL JIOXXX(W(1,3   ),W(1,17  ),GZL ,ZMASS   ,ZWIDTH  ,W(1,19  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,19  ),GZD ,AMP(5   ))            
      CALL FVIXXX(W(1,13  ),W(1,8   ),GWF ,ZERO    ,ZERO    ,W(1,20  ))    
      CALL JIOXXX(W(1,20  ),W(1,4   ),GAL ,ZERO    ,AWIDTH  ,W(1,21  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,21  ),GAD ,AMP(6   ))            
      CALL JIOXXX(W(1,20  ),W(1,4   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,22  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,22  ),GZD ,AMP(7   ))            
      CALL FVOXXX(W(1,9   ),W(1,1   ),GZN ,ZERO    ,ZERO    ,W(1,23  ))    
      CALL JIOXXX(W(1,5   ),W(1,23  ),GZN ,ZMASS   ,ZWIDTH  ,W(1,24  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,24  ),GZD ,AMP(8   ))            
      CALL JVVXXX(W(1,14  ),W(1,8   ),GWWA ,ZERO    ,AWIDTH  ,W(1,         
     &     25  ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,25  ),GAD ,AMP(9   ))            
      CALL JVVXXX(W(1,14  ),W(1,8   ),GWWZ ,ZMASS   ,ZWIDTH  ,W(1,         
     &     26  ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,26  ),GZD ,AMP(10  ))            
      CALL FVIXXX(W(1,7   ),W(1,14  ),GWF ,ZERO    ,ZERO    ,W(1,27  ))    
      CALL IOVXXX(W(1,27  ),W(1,6   ),W(1,8   ),GWF ,AMP(11  ))            
      CALL JIOXXX(W(1,13  ),W(1,9   ),GZN ,ZMASS   ,ZWIDTH  ,W(1,28  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,28  ),GZD ,AMP(12  ))            
      CALL JIOXXX(W(1,5   ),W(1,4   ),GWF ,WMASS   ,WWIDTH  ,W(1,29  ))    
      CALL FVIXXX(W(1,7   ),W(1,1   ),GZD ,ZERO    ,ZERO    ,W(1,30  ))    
      CALL JVVXXX(W(1,29  ),W(1,8   ),GWWA ,ZERO    ,AWIDTH  ,W(1,         
     &     31  ))                                                          
      CALL IOVXXX(W(1,30  ),W(1,6   ),W(1,31  ),GAD ,AMP(13  ))            
      CALL JVVXXX(W(1,29  ),W(1,8   ),GWWZ ,ZMASS   ,ZWIDTH  ,W(1,         
     &     32  ))                                                          
      CALL IOVXXX(W(1,30  ),W(1,6   ),W(1,32  ),GZD ,AMP(14  ))            
      CALL HVVXXX(W(1,29  ),W(1,8   ),GWWH ,HMASS   ,HWIDTH  ,W(1,         
     &     33  ))                                                          
      CALL JVSXXX(W(1,1   ),W(1,33  ),GZZH ,ZMASS   ,ZWIDTH  ,W(1,         
     &     34  ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,34  ),GZD ,AMP(15  ))            
      CALL FVIXXX(W(1,7   ),W(1,29  ),GWF ,ZERO    ,ZERO    ,W(1,35  ))    
      CALL FVIXXX(W(1,35  ),W(1,8   ),GWF ,ZERO    ,ZERO    ,W(1,36  ))    
      CALL IOVXXX(W(1,36  ),W(1,6   ),W(1,1   ),GZD ,AMP(16  ))            
      CALL FVIXXX(W(1,7   ),W(1,31  ),GAD ,ZERO    ,ZERO    ,W(1,37  ))    
      CALL IOVXXX(W(1,37  ),W(1,6   ),W(1,1   ),GZD ,AMP(17  ))            
      CALL FVIXXX(W(1,7   ),W(1,32  ),GZD ,ZERO    ,ZERO    ,W(1,38  ))    
      CALL IOVXXX(W(1,38  ),W(1,6   ),W(1,1   ),GZD ,AMP(18  ))            
      CALL JVVXXX(W(1,1   ),W(1,29  ),GWWZ ,WMASS   ,WWIDTH  ,W(1,         
     &     39  ))                                                          
      CALL FVIXXX(W(1,3   ),W(1,39  ),GWF ,ZERO    ,ZERO    ,W(1,40  ))    
      CALL JIOXXX(W(1,40  ),W(1,2   ),GZN ,ZMASS   ,ZWIDTH  ,W(1,41  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,41  ),GZD ,AMP(19  ))            
      CALL FVOXXX(W(1,2   ),W(1,39  ),GWF ,ZERO    ,ZERO    ,W(1,42  ))    
      CALL JIOXXX(W(1,3   ),W(1,42  ),GAL ,ZERO    ,AWIDTH  ,W(1,43  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,43  ),GAD ,AMP(20  ))            
      CALL JIOXXX(W(1,3   ),W(1,42  ),GZL ,ZMASS   ,ZWIDTH  ,W(1,44  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,44  ),GZD ,AMP(21  ))            
      CALL JVVXXX(W(1,8   ),W(1,1   ),GWWZ ,WMASS   ,WWIDTH  ,W(1,         
     &     45  ))                                                          
      CALL FVIXXX(W(1,5   ),W(1,45  ),GWF ,ZERO    ,ZERO    ,W(1,46  ))    
      CALL JIOXXX(W(1,46  ),W(1,4   ),GAL ,ZERO    ,AWIDTH  ,W(1,47  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,47  ),GAD ,AMP(22  ))            
      CALL JIOXXX(W(1,46  ),W(1,4   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,48  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,48  ),GZD ,AMP(23  ))            
      CALL FVOXXX(W(1,4   ),W(1,45  ),GWF ,ZERO    ,ZERO    ,W(1,49  ))    
      CALL JIOXXX(W(1,5   ),W(1,49  ),GZN ,ZMASS   ,ZWIDTH  ,W(1,50  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,50  ),GZD ,AMP(24  ))            
      CALL FVIXXX(W(1,30  ),W(1,29  ),GWF ,ZERO    ,ZERO    ,W(1,51  ))    
      CALL IOVXXX(W(1,51  ),W(1,6   ),W(1,8   ),GWF ,AMP(25  ))            
      CALL JVVXXX(W(1,39  ),W(1,8   ),GWWA ,ZERO    ,AWIDTH  ,W(1,         
     &     52  ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,52  ),GAD ,AMP(26  ))            
      CALL JVVXXX(W(1,39  ),W(1,8   ),GWWZ ,ZMASS   ,ZWIDTH  ,W(1,         
     &     53  ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,53  ),GZD ,AMP(27  ))            
      CALL FVIXXX(W(1,7   ),W(1,39  ),GWF ,ZERO    ,ZERO    ,W(1,54  ))    
      CALL IOVXXX(W(1,54  ),W(1,6   ),W(1,8   ),GWF ,AMP(28  ))            
      CALL FVIXXX(W(1,35  ),W(1,1   ),GZU ,ZERO    ,ZERO    ,W(1,55  ))    
      CALL IOVXXX(W(1,55  ),W(1,6   ),W(1,8   ),GWF ,AMP(29  ))            
      CALL JVVXXX(W(1,29  ),W(1,45  ),GWWA ,ZERO    ,AWIDTH  ,W(1,         
     &     56  ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,56  ),GAD ,AMP(30  ))            
      CALL JVVXXX(W(1,29  ),W(1,45  ),GWWZ ,ZMASS   ,ZWIDTH  ,W(1,         
     &     57  ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,57  ),GZD ,AMP(31  ))            
      CALL IOVXXX(W(1,35  ),W(1,6   ),W(1,45  ),GWF ,AMP(32  ))            
      CALL JW3WXX(W(1,29  ),W(1,1   ),W(1,8   ),GWWZ ,GWWA ,ZERO    ,      
     &     AWIDTH  ,W(1,58  ))                                             
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,58  ),GAD ,AMP(33  ))            
      CALL JW3WXX(W(1,29  ),W(1,1   ),W(1,8   ),GWWZ ,GWWZ ,ZMASS   ,      
     &     ZWIDTH  ,W(1,59  ))                                             
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,59  ),GZD ,AMP(34  ))            
      CALL FVIXXX(W(1,5   ),W(1,8   ),GWF ,ZERO    ,ZERO    ,W(1,60  ))    
      CALL JIOXXX(W(1,60  ),W(1,4   ),GAL ,ZERO    ,AWIDTH  ,W(1,61  ))    
      CALL IOVXXX(W(1,30  ),W(1,6   ),W(1,61  ),GAD ,AMP(35  ))            
      CALL JIOXXX(W(1,60  ),W(1,4   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,62  ))    
      CALL IOVXXX(W(1,30  ),W(1,6   ),W(1,62  ),GZD ,AMP(36  ))            
      CALL FVIXXX(W(1,7   ),W(1,61  ),GAD ,ZERO    ,ZERO    ,W(1,63  ))    
      CALL IOVXXX(W(1,63  ),W(1,6   ),W(1,1   ),GZD ,AMP(37  ))            
      CALL FVIXXX(W(1,7   ),W(1,62  ),GZD ,ZERO    ,ZERO    ,W(1,64  ))    
      CALL IOVXXX(W(1,64  ),W(1,6   ),W(1,1   ),GZD ,AMP(38  ))            
      CALL FVOXXX(W(1,4   ),W(1,1   ),GZL ,ZERO    ,ZERO    ,W(1,65  ))    
      CALL JIOXXX(W(1,5   ),W(1,65  ),GWF ,WMASS   ,WWIDTH  ,W(1,66  ))    
      CALL FVIXXX(W(1,3   ),W(1,66  ),GWF ,ZERO    ,ZERO    ,W(1,67  ))    
      CALL JIOXXX(W(1,67  ),W(1,2   ),GZN ,ZMASS   ,ZWIDTH  ,W(1,68  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,68  ),GZD ,AMP(39  ))            
      CALL FVOXXX(W(1,2   ),W(1,66  ),GWF ,ZERO    ,ZERO    ,W(1,69  ))    
      CALL JIOXXX(W(1,3   ),W(1,69  ),GAL ,ZERO    ,AWIDTH  ,W(1,70  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,70  ),GAD ,AMP(40  ))            
      CALL JIOXXX(W(1,3   ),W(1,69  ),GZL ,ZMASS   ,ZWIDTH  ,W(1,71  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,71  ),GZD ,AMP(41  ))            
      CALL FVIXXX(W(1,60  ),W(1,1   ),GZL ,ZERO    ,ZERO    ,W(1,72  ))    
      CALL JIOXXX(W(1,72  ),W(1,4   ),GAL ,ZERO    ,AWIDTH  ,W(1,73  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,73  ),GAD ,AMP(42  ))            
      CALL JIOXXX(W(1,72  ),W(1,4   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,74  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,74  ),GZD ,AMP(43  ))            
      CALL FVOXXX(W(1,65  ),W(1,8   ),GWF ,ZERO    ,ZERO    ,W(1,75  ))    
      CALL JIOXXX(W(1,5   ),W(1,75  ),GZN ,ZMASS   ,ZWIDTH  ,W(1,76  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,76  ),GZD ,AMP(44  ))            
      CALL JIOXXX(W(1,60  ),W(1,65  ),GAL ,ZERO    ,AWIDTH  ,W(1,77  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,77  ),GAD ,AMP(45  ))            
      CALL JIOXXX(W(1,60  ),W(1,65  ),GZL ,ZMASS   ,ZWIDTH  ,W(1,78  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,78  ),GZD ,AMP(46  ))            
      CALL JVVXXX(W(1,66  ),W(1,8   ),GWWA ,ZERO    ,AWIDTH  ,W(1,         
     &     79  ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,79  ),GAD ,AMP(47  ))            
      CALL JVVXXX(W(1,66  ),W(1,8   ),GWWZ ,ZMASS   ,ZWIDTH  ,W(1,         
     &     80  ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,80  ),GZD ,AMP(48  ))            
      CALL FVIXXX(W(1,7   ),W(1,66  ),GWF ,ZERO    ,ZERO    ,W(1,81  ))    
      CALL IOVXXX(W(1,81  ),W(1,6   ),W(1,8   ),GWF ,AMP(49  ))            
      CALL FVOXXX(W(1,2   ),W(1,29  ),GWF ,ZERO    ,ZERO    ,W(1,82  ))    
      CALL JIOXXX(W(1,3   ),W(1,82  ),GAL ,ZERO    ,AWIDTH  ,W(1,83  ))    
      CALL IOVXXX(W(1,30  ),W(1,6   ),W(1,83  ),GAD ,AMP(50  ))            
      CALL JIOXXX(W(1,3   ),W(1,82  ),GZL ,ZMASS   ,ZWIDTH  ,W(1,84  ))    
      CALL IOVXXX(W(1,30  ),W(1,6   ),W(1,84  ),GZD ,AMP(51  ))            
      CALL FVIXXX(W(1,7   ),W(1,83  ),GAD ,ZERO    ,ZERO    ,W(1,85  ))    
      CALL IOVXXX(W(1,85  ),W(1,6   ),W(1,1   ),GZD ,AMP(52  ))            
      CALL FVIXXX(W(1,7   ),W(1,84  ),GZD ,ZERO    ,ZERO    ,W(1,86  ))    
      CALL IOVXXX(W(1,86  ),W(1,6   ),W(1,1   ),GZD ,AMP(53  ))            
      CALL FVIXXX(W(1,3   ),W(1,1   ),GZL ,ZERO    ,ZERO    ,W(1,87  ))    
      CALL FVIXXX(W(1,87  ),W(1,29  ),GWF ,ZERO    ,ZERO    ,W(1,88  ))    
      CALL JIOXXX(W(1,88  ),W(1,2   ),GZN ,ZMASS   ,ZWIDTH  ,W(1,89  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,89  ),GZD ,AMP(54  ))            
      CALL FVOXXX(W(1,82  ),W(1,1   ),GZL ,ZERO    ,ZERO    ,W(1,90  ))    
      CALL JIOXXX(W(1,3   ),W(1,90  ),GAL ,ZERO    ,AWIDTH  ,W(1,91  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,91  ),GAD ,AMP(55  ))            
      CALL JIOXXX(W(1,3   ),W(1,90  ),GZL ,ZMASS   ,ZWIDTH  ,W(1,92  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,92  ),GZD ,AMP(56  ))            
      CALL JIOXXX(W(1,87  ),W(1,2   ),GWF ,WMASS   ,WWIDTH  ,W(1,93  ))    
      CALL FVIXXX(W(1,5   ),W(1,93  ),GWF ,ZERO    ,ZERO    ,W(1,94  ))    
      CALL JIOXXX(W(1,94  ),W(1,4   ),GAL ,ZERO    ,AWIDTH  ,W(1,95  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,95  ),GAD ,AMP(57  ))            
      CALL JIOXXX(W(1,94  ),W(1,4   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,96  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,96  ),GZD ,AMP(58  ))            
      CALL FVOXXX(W(1,4   ),W(1,93  ),GWF ,ZERO    ,ZERO    ,W(1,97  ))    
      CALL JIOXXX(W(1,5   ),W(1,97  ),GZN ,ZMASS   ,ZWIDTH  ,W(1,98  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,98  ),GZD ,AMP(59  ))            
      CALL JIOXXX(W(1,87  ),W(1,82  ),GAL ,ZERO    ,AWIDTH  ,W(1,99  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,99  ),GAD ,AMP(60  ))            
      CALL JIOXXX(W(1,87  ),W(1,82  ),GZL ,ZMASS   ,ZWIDTH  ,W(1,100 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,100 ),GZD ,AMP(61  ))            
      CALL JVVXXX(W(1,29  ),W(1,93  ),GWWA ,ZERO    ,AWIDTH  ,W(1,         
     &     101 ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,101 ),GAD ,AMP(62  ))            
      CALL JVVXXX(W(1,29  ),W(1,93  ),GWWZ ,ZMASS   ,ZWIDTH  ,W(1,         
     &     102 ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,102 ),GZD ,AMP(63  ))            
      CALL IOVXXX(W(1,35  ),W(1,6   ),W(1,93  ),GWF ,AMP(64  ))            
      CALL FVIXXX(W(1,3   ),W(1,29  ),GWF ,ZERO    ,ZERO    ,W(1,103 ))    
      CALL JIOXXX(W(1,103 ),W(1,2   ),GZN ,ZMASS   ,ZWIDTH  ,W(1,104 ))    
      CALL IOVXXX(W(1,30  ),W(1,6   ),W(1,104 ),GZD ,AMP(65  ))            
      CALL FVIXXX(W(1,7   ),W(1,104 ),GZD ,ZERO    ,ZERO    ,W(1,105 ))    
      CALL IOVXXX(W(1,105 ),W(1,6   ),W(1,1   ),GZD ,AMP(66  ))            
      CALL FVIXXX(W(1,103 ),W(1,1   ),GZN ,ZERO    ,ZERO    ,W(1,106 ))    
      CALL JIOXXX(W(1,106 ),W(1,2   ),GZN ,ZMASS   ,ZWIDTH  ,W(1,107 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,107 ),GZD ,AMP(67  ))            
      CALL FVOXXX(W(1,2   ),W(1,1   ),GZN ,ZERO    ,ZERO    ,W(1,108 ))    
      CALL FVOXXX(W(1,108 ),W(1,29  ),GWF ,ZERO    ,ZERO    ,W(1,109 ))    
      CALL JIOXXX(W(1,3   ),W(1,109 ),GAL ,ZERO    ,AWIDTH  ,W(1,110 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,110 ),GAD ,AMP(68  ))            
      CALL JIOXXX(W(1,3   ),W(1,109 ),GZL ,ZMASS   ,ZWIDTH  ,W(1,111 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,111 ),GZD ,AMP(69  ))            
      CALL JIOXXX(W(1,3   ),W(1,108 ),GWF ,WMASS   ,WWIDTH  ,W(1,112 ))    
      CALL FVIXXX(W(1,5   ),W(1,112 ),GWF ,ZERO    ,ZERO    ,W(1,113 ))    
      CALL JIOXXX(W(1,113 ),W(1,4   ),GAL ,ZERO    ,AWIDTH  ,W(1,114 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,114 ),GAD ,AMP(70  ))            
      CALL JIOXXX(W(1,113 ),W(1,4   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,115 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,115 ),GZD ,AMP(71  ))            
      CALL FVOXXX(W(1,4   ),W(1,112 ),GWF ,ZERO    ,ZERO    ,W(1,116 ))    
      CALL JIOXXX(W(1,5   ),W(1,116 ),GZN ,ZMASS   ,ZWIDTH  ,W(1,117 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,117 ),GZD ,AMP(72  ))            
      CALL JIOXXX(W(1,103 ),W(1,108 ),GZN ,ZMASS   ,ZWIDTH  ,W(1,118 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,118 ),GZD ,AMP(73  ))            
      CALL JVVXXX(W(1,29  ),W(1,112 ),GWWA ,ZERO    ,AWIDTH  ,W(1,         
     &     119 ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,119 ),GAD ,AMP(74  ))            
      CALL JVVXXX(W(1,29  ),W(1,112 ),GWWZ ,ZMASS   ,ZWIDTH  ,W(1,         
     &     120 ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,120 ),GZD ,AMP(75  ))            
      CALL IOVXXX(W(1,35  ),W(1,6   ),W(1,112 ),GWF ,AMP(76  ))            

      wwztens(mu) = -AMP(   1)-AMP(   2)-AMP(   3)-AMP(   4)-AMP(   5)
     &             -AMP(   6)-AMP(   7)-AMP(   8)-AMP(   9)-AMP(  10)
     &             -AMP(  11)-AMP(  12)-AMP(  13)-AMP(  14)-AMP(  15)
     &             -AMP(  16)-AMP(  17)-AMP(  18)-AMP(  19)-AMP(  20)
     &             -AMP(  21)-AMP(  22)-AMP(  23)-AMP(  24)-AMP(  25)
     &             -AMP(  26)-AMP(  27)-AMP(  28)-AMP(  29)-AMP(  30)
     &             -AMP(  31)-AMP(  32)-AMP(  33)-AMP(  34)-AMP(  35)
     &             -AMP(  36)-AMP(  37)-AMP(  38)-AMP(  39)-AMP(  40)
     &             -AMP(  41)-AMP(  42)-AMP(  43)-AMP(  44)-AMP(  45)
     &             -AMP(  46)-AMP(  47)-AMP(  48)-AMP(  49)-AMP(  50)
     &             -AMP(  51)-AMP(  52)-AMP(  53)-AMP(  54)-AMP(  55)
     &             -AMP(  56)-AMP(  57)-AMP(  58)-AMP(  59)-AMP(  60)
     &             -AMP(  61)-AMP(  62)-AMP(  63)-AMP(  64)-AMP(  65)
     &             -AMP(  66)-AMP(  67)-AMP(  68)-AMP(  69)-AMP(  70)
     &             -AMP(  71)-AMP(  72)-AMP(  73)-AMP(  74)-AMP(  75)
     &             -AMP(  76)

      elseif (procid.eq.WWZhad .and. Ztouu) then

      CALL JIOXXX(W(1,3   ),W(1,2   ),GWF ,WMASS   ,WWIDTH  ,W(1,8   ))    
      CALL FVOXXX(W(1,4   ),W(1,8   ),GWF ,ZERO    ,ZERO    ,W(1,9   ))    
      CALL JIOXXX(W(1,5   ),W(1,9   ),GZN ,ZMASS   ,ZWIDTH  ,W(1,10  ))    
      CALL FVOXXX(W(1,6   ),W(1,10  ),GZU ,ZERO    ,ZERO    ,W(1,11  ))    
      CALL IOVXXX(W(1,7   ),W(1,11  ),W(1,1   ),GZU ,AMP(1   ))            
      CALL FVIXXX(W(1,7   ),W(1,10  ),GZU ,ZERO    ,ZERO    ,W(1,12  ))    
      CALL IOVXXX(W(1,12  ),W(1,6   ),W(1,1   ),GZU ,AMP(2   ))            
      CALL FVIXXX(W(1,5   ),W(1,1   ),GZN ,ZERO    ,ZERO    ,W(1,13  ))    
      CALL JIOXXX(W(1,13  ),W(1,4   ),GWF ,WMASS   ,WWIDTH  ,W(1,14  ))    
      CALL FVIXXX(W(1,3   ),W(1,14  ),GWF ,ZERO    ,ZERO    ,W(1,15  ))    
      CALL JIOXXX(W(1,15  ),W(1,2   ),GZN ,ZMASS   ,ZWIDTH  ,W(1,16  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,16  ),GZU ,AMP(3   ))            
      CALL FVOXXX(W(1,2   ),W(1,14  ),GWF ,ZERO    ,ZERO    ,W(1,17  ))    
      CALL JIOXXX(W(1,3   ),W(1,17  ),GAL ,ZERO    ,AWIDTH  ,W(1,18  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,18  ),GAU ,AMP(4   ))            
      CALL JIOXXX(W(1,3   ),W(1,17  ),GZL ,ZMASS   ,ZWIDTH  ,W(1,19  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,19  ),GZU ,AMP(5   ))            
      CALL FVIXXX(W(1,13  ),W(1,8   ),GWF ,ZERO    ,ZERO    ,W(1,20  ))    
      CALL JIOXXX(W(1,20  ),W(1,4   ),GAL ,ZERO    ,AWIDTH  ,W(1,21  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,21  ),GAU ,AMP(6   ))            
      CALL JIOXXX(W(1,20  ),W(1,4   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,22  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,22  ),GZU ,AMP(7   ))            
      CALL FVOXXX(W(1,9   ),W(1,1   ),GZN ,ZERO    ,ZERO    ,W(1,23  ))    
      CALL JIOXXX(W(1,5   ),W(1,23  ),GZN ,ZMASS   ,ZWIDTH  ,W(1,24  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,24  ),GZU ,AMP(8   ))            
      CALL JVVXXX(W(1,14  ),W(1,8   ),GWWA ,ZERO    ,AWIDTH  ,W(1,         
     &     25  ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,25  ),GAU ,AMP(9   ))            
      CALL JVVXXX(W(1,14  ),W(1,8   ),GWWZ ,ZMASS   ,ZWIDTH  ,W(1,         
     &     26  ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,26  ),GZU ,AMP(10  ))            
      CALL FVIXXX(W(1,7   ),W(1,8   ),GWF ,ZERO    ,ZERO    ,W(1,27  ))    
      CALL IOVXXX(W(1,27  ),W(1,6   ),W(1,14  ),GWF ,AMP(11  ))            
      CALL JIOXXX(W(1,13  ),W(1,9   ),GZN ,ZMASS   ,ZWIDTH  ,W(1,28  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,28  ),GZU ,AMP(12  ))            
      CALL JIOXXX(W(1,5   ),W(1,4   ),GWF ,WMASS   ,WWIDTH  ,W(1,29  ))    
      CALL FVIXXX(W(1,7   ),W(1,1   ),GZU ,ZERO    ,ZERO    ,W(1,30  ))    
      CALL JVVXXX(W(1,29  ),W(1,8   ),GWWA ,ZERO    ,AWIDTH  ,W(1,         
     &     31  ))                                                          
      CALL IOVXXX(W(1,30  ),W(1,6   ),W(1,31  ),GAU ,AMP(13  ))            
      CALL JVVXXX(W(1,29  ),W(1,8   ),GWWZ ,ZMASS   ,ZWIDTH  ,W(1,         
     &     32  ))                                                          
      CALL IOVXXX(W(1,30  ),W(1,6   ),W(1,32  ),GZU ,AMP(14  ))            
      CALL HVVXXX(W(1,29  ),W(1,8   ),GWWH ,HMASS   ,HWIDTH  ,W(1,         
     &     33  ))                                                          
      CALL JVSXXX(W(1,1   ),W(1,33  ),GZZH ,ZMASS   ,ZWIDTH  ,W(1,         
     &     34  ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,34  ),GZU ,AMP(15  ))            
      CALL FVIXXX(W(1,27  ),W(1,29  ),GWF ,ZERO    ,ZERO    ,W(1,35  ))    
      CALL IOVXXX(W(1,35  ),W(1,6   ),W(1,1   ),GZU ,AMP(16  ))            
      CALL FVIXXX(W(1,7   ),W(1,31  ),GAU ,ZERO    ,ZERO    ,W(1,36  ))    
      CALL IOVXXX(W(1,36  ),W(1,6   ),W(1,1   ),GZU ,AMP(17  ))            
      CALL FVIXXX(W(1,7   ),W(1,32  ),GZU ,ZERO    ,ZERO    ,W(1,37  ))    
      CALL IOVXXX(W(1,37  ),W(1,6   ),W(1,1   ),GZU ,AMP(18  ))            
      CALL JVVXXX(W(1,1   ),W(1,29  ),GWWZ ,WMASS   ,WWIDTH  ,W(1,         
     &     38  ))                                                          
      CALL FVIXXX(W(1,3   ),W(1,38  ),GWF ,ZERO    ,ZERO    ,W(1,39  ))    
      CALL JIOXXX(W(1,39  ),W(1,2   ),GZN ,ZMASS   ,ZWIDTH  ,W(1,40  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,40  ),GZU ,AMP(19  ))            
      CALL FVOXXX(W(1,2   ),W(1,38  ),GWF ,ZERO    ,ZERO    ,W(1,41  ))    
      CALL JIOXXX(W(1,3   ),W(1,41  ),GAL ,ZERO    ,AWIDTH  ,W(1,42  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,42  ),GAU ,AMP(20  ))            
      CALL JIOXXX(W(1,3   ),W(1,41  ),GZL ,ZMASS   ,ZWIDTH  ,W(1,43  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,43  ),GZU ,AMP(21  ))            
      CALL JVVXXX(W(1,8   ),W(1,1   ),GWWZ ,WMASS   ,WWIDTH  ,W(1,         
     &     44  ))                                                          
      CALL FVIXXX(W(1,5   ),W(1,44  ),GWF ,ZERO    ,ZERO    ,W(1,45  ))    
      CALL JIOXXX(W(1,45  ),W(1,4   ),GAL ,ZERO    ,AWIDTH  ,W(1,46  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,46  ),GAU ,AMP(22  ))            
      CALL JIOXXX(W(1,45  ),W(1,4   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,47  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,47  ),GZU ,AMP(23  ))            
      CALL FVOXXX(W(1,4   ),W(1,44  ),GWF ,ZERO    ,ZERO    ,W(1,48  ))    
      CALL JIOXXX(W(1,5   ),W(1,48  ),GZN ,ZMASS   ,ZWIDTH  ,W(1,49  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,49  ),GZU ,AMP(24  ))            
      CALL JVVXXX(W(1,38  ),W(1,8   ),GWWA ,ZERO    ,AWIDTH  ,W(1,         
     &     50  ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,50  ),GAU ,AMP(25  ))            
      CALL JVVXXX(W(1,38  ),W(1,8   ),GWWZ ,ZMASS   ,ZWIDTH  ,W(1,         
     &     51  ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,51  ),GZU ,AMP(26  ))            
      CALL IOVXXX(W(1,27  ),W(1,6   ),W(1,38  ),GWF ,AMP(27  ))            
      CALL FVIXXX(W(1,30  ),W(1,8   ),GWF ,ZERO    ,ZERO    ,W(1,52  ))    
      CALL IOVXXX(W(1,52  ),W(1,6   ),W(1,29  ),GWF ,AMP(28  ))            
      CALL JVVXXX(W(1,29  ),W(1,44  ),GWWA ,ZERO    ,AWIDTH  ,W(1,         
     &     53  ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,53  ),GAU ,AMP(29  ))            
      CALL JVVXXX(W(1,29  ),W(1,44  ),GWWZ ,ZMASS   ,ZWIDTH  ,W(1,         
     &     54  ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,54  ),GZU ,AMP(30  ))            
      CALL FVIXXX(W(1,27  ),W(1,1   ),GZD ,ZERO    ,ZERO    ,W(1,55  ))    
      CALL IOVXXX(W(1,55  ),W(1,6   ),W(1,29  ),GWF ,AMP(31  ))            
      CALL FVIXXX(W(1,7   ),W(1,44  ),GWF ,ZERO    ,ZERO    ,W(1,56  ))    
      CALL IOVXXX(W(1,56  ),W(1,6   ),W(1,29  ),GWF ,AMP(32  ))            
      CALL JW3WXX(W(1,29  ),W(1,1   ),W(1,8   ),GWWZ ,GWWA ,ZERO    ,      
     &     AWIDTH  ,W(1,57  ))                                             
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,57  ),GAU ,AMP(33  ))            
      CALL JW3WXX(W(1,29  ),W(1,1   ),W(1,8   ),GWWZ ,GWWZ ,ZMASS   ,      
     &     ZWIDTH  ,W(1,58  ))                                             
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,58  ),GZU ,AMP(34  ))            
      CALL FVIXXX(W(1,5   ),W(1,8   ),GWF ,ZERO    ,ZERO    ,W(1,59  ))    
      CALL JIOXXX(W(1,59  ),W(1,4   ),GAL ,ZERO    ,AWIDTH  ,W(1,60  ))    
      CALL IOVXXX(W(1,30  ),W(1,6   ),W(1,60  ),GAU ,AMP(35  ))            
      CALL JIOXXX(W(1,59  ),W(1,4   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,61  ))    
      CALL IOVXXX(W(1,30  ),W(1,6   ),W(1,61  ),GZU ,AMP(36  ))            
      CALL FVIXXX(W(1,7   ),W(1,60  ),GAU ,ZERO    ,ZERO    ,W(1,62  ))    
      CALL IOVXXX(W(1,62  ),W(1,6   ),W(1,1   ),GZU ,AMP(37  ))            
      CALL FVIXXX(W(1,7   ),W(1,61  ),GZU ,ZERO    ,ZERO    ,W(1,63  ))    
      CALL IOVXXX(W(1,63  ),W(1,6   ),W(1,1   ),GZU ,AMP(38  ))            
      CALL FVOXXX(W(1,4   ),W(1,1   ),GZL ,ZERO    ,ZERO    ,W(1,64  ))    
      CALL JIOXXX(W(1,5   ),W(1,64  ),GWF ,WMASS   ,WWIDTH  ,W(1,65  ))    
      CALL FVIXXX(W(1,3   ),W(1,65  ),GWF ,ZERO    ,ZERO    ,W(1,66  ))    
      CALL JIOXXX(W(1,66  ),W(1,2   ),GZN ,ZMASS   ,ZWIDTH  ,W(1,67  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,67  ),GZU ,AMP(39  ))            
      CALL FVOXXX(W(1,2   ),W(1,65  ),GWF ,ZERO    ,ZERO    ,W(1,68  ))    
      CALL JIOXXX(W(1,3   ),W(1,68  ),GAL ,ZERO    ,AWIDTH  ,W(1,69  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,69  ),GAU ,AMP(40  ))            
      CALL JIOXXX(W(1,3   ),W(1,68  ),GZL ,ZMASS   ,ZWIDTH  ,W(1,70  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,70  ),GZU ,AMP(41  ))            
      CALL FVIXXX(W(1,59  ),W(1,1   ),GZL ,ZERO    ,ZERO    ,W(1,71  ))    
      CALL JIOXXX(W(1,71  ),W(1,4   ),GAL ,ZERO    ,AWIDTH  ,W(1,72  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,72  ),GAU ,AMP(42  ))            
      CALL JIOXXX(W(1,71  ),W(1,4   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,73  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,73  ),GZU ,AMP(43  ))            
      CALL FVOXXX(W(1,64  ),W(1,8   ),GWF ,ZERO    ,ZERO    ,W(1,74  ))    
      CALL JIOXXX(W(1,5   ),W(1,74  ),GZN ,ZMASS   ,ZWIDTH  ,W(1,75  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,75  ),GZU ,AMP(44  ))            
      CALL JIOXXX(W(1,59  ),W(1,64  ),GAL ,ZERO    ,AWIDTH  ,W(1,76  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,76  ),GAU ,AMP(45  ))            
      CALL JIOXXX(W(1,59  ),W(1,64  ),GZL ,ZMASS   ,ZWIDTH  ,W(1,77  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,77  ),GZU ,AMP(46  ))            
      CALL JVVXXX(W(1,65  ),W(1,8   ),GWWA ,ZERO    ,AWIDTH  ,W(1,         
     &     78  ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,78  ),GAU ,AMP(47  ))            
      CALL JVVXXX(W(1,65  ),W(1,8   ),GWWZ ,ZMASS   ,ZWIDTH  ,W(1,         
     &     79  ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,79  ),GZU ,AMP(48  ))            
      CALL IOVXXX(W(1,27  ),W(1,6   ),W(1,65  ),GWF ,AMP(49  ))            
      CALL FVOXXX(W(1,2   ),W(1,29  ),GWF ,ZERO    ,ZERO    ,W(1,80  ))    
      CALL JIOXXX(W(1,3   ),W(1,80  ),GAL ,ZERO    ,AWIDTH  ,W(1,81  ))    
      CALL IOVXXX(W(1,30  ),W(1,6   ),W(1,81  ),GAU ,AMP(50  ))            
      CALL JIOXXX(W(1,3   ),W(1,80  ),GZL ,ZMASS   ,ZWIDTH  ,W(1,82  ))    
      CALL IOVXXX(W(1,30  ),W(1,6   ),W(1,82  ),GZU ,AMP(51  ))            
      CALL FVIXXX(W(1,7   ),W(1,81  ),GAU ,ZERO    ,ZERO    ,W(1,83  ))    
      CALL IOVXXX(W(1,83  ),W(1,6   ),W(1,1   ),GZU ,AMP(52  ))            
      CALL FVIXXX(W(1,7   ),W(1,82  ),GZU ,ZERO    ,ZERO    ,W(1,84  ))    
      CALL IOVXXX(W(1,84  ),W(1,6   ),W(1,1   ),GZU ,AMP(53  ))            
      CALL FVIXXX(W(1,3   ),W(1,1   ),GZL ,ZERO    ,ZERO    ,W(1,85  ))    
      CALL FVIXXX(W(1,85  ),W(1,29  ),GWF ,ZERO    ,ZERO    ,W(1,86  ))    
      CALL JIOXXX(W(1,86  ),W(1,2   ),GZN ,ZMASS   ,ZWIDTH  ,W(1,87  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,87  ),GZU ,AMP(54  ))            
      CALL FVOXXX(W(1,80  ),W(1,1   ),GZL ,ZERO    ,ZERO    ,W(1,88  ))    
      CALL JIOXXX(W(1,3   ),W(1,88  ),GAL ,ZERO    ,AWIDTH  ,W(1,89  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,89  ),GAU ,AMP(55  ))            
      CALL JIOXXX(W(1,3   ),W(1,88  ),GZL ,ZMASS   ,ZWIDTH  ,W(1,90  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,90  ),GZU ,AMP(56  ))            
      CALL JIOXXX(W(1,85  ),W(1,2   ),GWF ,WMASS   ,WWIDTH  ,W(1,91  ))    
      CALL FVIXXX(W(1,5   ),W(1,91  ),GWF ,ZERO    ,ZERO    ,W(1,92  ))    
      CALL JIOXXX(W(1,92  ),W(1,4   ),GAL ,ZERO    ,AWIDTH  ,W(1,93  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,93  ),GAU ,AMP(57  ))            
      CALL JIOXXX(W(1,92  ),W(1,4   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,94  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,94  ),GZU ,AMP(58  ))            
      CALL FVOXXX(W(1,4   ),W(1,91  ),GWF ,ZERO    ,ZERO    ,W(1,95  ))    
      CALL JIOXXX(W(1,5   ),W(1,95  ),GZN ,ZMASS   ,ZWIDTH  ,W(1,96  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,96  ),GZU ,AMP(59  ))            
      CALL JIOXXX(W(1,85  ),W(1,80  ),GAL ,ZERO    ,AWIDTH  ,W(1,97  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,97  ),GAU ,AMP(60  ))            
      CALL JIOXXX(W(1,85  ),W(1,80  ),GZL ,ZMASS   ,ZWIDTH  ,W(1,98  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,98  ),GZU ,AMP(61  ))            
      CALL JVVXXX(W(1,29  ),W(1,91  ),GWWA ,ZERO    ,AWIDTH  ,W(1,         
     &     99  ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,99  ),GAU ,AMP(62  ))            
      CALL JVVXXX(W(1,29  ),W(1,91  ),GWWZ ,ZMASS   ,ZWIDTH  ,W(1,         
     &     100 ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,100 ),GZU ,AMP(63  ))            
      CALL FVIXXX(W(1,7   ),W(1,91  ),GWF ,ZERO    ,ZERO    ,W(1,101 ))    
      CALL IOVXXX(W(1,101 ),W(1,6   ),W(1,29  ),GWF ,AMP(64  ))            
      CALL FVIXXX(W(1,3   ),W(1,29  ),GWF ,ZERO    ,ZERO    ,W(1,102 ))    
      CALL JIOXXX(W(1,102 ),W(1,2   ),GZN ,ZMASS   ,ZWIDTH  ,W(1,103 ))    
      CALL IOVXXX(W(1,30  ),W(1,6   ),W(1,103 ),GZU ,AMP(65  ))            
      CALL FVIXXX(W(1,7   ),W(1,103 ),GZU ,ZERO    ,ZERO    ,W(1,104 ))    
      CALL IOVXXX(W(1,104 ),W(1,6   ),W(1,1   ),GZU ,AMP(66  ))            
      CALL FVIXXX(W(1,102 ),W(1,1   ),GZN ,ZERO    ,ZERO    ,W(1,105 ))    
      CALL JIOXXX(W(1,105 ),W(1,2   ),GZN ,ZMASS   ,ZWIDTH  ,W(1,106 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,106 ),GZU ,AMP(67  ))            
      CALL FVOXXX(W(1,2   ),W(1,1   ),GZN ,ZERO    ,ZERO    ,W(1,107 ))    
      CALL FVOXXX(W(1,107 ),W(1,29  ),GWF ,ZERO    ,ZERO    ,W(1,108 ))    
      CALL JIOXXX(W(1,3   ),W(1,108 ),GAL ,ZERO    ,AWIDTH  ,W(1,109 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,109 ),GAU ,AMP(68  ))            
      CALL JIOXXX(W(1,3   ),W(1,108 ),GZL ,ZMASS   ,ZWIDTH  ,W(1,110 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,110 ),GZU ,AMP(69  ))            
      CALL JIOXXX(W(1,3   ),W(1,107 ),GWF ,WMASS   ,WWIDTH  ,W(1,111 ))    
      CALL FVIXXX(W(1,5   ),W(1,111 ),GWF ,ZERO    ,ZERO    ,W(1,112 ))    
      CALL JIOXXX(W(1,112 ),W(1,4   ),GAL ,ZERO    ,AWIDTH  ,W(1,113 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,113 ),GAU ,AMP(70  ))            
      CALL JIOXXX(W(1,112 ),W(1,4   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,114 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,114 ),GZU ,AMP(71  ))            
      CALL FVOXXX(W(1,4   ),W(1,111 ),GWF ,ZERO    ,ZERO    ,W(1,115 ))    
      CALL JIOXXX(W(1,5   ),W(1,115 ),GZN ,ZMASS   ,ZWIDTH  ,W(1,116 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,116 ),GZU ,AMP(72  ))            
      CALL JIOXXX(W(1,102 ),W(1,107 ),GZN ,ZMASS   ,ZWIDTH  ,W(1,117 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,117 ),GZU ,AMP(73  ))            
      CALL JVVXXX(W(1,29  ),W(1,111 ),GWWA ,ZERO    ,AWIDTH  ,W(1,         
     &     118 ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,118 ),GAU ,AMP(74  ))            
      CALL JVVXXX(W(1,29  ),W(1,111 ),GWWZ ,ZMASS   ,ZWIDTH  ,W(1,         
     &     119 ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,119 ),GZU ,AMP(75  ))            
      CALL FVIXXX(W(1,7   ),W(1,111 ),GWF ,ZERO    ,ZERO    ,W(1,120 ))    
      CALL IOVXXX(W(1,120 ),W(1,6   ),W(1,29  ),GWF ,AMP(76  ))            

      wwztens(mu) = -AMP(   1)-AMP(   2)-AMP(   3)-AMP(   4)-AMP(   5)
     &             -AMP(   6)-AMP(   7)-AMP(   8)-AMP(   9)-AMP(  10)
     &             -AMP(  11)-AMP(  12)-AMP(  13)-AMP(  14)-AMP(  15)
     &             -AMP(  16)-AMP(  17)-AMP(  18)-AMP(  19)-AMP(  20)
     &             -AMP(  21)-AMP(  22)-AMP(  23)-AMP(  24)-AMP(  25)
     &             -AMP(  26)-AMP(  27)-AMP(  28)-AMP(  29)-AMP(  30)
     &             -AMP(  31)-AMP(  32)-AMP(  33)-AMP(  34)-AMP(  35)
     &             -AMP(  36)-AMP(  37)-AMP(  38)-AMP(  39)-AMP(  40)
     &             -AMP(  41)-AMP(  42)-AMP(  43)-AMP(  44)-AMP(  45)
     &             -AMP(  46)-AMP(  47)-AMP(  48)-AMP(  49)-AMP(  50)
     &             -AMP(  51)-AMP(  52)-AMP(  53)-AMP(  54)-AMP(  55)
     &             -AMP(  56)-AMP(  57)-AMP(  58)-AMP(  59)-AMP(  60)
     &             -AMP(  61)-AMP(  62)-AMP(  63)-AMP(  64)-AMP(  65)
     &             -AMP(  66)-AMP(  67)-AMP(  68)-AMP(  69)-AMP(  70)
     &             -AMP(  71)-AMP(  72)-AMP(  73)-AMP(  74)-AMP(  75)
     &             -AMP(  76)

      else

      wwztens(mu) = dcmplx(0.,0.)

      endif

      enddo
      wwztens(4) = dcmplx(q(0),q(3))
      wwztens(5) = dcmplx(q(1),q(2))

      END



      subroutine TRIBOSZtoWW_mg_had(P,N,z,NW)
C  
C Generated by MadGraph II Version 3.0. Updated 02/19/04                
C RETURNS AMPLITUDE SQUARED SUMMED/AVG OVER COLORS
C FOR THE POINT WITH EXTERNAL LINES W(0:6,NEXTERNAL)
C  
C FOR PROCESS : z -> ve e+ mu- vm~  
C  
      IMPLICIT NONE
C  
C CONSTANTS
C  
      INTEGER    NGRAPHS
      PARAMETER (NGRAPHS=   5) 
      INTEGER    NWAVEFUNCS
      PARAMETER (NWAVEFUNCS=  13) 
      DOUBLE PRECISION     ZERO
      PARAMETER (ZERO=0D0)
C  
C ARGUMENTS 
C  
      INTEGER N
      DOUBLE PRECISION Q(0:3), P(0:3,2:5)
      complex*16 z(0:5)
      integer NW ! = 0: all diagrams, = 1: no non resonant diagrams
C  
C LOCAL VARIABLES 
C  
      INTEGER I,J, mu
      COMPLEX*16 AMP(NGRAPHS)
      COMPLEX*16 W(6,NWAVEFUNCS)
      INTEGER NHEL(2:5), ihel
      DATA (NHEL(IHEL),IHEL=2,5) / -1,+1,-1,+1/
      Save NHEL
      complex*16 amptest
c  lepton spinors and W+- polarization vectors

#include "tensor.inc"

      logical lswitch
      parameter (lswitch=.true.)

C  
C GLOBAL VARIABLES
C  
#include "VBFNLO/utilities/coupl.inc"
#include "VBFNLO/utilities/global.inc"
#include "VBFNLO/utilities/coupl_haddecay.inc"
#include "VBFNLO/utilities/process.inc"
C                                                                          
C ----------
C BEGIN CODE
C ----------    
  
      if (lswitch) then      ! read in lepton an W states from common block
         do i =1,6
            w(i,2) = wve(i,N)
            w(i,3) = wep(i,N)
            w(i,4) = wmu(i,N)
            w(i,5) = wvm(i,N)
         enddo
      endif

      do mu = 0,3
         q(mu) = p(mu,2)+p(mu,3)+p(mu,4)+p(mu,5)
      enddo

      do mu = 0,3
      CALL TRIBOSVCARTX(Q(0     ),ZMASS ,Zwidth,MU,-1,W(1,1   )) 

      if (procid.eq.WPhadWMZ) then

      CALL JIOXXX(W(1,3   ),W(1,2   ),GWF ,WMASS   ,WWIDTH  ,W(1,6   ))    
      CALL FVOXXX(W(1,4   ),W(1,6   ),GWF ,ZERO    ,ZERO    ,W(1,7   ))    
      CALL IOVXXX(W(1,5   ),W(1,7   ),W(1,1   ),GZN ,AMP(1   ))            
      CALL JVVXXX(W(1,6   ),W(1,1   ),GWWZ ,WMASS   ,WWIDTH  ,W(1,         
     &     8   ))                                                          
      CALL IOVXXX(W(1,5   ),W(1,4   ),W(1,8   ),GWF ,AMP(2   ))            
      CALL FVOXXX(W(1,4   ),W(1,1   ),GZL ,ZERO    ,ZERO    ,W(1,9   ))    
      CALL IOVXXX(W(1,5   ),W(1,9   ),W(1,6   ),GWF ,AMP(3   ))            
      CALL FVIXXX(W(1,3   ),W(1,1   ),GZD ,ZERO    ,ZERO    ,W(1,10  ))    
      CALL JIOXXX(W(1,10  ),W(1,2   ),GWF ,WMASS   ,WWIDTH  ,W(1,11  ))    
      CALL IOVXXX(W(1,5   ),W(1,4   ),W(1,11  ),GWF ,AMP(4   ))            
      CALL FVOXXX(W(1,2   ),W(1,1   ),GZU ,ZERO    ,ZERO    ,W(1,12  ))    
      CALL JIOXXX(W(1,3   ),W(1,12  ),GWF ,WMASS   ,WWIDTH  ,W(1,13  ))    
      CALL IOVXXX(W(1,5   ),W(1,4   ),W(1,13  ),GWF ,AMP(5   ))            

         z(mu) = +AMP(   2)
     &           +AMP(   1)+AMP(   3)+AMP(   4)+AMP(   5) !non resonant

      elseif (procid.eq.WPWMhadZ) then

      CALL JIOXXX(W(1,3   ),W(1,2   ),GWF ,WMASS   ,WWIDTH  ,W(1,6   ))    
      CALL FVOXXX(W(1,4   ),W(1,6   ),GWF ,ZERO    ,ZERO    ,W(1,7   ))    
      CALL IOVXXX(W(1,5   ),W(1,7   ),W(1,1   ),GZU ,AMP(1   ))            
      CALL JVVXXX(W(1,6   ),W(1,1   ),GWWZ ,WMASS   ,WWIDTH  ,W(1,         
     &     8   ))                                                          
      CALL IOVXXX(W(1,5   ),W(1,4   ),W(1,8   ),GWF ,AMP(2   ))            
      CALL FVOXXX(W(1,4   ),W(1,1   ),GZD ,ZERO    ,ZERO    ,W(1,9   ))    
      CALL IOVXXX(W(1,5   ),W(1,9   ),W(1,6   ),GWF ,AMP(3   ))            
      CALL FVIXXX(W(1,3   ),W(1,1   ),GZL ,ZERO    ,ZERO    ,W(1,10  ))    
      CALL JIOXXX(W(1,10  ),W(1,2   ),GWF ,WMASS   ,WWIDTH  ,W(1,11  ))    
      CALL IOVXXX(W(1,5   ),W(1,4   ),W(1,11  ),GWF ,AMP(4   ))            
      CALL FVOXXX(W(1,2   ),W(1,1   ),GZN ,ZERO    ,ZERO    ,W(1,12  ))    
      CALL JIOXXX(W(1,3   ),W(1,12  ),GWF ,WMASS   ,WWIDTH  ,W(1,13  ))    
      CALL IOVXXX(W(1,5   ),W(1,4   ),W(1,13  ),GWF ,AMP(5   ))            

      z(mu) = +AMP(   1)+AMP(   2)+AMP(   3)+AMP(   4)+AMP(   5)

      else

      CALL JIOXXX(W(1,3   ),W(1,2   ),GWF ,WMASS   ,WWIDTH  ,W(1,6   ))    
      CALL FVOXXX(W(1,4   ),W(1,6   ),GWF ,ZERO    ,ZERO    ,W(1,7   ))    
      CALL IOVXXX(W(1,5   ),W(1,7   ),W(1,1   ),GZN ,AMP(1   ))            
      CALL JVVXXX(W(1,6   ),W(1,1   ),GWWZ ,WMASS   ,WWIDTH  ,W(1,         
     &     8   ))                                                          
      CALL IOVXXX(W(1,5   ),W(1,4   ),W(1,8   ),GWF ,AMP(2   ))            
      CALL FVOXXX(W(1,4   ),W(1,1   ),GZL ,ZERO    ,ZERO    ,W(1,9   ))    
      CALL IOVXXX(W(1,5   ),W(1,9   ),W(1,6   ),GWF ,AMP(3   ))            
      CALL FVIXXX(W(1,3   ),W(1,1   ),GZL ,ZERO    ,ZERO    ,W(1,10  ))    
      CALL JIOXXX(W(1,10  ),W(1,2   ),GWF ,WMASS   ,WWIDTH  ,W(1,11  ))    
      CALL IOVXXX(W(1,5   ),W(1,4   ),W(1,11  ),GWF ,AMP(4   ))            
      CALL FVOXXX(W(1,2   ),W(1,1   ),GZN ,ZERO    ,ZERO    ,W(1,12  ))    
      CALL JIOXXX(W(1,3   ),W(1,12  ),GWF ,WMASS   ,WWIDTH  ,W(1,13  ))    
      CALL IOVXXX(W(1,5   ),W(1,4   ),W(1,13  ),GWF ,AMP(5   ))            

      z(mu) = +AMP(   1)+AMP(   2)+AMP(   3)+AMP(   4)+AMP(   5)

      endif

      enddo
      z(4) = dcmplx(q(0),q(3))
      z(5) = dcmplx(q(1),q(2))
c
      return
      END

c---------------------------------------------------------------------

      subroutine TRIBOSAtoWW_mg_had(P,N,a, NW)
C  
C Generated by MadGraph II Version 3.0. Updated 02/19/04                
C RETURNS AMPLITUDE SQUARED SUMMED/AVG OVER COLORS
C FOR THE POINT WITH EXTERNAL LINES W(0:6,NEXTERNAL)
C  
C FOR PROCESS : a -> ve e+ mu- vm~  
C  
      IMPLICIT NONE
C  
C CONSTANTS
C  
      INTEGER    NGRAPHS
      PARAMETER (NGRAPHS=   4) 
      INTEGER    NWAVEFUNCS
      PARAMETER (NWAVEFUNCS=  12) 
      DOUBLE PRECISION     ZERO
      PARAMETER (ZERO=0D0)
C  
C ARGUMENTS 
C  
      INTEGER N
      DOUBLE PRECISION Q(0:3), P(0:3,2:5)
      complex*16 a(0:5)
      INTEGER NW ! = 0: all diagrams, = 1: no non resonant diagrams
C  
C LOCAL VARIABLES 
C
      INTEGER I,J, mu
      COMPLEX*16 AMP(NGRAPHS)
      COMPLEX*16 W(6,NWAVEFUNCS)
      INTEGER NHEL(2:5), ihel
      DATA (NHEL(IHEL),IHEL=2,5) /-1,+1,-1,+1/
      Save NHEL
c  lepton spinors and W+- polarization vectors
#include "tensor.inc"

      logical lswitch
      parameter (lswitch=.true.)
C  
C GLOBAL VARIABLES
C  
#include "VBFNLO/utilities/coupl.inc"
#include "VBFNLO/utilities/global.inc"
#include "VBFNLO/utilities/coupl_haddecay.inc"
#include "VBFNLO/utilities/process.inc"
C                                                                          
C ----------
C BEGIN CODE
C ----------
      if (lswitch) then      ! read in lepton an W states from common block
         do i=1,6
            w(i,2) = wve(i,N)
            w(i,3) = wep(i,N)
            w(i,4) = wmu(i,N)
            w(i,5) = wvm(i,N)
         enddo
      endif

      do mu = 0,3
         q(mu) = p(mu,2)+p(mu,3)+p(mu,4)+p(mu,5)
      enddo

      do mu = 0,3
      CALL TRIBOSVCARTX(Q(0),ZERO ,ZERO, MU,-1,W(1,1   ))

      if (procid.eq.WPhadWMZ) then

      CALL JIOXXX(W(1,3   ),W(1,2   ),GWF ,WMASS   ,WWIDTH  ,W(1,6   ))    
      CALL JVVXXX(W(1,6   ),W(1,1   ),GWWA ,WMASS   ,WWIDTH  ,W(1,         
     &     7   ))                                                          
      CALL IOVXXX(W(1,5   ),W(1,4   ),W(1,7   ),GWF ,AMP(1   ))            
      CALL FVOXXX(W(1,4   ),W(1,1   ),GAL ,ZERO    ,ZERO    ,W(1,8   ))    
      CALL IOVXXX(W(1,5   ),W(1,8   ),W(1,6   ),GWF ,AMP(2   ))            
      CALL FVIXXX(W(1,3   ),W(1,1   ),GAD ,ZERO    ,ZERO    ,W(1,9   ))    
      CALL JIOXXX(W(1,9   ),W(1,2   ),GWF ,WMASS   ,WWIDTH  ,W(1,10  ))    
      CALL IOVXXX(W(1,5   ),W(1,4   ),W(1,10  ),GWF ,AMP(3   ))            
      CALL FVOXXX(W(1,2   ),W(1,1   ),GAU ,ZERO    ,ZERO    ,W(1,11  ))    
      CALL JIOXXX(W(1,3   ),W(1,11  ),GWF ,WMASS   ,WWIDTH  ,W(1,12  ))    
      CALL IOVXXX(W(1,5   ),W(1,4   ),W(1,12  ),GWF ,AMP(4   ))            

         a(mu) = +AMP(   1)+AMP(   4)+AMP(   2)+AMP(   3)

      elseif (procid.eq.WPWMhadZ) then

      CALL JIOXXX(W(1,3   ),W(1,2   ),GWF ,WMASS   ,WWIDTH  ,W(1,6   ))    
      CALL FVOXXX(W(1,4   ),W(1,6   ),GWF ,ZERO    ,ZERO    ,W(1,7   ))    
      CALL IOVXXX(W(1,5   ),W(1,7   ),W(1,1   ),GAU ,AMP(1   ))            
      CALL JVVXXX(W(1,6   ),W(1,1   ),GWWA ,WMASS   ,WWIDTH  ,W(1,         
     &     8   ))                                                          
      CALL IOVXXX(W(1,5   ),W(1,4   ),W(1,8   ),GWF ,AMP(2   ))            
      CALL FVOXXX(W(1,4   ),W(1,1   ),GAD ,ZERO    ,ZERO    ,W(1,9   ))    
      CALL IOVXXX(W(1,5   ),W(1,9   ),W(1,6   ),GWF ,AMP(3   ))            
      CALL FVIXXX(W(1,3   ),W(1,1   ),GAL ,ZERO    ,ZERO    ,W(1,10  ))    
      CALL JIOXXX(W(1,10  ),W(1,2   ),GWF ,WMASS   ,WWIDTH  ,W(1,11  ))    
      CALL IOVXXX(W(1,5   ),W(1,4   ),W(1,11  ),GWF ,AMP(4   ))            

      a(mu) = +AMP(   1)+AMP(   2)+AMP(   3)+AMP(   4)

      else

      CALL JIOXXX(W(1,3   ),W(1,2   ),GWF ,WMASS   ,WWIDTH  ,W(1,6   ))    
      CALL JVVXXX(W(1,6   ),W(1,1   ),GWWA ,WMASS   ,WWIDTH  ,W(1,         
     &     7   ))                                                          
      CALL IOVXXX(W(1,5   ),W(1,4   ),W(1,7   ),GWF ,AMP(1   ))            
      CALL FVOXXX(W(1,4   ),W(1,1   ),GAL ,ZERO    ,ZERO    ,W(1,8   ))    
      CALL IOVXXX(W(1,5   ),W(1,8   ),W(1,6   ),GWF ,AMP(2   ))            
      CALL FVIXXX(W(1,3   ),W(1,1   ),GAL ,ZERO    ,ZERO    ,W(1,9   ))    
      CALL JIOXXX(W(1,9   ),W(1,2   ),GWF ,WMASS   ,WWIDTH  ,W(1,10  ))    
      CALL IOVXXX(W(1,5   ),W(1,4   ),W(1,10  ),GWF ,AMP(3   ))            

      a(mu) = +AMP(   1)+AMP(   2)+AMP(   3)

      endif

      enddo
      a(4) = dcmplx(q(0),q(3))
      a(5) = dcmplx(q(1),q(2))
c
      END



      SUBROUTINE WMTOWZ_mg_had(v,N,h,wmztens,NW)

      IMPLICIT NONE

      DOUBLE PRECISION P(0:3,2:5), v(0:3,6)
      complex*16 wmztens(0:5)
      integer lsign(2:5,2),ll,mu,h,N
      integer NW ! = 0: all diagrams, = 1: no non resonant diagrams

      ! possible lepton helicities:
      data (lsign(ll,1),ll=2,5) / -1, -1, -1, -1/  !h=1
      data (lsign(ll,2),ll=2,5) / -1, -1, +1, +1/  !h=2

      do mu = 0,3
         P(mu,2) = v(mu,3)
         P(mu,3) = v(mu,4)
         P(mu,4) = v(mu,5)
         P(mu,5) = v(mu,6)
      enddo

      call WMTOWZ1_mg_had(P,N,lsign(2,h),wmztens,NW)

      ! helicity combi nr.h is selected

      end

c ------------------------------------------------------------

      SUBROUTINE WMTOWZ1_mg_had(P,N,lsign,wmztens,NW)
C  
C Generated by MadGraph II Version 3.0. Updated 02/19/04                
C RETURNS AMPLITUDE SQUARED SUMMED/AVG OVER COLORS
C FOR THE POINT WITH EXTERNAL LINES W(0:6,NEXTERNAL)
C  
C FOR PROCESS : w- -> mu- vm~ ta- ta+  
C  
      IMPLICIT NONE
C  
C CONSTANTS
C  
      INTEGER    NGRAPHS
      PARAMETER (NGRAPHS=   8) 
      INTEGER    NWAVEFUNCS
      PARAMETER (NWAVEFUNCS=  16) 
      DOUBLE PRECISION     ZERO
      PARAMETER (ZERO=0D0)
C  
C ARGUMENTS 
C  
      DOUBLE PRECISION P(0:3,2:5), Q(0:3)
      INTEGER N
      COMPLEX*16 wmztens(0:5)
      INTEGER lsign(2:5)
      integer NW ! = 0: all diagrams, = 1: no non resonant diagrams

C  
C LOCAL VARIABLES 
C  
      INTEGER I,J, mu
      COMPLEX*16 AMP(NGRAPHS)
      COMPLEX*16 W(6,NWAVEFUNCS)

c  lepton spinors and W+-, Z/A polarization vectors
#include "tensor.inc"

      logical lswitch
      parameter (lswitch=.true.)

C  
C GLOBAL VARIABLES
C  
#include "VBFNLO/utilities/coupl.inc"                    
#include "VBFNLO/utilities/global.inc"
#include "VBFNLO/utilities/coupl_haddecay.inc"
#include "VBFNLO/utilities/process.inc"
C                                                                          
C ----------
C BEGIN CODE
C ----------
      if (lswitch) then      ! read in lepton an W states from common block
         do i=1,6
            w(i,2)  = wmu(i,N)
            w(i,3)  = wvm(i,N)
            w(i,4)  = ztm(i,N)
            w(i,5)  = ztp(i,N)
         enddo
      endif

      do mu = 0,3
         q(mu) = p(mu,2)+p(mu,3)+p(mu,4)+p(mu,5)
      enddo

      do mu = 0,3
      CALL TRIBOSVCARTX(Q(0),WMASS ,WWIDTH, MU,-1,W(1,1   ))


      if (procid.eq.WPWMhadZ) then

      CALL JIOXXX(W(1,3   ),W(1,2   ),GWF ,WMASS   ,WWIDTH  ,W(1,6   ))    
      CALL JVVXXX(W(1,6   ),W(1,1   ),GWWA ,ZERO    ,AWIDTH  ,W(1,         
     &     7   ))                                                          
      CALL IOVXXX(W(1,5   ),W(1,4   ),W(1,7   ),GAL ,AMP(1   ))            
      CALL JVVXXX(W(1,6   ),W(1,1   ),GWWZ ,ZMASS   ,ZWIDTH  ,W(1,         
     &     8   ))                                                          
      CALL IOVXXX(W(1,5   ),W(1,4   ),W(1,8   ),GZL ,AMP(2   ))            
      CALL HVVXXX(W(1,6   ),W(1,1   ),GWWH ,HMASS   ,HWIDTH  ,W(1,         
     &     9   ))                                                          
      CALL IOSXXX(W(1,5   ),W(1,4   ),W(1,9   ),GHTAU ,AMP(3   ))          
      CALL FVOXXX(W(1,4   ),W(1,1   ),GWF ,ZERO    ,ZERO    ,W(1,10  ))    
      CALL IOVXXX(W(1,5   ),W(1,10  ),W(1,6   ),GWF ,AMP(4   ))            
      CALL FVIXXX(W(1,3   ),W(1,1   ),GWF ,ZERO    ,ZERO    ,W(1,11  ))    
      CALL JIOXXX(W(1,11  ),W(1,2   ),GAD ,ZERO    ,AWIDTH  ,W(1,12  ))    
      CALL IOVXXX(W(1,5   ),W(1,4   ),W(1,12  ),GAL ,AMP(5   ))            
      CALL JIOXXX(W(1,11  ),W(1,2   ),GZD ,ZMASS   ,ZWIDTH  ,W(1,13  ))    
      CALL IOVXXX(W(1,5   ),W(1,4   ),W(1,13  ),GZL ,AMP(6   ))            
      CALL FVOXXX(W(1,2   ),W(1,1   ),GWF ,ZERO    ,ZERO    ,W(1,14  ))    
      CALL JIOXXX(W(1,3   ),W(1,14  ),GAU ,ZERO    ,AWIDTH  ,W(1,15  ))    
      CALL IOVXXX(W(1,5   ),W(1,4   ),W(1,15  ),GAL ,AMP(7   ))            
      CALL JIOXXX(W(1,3   ),W(1,14  ),GZU ,ZMASS   ,ZWIDTH  ,W(1,16  ))    
      CALL IOVXXX(W(1,5   ),W(1,4   ),W(1,16  ),GZL ,AMP(8   ))            

      wmztens(mu) = +AMP(   1)+AMP(   2)+AMP(   3)+AMP(   4)+AMP(   5)
     &             +AMP(   6)+AMP(   7)+AMP(   8)

      elseif (procid.eq.WWZhad .and. Ztodd) then

      CALL JIOXXX(W(1,3   ),W(1,2   ),GWF ,WMASS   ,WWIDTH  ,W(1,6   ))    
      CALL JVVXXX(W(1,6   ),W(1,1   ),GWWA ,ZERO    ,AWIDTH  ,W(1,         
     &     7   ))                                                          
      CALL IOVXXX(W(1,5   ),W(1,4   ),W(1,7   ),GAD ,AMP(1   ))            
      CALL JVVXXX(W(1,6   ),W(1,1   ),GWWZ ,ZMASS   ,ZWIDTH  ,W(1,         
     &     8   ))                                                          
      CALL IOVXXX(W(1,5   ),W(1,4   ),W(1,8   ),GZD ,AMP(2   ))            
      CALL FVOXXX(W(1,4   ),W(1,1   ),GWF ,ZERO    ,ZERO    ,W(1,9   ))    
      CALL IOVXXX(W(1,5   ),W(1,9   ),W(1,6   ),GWF ,AMP(3   ))            
      CALL FVIXXX(W(1,3   ),W(1,1   ),GWF ,ZERO    ,ZERO    ,W(1,10  ))    
      CALL JIOXXX(W(1,10  ),W(1,2   ),GAL ,ZERO    ,AWIDTH  ,W(1,11  ))    
      CALL IOVXXX(W(1,5   ),W(1,4   ),W(1,11  ),GAD ,AMP(4   ))            
      CALL JIOXXX(W(1,10  ),W(1,2   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,12  ))    
      CALL IOVXXX(W(1,5   ),W(1,4   ),W(1,12  ),GZD ,AMP(5   ))            
      CALL FVOXXX(W(1,2   ),W(1,1   ),GWF ,ZERO    ,ZERO    ,W(1,13  ))    
      CALL JIOXXX(W(1,3   ),W(1,13  ),GZN ,ZMASS   ,ZWIDTH  ,W(1,14  ))    
      CALL IOVXXX(W(1,5   ),W(1,4   ),W(1,14  ),GZD ,AMP(6   ))            

      wmztens(mu) = +AMP(   1)+AMP(   2)+AMP(   3)+AMP(   4)+AMP(   5)
     &             +AMP(   6)

      elseif (procid.eq.WWZhad .and. Ztouu) then

      CALL JIOXXX(W(1,3   ),W(1,2   ),GWF ,WMASS   ,WWIDTH  ,W(1,6   ))    
      CALL FVOXXX(W(1,4   ),W(1,6   ),GWF ,ZERO    ,ZERO    ,W(1,7   ))    
      CALL IOVXXX(W(1,5   ),W(1,7   ),W(1,1   ),GWF ,AMP(1   ))            
      CALL JVVXXX(W(1,6   ),W(1,1   ),GWWA ,ZERO    ,AWIDTH  ,W(1,         
     &     8   ))                                                          
      CALL IOVXXX(W(1,5   ),W(1,4   ),W(1,8   ),GAU ,AMP(2   ))            
      CALL JVVXXX(W(1,6   ),W(1,1   ),GWWZ ,ZMASS   ,ZWIDTH  ,W(1,         
     &     9   ))                                                          
      CALL IOVXXX(W(1,5   ),W(1,4   ),W(1,9   ),GZU ,AMP(3   ))            
      CALL FVIXXX(W(1,3   ),W(1,1   ),GWF ,ZERO    ,ZERO    ,W(1,10  ))    
      CALL JIOXXX(W(1,10  ),W(1,2   ),GAL ,ZERO    ,AWIDTH  ,W(1,11  ))    
      CALL IOVXXX(W(1,5   ),W(1,4   ),W(1,11  ),GAU ,AMP(4   ))            
      CALL JIOXXX(W(1,10  ),W(1,2   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,12  ))    
      CALL IOVXXX(W(1,5   ),W(1,4   ),W(1,12  ),GZU ,AMP(5   ))            
      CALL FVOXXX(W(1,2   ),W(1,1   ),GWF ,ZERO    ,ZERO    ,W(1,13  ))    
      CALL JIOXXX(W(1,3   ),W(1,13  ),GZN ,ZMASS   ,ZWIDTH  ,W(1,14  ))    
      CALL IOVXXX(W(1,5   ),W(1,4   ),W(1,14  ),GZU ,AMP(6   ))            

      wmztens(mu) = +AMP(   1)+AMP(   2)+AMP(   3)+AMP(   4)+AMP(   5)
     &             +AMP(   6)

      else

      CALL JIOXXX(W(1,3   ),W(1,2   ),GWF ,WMASS   ,WWIDTH  ,W(1,6   ))    
      CALL JVVXXX(W(1,6   ),W(1,1   ),GWWA ,ZERO    ,AWIDTH  ,W(1,         
     &     7   ))                                                          
      CALL IOVXXX(W(1,5   ),W(1,4   ),W(1,7   ),GAL ,AMP(1   ))            
      CALL JVVXXX(W(1,6   ),W(1,1   ),GWWZ ,ZMASS   ,ZWIDTH  ,W(1,         
     &     8   ))                                                          
      CALL IOVXXX(W(1,5   ),W(1,4   ),W(1,8   ),GZL ,AMP(2   ))            
      CALL HVVXXX(W(1,6   ),W(1,1   ),GWWH ,HMASS   ,HWIDTH  ,W(1,         
     &     9   ))                                                          
      CALL IOSXXX(W(1,5   ),W(1,4   ),W(1,9   ),GHTAU ,AMP(3   ))          
      CALL FVOXXX(W(1,4   ),W(1,1   ),GWF ,ZERO    ,ZERO    ,W(1,10  ))    
      CALL IOVXXX(W(1,5   ),W(1,10  ),W(1,6   ),GWF ,AMP(4   ))            
      CALL FVIXXX(W(1,3   ),W(1,1   ),GWF ,ZERO    ,ZERO    ,W(1,11  ))    
      CALL JIOXXX(W(1,11  ),W(1,2   ),GAL ,ZERO    ,AWIDTH  ,W(1,12  ))    
      CALL IOVXXX(W(1,5   ),W(1,4   ),W(1,12  ),GAL ,AMP(5   ))            
      CALL JIOXXX(W(1,11  ),W(1,2   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,13  ))    
      CALL IOVXXX(W(1,5   ),W(1,4   ),W(1,13  ),GZL ,AMP(6   ))            
      CALL FVOXXX(W(1,2   ),W(1,1   ),GWF ,ZERO    ,ZERO    ,W(1,14  ))    
      CALL JIOXXX(W(1,3   ),W(1,14  ),GZN ,ZMASS   ,ZWIDTH  ,W(1,15  ))    
      CALL IOVXXX(W(1,5   ),W(1,4   ),W(1,15  ),GZL ,AMP(7   ))            

      wmztens(mu) = +AMP(   1)+AMP(   2)+AMP(   3)+AMP(   4)+AMP(   5)
     &             +AMP(   6)+AMP(   7)

      endif

      enddo
      wmztens(4) = dcmplx(q(0),q(3))
      wmztens(5) = dcmplx(q(1),q(2))
c
      return
      END

c----------------------------------------------------------------------

      SUBROUTINE WPTOWZ_mg_had(v,N,h,wpztens,NW)

      IMPLICIT NONE

      DOUBLE PRECISION v(0:3,6)
      DOUBLE PRECISION P(0:3,2:5)
      
      complex*16 wpztens(0:5)
      integer lsign(2:5,2),ll,mu,h,N
      integer NW ! = 0: all diagrams, = 1: no non resonant diagrams

      ! possible lepton helicities:
      data (lsign(ll,1),ll=2,5) / -1, -1, -1, -1/  !h=1
      data (lsign(ll,2),ll=2,5) / -1, -1,  1,  1/  !h=2

      do mu = 0,3
         P(mu,2) = v(mu,1)
         P(mu,3) = v(mu,2)
         P(mu,4) = v(mu,5)
         P(mu,5) = v(mu,6)
      enddo

      call WPTOWZ1_mg_had(P,N,lsign(2,h),wpztens,NW)

      ! helicity combi nr.h is selected

      end

c ------------------------------------------------------------

      SUBROUTINE WPTOWZ1_mg_had(P,N,lsign,wpztens,NW)
C  
C Generated by MadGraph II Version 3.0. Updated 02/19/04                
C RETURNS AMPLITUDE SQUARED SUMMED/AVG OVER COLORS
C FOR THE POINT WITH EXTERNAL LINES W(0:6,NEXTERNAL)
C  
C FOR PROCESS : w+ ->  ve e+ ta- ta+   
C  
      IMPLICIT NONE
C  
C CONSTANTS
C  
      INTEGER    NGRAPHS
      PARAMETER (NGRAPHS=   8) 
      INTEGER    NWAVEFUNCS
      PARAMETER (NWAVEFUNCS=  16) 
      DOUBLE PRECISION     ZERO
      PARAMETER (ZERO=0D0)
C  
C ARGUMENTS 
C  
      DOUBLE PRECISION P(0:3,2:5), Q(0:3)
      INTEGER N
      COMPLEX*16 wpztens(0:5)
      INTEGER lsign(2:5)
      integer NW ! = 0: all diagrams, = 1: no non resonant diagrams
C  
C LOCAL VARIABLES 
C  
      INTEGER I,J, mu
      COMPLEX*16 AMP(NGRAPHS)
      COMPLEX*16 W(6,NWAVEFUNCS)

c  lepton spinors and W+-, Z/A polarization vectors
#include "tensor.inc"

  
C GLOBAL VARIABLES
  
#include "VBFNLO/utilities/coupl.inc"   
#include "VBFNLO/utilities/global.inc"
#include "VBFNLO/utilities/coupl_haddecay.inc"
#include "VBFNLO/utilities/process.inc"

      logical lswitch
      parameter (lswitch=.true.)
                       
C                                                                          
C ----------
C BEGIN CODE
C ----------
      if (lswitch) then      ! read in lepton an W states from common block
         do i=1,6
            w(i,2)  = wve(i,N)
            w(i,3)  = wep(i,N)
            w(i,4)  = ztm(i,N)
            w(i,5)  = ztp(i,N)
         enddo
      endif

      do mu = 0,3
         q(mu) = p(mu,2)+p(mu,3)+p(mu,4)+p(mu,5)
      enddo

      do mu = 0,3
      CALL TRIBOSVCARTX(Q(0),WMASS ,WWIDTH, MU,-1,W(1,1   ))

      if (procid.eq.WPhadWMZ) then

      CALL JIOXXX(W(1,3   ),W(1,2   ),GWF ,WMASS   ,WWIDTH  ,W(1,6   ))    
      CALL FVOXXX(W(1,4   ),W(1,6   ),GWF ,ZERO    ,ZERO    ,W(1,7   ))    
      CALL IOVXXX(W(1,5   ),W(1,7   ),W(1,1   ),GWF ,AMP(1   ))            
      CALL JVVXXX(W(1,1   ),W(1,6   ),GWWA ,ZERO    ,AWIDTH  ,W(1,         
     &     8   ))                                                          
      CALL IOVXXX(W(1,5   ),W(1,4   ),W(1,8   ),GAL ,AMP(2   ))            
      CALL JVVXXX(W(1,1   ),W(1,6   ),GWWZ ,ZMASS   ,ZWIDTH  ,W(1,         
     &     9   ))                                                          
      CALL IOVXXX(W(1,5   ),W(1,4   ),W(1,9   ),GZL ,AMP(3   ))            
      CALL HVVXXX(W(1,1   ),W(1,6   ),GWWH ,HMASS   ,HWIDTH  ,W(1,         
     &     10  ))                                                          
      CALL IOSXXX(W(1,5   ),W(1,4   ),W(1,10  ),GHTAU ,AMP(4   ))          
      CALL FVIXXX(W(1,3   ),W(1,1   ),GWF ,ZERO    ,ZERO    ,W(1,11  ))    
      CALL JIOXXX(W(1,11  ),W(1,2   ),GAU ,ZERO    ,AWIDTH  ,W(1,12  ))    
      CALL IOVXXX(W(1,5   ),W(1,4   ),W(1,12  ),GAL ,AMP(5   ))            
      CALL JIOXXX(W(1,11  ),W(1,2   ),GZU ,ZMASS   ,ZWIDTH  ,W(1,13  ))    
      CALL IOVXXX(W(1,5   ),W(1,4   ),W(1,13  ),GZL ,AMP(6   ))            
      CALL FVOXXX(W(1,2   ),W(1,1   ),GWF ,ZERO    ,ZERO    ,W(1,14  ))    
      CALL JIOXXX(W(1,3   ),W(1,14  ),GAD ,ZERO    ,AWIDTH  ,W(1,15  ))    
      CALL IOVXXX(W(1,5   ),W(1,4   ),W(1,15  ),GAL ,AMP(7   ))            
      CALL JIOXXX(W(1,3   ),W(1,14  ),GZD ,ZMASS   ,ZWIDTH  ,W(1,16  ))    
      CALL IOVXXX(W(1,5   ),W(1,4   ),W(1,16  ),GZL ,AMP(8   ))            

      wpztens(mu) = +AMP(   1)+AMP(   2)+AMP(   3)+AMP(   4)+AMP(   5)
     &             +AMP(   6)+AMP(   7)+AMP(   8)

      elseif (procid.eq.WWZhad .and. Ztodd) then

      CALL JIOXXX(W(1,3   ),W(1,2   ),GWF ,WMASS   ,WWIDTH  ,W(1,6   ))    
      CALL FVOXXX(W(1,4   ),W(1,6   ),GWF ,ZERO    ,ZERO    ,W(1,7   ))    
      CALL IOVXXX(W(1,5   ),W(1,7   ),W(1,1   ),GWF ,AMP(1   ))            
      CALL JVVXXX(W(1,1   ),W(1,6   ),GWWA ,ZERO    ,AWIDTH  ,W(1,         
     &     8   ))                                                          
      CALL IOVXXX(W(1,5   ),W(1,4   ),W(1,8   ),GAD ,AMP(2   ))            
      CALL JVVXXX(W(1,1   ),W(1,6   ),GWWZ ,ZMASS   ,ZWIDTH  ,W(1,         
     &     9   ))                                                          
      CALL IOVXXX(W(1,5   ),W(1,4   ),W(1,9   ),GZD ,AMP(3   ))            
      CALL FVIXXX(W(1,3   ),W(1,1   ),GWF ,ZERO    ,ZERO    ,W(1,10  ))    
      CALL JIOXXX(W(1,10  ),W(1,2   ),GZN ,ZMASS   ,ZWIDTH  ,W(1,11  ))    
      CALL IOVXXX(W(1,5   ),W(1,4   ),W(1,11  ),GZD ,AMP(4   ))            
      CALL FVOXXX(W(1,2   ),W(1,1   ),GWF ,ZERO    ,ZERO    ,W(1,12  ))    
      CALL JIOXXX(W(1,3   ),W(1,12  ),GAL ,ZERO    ,AWIDTH  ,W(1,13  ))    
      CALL IOVXXX(W(1,5   ),W(1,4   ),W(1,13  ),GAD ,AMP(5   ))            
      CALL JIOXXX(W(1,3   ),W(1,12  ),GZL ,ZMASS   ,ZWIDTH  ,W(1,14  ))    
      CALL IOVXXX(W(1,5   ),W(1,4   ),W(1,14  ),GZD ,AMP(6   ))            

      wpztens(mu) = +AMP(   1)+AMP(   2)+AMP(   3)+AMP(   4)+AMP(   5)
     &             +AMP(   6)

      elseif (procid.eq.WWZhad .and. Ztouu) then

      CALL JIOXXX(W(1,3   ),W(1,2   ),GWF ,WMASS   ,WWIDTH  ,W(1,6   ))    
      CALL JVVXXX(W(1,1   ),W(1,6   ),GWWA ,ZERO    ,AWIDTH  ,W(1,         
     &     7   ))                                                          
      CALL IOVXXX(W(1,5   ),W(1,4   ),W(1,7   ),GAU ,AMP(1   ))            
      CALL JVVXXX(W(1,1   ),W(1,6   ),GWWZ ,ZMASS   ,ZWIDTH  ,W(1,         
     &     8   ))                                                          
      CALL IOVXXX(W(1,5   ),W(1,4   ),W(1,8   ),GZU ,AMP(2   ))            
      CALL FVOXXX(W(1,4   ),W(1,1   ),GWF ,ZERO    ,ZERO    ,W(1,9   ))    
      CALL IOVXXX(W(1,5   ),W(1,9   ),W(1,6   ),GWF ,AMP(3   ))            
      CALL FVIXXX(W(1,3   ),W(1,1   ),GWF ,ZERO    ,ZERO    ,W(1,10  ))    
      CALL JIOXXX(W(1,10  ),W(1,2   ),GZN ,ZMASS   ,ZWIDTH  ,W(1,11  ))    
      CALL IOVXXX(W(1,5   ),W(1,4   ),W(1,11  ),GZU ,AMP(4   ))            
      CALL FVOXXX(W(1,2   ),W(1,1   ),GWF ,ZERO    ,ZERO    ,W(1,12  ))    
      CALL JIOXXX(W(1,3   ),W(1,12  ),GAL ,ZERO    ,AWIDTH  ,W(1,13  ))    
      CALL IOVXXX(W(1,5   ),W(1,4   ),W(1,13  ),GAU ,AMP(5   ))            
      CALL JIOXXX(W(1,3   ),W(1,12  ),GZL ,ZMASS   ,ZWIDTH  ,W(1,14  ))    
      CALL IOVXXX(W(1,5   ),W(1,4   ),W(1,14  ),GZU ,AMP(6   ))            

      wpztens(mu) = +AMP(   1)+AMP(   2)+AMP(   3)+AMP(   4)+AMP(   5)
     &             +AMP(   6)

      else

      CALL JIOXXX(W(1,3   ),W(1,2   ),GWF ,WMASS   ,WWIDTH  ,W(1,6   ))    
      CALL FVOXXX(W(1,4   ),W(1,6   ),GWF ,ZERO    ,ZERO    ,W(1,7   ))    
      CALL IOVXXX(W(1,5   ),W(1,7   ),W(1,1   ),GWF ,AMP(1   ))            
      CALL JVVXXX(W(1,1   ),W(1,6   ),GWWA ,ZERO    ,AWIDTH  ,W(1,         
     &     8   ))                                                          
      CALL IOVXXX(W(1,5   ),W(1,4   ),W(1,8   ),GAL ,AMP(2   ))            
      CALL JVVXXX(W(1,1   ),W(1,6   ),GWWZ ,ZMASS   ,ZWIDTH  ,W(1,         
     &     9   ))                                                          
      CALL IOVXXX(W(1,5   ),W(1,4   ),W(1,9   ),GZL ,AMP(3   ))            
      CALL HVVXXX(W(1,1   ),W(1,6   ),GWWH ,HMASS   ,HWIDTH  ,W(1,         
     &     10  ))                                                          
      CALL IOSXXX(W(1,5   ),W(1,4   ),W(1,10  ),GHTAU ,AMP(4   ))          
      CALL FVIXXX(W(1,3   ),W(1,1   ),GWF ,ZERO    ,ZERO    ,W(1,11  ))    
      CALL JIOXXX(W(1,11  ),W(1,2   ),GZN ,ZMASS   ,ZWIDTH  ,W(1,12  ))    
      CALL IOVXXX(W(1,5   ),W(1,4   ),W(1,12  ),GZL ,AMP(5   ))            
      CALL FVOXXX(W(1,2   ),W(1,1   ),GWF ,ZERO    ,ZERO    ,W(1,13  ))    
      CALL JIOXXX(W(1,3   ),W(1,13  ),GAL ,ZERO    ,AWIDTH  ,W(1,14  ))    
      CALL IOVXXX(W(1,5   ),W(1,4   ),W(1,14  ),GAL ,AMP(6   ))            
      CALL JIOXXX(W(1,3   ),W(1,13  ),GZL ,ZMASS   ,ZWIDTH  ,W(1,15  ))    
      CALL IOVXXX(W(1,5   ),W(1,4   ),W(1,15  ),GZL ,AMP(7   ))            

      wpztens(mu) = +AMP(   1)+AMP(   2)+AMP(   3)+AMP(   4)+AMP(   5)
     &             +AMP(   6)+AMP(   7)

      endif

      enddo
      wpztens(4) = dcmplx(q(0),q(3))
      wpztens(5) = dcmplx(q(1),q(2))
c
      return
      END

