c
c     Franziska Schissler: schissler@particle.uni-karlsruhe.de
c     Initial version:  2011 April 5
c
      real*8 function m2s_Wmdy(
c     &                   bos,   !in:  Boson identifier, 2 = Z, 6=H, 34=W+W-
c     &                   nlo,   !in:  Born only for nlo=0, +interference for 1
     &                   xi,     !in:  Feynman x parameters of incoming fermions
     &                    p,     !in:  momenta associated with external partons
     &                    v      !in:  momenta associated with decay leptons
     &                        )
      implicit none
c
c declare input/output variables
c
#include "VBFNLO/utilities/global.inc"
#include "VBFNLO/utilities/scales.inc"
#include "VBFNLO/utilities/lha.inc"

      
      integer i, mu, fsign(4), if1, k, ires, nmax,
     &        nmin
      double precision xi(nx), q_sf, pdf(-6:6,2)
      double precision p(0:3,2),v(0:3,2),
     &                 pbar(0:3,4), tmp, tmp2, test(4)
      double precision mass2, m2s
      external mass2
      real*8 res(2)
      double precision RandomNumber, weight, rnumb
      integer iflav(2)
      real*8 alphas, xmt, alpha, xmz, xmw, polcol
      double precision sin2w, xmh, gf, alfas_lo
      common /bkopin/ alphas, xmt, alpha, xmz, xmw, sin2w, xmh, gf, alfas_lo
      

c
c alfas, scales etc
c#include "scales.inc"

        if ((lha.or.hepmc).and..not.doNLO) then
           helicity(1)= 1
           helicity(2)=-1
        endif     

      do mu= 0, 3
         do i = 1,2
            pbar(mu,i) = p(mu,i)
         enddo
         do i = 1, 2
            pbar(mu,2+i) = v(mu,i)
         enddo
      enddo



c if calc_qsq has been called in main-prog      q_sf = sqrt(mufsq(1,1))
      q_sf = sqrt(mufsq(1,1))
      call pdfproton( xi(1), q_sf, pdf(-6,1) ) ! f_a(x1)
      q_sf = sqrt(mufsq(2,1))
      call pdfproton( xi(2), q_sf, pdf(-6,2) ) ! f_a(x2)



      do i=-6, 6
         pdf(i,1) = pdf(i,1)/xi(1)
         pdf(i,2) = pdf(i,2)/xi(2)
! 
!          print*, "pdf(",i," ,1):", pdf(i,1)
!          print*, "pdf(",i," ,2):", pdf(i,2)
      enddo

      
!      print*, pdf(-2,2), pdf(2,1), pdf(-2,2)*pdf(2,1)
  !    stop
      do i=1,4
      test(i) = 0d0
      enddo
      tmp=0d0
      tmp2=0d0
      
       if (with_kk) then
          call SWm_DY_kk(pbar, tmp)
       else  
          call SWm_DY(pbar, tmp)
       endif
!      print*, tmp

      test(1) = test(1) + tmp * pdf(-2,1) * pdf(1,2) ! u~d
      test(2) = test(2) + tmp * pdf(-4,1) * pdf(3,2) ! c~s

        iflav(1)=-2
	iflav(2)=1
	do i=1,2
	call fillColoredPartons_Wdy(iflav,i)
	enddo

      call switchmom( pbar(0,1), pbar(0,2) )
      
      
       if (with_kk) then
          call SWm_DY_kk(pbar, tmp2)
       else  
          call SWm_DY(pbar, tmp2)
       endif
      

      test(3) = test(3) + tmp2 * pdf(-2,2) * pdf(1,1) ! du~
      test(4) = test(4) + tmp2 * pdf(-4,2) * pdf(3,1) ! sc~
      
        iflav(1)=1
	iflav(2)=-2
	do i=3,4
	call fillColoredPartons_Wdy(iflav,i)
	enddo

      call switchmom( pbar(0,1), pbar(0,2) )


 
!       print*, test
!      stop

c crossing -------------------------


      do i=1,4
      m2s_wmdy =m2s_wmdy+test(i)
      enddo
      
      if ((lha.or.hepmc).and..not.doNLO) then
         i=0
         weight=0.d0
         rnumb=RandomNumber()
! 	 print*, "M^2" , m2s_Wmdy
! 	 print*, "Zufall",rnumb
         do while((i.le.4).and.(weight.le.rnumb*m2s_wmdy))
            i=i+1
            weight=weight+test(i)
            iprocess=i
! 	    print*,"weight", weight

         enddo
      endif      
      
      
      RETURN
      END

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc      

*****************************************************************************
c
c    begin  subroutine fillColoredPartons_VV
c
c*****************************************************************************

      subroutine fillColoredPartons_Wdy(iflav,listposition)

c  assigns values to the variables in the common block localHEPUP
c  in particular, this subroutine assigns values to those variables that 
c  will be stored in the lookup tables generated by writeHEPUPtable.  
c  As the name suggests, this routine only stores the information for the 
c  colored partons.  Particles without color will be dealt with in the 
c  subroutine fillColorless.

      IMPLICIT NONE

c  include files
#include "VBFNLO/utilities/global.inc"
#include "VBFNLO/utilities/lha.inc"
#include "VBFNLO/utilities/process.inc"

c  input parameters
      INTEGER iflav(2),id1,id2,id3,id4,listposition !2 quark flavors and subprocess number

c  local variables
      INTEGER i
      
      id1=iflav(1)
      id2=iflav(2)
   
      select case(process)
      case(WP_DY,WM_DY) 
         lnup(listposition)=5

	 
      case default
         print*,'wrong process number in fillColoredPartons_VV: ',process
         stop
      end select

      listup(1,listposition)=-1   !incoming quarks
      listup(2,listposition)=-1
 
      lidup(1,listposition)=id1     ! the 2 quarks
      lidup(2,listposition)=id2

      if (id1.gt.0) then
        licolup(1,1,listposition)=501
        licolup(2,1,listposition)=0
        licolup(1,2,listposition)=0
        licolup(2,2,listposition)=501
      else
        licolup(1,1,listposition)=0
        licolup(2,1,listposition)=501
        licolup(1,2,listposition)=501
        licolup(2,2,listposition)=0
      endif
      END





