c
c     Franziska Schissler: schissler@particle.uni-karlsruhe.de
c     Initial version:  2011 April 5
c
      real*8 function m2s_Wpdy(
c     &                   bos,   !in:  Boson identifier, 2 = Z, 6=H, 34=W+W-
c     &                   nlo,   !in:  Born only for nlo=0, +interference for 1
     &                   xi,     !in:  Feynman x parameters of incoming fermions
     &                    p,     !in:  momenta associated with external partons
     &                    v      !in:  momenta associated with decay leptons
     &                        )
      implicit none
c
c declare input/output variables
c
#include "VBFNLO/utilities/global.inc"
#include "VBFNLO/utilities/scales.inc"
#include "VBFNLO/utilities/lha.inc"

      
      integer i, mu, fsign(4), if1, k, ires, nmax,
     &        nmin
      double precision xi(nx), q_sf, pdf(-6:6,2)
      double precision p(0:3,2),v(0:3,2),
     &                 pbar(0:3,4), tmp, tmp2, test(4)
      double precision mass2, m2s
      external mass2
      real*8 res(2)
      double precision RandomNumber, weight, rnumb
      integer iflav(2)
      real*8 alphas, xmt, alpha, xmz, xmw, polcol
      double precision sin2w, xmh, gf, alfas_lo
      common /bkopin/ alphas, xmt, alpha, xmz, xmw, sin2w, xmh, gf, alfas_lo
      

c
c alfas, scales etc
c#include "scales.inc"
        if ((lha.or.hepmc).and..not.doNLO) then
           helicity(1)=-1
           helicity(2)= 1
        endif     


      do mu= 0, 3
         do i = 1,2
            pbar(mu,i) = p(mu,i)
         enddo
         do i = 1, 2
            pbar(mu,2+i) = v(mu,i)
         enddo
      enddo



c if calc_qsq has been called in main-prog      q_sf = sqrt(mufsq(1,1))
      q_sf = sqrt(mufsq(1,1))
      call pdfproton( xi(1), q_sf, pdf(-6,1) ) ! f_a(x1)
      q_sf = sqrt(mufsq(2,1))
      call pdfproton( xi(2), q_sf, pdf(-6,2) ) ! f_a(x2)


 
      do i=-6, 6
         pdf(i,1) = pdf(i,1)/xi(1)
         pdf(i,2) = pdf(i,2)/xi(2)

c         print*, "pdf(",i," ,1):", pdf(i,1)
c         print*, "pdf(",i," ,2):", pdf(i,2)
      enddo

      
!      print*, pdf(-2,2), pdf(2,1), pdf(-2,2)*pdf(2,1)
  !    stop
      do i=1,4
      test(i) = 0d0
      enddo
      
       if (with_kk) then
          call SWp_DY_kk(pbar, tmp)
       else  
          call SWp_DY(pbar, tmp)
       endif
!      print*, tmp


      test(1) = test(1) + tmp * pdf(2,1) * pdf(-1,2) ! ud~
      test(2) = test(2) + tmp * pdf(4,1) * pdf(-3,2) ! cs~
        iflav(1)=2
	iflav(2)=-1
	do i=1,2
	call fillColoredPartons_Wdy(iflav,i)
	enddo


      call switchmom( pbar(0,1), pbar(0,2) )
      
      
       if (with_kk) then
          call SWp_DY_kk(pbar, tmp)
       else  
          call SWp_DY(pbar, tmp)
       endif
      
      
      call switchmom( pbar(0,1), pbar(0,2) )

      test(3) = test(3) + tmp * pdf(2,2) * pdf(-1,1) ! d~u
      test(4) = test(4) + tmp * pdf(4,2) * pdf(-3,1) ! s~c
        iflav(1)=-1
	iflav(2)=2
	do i=3,4
	call fillColoredPartons_Wdy(iflav,i)
	enddo 
!      print*, test(3)
!      stop

c crossing -------------------------

      do i=1,4
      m2s_wpdy =m2s_wpdy+test(i)
      enddo

      if ((lha.or.hepmc).and..not.doNLO) then
         i=0
         weight=0.d0
         rnumb=RandomNumber()
         do while((i.le.4).and.(weight.le.rnumb*m2s_wpdy))
            i=i+1
            weight=weight+test(i)
            iprocess=i

         enddo
      endif 
      



      RETURN
      END

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc      







