c
c in this file leptonic tensors needed for qq -> ZZZ, ZZZ -> 6l
c are computed for specific helicities (h)
c
c ------------------------------------------------------------
c ------------------------------------------------------------

      subroutine ATOZZZ_mg2_had(P,N,h,ZZZtensor,NW)

      IMPLICIT NONE
      DOUBLE PRECISION P(0:3,2:7)
      COMPLEX*16 ZZZTENSOR(0:5)
      integer lsign(2:7,8),ll,mu,nu,h,N
      integer NW

      !possible lepton helicities
      data (lsign(ll,1),ll=2,7) / -1, -1, -1, -1, -1, -1/  !h=1
      data (lsign(ll,2),ll=2,7) / -1, -1,  1,  1, -1, -1/  !h=2
      data (lsign(ll,3),ll=2,7) / -1, -1, -1, -1,  1,  1/  !h=3
      data (lsign(ll,4),ll=2,7) / -1, -1,  1,  1,  1,  1/  !h=4
      data (lsign(ll,5),ll=2,7) /  1,  1, -1, -1, -1, -1/  !h=5
      data (lsign(ll,6),ll=2,7) /  1,  1,  1,  1, -1, -1/  !h=6
      data (lsign(ll,7),ll=2,7) /  1,  1, -1, -1,  1,  1/  !h=7
      data (lsign(ll,8),ll=2,7) /  1,  1,  1,  1,  1,  1/  !h=8

      call ATOZZZ1_mg2_had(P,N,lsign(2,h),zzztensor(0),NW)

      ! helicity combi Nr. h is selected

      end

c-------------------------------------------------------------------

      SUBROUTINE ATOZZZ1_mg2_had(P,N,lsign,zzztensor,NW)
C  
C Generated by MadGraph II Version 3.0. Updated 02/19/04                
C RETURNS AMPLITUDE SQUARED SUMMED/AVG OVER COLORS
C FOR THE POINT WITH EXTERNAL LINES W(0:6,NEXTERNAL)
C  
C FOR PROCESS : a -> e- e+ mu- mu+ ta- ta+  
C  
      IMPLICIT NONE
C  
C CONSTANTS
C  
      INTEGER    NGRAPHS 
      PARAMETER (NGRAPHS= 174) 
      INTEGER    NWAVEFUNCS
      PARAMETER (NWAVEFUNCS= 214) 
      DOUBLE PRECISION     ZERO
      PARAMETER (ZERO=0D0)
C  
C ARGUMENTS 
C  
      DOUBLE PRECISION P(0:3,2:7), Q(0:3)
      INTEGER N
      COMPLEX*16 zzztensor(0:5)
      INTEGER lsign(2:7)
      integer NW
C  
C LOCAL VARIABLES 
C  
      INTEGER I,J, mu
      COMPLEX*16 AMP(NGRAPHS)
      COMPLEX*16 W(6,NWAVEFUNCS)
c  lepton spinors and Z/A polarization vectors
#include "tensor.inc"

      logical lswitch
      parameter (lswitch=.true.)
C  
C GLOBAL VARIABLES
C  
#include "VBFNLO/utilities/coupl.inc"                                  
#include "VBFNLO/utilities/process.inc"
#include "VBFNLO/utilities/coupl_haddecay.inc"
#include "VBFNLO/utilities/global.inc"
C                                                                          
C ----------
C BEGIN CODE
C ----------
      if (lswitch) then
         do i=1,6
            w(i,2)  = zem(i,N)
            w(i,3)  = zep(i,N)
            w(i,4)  = zmm(i,N)
            w(i,5)  = zmp(i,N)
            w(i,6)  = ztm(i,N)
            w(i,7)  = ztp(i,N)
            w(i,8)  = ae(i,N)
            w(i,14) = ze(i,N)
            w(i,22) = atau(i,N)
            w(i,26) = ztau(i,N)
         enddo
      endif

      do mu = 0,3
         q(mu) = p(mu,2)+p(mu,3)+p(mu,4)+p(mu,5)+p(mu,6)+p(mu,7)
      enddo

      do mu = 0,3
      call TRIBOSVCARTX(Q(0), ZERO, ZERO, MU, -1, W(1,1))      

      if (procid.eq.ZZZhad .and. Ztouu) then

      CALL JIOXXX(W(1,3   ),W(1,2   ),GAU ,ZERO    ,AWIDTH  ,W(1,8   ))    
      CALL FVOXXX(W(1,4   ),W(1,8   ),GAL ,ZERO    ,ZERO    ,W(1,9   ))    
      CALL JIOXXX(W(1,5   ),W(1,9   ),GAL ,ZERO    ,AWIDTH  ,W(1,10  ))    
      CALL FVOXXX(W(1,6   ),W(1,10  ),GAL ,LMASS   ,ZERO    ,W(1,11  ))    
      CALL IOVXXX(W(1,7   ),W(1,11  ),W(1,1   ),GAL ,AMP(1   ))            
      CALL JIOXXX(W(1,5   ),W(1,9   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,12  ))    
      CALL FVOXXX(W(1,6   ),W(1,12  ),GZL ,LMASS   ,ZERO    ,W(1,13  ))    
      CALL IOVXXX(W(1,7   ),W(1,13  ),W(1,1   ),GAL ,AMP(2   ))            
      CALL JIOXXX(W(1,3   ),W(1,2   ),GZU ,ZMASS   ,ZWIDTH  ,W(1,14  ))    
      CALL FVOXXX(W(1,4   ),W(1,14  ),GZL ,ZERO    ,ZERO    ,W(1,15  ))    
      CALL JIOXXX(W(1,5   ),W(1,15  ),GAL ,ZERO    ,AWIDTH  ,W(1,16  ))    
      CALL FVOXXX(W(1,6   ),W(1,16  ),GAL ,LMASS   ,ZERO    ,W(1,17  ))    
      CALL IOVXXX(W(1,7   ),W(1,17  ),W(1,1   ),GAL ,AMP(3   ))            
      CALL JIOXXX(W(1,5   ),W(1,15  ),GZL ,ZMASS   ,ZWIDTH  ,W(1,18  ))    
      CALL FVOXXX(W(1,6   ),W(1,18  ),GZL ,LMASS   ,ZERO    ,W(1,19  ))    
      CALL IOVXXX(W(1,7   ),W(1,19  ),W(1,1   ),GAL ,AMP(4   ))            
      CALL FVIXXX(W(1,7   ),W(1,10  ),GAL ,LMASS   ,ZERO    ,W(1,20  ))    
      CALL IOVXXX(W(1,20  ),W(1,6   ),W(1,1   ),GAL ,AMP(5   ))            
      CALL FVIXXX(W(1,7   ),W(1,12  ),GZL ,LMASS   ,ZERO    ,W(1,21  ))    
      CALL IOVXXX(W(1,21  ),W(1,6   ),W(1,1   ),GAL ,AMP(6   ))            
      CALL FVIXXX(W(1,7   ),W(1,16  ),GAL ,LMASS   ,ZERO    ,W(1,22  ))    
      CALL IOVXXX(W(1,22  ),W(1,6   ),W(1,1   ),GAL ,AMP(7   ))            
      CALL FVIXXX(W(1,7   ),W(1,18  ),GZL ,LMASS   ,ZERO    ,W(1,23  ))    
      CALL IOVXXX(W(1,23  ),W(1,6   ),W(1,1   ),GAL ,AMP(8   ))            
      CALL FVIXXX(W(1,5   ),W(1,1   ),GAL ,ZERO    ,ZERO    ,W(1,24  ))    
      CALL JIOXXX(W(1,24  ),W(1,4   ),GAL ,ZERO    ,AWIDTH  ,W(1,25  ))    
      CALL FVIXXX(W(1,3   ),W(1,25  ),GAU ,ZERO    ,ZERO    ,W(1,26  ))    
      CALL JIOXXX(W(1,26  ),W(1,2   ),GAU ,ZERO    ,AWIDTH  ,W(1,27  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,27  ),GAL ,AMP(9   ))            
      CALL JIOXXX(W(1,26  ),W(1,2   ),GZU ,ZMASS   ,ZWIDTH  ,W(1,28  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,28  ),GZL ,AMP(10  ))            
      CALL JIOXXX(W(1,24  ),W(1,4   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,29  ))    
      CALL FVIXXX(W(1,3   ),W(1,29  ),GZU ,ZERO    ,ZERO    ,W(1,30  ))    
      CALL JIOXXX(W(1,30  ),W(1,2   ),GAU ,ZERO    ,AWIDTH  ,W(1,31  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,31  ),GAL ,AMP(11  ))            
      CALL JIOXXX(W(1,30  ),W(1,2   ),GZU ,ZMASS   ,ZWIDTH  ,W(1,32  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,32  ),GZL ,AMP(12  ))            
      CALL FVOXXX(W(1,2   ),W(1,25  ),GAU ,ZERO    ,ZERO    ,W(1,33  ))    
      CALL JIOXXX(W(1,3   ),W(1,33  ),GAU ,ZERO    ,AWIDTH  ,W(1,34  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,34  ),GAL ,AMP(13  ))            
      CALL JIOXXX(W(1,3   ),W(1,33  ),GZU ,ZMASS   ,ZWIDTH  ,W(1,35  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,35  ),GZL ,AMP(14  ))            
      CALL FVOXXX(W(1,2   ),W(1,29  ),GZU ,ZERO    ,ZERO    ,W(1,36  ))    
      CALL JIOXXX(W(1,3   ),W(1,36  ),GAU ,ZERO    ,AWIDTH  ,W(1,37  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,37  ),GAL ,AMP(15  ))            
      CALL JIOXXX(W(1,3   ),W(1,36  ),GZU ,ZMASS   ,ZWIDTH  ,W(1,38  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,38  ),GZL ,AMP(16  ))            
      CALL FVIXXX(W(1,24  ),W(1,8   ),GAL ,ZERO    ,ZERO    ,W(1,39  ))    
      CALL JIOXXX(W(1,39  ),W(1,4   ),GAL ,ZERO    ,AWIDTH  ,W(1,40  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,40  ),GAL ,AMP(17  ))            
      CALL JIOXXX(W(1,39  ),W(1,4   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,41  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,41  ),GZL ,AMP(18  ))            
      CALL FVIXXX(W(1,24  ),W(1,14  ),GZL ,ZERO    ,ZERO    ,W(1,42  ))    
      CALL JIOXXX(W(1,42  ),W(1,4   ),GAL ,ZERO    ,AWIDTH  ,W(1,43  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,43  ),GAL ,AMP(19  ))            
      CALL JIOXXX(W(1,42  ),W(1,4   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,44  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,44  ),GZL ,AMP(20  ))            
      CALL FVOXXX(W(1,9   ),W(1,1   ),GAL ,ZERO    ,ZERO    ,W(1,45  ))    
      CALL JIOXXX(W(1,5   ),W(1,45  ),GAL ,ZERO    ,AWIDTH  ,W(1,46  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,46  ),GAL ,AMP(21  ))            
      CALL JIOXXX(W(1,5   ),W(1,45  ),GZL ,ZMASS   ,ZWIDTH  ,W(1,47  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,47  ),GZL ,AMP(22  ))            
      CALL FVOXXX(W(1,15  ),W(1,1   ),GAL ,ZERO    ,ZERO    ,W(1,48  ))    
      CALL JIOXXX(W(1,5   ),W(1,48  ),GAL ,ZERO    ,AWIDTH  ,W(1,49  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,49  ),GAL ,AMP(23  ))            
      CALL JIOXXX(W(1,5   ),W(1,48  ),GZL ,ZMASS   ,ZWIDTH  ,W(1,50  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,50  ),GZL ,AMP(24  ))            
      CALL HVVXXX(W(1,14  ),W(1,29  ),GZZH ,HMASS   ,HWIDTH  ,W(1,         
     &     51  ))                                                          
      CALL IOSXXX(W(1,7   ),W(1,6   ),W(1,51  ),GHTAU ,AMP(25  ))          
      CALL FVIXXX(W(1,7   ),W(1,25  ),GAL ,LMASS   ,ZERO    ,W(1,52  ))    
      CALL IOVXXX(W(1,52  ),W(1,6   ),W(1,8   ),GAL ,AMP(26  ))            
      CALL FVIXXX(W(1,7   ),W(1,29  ),GZL ,LMASS   ,ZERO    ,W(1,53  ))    
      CALL IOVXXX(W(1,53  ),W(1,6   ),W(1,8   ),GAL ,AMP(27  ))            
      CALL IOVXXX(W(1,52  ),W(1,6   ),W(1,14  ),GZL ,AMP(28  ))            
      CALL IOVXXX(W(1,53  ),W(1,6   ),W(1,14  ),GZL ,AMP(29  ))            
      CALL FVIXXX(W(1,7   ),W(1,8   ),GAL ,LMASS   ,ZERO    ,W(1,54  ))    
      CALL IOVXXX(W(1,54  ),W(1,6   ),W(1,25  ),GAL ,AMP(30  ))            
      CALL IOVXXX(W(1,54  ),W(1,6   ),W(1,29  ),GZL ,AMP(31  ))            
      CALL FVIXXX(W(1,7   ),W(1,14  ),GZL ,LMASS   ,ZERO    ,W(1,55  ))    
      CALL IOVXXX(W(1,55  ),W(1,6   ),W(1,25  ),GAL ,AMP(32  ))            
      CALL IOVXXX(W(1,55  ),W(1,6   ),W(1,29  ),GZL ,AMP(33  ))            
      CALL JIOXXX(W(1,24  ),W(1,9   ),GAL ,ZERO    ,AWIDTH  ,W(1,56  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,56  ),GAL ,AMP(34  ))            
      CALL JIOXXX(W(1,24  ),W(1,9   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,57  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,57  ),GZL ,AMP(35  ))            
      CALL JIOXXX(W(1,24  ),W(1,15  ),GAL ,ZERO    ,AWIDTH  ,W(1,58  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,58  ),GAL ,AMP(36  ))            
      CALL JIOXXX(W(1,24  ),W(1,15  ),GZL ,ZMASS   ,ZWIDTH  ,W(1,59  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,59  ),GZL ,AMP(37  ))            
      CALL JIOXXX(W(1,5   ),W(1,4   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,60  ))    
      CALL FVIXXX(W(1,7   ),W(1,1   ),GAL ,LMASS   ,ZERO    ,W(1,61  ))    
      CALL HVVXXX(W(1,60  ),W(1,14  ),GZZH ,HMASS   ,HWIDTH  ,W(1,         
     &     62  ))                                                          
      CALL IOSXXX(W(1,61  ),W(1,6   ),W(1,62  ),GHTAU ,AMP(38  ))          
      CALL JIOXXX(W(1,5   ),W(1,4   ),GAL ,ZERO    ,AWIDTH  ,W(1,63  ))    
      CALL FVIXXX(W(1,54  ),W(1,63  ),GAL ,LMASS   ,ZERO    ,W(1,64  ))    
      CALL IOVXXX(W(1,64  ),W(1,6   ),W(1,1   ),GAL ,AMP(39  ))            
      CALL FVIXXX(W(1,54  ),W(1,60  ),GZL ,LMASS   ,ZERO    ,W(1,65  ))    
      CALL IOVXXX(W(1,65  ),W(1,6   ),W(1,1   ),GAL ,AMP(40  ))            
      CALL FVIXXX(W(1,55  ),W(1,63  ),GAL ,LMASS   ,ZERO    ,W(1,66  ))    
      CALL IOVXXX(W(1,66  ),W(1,6   ),W(1,1   ),GAL ,AMP(41  ))            
      CALL FVIXXX(W(1,55  ),W(1,60  ),GZL ,LMASS   ,ZERO    ,W(1,67  ))    
      CALL IOVXXX(W(1,67  ),W(1,6   ),W(1,1   ),GAL ,AMP(42  ))            
      CALL FVIXXX(W(1,7   ),W(1,63  ),GAL ,LMASS   ,ZERO    ,W(1,68  ))    
      CALL FVIXXX(W(1,68  ),W(1,8   ),GAL ,LMASS   ,ZERO    ,W(1,69  ))    
      CALL IOVXXX(W(1,69  ),W(1,6   ),W(1,1   ),GAL ,AMP(43  ))            
      CALL FVIXXX(W(1,7   ),W(1,60  ),GZL ,LMASS   ,ZERO    ,W(1,70  ))    
      CALL FVIXXX(W(1,70  ),W(1,8   ),GAL ,LMASS   ,ZERO    ,W(1,71  ))    
      CALL IOVXXX(W(1,71  ),W(1,6   ),W(1,1   ),GAL ,AMP(44  ))            
      CALL FVIXXX(W(1,68  ),W(1,14  ),GZL ,LMASS   ,ZERO    ,W(1,72  ))    
      CALL IOVXXX(W(1,72  ),W(1,6   ),W(1,1   ),GAL ,AMP(45  ))            
      CALL FVIXXX(W(1,70  ),W(1,14  ),GZL ,LMASS   ,ZERO    ,W(1,73  ))    
      CALL IOVXXX(W(1,73  ),W(1,6   ),W(1,1   ),GAL ,AMP(46  ))            
      CALL FSIXXX(W(1,7   ),W(1,62  ),GHTAU ,LMASS   ,ZERO    ,W(1,        
     &     74  ))                                                          
      CALL IOVXXX(W(1,74  ),W(1,6   ),W(1,1   ),GAL ,AMP(47  ))            
      CALL FVIXXX(W(1,61  ),W(1,63  ),GAL ,LMASS   ,ZERO    ,W(1,75  ))    
      CALL IOVXXX(W(1,75  ),W(1,6   ),W(1,8   ),GAL ,AMP(48  ))            
      CALL FVIXXX(W(1,61  ),W(1,60  ),GZL ,LMASS   ,ZERO    ,W(1,76  ))    
      CALL IOVXXX(W(1,76  ),W(1,6   ),W(1,8   ),GAL ,AMP(49  ))            
      CALL IOVXXX(W(1,75  ),W(1,6   ),W(1,14  ),GZL ,AMP(50  ))            
      CALL IOVXXX(W(1,76  ),W(1,6   ),W(1,14  ),GZL ,AMP(51  ))            
      CALL FVIXXX(W(1,68  ),W(1,1   ),GAL ,LMASS   ,ZERO    ,W(1,77  ))    
      CALL IOVXXX(W(1,77  ),W(1,6   ),W(1,8   ),GAL ,AMP(52  ))            
      CALL FVIXXX(W(1,70  ),W(1,1   ),GAL ,LMASS   ,ZERO    ,W(1,78  ))    
      CALL IOVXXX(W(1,78  ),W(1,6   ),W(1,8   ),GAL ,AMP(53  ))            
      CALL IOVXXX(W(1,77  ),W(1,6   ),W(1,14  ),GZL ,AMP(54  ))            
      CALL IOVXXX(W(1,78  ),W(1,6   ),W(1,14  ),GZL ,AMP(55  ))            
      CALL FVIXXX(W(1,61  ),W(1,8   ),GAL ,LMASS   ,ZERO    ,W(1,79  ))    
      CALL IOVXXX(W(1,79  ),W(1,6   ),W(1,63  ),GAL ,AMP(56  ))            
      CALL IOVXXX(W(1,79  ),W(1,6   ),W(1,60  ),GZL ,AMP(57  ))            
      CALL FVIXXX(W(1,61  ),W(1,14  ),GZL ,LMASS   ,ZERO    ,W(1,80  ))    
      CALL IOVXXX(W(1,80  ),W(1,6   ),W(1,63  ),GAL ,AMP(58  ))            
      CALL IOVXXX(W(1,80  ),W(1,6   ),W(1,60  ),GZL ,AMP(59  ))            
      CALL FVIXXX(W(1,54  ),W(1,1   ),GAL ,LMASS   ,ZERO    ,W(1,81  ))    
      CALL IOVXXX(W(1,81  ),W(1,6   ),W(1,63  ),GAL ,AMP(60  ))            
      CALL IOVXXX(W(1,81  ),W(1,6   ),W(1,60  ),GZL ,AMP(61  ))            
      CALL FVIXXX(W(1,55  ),W(1,1   ),GAL ,LMASS   ,ZERO    ,W(1,82  ))    
      CALL IOVXXX(W(1,82  ),W(1,6   ),W(1,63  ),GAL ,AMP(62  ))            
      CALL IOVXXX(W(1,82  ),W(1,6   ),W(1,60  ),GZL ,AMP(63  ))            
      CALL FVIXXX(W(1,5   ),W(1,8   ),GAL ,ZERO    ,ZERO    ,W(1,83  ))    
      CALL JIOXXX(W(1,83  ),W(1,4   ),GAL ,ZERO    ,AWIDTH  ,W(1,84  ))    
      CALL IOVXXX(W(1,61  ),W(1,6   ),W(1,84  ),GAL ,AMP(64  ))            
      CALL JIOXXX(W(1,83  ),W(1,4   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,85  ))    
      CALL IOVXXX(W(1,61  ),W(1,6   ),W(1,85  ),GZL ,AMP(65  ))            
      CALL FVIXXX(W(1,5   ),W(1,14  ),GZL ,ZERO    ,ZERO    ,W(1,86  ))    
      CALL JIOXXX(W(1,86  ),W(1,4   ),GAL ,ZERO    ,AWIDTH  ,W(1,87  ))    
      CALL IOVXXX(W(1,61  ),W(1,6   ),W(1,87  ),GAL ,AMP(66  ))            
      CALL JIOXXX(W(1,86  ),W(1,4   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,88  ))    
      CALL IOVXXX(W(1,61  ),W(1,6   ),W(1,88  ),GZL ,AMP(67  ))            
      CALL FVIXXX(W(1,7   ),W(1,84  ),GAL ,LMASS   ,ZERO    ,W(1,89  ))    
      CALL IOVXXX(W(1,89  ),W(1,6   ),W(1,1   ),GAL ,AMP(68  ))            
      CALL FVIXXX(W(1,7   ),W(1,85  ),GZL ,LMASS   ,ZERO    ,W(1,90  ))    
      CALL IOVXXX(W(1,90  ),W(1,6   ),W(1,1   ),GAL ,AMP(69  ))            
      CALL FVIXXX(W(1,7   ),W(1,87  ),GAL ,LMASS   ,ZERO    ,W(1,91  ))    
      CALL IOVXXX(W(1,91  ),W(1,6   ),W(1,1   ),GAL ,AMP(70  ))            
      CALL FVIXXX(W(1,7   ),W(1,88  ),GZL ,LMASS   ,ZERO    ,W(1,92  ))    
      CALL IOVXXX(W(1,92  ),W(1,6   ),W(1,1   ),GAL ,AMP(71  ))            
      CALL FVOXXX(W(1,4   ),W(1,1   ),GAL ,ZERO    ,ZERO    ,W(1,93  ))    
      CALL JIOXXX(W(1,5   ),W(1,93  ),GAL ,ZERO    ,AWIDTH  ,W(1,94  ))    
      CALL FVIXXX(W(1,3   ),W(1,94  ),GAU ,ZERO    ,ZERO    ,W(1,95  ))    
      CALL JIOXXX(W(1,95  ),W(1,2   ),GAU ,ZERO    ,AWIDTH  ,W(1,96  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,96  ),GAL ,AMP(72  ))            
      CALL JIOXXX(W(1,95  ),W(1,2   ),GZU ,ZMASS   ,ZWIDTH  ,W(1,97  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,97  ),GZL ,AMP(73  ))            
      CALL JIOXXX(W(1,5   ),W(1,93  ),GZL ,ZMASS   ,ZWIDTH  ,W(1,98  ))    
      CALL FVIXXX(W(1,3   ),W(1,98  ),GZU ,ZERO    ,ZERO    ,W(1,99  ))    
      CALL JIOXXX(W(1,99  ),W(1,2   ),GAU ,ZERO    ,AWIDTH  ,W(1,100 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,100 ),GAL ,AMP(74  ))            
      CALL JIOXXX(W(1,99  ),W(1,2   ),GZU ,ZMASS   ,ZWIDTH  ,W(1,101 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,101 ),GZL ,AMP(75  ))            
      CALL FVOXXX(W(1,2   ),W(1,94  ),GAU ,ZERO    ,ZERO    ,W(1,102 ))    
      CALL JIOXXX(W(1,3   ),W(1,102 ),GAU ,ZERO    ,AWIDTH  ,W(1,103 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,103 ),GAL ,AMP(76  ))            
      CALL JIOXXX(W(1,3   ),W(1,102 ),GZU ,ZMASS   ,ZWIDTH  ,W(1,104 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,104 ),GZL ,AMP(77  ))            
      CALL FVOXXX(W(1,2   ),W(1,98  ),GZU ,ZERO    ,ZERO    ,W(1,105 ))    
      CALL JIOXXX(W(1,3   ),W(1,105 ),GAU ,ZERO    ,AWIDTH  ,W(1,106 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,106 ),GAL ,AMP(78  ))            
      CALL JIOXXX(W(1,3   ),W(1,105 ),GZU ,ZMASS   ,ZWIDTH  ,W(1,107 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,107 ),GZL ,AMP(79  ))            
      CALL FVIXXX(W(1,83  ),W(1,1   ),GAL ,ZERO    ,ZERO    ,W(1,108 ))    
      CALL JIOXXX(W(1,108 ),W(1,4   ),GAL ,ZERO    ,AWIDTH  ,W(1,109 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,109 ),GAL ,AMP(80  ))            
      CALL JIOXXX(W(1,108 ),W(1,4   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,110 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,110 ),GZL ,AMP(81  ))            
      CALL FVIXXX(W(1,86  ),W(1,1   ),GAL ,ZERO    ,ZERO    ,W(1,111 ))    
      CALL JIOXXX(W(1,111 ),W(1,4   ),GAL ,ZERO    ,AWIDTH  ,W(1,112 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,112 ),GAL ,AMP(82  ))            
      CALL JIOXXX(W(1,111 ),W(1,4   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,113 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,113 ),GZL ,AMP(83  ))            
      CALL FVOXXX(W(1,93  ),W(1,8   ),GAL ,ZERO    ,ZERO    ,W(1,114 ))    
      CALL JIOXXX(W(1,5   ),W(1,114 ),GAL ,ZERO    ,AWIDTH  ,W(1,115 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,115 ),GAL ,AMP(84  ))            
      CALL JIOXXX(W(1,5   ),W(1,114 ),GZL ,ZMASS   ,ZWIDTH  ,W(1,116 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,116 ),GZL ,AMP(85  ))            
      CALL FVOXXX(W(1,93  ),W(1,14  ),GZL ,ZERO    ,ZERO    ,W(1,117 ))    
      CALL JIOXXX(W(1,5   ),W(1,117 ),GAL ,ZERO    ,AWIDTH  ,W(1,118 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,118 ),GAL ,AMP(86  ))            
      CALL JIOXXX(W(1,5   ),W(1,117 ),GZL ,ZMASS   ,ZWIDTH  ,W(1,119 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,119 ),GZL ,AMP(87  ))            
      CALL JIOXXX(W(1,83  ),W(1,93  ),GAL ,ZERO    ,AWIDTH  ,W(1,120 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,120 ),GAL ,AMP(88  ))            
      CALL JIOXXX(W(1,83  ),W(1,93  ),GZL ,ZMASS   ,ZWIDTH  ,W(1,121 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,121 ),GZL ,AMP(89  ))            
      CALL JIOXXX(W(1,86  ),W(1,93  ),GAL ,ZERO    ,AWIDTH  ,W(1,122 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,122 ),GAL ,AMP(90  ))            
      CALL JIOXXX(W(1,86  ),W(1,93  ),GZL ,ZMASS   ,ZWIDTH  ,W(1,123 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,123 ),GZL ,AMP(91  ))            
      CALL HVVXXX(W(1,14  ),W(1,98  ),GZZH ,HMASS   ,HWIDTH  ,W(1,         
     &     124 ))                                                          
      CALL IOSXXX(W(1,7   ),W(1,6   ),W(1,124 ),GHTAU ,AMP(92  ))          
      CALL FVIXXX(W(1,7   ),W(1,94  ),GAL ,LMASS   ,ZERO    ,W(1,125 ))    
      CALL IOVXXX(W(1,125 ),W(1,6   ),W(1,8   ),GAL ,AMP(93  ))            
      CALL FVIXXX(W(1,7   ),W(1,98  ),GZL ,LMASS   ,ZERO    ,W(1,126 ))    
      CALL IOVXXX(W(1,126 ),W(1,6   ),W(1,8   ),GAL ,AMP(94  ))            
      CALL IOVXXX(W(1,125 ),W(1,6   ),W(1,14  ),GZL ,AMP(95  ))            
      CALL IOVXXX(W(1,126 ),W(1,6   ),W(1,14  ),GZL ,AMP(96  ))            
      CALL IOVXXX(W(1,54  ),W(1,6   ),W(1,94  ),GAL ,AMP(97  ))            
      CALL IOVXXX(W(1,54  ),W(1,6   ),W(1,98  ),GZL ,AMP(98  ))            
      CALL IOVXXX(W(1,55  ),W(1,6   ),W(1,94  ),GAL ,AMP(99  ))            
      CALL IOVXXX(W(1,55  ),W(1,6   ),W(1,98  ),GZL ,AMP(100 ))            
      CALL FVOXXX(W(1,2   ),W(1,63  ),GAU ,ZERO    ,ZERO    ,W(1,127 ))    
      CALL JIOXXX(W(1,3   ),W(1,127 ),GAU ,ZERO    ,AWIDTH  ,W(1,128 ))    
      CALL IOVXXX(W(1,61  ),W(1,6   ),W(1,128 ),GAL ,AMP(101 ))            
      CALL JIOXXX(W(1,3   ),W(1,127 ),GZU ,ZMASS   ,ZWIDTH  ,W(1,129 ))    
      CALL IOVXXX(W(1,61  ),W(1,6   ),W(1,129 ),GZL ,AMP(102 ))            
      CALL FVOXXX(W(1,2   ),W(1,60  ),GZU ,ZERO    ,ZERO    ,W(1,130 ))    
      CALL JIOXXX(W(1,3   ),W(1,130 ),GAU ,ZERO    ,AWIDTH  ,W(1,131 ))    
      CALL IOVXXX(W(1,61  ),W(1,6   ),W(1,131 ),GAL ,AMP(103 ))            
      CALL JIOXXX(W(1,3   ),W(1,130 ),GZU ,ZMASS   ,ZWIDTH  ,W(1,132 ))    
      CALL IOVXXX(W(1,61  ),W(1,6   ),W(1,132 ),GZL ,AMP(104 ))            
      CALL FVIXXX(W(1,7   ),W(1,128 ),GAL ,LMASS   ,ZERO    ,W(1,133 ))    
      CALL IOVXXX(W(1,133 ),W(1,6   ),W(1,1   ),GAL ,AMP(105 ))            
      CALL FVIXXX(W(1,7   ),W(1,129 ),GZL ,LMASS   ,ZERO    ,W(1,134 ))    
      CALL IOVXXX(W(1,134 ),W(1,6   ),W(1,1   ),GAL ,AMP(106 ))            
      CALL FVIXXX(W(1,7   ),W(1,131 ),GAL ,LMASS   ,ZERO    ,W(1,135 ))    
      CALL IOVXXX(W(1,135 ),W(1,6   ),W(1,1   ),GAL ,AMP(107 ))            
      CALL FVIXXX(W(1,7   ),W(1,132 ),GZL ,LMASS   ,ZERO    ,W(1,136 ))    
      CALL IOVXXX(W(1,136 ),W(1,6   ),W(1,1   ),GAL ,AMP(108 ))            
      CALL FVIXXX(W(1,3   ),W(1,1   ),GAU ,ZERO    ,ZERO    ,W(1,137 ))    
      CALL FVIXXX(W(1,137 ),W(1,63  ),GAU ,ZERO    ,ZERO    ,W(1,138 ))    
      CALL JIOXXX(W(1,138 ),W(1,2   ),GAU ,ZERO    ,AWIDTH  ,W(1,139 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,139 ),GAL ,AMP(109 ))            
      CALL JIOXXX(W(1,138 ),W(1,2   ),GZU ,ZMASS   ,ZWIDTH  ,W(1,140 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,140 ),GZL ,AMP(110 ))            
      CALL FVIXXX(W(1,137 ),W(1,60  ),GZU ,ZERO    ,ZERO    ,W(1,141 ))    
      CALL JIOXXX(W(1,141 ),W(1,2   ),GAU ,ZERO    ,AWIDTH  ,W(1,142 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,142 ),GAL ,AMP(111 ))            
      CALL JIOXXX(W(1,141 ),W(1,2   ),GZU ,ZMASS   ,ZWIDTH  ,W(1,143 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,143 ),GZL ,AMP(112 ))            
      CALL FVOXXX(W(1,127 ),W(1,1   ),GAU ,ZERO    ,ZERO    ,W(1,144 ))    
      CALL JIOXXX(W(1,3   ),W(1,144 ),GAU ,ZERO    ,AWIDTH  ,W(1,145 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,145 ),GAL ,AMP(113 ))            
      CALL JIOXXX(W(1,3   ),W(1,144 ),GZU ,ZMASS   ,ZWIDTH  ,W(1,146 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,146 ),GZL ,AMP(114 ))            
      CALL FVOXXX(W(1,130 ),W(1,1   ),GAU ,ZERO    ,ZERO    ,W(1,147 ))    
      CALL JIOXXX(W(1,3   ),W(1,147 ),GAU ,ZERO    ,AWIDTH  ,W(1,148 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,148 ),GAL ,AMP(115 ))            
      CALL JIOXXX(W(1,3   ),W(1,147 ),GZU ,ZMASS   ,ZWIDTH  ,W(1,149 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,149 ),GZL ,AMP(116 ))            
      CALL JIOXXX(W(1,137 ),W(1,2   ),GAU ,ZERO    ,AWIDTH  ,W(1,150 ))    
      CALL FVIXXX(W(1,5   ),W(1,150 ),GAL ,ZERO    ,ZERO    ,W(1,151 ))    
      CALL JIOXXX(W(1,151 ),W(1,4   ),GAL ,ZERO    ,AWIDTH  ,W(1,152 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,152 ),GAL ,AMP(117 ))            
      CALL JIOXXX(W(1,151 ),W(1,4   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,153 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,153 ),GZL ,AMP(118 ))            
      CALL JIOXXX(W(1,137 ),W(1,2   ),GZU ,ZMASS   ,ZWIDTH  ,W(1,154 ))    
      CALL FVIXXX(W(1,5   ),W(1,154 ),GZL ,ZERO    ,ZERO    ,W(1,155 ))    
      CALL JIOXXX(W(1,155 ),W(1,4   ),GAL ,ZERO    ,AWIDTH  ,W(1,156 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,156 ),GAL ,AMP(119 ))            
      CALL JIOXXX(W(1,155 ),W(1,4   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,157 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,157 ),GZL ,AMP(120 ))            
      CALL FVOXXX(W(1,4   ),W(1,150 ),GAL ,ZERO    ,ZERO    ,W(1,158 ))    
      CALL JIOXXX(W(1,5   ),W(1,158 ),GAL ,ZERO    ,AWIDTH  ,W(1,159 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,159 ),GAL ,AMP(121 ))            
      CALL JIOXXX(W(1,5   ),W(1,158 ),GZL ,ZMASS   ,ZWIDTH  ,W(1,160 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,160 ),GZL ,AMP(122 ))            
      CALL FVOXXX(W(1,4   ),W(1,154 ),GZL ,ZERO    ,ZERO    ,W(1,161 ))    
      CALL JIOXXX(W(1,5   ),W(1,161 ),GAL ,ZERO    ,AWIDTH  ,W(1,162 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,162 ),GAL ,AMP(123 ))            
      CALL JIOXXX(W(1,5   ),W(1,161 ),GZL ,ZMASS   ,ZWIDTH  ,W(1,163 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,163 ),GZL ,AMP(124 ))            
      CALL JIOXXX(W(1,137 ),W(1,127 ),GAU ,ZERO    ,AWIDTH  ,W(1,164 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,164 ),GAL ,AMP(125 ))            
      CALL JIOXXX(W(1,137 ),W(1,127 ),GZU ,ZMASS   ,ZWIDTH  ,W(1,165 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,165 ),GZL ,AMP(126 ))            
      CALL JIOXXX(W(1,137 ),W(1,130 ),GAU ,ZERO    ,AWIDTH  ,W(1,166 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,166 ),GAL ,AMP(127 ))            
      CALL JIOXXX(W(1,137 ),W(1,130 ),GZU ,ZMASS   ,ZWIDTH  ,W(1,167 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,167 ),GZL ,AMP(128 ))            
      CALL HVVXXX(W(1,154 ),W(1,60  ),GZZH ,HMASS   ,HWIDTH  ,W(1,         
     &     168 ))                                                          
      CALL IOSXXX(W(1,7   ),W(1,6   ),W(1,168 ),GHTAU ,AMP(129 ))          
      CALL IOVXXX(W(1,68  ),W(1,6   ),W(1,150 ),GAL ,AMP(130 ))            
      CALL IOVXXX(W(1,70  ),W(1,6   ),W(1,150 ),GAL ,AMP(131 ))            
      CALL IOVXXX(W(1,68  ),W(1,6   ),W(1,154 ),GZL ,AMP(132 ))            
      CALL IOVXXX(W(1,70  ),W(1,6   ),W(1,154 ),GZL ,AMP(133 ))            
      CALL FVIXXX(W(1,7   ),W(1,150 ),GAL ,LMASS   ,ZERO    ,W(1,169 ))    
      CALL IOVXXX(W(1,169 ),W(1,6   ),W(1,63  ),GAL ,AMP(134 ))            
      CALL IOVXXX(W(1,169 ),W(1,6   ),W(1,60  ),GZL ,AMP(135 ))            
      CALL FVIXXX(W(1,7   ),W(1,154 ),GZL ,LMASS   ,ZERO    ,W(1,170 ))    
      CALL IOVXXX(W(1,170 ),W(1,6   ),W(1,63  ),GAL ,AMP(136 ))            
      CALL IOVXXX(W(1,170 ),W(1,6   ),W(1,60  ),GZL ,AMP(137 ))            
      CALL FVIXXX(W(1,3   ),W(1,63  ),GAU ,ZERO    ,ZERO    ,W(1,171 ))    
      CALL JIOXXX(W(1,171 ),W(1,2   ),GAU ,ZERO    ,AWIDTH  ,W(1,172 ))    
      CALL IOVXXX(W(1,61  ),W(1,6   ),W(1,172 ),GAL ,AMP(138 ))            
      CALL JIOXXX(W(1,171 ),W(1,2   ),GZU ,ZMASS   ,ZWIDTH  ,W(1,173 ))    
      CALL IOVXXX(W(1,61  ),W(1,6   ),W(1,173 ),GZL ,AMP(139 ))            
      CALL FVIXXX(W(1,3   ),W(1,60  ),GZU ,ZERO    ,ZERO    ,W(1,174 ))    
      CALL JIOXXX(W(1,174 ),W(1,2   ),GAU ,ZERO    ,AWIDTH  ,W(1,175 ))    
      CALL IOVXXX(W(1,61  ),W(1,6   ),W(1,175 ),GAL ,AMP(140 ))            
      CALL JIOXXX(W(1,174 ),W(1,2   ),GZU ,ZMASS   ,ZWIDTH  ,W(1,176 ))    
      CALL IOVXXX(W(1,61  ),W(1,6   ),W(1,176 ),GZL ,AMP(141 ))            
      CALL FVIXXX(W(1,7   ),W(1,172 ),GAL ,LMASS   ,ZERO    ,W(1,177 ))    
      CALL IOVXXX(W(1,177 ),W(1,6   ),W(1,1   ),GAL ,AMP(142 ))            
      CALL FVIXXX(W(1,7   ),W(1,173 ),GZL ,LMASS   ,ZERO    ,W(1,178 ))    
      CALL IOVXXX(W(1,178 ),W(1,6   ),W(1,1   ),GAL ,AMP(143 ))            
      CALL FVIXXX(W(1,7   ),W(1,175 ),GAL ,LMASS   ,ZERO    ,W(1,179 ))    
      CALL IOVXXX(W(1,179 ),W(1,6   ),W(1,1   ),GAL ,AMP(144 ))            
      CALL FVIXXX(W(1,7   ),W(1,176 ),GZL ,LMASS   ,ZERO    ,W(1,180 ))    
      CALL IOVXXX(W(1,180 ),W(1,6   ),W(1,1   ),GAL ,AMP(145 ))            
      CALL FVIXXX(W(1,171 ),W(1,1   ),GAU ,ZERO    ,ZERO    ,W(1,181 ))    
      CALL JIOXXX(W(1,181 ),W(1,2   ),GAU ,ZERO    ,AWIDTH  ,W(1,182 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,182 ),GAL ,AMP(146 ))            
      CALL JIOXXX(W(1,181 ),W(1,2   ),GZU ,ZMASS   ,ZWIDTH  ,W(1,183 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,183 ),GZL ,AMP(147 ))            
      CALL FVIXXX(W(1,174 ),W(1,1   ),GAU ,ZERO    ,ZERO    ,W(1,184 ))    
      CALL JIOXXX(W(1,184 ),W(1,2   ),GAU ,ZERO    ,AWIDTH  ,W(1,185 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,185 ),GAL ,AMP(148 ))            
      CALL JIOXXX(W(1,184 ),W(1,2   ),GZU ,ZMASS   ,ZWIDTH  ,W(1,186 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,186 ),GZL ,AMP(149 ))            
      CALL FVOXXX(W(1,2   ),W(1,1   ),GAU ,ZERO    ,ZERO    ,W(1,187 ))    
      CALL FVOXXX(W(1,187 ),W(1,63  ),GAU ,ZERO    ,ZERO    ,W(1,188 ))    
      CALL JIOXXX(W(1,3   ),W(1,188 ),GAU ,ZERO    ,AWIDTH  ,W(1,189 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,189 ),GAL ,AMP(150 ))            
      CALL JIOXXX(W(1,3   ),W(1,188 ),GZU ,ZMASS   ,ZWIDTH  ,W(1,190 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,190 ),GZL ,AMP(151 ))            
      CALL FVOXXX(W(1,187 ),W(1,60  ),GZU ,ZERO    ,ZERO    ,W(1,191 ))    
      CALL JIOXXX(W(1,3   ),W(1,191 ),GAU ,ZERO    ,AWIDTH  ,W(1,192 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,192 ),GAL ,AMP(152 ))            
      CALL JIOXXX(W(1,3   ),W(1,191 ),GZU ,ZMASS   ,ZWIDTH  ,W(1,193 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,193 ),GZL ,AMP(153 ))            
      CALL JIOXXX(W(1,3   ),W(1,187 ),GAU ,ZERO    ,AWIDTH  ,W(1,194 ))    
      CALL FVIXXX(W(1,5   ),W(1,194 ),GAL ,ZERO    ,ZERO    ,W(1,195 ))    
      CALL JIOXXX(W(1,195 ),W(1,4   ),GAL ,ZERO    ,AWIDTH  ,W(1,196 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,196 ),GAL ,AMP(154 ))            
      CALL JIOXXX(W(1,195 ),W(1,4   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,197 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,197 ),GZL ,AMP(155 ))            
      CALL JIOXXX(W(1,3   ),W(1,187 ),GZU ,ZMASS   ,ZWIDTH  ,W(1,198 ))    
      CALL FVIXXX(W(1,5   ),W(1,198 ),GZL ,ZERO    ,ZERO    ,W(1,199 ))    
      CALL JIOXXX(W(1,199 ),W(1,4   ),GAL ,ZERO    ,AWIDTH  ,W(1,200 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,200 ),GAL ,AMP(156 ))            
      CALL JIOXXX(W(1,199 ),W(1,4   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,201 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,201 ),GZL ,AMP(157 ))            
      CALL FVOXXX(W(1,4   ),W(1,194 ),GAL ,ZERO    ,ZERO    ,W(1,202 ))    
      CALL JIOXXX(W(1,5   ),W(1,202 ),GAL ,ZERO    ,AWIDTH  ,W(1,203 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,203 ),GAL ,AMP(158 ))            
      CALL JIOXXX(W(1,5   ),W(1,202 ),GZL ,ZMASS   ,ZWIDTH  ,W(1,204 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,204 ),GZL ,AMP(159 ))            
      CALL FVOXXX(W(1,4   ),W(1,198 ),GZL ,ZERO    ,ZERO    ,W(1,205 ))    
      CALL JIOXXX(W(1,5   ),W(1,205 ),GAL ,ZERO    ,AWIDTH  ,W(1,206 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,206 ),GAL ,AMP(160 ))            
      CALL JIOXXX(W(1,5   ),W(1,205 ),GZL ,ZMASS   ,ZWIDTH  ,W(1,207 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,207 ),GZL ,AMP(161 ))            
      CALL JIOXXX(W(1,171 ),W(1,187 ),GAU ,ZERO    ,AWIDTH  ,W(1,208 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,208 ),GAL ,AMP(162 ))            
      CALL JIOXXX(W(1,171 ),W(1,187 ),GZU ,ZMASS   ,ZWIDTH  ,W(1,209 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,209 ),GZL ,AMP(163 ))            
      CALL JIOXXX(W(1,174 ),W(1,187 ),GAU ,ZERO    ,AWIDTH  ,W(1,210 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,210 ),GAL ,AMP(164 ))            
      CALL JIOXXX(W(1,174 ),W(1,187 ),GZU ,ZMASS   ,ZWIDTH  ,W(1,211 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,211 ),GZL ,AMP(165 ))            
      CALL HVVXXX(W(1,198 ),W(1,60  ),GZZH ,HMASS   ,HWIDTH  ,W(1,         
     &     212 ))                                                          
      CALL IOSXXX(W(1,7   ),W(1,6   ),W(1,212 ),GHTAU ,AMP(166 ))          
      CALL IOVXXX(W(1,68  ),W(1,6   ),W(1,194 ),GAL ,AMP(167 ))            
      CALL IOVXXX(W(1,70  ),W(1,6   ),W(1,194 ),GAL ,AMP(168 ))            
      CALL IOVXXX(W(1,68  ),W(1,6   ),W(1,198 ),GZL ,AMP(169 ))            
      CALL IOVXXX(W(1,70  ),W(1,6   ),W(1,198 ),GZL ,AMP(170 ))            
      CALL FVIXXX(W(1,7   ),W(1,194 ),GAL ,LMASS   ,ZERO    ,W(1,213 ))    
      CALL IOVXXX(W(1,213 ),W(1,6   ),W(1,63  ),GAL ,AMP(171 ))            
      CALL IOVXXX(W(1,213 ),W(1,6   ),W(1,60  ),GZL ,AMP(172 ))            
      CALL FVIXXX(W(1,7   ),W(1,198 ),GZL ,LMASS   ,ZERO    ,W(1,214 ))    
      CALL IOVXXX(W(1,214 ),W(1,6   ),W(1,63  ),GAL ,AMP(173 ))            
      CALL IOVXXX(W(1,214 ),W(1,6   ),W(1,60  ),GZL ,AMP(174 ))            
      zzztensor(mu) = -AMP(   1)-AMP(   2)-AMP(   3)-AMP(   4)-AMP(   5)
     &             -AMP(   6)-AMP(   7)-AMP(   8)-AMP(   9)-AMP(  10)
     &             -AMP(  11)-AMP(  12)-AMP(  13)-AMP(  14)-AMP(  15)
     &             -AMP(  16)-AMP(  17)-AMP(  18)-AMP(  19)-AMP(  20)
     &             -AMP(  21)-AMP(  22)-AMP(  23)-AMP(  24)-AMP(  25)
     &             -AMP(  26)-AMP(  27)-AMP(  28)-AMP(  29)-AMP(  30)
     &             -AMP(  31)-AMP(  32)-AMP(  33)-AMP(  34)-AMP(  35)
     &             -AMP(  36)-AMP(  37)-AMP(  38)-AMP(  39)-AMP(  40)
     &             -AMP(  41)-AMP(  42)-AMP(  43)-AMP(  44)-AMP(  45)
     &             -AMP(  46)-AMP(  47)-AMP(  48)-AMP(  49)-AMP(  50)
     &             -AMP(  51)-AMP(  52)-AMP(  53)-AMP(  54)-AMP(  55)
     &             -AMP(  56)-AMP(  57)-AMP(  58)-AMP(  59)-AMP(  60)
     &             -AMP(  61)-AMP(  62)-AMP(  63)-AMP(  64)-AMP(  65)
     &             -AMP(  66)-AMP(  67)-AMP(  68)-AMP(  69)-AMP(  70)
     &             -AMP(  71)-AMP(  72)-AMP(  73)-AMP(  74)-AMP(  75)
     &             -AMP(  76)-AMP(  77)-AMP(  78)-AMP(  79)-AMP(  80)
     &             -AMP(  81)-AMP(  82)-AMP(  83)-AMP(  84)-AMP(  85)
     &             -AMP(  86)-AMP(  87)-AMP(  88)-AMP(  89)-AMP(  90)
     &             -AMP(  91)-AMP(  92)-AMP(  93)-AMP(  94)-AMP(  95)
     &             -AMP(  96)-AMP(  97)-AMP(  98)-AMP(  99)-AMP( 100)
     &             -AMP( 101)-AMP( 102)-AMP( 103)-AMP( 104)-AMP( 105)
     &             -AMP( 106)-AMP( 107)-AMP( 108)-AMP( 109)-AMP( 110)
     &             -AMP( 111)-AMP( 112)-AMP( 113)-AMP( 114)-AMP( 115)
     &             -AMP( 116)-AMP( 117)-AMP( 118)-AMP( 119)-AMP( 120)
     &             -AMP( 121)-AMP( 122)-AMP( 123)-AMP( 124)-AMP( 125)
     &             -AMP( 126)-AMP( 127)-AMP( 128)-AMP( 129)-AMP( 130)
     &             -AMP( 131)-AMP( 132)-AMP( 133)-AMP( 134)-AMP( 135)
     &             -AMP( 136)-AMP( 137)-AMP( 138)-AMP( 139)-AMP( 140)
     &             -AMP( 141)-AMP( 142)-AMP( 143)-AMP( 144)-AMP( 145)
     &             -AMP( 146)-AMP( 147)-AMP( 148)-AMP( 149)-AMP( 150)
     &             -AMP( 151)-AMP( 152)-AMP( 153)-AMP( 154)-AMP( 155)
     &             -AMP( 156)-AMP( 157)-AMP( 158)-AMP( 159)-AMP( 160)
     &             -AMP( 161)-AMP( 162)-AMP( 163)-AMP( 164)-AMP( 165)
     &             -AMP( 166)-AMP( 167)-AMP( 168)-AMP( 169)-AMP( 170)
     &             -AMP( 171)-AMP( 172)-AMP( 173)-AMP( 174)

      elseif (procid.eq.ZZZhad .and. Ztodd) then

      CALL JIOXXX(W(1,3   ),W(1,2   ),GAD ,ZERO    ,AWIDTH  ,W(1,8   ))    
      CALL FVOXXX(W(1,4   ),W(1,8   ),GAL ,ZERO    ,ZERO    ,W(1,9   ))    
      CALL JIOXXX(W(1,5   ),W(1,9   ),GAL ,ZERO    ,AWIDTH  ,W(1,10  ))    
      CALL FVOXXX(W(1,6   ),W(1,10  ),GAL ,LMASS   ,ZERO    ,W(1,11  ))    
      CALL IOVXXX(W(1,7   ),W(1,11  ),W(1,1   ),GAL ,AMP(1   ))            
      CALL JIOXXX(W(1,5   ),W(1,9   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,12  ))    
      CALL FVOXXX(W(1,6   ),W(1,12  ),GZL ,LMASS   ,ZERO    ,W(1,13  ))    
      CALL IOVXXX(W(1,7   ),W(1,13  ),W(1,1   ),GAL ,AMP(2   ))            
      CALL JIOXXX(W(1,3   ),W(1,2   ),GZD ,ZMASS   ,ZWIDTH  ,W(1,14  ))    
      CALL FVOXXX(W(1,4   ),W(1,14  ),GZL ,ZERO    ,ZERO    ,W(1,15  ))    
      CALL JIOXXX(W(1,5   ),W(1,15  ),GAL ,ZERO    ,AWIDTH  ,W(1,16  ))    
      CALL FVOXXX(W(1,6   ),W(1,16  ),GAL ,LMASS   ,ZERO    ,W(1,17  ))    
      CALL IOVXXX(W(1,7   ),W(1,17  ),W(1,1   ),GAL ,AMP(3   ))            
      CALL JIOXXX(W(1,5   ),W(1,15  ),GZL ,ZMASS   ,ZWIDTH  ,W(1,18  ))    
      CALL FVOXXX(W(1,6   ),W(1,18  ),GZL ,LMASS   ,ZERO    ,W(1,19  ))    
      CALL IOVXXX(W(1,7   ),W(1,19  ),W(1,1   ),GAL ,AMP(4   ))            
      CALL FVIXXX(W(1,7   ),W(1,10  ),GAL ,LMASS   ,ZERO    ,W(1,20  ))    
      CALL IOVXXX(W(1,20  ),W(1,6   ),W(1,1   ),GAL ,AMP(5   ))            
      CALL FVIXXX(W(1,7   ),W(1,12  ),GZL ,LMASS   ,ZERO    ,W(1,21  ))    
      CALL IOVXXX(W(1,21  ),W(1,6   ),W(1,1   ),GAL ,AMP(6   ))            
      CALL FVIXXX(W(1,7   ),W(1,16  ),GAL ,LMASS   ,ZERO    ,W(1,22  ))    
      CALL IOVXXX(W(1,22  ),W(1,6   ),W(1,1   ),GAL ,AMP(7   ))            
      CALL FVIXXX(W(1,7   ),W(1,18  ),GZL ,LMASS   ,ZERO    ,W(1,23  ))    
      CALL IOVXXX(W(1,23  ),W(1,6   ),W(1,1   ),GAL ,AMP(8   ))            
      CALL FVIXXX(W(1,5   ),W(1,1   ),GAL ,ZERO    ,ZERO    ,W(1,24  ))    
      CALL JIOXXX(W(1,24  ),W(1,4   ),GAL ,ZERO    ,AWIDTH  ,W(1,25  ))    
      CALL FVIXXX(W(1,3   ),W(1,25  ),GAD ,ZERO    ,ZERO    ,W(1,26  ))    
      CALL JIOXXX(W(1,26  ),W(1,2   ),GAD ,ZERO    ,AWIDTH  ,W(1,27  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,27  ),GAL ,AMP(9   ))            
      CALL JIOXXX(W(1,26  ),W(1,2   ),GZD ,ZMASS   ,ZWIDTH  ,W(1,28  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,28  ),GZL ,AMP(10  ))            
      CALL JIOXXX(W(1,24  ),W(1,4   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,29  ))    
      CALL FVIXXX(W(1,3   ),W(1,29  ),GZD ,ZERO    ,ZERO    ,W(1,30  ))    
      CALL JIOXXX(W(1,30  ),W(1,2   ),GAD ,ZERO    ,AWIDTH  ,W(1,31  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,31  ),GAL ,AMP(11  ))            
      CALL JIOXXX(W(1,30  ),W(1,2   ),GZD ,ZMASS   ,ZWIDTH  ,W(1,32  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,32  ),GZL ,AMP(12  ))            
      CALL FVOXXX(W(1,2   ),W(1,25  ),GAD ,ZERO    ,ZERO    ,W(1,33  ))    
      CALL JIOXXX(W(1,3   ),W(1,33  ),GAD ,ZERO    ,AWIDTH  ,W(1,34  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,34  ),GAL ,AMP(13  ))            
      CALL JIOXXX(W(1,3   ),W(1,33  ),GZD ,ZMASS   ,ZWIDTH  ,W(1,35  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,35  ),GZL ,AMP(14  ))            
      CALL FVOXXX(W(1,2   ),W(1,29  ),GZD ,ZERO    ,ZERO    ,W(1,36  ))    
      CALL JIOXXX(W(1,3   ),W(1,36  ),GAD ,ZERO    ,AWIDTH  ,W(1,37  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,37  ),GAL ,AMP(15  ))            
      CALL JIOXXX(W(1,3   ),W(1,36  ),GZD ,ZMASS   ,ZWIDTH  ,W(1,38  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,38  ),GZL ,AMP(16  ))            
      CALL FVIXXX(W(1,24  ),W(1,8   ),GAL ,ZERO    ,ZERO    ,W(1,39  ))    
      CALL JIOXXX(W(1,39  ),W(1,4   ),GAL ,ZERO    ,AWIDTH  ,W(1,40  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,40  ),GAL ,AMP(17  ))            
      CALL JIOXXX(W(1,39  ),W(1,4   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,41  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,41  ),GZL ,AMP(18  ))            
      CALL FVIXXX(W(1,24  ),W(1,14  ),GZL ,ZERO    ,ZERO    ,W(1,42  ))    
      CALL JIOXXX(W(1,42  ),W(1,4   ),GAL ,ZERO    ,AWIDTH  ,W(1,43  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,43  ),GAL ,AMP(19  ))            
      CALL JIOXXX(W(1,42  ),W(1,4   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,44  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,44  ),GZL ,AMP(20  ))            
      CALL FVOXXX(W(1,9   ),W(1,1   ),GAL ,ZERO    ,ZERO    ,W(1,45  ))    
      CALL JIOXXX(W(1,5   ),W(1,45  ),GAL ,ZERO    ,AWIDTH  ,W(1,46  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,46  ),GAL ,AMP(21  ))            
      CALL JIOXXX(W(1,5   ),W(1,45  ),GZL ,ZMASS   ,ZWIDTH  ,W(1,47  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,47  ),GZL ,AMP(22  ))            
      CALL FVOXXX(W(1,15  ),W(1,1   ),GAL ,ZERO    ,ZERO    ,W(1,48  ))    
      CALL JIOXXX(W(1,5   ),W(1,48  ),GAL ,ZERO    ,AWIDTH  ,W(1,49  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,49  ),GAL ,AMP(23  ))            
      CALL JIOXXX(W(1,5   ),W(1,48  ),GZL ,ZMASS   ,ZWIDTH  ,W(1,50  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,50  ),GZL ,AMP(24  ))            
      CALL HVVXXX(W(1,14  ),W(1,29  ),GZZH ,HMASS   ,HWIDTH  ,W(1,         
     &     51  ))                                                          
      CALL IOSXXX(W(1,7   ),W(1,6   ),W(1,51  ),GHTAU ,AMP(25  ))          
      CALL FVIXXX(W(1,7   ),W(1,25  ),GAL ,LMASS   ,ZERO    ,W(1,52  ))    
      CALL IOVXXX(W(1,52  ),W(1,6   ),W(1,8   ),GAL ,AMP(26  ))            
      CALL FVIXXX(W(1,7   ),W(1,29  ),GZL ,LMASS   ,ZERO    ,W(1,53  ))    
      CALL IOVXXX(W(1,53  ),W(1,6   ),W(1,8   ),GAL ,AMP(27  ))            
      CALL IOVXXX(W(1,52  ),W(1,6   ),W(1,14  ),GZL ,AMP(28  ))            
      CALL IOVXXX(W(1,53  ),W(1,6   ),W(1,14  ),GZL ,AMP(29  ))            
      CALL FVIXXX(W(1,7   ),W(1,8   ),GAL ,LMASS   ,ZERO    ,W(1,54  ))    
      CALL IOVXXX(W(1,54  ),W(1,6   ),W(1,25  ),GAL ,AMP(30  ))            
      CALL IOVXXX(W(1,54  ),W(1,6   ),W(1,29  ),GZL ,AMP(31  ))            
      CALL FVIXXX(W(1,7   ),W(1,14  ),GZL ,LMASS   ,ZERO    ,W(1,55  ))    
      CALL IOVXXX(W(1,55  ),W(1,6   ),W(1,25  ),GAL ,AMP(32  ))            
      CALL IOVXXX(W(1,55  ),W(1,6   ),W(1,29  ),GZL ,AMP(33  ))            
      CALL JIOXXX(W(1,24  ),W(1,9   ),GAL ,ZERO    ,AWIDTH  ,W(1,56  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,56  ),GAL ,AMP(34  ))            
      CALL JIOXXX(W(1,24  ),W(1,9   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,57  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,57  ),GZL ,AMP(35  ))            
      CALL JIOXXX(W(1,24  ),W(1,15  ),GAL ,ZERO    ,AWIDTH  ,W(1,58  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,58  ),GAL ,AMP(36  ))            
      CALL JIOXXX(W(1,24  ),W(1,15  ),GZL ,ZMASS   ,ZWIDTH  ,W(1,59  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,59  ),GZL ,AMP(37  ))            
      CALL JIOXXX(W(1,5   ),W(1,4   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,60  ))    
      CALL FVIXXX(W(1,7   ),W(1,1   ),GAL ,LMASS   ,ZERO    ,W(1,61  ))    
      CALL HVVXXX(W(1,60  ),W(1,14  ),GZZH ,HMASS   ,HWIDTH  ,W(1,         
     &     62  ))                                                          
      CALL IOSXXX(W(1,61  ),W(1,6   ),W(1,62  ),GHTAU ,AMP(38  ))          
      CALL JIOXXX(W(1,5   ),W(1,4   ),GAL ,ZERO    ,AWIDTH  ,W(1,63  ))    
      CALL FVIXXX(W(1,54  ),W(1,63  ),GAL ,LMASS   ,ZERO    ,W(1,64  ))    
      CALL IOVXXX(W(1,64  ),W(1,6   ),W(1,1   ),GAL ,AMP(39  ))            
      CALL FVIXXX(W(1,54  ),W(1,60  ),GZL ,LMASS   ,ZERO    ,W(1,65  ))    
      CALL IOVXXX(W(1,65  ),W(1,6   ),W(1,1   ),GAL ,AMP(40  ))            
      CALL FVIXXX(W(1,55  ),W(1,63  ),GAL ,LMASS   ,ZERO    ,W(1,66  ))    
      CALL IOVXXX(W(1,66  ),W(1,6   ),W(1,1   ),GAL ,AMP(41  ))            
      CALL FVIXXX(W(1,55  ),W(1,60  ),GZL ,LMASS   ,ZERO    ,W(1,67  ))    
      CALL IOVXXX(W(1,67  ),W(1,6   ),W(1,1   ),GAL ,AMP(42  ))            
      CALL FVIXXX(W(1,7   ),W(1,63  ),GAL ,LMASS   ,ZERO    ,W(1,68  ))    
      CALL FVIXXX(W(1,68  ),W(1,8   ),GAL ,LMASS   ,ZERO    ,W(1,69  ))    
      CALL IOVXXX(W(1,69  ),W(1,6   ),W(1,1   ),GAL ,AMP(43  ))            
      CALL FVIXXX(W(1,7   ),W(1,60  ),GZL ,LMASS   ,ZERO    ,W(1,70  ))    
      CALL FVIXXX(W(1,70  ),W(1,8   ),GAL ,LMASS   ,ZERO    ,W(1,71  ))    
      CALL IOVXXX(W(1,71  ),W(1,6   ),W(1,1   ),GAL ,AMP(44  ))            
      CALL FVIXXX(W(1,68  ),W(1,14  ),GZL ,LMASS   ,ZERO    ,W(1,72  ))    
      CALL IOVXXX(W(1,72  ),W(1,6   ),W(1,1   ),GAL ,AMP(45  ))            
      CALL FVIXXX(W(1,70  ),W(1,14  ),GZL ,LMASS   ,ZERO    ,W(1,73  ))    
      CALL IOVXXX(W(1,73  ),W(1,6   ),W(1,1   ),GAL ,AMP(46  ))            
      CALL FSIXXX(W(1,7   ),W(1,62  ),GHTAU ,LMASS   ,ZERO    ,W(1,        
     &     74  ))                                                          
      CALL IOVXXX(W(1,74  ),W(1,6   ),W(1,1   ),GAL ,AMP(47  ))            
      CALL FVIXXX(W(1,61  ),W(1,63  ),GAL ,LMASS   ,ZERO    ,W(1,75  ))    
      CALL IOVXXX(W(1,75  ),W(1,6   ),W(1,8   ),GAL ,AMP(48  ))            
      CALL FVIXXX(W(1,61  ),W(1,60  ),GZL ,LMASS   ,ZERO    ,W(1,76  ))    
      CALL IOVXXX(W(1,76  ),W(1,6   ),W(1,8   ),GAL ,AMP(49  ))            
      CALL IOVXXX(W(1,75  ),W(1,6   ),W(1,14  ),GZL ,AMP(50  ))            
      CALL IOVXXX(W(1,76  ),W(1,6   ),W(1,14  ),GZL ,AMP(51  ))            
      CALL FVIXXX(W(1,68  ),W(1,1   ),GAL ,LMASS   ,ZERO    ,W(1,77  ))    
      CALL IOVXXX(W(1,77  ),W(1,6   ),W(1,8   ),GAL ,AMP(52  ))            
      CALL FVIXXX(W(1,70  ),W(1,1   ),GAL ,LMASS   ,ZERO    ,W(1,78  ))    
      CALL IOVXXX(W(1,78  ),W(1,6   ),W(1,8   ),GAL ,AMP(53  ))            
      CALL IOVXXX(W(1,77  ),W(1,6   ),W(1,14  ),GZL ,AMP(54  ))            
      CALL IOVXXX(W(1,78  ),W(1,6   ),W(1,14  ),GZL ,AMP(55  ))            
      CALL FVIXXX(W(1,61  ),W(1,8   ),GAL ,LMASS   ,ZERO    ,W(1,79  ))    
      CALL IOVXXX(W(1,79  ),W(1,6   ),W(1,63  ),GAL ,AMP(56  ))            
      CALL IOVXXX(W(1,79  ),W(1,6   ),W(1,60  ),GZL ,AMP(57  ))            
      CALL FVIXXX(W(1,61  ),W(1,14  ),GZL ,LMASS   ,ZERO    ,W(1,80  ))    
      CALL IOVXXX(W(1,80  ),W(1,6   ),W(1,63  ),GAL ,AMP(58  ))            
      CALL IOVXXX(W(1,80  ),W(1,6   ),W(1,60  ),GZL ,AMP(59  ))            
      CALL FVIXXX(W(1,54  ),W(1,1   ),GAL ,LMASS   ,ZERO    ,W(1,81  ))    
      CALL IOVXXX(W(1,81  ),W(1,6   ),W(1,63  ),GAL ,AMP(60  ))            
      CALL IOVXXX(W(1,81  ),W(1,6   ),W(1,60  ),GZL ,AMP(61  ))            
      CALL FVIXXX(W(1,55  ),W(1,1   ),GAL ,LMASS   ,ZERO    ,W(1,82  ))    
      CALL IOVXXX(W(1,82  ),W(1,6   ),W(1,63  ),GAL ,AMP(62  ))            
      CALL IOVXXX(W(1,82  ),W(1,6   ),W(1,60  ),GZL ,AMP(63  ))            
      CALL FVIXXX(W(1,5   ),W(1,8   ),GAL ,ZERO    ,ZERO    ,W(1,83  ))    
      CALL JIOXXX(W(1,83  ),W(1,4   ),GAL ,ZERO    ,AWIDTH  ,W(1,84  ))    
      CALL IOVXXX(W(1,61  ),W(1,6   ),W(1,84  ),GAL ,AMP(64  ))            
      CALL JIOXXX(W(1,83  ),W(1,4   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,85  ))    
      CALL IOVXXX(W(1,61  ),W(1,6   ),W(1,85  ),GZL ,AMP(65  ))            
      CALL FVIXXX(W(1,5   ),W(1,14  ),GZL ,ZERO    ,ZERO    ,W(1,86  ))    
      CALL JIOXXX(W(1,86  ),W(1,4   ),GAL ,ZERO    ,AWIDTH  ,W(1,87  ))    
      CALL IOVXXX(W(1,61  ),W(1,6   ),W(1,87  ),GAL ,AMP(66  ))            
      CALL JIOXXX(W(1,86  ),W(1,4   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,88  ))    
      CALL IOVXXX(W(1,61  ),W(1,6   ),W(1,88  ),GZL ,AMP(67  ))            
      CALL FVIXXX(W(1,7   ),W(1,84  ),GAL ,LMASS   ,ZERO    ,W(1,89  ))    
      CALL IOVXXX(W(1,89  ),W(1,6   ),W(1,1   ),GAL ,AMP(68  ))            
      CALL FVIXXX(W(1,7   ),W(1,85  ),GZL ,LMASS   ,ZERO    ,W(1,90  ))    
      CALL IOVXXX(W(1,90  ),W(1,6   ),W(1,1   ),GAL ,AMP(69  ))            
      CALL FVIXXX(W(1,7   ),W(1,87  ),GAL ,LMASS   ,ZERO    ,W(1,91  ))    
      CALL IOVXXX(W(1,91  ),W(1,6   ),W(1,1   ),GAL ,AMP(70  ))            
      CALL FVIXXX(W(1,7   ),W(1,88  ),GZL ,LMASS   ,ZERO    ,W(1,92  ))    
      CALL IOVXXX(W(1,92  ),W(1,6   ),W(1,1   ),GAL ,AMP(71  ))            
      CALL FVOXXX(W(1,4   ),W(1,1   ),GAL ,ZERO    ,ZERO    ,W(1,93  ))    
      CALL JIOXXX(W(1,5   ),W(1,93  ),GAL ,ZERO    ,AWIDTH  ,W(1,94  ))    
      CALL FVIXXX(W(1,3   ),W(1,94  ),GAD ,ZERO    ,ZERO    ,W(1,95  ))    
      CALL JIOXXX(W(1,95  ),W(1,2   ),GAD ,ZERO    ,AWIDTH  ,W(1,96  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,96  ),GAL ,AMP(72  ))            
      CALL JIOXXX(W(1,95  ),W(1,2   ),GZD ,ZMASS   ,ZWIDTH  ,W(1,97  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,97  ),GZL ,AMP(73  ))            
      CALL JIOXXX(W(1,5   ),W(1,93  ),GZL ,ZMASS   ,ZWIDTH  ,W(1,98  ))    
      CALL FVIXXX(W(1,3   ),W(1,98  ),GZD ,ZERO    ,ZERO    ,W(1,99  ))    
      CALL JIOXXX(W(1,99  ),W(1,2   ),GAD ,ZERO    ,AWIDTH  ,W(1,100 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,100 ),GAL ,AMP(74  ))            
      CALL JIOXXX(W(1,99  ),W(1,2   ),GZD ,ZMASS   ,ZWIDTH  ,W(1,101 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,101 ),GZL ,AMP(75  ))            
      CALL FVOXXX(W(1,2   ),W(1,94  ),GAD ,ZERO    ,ZERO    ,W(1,102 ))    
      CALL JIOXXX(W(1,3   ),W(1,102 ),GAD ,ZERO    ,AWIDTH  ,W(1,103 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,103 ),GAL ,AMP(76  ))            
      CALL JIOXXX(W(1,3   ),W(1,102 ),GZD ,ZMASS   ,ZWIDTH  ,W(1,104 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,104 ),GZL ,AMP(77  ))            
      CALL FVOXXX(W(1,2   ),W(1,98  ),GZD ,ZERO    ,ZERO    ,W(1,105 ))    
      CALL JIOXXX(W(1,3   ),W(1,105 ),GAD ,ZERO    ,AWIDTH  ,W(1,106 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,106 ),GAL ,AMP(78  ))            
      CALL JIOXXX(W(1,3   ),W(1,105 ),GZD ,ZMASS   ,ZWIDTH  ,W(1,107 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,107 ),GZL ,AMP(79  ))            
      CALL FVIXXX(W(1,83  ),W(1,1   ),GAL ,ZERO    ,ZERO    ,W(1,108 ))    
      CALL JIOXXX(W(1,108 ),W(1,4   ),GAL ,ZERO    ,AWIDTH  ,W(1,109 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,109 ),GAL ,AMP(80  ))            
      CALL JIOXXX(W(1,108 ),W(1,4   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,110 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,110 ),GZL ,AMP(81  ))            
      CALL FVIXXX(W(1,86  ),W(1,1   ),GAL ,ZERO    ,ZERO    ,W(1,111 ))    
      CALL JIOXXX(W(1,111 ),W(1,4   ),GAL ,ZERO    ,AWIDTH  ,W(1,112 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,112 ),GAL ,AMP(82  ))            
      CALL JIOXXX(W(1,111 ),W(1,4   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,113 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,113 ),GZL ,AMP(83  ))            
      CALL FVOXXX(W(1,93  ),W(1,8   ),GAL ,ZERO    ,ZERO    ,W(1,114 ))    
      CALL JIOXXX(W(1,5   ),W(1,114 ),GAL ,ZERO    ,AWIDTH  ,W(1,115 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,115 ),GAL ,AMP(84  ))            
      CALL JIOXXX(W(1,5   ),W(1,114 ),GZL ,ZMASS   ,ZWIDTH  ,W(1,116 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,116 ),GZL ,AMP(85  ))            
      CALL FVOXXX(W(1,93  ),W(1,14  ),GZL ,ZERO    ,ZERO    ,W(1,117 ))    
      CALL JIOXXX(W(1,5   ),W(1,117 ),GAL ,ZERO    ,AWIDTH  ,W(1,118 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,118 ),GAL ,AMP(86  ))            
      CALL JIOXXX(W(1,5   ),W(1,117 ),GZL ,ZMASS   ,ZWIDTH  ,W(1,119 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,119 ),GZL ,AMP(87  ))            
      CALL JIOXXX(W(1,83  ),W(1,93  ),GAL ,ZERO    ,AWIDTH  ,W(1,120 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,120 ),GAL ,AMP(88  ))            
      CALL JIOXXX(W(1,83  ),W(1,93  ),GZL ,ZMASS   ,ZWIDTH  ,W(1,121 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,121 ),GZL ,AMP(89  ))            
      CALL JIOXXX(W(1,86  ),W(1,93  ),GAL ,ZERO    ,AWIDTH  ,W(1,122 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,122 ),GAL ,AMP(90  ))            
      CALL JIOXXX(W(1,86  ),W(1,93  ),GZL ,ZMASS   ,ZWIDTH  ,W(1,123 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,123 ),GZL ,AMP(91  ))            
      CALL HVVXXX(W(1,14  ),W(1,98  ),GZZH ,HMASS   ,HWIDTH  ,W(1,         
     &     124 ))                                                          
      CALL IOSXXX(W(1,7   ),W(1,6   ),W(1,124 ),GHTAU ,AMP(92  ))          
      CALL FVIXXX(W(1,7   ),W(1,94  ),GAL ,LMASS   ,ZERO    ,W(1,125 ))    
      CALL IOVXXX(W(1,125 ),W(1,6   ),W(1,8   ),GAL ,AMP(93  ))            
      CALL FVIXXX(W(1,7   ),W(1,98  ),GZL ,LMASS   ,ZERO    ,W(1,126 ))    
      CALL IOVXXX(W(1,126 ),W(1,6   ),W(1,8   ),GAL ,AMP(94  ))            
      CALL IOVXXX(W(1,125 ),W(1,6   ),W(1,14  ),GZL ,AMP(95  ))            
      CALL IOVXXX(W(1,126 ),W(1,6   ),W(1,14  ),GZL ,AMP(96  ))            
      CALL IOVXXX(W(1,54  ),W(1,6   ),W(1,94  ),GAL ,AMP(97  ))            
      CALL IOVXXX(W(1,54  ),W(1,6   ),W(1,98  ),GZL ,AMP(98  ))            
      CALL IOVXXX(W(1,55  ),W(1,6   ),W(1,94  ),GAL ,AMP(99  ))            
      CALL IOVXXX(W(1,55  ),W(1,6   ),W(1,98  ),GZL ,AMP(100 ))            
      CALL FVOXXX(W(1,2   ),W(1,63  ),GAD ,ZERO    ,ZERO    ,W(1,127 ))    
      CALL JIOXXX(W(1,3   ),W(1,127 ),GAD ,ZERO    ,AWIDTH  ,W(1,128 ))    
      CALL IOVXXX(W(1,61  ),W(1,6   ),W(1,128 ),GAL ,AMP(101 ))            
      CALL JIOXXX(W(1,3   ),W(1,127 ),GZD ,ZMASS   ,ZWIDTH  ,W(1,129 ))    
      CALL IOVXXX(W(1,61  ),W(1,6   ),W(1,129 ),GZL ,AMP(102 ))            
      CALL FVOXXX(W(1,2   ),W(1,60  ),GZD ,ZERO    ,ZERO    ,W(1,130 ))    
      CALL JIOXXX(W(1,3   ),W(1,130 ),GAD ,ZERO    ,AWIDTH  ,W(1,131 ))    
      CALL IOVXXX(W(1,61  ),W(1,6   ),W(1,131 ),GAL ,AMP(103 ))            
      CALL JIOXXX(W(1,3   ),W(1,130 ),GZD ,ZMASS   ,ZWIDTH  ,W(1,132 ))    
      CALL IOVXXX(W(1,61  ),W(1,6   ),W(1,132 ),GZL ,AMP(104 ))            
      CALL FVIXXX(W(1,7   ),W(1,128 ),GAL ,LMASS   ,ZERO    ,W(1,133 ))    
      CALL IOVXXX(W(1,133 ),W(1,6   ),W(1,1   ),GAL ,AMP(105 ))            
      CALL FVIXXX(W(1,7   ),W(1,129 ),GZL ,LMASS   ,ZERO    ,W(1,134 ))    
      CALL IOVXXX(W(1,134 ),W(1,6   ),W(1,1   ),GAL ,AMP(106 ))            
      CALL FVIXXX(W(1,7   ),W(1,131 ),GAL ,LMASS   ,ZERO    ,W(1,135 ))    
      CALL IOVXXX(W(1,135 ),W(1,6   ),W(1,1   ),GAL ,AMP(107 ))            
      CALL FVIXXX(W(1,7   ),W(1,132 ),GZL ,LMASS   ,ZERO    ,W(1,136 ))    
      CALL IOVXXX(W(1,136 ),W(1,6   ),W(1,1   ),GAL ,AMP(108 ))            
      CALL FVIXXX(W(1,3   ),W(1,1   ),GAD ,ZERO    ,ZERO    ,W(1,137 ))    
      CALL FVIXXX(W(1,137 ),W(1,63  ),GAD ,ZERO    ,ZERO    ,W(1,138 ))    
      CALL JIOXXX(W(1,138 ),W(1,2   ),GAD ,ZERO    ,AWIDTH  ,W(1,139 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,139 ),GAL ,AMP(109 ))            
      CALL JIOXXX(W(1,138 ),W(1,2   ),GZD ,ZMASS   ,ZWIDTH  ,W(1,140 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,140 ),GZL ,AMP(110 ))            
      CALL FVIXXX(W(1,137 ),W(1,60  ),GZD ,ZERO    ,ZERO    ,W(1,141 ))    
      CALL JIOXXX(W(1,141 ),W(1,2   ),GAD ,ZERO    ,AWIDTH  ,W(1,142 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,142 ),GAL ,AMP(111 ))            
      CALL JIOXXX(W(1,141 ),W(1,2   ),GZD ,ZMASS   ,ZWIDTH  ,W(1,143 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,143 ),GZL ,AMP(112 ))            
      CALL FVOXXX(W(1,127 ),W(1,1   ),GAD ,ZERO    ,ZERO    ,W(1,144 ))    
      CALL JIOXXX(W(1,3   ),W(1,144 ),GAD ,ZERO    ,AWIDTH  ,W(1,145 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,145 ),GAL ,AMP(113 ))            
      CALL JIOXXX(W(1,3   ),W(1,144 ),GZD ,ZMASS   ,ZWIDTH  ,W(1,146 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,146 ),GZL ,AMP(114 ))            
      CALL FVOXXX(W(1,130 ),W(1,1   ),GAD ,ZERO    ,ZERO    ,W(1,147 ))    
      CALL JIOXXX(W(1,3   ),W(1,147 ),GAD ,ZERO    ,AWIDTH  ,W(1,148 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,148 ),GAL ,AMP(115 ))            
      CALL JIOXXX(W(1,3   ),W(1,147 ),GZD ,ZMASS   ,ZWIDTH  ,W(1,149 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,149 ),GZL ,AMP(116 ))            
      CALL JIOXXX(W(1,137 ),W(1,2   ),GAD ,ZERO    ,AWIDTH  ,W(1,150 ))    
      CALL FVIXXX(W(1,5   ),W(1,150 ),GAL ,ZERO    ,ZERO    ,W(1,151 ))    
      CALL JIOXXX(W(1,151 ),W(1,4   ),GAL ,ZERO    ,AWIDTH  ,W(1,152 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,152 ),GAL ,AMP(117 ))            
      CALL JIOXXX(W(1,151 ),W(1,4   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,153 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,153 ),GZL ,AMP(118 ))            
      CALL JIOXXX(W(1,137 ),W(1,2   ),GZD ,ZMASS   ,ZWIDTH  ,W(1,154 ))    
      CALL FVIXXX(W(1,5   ),W(1,154 ),GZL ,ZERO    ,ZERO    ,W(1,155 ))    
      CALL JIOXXX(W(1,155 ),W(1,4   ),GAL ,ZERO    ,AWIDTH  ,W(1,156 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,156 ),GAL ,AMP(119 ))            
      CALL JIOXXX(W(1,155 ),W(1,4   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,157 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,157 ),GZL ,AMP(120 ))            
      CALL FVOXXX(W(1,4   ),W(1,150 ),GAL ,ZERO    ,ZERO    ,W(1,158 ))    
      CALL JIOXXX(W(1,5   ),W(1,158 ),GAL ,ZERO    ,AWIDTH  ,W(1,159 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,159 ),GAL ,AMP(121 ))            
      CALL JIOXXX(W(1,5   ),W(1,158 ),GZL ,ZMASS   ,ZWIDTH  ,W(1,160 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,160 ),GZL ,AMP(122 ))            
      CALL FVOXXX(W(1,4   ),W(1,154 ),GZL ,ZERO    ,ZERO    ,W(1,161 ))    
      CALL JIOXXX(W(1,5   ),W(1,161 ),GAL ,ZERO    ,AWIDTH  ,W(1,162 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,162 ),GAL ,AMP(123 ))            
      CALL JIOXXX(W(1,5   ),W(1,161 ),GZL ,ZMASS   ,ZWIDTH  ,W(1,163 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,163 ),GZL ,AMP(124 ))            
      CALL JIOXXX(W(1,137 ),W(1,127 ),GAD ,ZERO    ,AWIDTH  ,W(1,164 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,164 ),GAL ,AMP(125 ))            
      CALL JIOXXX(W(1,137 ),W(1,127 ),GZD ,ZMASS   ,ZWIDTH  ,W(1,165 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,165 ),GZL ,AMP(126 ))            
      CALL JIOXXX(W(1,137 ),W(1,130 ),GAD ,ZERO    ,AWIDTH  ,W(1,166 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,166 ),GAL ,AMP(127 ))            
      CALL JIOXXX(W(1,137 ),W(1,130 ),GZD ,ZMASS   ,ZWIDTH  ,W(1,167 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,167 ),GZL ,AMP(128 ))            
      CALL HVVXXX(W(1,154 ),W(1,60  ),GZZH ,HMASS   ,HWIDTH  ,W(1,         
     &     168 ))                                                          
      CALL IOSXXX(W(1,7   ),W(1,6   ),W(1,168 ),GHTAU ,AMP(129 ))          
      CALL IOVXXX(W(1,68  ),W(1,6   ),W(1,150 ),GAL ,AMP(130 ))            
      CALL IOVXXX(W(1,70  ),W(1,6   ),W(1,150 ),GAL ,AMP(131 ))            
      CALL IOVXXX(W(1,68  ),W(1,6   ),W(1,154 ),GZL ,AMP(132 ))            
      CALL IOVXXX(W(1,70  ),W(1,6   ),W(1,154 ),GZL ,AMP(133 ))            
      CALL FVIXXX(W(1,7   ),W(1,150 ),GAL ,LMASS   ,ZERO    ,W(1,169 ))    
      CALL IOVXXX(W(1,169 ),W(1,6   ),W(1,63  ),GAL ,AMP(134 ))            
      CALL IOVXXX(W(1,169 ),W(1,6   ),W(1,60  ),GZL ,AMP(135 ))            
      CALL FVIXXX(W(1,7   ),W(1,154 ),GZL ,LMASS   ,ZERO    ,W(1,170 ))    
      CALL IOVXXX(W(1,170 ),W(1,6   ),W(1,63  ),GAL ,AMP(136 ))            
      CALL IOVXXX(W(1,170 ),W(1,6   ),W(1,60  ),GZL ,AMP(137 ))            
      CALL FVIXXX(W(1,3   ),W(1,63  ),GAD ,ZERO    ,ZERO    ,W(1,171 ))    
      CALL JIOXXX(W(1,171 ),W(1,2   ),GAD ,ZERO    ,AWIDTH  ,W(1,172 ))    
      CALL IOVXXX(W(1,61  ),W(1,6   ),W(1,172 ),GAL ,AMP(138 ))            
      CALL JIOXXX(W(1,171 ),W(1,2   ),GZD ,ZMASS   ,ZWIDTH  ,W(1,173 ))    
      CALL IOVXXX(W(1,61  ),W(1,6   ),W(1,173 ),GZL ,AMP(139 ))            
      CALL FVIXXX(W(1,3   ),W(1,60  ),GZD ,ZERO    ,ZERO    ,W(1,174 ))    
      CALL JIOXXX(W(1,174 ),W(1,2   ),GAD ,ZERO    ,AWIDTH  ,W(1,175 ))    
      CALL IOVXXX(W(1,61  ),W(1,6   ),W(1,175 ),GAL ,AMP(140 ))            
      CALL JIOXXX(W(1,174 ),W(1,2   ),GZD ,ZMASS   ,ZWIDTH  ,W(1,176 ))    
      CALL IOVXXX(W(1,61  ),W(1,6   ),W(1,176 ),GZL ,AMP(141 ))            
      CALL FVIXXX(W(1,7   ),W(1,172 ),GAL ,LMASS   ,ZERO    ,W(1,177 ))    
      CALL IOVXXX(W(1,177 ),W(1,6   ),W(1,1   ),GAL ,AMP(142 ))            
      CALL FVIXXX(W(1,7   ),W(1,173 ),GZL ,LMASS   ,ZERO    ,W(1,178 ))    
      CALL IOVXXX(W(1,178 ),W(1,6   ),W(1,1   ),GAL ,AMP(143 ))            
      CALL FVIXXX(W(1,7   ),W(1,175 ),GAL ,LMASS   ,ZERO    ,W(1,179 ))    
      CALL IOVXXX(W(1,179 ),W(1,6   ),W(1,1   ),GAL ,AMP(144 ))            
      CALL FVIXXX(W(1,7   ),W(1,176 ),GZL ,LMASS   ,ZERO    ,W(1,180 ))    
      CALL IOVXXX(W(1,180 ),W(1,6   ),W(1,1   ),GAL ,AMP(145 ))            
      CALL FVIXXX(W(1,171 ),W(1,1   ),GAD ,ZERO    ,ZERO    ,W(1,181 ))    
      CALL JIOXXX(W(1,181 ),W(1,2   ),GAD ,ZERO    ,AWIDTH  ,W(1,182 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,182 ),GAL ,AMP(146 ))            
      CALL JIOXXX(W(1,181 ),W(1,2   ),GZD ,ZMASS   ,ZWIDTH  ,W(1,183 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,183 ),GZL ,AMP(147 ))            
      CALL FVIXXX(W(1,174 ),W(1,1   ),GAD ,ZERO    ,ZERO    ,W(1,184 ))    
      CALL JIOXXX(W(1,184 ),W(1,2   ),GAD ,ZERO    ,AWIDTH  ,W(1,185 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,185 ),GAL ,AMP(148 ))            
      CALL JIOXXX(W(1,184 ),W(1,2   ),GZD ,ZMASS   ,ZWIDTH  ,W(1,186 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,186 ),GZL ,AMP(149 ))            
      CALL FVOXXX(W(1,2   ),W(1,1   ),GAD ,ZERO    ,ZERO    ,W(1,187 ))    
      CALL FVOXXX(W(1,187 ),W(1,63  ),GAD ,ZERO    ,ZERO    ,W(1,188 ))    
      CALL JIOXXX(W(1,3   ),W(1,188 ),GAD ,ZERO    ,AWIDTH  ,W(1,189 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,189 ),GAL ,AMP(150 ))            
      CALL JIOXXX(W(1,3   ),W(1,188 ),GZD ,ZMASS   ,ZWIDTH  ,W(1,190 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,190 ),GZL ,AMP(151 ))            
      CALL FVOXXX(W(1,187 ),W(1,60  ),GZD ,ZERO    ,ZERO    ,W(1,191 ))    
      CALL JIOXXX(W(1,3   ),W(1,191 ),GAD ,ZERO    ,AWIDTH  ,W(1,192 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,192 ),GAL ,AMP(152 ))            
      CALL JIOXXX(W(1,3   ),W(1,191 ),GZD ,ZMASS   ,ZWIDTH  ,W(1,193 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,193 ),GZL ,AMP(153 ))            
      CALL JIOXXX(W(1,3   ),W(1,187 ),GAD ,ZERO    ,AWIDTH  ,W(1,194 ))    
      CALL FVIXXX(W(1,5   ),W(1,194 ),GAL ,ZERO    ,ZERO    ,W(1,195 ))    
      CALL JIOXXX(W(1,195 ),W(1,4   ),GAL ,ZERO    ,AWIDTH  ,W(1,196 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,196 ),GAL ,AMP(154 ))            
      CALL JIOXXX(W(1,195 ),W(1,4   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,197 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,197 ),GZL ,AMP(155 ))            
      CALL JIOXXX(W(1,3   ),W(1,187 ),GZD ,ZMASS   ,ZWIDTH  ,W(1,198 ))    
      CALL FVIXXX(W(1,5   ),W(1,198 ),GZL ,ZERO    ,ZERO    ,W(1,199 ))    
      CALL JIOXXX(W(1,199 ),W(1,4   ),GAL ,ZERO    ,AWIDTH  ,W(1,200 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,200 ),GAL ,AMP(156 ))            
      CALL JIOXXX(W(1,199 ),W(1,4   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,201 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,201 ),GZL ,AMP(157 ))            
      CALL FVOXXX(W(1,4   ),W(1,194 ),GAL ,ZERO    ,ZERO    ,W(1,202 ))    
      CALL JIOXXX(W(1,5   ),W(1,202 ),GAL ,ZERO    ,AWIDTH  ,W(1,203 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,203 ),GAL ,AMP(158 ))            
      CALL JIOXXX(W(1,5   ),W(1,202 ),GZL ,ZMASS   ,ZWIDTH  ,W(1,204 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,204 ),GZL ,AMP(159 ))            
      CALL FVOXXX(W(1,4   ),W(1,198 ),GZL ,ZERO    ,ZERO    ,W(1,205 ))    
      CALL JIOXXX(W(1,5   ),W(1,205 ),GAL ,ZERO    ,AWIDTH  ,W(1,206 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,206 ),GAL ,AMP(160 ))            
      CALL JIOXXX(W(1,5   ),W(1,205 ),GZL ,ZMASS   ,ZWIDTH  ,W(1,207 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,207 ),GZL ,AMP(161 ))            
      CALL JIOXXX(W(1,171 ),W(1,187 ),GAD ,ZERO    ,AWIDTH  ,W(1,208 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,208 ),GAL ,AMP(162 ))            
      CALL JIOXXX(W(1,171 ),W(1,187 ),GZD ,ZMASS   ,ZWIDTH  ,W(1,209 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,209 ),GZL ,AMP(163 ))            
      CALL JIOXXX(W(1,174 ),W(1,187 ),GAD ,ZERO    ,AWIDTH  ,W(1,210 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,210 ),GAL ,AMP(164 ))            
      CALL JIOXXX(W(1,174 ),W(1,187 ),GZD ,ZMASS   ,ZWIDTH  ,W(1,211 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,211 ),GZL ,AMP(165 ))            
      CALL HVVXXX(W(1,198 ),W(1,60  ),GZZH ,HMASS   ,HWIDTH  ,W(1,         
     &     212 ))                                                          
      CALL IOSXXX(W(1,7   ),W(1,6   ),W(1,212 ),GHTAU ,AMP(166 ))          
      CALL IOVXXX(W(1,68  ),W(1,6   ),W(1,194 ),GAL ,AMP(167 ))            
      CALL IOVXXX(W(1,70  ),W(1,6   ),W(1,194 ),GAL ,AMP(168 ))            
      CALL IOVXXX(W(1,68  ),W(1,6   ),W(1,198 ),GZL ,AMP(169 ))            
      CALL IOVXXX(W(1,70  ),W(1,6   ),W(1,198 ),GZL ,AMP(170 ))            
      CALL FVIXXX(W(1,7   ),W(1,194 ),GAL ,LMASS   ,ZERO    ,W(1,213 ))    
      CALL IOVXXX(W(1,213 ),W(1,6   ),W(1,63  ),GAL ,AMP(171 ))            
      CALL IOVXXX(W(1,213 ),W(1,6   ),W(1,60  ),GZL ,AMP(172 ))            
      CALL FVIXXX(W(1,7   ),W(1,198 ),GZL ,LMASS   ,ZERO    ,W(1,214 ))    
      CALL IOVXXX(W(1,214 ),W(1,6   ),W(1,63  ),GAL ,AMP(173 ))            
      CALL IOVXXX(W(1,214 ),W(1,6   ),W(1,60  ),GZL ,AMP(174 ))            
      zzztensor(mu) = -AMP(   1)-AMP(   2)-AMP(   3)-AMP(   4)-AMP(   5)
     &             -AMP(   6)-AMP(   7)-AMP(   8)-AMP(   9)-AMP(  10)
     &             -AMP(  11)-AMP(  12)-AMP(  13)-AMP(  14)-AMP(  15)
     &             -AMP(  16)-AMP(  17)-AMP(  18)-AMP(  19)-AMP(  20)
     &             -AMP(  21)-AMP(  22)-AMP(  23)-AMP(  24)-AMP(  25)
     &             -AMP(  26)-AMP(  27)-AMP(  28)-AMP(  29)-AMP(  30)
     &             -AMP(  31)-AMP(  32)-AMP(  33)-AMP(  34)-AMP(  35)
     &             -AMP(  36)-AMP(  37)-AMP(  38)-AMP(  39)-AMP(  40)
     &             -AMP(  41)-AMP(  42)-AMP(  43)-AMP(  44)-AMP(  45)
     &             -AMP(  46)-AMP(  47)-AMP(  48)-AMP(  49)-AMP(  50)
     &             -AMP(  51)-AMP(  52)-AMP(  53)-AMP(  54)-AMP(  55)
     &             -AMP(  56)-AMP(  57)-AMP(  58)-AMP(  59)-AMP(  60)
     &             -AMP(  61)-AMP(  62)-AMP(  63)-AMP(  64)-AMP(  65)
     &             -AMP(  66)-AMP(  67)-AMP(  68)-AMP(  69)-AMP(  70)
     &             -AMP(  71)-AMP(  72)-AMP(  73)-AMP(  74)-AMP(  75)
     &             -AMP(  76)-AMP(  77)-AMP(  78)-AMP(  79)-AMP(  80)
     &             -AMP(  81)-AMP(  82)-AMP(  83)-AMP(  84)-AMP(  85)
     &             -AMP(  86)-AMP(  87)-AMP(  88)-AMP(  89)-AMP(  90)
     &             -AMP(  91)-AMP(  92)-AMP(  93)-AMP(  94)-AMP(  95)
     &             -AMP(  96)-AMP(  97)-AMP(  98)-AMP(  99)-AMP( 100)
     &             -AMP( 101)-AMP( 102)-AMP( 103)-AMP( 104)-AMP( 105)
     &             -AMP( 106)-AMP( 107)-AMP( 108)-AMP( 109)-AMP( 110)
     &             -AMP( 111)-AMP( 112)-AMP( 113)-AMP( 114)-AMP( 115)
     &             -AMP( 116)-AMP( 117)-AMP( 118)-AMP( 119)-AMP( 120)
     &             -AMP( 121)-AMP( 122)-AMP( 123)-AMP( 124)-AMP( 125)
     &             -AMP( 126)-AMP( 127)-AMP( 128)-AMP( 129)-AMP( 130)
     &             -AMP( 131)-AMP( 132)-AMP( 133)-AMP( 134)-AMP( 135)
     &             -AMP( 136)-AMP( 137)-AMP( 138)-AMP( 139)-AMP( 140)
     &             -AMP( 141)-AMP( 142)-AMP( 143)-AMP( 144)-AMP( 145)
     &             -AMP( 146)-AMP( 147)-AMP( 148)-AMP( 149)-AMP( 150)
     &             -AMP( 151)-AMP( 152)-AMP( 153)-AMP( 154)-AMP( 155)
     &             -AMP( 156)-AMP( 157)-AMP( 158)-AMP( 159)-AMP( 160)
     &             -AMP( 161)-AMP( 162)-AMP( 163)-AMP( 164)-AMP( 165)
     &             -AMP( 166)-AMP( 167)-AMP( 168)-AMP( 169)-AMP( 170)
     &             -AMP( 171)-AMP( 172)-AMP( 173)-AMP( 174)

      endif

      enddo

      zzztensor(4) = dcmplx(q(0),q(3))
      zzztensor(5) = dcmplx(q(1),q(2))

      END

c ----------------------------------------------------------------------

      subroutine ztozzz_mg2_had(P,N,h,ZZZtensor,NW)

      IMPLICIT NONE

      DOUBLE PRECISION P(0:3,2:7)
      COMPLEX*16 ZZZtensor(0:5)
      INTEGER lsign(2:7,8),ll,mu,nu,h,N
      integer NW

      !possible lepton helicities
      data (lsign(ll,1),ll=2,7) / -1, -1, -1, -1, -1, -1/  !h=1
      data (lsign(ll,2),ll=2,7) / -1, -1,  1,  1, -1, -1/  !h=2
      data (lsign(ll,3),ll=2,7) / -1, -1, -1, -1,  1,  1/  !h=3
      data (lsign(ll,4),ll=2,7) / -1, -1,  1,  1,  1,  1/  !h=4
      data (lsign(ll,5),ll=2,7) /  1,  1, -1, -1, -1, -1/  !h=5
      data (lsign(ll,6),ll=2,7) /  1,  1,  1,  1, -1, -1/  !h=6
      data (lsign(ll,7),ll=2,7) /  1,  1, -1, -1,  1,  1/  !h=7
      data (lsign(ll,8),ll=2,7) /  1,  1,  1,  1,  1,  1/  !h=8

      call ZTOZZZ1_mg2_had(P,N,lsign(2,h),zzztensor(0),NW)

      ! helicity combi Nr. h is selected

      end

c-------------------------------------------------------------------

      SUBROUTINE ZTOZZZ1_mg2_had(P,N,lsign,zzztensor,NW)
C  
C Generated by MadGraph II Version 3.0. Updated 02/19/04                
C RETURNS AMPLITUDE SQUARED SUMMED/AVG OVER COLORS
C FOR THE POINT WITH EXTERNAL LINES W(0:6,NEXTERNAL)
C  
C FOR PROCESS : z -> e- e+ mu- mu+ ta- ta+  
C  
      IMPLICIT NONE
C  
C CONSTANTS
C  
      INTEGER    NGRAPHS 
      PARAMETER (NGRAPHS= 193) 
      INTEGER    NWAVEFUNCS
      PARAMETER (NWAVEFUNCS= 229) 
      DOUBLE PRECISION     ZERO
      PARAMETER (ZERO=0D0)
C  
C ARGUMENTS 
C  
      DOUBLE PRECISION P(0:3,2:7), Q(0:3)
      INTEGER N
      COMPLEX*16 zzztensor(0:5)
      INTEGER lsign(2:7)
      integer NW
C  
C LOCAL VARIABLES 
C  
      INTEGER I,J, mu
      COMPLEX*16 AMP(NGRAPHS)
      COMPLEX*16 W(6,NWAVEFUNCS)

c  lepton spinors and Z/A polarization vectors
#include "tensor.inc"

      logical lswitch
      parameter (lswitch=.true.)
C  
C GLOBAL VARIABLES
C  
#include "VBFNLO/utilities/coupl.inc"
#include "VBFNLO/utilities/process.inc"
#include "VBFNLO/utilities/coupl_haddecay.inc"
#include "VBFNLO/utilities/global.inc"
C                                          
C ----------
C BEGIN CODE
C ----------
      if (lswitch) then
         do i=1,6
            w(i,2)  = zem(i,N)
            w(i,3)  = zep(i,N)
            w(i,4)  = zmm(i,N)
            w(i,5)  = zmp(i,N)
            w(i,6)  = ztm(i,N)
            w(i,7)  = ztp(i,N)
            w(i,8)  = ae(i,N)
            w(i,14) = ze(i,N)
         enddo
      endif

      do mu = 0,3
         q(mu) = p(mu,2)+p(mu,3)+p(mu,4)+p(mu,5)+p(mu,6)+p(mu,7)
      enddo

      do mu = 0,3
      call TRIBOSVCARTX(Q(0), ZMASS, ZWIDTH, MU, -1, W(1,1))                   

      if (procid.eq.ZZZhad .and. Ztouu) then

      CALL JIOXXX(W(1,3   ),W(1,2   ),GAU ,ZERO    ,AWIDTH  ,W(1,8   ))    
      CALL FVOXXX(W(1,4   ),W(1,8   ),GAL ,ZERO    ,ZERO    ,W(1,9   ))    
      CALL JIOXXX(W(1,5   ),W(1,9   ),GAL ,ZERO    ,AWIDTH  ,W(1,10  ))    
      CALL FVOXXX(W(1,6   ),W(1,10  ),GAL ,LMASS   ,ZERO    ,W(1,11  ))    
      CALL IOVXXX(W(1,7   ),W(1,11  ),W(1,1   ),GZL ,AMP(1   ))            
      CALL JIOXXX(W(1,5   ),W(1,9   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,12  ))    
      CALL FVOXXX(W(1,6   ),W(1,12  ),GZL ,LMASS   ,ZERO    ,W(1,13  ))    
      CALL IOVXXX(W(1,7   ),W(1,13  ),W(1,1   ),GZL ,AMP(2   ))            
      CALL JIOXXX(W(1,3   ),W(1,2   ),GZU ,ZMASS   ,ZWIDTH  ,W(1,14  ))    
      CALL FVOXXX(W(1,4   ),W(1,14  ),GZL ,ZERO    ,ZERO    ,W(1,15  ))    
      CALL JIOXXX(W(1,5   ),W(1,15  ),GAL ,ZERO    ,AWIDTH  ,W(1,16  ))    
      CALL FVOXXX(W(1,6   ),W(1,16  ),GAL ,LMASS   ,ZERO    ,W(1,17  ))    
      CALL IOVXXX(W(1,7   ),W(1,17  ),W(1,1   ),GZL ,AMP(3   ))            
      CALL JIOXXX(W(1,5   ),W(1,15  ),GZL ,ZMASS   ,ZWIDTH  ,W(1,18  ))    
      CALL FVOXXX(W(1,6   ),W(1,18  ),GZL ,LMASS   ,ZERO    ,W(1,19  ))    
      CALL IOVXXX(W(1,7   ),W(1,19  ),W(1,1   ),GZL ,AMP(4   ))            
      CALL HVVXXX(W(1,12  ),W(1,1   ),GZZH ,HMASS   ,HWIDTH  ,W(1,         
     &     20  ))                                                          
      CALL IOSXXX(W(1,7   ),W(1,6   ),W(1,20  ),GHTAU ,AMP(5   ))          
      CALL HVVXXX(W(1,18  ),W(1,1   ),GZZH ,HMASS   ,HWIDTH  ,W(1,         
     &     21  ))                                                          
      CALL IOSXXX(W(1,7   ),W(1,6   ),W(1,21  ),GHTAU ,AMP(6   ))          
      CALL FVIXXX(W(1,7   ),W(1,10  ),GAL ,LMASS   ,ZERO    ,W(1,22  ))    
      CALL IOVXXX(W(1,22  ),W(1,6   ),W(1,1   ),GZL ,AMP(7   ))            
      CALL FVIXXX(W(1,7   ),W(1,12  ),GZL ,LMASS   ,ZERO    ,W(1,23  ))    
      CALL IOVXXX(W(1,23  ),W(1,6   ),W(1,1   ),GZL ,AMP(8   ))            
      CALL FVIXXX(W(1,7   ),W(1,16  ),GAL ,LMASS   ,ZERO    ,W(1,24  ))    
      CALL IOVXXX(W(1,24  ),W(1,6   ),W(1,1   ),GZL ,AMP(9   ))            
      CALL FVIXXX(W(1,7   ),W(1,18  ),GZL ,LMASS   ,ZERO    ,W(1,25  ))    
      CALL IOVXXX(W(1,25  ),W(1,6   ),W(1,1   ),GZL ,AMP(10  ))            
      CALL FVIXXX(W(1,5   ),W(1,1   ),GZL ,ZERO    ,ZERO    ,W(1,26  ))    
      CALL JIOXXX(W(1,26  ),W(1,4   ),GAL ,ZERO    ,AWIDTH  ,W(1,27  ))    
      CALL FVIXXX(W(1,3   ),W(1,27  ),GAU ,ZERO    ,ZERO    ,W(1,28  ))    
      CALL JIOXXX(W(1,28  ),W(1,2   ),GAU ,ZERO    ,AWIDTH  ,W(1,29  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,29  ),GAL ,AMP(11  ))            
      CALL JIOXXX(W(1,28  ),W(1,2   ),GZU ,ZMASS   ,ZWIDTH  ,W(1,30  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,30  ),GZL ,AMP(12  ))            
      CALL JIOXXX(W(1,26  ),W(1,4   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,31  ))    
      CALL FVIXXX(W(1,3   ),W(1,31  ),GZU ,ZERO    ,ZERO    ,W(1,32  ))    
      CALL JIOXXX(W(1,32  ),W(1,2   ),GAU ,ZERO    ,AWIDTH  ,W(1,33  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,33  ),GAL ,AMP(13  ))            
      CALL JIOXXX(W(1,32  ),W(1,2   ),GZU ,ZMASS   ,ZWIDTH  ,W(1,34  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,34  ),GZL ,AMP(14  ))            
      CALL FVOXXX(W(1,2   ),W(1,27  ),GAU ,ZERO    ,ZERO    ,W(1,35  ))    
      CALL JIOXXX(W(1,3   ),W(1,35  ),GAU ,ZERO    ,AWIDTH  ,W(1,36  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,36  ),GAL ,AMP(15  ))            
      CALL JIOXXX(W(1,3   ),W(1,35  ),GZU ,ZMASS   ,ZWIDTH  ,W(1,37  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,37  ),GZL ,AMP(16  ))            
      CALL FVOXXX(W(1,2   ),W(1,31  ),GZU ,ZERO    ,ZERO    ,W(1,38  ))    
      CALL JIOXXX(W(1,3   ),W(1,38  ),GAU ,ZERO    ,AWIDTH  ,W(1,39  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,39  ),GAL ,AMP(17  ))            
      CALL JIOXXX(W(1,3   ),W(1,38  ),GZU ,ZMASS   ,ZWIDTH  ,W(1,40  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,40  ),GZL ,AMP(18  ))            
      CALL FVIXXX(W(1,26  ),W(1,8   ),GAL ,ZERO    ,ZERO    ,W(1,41  ))    
      CALL JIOXXX(W(1,41  ),W(1,4   ),GAL ,ZERO    ,AWIDTH  ,W(1,42  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,42  ),GAL ,AMP(19  ))            
      CALL JIOXXX(W(1,41  ),W(1,4   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,43  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,43  ),GZL ,AMP(20  ))            
      CALL FVIXXX(W(1,26  ),W(1,14  ),GZL ,ZERO    ,ZERO    ,W(1,44  ))    
      CALL JIOXXX(W(1,44  ),W(1,4   ),GAL ,ZERO    ,AWIDTH  ,W(1,45  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,45  ),GAL ,AMP(21  ))            
      CALL JIOXXX(W(1,44  ),W(1,4   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,46  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,46  ),GZL ,AMP(22  ))            
      CALL FVOXXX(W(1,9   ),W(1,1   ),GZL ,ZERO    ,ZERO    ,W(1,47  ))    
      CALL JIOXXX(W(1,5   ),W(1,47  ),GAL ,ZERO    ,AWIDTH  ,W(1,48  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,48  ),GAL ,AMP(23  ))            
      CALL JIOXXX(W(1,5   ),W(1,47  ),GZL ,ZMASS   ,ZWIDTH  ,W(1,49  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,49  ),GZL ,AMP(24  ))            
      CALL FVOXXX(W(1,15  ),W(1,1   ),GZL ,ZERO    ,ZERO    ,W(1,50  ))    
      CALL JIOXXX(W(1,5   ),W(1,50  ),GAL ,ZERO    ,AWIDTH  ,W(1,51  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,51  ),GAL ,AMP(25  ))            
      CALL JIOXXX(W(1,5   ),W(1,50  ),GZL ,ZMASS   ,ZWIDTH  ,W(1,52  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,52  ),GZL ,AMP(26  ))            
      CALL HVVXXX(W(1,14  ),W(1,31  ),GZZH ,HMASS   ,HWIDTH  ,W(1,         
     &     53  ))                                                          
      CALL IOSXXX(W(1,7   ),W(1,6   ),W(1,53  ),GHTAU ,AMP(27  ))          
      CALL FVIXXX(W(1,7   ),W(1,27  ),GAL ,LMASS   ,ZERO    ,W(1,54  ))    
      CALL IOVXXX(W(1,54  ),W(1,6   ),W(1,8   ),GAL ,AMP(28  ))            
      CALL FVIXXX(W(1,7   ),W(1,31  ),GZL ,LMASS   ,ZERO    ,W(1,55  ))    
      CALL IOVXXX(W(1,55  ),W(1,6   ),W(1,8   ),GAL ,AMP(29  ))            
      CALL IOVXXX(W(1,54  ),W(1,6   ),W(1,14  ),GZL ,AMP(30  ))            
      CALL IOVXXX(W(1,55  ),W(1,6   ),W(1,14  ),GZL ,AMP(31  ))            
      CALL FVIXXX(W(1,7   ),W(1,8   ),GAL ,LMASS   ,ZERO    ,W(1,56  ))    
      CALL IOVXXX(W(1,56  ),W(1,6   ),W(1,27  ),GAL ,AMP(32  ))            
      CALL IOVXXX(W(1,56  ),W(1,6   ),W(1,31  ),GZL ,AMP(33  ))            
      CALL FVIXXX(W(1,7   ),W(1,14  ),GZL ,LMASS   ,ZERO    ,W(1,57  ))    
      CALL IOVXXX(W(1,57  ),W(1,6   ),W(1,27  ),GAL ,AMP(34  ))            
      CALL IOVXXX(W(1,57  ),W(1,6   ),W(1,31  ),GZL ,AMP(35  ))            
      CALL JIOXXX(W(1,26  ),W(1,9   ),GAL ,ZERO    ,AWIDTH  ,W(1,58  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,58  ),GAL ,AMP(36  ))            
      CALL JIOXXX(W(1,26  ),W(1,9   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,59  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,59  ),GZL ,AMP(37  ))            
      CALL JIOXXX(W(1,26  ),W(1,15  ),GAL ,ZERO    ,AWIDTH  ,W(1,60  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,60  ),GAL ,AMP(38  ))            
      CALL JIOXXX(W(1,26  ),W(1,15  ),GZL ,ZMASS   ,ZWIDTH  ,W(1,61  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,61  ),GZL ,AMP(39  ))            
      CALL JIOXXX(W(1,5   ),W(1,4   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,62  ))    
      CALL FVIXXX(W(1,7   ),W(1,1   ),GZL ,LMASS   ,ZERO    ,W(1,63  ))    
      CALL HVVXXX(W(1,62  ),W(1,14  ),GZZH ,HMASS   ,HWIDTH  ,W(1,         
     &     64  ))                                                          
      CALL IOSXXX(W(1,63  ),W(1,6   ),W(1,64  ),GHTAU ,AMP(40  ))          
      CALL JVSXXX(W(1,1   ),W(1,64  ),GZZH ,ZMASS   ,ZWIDTH  ,W(1,         
     &     65  ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,65  ),GZL ,AMP(41  ))            
      CALL JIOXXX(W(1,5   ),W(1,4   ),GAL ,ZERO    ,AWIDTH  ,W(1,66  ))    
      CALL FVIXXX(W(1,56  ),W(1,66  ),GAL ,LMASS   ,ZERO    ,W(1,67  ))    
      CALL IOVXXX(W(1,67  ),W(1,6   ),W(1,1   ),GZL ,AMP(42  ))            
      CALL FVIXXX(W(1,56  ),W(1,62  ),GZL ,LMASS   ,ZERO    ,W(1,68  ))    
      CALL IOVXXX(W(1,68  ),W(1,6   ),W(1,1   ),GZL ,AMP(43  ))            
      CALL FVIXXX(W(1,57  ),W(1,66  ),GAL ,LMASS   ,ZERO    ,W(1,69  ))    
      CALL IOVXXX(W(1,69  ),W(1,6   ),W(1,1   ),GZL ,AMP(44  ))            
      CALL FVIXXX(W(1,57  ),W(1,62  ),GZL ,LMASS   ,ZERO    ,W(1,70  ))    
      CALL IOVXXX(W(1,70  ),W(1,6   ),W(1,1   ),GZL ,AMP(45  ))            
      CALL FVIXXX(W(1,7   ),W(1,66  ),GAL ,LMASS   ,ZERO    ,W(1,71  ))    
      CALL FVIXXX(W(1,71  ),W(1,8   ),GAL ,LMASS   ,ZERO    ,W(1,72  ))    
      CALL IOVXXX(W(1,72  ),W(1,6   ),W(1,1   ),GZL ,AMP(46  ))            
      CALL FVIXXX(W(1,7   ),W(1,62  ),GZL ,LMASS   ,ZERO    ,W(1,73  ))    
      CALL FVIXXX(W(1,73  ),W(1,8   ),GAL ,LMASS   ,ZERO    ,W(1,74  ))    
      CALL IOVXXX(W(1,74  ),W(1,6   ),W(1,1   ),GZL ,AMP(47  ))            
      CALL FVIXXX(W(1,71  ),W(1,14  ),GZL ,LMASS   ,ZERO    ,W(1,75  ))    
      CALL IOVXXX(W(1,75  ),W(1,6   ),W(1,1   ),GZL ,AMP(48  ))            
      CALL FVIXXX(W(1,73  ),W(1,14  ),GZL ,LMASS   ,ZERO    ,W(1,76  ))    
      CALL IOVXXX(W(1,76  ),W(1,6   ),W(1,1   ),GZL ,AMP(49  ))            
      CALL FSIXXX(W(1,7   ),W(1,64  ),GHTAU ,LMASS   ,ZERO    ,W(1,        
     &     77  ))                                                          
      CALL IOVXXX(W(1,77  ),W(1,6   ),W(1,1   ),GZL ,AMP(50  ))            
      CALL FVIXXX(W(1,63  ),W(1,66  ),GAL ,LMASS   ,ZERO    ,W(1,78  ))    
      CALL IOVXXX(W(1,78  ),W(1,6   ),W(1,8   ),GAL ,AMP(51  ))            
      CALL FVIXXX(W(1,63  ),W(1,62  ),GZL ,LMASS   ,ZERO    ,W(1,79  ))    
      CALL IOVXXX(W(1,79  ),W(1,6   ),W(1,8   ),GAL ,AMP(52  ))            
      CALL IOVXXX(W(1,78  ),W(1,6   ),W(1,14  ),GZL ,AMP(53  ))            
      CALL IOVXXX(W(1,79  ),W(1,6   ),W(1,14  ),GZL ,AMP(54  ))            
      CALL HVVXXX(W(1,62  ),W(1,1   ),GZZH ,HMASS   ,HWIDTH  ,W(1,         
     &     80  ))                                                          
      CALL JVSXXX(W(1,14  ),W(1,80  ),GZZH ,ZMASS   ,ZWIDTH  ,W(1,         
     &     81  ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,81  ),GZL ,AMP(55  ))            
      CALL FSIXXX(W(1,7   ),W(1,80  ),GHTAU ,LMASS   ,ZERO    ,W(1,        
     &     82  ))                                                          
      CALL IOVXXX(W(1,82  ),W(1,6   ),W(1,8   ),GAL ,AMP(56  ))            
      CALL IOVXXX(W(1,82  ),W(1,6   ),W(1,14  ),GZL ,AMP(57  ))            
      CALL FVIXXX(W(1,71  ),W(1,1   ),GZL ,LMASS   ,ZERO    ,W(1,83  ))    
      CALL IOVXXX(W(1,83  ),W(1,6   ),W(1,8   ),GAL ,AMP(58  ))            
      CALL FVIXXX(W(1,73  ),W(1,1   ),GZL ,LMASS   ,ZERO    ,W(1,84  ))    
      CALL IOVXXX(W(1,84  ),W(1,6   ),W(1,8   ),GAL ,AMP(59  ))            
      CALL IOVXXX(W(1,83  ),W(1,6   ),W(1,14  ),GZL ,AMP(60  ))            
      CALL IOVXXX(W(1,84  ),W(1,6   ),W(1,14  ),GZL ,AMP(61  ))            
      CALL IOSXXX(W(1,56  ),W(1,6   ),W(1,80  ),GHTAU ,AMP(62  ))          
      CALL IOSXXX(W(1,57  ),W(1,6   ),W(1,80  ),GHTAU ,AMP(63  ))          
      CALL FVIXXX(W(1,63  ),W(1,8   ),GAL ,LMASS   ,ZERO    ,W(1,85  ))    
      CALL IOVXXX(W(1,85  ),W(1,6   ),W(1,66  ),GAL ,AMP(64  ))            
      CALL IOVXXX(W(1,85  ),W(1,6   ),W(1,62  ),GZL ,AMP(65  ))            
      CALL FVIXXX(W(1,63  ),W(1,14  ),GZL ,LMASS   ,ZERO    ,W(1,86  ))    
      CALL IOVXXX(W(1,86  ),W(1,6   ),W(1,66  ),GAL ,AMP(66  ))            
      CALL IOVXXX(W(1,86  ),W(1,6   ),W(1,62  ),GZL ,AMP(67  ))            
      CALL HVVXXX(W(1,14  ),W(1,1   ),GZZH ,HMASS   ,HWIDTH  ,W(1,         
     &     87  ))                                                          
      CALL JVSXXX(W(1,62  ),W(1,87  ),GZZH ,ZMASS   ,ZWIDTH  ,W(1,         
     &     88  ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,88  ),GZL ,AMP(68  ))            
      CALL FVIXXX(W(1,56  ),W(1,1   ),GZL ,LMASS   ,ZERO    ,W(1,89  ))    
      CALL IOVXXX(W(1,89  ),W(1,6   ),W(1,66  ),GAL ,AMP(69  ))            
      CALL IOVXXX(W(1,89  ),W(1,6   ),W(1,62  ),GZL ,AMP(70  ))            
      CALL FVIXXX(W(1,57  ),W(1,1   ),GZL ,LMASS   ,ZERO    ,W(1,90  ))    
      CALL IOVXXX(W(1,90  ),W(1,6   ),W(1,66  ),GAL ,AMP(71  ))            
      CALL IOVXXX(W(1,90  ),W(1,6   ),W(1,62  ),GZL ,AMP(72  ))            
      CALL IOSXXX(W(1,71  ),W(1,6   ),W(1,87  ),GHTAU ,AMP(73  ))          
      CALL IOSXXX(W(1,73  ),W(1,6   ),W(1,87  ),GHTAU ,AMP(74  ))          
      CALL FSIXXX(W(1,7   ),W(1,87  ),GHTAU ,LMASS   ,ZERO    ,W(1,        
     &     91  ))                                                          
      CALL IOVXXX(W(1,91  ),W(1,6   ),W(1,66  ),GAL ,AMP(75  ))            
      CALL IOVXXX(W(1,91  ),W(1,6   ),W(1,62  ),GZL ,AMP(76  ))            
      CALL FVIXXX(W(1,5   ),W(1,8   ),GAL ,ZERO    ,ZERO    ,W(1,92  ))    
      CALL JIOXXX(W(1,92  ),W(1,4   ),GAL ,ZERO    ,AWIDTH  ,W(1,93  ))    
      CALL IOVXXX(W(1,63  ),W(1,6   ),W(1,93  ),GAL ,AMP(77  ))            
      CALL JIOXXX(W(1,92  ),W(1,4   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,94  ))    
      CALL IOVXXX(W(1,63  ),W(1,6   ),W(1,94  ),GZL ,AMP(78  ))            
      CALL FVIXXX(W(1,5   ),W(1,14  ),GZL ,ZERO    ,ZERO    ,W(1,95  ))    
      CALL JIOXXX(W(1,95  ),W(1,4   ),GAL ,ZERO    ,AWIDTH  ,W(1,96  ))    
      CALL IOVXXX(W(1,63  ),W(1,6   ),W(1,96  ),GAL ,AMP(79  ))            
      CALL JIOXXX(W(1,95  ),W(1,4   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,97  ))    
      CALL IOVXXX(W(1,63  ),W(1,6   ),W(1,97  ),GZL ,AMP(80  ))            
      CALL HVVXXX(W(1,94  ),W(1,1   ),GZZH ,HMASS   ,HWIDTH  ,W(1,         
     &     98  ))                                                          
      CALL IOSXXX(W(1,7   ),W(1,6   ),W(1,98  ),GHTAU ,AMP(81  ))          
      CALL HVVXXX(W(1,97  ),W(1,1   ),GZZH ,HMASS   ,HWIDTH  ,W(1,         
     &     99  ))                                                          
      CALL IOSXXX(W(1,7   ),W(1,6   ),W(1,99  ),GHTAU ,AMP(82  ))          
      CALL FVIXXX(W(1,7   ),W(1,93  ),GAL ,LMASS   ,ZERO    ,W(1,100 ))    
      CALL IOVXXX(W(1,100 ),W(1,6   ),W(1,1   ),GZL ,AMP(83  ))            
      CALL FVIXXX(W(1,7   ),W(1,94  ),GZL ,LMASS   ,ZERO    ,W(1,101 ))    
      CALL IOVXXX(W(1,101 ),W(1,6   ),W(1,1   ),GZL ,AMP(84  ))            
      CALL FVIXXX(W(1,7   ),W(1,96  ),GAL ,LMASS   ,ZERO    ,W(1,102 ))    
      CALL IOVXXX(W(1,102 ),W(1,6   ),W(1,1   ),GZL ,AMP(85  ))            
      CALL FVIXXX(W(1,7   ),W(1,97  ),GZL ,LMASS   ,ZERO    ,W(1,103 ))    
      CALL IOVXXX(W(1,103 ),W(1,6   ),W(1,1   ),GZL ,AMP(86  ))            
      CALL FVOXXX(W(1,4   ),W(1,1   ),GZL ,ZERO    ,ZERO    ,W(1,104 ))    
      CALL JIOXXX(W(1,5   ),W(1,104 ),GAL ,ZERO    ,AWIDTH  ,W(1,105 ))    
      CALL FVIXXX(W(1,3   ),W(1,105 ),GAU ,ZERO    ,ZERO    ,W(1,106 ))    
      CALL JIOXXX(W(1,106 ),W(1,2   ),GAU ,ZERO    ,AWIDTH  ,W(1,107 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,107 ),GAL ,AMP(87  ))            
      CALL JIOXXX(W(1,106 ),W(1,2   ),GZU ,ZMASS   ,ZWIDTH  ,W(1,108 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,108 ),GZL ,AMP(88  ))            
      CALL JIOXXX(W(1,5   ),W(1,104 ),GZL ,ZMASS   ,ZWIDTH  ,W(1,109 ))    
      CALL FVIXXX(W(1,3   ),W(1,109 ),GZU ,ZERO    ,ZERO    ,W(1,110 ))    
      CALL JIOXXX(W(1,110 ),W(1,2   ),GAU ,ZERO    ,AWIDTH  ,W(1,111 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,111 ),GAL ,AMP(89  ))            
      CALL JIOXXX(W(1,110 ),W(1,2   ),GZU ,ZMASS   ,ZWIDTH  ,W(1,112 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,112 ),GZL ,AMP(90  ))            
      CALL FVOXXX(W(1,2   ),W(1,105 ),GAU ,ZERO    ,ZERO    ,W(1,113 ))    
      CALL JIOXXX(W(1,3   ),W(1,113 ),GAU ,ZERO    ,AWIDTH  ,W(1,114 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,114 ),GAL ,AMP(91  ))            
      CALL JIOXXX(W(1,3   ),W(1,113 ),GZU ,ZMASS   ,ZWIDTH  ,W(1,115 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,115 ),GZL ,AMP(92  ))            
      CALL FVOXXX(W(1,2   ),W(1,109 ),GZU ,ZERO    ,ZERO    ,W(1,116 ))    
      CALL JIOXXX(W(1,3   ),W(1,116 ),GAU ,ZERO    ,AWIDTH  ,W(1,117 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,117 ),GAL ,AMP(93  ))            
      CALL JIOXXX(W(1,3   ),W(1,116 ),GZU ,ZMASS   ,ZWIDTH  ,W(1,118 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,118 ),GZL ,AMP(94  ))            
      CALL FVIXXX(W(1,92  ),W(1,1   ),GZL ,ZERO    ,ZERO    ,W(1,119 ))    
      CALL JIOXXX(W(1,119 ),W(1,4   ),GAL ,ZERO    ,AWIDTH  ,W(1,120 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,120 ),GAL ,AMP(95  ))            
      CALL JIOXXX(W(1,119 ),W(1,4   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,121 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,121 ),GZL ,AMP(96  ))            
      CALL FVIXXX(W(1,95  ),W(1,1   ),GZL ,ZERO    ,ZERO    ,W(1,122 ))    
      CALL JIOXXX(W(1,122 ),W(1,4   ),GAL ,ZERO    ,AWIDTH  ,W(1,123 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,123 ),GAL ,AMP(97  ))            
      CALL JIOXXX(W(1,122 ),W(1,4   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,124 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,124 ),GZL ,AMP(98  ))            
      CALL FVOXXX(W(1,104 ),W(1,8   ),GAL ,ZERO    ,ZERO    ,W(1,125 ))    
      CALL JIOXXX(W(1,5   ),W(1,125 ),GAL ,ZERO    ,AWIDTH  ,W(1,126 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,126 ),GAL ,AMP(99  ))            
      CALL JIOXXX(W(1,5   ),W(1,125 ),GZL ,ZMASS   ,ZWIDTH  ,W(1,127 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,127 ),GZL ,AMP(100 ))            
      CALL FVOXXX(W(1,104 ),W(1,14  ),GZL ,ZERO    ,ZERO    ,W(1,128 ))    
      CALL JIOXXX(W(1,5   ),W(1,128 ),GAL ,ZERO    ,AWIDTH  ,W(1,129 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,129 ),GAL ,AMP(101 ))            
      CALL JIOXXX(W(1,5   ),W(1,128 ),GZL ,ZMASS   ,ZWIDTH  ,W(1,130 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,130 ),GZL ,AMP(102 ))            
      CALL JIOXXX(W(1,92  ),W(1,104 ),GAL ,ZERO    ,AWIDTH  ,W(1,131 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,131 ),GAL ,AMP(103 ))            
      CALL JIOXXX(W(1,92  ),W(1,104 ),GZL ,ZMASS   ,ZWIDTH  ,W(1,132 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,132 ),GZL ,AMP(104 ))            
      CALL JIOXXX(W(1,95  ),W(1,104 ),GAL ,ZERO    ,AWIDTH  ,W(1,133 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,133 ),GAL ,AMP(105 ))            
      CALL JIOXXX(W(1,95  ),W(1,104 ),GZL ,ZMASS   ,ZWIDTH  ,W(1,134 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,134 ),GZL ,AMP(106 ))            
      CALL HVVXXX(W(1,14  ),W(1,109 ),GZZH ,HMASS   ,HWIDTH  ,W(1,         
     &     135 ))                                                          
      CALL IOSXXX(W(1,7   ),W(1,6   ),W(1,135 ),GHTAU ,AMP(107 ))          
      CALL FVIXXX(W(1,7   ),W(1,105 ),GAL ,LMASS   ,ZERO    ,W(1,136 ))    
      CALL IOVXXX(W(1,136 ),W(1,6   ),W(1,8   ),GAL ,AMP(108 ))            
      CALL FVIXXX(W(1,7   ),W(1,109 ),GZL ,LMASS   ,ZERO    ,W(1,137 ))    
      CALL IOVXXX(W(1,137 ),W(1,6   ),W(1,8   ),GAL ,AMP(109 ))            
      CALL IOVXXX(W(1,136 ),W(1,6   ),W(1,14  ),GZL ,AMP(110 ))            
      CALL IOVXXX(W(1,137 ),W(1,6   ),W(1,14  ),GZL ,AMP(111 ))            
      CALL IOVXXX(W(1,56  ),W(1,6   ),W(1,105 ),GAL ,AMP(112 ))            
      CALL IOVXXX(W(1,56  ),W(1,6   ),W(1,109 ),GZL ,AMP(113 ))            
      CALL IOVXXX(W(1,57  ),W(1,6   ),W(1,105 ),GAL ,AMP(114 ))            
      CALL IOVXXX(W(1,57  ),W(1,6   ),W(1,109 ),GZL ,AMP(115 ))            
      CALL FVOXXX(W(1,2   ),W(1,66  ),GAU ,ZERO    ,ZERO    ,W(1,138 ))    
      CALL JIOXXX(W(1,3   ),W(1,138 ),GAU ,ZERO    ,AWIDTH  ,W(1,139 ))    
      CALL IOVXXX(W(1,63  ),W(1,6   ),W(1,139 ),GAL ,AMP(116 ))            
      CALL JIOXXX(W(1,3   ),W(1,138 ),GZU ,ZMASS   ,ZWIDTH  ,W(1,140 ))    
      CALL IOVXXX(W(1,63  ),W(1,6   ),W(1,140 ),GZL ,AMP(117 ))            
      CALL FVOXXX(W(1,2   ),W(1,62  ),GZU ,ZERO    ,ZERO    ,W(1,141 ))    
      CALL JIOXXX(W(1,3   ),W(1,141 ),GAU ,ZERO    ,AWIDTH  ,W(1,142 ))    
      CALL IOVXXX(W(1,63  ),W(1,6   ),W(1,142 ),GAL ,AMP(118 ))            
      CALL JIOXXX(W(1,3   ),W(1,141 ),GZU ,ZMASS   ,ZWIDTH  ,W(1,143 ))    
      CALL IOVXXX(W(1,63  ),W(1,6   ),W(1,143 ),GZL ,AMP(119 ))            
      CALL HVVXXX(W(1,140 ),W(1,1   ),GZZH ,HMASS   ,HWIDTH  ,W(1,         
     &     144 ))                                                          
      CALL IOSXXX(W(1,7   ),W(1,6   ),W(1,144 ),GHTAU ,AMP(120 ))          
      CALL HVVXXX(W(1,143 ),W(1,1   ),GZZH ,HMASS   ,HWIDTH  ,W(1,         
     &     145 ))                                                          
      CALL IOSXXX(W(1,7   ),W(1,6   ),W(1,145 ),GHTAU ,AMP(121 ))          
      CALL FVIXXX(W(1,7   ),W(1,139 ),GAL ,LMASS   ,ZERO    ,W(1,146 ))    
      CALL IOVXXX(W(1,146 ),W(1,6   ),W(1,1   ),GZL ,AMP(122 ))            
      CALL FVIXXX(W(1,7   ),W(1,140 ),GZL ,LMASS   ,ZERO    ,W(1,147 ))    
      CALL IOVXXX(W(1,147 ),W(1,6   ),W(1,1   ),GZL ,AMP(123 ))            
      CALL FVIXXX(W(1,7   ),W(1,142 ),GAL ,LMASS   ,ZERO    ,W(1,148 ))    
      CALL IOVXXX(W(1,148 ),W(1,6   ),W(1,1   ),GZL ,AMP(124 ))            
      CALL FVIXXX(W(1,7   ),W(1,143 ),GZL ,LMASS   ,ZERO    ,W(1,149 ))    
      CALL IOVXXX(W(1,149 ),W(1,6   ),W(1,1   ),GZL ,AMP(125 ))            
      CALL FVIXXX(W(1,3   ),W(1,1   ),GZU ,ZERO    ,ZERO    ,W(1,150 ))    
      CALL FVIXXX(W(1,150 ),W(1,66  ),GAU ,ZERO    ,ZERO    ,W(1,151 ))    
      CALL JIOXXX(W(1,151 ),W(1,2   ),GAU ,ZERO    ,AWIDTH  ,W(1,152 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,152 ),GAL ,AMP(126 ))            
      CALL JIOXXX(W(1,151 ),W(1,2   ),GZU ,ZMASS   ,ZWIDTH  ,W(1,153 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,153 ),GZL ,AMP(127 ))            
      CALL FVIXXX(W(1,150 ),W(1,62  ),GZU ,ZERO    ,ZERO    ,W(1,154 ))    
      CALL JIOXXX(W(1,154 ),W(1,2   ),GAU ,ZERO    ,AWIDTH  ,W(1,155 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,155 ),GAL ,AMP(128 ))            
      CALL JIOXXX(W(1,154 ),W(1,2   ),GZU ,ZMASS   ,ZWIDTH  ,W(1,156 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,156 ),GZL ,AMP(129 ))            
      CALL FVOXXX(W(1,138 ),W(1,1   ),GZU ,ZERO    ,ZERO    ,W(1,157 ))    
      CALL JIOXXX(W(1,3   ),W(1,157 ),GAU ,ZERO    ,AWIDTH  ,W(1,158 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,158 ),GAL ,AMP(130 ))            
      CALL JIOXXX(W(1,3   ),W(1,157 ),GZU ,ZMASS   ,ZWIDTH  ,W(1,159 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,159 ),GZL ,AMP(131 ))            
      CALL FVOXXX(W(1,141 ),W(1,1   ),GZU ,ZERO    ,ZERO    ,W(1,160 ))    
      CALL JIOXXX(W(1,3   ),W(1,160 ),GAU ,ZERO    ,AWIDTH  ,W(1,161 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,161 ),GAL ,AMP(132 ))            
      CALL JIOXXX(W(1,3   ),W(1,160 ),GZU ,ZMASS   ,ZWIDTH  ,W(1,162 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,162 ),GZL ,AMP(133 ))            
      CALL JIOXXX(W(1,150 ),W(1,2   ),GAU ,ZERO    ,AWIDTH  ,W(1,163 ))    
      CALL FVIXXX(W(1,5   ),W(1,163 ),GAL ,ZERO    ,ZERO    ,W(1,164 ))    
      CALL JIOXXX(W(1,164 ),W(1,4   ),GAL ,ZERO    ,AWIDTH  ,W(1,165 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,165 ),GAL ,AMP(134 ))            
      CALL JIOXXX(W(1,164 ),W(1,4   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,166 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,166 ),GZL ,AMP(135 ))            
      CALL JIOXXX(W(1,150 ),W(1,2   ),GZU ,ZMASS   ,ZWIDTH  ,W(1,167 ))    
      CALL FVIXXX(W(1,5   ),W(1,167 ),GZL ,ZERO    ,ZERO    ,W(1,168 ))    
      CALL JIOXXX(W(1,168 ),W(1,4   ),GAL ,ZERO    ,AWIDTH  ,W(1,169 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,169 ),GAL ,AMP(136 ))            
      CALL JIOXXX(W(1,168 ),W(1,4   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,170 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,170 ),GZL ,AMP(137 ))            
      CALL FVOXXX(W(1,4   ),W(1,163 ),GAL ,ZERO    ,ZERO    ,W(1,171 ))    
      CALL JIOXXX(W(1,5   ),W(1,171 ),GAL ,ZERO    ,AWIDTH  ,W(1,172 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,172 ),GAL ,AMP(138 ))            
      CALL JIOXXX(W(1,5   ),W(1,171 ),GZL ,ZMASS   ,ZWIDTH  ,W(1,173 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,173 ),GZL ,AMP(139 ))            
      CALL FVOXXX(W(1,4   ),W(1,167 ),GZL ,ZERO    ,ZERO    ,W(1,174 ))    
      CALL JIOXXX(W(1,5   ),W(1,174 ),GAL ,ZERO    ,AWIDTH  ,W(1,175 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,175 ),GAL ,AMP(140 ))            
      CALL JIOXXX(W(1,5   ),W(1,174 ),GZL ,ZMASS   ,ZWIDTH  ,W(1,176 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,176 ),GZL ,AMP(141 ))            
      CALL JIOXXX(W(1,150 ),W(1,138 ),GAU ,ZERO    ,AWIDTH  ,W(1,177 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,177 ),GAL ,AMP(142 ))            
      CALL JIOXXX(W(1,150 ),W(1,138 ),GZU ,ZMASS   ,ZWIDTH  ,W(1,178 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,178 ),GZL ,AMP(143 ))            
      CALL JIOXXX(W(1,150 ),W(1,141 ),GAU ,ZERO    ,AWIDTH  ,W(1,179 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,179 ),GAL ,AMP(144 ))            
      CALL JIOXXX(W(1,150 ),W(1,141 ),GZU ,ZMASS   ,ZWIDTH  ,W(1,180 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,180 ),GZL ,AMP(145 ))            
      CALL HVVXXX(W(1,167 ),W(1,62  ),GZZH ,HMASS   ,HWIDTH  ,W(1,         
     &     181 ))                                                          
      CALL IOSXXX(W(1,7   ),W(1,6   ),W(1,181 ),GHTAU ,AMP(146 ))          
      CALL IOVXXX(W(1,71  ),W(1,6   ),W(1,163 ),GAL ,AMP(147 ))            
      CALL IOVXXX(W(1,73  ),W(1,6   ),W(1,163 ),GAL ,AMP(148 ))            
      CALL IOVXXX(W(1,71  ),W(1,6   ),W(1,167 ),GZL ,AMP(149 ))            
      CALL IOVXXX(W(1,73  ),W(1,6   ),W(1,167 ),GZL ,AMP(150 ))            
      CALL FVIXXX(W(1,7   ),W(1,163 ),GAL ,LMASS   ,ZERO    ,W(1,182 ))    
      CALL IOVXXX(W(1,182 ),W(1,6   ),W(1,66  ),GAL ,AMP(151 ))            
      CALL IOVXXX(W(1,182 ),W(1,6   ),W(1,62  ),GZL ,AMP(152 ))            
      CALL FVIXXX(W(1,7   ),W(1,167 ),GZL ,LMASS   ,ZERO    ,W(1,183 ))    
      CALL IOVXXX(W(1,183 ),W(1,6   ),W(1,66  ),GAL ,AMP(153 ))            
      CALL IOVXXX(W(1,183 ),W(1,6   ),W(1,62  ),GZL ,AMP(154 ))            
      CALL FVIXXX(W(1,3   ),W(1,66  ),GAU ,ZERO    ,ZERO    ,W(1,184 ))    
      CALL JIOXXX(W(1,184 ),W(1,2   ),GAU ,ZERO    ,AWIDTH  ,W(1,185 ))    
      CALL IOVXXX(W(1,63  ),W(1,6   ),W(1,185 ),GAL ,AMP(155 ))            
      CALL JIOXXX(W(1,184 ),W(1,2   ),GZU ,ZMASS   ,ZWIDTH  ,W(1,186 ))    
      CALL IOVXXX(W(1,63  ),W(1,6   ),W(1,186 ),GZL ,AMP(156 ))            
      CALL FVIXXX(W(1,3   ),W(1,62  ),GZU ,ZERO    ,ZERO    ,W(1,187 ))    
      CALL JIOXXX(W(1,187 ),W(1,2   ),GAU ,ZERO    ,AWIDTH  ,W(1,188 ))    
      CALL IOVXXX(W(1,63  ),W(1,6   ),W(1,188 ),GAL ,AMP(157 ))            
      CALL JIOXXX(W(1,187 ),W(1,2   ),GZU ,ZMASS   ,ZWIDTH  ,W(1,189 ))    
      CALL IOVXXX(W(1,63  ),W(1,6   ),W(1,189 ),GZL ,AMP(158 ))            
      CALL HVVXXX(W(1,186 ),W(1,1   ),GZZH ,HMASS   ,HWIDTH  ,W(1,         
     &     190 ))                                                          
      CALL IOSXXX(W(1,7   ),W(1,6   ),W(1,190 ),GHTAU ,AMP(159 ))          
      CALL HVVXXX(W(1,189 ),W(1,1   ),GZZH ,HMASS   ,HWIDTH  ,W(1,         
     &     191 ))                                                          
      CALL IOSXXX(W(1,7   ),W(1,6   ),W(1,191 ),GHTAU ,AMP(160 ))          
      CALL FVIXXX(W(1,7   ),W(1,185 ),GAL ,LMASS   ,ZERO    ,W(1,192 ))    
      CALL IOVXXX(W(1,192 ),W(1,6   ),W(1,1   ),GZL ,AMP(161 ))            
      CALL FVIXXX(W(1,7   ),W(1,186 ),GZL ,LMASS   ,ZERO    ,W(1,193 ))    
      CALL IOVXXX(W(1,193 ),W(1,6   ),W(1,1   ),GZL ,AMP(162 ))            
      CALL FVIXXX(W(1,7   ),W(1,188 ),GAL ,LMASS   ,ZERO    ,W(1,194 ))    
      CALL IOVXXX(W(1,194 ),W(1,6   ),W(1,1   ),GZL ,AMP(163 ))            
      CALL FVIXXX(W(1,7   ),W(1,189 ),GZL ,LMASS   ,ZERO    ,W(1,195 ))    
      CALL IOVXXX(W(1,195 ),W(1,6   ),W(1,1   ),GZL ,AMP(164 ))            
      CALL FVIXXX(W(1,184 ),W(1,1   ),GZU ,ZERO    ,ZERO    ,W(1,196 ))    
      CALL JIOXXX(W(1,196 ),W(1,2   ),GAU ,ZERO    ,AWIDTH  ,W(1,197 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,197 ),GAL ,AMP(165 ))            
      CALL JIOXXX(W(1,196 ),W(1,2   ),GZU ,ZMASS   ,ZWIDTH  ,W(1,198 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,198 ),GZL ,AMP(166 ))            
      CALL FVIXXX(W(1,187 ),W(1,1   ),GZU ,ZERO    ,ZERO    ,W(1,199 ))    
      CALL JIOXXX(W(1,199 ),W(1,2   ),GAU ,ZERO    ,AWIDTH  ,W(1,200 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,200 ),GAL ,AMP(167 ))            
      CALL JIOXXX(W(1,199 ),W(1,2   ),GZU ,ZMASS   ,ZWIDTH  ,W(1,201 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,201 ),GZL ,AMP(168 ))            
      CALL FVOXXX(W(1,2   ),W(1,1   ),GZU ,ZERO    ,ZERO    ,W(1,202 ))    
      CALL FVOXXX(W(1,202 ),W(1,66  ),GAU ,ZERO    ,ZERO    ,W(1,203 ))    
      CALL JIOXXX(W(1,3   ),W(1,203 ),GAU ,ZERO    ,AWIDTH  ,W(1,204 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,204 ),GAL ,AMP(169 ))            
      CALL JIOXXX(W(1,3   ),W(1,203 ),GZU ,ZMASS   ,ZWIDTH  ,W(1,205 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,205 ),GZL ,AMP(170 ))            
      CALL FVOXXX(W(1,202 ),W(1,62  ),GZU ,ZERO    ,ZERO    ,W(1,206 ))    
      CALL JIOXXX(W(1,3   ),W(1,206 ),GAU ,ZERO    ,AWIDTH  ,W(1,207 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,207 ),GAL ,AMP(171 ))            
      CALL JIOXXX(W(1,3   ),W(1,206 ),GZU ,ZMASS   ,ZWIDTH  ,W(1,208 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,208 ),GZL ,AMP(172 ))            
      CALL JIOXXX(W(1,3   ),W(1,202 ),GAU ,ZERO    ,AWIDTH  ,W(1,209 ))    
      CALL FVIXXX(W(1,5   ),W(1,209 ),GAL ,ZERO    ,ZERO    ,W(1,210 ))    
      CALL JIOXXX(W(1,210 ),W(1,4   ),GAL ,ZERO    ,AWIDTH  ,W(1,211 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,211 ),GAL ,AMP(173 ))            
      CALL JIOXXX(W(1,210 ),W(1,4   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,212 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,212 ),GZL ,AMP(174 ))            
      CALL JIOXXX(W(1,3   ),W(1,202 ),GZU ,ZMASS   ,ZWIDTH  ,W(1,213 ))    
      CALL FVIXXX(W(1,5   ),W(1,213 ),GZL ,ZERO    ,ZERO    ,W(1,214 ))    
      CALL JIOXXX(W(1,214 ),W(1,4   ),GAL ,ZERO    ,AWIDTH  ,W(1,215 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,215 ),GAL ,AMP(175 ))            
      CALL JIOXXX(W(1,214 ),W(1,4   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,216 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,216 ),GZL ,AMP(176 ))            
      CALL FVOXXX(W(1,4   ),W(1,209 ),GAL ,ZERO    ,ZERO    ,W(1,217 ))    
      CALL JIOXXX(W(1,5   ),W(1,217 ),GAL ,ZERO    ,AWIDTH  ,W(1,218 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,218 ),GAL ,AMP(177 ))            
      CALL JIOXXX(W(1,5   ),W(1,217 ),GZL ,ZMASS   ,ZWIDTH  ,W(1,219 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,219 ),GZL ,AMP(178 ))            
      CALL FVOXXX(W(1,4   ),W(1,213 ),GZL ,ZERO    ,ZERO    ,W(1,220 ))    
      CALL JIOXXX(W(1,5   ),W(1,220 ),GAL ,ZERO    ,AWIDTH  ,W(1,221 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,221 ),GAL ,AMP(179 ))            
      CALL JIOXXX(W(1,5   ),W(1,220 ),GZL ,ZMASS   ,ZWIDTH  ,W(1,222 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,222 ),GZL ,AMP(180 ))            
      CALL JIOXXX(W(1,184 ),W(1,202 ),GAU ,ZERO    ,AWIDTH  ,W(1,223 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,223 ),GAL ,AMP(181 ))            
      CALL JIOXXX(W(1,184 ),W(1,202 ),GZU ,ZMASS   ,ZWIDTH  ,W(1,224 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,224 ),GZL ,AMP(182 ))            
      CALL JIOXXX(W(1,187 ),W(1,202 ),GAU ,ZERO    ,AWIDTH  ,W(1,225 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,225 ),GAL ,AMP(183 ))            
      CALL JIOXXX(W(1,187 ),W(1,202 ),GZU ,ZMASS   ,ZWIDTH  ,W(1,226 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,226 ),GZL ,AMP(184 ))            
      CALL HVVXXX(W(1,213 ),W(1,62  ),GZZH ,HMASS   ,HWIDTH  ,W(1,         
     &     227 ))                                                          
      CALL IOSXXX(W(1,7   ),W(1,6   ),W(1,227 ),GHTAU ,AMP(185 ))          
      CALL IOVXXX(W(1,71  ),W(1,6   ),W(1,209 ),GAL ,AMP(186 ))            
      CALL IOVXXX(W(1,73  ),W(1,6   ),W(1,209 ),GAL ,AMP(187 ))            
      CALL IOVXXX(W(1,71  ),W(1,6   ),W(1,213 ),GZL ,AMP(188 ))            
      CALL IOVXXX(W(1,73  ),W(1,6   ),W(1,213 ),GZL ,AMP(189 ))            
      CALL FVIXXX(W(1,7   ),W(1,209 ),GAL ,LMASS   ,ZERO    ,W(1,228 ))    
      CALL IOVXXX(W(1,228 ),W(1,6   ),W(1,66  ),GAL ,AMP(190 ))            
      CALL IOVXXX(W(1,228 ),W(1,6   ),W(1,62  ),GZL ,AMP(191 ))            
      CALL FVIXXX(W(1,7   ),W(1,213 ),GZL ,LMASS   ,ZERO    ,W(1,229 ))    
      CALL IOVXXX(W(1,229 ),W(1,6   ),W(1,66  ),GAL ,AMP(192 ))            
      CALL IOVXXX(W(1,229 ),W(1,6   ),W(1,62  ),GZL ,AMP(193 ))            
      zzztensor(mu) = -AMP(   1)-AMP(   2)-AMP(   3)-AMP(   4)-AMP(   5)
     &             -AMP(   6)-AMP(   7)-AMP(   8)-AMP(   9)-AMP(  10)
     &             -AMP(  11)-AMP(  12)-AMP(  13)-AMP(  14)-AMP(  15)
     &             -AMP(  16)-AMP(  17)-AMP(  18)-AMP(  19)-AMP(  20)
     &             -AMP(  21)-AMP(  22)-AMP(  23)-AMP(  24)-AMP(  25)
     &             -AMP(  26)-AMP(  27)-AMP(  28)-AMP(  29)-AMP(  30)
     &             -AMP(  31)-AMP(  32)-AMP(  33)-AMP(  34)-AMP(  35)
     &             -AMP(  36)-AMP(  37)-AMP(  38)-AMP(  39)-AMP(  40)
     &             -AMP(  41)-AMP(  42)-AMP(  43)-AMP(  44)-AMP(  45)
     &             -AMP(  46)-AMP(  47)-AMP(  48)-AMP(  49)-AMP(  50)
     &             -AMP(  51)-AMP(  52)-AMP(  53)-AMP(  54)-AMP(  55)
     &             -AMP(  56)-AMP(  57)-AMP(  58)-AMP(  59)-AMP(  60)
     &             -AMP(  61)-AMP(  62)-AMP(  63)-AMP(  64)-AMP(  65)
     &             -AMP(  66)-AMP(  67)-AMP(  68)-AMP(  69)-AMP(  70)
     &             -AMP(  71)-AMP(  72)-AMP(  73)-AMP(  74)-AMP(  75)
     &             -AMP(  76)-AMP(  77)-AMP(  78)-AMP(  79)-AMP(  80)
     &             -AMP(  81)-AMP(  82)-AMP(  83)-AMP(  84)-AMP(  85)
     &             -AMP(  86)-AMP(  87)-AMP(  88)-AMP(  89)-AMP(  90)
     &             -AMP(  91)-AMP(  92)-AMP(  93)-AMP(  94)-AMP(  95)
     &             -AMP(  96)-AMP(  97)-AMP(  98)-AMP(  99)-AMP( 100)
     &             -AMP( 101)-AMP( 102)-AMP( 103)-AMP( 104)-AMP( 105)
     &             -AMP( 106)-AMP( 107)-AMP( 108)-AMP( 109)-AMP( 110)
     &             -AMP( 111)-AMP( 112)-AMP( 113)-AMP( 114)-AMP( 115)
     &             -AMP( 116)-AMP( 117)-AMP( 118)-AMP( 119)-AMP( 120)
     &             -AMP( 121)-AMP( 122)-AMP( 123)-AMP( 124)-AMP( 125)
     &             -AMP( 126)-AMP( 127)-AMP( 128)-AMP( 129)-AMP( 130)
     &             -AMP( 131)-AMP( 132)-AMP( 133)-AMP( 134)-AMP( 135)
     &             -AMP( 136)-AMP( 137)-AMP( 138)-AMP( 139)-AMP( 140)
     &             -AMP( 141)-AMP( 142)-AMP( 143)-AMP( 144)-AMP( 145)
     &             -AMP( 146)-AMP( 147)-AMP( 148)-AMP( 149)-AMP( 150)
     &             -AMP( 151)-AMP( 152)-AMP( 153)-AMP( 154)-AMP( 155)
     &             -AMP( 156)-AMP( 157)-AMP( 158)-AMP( 159)-AMP( 160)
     &             -AMP( 161)-AMP( 162)-AMP( 163)-AMP( 164)-AMP( 165)
     &             -AMP( 166)-AMP( 167)-AMP( 168)-AMP( 169)-AMP( 170)
     &             -AMP( 171)-AMP( 172)-AMP( 173)-AMP( 174)-AMP( 175)
     &             -AMP( 176)-AMP( 177)-AMP( 178)-AMP( 179)-AMP( 180)
     &             -AMP( 181)-AMP( 182)-AMP( 183)-AMP( 184)-AMP( 185)
     &             -AMP( 186)-AMP( 187)-AMP( 188)-AMP( 189)-AMP( 190)
     &             -AMP( 191)-AMP( 192)-AMP( 193)

      elseif (procid.eq.ZZZhad .and. Ztodd) then

      CALL JIOXXX(W(1,3   ),W(1,2   ),GAD ,ZERO    ,AWIDTH  ,W(1,8   ))    
      CALL FVOXXX(W(1,4   ),W(1,8   ),GAL ,ZERO    ,ZERO    ,W(1,9   ))    
      CALL JIOXXX(W(1,5   ),W(1,9   ),GAL ,ZERO    ,AWIDTH  ,W(1,10  ))    
      CALL FVOXXX(W(1,6   ),W(1,10  ),GAL ,LMASS   ,ZERO    ,W(1,11  ))    
      CALL IOVXXX(W(1,7   ),W(1,11  ),W(1,1   ),GZL ,AMP(1   ))            
      CALL JIOXXX(W(1,5   ),W(1,9   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,12  ))    
      CALL FVOXXX(W(1,6   ),W(1,12  ),GZL ,LMASS   ,ZERO    ,W(1,13  ))    
      CALL IOVXXX(W(1,7   ),W(1,13  ),W(1,1   ),GZL ,AMP(2   ))            
      CALL JIOXXX(W(1,3   ),W(1,2   ),GZD ,ZMASS   ,ZWIDTH  ,W(1,14  ))    
      CALL FVOXXX(W(1,4   ),W(1,14  ),GZL ,ZERO    ,ZERO    ,W(1,15  ))    
      CALL JIOXXX(W(1,5   ),W(1,15  ),GAL ,ZERO    ,AWIDTH  ,W(1,16  ))    
      CALL FVOXXX(W(1,6   ),W(1,16  ),GAL ,LMASS   ,ZERO    ,W(1,17  ))    
      CALL IOVXXX(W(1,7   ),W(1,17  ),W(1,1   ),GZL ,AMP(3   ))            
      CALL JIOXXX(W(1,5   ),W(1,15  ),GZL ,ZMASS   ,ZWIDTH  ,W(1,18  ))    
      CALL FVOXXX(W(1,6   ),W(1,18  ),GZL ,LMASS   ,ZERO    ,W(1,19  ))    
      CALL IOVXXX(W(1,7   ),W(1,19  ),W(1,1   ),GZL ,AMP(4   ))            
      CALL HVVXXX(W(1,12  ),W(1,1   ),GZZH ,HMASS   ,HWIDTH  ,W(1,         
     &     20  ))                                                          
      CALL IOSXXX(W(1,7   ),W(1,6   ),W(1,20  ),GHTAU ,AMP(5   ))          
      CALL HVVXXX(W(1,18  ),W(1,1   ),GZZH ,HMASS   ,HWIDTH  ,W(1,         
     &     21  ))                                                          
      CALL IOSXXX(W(1,7   ),W(1,6   ),W(1,21  ),GHTAU ,AMP(6   ))          
      CALL FVIXXX(W(1,7   ),W(1,10  ),GAL ,LMASS   ,ZERO    ,W(1,22  ))    
      CALL IOVXXX(W(1,22  ),W(1,6   ),W(1,1   ),GZL ,AMP(7   ))            
      CALL FVIXXX(W(1,7   ),W(1,12  ),GZL ,LMASS   ,ZERO    ,W(1,23  ))    
      CALL IOVXXX(W(1,23  ),W(1,6   ),W(1,1   ),GZL ,AMP(8   ))            
      CALL FVIXXX(W(1,7   ),W(1,16  ),GAL ,LMASS   ,ZERO    ,W(1,24  ))    
      CALL IOVXXX(W(1,24  ),W(1,6   ),W(1,1   ),GZL ,AMP(9   ))            
      CALL FVIXXX(W(1,7   ),W(1,18  ),GZL ,LMASS   ,ZERO    ,W(1,25  ))    
      CALL IOVXXX(W(1,25  ),W(1,6   ),W(1,1   ),GZL ,AMP(10  ))            
      CALL FVIXXX(W(1,5   ),W(1,1   ),GZL ,ZERO    ,ZERO    ,W(1,26  ))    
      CALL JIOXXX(W(1,26  ),W(1,4   ),GAL ,ZERO    ,AWIDTH  ,W(1,27  ))    
      CALL FVIXXX(W(1,3   ),W(1,27  ),GAD ,ZERO    ,ZERO    ,W(1,28  ))    
      CALL JIOXXX(W(1,28  ),W(1,2   ),GAD ,ZERO    ,AWIDTH  ,W(1,29  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,29  ),GAL ,AMP(11  ))            
      CALL JIOXXX(W(1,28  ),W(1,2   ),GZD ,ZMASS   ,ZWIDTH  ,W(1,30  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,30  ),GZL ,AMP(12  ))            
      CALL JIOXXX(W(1,26  ),W(1,4   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,31  ))    
      CALL FVIXXX(W(1,3   ),W(1,31  ),GZD ,ZERO    ,ZERO    ,W(1,32  ))    
      CALL JIOXXX(W(1,32  ),W(1,2   ),GAD ,ZERO    ,AWIDTH  ,W(1,33  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,33  ),GAL ,AMP(13  ))            
      CALL JIOXXX(W(1,32  ),W(1,2   ),GZD ,ZMASS   ,ZWIDTH  ,W(1,34  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,34  ),GZL ,AMP(14  ))            
      CALL FVOXXX(W(1,2   ),W(1,27  ),GAD ,ZERO    ,ZERO    ,W(1,35  ))    
      CALL JIOXXX(W(1,3   ),W(1,35  ),GAD ,ZERO    ,AWIDTH  ,W(1,36  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,36  ),GAL ,AMP(15  ))            
      CALL JIOXXX(W(1,3   ),W(1,35  ),GZD ,ZMASS   ,ZWIDTH  ,W(1,37  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,37  ),GZL ,AMP(16  ))            
      CALL FVOXXX(W(1,2   ),W(1,31  ),GZD ,ZERO    ,ZERO    ,W(1,38  ))    
      CALL JIOXXX(W(1,3   ),W(1,38  ),GAD ,ZERO    ,AWIDTH  ,W(1,39  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,39  ),GAL ,AMP(17  ))            
      CALL JIOXXX(W(1,3   ),W(1,38  ),GZD ,ZMASS   ,ZWIDTH  ,W(1,40  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,40  ),GZL ,AMP(18  ))            
      CALL FVIXXX(W(1,26  ),W(1,8   ),GAL ,ZERO    ,ZERO    ,W(1,41  ))    
      CALL JIOXXX(W(1,41  ),W(1,4   ),GAL ,ZERO    ,AWIDTH  ,W(1,42  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,42  ),GAL ,AMP(19  ))            
      CALL JIOXXX(W(1,41  ),W(1,4   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,43  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,43  ),GZL ,AMP(20  ))            
      CALL FVIXXX(W(1,26  ),W(1,14  ),GZL ,ZERO    ,ZERO    ,W(1,44  ))    
      CALL JIOXXX(W(1,44  ),W(1,4   ),GAL ,ZERO    ,AWIDTH  ,W(1,45  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,45  ),GAL ,AMP(21  ))            
      CALL JIOXXX(W(1,44  ),W(1,4   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,46  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,46  ),GZL ,AMP(22  ))            
      CALL FVOXXX(W(1,9   ),W(1,1   ),GZL ,ZERO    ,ZERO    ,W(1,47  ))    
      CALL JIOXXX(W(1,5   ),W(1,47  ),GAL ,ZERO    ,AWIDTH  ,W(1,48  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,48  ),GAL ,AMP(23  ))            
      CALL JIOXXX(W(1,5   ),W(1,47  ),GZL ,ZMASS   ,ZWIDTH  ,W(1,49  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,49  ),GZL ,AMP(24  ))            
      CALL FVOXXX(W(1,15  ),W(1,1   ),GZL ,ZERO    ,ZERO    ,W(1,50  ))    
      CALL JIOXXX(W(1,5   ),W(1,50  ),GAL ,ZERO    ,AWIDTH  ,W(1,51  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,51  ),GAL ,AMP(25  ))            
      CALL JIOXXX(W(1,5   ),W(1,50  ),GZL ,ZMASS   ,ZWIDTH  ,W(1,52  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,52  ),GZL ,AMP(26  ))            
      CALL HVVXXX(W(1,14  ),W(1,31  ),GZZH ,HMASS   ,HWIDTH  ,W(1,         
     &     53  ))                                                          
      CALL IOSXXX(W(1,7   ),W(1,6   ),W(1,53  ),GHTAU ,AMP(27  ))          
      CALL FVIXXX(W(1,7   ),W(1,27  ),GAL ,LMASS   ,ZERO    ,W(1,54  ))    
      CALL IOVXXX(W(1,54  ),W(1,6   ),W(1,8   ),GAL ,AMP(28  ))            
      CALL FVIXXX(W(1,7   ),W(1,31  ),GZL ,LMASS   ,ZERO    ,W(1,55  ))    
      CALL IOVXXX(W(1,55  ),W(1,6   ),W(1,8   ),GAL ,AMP(29  ))            
      CALL IOVXXX(W(1,54  ),W(1,6   ),W(1,14  ),GZL ,AMP(30  ))            
      CALL IOVXXX(W(1,55  ),W(1,6   ),W(1,14  ),GZL ,AMP(31  ))            
      CALL FVIXXX(W(1,7   ),W(1,8   ),GAL ,LMASS   ,ZERO    ,W(1,56  ))    
      CALL IOVXXX(W(1,56  ),W(1,6   ),W(1,27  ),GAL ,AMP(32  ))            
      CALL IOVXXX(W(1,56  ),W(1,6   ),W(1,31  ),GZL ,AMP(33  ))            
      CALL FVIXXX(W(1,7   ),W(1,14  ),GZL ,LMASS   ,ZERO    ,W(1,57  ))    
      CALL IOVXXX(W(1,57  ),W(1,6   ),W(1,27  ),GAL ,AMP(34  ))            
      CALL IOVXXX(W(1,57  ),W(1,6   ),W(1,31  ),GZL ,AMP(35  ))            
      CALL JIOXXX(W(1,26  ),W(1,9   ),GAL ,ZERO    ,AWIDTH  ,W(1,58  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,58  ),GAL ,AMP(36  ))            
      CALL JIOXXX(W(1,26  ),W(1,9   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,59  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,59  ),GZL ,AMP(37  ))            
      CALL JIOXXX(W(1,26  ),W(1,15  ),GAL ,ZERO    ,AWIDTH  ,W(1,60  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,60  ),GAL ,AMP(38  ))            
      CALL JIOXXX(W(1,26  ),W(1,15  ),GZL ,ZMASS   ,ZWIDTH  ,W(1,61  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,61  ),GZL ,AMP(39  ))            
      CALL JIOXXX(W(1,5   ),W(1,4   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,62  ))    
      CALL FVIXXX(W(1,7   ),W(1,1   ),GZL ,LMASS   ,ZERO    ,W(1,63  ))    
      CALL HVVXXX(W(1,62  ),W(1,14  ),GZZH ,HMASS   ,HWIDTH  ,W(1,         
     &     64  ))                                                          
      CALL IOSXXX(W(1,63  ),W(1,6   ),W(1,64  ),GHTAU ,AMP(40  ))          
      CALL JVSXXX(W(1,1   ),W(1,64  ),GZZH ,ZMASS   ,ZWIDTH  ,W(1,         
     &     65  ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,65  ),GZL ,AMP(41  ))            
      CALL JIOXXX(W(1,5   ),W(1,4   ),GAL ,ZERO    ,AWIDTH  ,W(1,66  ))    
      CALL FVIXXX(W(1,56  ),W(1,66  ),GAL ,LMASS   ,ZERO    ,W(1,67  ))    
      CALL IOVXXX(W(1,67  ),W(1,6   ),W(1,1   ),GZL ,AMP(42  ))            
      CALL FVIXXX(W(1,56  ),W(1,62  ),GZL ,LMASS   ,ZERO    ,W(1,68  ))    
      CALL IOVXXX(W(1,68  ),W(1,6   ),W(1,1   ),GZL ,AMP(43  ))            
      CALL FVIXXX(W(1,57  ),W(1,66  ),GAL ,LMASS   ,ZERO    ,W(1,69  ))    
      CALL IOVXXX(W(1,69  ),W(1,6   ),W(1,1   ),GZL ,AMP(44  ))            
      CALL FVIXXX(W(1,57  ),W(1,62  ),GZL ,LMASS   ,ZERO    ,W(1,70  ))    
      CALL IOVXXX(W(1,70  ),W(1,6   ),W(1,1   ),GZL ,AMP(45  ))            
      CALL FVIXXX(W(1,7   ),W(1,66  ),GAL ,LMASS   ,ZERO    ,W(1,71  ))    
      CALL FVIXXX(W(1,71  ),W(1,8   ),GAL ,LMASS   ,ZERO    ,W(1,72  ))    
      CALL IOVXXX(W(1,72  ),W(1,6   ),W(1,1   ),GZL ,AMP(46  ))            
      CALL FVIXXX(W(1,7   ),W(1,62  ),GZL ,LMASS   ,ZERO    ,W(1,73  ))    
      CALL FVIXXX(W(1,73  ),W(1,8   ),GAL ,LMASS   ,ZERO    ,W(1,74  ))    
      CALL IOVXXX(W(1,74  ),W(1,6   ),W(1,1   ),GZL ,AMP(47  ))            
      CALL FVIXXX(W(1,71  ),W(1,14  ),GZL ,LMASS   ,ZERO    ,W(1,75  ))    
      CALL IOVXXX(W(1,75  ),W(1,6   ),W(1,1   ),GZL ,AMP(48  ))            
      CALL FVIXXX(W(1,73  ),W(1,14  ),GZL ,LMASS   ,ZERO    ,W(1,76  ))    
      CALL IOVXXX(W(1,76  ),W(1,6   ),W(1,1   ),GZL ,AMP(49  ))            
      CALL FSIXXX(W(1,7   ),W(1,64  ),GHTAU ,LMASS   ,ZERO    ,W(1,        
     &     77  ))                                                          
      CALL IOVXXX(W(1,77  ),W(1,6   ),W(1,1   ),GZL ,AMP(50  ))            
      CALL FVIXXX(W(1,63  ),W(1,66  ),GAL ,LMASS   ,ZERO    ,W(1,78  ))    
      CALL IOVXXX(W(1,78  ),W(1,6   ),W(1,8   ),GAL ,AMP(51  ))            
      CALL FVIXXX(W(1,63  ),W(1,62  ),GZL ,LMASS   ,ZERO    ,W(1,79  ))    
      CALL IOVXXX(W(1,79  ),W(1,6   ),W(1,8   ),GAL ,AMP(52  ))            
      CALL IOVXXX(W(1,78  ),W(1,6   ),W(1,14  ),GZL ,AMP(53  ))            
      CALL IOVXXX(W(1,79  ),W(1,6   ),W(1,14  ),GZL ,AMP(54  ))            
      CALL HVVXXX(W(1,62  ),W(1,1   ),GZZH ,HMASS   ,HWIDTH  ,W(1,         
     &     80  ))                                                          
      CALL JVSXXX(W(1,14  ),W(1,80  ),GZZH ,ZMASS   ,ZWIDTH  ,W(1,         
     &     81  ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,81  ),GZL ,AMP(55  ))            
      CALL FSIXXX(W(1,7   ),W(1,80  ),GHTAU ,LMASS   ,ZERO    ,W(1,        
     &     82  ))                                                          
      CALL IOVXXX(W(1,82  ),W(1,6   ),W(1,8   ),GAL ,AMP(56  ))            
      CALL IOVXXX(W(1,82  ),W(1,6   ),W(1,14  ),GZL ,AMP(57  ))            
      CALL FVIXXX(W(1,71  ),W(1,1   ),GZL ,LMASS   ,ZERO    ,W(1,83  ))    
      CALL IOVXXX(W(1,83  ),W(1,6   ),W(1,8   ),GAL ,AMP(58  ))            
      CALL FVIXXX(W(1,73  ),W(1,1   ),GZL ,LMASS   ,ZERO    ,W(1,84  ))    
      CALL IOVXXX(W(1,84  ),W(1,6   ),W(1,8   ),GAL ,AMP(59  ))            
      CALL IOVXXX(W(1,83  ),W(1,6   ),W(1,14  ),GZL ,AMP(60  ))            
      CALL IOVXXX(W(1,84  ),W(1,6   ),W(1,14  ),GZL ,AMP(61  ))            
      CALL IOSXXX(W(1,56  ),W(1,6   ),W(1,80  ),GHTAU ,AMP(62  ))          
      CALL IOSXXX(W(1,57  ),W(1,6   ),W(1,80  ),GHTAU ,AMP(63  ))          
      CALL FVIXXX(W(1,63  ),W(1,8   ),GAL ,LMASS   ,ZERO    ,W(1,85  ))    
      CALL IOVXXX(W(1,85  ),W(1,6   ),W(1,66  ),GAL ,AMP(64  ))            
      CALL IOVXXX(W(1,85  ),W(1,6   ),W(1,62  ),GZL ,AMP(65  ))            
      CALL FVIXXX(W(1,63  ),W(1,14  ),GZL ,LMASS   ,ZERO    ,W(1,86  ))    
      CALL IOVXXX(W(1,86  ),W(1,6   ),W(1,66  ),GAL ,AMP(66  ))            
      CALL IOVXXX(W(1,86  ),W(1,6   ),W(1,62  ),GZL ,AMP(67  ))            
      CALL HVVXXX(W(1,14  ),W(1,1   ),GZZH ,HMASS   ,HWIDTH  ,W(1,         
     &     87  ))                                                          
      CALL JVSXXX(W(1,62  ),W(1,87  ),GZZH ,ZMASS   ,ZWIDTH  ,W(1,         
     &     88  ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,88  ),GZL ,AMP(68  ))            
      CALL FVIXXX(W(1,56  ),W(1,1   ),GZL ,LMASS   ,ZERO    ,W(1,89  ))    
      CALL IOVXXX(W(1,89  ),W(1,6   ),W(1,66  ),GAL ,AMP(69  ))            
      CALL IOVXXX(W(1,89  ),W(1,6   ),W(1,62  ),GZL ,AMP(70  ))            
      CALL FVIXXX(W(1,57  ),W(1,1   ),GZL ,LMASS   ,ZERO    ,W(1,90  ))    
      CALL IOVXXX(W(1,90  ),W(1,6   ),W(1,66  ),GAL ,AMP(71  ))            
      CALL IOVXXX(W(1,90  ),W(1,6   ),W(1,62  ),GZL ,AMP(72  ))            
      CALL IOSXXX(W(1,71  ),W(1,6   ),W(1,87  ),GHTAU ,AMP(73  ))          
      CALL IOSXXX(W(1,73  ),W(1,6   ),W(1,87  ),GHTAU ,AMP(74  ))          
      CALL FSIXXX(W(1,7   ),W(1,87  ),GHTAU ,LMASS   ,ZERO    ,W(1,        
     &     91  ))                                                          
      CALL IOVXXX(W(1,91  ),W(1,6   ),W(1,66  ),GAL ,AMP(75  ))            
      CALL IOVXXX(W(1,91  ),W(1,6   ),W(1,62  ),GZL ,AMP(76  ))            
      CALL FVIXXX(W(1,5   ),W(1,8   ),GAL ,ZERO    ,ZERO    ,W(1,92  ))    
      CALL JIOXXX(W(1,92  ),W(1,4   ),GAL ,ZERO    ,AWIDTH  ,W(1,93  ))    
      CALL IOVXXX(W(1,63  ),W(1,6   ),W(1,93  ),GAL ,AMP(77  ))            
      CALL JIOXXX(W(1,92  ),W(1,4   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,94  ))    
      CALL IOVXXX(W(1,63  ),W(1,6   ),W(1,94  ),GZL ,AMP(78  ))            
      CALL FVIXXX(W(1,5   ),W(1,14  ),GZL ,ZERO    ,ZERO    ,W(1,95  ))    
      CALL JIOXXX(W(1,95  ),W(1,4   ),GAL ,ZERO    ,AWIDTH  ,W(1,96  ))    
      CALL IOVXXX(W(1,63  ),W(1,6   ),W(1,96  ),GAL ,AMP(79  ))            
      CALL JIOXXX(W(1,95  ),W(1,4   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,97  ))    
      CALL IOVXXX(W(1,63  ),W(1,6   ),W(1,97  ),GZL ,AMP(80  ))            
      CALL HVVXXX(W(1,94  ),W(1,1   ),GZZH ,HMASS   ,HWIDTH  ,W(1,         
     &     98  ))                                                          
      CALL IOSXXX(W(1,7   ),W(1,6   ),W(1,98  ),GHTAU ,AMP(81  ))          
      CALL HVVXXX(W(1,97  ),W(1,1   ),GZZH ,HMASS   ,HWIDTH  ,W(1,         
     &     99  ))                                                          
      CALL IOSXXX(W(1,7   ),W(1,6   ),W(1,99  ),GHTAU ,AMP(82  ))          
      CALL FVIXXX(W(1,7   ),W(1,93  ),GAL ,LMASS   ,ZERO    ,W(1,100 ))    
      CALL IOVXXX(W(1,100 ),W(1,6   ),W(1,1   ),GZL ,AMP(83  ))            
      CALL FVIXXX(W(1,7   ),W(1,94  ),GZL ,LMASS   ,ZERO    ,W(1,101 ))    
      CALL IOVXXX(W(1,101 ),W(1,6   ),W(1,1   ),GZL ,AMP(84  ))            
      CALL FVIXXX(W(1,7   ),W(1,96  ),GAL ,LMASS   ,ZERO    ,W(1,102 ))    
      CALL IOVXXX(W(1,102 ),W(1,6   ),W(1,1   ),GZL ,AMP(85  ))            
      CALL FVIXXX(W(1,7   ),W(1,97  ),GZL ,LMASS   ,ZERO    ,W(1,103 ))    
      CALL IOVXXX(W(1,103 ),W(1,6   ),W(1,1   ),GZL ,AMP(86  ))            
      CALL FVOXXX(W(1,4   ),W(1,1   ),GZL ,ZERO    ,ZERO    ,W(1,104 ))    
      CALL JIOXXX(W(1,5   ),W(1,104 ),GAL ,ZERO    ,AWIDTH  ,W(1,105 ))    
      CALL FVIXXX(W(1,3   ),W(1,105 ),GAD ,ZERO    ,ZERO    ,W(1,106 ))    
      CALL JIOXXX(W(1,106 ),W(1,2   ),GAD ,ZERO    ,AWIDTH  ,W(1,107 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,107 ),GAL ,AMP(87  ))            
      CALL JIOXXX(W(1,106 ),W(1,2   ),GZD ,ZMASS   ,ZWIDTH  ,W(1,108 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,108 ),GZL ,AMP(88  ))            
      CALL JIOXXX(W(1,5   ),W(1,104 ),GZL ,ZMASS   ,ZWIDTH  ,W(1,109 ))    
      CALL FVIXXX(W(1,3   ),W(1,109 ),GZD ,ZERO    ,ZERO    ,W(1,110 ))    
      CALL JIOXXX(W(1,110 ),W(1,2   ),GAD ,ZERO    ,AWIDTH  ,W(1,111 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,111 ),GAL ,AMP(89  ))            
      CALL JIOXXX(W(1,110 ),W(1,2   ),GZD ,ZMASS   ,ZWIDTH  ,W(1,112 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,112 ),GZL ,AMP(90  ))            
      CALL FVOXXX(W(1,2   ),W(1,105 ),GAD ,ZERO    ,ZERO    ,W(1,113 ))    
      CALL JIOXXX(W(1,3   ),W(1,113 ),GAD ,ZERO    ,AWIDTH  ,W(1,114 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,114 ),GAL ,AMP(91  ))            
      CALL JIOXXX(W(1,3   ),W(1,113 ),GZD ,ZMASS   ,ZWIDTH  ,W(1,115 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,115 ),GZL ,AMP(92  ))            
      CALL FVOXXX(W(1,2   ),W(1,109 ),GZD ,ZERO    ,ZERO    ,W(1,116 ))    
      CALL JIOXXX(W(1,3   ),W(1,116 ),GAD ,ZERO    ,AWIDTH  ,W(1,117 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,117 ),GAL ,AMP(93  ))            
      CALL JIOXXX(W(1,3   ),W(1,116 ),GZD ,ZMASS   ,ZWIDTH  ,W(1,118 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,118 ),GZL ,AMP(94  ))            
      CALL FVIXXX(W(1,92  ),W(1,1   ),GZL ,ZERO    ,ZERO    ,W(1,119 ))    
      CALL JIOXXX(W(1,119 ),W(1,4   ),GAL ,ZERO    ,AWIDTH  ,W(1,120 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,120 ),GAL ,AMP(95  ))            
      CALL JIOXXX(W(1,119 ),W(1,4   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,121 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,121 ),GZL ,AMP(96  ))            
      CALL FVIXXX(W(1,95  ),W(1,1   ),GZL ,ZERO    ,ZERO    ,W(1,122 ))    
      CALL JIOXXX(W(1,122 ),W(1,4   ),GAL ,ZERO    ,AWIDTH  ,W(1,123 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,123 ),GAL ,AMP(97  ))            
      CALL JIOXXX(W(1,122 ),W(1,4   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,124 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,124 ),GZL ,AMP(98  ))            
      CALL FVOXXX(W(1,104 ),W(1,8   ),GAL ,ZERO    ,ZERO    ,W(1,125 ))    
      CALL JIOXXX(W(1,5   ),W(1,125 ),GAL ,ZERO    ,AWIDTH  ,W(1,126 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,126 ),GAL ,AMP(99  ))            
      CALL JIOXXX(W(1,5   ),W(1,125 ),GZL ,ZMASS   ,ZWIDTH  ,W(1,127 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,127 ),GZL ,AMP(100 ))            
      CALL FVOXXX(W(1,104 ),W(1,14  ),GZL ,ZERO    ,ZERO    ,W(1,128 ))    
      CALL JIOXXX(W(1,5   ),W(1,128 ),GAL ,ZERO    ,AWIDTH  ,W(1,129 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,129 ),GAL ,AMP(101 ))            
      CALL JIOXXX(W(1,5   ),W(1,128 ),GZL ,ZMASS   ,ZWIDTH  ,W(1,130 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,130 ),GZL ,AMP(102 ))            
      CALL JIOXXX(W(1,92  ),W(1,104 ),GAL ,ZERO    ,AWIDTH  ,W(1,131 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,131 ),GAL ,AMP(103 ))            
      CALL JIOXXX(W(1,92  ),W(1,104 ),GZL ,ZMASS   ,ZWIDTH  ,W(1,132 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,132 ),GZL ,AMP(104 ))            
      CALL JIOXXX(W(1,95  ),W(1,104 ),GAL ,ZERO    ,AWIDTH  ,W(1,133 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,133 ),GAL ,AMP(105 ))            
      CALL JIOXXX(W(1,95  ),W(1,104 ),GZL ,ZMASS   ,ZWIDTH  ,W(1,134 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,134 ),GZL ,AMP(106 ))            
      CALL HVVXXX(W(1,14  ),W(1,109 ),GZZH ,HMASS   ,HWIDTH  ,W(1,         
     &     135 ))                                                          
      CALL IOSXXX(W(1,7   ),W(1,6   ),W(1,135 ),GHTAU ,AMP(107 ))          
      CALL FVIXXX(W(1,7   ),W(1,105 ),GAL ,LMASS   ,ZERO    ,W(1,136 ))    
      CALL IOVXXX(W(1,136 ),W(1,6   ),W(1,8   ),GAL ,AMP(108 ))            
      CALL FVIXXX(W(1,7   ),W(1,109 ),GZL ,LMASS   ,ZERO    ,W(1,137 ))    
      CALL IOVXXX(W(1,137 ),W(1,6   ),W(1,8   ),GAL ,AMP(109 ))            
      CALL IOVXXX(W(1,136 ),W(1,6   ),W(1,14  ),GZL ,AMP(110 ))            
      CALL IOVXXX(W(1,137 ),W(1,6   ),W(1,14  ),GZL ,AMP(111 ))            
      CALL IOVXXX(W(1,56  ),W(1,6   ),W(1,105 ),GAL ,AMP(112 ))            
      CALL IOVXXX(W(1,56  ),W(1,6   ),W(1,109 ),GZL ,AMP(113 ))            
      CALL IOVXXX(W(1,57  ),W(1,6   ),W(1,105 ),GAL ,AMP(114 ))            
      CALL IOVXXX(W(1,57  ),W(1,6   ),W(1,109 ),GZL ,AMP(115 ))            
      CALL FVOXXX(W(1,2   ),W(1,66  ),GAD ,ZERO    ,ZERO    ,W(1,138 ))    
      CALL JIOXXX(W(1,3   ),W(1,138 ),GAD ,ZERO    ,AWIDTH  ,W(1,139 ))    
      CALL IOVXXX(W(1,63  ),W(1,6   ),W(1,139 ),GAL ,AMP(116 ))            
      CALL JIOXXX(W(1,3   ),W(1,138 ),GZD ,ZMASS   ,ZWIDTH  ,W(1,140 ))    
      CALL IOVXXX(W(1,63  ),W(1,6   ),W(1,140 ),GZL ,AMP(117 ))            
      CALL FVOXXX(W(1,2   ),W(1,62  ),GZD ,ZERO    ,ZERO    ,W(1,141 ))    
      CALL JIOXXX(W(1,3   ),W(1,141 ),GAD ,ZERO    ,AWIDTH  ,W(1,142 ))    
      CALL IOVXXX(W(1,63  ),W(1,6   ),W(1,142 ),GAL ,AMP(118 ))            
      CALL JIOXXX(W(1,3   ),W(1,141 ),GZD ,ZMASS   ,ZWIDTH  ,W(1,143 ))    
      CALL IOVXXX(W(1,63  ),W(1,6   ),W(1,143 ),GZL ,AMP(119 ))            
      CALL HVVXXX(W(1,140 ),W(1,1   ),GZZH ,HMASS   ,HWIDTH  ,W(1,         
     &     144 ))                                                          
      CALL IOSXXX(W(1,7   ),W(1,6   ),W(1,144 ),GHTAU ,AMP(120 ))          
      CALL HVVXXX(W(1,143 ),W(1,1   ),GZZH ,HMASS   ,HWIDTH  ,W(1,         
     &     145 ))                                                          
      CALL IOSXXX(W(1,7   ),W(1,6   ),W(1,145 ),GHTAU ,AMP(121 ))          
      CALL FVIXXX(W(1,7   ),W(1,139 ),GAL ,LMASS   ,ZERO    ,W(1,146 ))    
      CALL IOVXXX(W(1,146 ),W(1,6   ),W(1,1   ),GZL ,AMP(122 ))            
      CALL FVIXXX(W(1,7   ),W(1,140 ),GZL ,LMASS   ,ZERO    ,W(1,147 ))    
      CALL IOVXXX(W(1,147 ),W(1,6   ),W(1,1   ),GZL ,AMP(123 ))            
      CALL FVIXXX(W(1,7   ),W(1,142 ),GAL ,LMASS   ,ZERO    ,W(1,148 ))    
      CALL IOVXXX(W(1,148 ),W(1,6   ),W(1,1   ),GZL ,AMP(124 ))            
      CALL FVIXXX(W(1,7   ),W(1,143 ),GZL ,LMASS   ,ZERO    ,W(1,149 ))    
      CALL IOVXXX(W(1,149 ),W(1,6   ),W(1,1   ),GZL ,AMP(125 ))            
      CALL FVIXXX(W(1,3   ),W(1,1   ),GZD ,ZERO    ,ZERO    ,W(1,150 ))    
      CALL FVIXXX(W(1,150 ),W(1,66  ),GAD ,ZERO    ,ZERO    ,W(1,151 ))    
      CALL JIOXXX(W(1,151 ),W(1,2   ),GAD ,ZERO    ,AWIDTH  ,W(1,152 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,152 ),GAL ,AMP(126 ))            
      CALL JIOXXX(W(1,151 ),W(1,2   ),GZD ,ZMASS   ,ZWIDTH  ,W(1,153 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,153 ),GZL ,AMP(127 ))            
      CALL FVIXXX(W(1,150 ),W(1,62  ),GZD ,ZERO    ,ZERO    ,W(1,154 ))    
      CALL JIOXXX(W(1,154 ),W(1,2   ),GAD ,ZERO    ,AWIDTH  ,W(1,155 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,155 ),GAL ,AMP(128 ))            
      CALL JIOXXX(W(1,154 ),W(1,2   ),GZD ,ZMASS   ,ZWIDTH  ,W(1,156 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,156 ),GZL ,AMP(129 ))            
      CALL FVOXXX(W(1,138 ),W(1,1   ),GZD ,ZERO    ,ZERO    ,W(1,157 ))    
      CALL JIOXXX(W(1,3   ),W(1,157 ),GAD ,ZERO    ,AWIDTH  ,W(1,158 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,158 ),GAL ,AMP(130 ))            
      CALL JIOXXX(W(1,3   ),W(1,157 ),GZD ,ZMASS   ,ZWIDTH  ,W(1,159 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,159 ),GZL ,AMP(131 ))            
      CALL FVOXXX(W(1,141 ),W(1,1   ),GZD ,ZERO    ,ZERO    ,W(1,160 ))    
      CALL JIOXXX(W(1,3   ),W(1,160 ),GAD ,ZERO    ,AWIDTH  ,W(1,161 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,161 ),GAL ,AMP(132 ))            
      CALL JIOXXX(W(1,3   ),W(1,160 ),GZD ,ZMASS   ,ZWIDTH  ,W(1,162 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,162 ),GZL ,AMP(133 ))            
      CALL JIOXXX(W(1,150 ),W(1,2   ),GAD ,ZERO    ,AWIDTH  ,W(1,163 ))    
      CALL FVIXXX(W(1,5   ),W(1,163 ),GAL ,ZERO    ,ZERO    ,W(1,164 ))    
      CALL JIOXXX(W(1,164 ),W(1,4   ),GAL ,ZERO    ,AWIDTH  ,W(1,165 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,165 ),GAL ,AMP(134 ))            
      CALL JIOXXX(W(1,164 ),W(1,4   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,166 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,166 ),GZL ,AMP(135 ))            
      CALL JIOXXX(W(1,150 ),W(1,2   ),GZD ,ZMASS   ,ZWIDTH  ,W(1,167 ))    
      CALL FVIXXX(W(1,5   ),W(1,167 ),GZL ,ZERO    ,ZERO    ,W(1,168 ))    
      CALL JIOXXX(W(1,168 ),W(1,4   ),GAL ,ZERO    ,AWIDTH  ,W(1,169 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,169 ),GAL ,AMP(136 ))            
      CALL JIOXXX(W(1,168 ),W(1,4   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,170 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,170 ),GZL ,AMP(137 ))            
      CALL FVOXXX(W(1,4   ),W(1,163 ),GAL ,ZERO    ,ZERO    ,W(1,171 ))    
      CALL JIOXXX(W(1,5   ),W(1,171 ),GAL ,ZERO    ,AWIDTH  ,W(1,172 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,172 ),GAL ,AMP(138 ))            
      CALL JIOXXX(W(1,5   ),W(1,171 ),GZL ,ZMASS   ,ZWIDTH  ,W(1,173 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,173 ),GZL ,AMP(139 ))            
      CALL FVOXXX(W(1,4   ),W(1,167 ),GZL ,ZERO    ,ZERO    ,W(1,174 ))    
      CALL JIOXXX(W(1,5   ),W(1,174 ),GAL ,ZERO    ,AWIDTH  ,W(1,175 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,175 ),GAL ,AMP(140 ))            
      CALL JIOXXX(W(1,5   ),W(1,174 ),GZL ,ZMASS   ,ZWIDTH  ,W(1,176 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,176 ),GZL ,AMP(141 ))            
      CALL JIOXXX(W(1,150 ),W(1,138 ),GAD ,ZERO    ,AWIDTH  ,W(1,177 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,177 ),GAL ,AMP(142 ))            
      CALL JIOXXX(W(1,150 ),W(1,138 ),GZD ,ZMASS   ,ZWIDTH  ,W(1,178 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,178 ),GZL ,AMP(143 ))            
      CALL JIOXXX(W(1,150 ),W(1,141 ),GAD ,ZERO    ,AWIDTH  ,W(1,179 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,179 ),GAL ,AMP(144 ))            
      CALL JIOXXX(W(1,150 ),W(1,141 ),GZD ,ZMASS   ,ZWIDTH  ,W(1,180 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,180 ),GZL ,AMP(145 ))            
      CALL HVVXXX(W(1,167 ),W(1,62  ),GZZH ,HMASS   ,HWIDTH  ,W(1,         
     &     181 ))                                                          
      CALL IOSXXX(W(1,7   ),W(1,6   ),W(1,181 ),GHTAU ,AMP(146 ))          
      CALL IOVXXX(W(1,71  ),W(1,6   ),W(1,163 ),GAL ,AMP(147 ))            
      CALL IOVXXX(W(1,73  ),W(1,6   ),W(1,163 ),GAL ,AMP(148 ))            
      CALL IOVXXX(W(1,71  ),W(1,6   ),W(1,167 ),GZL ,AMP(149 ))            
      CALL IOVXXX(W(1,73  ),W(1,6   ),W(1,167 ),GZL ,AMP(150 ))            
      CALL FVIXXX(W(1,7   ),W(1,163 ),GAL ,LMASS   ,ZERO    ,W(1,182 ))    
      CALL IOVXXX(W(1,182 ),W(1,6   ),W(1,66  ),GAL ,AMP(151 ))            
      CALL IOVXXX(W(1,182 ),W(1,6   ),W(1,62  ),GZL ,AMP(152 ))            
      CALL FVIXXX(W(1,7   ),W(1,167 ),GZL ,LMASS   ,ZERO    ,W(1,183 ))    
      CALL IOVXXX(W(1,183 ),W(1,6   ),W(1,66  ),GAL ,AMP(153 ))            
      CALL IOVXXX(W(1,183 ),W(1,6   ),W(1,62  ),GZL ,AMP(154 ))            
      CALL FVIXXX(W(1,3   ),W(1,66  ),GAD ,ZERO    ,ZERO    ,W(1,184 ))    
      CALL JIOXXX(W(1,184 ),W(1,2   ),GAD ,ZERO    ,AWIDTH  ,W(1,185 ))    
      CALL IOVXXX(W(1,63  ),W(1,6   ),W(1,185 ),GAL ,AMP(155 ))            
      CALL JIOXXX(W(1,184 ),W(1,2   ),GZD ,ZMASS   ,ZWIDTH  ,W(1,186 ))    
      CALL IOVXXX(W(1,63  ),W(1,6   ),W(1,186 ),GZL ,AMP(156 ))            
      CALL FVIXXX(W(1,3   ),W(1,62  ),GZD ,ZERO    ,ZERO    ,W(1,187 ))    
      CALL JIOXXX(W(1,187 ),W(1,2   ),GAD ,ZERO    ,AWIDTH  ,W(1,188 ))    
      CALL IOVXXX(W(1,63  ),W(1,6   ),W(1,188 ),GAL ,AMP(157 ))            
      CALL JIOXXX(W(1,187 ),W(1,2   ),GZD ,ZMASS   ,ZWIDTH  ,W(1,189 ))    
      CALL IOVXXX(W(1,63  ),W(1,6   ),W(1,189 ),GZL ,AMP(158 ))            
      CALL HVVXXX(W(1,186 ),W(1,1   ),GZZH ,HMASS   ,HWIDTH  ,W(1,         
     &     190 ))                                                          
      CALL IOSXXX(W(1,7   ),W(1,6   ),W(1,190 ),GHTAU ,AMP(159 ))          
      CALL HVVXXX(W(1,189 ),W(1,1   ),GZZH ,HMASS   ,HWIDTH  ,W(1,         
     &     191 ))                                                          
      CALL IOSXXX(W(1,7   ),W(1,6   ),W(1,191 ),GHTAU ,AMP(160 ))          
      CALL FVIXXX(W(1,7   ),W(1,185 ),GAL ,LMASS   ,ZERO    ,W(1,192 ))    
      CALL IOVXXX(W(1,192 ),W(1,6   ),W(1,1   ),GZL ,AMP(161 ))            
      CALL FVIXXX(W(1,7   ),W(1,186 ),GZL ,LMASS   ,ZERO    ,W(1,193 ))    
      CALL IOVXXX(W(1,193 ),W(1,6   ),W(1,1   ),GZL ,AMP(162 ))            
      CALL FVIXXX(W(1,7   ),W(1,188 ),GAL ,LMASS   ,ZERO    ,W(1,194 ))    
      CALL IOVXXX(W(1,194 ),W(1,6   ),W(1,1   ),GZL ,AMP(163 ))            
      CALL FVIXXX(W(1,7   ),W(1,189 ),GZL ,LMASS   ,ZERO    ,W(1,195 ))    
      CALL IOVXXX(W(1,195 ),W(1,6   ),W(1,1   ),GZL ,AMP(164 ))            
      CALL FVIXXX(W(1,184 ),W(1,1   ),GZD ,ZERO    ,ZERO    ,W(1,196 ))    
      CALL JIOXXX(W(1,196 ),W(1,2   ),GAD ,ZERO    ,AWIDTH  ,W(1,197 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,197 ),GAL ,AMP(165 ))            
      CALL JIOXXX(W(1,196 ),W(1,2   ),GZD ,ZMASS   ,ZWIDTH  ,W(1,198 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,198 ),GZL ,AMP(166 ))            
      CALL FVIXXX(W(1,187 ),W(1,1   ),GZD ,ZERO    ,ZERO    ,W(1,199 ))    
      CALL JIOXXX(W(1,199 ),W(1,2   ),GAD ,ZERO    ,AWIDTH  ,W(1,200 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,200 ),GAL ,AMP(167 ))            
      CALL JIOXXX(W(1,199 ),W(1,2   ),GZD ,ZMASS   ,ZWIDTH  ,W(1,201 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,201 ),GZL ,AMP(168 ))            
      CALL FVOXXX(W(1,2   ),W(1,1   ),GZD ,ZERO    ,ZERO    ,W(1,202 ))    
      CALL FVOXXX(W(1,202 ),W(1,66  ),GAD ,ZERO    ,ZERO    ,W(1,203 ))    
      CALL JIOXXX(W(1,3   ),W(1,203 ),GAD ,ZERO    ,AWIDTH  ,W(1,204 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,204 ),GAL ,AMP(169 ))            
      CALL JIOXXX(W(1,3   ),W(1,203 ),GZD ,ZMASS   ,ZWIDTH  ,W(1,205 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,205 ),GZL ,AMP(170 ))            
      CALL FVOXXX(W(1,202 ),W(1,62  ),GZD ,ZERO    ,ZERO    ,W(1,206 ))    
      CALL JIOXXX(W(1,3   ),W(1,206 ),GAD ,ZERO    ,AWIDTH  ,W(1,207 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,207 ),GAL ,AMP(171 ))            
      CALL JIOXXX(W(1,3   ),W(1,206 ),GZD ,ZMASS   ,ZWIDTH  ,W(1,208 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,208 ),GZL ,AMP(172 ))            
      CALL JIOXXX(W(1,3   ),W(1,202 ),GAD ,ZERO    ,AWIDTH  ,W(1,209 ))    
      CALL FVIXXX(W(1,5   ),W(1,209 ),GAL ,ZERO    ,ZERO    ,W(1,210 ))    
      CALL JIOXXX(W(1,210 ),W(1,4   ),GAL ,ZERO    ,AWIDTH  ,W(1,211 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,211 ),GAL ,AMP(173 ))            
      CALL JIOXXX(W(1,210 ),W(1,4   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,212 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,212 ),GZL ,AMP(174 ))            
      CALL JIOXXX(W(1,3   ),W(1,202 ),GZD ,ZMASS   ,ZWIDTH  ,W(1,213 ))    
      CALL FVIXXX(W(1,5   ),W(1,213 ),GZL ,ZERO    ,ZERO    ,W(1,214 ))    
      CALL JIOXXX(W(1,214 ),W(1,4   ),GAL ,ZERO    ,AWIDTH  ,W(1,215 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,215 ),GAL ,AMP(175 ))            
      CALL JIOXXX(W(1,214 ),W(1,4   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,216 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,216 ),GZL ,AMP(176 ))            
      CALL FVOXXX(W(1,4   ),W(1,209 ),GAL ,ZERO    ,ZERO    ,W(1,217 ))    
      CALL JIOXXX(W(1,5   ),W(1,217 ),GAL ,ZERO    ,AWIDTH  ,W(1,218 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,218 ),GAL ,AMP(177 ))            
      CALL JIOXXX(W(1,5   ),W(1,217 ),GZL ,ZMASS   ,ZWIDTH  ,W(1,219 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,219 ),GZL ,AMP(178 ))            
      CALL FVOXXX(W(1,4   ),W(1,213 ),GZL ,ZERO    ,ZERO    ,W(1,220 ))    
      CALL JIOXXX(W(1,5   ),W(1,220 ),GAL ,ZERO    ,AWIDTH  ,W(1,221 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,221 ),GAL ,AMP(179 ))            
      CALL JIOXXX(W(1,5   ),W(1,220 ),GZL ,ZMASS   ,ZWIDTH  ,W(1,222 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,222 ),GZL ,AMP(180 ))            
      CALL JIOXXX(W(1,184 ),W(1,202 ),GAD ,ZERO    ,AWIDTH  ,W(1,223 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,223 ),GAL ,AMP(181 ))            
      CALL JIOXXX(W(1,184 ),W(1,202 ),GZD ,ZMASS   ,ZWIDTH  ,W(1,224 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,224 ),GZL ,AMP(182 ))            
      CALL JIOXXX(W(1,187 ),W(1,202 ),GAD ,ZERO    ,AWIDTH  ,W(1,225 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,225 ),GAL ,AMP(183 ))            
      CALL JIOXXX(W(1,187 ),W(1,202 ),GZD ,ZMASS   ,ZWIDTH  ,W(1,226 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,226 ),GZL ,AMP(184 ))            
      CALL HVVXXX(W(1,213 ),W(1,62  ),GZZH ,HMASS   ,HWIDTH  ,W(1,         
     &     227 ))                                                          
      CALL IOSXXX(W(1,7   ),W(1,6   ),W(1,227 ),GHTAU ,AMP(185 ))          
      CALL IOVXXX(W(1,71  ),W(1,6   ),W(1,209 ),GAL ,AMP(186 ))            
      CALL IOVXXX(W(1,73  ),W(1,6   ),W(1,209 ),GAL ,AMP(187 ))            
      CALL IOVXXX(W(1,71  ),W(1,6   ),W(1,213 ),GZL ,AMP(188 ))            
      CALL IOVXXX(W(1,73  ),W(1,6   ),W(1,213 ),GZL ,AMP(189 ))            
      CALL FVIXXX(W(1,7   ),W(1,209 ),GAL ,LMASS   ,ZERO    ,W(1,228 ))    
      CALL IOVXXX(W(1,228 ),W(1,6   ),W(1,66  ),GAL ,AMP(190 ))            
      CALL IOVXXX(W(1,228 ),W(1,6   ),W(1,62  ),GZL ,AMP(191 ))            
      CALL FVIXXX(W(1,7   ),W(1,213 ),GZL ,LMASS   ,ZERO    ,W(1,229 ))    
      CALL IOVXXX(W(1,229 ),W(1,6   ),W(1,66  ),GAL ,AMP(192 ))            
      CALL IOVXXX(W(1,229 ),W(1,6   ),W(1,62  ),GZL ,AMP(193 ))            
      zzztensor(mu) = -AMP(   1)-AMP(   2)-AMP(   3)-AMP(   4)-AMP(   5)
     &             -AMP(   6)-AMP(   7)-AMP(   8)-AMP(   9)-AMP(  10)
     &             -AMP(  11)-AMP(  12)-AMP(  13)-AMP(  14)-AMP(  15)
     &             -AMP(  16)-AMP(  17)-AMP(  18)-AMP(  19)-AMP(  20)
     &             -AMP(  21)-AMP(  22)-AMP(  23)-AMP(  24)-AMP(  25)
     &             -AMP(  26)-AMP(  27)-AMP(  28)-AMP(  29)-AMP(  30)
     &             -AMP(  31)-AMP(  32)-AMP(  33)-AMP(  34)-AMP(  35)
     &             -AMP(  36)-AMP(  37)-AMP(  38)-AMP(  39)-AMP(  40)
     &             -AMP(  41)-AMP(  42)-AMP(  43)-AMP(  44)-AMP(  45)
     &             -AMP(  46)-AMP(  47)-AMP(  48)-AMP(  49)-AMP(  50)
     &             -AMP(  51)-AMP(  52)-AMP(  53)-AMP(  54)-AMP(  55)
     &             -AMP(  56)-AMP(  57)-AMP(  58)-AMP(  59)-AMP(  60)
     &             -AMP(  61)-AMP(  62)-AMP(  63)-AMP(  64)-AMP(  65)
     &             -AMP(  66)-AMP(  67)-AMP(  68)-AMP(  69)-AMP(  70)
     &             -AMP(  71)-AMP(  72)-AMP(  73)-AMP(  74)-AMP(  75)
     &             -AMP(  76)-AMP(  77)-AMP(  78)-AMP(  79)-AMP(  80)
     &             -AMP(  81)-AMP(  82)-AMP(  83)-AMP(  84)-AMP(  85)
     &             -AMP(  86)-AMP(  87)-AMP(  88)-AMP(  89)-AMP(  90)
     &             -AMP(  91)-AMP(  92)-AMP(  93)-AMP(  94)-AMP(  95)
     &             -AMP(  96)-AMP(  97)-AMP(  98)-AMP(  99)-AMP( 100)
     &             -AMP( 101)-AMP( 102)-AMP( 103)-AMP( 104)-AMP( 105)
     &             -AMP( 106)-AMP( 107)-AMP( 108)-AMP( 109)-AMP( 110)
     &             -AMP( 111)-AMP( 112)-AMP( 113)-AMP( 114)-AMP( 115)
     &             -AMP( 116)-AMP( 117)-AMP( 118)-AMP( 119)-AMP( 120)
     &             -AMP( 121)-AMP( 122)-AMP( 123)-AMP( 124)-AMP( 125)
     &             -AMP( 126)-AMP( 127)-AMP( 128)-AMP( 129)-AMP( 130)
     &             -AMP( 131)-AMP( 132)-AMP( 133)-AMP( 134)-AMP( 135)
     &             -AMP( 136)-AMP( 137)-AMP( 138)-AMP( 139)-AMP( 140)
     &             -AMP( 141)-AMP( 142)-AMP( 143)-AMP( 144)-AMP( 145)
     &             -AMP( 146)-AMP( 147)-AMP( 148)-AMP( 149)-AMP( 150)
     &             -AMP( 151)-AMP( 152)-AMP( 153)-AMP( 154)-AMP( 155)
     &             -AMP( 156)-AMP( 157)-AMP( 158)-AMP( 159)-AMP( 160)
     &             -AMP( 161)-AMP( 162)-AMP( 163)-AMP( 164)-AMP( 165)
     &             -AMP( 166)-AMP( 167)-AMP( 168)-AMP( 169)-AMP( 170)
     &             -AMP( 171)-AMP( 172)-AMP( 173)-AMP( 174)-AMP( 175)
     &             -AMP( 176)-AMP( 177)-AMP( 178)-AMP( 179)-AMP( 180)
     &             -AMP( 181)-AMP( 182)-AMP( 183)-AMP( 184)-AMP( 185)
     &             -AMP( 186)-AMP( 187)-AMP( 188)-AMP( 189)-AMP( 190)
     &             -AMP( 191)-AMP( 192)-AMP( 193)

      endif

      enddo

      zzztensor(4) = dcmplx(q(0),q(3))
      zzztensor(5) = dcmplx(q(1),q(2))

      END

c ----------------------------------------------------------------------

      subroutine ztozzzHiggs_mg2_had(P,N,h,ZZZtensor1,ZZZtensor2,ZZZtensor3,NW)

      IMPLICIT NONE

      DOUBLE PRECISION P(0:3,2:7)
      COMPLEX*16 ZZZtensor1(0:5),ZZZtensor2(0:5),ZZZtensor3(0:5)
      INTEGER lsign(2:7,8),ll,mu,nu,h,N
      integer NW

      !possible lepton helicities
      data (lsign(ll,1),ll=2,7) / -1, -1, -1, -1, -1, -1/  !h=1
      data (lsign(ll,2),ll=2,7) / -1, -1,  1,  1, -1, -1/  !h=2
      data (lsign(ll,3),ll=2,7) / -1, -1, -1, -1,  1,  1/  !h=3
      data (lsign(ll,4),ll=2,7) / -1, -1,  1,  1,  1,  1/  !h=4
      data (lsign(ll,5),ll=2,7) /  1,  1, -1, -1, -1, -1/  !h=5
      data (lsign(ll,6),ll=2,7) /  1,  1,  1,  1, -1, -1/  !h=6
      data (lsign(ll,7),ll=2,7) /  1,  1, -1, -1,  1,  1/  !h=7
      data (lsign(ll,8),ll=2,7) /  1,  1,  1,  1,  1,  1/  !h=8

      call ZTOZZZHiggs1_mg2_had(P,N,lsign(2,h),zzztensor1(0),zzztensor2(0),
     1                zzztensor3(0),NW)

      ! helicity combi Nr. h is selected

      end

c-------------------------------------------------------------------

      SUBROUTINE ZTOZZZHiggs1_mg2_had(P,N,lsign,zzztensor1,zzztensor2,
     1                zzztensor3,NW)
C  
C Generated by MadGraph II Version 3.0. Updated 02/19/04                
C RETURNS AMPLITUDE SQUARED SUMMED/AVG OVER COLORS
C FOR THE POINT WITH EXTERNAL LINES W(0:6,NEXTERNAL)
C  
C FOR PROCESS : z -> e- e+ mu- mu+ ta- ta+  
C  
      IMPLICIT NONE
C  
C CONSTANTS
C  
      INTEGER    NGRAPHS 
      PARAMETER (NGRAPHS= 227) 
      INTEGER    NWAVEFUNCS
      PARAMETER (NWAVEFUNCS= 151) 
      DOUBLE PRECISION     ZERO
      PARAMETER (ZERO=0D0)
C  
C ARGUMENTS 
C  
      DOUBLE PRECISION P(0:3,2:7), Q(0:3)
      INTEGER N
      COMPLEX*16 zzztensor1(0:5), zzztensor2(0:5), zzztensor3(0:5)
      INTEGER lsign(2:7)
      integer NW
C  
C LOCAL VARIABLES 
C  
      INTEGER I,J, mu
      COMPLEX*16 AMP(NGRAPHS)
      COMPLEX*16 W(6,NWAVEFUNCS)

c  lepton spinors and Z/A polarization vectors
#include "tensor.inc"

      logical lswitch
      parameter (lswitch=.true.)
C  
C GLOBAL VARIABLES
C  
#include "VBFNLO/utilities/coupl.inc"
#include "VBFNLO/utilities/process.inc"
C                                          
C ----------
C BEGIN CODE
C ----------
      if (lswitch) then
         do i=1,6
            w(i,2)  = zem(i,N)
            w(i,3)  = zep(i,N)
            w(i,4)  = zmm(i,N)
            w(i,5)  = zmp(i,N)
            w(i,6)  = ztm(i,N)
            w(i,7)  = ztp(i,N)
            w(i,8)  = ae(i,N)
            w(i,14) = ze(i,N)
         enddo
      endif

      do mu = 0,3
         q(mu) = p(mu,2)+p(mu,3)+p(mu,4)+p(mu,5)+p(mu,6)+p(mu,7)
      enddo

      do mu = 0,3
      call TRIBOSVCARTX(Q(0), ZMASS, ZWIDTH, MU, -1, W(1,1))        ! Z
      call TRIBOSVCARTX(Q(0), ZERO, ZERO, MU, -1, W(1,11))          ! A
      CALL JIOXXX(W(1,7   ),W(1,6   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,28  ))  ! Z3
      CALL JIOXXX(W(1,7   ),W(1,6   ),GAL ,ZERO    ,ZERO    ,W(1,24  ))  ! A3      
      CALL JIOXXX(W(1,5   ),W(1,4   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,53  ))  ! Z2
      CALL JIOXXX(W(1,5   ),W(1,4   ),GAL ,ZERO    ,ZERO    ,W(1,56  ))  ! A2 

      CALL jhzz_anomal3(W(1,28  ),W(1,1   ),W(1,55  ))
      CALL jhzz_anomal3(W(1,53  ),W(1,1   ),W(1,60  ))   
      CALL jhzz_anomal3(W(1,14  ),W(1,1   ),W(1,65  )) 
      CALL zzh_anomal3(W(1,53  ),W(1,14  ),W(1,55  ),AMP(41  ))  ! Z -> Z3 H -> Z1 Z2
      CALL zzh_anomal3(W(1,28  ),W(1,14  ),W(1,60  ),AMP(55  ))  ! Z -> Z2 H -> Z1 Z3    
      CALL zzh_anomal3(W(1,28  ),W(1,53  ),W(1,65  ),AMP(68  ))  ! Z -> Z1 H -> Z2 Z3

      Call azh_anomal3(W(1,8   ),W(1,53  ),W(1,55  ),AMP(207 ))  ! Z -> Z3(A3) H -> Z1(A1) Z2(A2)
      Call azh_anomal3(W(1,56  ),W(1,14  ),W(1,55  ),AMP(208 ))
      Call aah_anomal3(W(1,8   ),W(1,56  ),W(1,55  ),AMP(209 ))
      CALL jhaz_anomal3(W(1,24  ),W(1,1   ),W(1,149  ))  
      Call zzh_anomal3(W(1,14  ),W(1,53  ),W(1,149 ),AMP(210 )) 
      Call azh_anomal3(W(1,8   ),W(1,53  ),W(1,149 ),AMP(211 ))
      Call azh_anomal3(W(1,56  ),W(1,14  ),W(1,149 ),AMP(212 ))
      Call aah_anomal3(W(1,8   ),W(1,56  ),W(1,149 ),AMP(213 ))

      Call azh_anomal3(W(1,8   ),W(1,28  ),W(1,60  ),AMP(214 ))  ! Z -> Z2(A2) H -> Z1(A1) Z3(A3)
      Call azh_anomal3(W(1,24  ),W(1,14  ),W(1,60  ),AMP(215 ))
      Call aah_anomal3(W(1,8   ),W(1,24  ),W(1,60  ),AMP(216 ))
      CALL jhaz_anomal3(W(1,56 ),W(1,1   ),W(1,150  ))  
      Call zzh_anomal3(W(1,14  ),W(1,28  ),W(1,150 ),AMP(217 )) 
      Call azh_anomal3(W(1,8   ),W(1,28  ),W(1,150 ),AMP(218 ))
      Call azh_anomal3(W(1,24  ),W(1,14  ),W(1,150 ),AMP(219 ))
      Call aah_anomal3(W(1,8   ),W(1,24  ),W(1,150 ),AMP(220 ))
  
      Call azh_anomal3(W(1,56  ),W(1,28  ),W(1,65  ),AMP(221 ))  ! Z -> Z1(A1) H -> Z2(A2) Z3(A3)
      Call azh_anomal3(W(1,24  ),W(1,53  ),W(1,65  ),AMP(222 ))
      Call aah_anomal3(W(1,56  ),W(1,24  ),W(1,65  ),AMP(223 ))
      CALL jhaz_anomal3(W(1,8  ),W(1,1   ),W(1,151  ))  
      Call zzh_anomal3(W(1,53  ),W(1,28  ),W(1,151 ),AMP(224 )) 
      Call azh_anomal3(W(1,56  ),W(1,28  ),W(1,151 ),AMP(225 ))
      Call azh_anomal3(W(1,24  ),W(1,53  ),W(1,151 ),AMP(226 ))
      Call aah_anomal3(W(1,56  ),W(1,24  ),W(1,151 ),AMP(227 ))

      CALL jhaz_anomal3(W(1,11  ),W(1,14  ),W(1,140 ))          
      CALL zzh_anomal3(W(1,53  ),W(1,28  ),W(1,140 ),AMP(183 ))  ! A -> Z1(A1) H -> Z2(A2) Z3(A3)
      CALL azh_anomal3(W(1,56  ),W(1,28  ),W(1,140 ),AMP(184 ))
      CALL azh_anomal3(W(1,24  ),W(1,53  ),W(1,140 ),AMP(185 ))
      CALL aah_anomal3(W(1,24  ),W(1,56  ),W(1,140 ),AMP(186 ))
      CALL jhaa_anomal3(W(1,11  ),W(1,8   ),W(1,141 ))
      CALL zzh_anomal3(W(1,53  ),W(1,28  ),W(1,141 ),AMP(187 ))
      CALL azh_anomal3(W(1,56  ),W(1,28  ),W(1,141 ),AMP(188 ))
      CALL azh_anomal3(W(1,24  ),W(1,53  ),W(1,141 ),AMP(189 ))
      CALL aah_anomal3(W(1,24  ),W(1,56  ),W(1,141 ),AMP(190 ))

      CALL jhaz_anomal3(W(1,11  ),W(1,53  ),W(1,142 ))          
      CALL zzh_anomal3(W(1,14  ),W(1,28  ),W(1,142 ),AMP(191 ))  ! A -> Z2(A2) H -> Z1(A1) Z3(A3)
      CALL azh_anomal3(W(1,8   ),W(1,28  ),W(1,142 ),AMP(192 ))
      CALL azh_anomal3(W(1,24  ),W(1,14  ),W(1,142 ),AMP(193 ))
      CALL aah_anomal3(W(1,24  ),W(1,8   ),W(1,142 ),AMP(194 ))
      CALL jhaa_anomal3(W(1,11  ),W(1,56  ),W(1,143 ))
      CALL zzh_anomal3(W(1,14  ),W(1,28  ),W(1,143 ),AMP(195 ))
      CALL azh_anomal3(W(1,8   ),W(1,28  ),W(1,143 ),AMP(196 ))
      CALL azh_anomal3(W(1,24  ),W(1,14  ),W(1,143 ),AMP(197 ))
      CALL aah_anomal3(W(1,24  ),W(1,8   ),W(1,143 ),AMP(198 ))

      CALL jhaz_anomal3(W(1,11  ),W(1,28  ),W(1,144 ))         
      CALL zzh_anomal3(W(1,14  ),W(1,53  ),W(1,144 ),AMP(199 ))  ! A -> Z3(A3) H -> Z1(A1) Z2(A2)
      CALL azh_anomal3(W(1,8   ),W(1,53  ),W(1,144 ),AMP(200 ))
      CALL azh_anomal3(W(1,56  ),W(1,14  ),W(1,144 ),AMP(201 ))
      CALL aah_anomal3(W(1,56  ),W(1,8   ),W(1,144 ),AMP(202 ))
      CALL jhaa_anomal3(W(1,11  ),W(1,24  ),W(1,145 ))
      CALL zzh_anomal3(W(1,14  ),W(1,53  ),W(1,145 ),AMP(203 ))
      CALL azh_anomal3(W(1,8   ),W(1,53  ),W(1,145 ),AMP(204 ))
      CALL azh_anomal3(W(1,56  ),W(1,14  ),W(1,145 ),AMP(205 ))
      CALL aah_anomal3(W(1,56  ),W(1,8   ),W(1,145 ),AMP(206 ))

          
      zzztensor1(mu) =  -AMP(  41)-AMP(207 )-AMP(208 )-AMP(209 ) !H -> Z1Z2 contribution
     &                  -AMP(210 )-AMP(211 )-AMP(212 )-AMP(213 )
     &                  -AMP(199 )-AMP(200 )-AMP(201 )-AMP(202 )
     &                  -AMP(203 )-AMP(204 )-AMP(205 )-AMP(206 )
      zzztensor2(mu) =  -AMP(  55)-AMP(214 )-AMP(215 )-AMP(216 ) !H -> Z1Z3 contribution
     &                  -AMP(217 )-AMP(218 )-AMP(219 )-AMP(220 )
     &                  -AMP(191 )-AMP(192 )-AMP(193 )-AMP(194 )
     &                  -AMP(195 )-AMP(196 )-AMP(197 )-AMP(198 )
      zzztensor3(mu) =  -AMP(  68)-AMP(221 )-AMP(222 )-AMP(223 ) !H -> Z2Z3 contribution
     &                  -AMP(224 )-AMP(225 )-AMP(226 )-AMP(227 )
     &                  -AMP(183 )-AMP(184 )-AMP(185 )-AMP(186 )
     &                  -AMP(187 )-AMP(188 )-AMP(189 )-AMP(190 )
      enddo

      zzztensor1(4) = dcmplx(q(0),q(3))
      zzztensor1(5) = dcmplx(q(1),q(2))
      zzztensor2(4) = dcmplx(q(0),q(3))
      zzztensor2(5) = dcmplx(q(1),q(2))
      zzztensor3(4) = dcmplx(q(0),q(3))
      zzztensor3(5) = dcmplx(q(1),q(2))


      END


c----------------------------------------------------------------------



      SUBROUTINE ZZZ_ATOZZ_mg2_had(P2,P3,P4,P5,lsign1,lsign2,ZZtens)
C  
C Generated by MadGraph II Version 3.0. Updated 02/19/04                
C RETURNS AMPLITUDE SQUARED SUMMED/AVG OVER COLORS
C FOR THE POINT WITH EXTERNAL LINES W(0:6,NEXTERNAL)
C  
C FOR PROCESS : a -> e- e+ mu- mu+  
C  
      IMPLICIT NONE
C  
C CONSTANTS
C  
      INTEGER    NGRAPHS
      PARAMETER (NGRAPHS=   8)
      INTEGER    NWAVEFUNCS
      PARAMETER (NWAVEFUNCS=  16) 
      DOUBLE PRECISION     ZERO
      PARAMETER (ZERO=0D0)
C  
C ARGUMENTS 
C  
      DOUBLE PRECISION p2(0:3), p3(0:3), p4(0:3), p5(0:3)
      DOUBLE PRECISION Q(0:3)
      COMPLEX*16 ZZtens(0:5)
      INTEGER lsign1, lsign2
C  
C LOCAL VARIABLES 
C  
      INTEGER I,J, mu
      COMPLEX*16 AMP(NGRAPHS)
      COMPLEX*16 W(6,NWAVEFUNCS)
C  
C GLOBAL VARIABLES
C  
#include "VBFNLO/utilities/coupl.inc"                                  
#include "VBFNLO/utilities/global.inc"
#include "VBFNLO/utilities/coupl_haddecay.inc"
#include "VBFNLO/utilities/process.inc"
C                                                                          
C ----------
C BEGIN CODE
C ----------
      do mu = 0,3
         q(mu) = p2(mu)+p3(mu)+p4(mu)+p5(mu)
      enddo
        
      CALL OXXXXX(P2(0), ZERO, lsign1,+1, W(1,2   ))        
      CALL IXXXXX(P3(0), ZERO,-lsign1,-1, W(1,3   ))        
      CALL OXXXXX(P4(0), ZERO, lsign2,+1, W(1,4   ))        
      CALL IXXXXX(P5(0), ZERO,-lsign2,-1, W(1,5   ))

      do mu = 0,3
      call TRIBOSVCARTX(Q(0), ZERO, ZERO, MU, -1, W(1,1))

      if (procid.eq.ZZZhad .and. Ztouu) then

      CALL JIOXXX(W(1,3   ),W(1,2   ),GAU ,ZERO    ,AWIDTH  ,W(1,6   ))    
      CALL FVOXXX(W(1,4   ),W(1,6   ),GAL ,ZERO    ,ZERO    ,W(1,7   ))    
      CALL IOVXXX(W(1,5   ),W(1,7   ),W(1,1   ),GAL ,AMP(1   ))            
      CALL JIOXXX(W(1,3   ),W(1,2   ),GZU ,ZMASS   ,ZWIDTH  ,W(1,8   ))    
      CALL FVOXXX(W(1,4   ),W(1,8   ),GZL ,ZERO    ,ZERO    ,W(1,9   ))    
      CALL IOVXXX(W(1,5   ),W(1,9   ),W(1,1   ),GAL ,AMP(2   ))            
      CALL FVOXXX(W(1,4   ),W(1,1   ),GAL ,ZERO    ,ZERO    ,W(1,10  ))    
      CALL IOVXXX(W(1,5   ),W(1,10  ),W(1,6   ),GAL ,AMP(3   ))            
      CALL IOVXXX(W(1,5   ),W(1,10  ),W(1,8   ),GZL ,AMP(4   ))            
      CALL FVIXXX(W(1,3   ),W(1,1   ),GAU ,ZERO    ,ZERO    ,W(1,11  ))    
      CALL JIOXXX(W(1,11  ),W(1,2   ),GAU ,ZERO    ,AWIDTH  ,W(1,12  ))    
      CALL IOVXXX(W(1,5   ),W(1,4   ),W(1,12  ),GAL ,AMP(5   ))            
      CALL JIOXXX(W(1,11  ),W(1,2   ),GZU ,ZMASS   ,ZWIDTH  ,W(1,13  ))    
      CALL IOVXXX(W(1,5   ),W(1,4   ),W(1,13  ),GZL ,AMP(6   ))            
      CALL FVOXXX(W(1,2   ),W(1,1   ),GAU ,ZERO    ,ZERO    ,W(1,14  ))    
      CALL JIOXXX(W(1,3   ),W(1,14  ),GAU ,ZERO    ,AWIDTH  ,W(1,15  ))    
      CALL IOVXXX(W(1,5   ),W(1,4   ),W(1,15  ),GAL ,AMP(7   ))            
      CALL JIOXXX(W(1,3   ),W(1,14  ),GZU ,ZMASS   ,ZWIDTH  ,W(1,16  ))    
      CALL IOVXXX(W(1,5   ),W(1,4   ),W(1,16  ),GZL ,AMP(8   ))            
      ZZtens(mu) = +AMP(   1)+AMP(   2)+AMP(   3)+AMP(   4)+AMP(   5)
     &             +AMP(   6)+AMP(   7)+AMP(   8)

      elseif (procid.eq.ZZZhad .and. Ztodd) then

      CALL JIOXXX(W(1,3   ),W(1,2   ),GAD ,ZERO    ,AWIDTH  ,W(1,6   ))    
      CALL FVOXXX(W(1,4   ),W(1,6   ),GAL ,ZERO    ,ZERO    ,W(1,7   ))    
      CALL IOVXXX(W(1,5   ),W(1,7   ),W(1,1   ),GAL ,AMP(1   ))            
      CALL JIOXXX(W(1,3   ),W(1,2   ),GZD ,ZMASS   ,ZWIDTH  ,W(1,8   ))    
      CALL FVOXXX(W(1,4   ),W(1,8   ),GZL ,ZERO    ,ZERO    ,W(1,9   ))    
      CALL IOVXXX(W(1,5   ),W(1,9   ),W(1,1   ),GAL ,AMP(2   ))            
      CALL FVOXXX(W(1,4   ),W(1,1   ),GAL ,ZERO    ,ZERO    ,W(1,10  ))    
      CALL IOVXXX(W(1,5   ),W(1,10  ),W(1,6   ),GAL ,AMP(3   ))            
      CALL IOVXXX(W(1,5   ),W(1,10  ),W(1,8   ),GZL ,AMP(4   ))            
      CALL FVIXXX(W(1,3   ),W(1,1   ),GAD ,ZERO    ,ZERO    ,W(1,11  ))    
      CALL JIOXXX(W(1,11  ),W(1,2   ),GAD ,ZERO    ,AWIDTH  ,W(1,12  ))    
      CALL IOVXXX(W(1,5   ),W(1,4   ),W(1,12  ),GAL ,AMP(5   ))            
      CALL JIOXXX(W(1,11  ),W(1,2   ),GZD ,ZMASS   ,ZWIDTH  ,W(1,13  ))    
      CALL IOVXXX(W(1,5   ),W(1,4   ),W(1,13  ),GZL ,AMP(6   ))            
      CALL FVOXXX(W(1,2   ),W(1,1   ),GAD ,ZERO    ,ZERO    ,W(1,14  ))    
      CALL JIOXXX(W(1,3   ),W(1,14  ),GAD ,ZERO    ,AWIDTH  ,W(1,15  ))    
      CALL IOVXXX(W(1,5   ),W(1,4   ),W(1,15  ),GAL ,AMP(7   ))            
      CALL JIOXXX(W(1,3   ),W(1,14  ),GZD ,ZMASS   ,ZWIDTH  ,W(1,16  ))    
      CALL IOVXXX(W(1,5   ),W(1,4   ),W(1,16  ),GZL ,AMP(8   ))            
      ZZtens(mu) = +AMP(   1)+AMP(   2)+AMP(   3)+AMP(   4)+AMP(   5)
     &             +AMP(   6)+AMP(   7)+AMP(   8)

      else

      CALL JIOXXX(W(1,3   ),W(1,2   ),GAL ,ZERO    ,AWIDTH  ,W(1,6   ))    
      CALL FVOXXX(W(1,4   ),W(1,6   ),GAL ,ZERO    ,ZERO    ,W(1,7   ))    
      CALL IOVXXX(W(1,5   ),W(1,7   ),W(1,1   ),GAL ,AMP(1   ))            
      CALL JIOXXX(W(1,3   ),W(1,2   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,8   ))    
      CALL FVOXXX(W(1,4   ),W(1,8   ),GZL ,ZERO    ,ZERO    ,W(1,9   ))    
      CALL IOVXXX(W(1,5   ),W(1,9   ),W(1,1   ),GAL ,AMP(2   ))            
      CALL FVOXXX(W(1,4   ),W(1,1   ),GAL ,ZERO    ,ZERO    ,W(1,10  ))    
      CALL IOVXXX(W(1,5   ),W(1,10  ),W(1,6   ),GAL ,AMP(3   ))            
      CALL IOVXXX(W(1,5   ),W(1,10  ),W(1,8   ),GZL ,AMP(4   ))            
      CALL FVIXXX(W(1,3   ),W(1,1   ),GAL ,ZERO    ,ZERO    ,W(1,11  ))    
      CALL JIOXXX(W(1,11  ),W(1,2   ),GAL ,ZERO    ,AWIDTH  ,W(1,12  ))    
      CALL IOVXXX(W(1,5   ),W(1,4   ),W(1,12  ),GAL ,AMP(5   ))            
      CALL JIOXXX(W(1,11  ),W(1,2   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,13  ))    
      CALL IOVXXX(W(1,5   ),W(1,4   ),W(1,13  ),GZL ,AMP(6   ))            
      CALL FVOXXX(W(1,2   ),W(1,1   ),GAL ,ZERO    ,ZERO    ,W(1,14  ))    
      CALL JIOXXX(W(1,3   ),W(1,14  ),GAL ,ZERO    ,AWIDTH  ,W(1,15  ))    
      CALL IOVXXX(W(1,5   ),W(1,4   ),W(1,15  ),GAL ,AMP(7   ))            
      CALL JIOXXX(W(1,3   ),W(1,14  ),GZL ,ZMASS   ,ZWIDTH  ,W(1,16  ))    
      CALL IOVXXX(W(1,5   ),W(1,4   ),W(1,16  ),GZL ,AMP(8   ))            
      ZZtens(mu) = +AMP(   1)+AMP(   2)+AMP(   3)+AMP(   4)+AMP(   5)
     &             +AMP(   6)+AMP(   7)+AMP(   8)

      endif

      enddo
      ZZtens(4) = dcmplx(q(0),q(3))
      ZZtens(5) = dcmplx(q(1),q(2))

      END

c--------------------------------------------------------------------

      SUBROUTINE ZZZ_ZTOZZ_mg2_had(P2,P3,P4,P5,lsign1,lsign2,ZZtens)
C  
C Generated by MadGraph II Version 3.0. Updated 02/19/04                
C RETURNS AMPLITUDE SQUARED SUMMED/AVG OVER COLORS
C FOR THE POINT WITH EXTERNAL LINES W(0:6,NEXTERNAL)
C  
C FOR PROCESS : z -> e- e+ mu- mu+  
C  
      IMPLICIT NONE
C  
C CONSTANTS
C  
      INTEGER    NGRAPHS
      PARAMETER (NGRAPHS=   8)
      INTEGER    NWAVEFUNCS
      PARAMETER (NWAVEFUNCS=  16) 
      DOUBLE PRECISION     ZERO
      PARAMETER (ZERO=0D0)
C  
C ARGUMENTS 
C  
      DOUBLE PRECISION P2(0:3), P3(0:3), P4(0:3), P5(0:3)
      DOUBLE PRECISION Q(0:3)
      COMPLEX*16 ZZtens(0:5)
      INTEGER lsign1, lsign2
C  
C LOCAL VARIABLES 
C  
      INTEGER I,J, mu
      COMPLEX*16 AMP(NGRAPHS)
      COMPLEX*16 W(6,NWAVEFUNCS)
C  
C GLOBAL VARIABLES
C  
#include "VBFNLO/utilities/coupl.inc"                                  
#include "VBFNLO/utilities/global.inc"
#include "VBFNLO/utilities/coupl_haddecay.inc"
#include "VBFNLO/utilities/process.inc"
C                                                                          
C ----------
C BEGIN CODE
C ----------

      do mu = 0,3
         q(mu) = p2(mu)+p3(mu)+p4(mu)+p5(mu)
      enddo
        
      CALL OXXXXX(P2(0), ZERO, lsign1,+1, W(1,2   ))        
      CALL IXXXXX(P3(0), ZERO,-lsign1,-1, W(1,3   ))        
      CALL OXXXXX(P4(0), ZERO, lsign2,+1, W(1,4   ))        
      CALL IXXXXX(P5(0), ZERO,-lsign2,-1, W(1,5   ))

      do mu = 0,3       
       call TRIBOSVCARTX(Q(0), ZMASS, ZWIDTH, MU, -1, W(1,1))


      if (procid.eq.ZZZhad .and. Ztouu) then

      CALL JIOXXX(W(1,3   ),W(1,2   ),GAU ,ZERO    ,AWIDTH  ,W(1,6   ))    
      CALL FVOXXX(W(1,4   ),W(1,6   ),GAL ,ZERO    ,ZERO    ,W(1,7   ))    
      CALL IOVXXX(W(1,5   ),W(1,7   ),W(1,1   ),GZL ,AMP(1   ))            
      CALL JIOXXX(W(1,3   ),W(1,2   ),GZU ,ZMASS   ,ZWIDTH  ,W(1,8   ))    
      CALL FVOXXX(W(1,4   ),W(1,8   ),GZL ,ZERO    ,ZERO    ,W(1,9   ))    
      CALL IOVXXX(W(1,5   ),W(1,9   ),W(1,1   ),GZL ,AMP(2   ))            
      CALL FVOXXX(W(1,4   ),W(1,1   ),GZL ,ZERO    ,ZERO    ,W(1,10  ))    
      CALL IOVXXX(W(1,5   ),W(1,10  ),W(1,6   ),GAL ,AMP(3   ))            
      CALL IOVXXX(W(1,5   ),W(1,10  ),W(1,8   ),GZL ,AMP(4   ))            
      CALL FVIXXX(W(1,3   ),W(1,1   ),GZU ,ZERO    ,ZERO    ,W(1,11  ))    
      CALL JIOXXX(W(1,11  ),W(1,2   ),GAU ,ZERO    ,AWIDTH  ,W(1,12  ))    
      CALL IOVXXX(W(1,5   ),W(1,4   ),W(1,12  ),GAL ,AMP(5   ))            
      CALL JIOXXX(W(1,11  ),W(1,2   ),GZU ,ZMASS   ,ZWIDTH  ,W(1,13  ))    
      CALL IOVXXX(W(1,5   ),W(1,4   ),W(1,13  ),GZL ,AMP(6   ))            
      CALL FVOXXX(W(1,2   ),W(1,1   ),GZU ,ZERO    ,ZERO    ,W(1,14  ))    
      CALL JIOXXX(W(1,3   ),W(1,14  ),GAU ,ZERO    ,AWIDTH  ,W(1,15  ))    
      CALL IOVXXX(W(1,5   ),W(1,4   ),W(1,15  ),GAL ,AMP(7   ))            
      CALL JIOXXX(W(1,3   ),W(1,14  ),GZU ,ZMASS   ,ZWIDTH  ,W(1,16  ))    
      CALL IOVXXX(W(1,5   ),W(1,4   ),W(1,16  ),GZL ,AMP(8   ))            
      ZZtens(mu) = +AMP(   1)+AMP(   2)+AMP(   3)+AMP(   4)+AMP(   5)
     &             +AMP(   6)+AMP(   7)+AMP(   8)

      elseif (procid.eq.ZZZhad .and. Ztodd) then

      CALL JIOXXX(W(1,3   ),W(1,2   ),GAD ,ZERO    ,AWIDTH  ,W(1,6   ))    
      CALL FVOXXX(W(1,4   ),W(1,6   ),GAL ,ZERO    ,ZERO    ,W(1,7   ))    
      CALL IOVXXX(W(1,5   ),W(1,7   ),W(1,1   ),GZL ,AMP(1   ))            
      CALL JIOXXX(W(1,3   ),W(1,2   ),GZD ,ZMASS   ,ZWIDTH  ,W(1,8   ))    
      CALL FVOXXX(W(1,4   ),W(1,8   ),GZL ,ZERO    ,ZERO    ,W(1,9   ))    
      CALL IOVXXX(W(1,5   ),W(1,9   ),W(1,1   ),GZL ,AMP(2   ))            
      CALL FVOXXX(W(1,4   ),W(1,1   ),GZL ,ZERO    ,ZERO    ,W(1,10  ))    
      CALL IOVXXX(W(1,5   ),W(1,10  ),W(1,6   ),GAL ,AMP(3   ))            
      CALL IOVXXX(W(1,5   ),W(1,10  ),W(1,8   ),GZL ,AMP(4   ))            
      CALL FVIXXX(W(1,3   ),W(1,1   ),GZD ,ZERO    ,ZERO    ,W(1,11  ))    
      CALL JIOXXX(W(1,11  ),W(1,2   ),GAD ,ZERO    ,AWIDTH  ,W(1,12  ))    
      CALL IOVXXX(W(1,5   ),W(1,4   ),W(1,12  ),GAL ,AMP(5   ))            
      CALL JIOXXX(W(1,11  ),W(1,2   ),GZD ,ZMASS   ,ZWIDTH  ,W(1,13  ))    
      CALL IOVXXX(W(1,5   ),W(1,4   ),W(1,13  ),GZL ,AMP(6   ))            
      CALL FVOXXX(W(1,2   ),W(1,1   ),GZD ,ZERO    ,ZERO    ,W(1,14  ))    
      CALL JIOXXX(W(1,3   ),W(1,14  ),GAD ,ZERO    ,AWIDTH  ,W(1,15  ))    
      CALL IOVXXX(W(1,5   ),W(1,4   ),W(1,15  ),GAL ,AMP(7   ))            
      CALL JIOXXX(W(1,3   ),W(1,14  ),GZD ,ZMASS   ,ZWIDTH  ,W(1,16  ))    
      CALL IOVXXX(W(1,5   ),W(1,4   ),W(1,16  ),GZL ,AMP(8   ))            
      ZZtens(mu) = +AMP(   1)+AMP(   2)+AMP(   3)+AMP(   4)+AMP(   5)
     &             +AMP(   6)+AMP(   7)+AMP(   8)

      else

      CALL JIOXXX(W(1,3   ),W(1,2   ),GAL ,ZERO    ,AWIDTH  ,W(1,6   ))    
      CALL FVOXXX(W(1,4   ),W(1,6   ),GAL ,ZERO    ,ZERO    ,W(1,7   ))    
      CALL IOVXXX(W(1,5   ),W(1,7   ),W(1,1   ),GZL ,AMP(1   ))            
      CALL JIOXXX(W(1,3   ),W(1,2   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,8   ))    
      CALL FVOXXX(W(1,4   ),W(1,8   ),GZL ,ZERO    ,ZERO    ,W(1,9   ))    
      CALL IOVXXX(W(1,5   ),W(1,9   ),W(1,1   ),GZL ,AMP(2   ))            
      CALL FVOXXX(W(1,4   ),W(1,1   ),GZL ,ZERO    ,ZERO    ,W(1,10  ))    
      CALL IOVXXX(W(1,5   ),W(1,10  ),W(1,6   ),GAL ,AMP(3   ))            
      CALL IOVXXX(W(1,5   ),W(1,10  ),W(1,8   ),GZL ,AMP(4   ))            
      CALL FVIXXX(W(1,3   ),W(1,1   ),GZL ,ZERO    ,ZERO    ,W(1,11  ))    
      CALL JIOXXX(W(1,11  ),W(1,2   ),GAL ,ZERO    ,AWIDTH  ,W(1,12  ))    
      CALL IOVXXX(W(1,5   ),W(1,4   ),W(1,12  ),GAL ,AMP(5   ))            
      CALL JIOXXX(W(1,11  ),W(1,2   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,13  ))    
      CALL IOVXXX(W(1,5   ),W(1,4   ),W(1,13  ),GZL ,AMP(6   ))            
      CALL FVOXXX(W(1,2   ),W(1,1   ),GZL ,ZERO    ,ZERO    ,W(1,14  ))    
      CALL JIOXXX(W(1,3   ),W(1,14  ),GAL ,ZERO    ,AWIDTH  ,W(1,15  ))    
      CALL IOVXXX(W(1,5   ),W(1,4   ),W(1,15  ),GAL ,AMP(7   ))            
      CALL JIOXXX(W(1,3   ),W(1,14  ),GZL ,ZMASS   ,ZWIDTH  ,W(1,16  ))    
      CALL IOVXXX(W(1,5   ),W(1,4   ),W(1,16  ),GZL ,AMP(8   ))            
      ZZtens(mu) = +AMP(   1)+AMP(   2)+AMP(   3)+AMP(   4)+AMP(   5)
     &             +AMP(   6)+AMP(   7)+AMP(   8)

      endif

      enddo
      ZZtens(4) = dcmplx(q(0),q(3))
      ZZtens(5) = dcmplx(q(1),q(2))

      END

