      subroutine call_qqZjqq(
     &                   bos,   !in:  Boson identifier, 2 = Z, 6=H, 34=W+W-
     &                   p,	!in:  momenta associated with external fermions
     &                   v,	!in:  momenta associated with Z/H dec. fermions 
     &                  m2s)   !out: amplitude squared
      
      implicit none

#include "VBFNLO/utilities/global.inc"
#include "VBFNLO/amplitudes/vvjj/tensor.inc"
#include "VBFNLO/amplitudes/vvjj/tensorz.inc"
#include "VBFNLO/amplitudes/vvjj/tensorsp2aa.inc"
      integer bos, h
      real*8  p(0:3,max_p,max_kin), v(0:3,max_v), m2s   
      complex*16 zero
      parameter (zero=(0d0,0d0))      
      integer FSIGN(4+max_v), physToDiag(5),gsign     
      real*8 pbar(0:3,4+max_v), qbar(0:4), polcolq, polcolg, polcol     
      real*8 bornflav(max_p), realflav(max_p+1),bflavborntwofl(max_p),bflavborn(max_p)

      real*8 uucc(3), uuss(3), ddcc(3), ddss(3), udsc(3), ducs(3)
      integer i, mu, flavcombi, n, j
      parameter (n=3)
      double precision tree(6)      

#include "VBFNLO/utilities/scales.inc"
      real*8 x1,x2
      real*8 q12(0:4,3), q34(0:4,3), qvv(0:3), !qww(0:3), 
     1 	     lnQomu(2:3), omxi(2:3), 
     1       Ax(2:3), Bx(2:3), Cx(2:3), Dxi(2:3), tgs2oqsq(2:3), 
     2       ln1mxi, lnrat, z, lnz

      INTEGER LFLAVR(5:6), lsign(3:4) 
      logical ini
      data ini/.true./
      save ini
      common/flavREW/bornflav, realflav, flavcombi
      common /hcount / h


#ifdef WITH_SPIN2
         if (ini.and.(bos.eq.11)) then
            write(6,*) " "
            write(6,*) "VV jjj (-> spin-2) -> gamma gamma  amplitude"
            write(6,*) "square information:"
            write(6,*) "-----------------------------------------------"
            write(6,*) " "
            call vtosp2aa_reset
            ini=.false.
         endif
#endif

      polcolq = 1d0/(4d0*N**2)
      polcolg = 1d0/(4d0*N*(N**2-1))

      if (realflav(1).gt.0.and.realflav(2).gt.0) then          
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c   physToDiag(ext.momentum label) = Feynman diagram label

      physToDiag(1)=1    !physToDiag(1/2) are labels of incoming quarks
      physToDiag(2)=3
      physToDiag(3)=2    !physToDiag(3/4) are labels of outgoing quarks.
      physToDiag(4)=4
      physToDiag(5)=5   ! gluon
C NOTE: for call of wbf_zh3j it is important that p(*,1,*) and p(*,3,*)
c correspond to 1-2 fermion line ALWAYS, i.e physToDiag(1/2)={1,3} and 
c similarly physToDiag(3/4)={2,4} for the 3-4 fermion line
      fsign(1) = 1
      fsign(2) = 1
      fsign(3) = 1
      fsign(4) = 1
      gsign    = 1

      polcol=polcolq
      
      do i=1,n_p
        bflavborn(i)=realflav(i)
      enddo      
C*******************  q1 qb4 ---> q2 qb3 g V V   **********************
      elseif (realflav(1).gt.0.and.realflav(2).lt.0) then 
      physToDiag(1)=1    !physToDiag(1/2) are labels of incoming quarks
      physToDiag(2)=4
      physToDiag(3)=2    !physToDiag(3/4) are labels of outgoing quarks.
      physToDiag(4)=3
      physToDiag(5)=5   ! gluon

      fsign(1) = 1
      fsign(2) = 1
      fsign(3) = -1
      fsign(4) = -1
      gsign    = 1

      polcol=polcolq


      do i=1,n_p
        bflavborn(i)=realflav(i)
      enddo
      
C*******************  qbar2 q3 ---> qbar1 q4 g V V   **********************
      elseif (realflav(1).lt.0.and.realflav(2).gt.0) then 

      physToDiag(1)=2    !physToDiag(1/2) are labels of incoming quarks
      physToDiag(2)=3
      physToDiag(3)=1    !physToDiag(3/4) are labels of outgoing quarks.
      physToDiag(4)=4
      physToDiag(5)=5   ! gluon

      fsign(1) = -1
      fsign(2) = -1
      fsign(3) = 1
      fsign(4) = 1
      gsign    = 1
      
      polcol=polcolq
      
      do i=1,n_p
        bflavborn(i)=realflav(i)
      enddo      



C*******************  qbar2 qb4 ---> qbar1 qb3 g V V  ******************
      elseif ((realflav(1).lt.0).and.(realflav(2).lt.0)) then 
      physToDiag(1)=2    !physToDiag(1/2) are labels of incoming quarks
      physToDiag(2)=4
      physToDiag(3)=1    !physToDiag(3/4) are labels of outgoing quarks.
      physToDiag(4)=3
      physToDiag(5)=5   ! gluon

      fsign(1) = -1
      fsign(2) = -1
      fsign(3) = -1 
      fsign(4) = -1
      gsign    = 1         
      polcol=polcolq
      
      do i=1,n_p
        bflavborn(i)=realflav(i)
      enddo      
      elseif (realflav(1).eq.0.and.realflav(2).gt.0.and.realflav(3).gt.0) then
         
c*******************  g q ---> q q qb W W   **********************

      physToDiag(1)=5          
      physToDiag(2)=3           
      physToDiag(3)=2           
      physToDiag(4)=4
      physToDiag(5)=1
c
      fsign(1) = -1
      fsign(2) =  1
      fsign(3) =  1
      fsign(4) =  1
      gsign    = -1
      
      polcol=polcolg
       bflavborn(1)=-realflav(n_p+1)      
      do i=2,4
        bflavborn(i)=realflav(i)
      enddo     

      elseif (realflav(1).eq.0.and.realflav(2).gt.0.and.realflav(3).lt.0) then
         
c*******************  g q ---> qb q q W W   **********************
c
      physToDiag(1)=5          
      physToDiag(2)=3           
      physToDiag(3)=1           
      physToDiag(4)=4
      physToDiag(5)=2
c
      fsign(1) = -1
      fsign(2) =  1
      fsign(3) =  1
      fsign(4) =  1
      gsign    = -1
      
      polcol=polcolg
       bflavborn(1)=-realflav(n_p+1)      
      do i=2,4
        bflavborn(i)=realflav(i)
      enddo             


      elseif (realflav(1).gt.0.and.realflav(2).eq.0
     &    .and.realflav(3).gt.0.and.realflav(4).gt.0) then
      
C*******************  q g ---> q q qb W W   **********************
      
      physToDiag(1)=1  
      physToDiag(2)=5      
      physToDiag(3)=2             
      physToDiag(4)=4
      physToDiag(5)=3       
c
      fsign(1) =  1
      fsign(2) =  1
      fsign(3) = -1
      fsign(4) =  1
      gsign    = -1

      polcol=polcolg
      
       bflavborn(1)=realflav(1)      
       bflavborn(2)=-realflav(n_p+1)    
      do i=3,4
        bflavborn(i)=realflav(i)
      enddo   

      elseif (realflav(1).gt.0.and.realflav(2).eq.0.and.
     &        realflav(3).gt.0.and.realflav(4).lt.0) then

C*******************  q g ---> q qb q W W   **********************
     
      physToDiag(1)=1 
      physToDiag(2)=5
      physToDiag(3)=2             
      physToDiag(4)=3
      physToDiag(5)=4
c
      fsign(1) =  1
      fsign(2) =  1
      fsign(3) = -1
      fsign(4) =  1
      gsign    = -1

      polcol=polcolg
      
       bflavborn(1)=realflav(1)      
       bflavborn(2)=-realflav(n_p+1)    
      do i=3,4
        bflavborn(i)=realflav(i)
      enddo   



      elseif (realflav(1).eq.0.and.realflav(2).lt.0.and.realflav(3).gt.0) then
        
C*******************  g qbar ---> q qb qb W W  **********************

      physToDiag(1)=5
      physToDiag(2)=4
      physToDiag(3)=2
      physToDiag(4)=3
      physToDiag(5)=1
c
      fsign(1) = -1
      fsign(2) =  1
      fsign(3) = -1
      fsign(4) = -1
      gsign    = -1

      polcol=polcolg

       bflavborn(1)=-realflav(n_p+1)      
      do i=2,4
        bflavborn(i)=realflav(i)
      enddo            

      elseif (realflav(1).eq.0.and.realflav(2).lt.0.and.realflav(3).lt.0) then
        
C*******************  g qbar ---> qb qb q W W  **********************

      physToDiag(1)=5
      physToDiag(2)=4
      physToDiag(3)=1
      physToDiag(4)=3
      physToDiag(5)=2
c
      fsign(1) = -1
      fsign(2) =  1
      fsign(3) = -1
      fsign(4) = -1
      gsign    = -1

      polcol=polcolg

       bflavborn(1)=-realflav(n_p+1)      
      do i=2,4
        bflavborn(i)=realflav(i)
      enddo

      elseif (realflav(1).lt.0.and.realflav(2).eq.0.and.realflav(3).lt.0.and.realflav(4).lt.0) then
 
C*******************  qbar2 g ---> qbar1 qb3 q4 W W   **********************
c
      physToDiag(1)=2!1
      physToDiag(2)=5        
      physToDiag(3)=1!2             
      physToDiag(4)=3 
      physToDiag(5)=4

      fsign(1) = -1
      fsign(2) = -1
      fsign(3) = -1
      fsign(4) =  1
      gsign    = -1
      polcol=polcolg
      
       bflavborn(1)=realflav(1)      
       bflavborn(2)=-realflav(n_p+1)    
      do i=3,4
        bflavborn(i)=realflav(i)
      enddo         

      elseif (realflav(1).lt.0.and.realflav(2).eq.0.and.realflav(3).lt.0.and.realflav(4).gt.0) then
! C*******************  qbar2 g ---> qbar1 q4 qb3 W W   **********************
! c
      physToDiag(1)=2!1
      physToDiag(2)=5        
      physToDiag(3)=1!2             
      physToDiag(4)=4 
      physToDiag(5)=3

      fsign(1) = -1
      fsign(2) = -1
      fsign(3) = -1
      fsign(4) =  1
      gsign    = -1
      polcol=polcolg
      
       bflavborn(1)=realflav(1)      
       bflavborn(2)=-realflav(n_p+1)    
      do i=3,4
        bflavborn(i)=realflav(i)
      enddo         


!        bflavborn(2)=-realflav(7)        
      else
         
         write(*,*) 'wrong value of realflav(1) and realflav(2)'
         write(*,*) 'realflav(1) = ',realflav(1)
         write(*,*) 'realflav(2) = ',realflav(2)
         write(*,*) 'bflav', realflav
         stop

      endif
         
C*****************  end of process evaluation  **********************

      do i=1, n_p
      if( abs(bflavborn(i)).gt.2) then
        bflavborntwofl(i)=sign(abs(bflavborn(i))-2,bflavborn(i))
      else
        bflavborntwofl(i)= bflavborn(i)
      endif
      enddo

!        print*, 'here'

        flavcombi=0
      if((abs(bflavborntwofl(1))-abs(bflavborntwofl(3)).eq.0).and.(abs(bflavborntwofl(2))-abs(bflavborntwofl(4)).eq.0)) then
         if (abs(bflavborntwofl(1)).eq.abs(bflavborntwofl(2))) then
             if(abs(bflavborntwofl(1)).eq.1) then
               flavcombi=4

             elseif (abs(bflavborntwofl(1)).eq.2) then
               flavcombi=1

             endif

         elseif(abs(bflavborntwofl(1)).ne.abs(bflavborntwofl(2))) then !ud, du
             if(abs(bflavborntwofl(1)).eq.1) then
               flavcombi=3

             elseif (abs(bflavborntwofl(1)).eq.2) then
               flavcombi=2

             endif
         endif

      elseif((abs(bflavborntwofl(1))-abs(bflavborntwofl(3)).ne.0).and.(abs(bflavborntwofl(2))-abs(bflavborntwofl(4)).ne.0)) then  !charged currents
             if(abs(bflavborntwofl(1)).eq.1) then
               flavcombi=6

             elseif (abs(bflavborntwofl(1)).eq.2) then
               flavcombi=5

             endif

      else
        write(*,*) "flavour combination not found, stop"
        write(*,*) realflav
        write(*,*) 'uborn', bflavborn
        write(*,*) 'uborn2flav',bflavborntwofl
 

      endif


c get the real emission amplitude squared, store it in uucc(-1,1) etc.
      do mu = 0,3
         do i = 1,5
            pbar(mu,physToDiag(i))=p(mu,i,1)
         enddo
         do i = 6,4+max_v
            pbar(mu,i)=0d0
         enddo
         qbar(mu) = pbar(mu,5)
      enddo
      qbar(4)=0d0
      


      if (bos.eq.2) then  ! Z
         do mu = 0,3             ! kinematics for Z-->l+l- decay
            pbar(mu,5) = v(mu,2) ! ebar
            pbar(mu,6) = v(mu,1) ! e
         enddo
         fsign(5) = -1
         fsign(6) = 1

        call qqzqqj(pbar,fsign,qbar,gsign, 
     1            uucc(1),uuss(1),ddcc(1),ddss(1),udsc(1),ducs(1))

      elseif (bos.eq.1) then  ! photon
         do mu = 0,3
            pbar(mu,5) = v(mu,n_v) ! photon
            pbar(mu,6) = 0d0 
         enddo
         fsign(5) = -1
         fsign(6) = 0

         call qqAqqj(pbar, fsign, qbar, gsign,
     1           uucc(1),uuss(1),ddcc(1),ddss(1),udsc(1),ducs(1),tree)
!          endif
      elseif (bos.eq.6) then  ! higgs
         do mu = 0,3
            pbar(mu,5) = 0      ! dummy momentum
            pbar(mu,6) = 0
            do i = 1,n_v
               pbar(mu,6) = pbar(mu,6) + v(mu,i) ! Higgs momentum
            enddo
         enddo
         fsign(5) = 0
         fsign(6) = 1  
!       print*, 'realflav', realflav
!       print*, 'flavcombi',flavcombi
!       do i=1,6
!           print*,i, pbar(:,i)
!           pause
!       enddo
         call qqhqqj(pbar,fsign,qbar,gsign, 
     1            uucc(1),uuss(1),ddcc(1),ddss(1),udsc(1),ducs(1))
!       elseif (bos.eq.16.or.bos.eq.61) then  ! Higgs plus photon
!          fsign(5) = 0
!          fsign(6) = 1
! 
!          call HAjjj_ME(fsign,gsign,
!      $           uucc(1),uuss(1),ddcc(1),ddss(1),udsc(1),ducs(1))
!          endif
      elseif (bos.eq.34 .or. bos.eq.43) then         ! W+W- to 4 leptons
         do mu = 0,3            ! kinematics for H-->WW -->4 lepton decay
            pbar(mu,5) = v(mu,2) ! l+
            pbar(mu,6) = v(mu,1) ! nu
            pbar(mu,7) = v(mu,3) ! nubar
            pbar(mu,8) = v(mu,4) ! l-
         enddo
         fsign(5) = -1
         fsign(6) = 1
         fsign(7) = -1
         fsign(8) = 1
c

c original version for H->WW only:		 
c           call qqhqqj_c(pbar,fsign,qbar,gsign, 
c     1            uucc(1),uuss(1),ddcc(1),ddss(1),udsc(1),ducs(1))
c	
c new routine "bqqwwqqj" with madgraph-call:
c            call bqqwwqqj_comp(pbar,fsign,qbar,gsign,
c     &           uucc(1),uuss(1),ddcc(1),ddss(1),udsc(1),ducs(1))
     
c new routine (with speed-up): uucc(1) stands for uucc(1:3) here!    
        call qqwwqqj(pbar,fsign,qbar,gsign,
     &            uucc(1),uuss(1),ddcc(1),ddss(1),udsc(1),ducs(1))  


      elseif (bos.eq.22) then         ! ZZ to 4 leptons
         do mu = 0,3            ! kinematics for H-->ZZ -->4 lepton decay
            pbar(mu,5) = v(mu,1) ! l+
            pbar(mu,6) = v(mu,2) ! l-
            pbar(mu,7) = v(mu,3) ! l"+
            pbar(mu,8) = v(mu,4) ! l"-
         enddo
         fsign(5) = -1
         fsign(6) = 1
         fsign(7) = -1
         fsign(8) = 1
c

c routine "bqqzzqqj" with madgraph-call:
c            call bqqzzqqj_comp(pbar,fsign,qbar,gsign,bos,
c     &           uucc(1),uuss(1),ddcc(1),ddss(1),udsc(1),ducs(1))
c         
c new routine (with speed-up): uucc(1) stands for uucc(1:3) here!      
         call qqzzqqj(pbar,fsign,qbar,gsign,bos,
     &            uucc(1),uuss(1),ddcc(1),ddss(1),udsc(1),ducs(1)) 
	
c	compare to madgraph:
c            call bqqzzqqj_comp(pbar,fsign,qbar,gsign,bos,
c     &           uucc(1),uuss(1),ddcc(1),ddss(1),udsc(1),ducs(1))
     


#ifdef WITH_SPIN2
      elseif (bos.eq.11) then         ! qq(-->spin-2)-->qq gamma gamma
      call Calc_Momentum_Transfer(p, v, q12,q34,3)      
        h = mod(h,4) + 1
        

	lsign(3) = sign(1,2-h)
	lsign(4) = (-1)**(h+1)
		
      CALL VXXXXX(v(0,1),ZERO ,lsign(3),1,sp2au(1))          !A1
      CALL VXXXXX(v(0,2),ZERO ,lsign(4),1,sp2ae(1))          !A2

c leptonic tensors
         do j = 2,3
           if((flavcombi.eq.5).or.(flavcombi.eq.6)) then
             CALL wwsp2toaa(q34(0,j),q12(0,j),v,lsign,sp2wwaa5(0,0,j))
             CALL wwsp2toaa(q12(0,j),q34(0,j),v,lsign,sp2wwaa6(0,0,j))
           else
             CALL zzsp2toaa(q34(0,j),q12(0,j),v,lsign,sp2zzaa(0,0,j))
             CALL azsp2toaa(q34(0,j),q12(0,j),v,lsign,sp2azaa(0,0,j))
             CALL azsp2toaa(q12(0,j),q34(0,j),v,lsign,sp2zaaa(0,0,j))
             CALL aasp2toaa(q34(0,j),q12(0,j),v,lsign,sp2aaaa(0,0,j))
           endif
         enddo      
      
         do mu = 0,3             
            pbar(mu,5) = v(mu,1) ! photon 1
            pbar(mu,6) = v(mu,2) ! photon 2
         enddo

         fsign(5) = 1
         fsign(6) = 1

            call qqsp2aaqqj(pbar,fsign,qbar,gsign,bos,
     &            uucc(1),uuss(1),ddcc(1),ddss(1),udsc(1),ducs(1))         

!         print*, 'h', h ,uucc(1),uuss(1),ddcc(1),ddss(1),udsc(1),ducs(1)
#endif
      elseif (bos.eq.21) then         ! ZZ to 2 leptons 2 neutrinos
         do mu = 0,3            ! kinematics for H-->ZZ -->4 lepton decay
            pbar(mu,5) = v(mu,1) ! l+
            pbar(mu,6) = v(mu,2) ! l-
            pbar(mu,7) = v(mu,3) ! v
            pbar(mu,8) = v(mu,4) ! v~
         enddo
         fsign(5) = -1
         fsign(6) =  1
         fsign(7) =  1
         fsign(8) = -1
c
c routine "bqqzzqqj" with madgraph-call:
c            call bqqzzqqj_comp(pbar,fsign,qbar,gsign,bos,
c     &           uucc(1),uuss(1),ddcc(1),ddss(1),udsc(1),ducs(1))
c         
c new routine (with speed-up): uucc(1) stands for uucc(1:3) here!      
        call qqzzqqj(pbar,fsign,qbar,gsign,bos,
     &            uucc(1),uuss(1),ddcc(1),ddss(1),udsc(1),ducs(1)) 
	
c	compare to madgraph:
c            call bqqzzqqj_comp(pbar,fsign,qbar,gsign,bos,
c     &           uucc(1),uuss(1),ddcc(1),ddss(1),udsc(1),ducs(1))
     
       	

      else
         print*," Invalid entry BOS = ",bos,"in call of wbf_zh3j"
         print*," Must be 2, 6, 34 / 43, 22, 11 or 21 "
         stop
      endif   ! end of if bos = ..
      
      
      select case (flavcombi)
      case(1) 
         m2s=polcol*uucc(1)
      case(2) 
         m2s=polcol*uuss(1)
      case(3) 
         m2s=polcol*ddcc(1)
      case(4) 
         m2s=polcol*ddss(1)
      case(5) 
         m2s=polcol*udsc(1)
      case(6) 
         m2s=polcol*ducs(1)
      end select

ccc      if(m2s.eq.0d0) then
ccc      print*,flavcombi, m2s
ccc      print*,  uucc(1),uuss(1),ddcc(1),ddss(1),udsc(1),ducs(1)
ccc!       print*, pbar,fsign
ccc!       print*, qbar,gsign
ccc
ccc     endif
      
      end