c
c	Dieter Zeppenfeld, <dieter@pheno.physics.wisc.edu>
c       Rob Szalapski, <robs@theory.kek.jp>
c       Terrance Figy, <terrance@pheno.physics.wisc.edu>
c	Initial version:  1995 March 24
c	Last modified:    2001 June 14
c
      real*8 function m2s_w2j(
     &                   bosC,  !in:  Id for W+ or W- or W+- cases
     &                   bosi,  !in:  Id W+ or W- for this particular event
     &                   xi,	!in:  Feynman x parameters of incoming fermions
     &                   p,	!in:  momenta associated with external fermions
     &                   v,	!in:  momenta associated with W decay fermions
     &                   rn!,	!in:  random numbers, first 2 used here
!     &                   qsq    !out:  generated event Q^2
     &                        )
      implicit none

c
c declare input/output variables
c
#include "VBFNLO/utilities/global.inc"
#include "VBFNLO/utilities/lha.inc"  
#include "VBFNLO/utilities/coupl.inc"
#include "VBFNLO/utilities/scales.inc"
      logical ldebug
      parameter (ldebug = .false.)
cccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c     commom block for diagrammatic labels:
      integer idq,idg
      common/diagram/ idq(1:4),idg(1:2)
ccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      real*8
     $     xi(nx), p(0:3,max_p), v(0:3,max_v), rn(2), qsq
      integer bosi, bosC

c  For transformation of old notation
      integer
     $     njets
      parameter (njets = max_p - nx)
c
!       real*8
!      $     pi
!       PARAMETER (PI=3.14159 26535 89793d0)
c
c declare global variables
c
!      include 'coupl.inc'
c
c declare external functions
c
      integer  FL4qcd
      external FL4qcd
      external getRes4QW
      external getRes2Q2GW
c
c
      real*8
     $     alphas5!,als
      external
     $     alphas5
c  
      integer ProcessNumber
      logical firstTimeThrough
      save firstTimeThrough
      data firstTimeThrough /.true./
      
      logical FLskipid(1:2)     ! for skipping already calculated processes
      logical bquarkoff
      parameter (bquarkoff = .true.)
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c     Variables for use in summation over flavors and what not.

      INTEGER
     $     LFLAVR(5:6), bos, bosii    
      INTEGER
     $     FSIGNQ(4), GSIGN(3), LSIGN(2), I, J, ires_min, ires_max,
     $     numcolor1,colorprocess,colorprocess1,num2gprocs
      REAL*8
     $     PBARQ(0:3,4), QBAR(0:4,3), LBAR(0:3,2), CSAMSQ(0:6),
     $     PBARQF(0:3,4), QBARF(0:4,3), RES(1:maxnumsubproc),
     $     wtot,w4q,w2g,weight
      Real*8
     $     SQ00(0:4), SQ13(0:4),SQ24(0:4)

c save this
      integer upperbosi,lowerbosi
      save upperbosi,lowerbosi
c
c declare parton distribution variables
c     
      real*8
     $     pdf1(-6:6), pdf2(-6:6)
      integer ip(2)
c
ccccccccccccccccccccccccccccccccccccccccc
c
      real*8
     $     qsq_al, qsq_sf, q_sf
      real*8
     $     ptmin,pt(njets)
      numdecay =3
      ip(1)=sign1
      ip(2)=sign2
!       call leptonfillw(bosC,templflavr,rn(2),upperbosi, temp)
!       call initHEPEUPw(1,p,v)
!       call parton_initw
ccccccccccccccccccccccccccccccccccccccccc

      if ( firstTimeThrough ) then
c
         write(6,*) ' '
         write(6,*) 'W2j  amplitude square information:'
         write(6,*) '--------------------------------------------------'
	 call printnfl(.true.)
         if(bosC.eq.4) then
            write(6,*)'This is the W- case.'
            upperbosi = 4
            lowerbosi = 4

         elseif(bosC.eq.3) then
            write(6,*)'This is the W+ case.'
            upperbosi = 3
            lowerbosi = 3

         elseif(bosC.eq.34) then
            write(6,*)'This is the W+ and W- case'
            upperbosi = 4 ! upper boson index
            lowerbosi = 3 ! lower boson index

         else
            stop
         endif
!          write(6,*) ' first event at sqrt(s) = ',
!      &           sqrt(4*p(0,1)*p(0,2)/(xi(1)*xi(2)))
         write(6,*) ' '
c 
         do i = 1,2
            IDBMUP(i) = ip(i)*2212
            EBMUP(i) = p(0,i)/xi(i)
         enddo
!          print*,IDBMUP,EBMUP
c
!         call calc_qsq(bosi,firstTimeThrough,def_qsq,p,v,qsq_al,qsq_sf)
c
         write (6,*) ' '
!          if (ptsa.gt.1d-2) then
!             write(6,171),' 1-exp(-pt^2/p_TSA^2) TSA used with p_TSA =',
!      $          ptsa,' GeV.'
!  171        format(a,f8.2,a)
!          else
!             write(6,*),' no TSA reduction factor used '
!          endif
! !         print*,' alphas = ',als,' alphas(m_Z) = ',alphas(91.189d0**2)
      endif

      if (ldebug) then
         print*,' ip(1),ip(2),bosi = ', ip,bosi,bosC
      endif

!      call calc_qsq(bosi,.false.,def_qsq,p,v,qsq_al,qsq_sf)
      qsq_sf = mufsq(1,1)
      qsq = qsq_sf
!       print*,'         qsq_sf = ', qsq_sf
c
c if desired, print output information
c
      if ( ldebug ) then
         write(6,*) ' '
 10      format( ' p(', i1, ') = ', 4(f8.1, 2x) )
 20      format( ' v(', i1, ') = ', 4(f8.1, 2x) )
c
         write(6,*) ' '
         do i = 1, max_p
            write(6,10) i, p(0,i), p(1,i), p(2,i), p(3,i)
         end do
         do i = 1, max_v
            write(6,20) i, v(0,i), v(1,i), v(2,i), v(3,i)
         end do
c
         write(6,*) ' '
         write(6,*) 'xi(1), xi(2) =', xi
         write(6,*) 'event Q^2 =', qsq_sf
      end if
c
c call PDF subroutine in order to determine parton
c distributions in the incoming (anti)protons.
c
      q_sf = sqrt(qsq_sf)
!       print*,qsq_sf
      call pdfproton( xi(1), q_sf, pdf1 )
      do i = -6,6
         pdf1(i) = pdf1(i)/xi(1)
      enddo
c
      call pdfproton( xi(2), q_sf, pdf2 )
      do i = -6,6
         pdf2(i) = pdf2(i)/xi(2)
      enddo
c
      if(bquarkoff) then
         pdf1(5)  = 0
         pdf1(-5) = 0
         pdf2(5)  = 0
         pdf2(-5) = 0
      endif
c
c calculate alphas
!       if (def_qsq.eq.6) then
!          ALS = 1.0d0
!          do i = 1, njets
!             pt(i) = p(1,nx+i)**2 + p(2,nx+i)**2
!             ALS  = ALS*alphas( pt(i) )
!          enddo
!          ALS = ALS**(1.0d0/dble(njets))
!       else
!          ALS = ALPHAS( qsq_al )
! c         als = alphas_old(qsq_al,-0.2d0,5)
!       endif
!       if (ldebug) then
!          print*,' qsq_al = ',qsq_al,sqrt(qsq_al)
! !         print*,' alphas = ',als,' alphas(m_Z) = ',alphas(91.189d0**2)
!       endif
! 
!       ptmin = 1d33
!       do i = 1, njets
!          ptmin = min( ptmin, pt(i) )
!       enddo
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c    initialize counter in FL4qcd:
 101  if (firstTimeThrough .or. bosC.ne.34) then
         ires_min = FL4qcd(1,1,1,1,-100000)+1
         if (firstTimeThrough) then
            ires_max = maxnumsubproc
         else
            ires_max = numcolor1
         endif
      elseif (bosi.eq.3) then                  ! W+  case
         ires_min = FL4qcd(1,1,1,1,-100000)+1  ! start at head of color table
         ires_max = numcolor1/2
         upperbosi = bosi
         lowerbosi = bosi
      elseif (bosi.eq.4) then                      ! W-  case
         ires_min = FL4qcd(1,1,1,1,-numcolor1/2)+1  ! start in middle of table
         ires_max = numcolor1
         upperbosi = bosi
         lowerbosi = bosi
      endif
c
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
c
c
c
C	FROM JIM, ON 11/8/88
C	MODIFIED  ON 3/24/89 for the new Vjet code
C
C******************************************************************************
C
C	PATCH IN DIETERS SUBROUTINE TO EVALUATE SQUARED MATRIX ELEMENT FOR
C	
C	P PBAR -> W + 2 JETS WITH W -> e nu
C
C*******************************************************************************
c
  
      do bosii = lowerbosi,upperbosi
c     initialize FLskipid logical: the default is .false.
         FLskipid(1) = .false.  ! SQ13 true = process done already
         FLskipid(2) = .false.  ! SQ24 false = process not done yet
C     FIRST SET UP LEPTON
         IF(bosii.EQ.4) THEN
            LFLAVR(5) = 11      ! nubar
            LFLAVR(6) = 21      ! e
            bos = 40            !VIRTUAL W-
            DO j=0,3
               LBAR(J,1)  = v(j,1) ! nubar (anti-lepton)
               LBAR(J,2)  = v(j,2) ! e (lepton)
            END DO		 
         ELSEIF(bosii.EQ.3) THEN
            LFLAVR(5) = 21      ! e+
            LFLAVR(6) = 11      ! nu     
            BOS = 30            ! VIRTUAL W+
            DO j=0,3
               LBAR(J,1)  = v(j,2) ! e+ (anti-lepton)
               LBAR(J,2)  = v(j,1) ! nu (lepton)
            END DO		 
         ENDIF
         LSIGN(1)  = -1
         LSIGN(2)  =  1

C----------------------------------------------------------------------------
C     USE HSLW2Q
c     use HcSRW2Q
C     G1 G2 -> QBAR1 Q2 W-
c     p1 p2    p3    p4    pythia labels
         idg(1) = 1
         idg(2) = 2
         idq(1) = 3
         idq(2) = 4
         
C     PUT MY MOMENTA INTO DIETERS FORMAT
         DO j = 0,3
            do i = 1,2
               QBAR(J,i)  = p(j,idg(i)) ! G	
               PBARQ(J,i) = p(j,idq(i)) ! QB
            enddo
         ENDDO	
c     
         QBAR(4,1) = 0.0d0
         QBAR(4,2) = 0.0d0
         QBARF(4,1) = 0.0d0
         QBARF(4,2) = 0.0d0
         
         FSIGNQ(1) = -1
         FSIGNQ(2) =  1
         GSIGN(1)  = -1
         GSIGN(2)  = -1
         

C     G + G -> DB U W-  	G + G -> SB C W-
C     
         CALL HcSLW2Q('R',RN(1),2,PBARQ,FSIGNQ,QBAR,GSIGN,BOS,LBAR,
     $        LSIGN,LFLAVR,CSAMSQ)	
C     
!       print*,bos,bosii,lflavr,csamsq
         call getRes2Q2GW(res,fsignq,ip,pdf1,pdf2,CSAMSQ,bosii)
!             wtot = 0d0
!       do i=i,maxnumsubproc
!          if (res(i).gt.wtot) wtot = res(i)
!       enddo
! !      print*,wtot
!       do i = ires_min,ires_max
!          wtot = wtot + res(i)
!       enddo
!       print*,wtot
C
C----------------------------------------------------------------------------

C     Q1 QBAR2 -> G1 G2 W-
c     p1 p2       p3 p4    pythia labels
         idg(1) = 3
         idg(2) = 4
         idq(1) = 1
         idq(2) = 2
c     
C     PUT MY MOMENTA INTO DIETERS FORMAT
         DO j = 0,3
            do i = 1,2
               QBAR(J,i)  = p(j,idg(i)) ! G	
               PBARQ(J,i) = p(j,idq(i)) ! QB
            enddo
         ENDDO	
      

         FSIGNQ(1) =  1
         FSIGNQ(2) = -1
         GSIGN(1)  =  1
         GSIGN(2)  =  1
         
         
C     D UB -> G G W-  	S CB -> G G W- 
c     
         CALL HcSLW2Q('R',RN(1),2,PBARQ,FSIGNQ,QBAR,GSIGN,BOS,LBAR,LSIGN,
     $        LFLAVR,CSAMSQ)
         call getRes2Q2GW(res,fsignq,ip,pdf1,pdf2,CSAMSQ,bosii)
      


C     UB D -> G G W-		CB S -> G G W-
         idq(1) = 2
         idq(2) = 1
c     
         DO j = 0,3
            do i = 1,2
               QBAR(J,i)  = p(j,idg(i)) ! G	
               PBARQF(J,i) = p(j,idq(i)) ! QB
            enddo
         ENDDO
c     
         CALL HcSLW2Q('R',RN(1),2,PBARQF,FSIGNQ,QBAR,GSIGN,BOS,LBAR,LSIGN,
     $        LFLAVR,CSAMSQ)
c     
     
         call getRes2Q2GW(res,fsignq,ip,pdf1,pdf2,CSAMSQ,bosii)
!             print*,res

C----------------------------------------------------------------------------
C     G1 Q1 -> Q2 G2 W-  
c     p1 p2    p3 p4    pythia
         idq(1) = 2
         idq(2) = 3
         idg(1) = 1
         idg(2) = 4
c     
C     PUT MY MOMENTA INTO DIETERS FORMAT
         DO j = 0,3
            do i = 1,2
               QBAR(J,i)  = p(j,idg(i)) ! G	
               PBARQ(J,i) = p(j,idq(i)) ! QB
            enddo
         ENDDO
    
        
         FSIGNQ(1) =  1
         FSIGNQ(2) =  1
         GSIGN(1)  = -1
         GSIGN(2)  =  1


C     G D -> G U W-  		G S -> G C W- 
         
         CALL HcSLW2Q('R',RN(1),2,PBARQ,FSIGNQ,QBAR,GSIGN,BOS,LBAR,LSIGN,
     $        LFLAVR,CSAMSQ)
         call getRes2Q2GW(res,fsignq,ip,pdf1,pdf2,CSAMSQ,bosii)
     


C     D G -> G U W-		S G -> G C W-
         idq(1) = 1
         idg(1) = 2
c
         DO j = 0,3
            do i = 1,2
               QBARF(J,i)  = p(j,idg(i)) ! G	
               PBARQF(J,i) = p(j,idq(i)) ! QB
            enddo
         ENDDO
c     
         CALL HcSLW2Q('R',RN(1),2,PBARQF,FSIGNQ,QBARF,GSIGN,BOS,LBAR,LSIGN,
     $        LFLAVR,CSAMSQ)
      
         call getRes2Q2GW(res,fsignq,ip,pdf1,pdf2,CSAMSQ,bosii)
c
C----------------------------------------------------------------------------
C     G1 QBAR2 -> QBAR1 G2 W-
c     p1 p2       p3    p4    pythia labels
         idq(1) = 3
         idq(2) = 2
         idg(1) = 1
         idg(2) = 4
c     
C     PUT MY MOMENTA INTO DIETERS FORMAT
         DO j = 0,3
            do i = 1,2
               QBAR(J,i)  = p(j,idg(i)) ! G	
               PBARQ(J,i) = p(j,idq(i)) ! QB
            enddo
         ENDDO
   

         FSIGNQ(1) = -1
         FSIGNQ(2) = -1
         GSIGN(1)  = -1
         GSIGN(2)  =  1

C     G UB -> G DB W-  		G CB -> G SB W- 
         
         CALL HcSLW2Q('R',RN(1),2,PBARQ,FSIGNQ,QBAR,GSIGN,BOS,LBAR,LSIGN,
     $        LFLAVR,CSAMSQ)
         call getRes2Q2GW(res,fsignq,ip,pdf1,pdf2,CSAMSQ,bosii)



C     UB G -> G DB W-		CB G -> G SB W-
         idq(2) = 1
         idg(1) = 2
c     
         DO j = 0,3
            do i = 1,2
               QBARF(J,i)  = p(j,idg(i)) ! G	
               PBARQF(J,i) = p(j,idq(i)) ! QB
            enddo
         ENDDO
         CALL HcSLW2Q('R',RN(1),2,PBARQF,FSIGNQ,QBARF,GSIGN,BOS,LBAR,LSIGN,
     $        LFLAVR,CSAMSQ)
      
         call getRes2Q2GW(res,fsignq,ip,pdf1,pdf2,CSAMSQ,bosii)
!          print*,res

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c                         end 2q2g subprocesses  
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
         num2gprocs = numcolor  ! number of 2q2g subprocesses
c
C----------------------------------------------------------------------------
C     NEXT USE SLW4Q: NOTE THAT, W COUPLES TO Q1,Q2 FOR EVER.
C     use ScLW4Q
C     6 TYPES OF CLASSIFICATIONS ACCORDING TO Z.& H.'S PAPER: MAD/PH/402
         
c     CLASS (1):  Q1 QBAR2 -> QB3 Q4 W-
c                 p1 p2       p3  p4    pythia labels
         idq(1) = 1
         idq(2) = 2
         idq(3) = 3
         idq(4) = 4
c
C     PUT MY MOMENTA INTO DIETERS FORMAT
         DO J=0,3
            do i = 1,4
               PBARQ(J,i) = p(j,idq(i)) ! Q IN	
            enddo
         END DO		 

         FSIGNQ(1) =  1
         FSIGNQ(2) = -1
         FSIGNQ(3) = -1
         FSIGNQ(4) =  1

CCCCC TAKE Q FROM THE LEFT AND QB FROM THE RIGHT

         CALL ScLW4Q('R',RN(1),PBARQ,FSIGNQ,BOS,LBAR,LSIGN,
     $        LFLAVR,SQ00,SQ13,SQ24)

         call getRes4QW(res,fsignq,ip,pdf1,pdf2,SQ00,SQ13,
     $        SQ24,FLskipid,bosii)

CCCCC TAKE Q FROM THE RIGHT AND QB FROM THE LEFT
         idq(1) = 2
         idq(2) = 1
c
         DO J=0,3
            do i = 1,4
               PBARQF(J,i) = p(j,idq(i)) ! Q IN	
            enddo
         END DO	
c     
         CALL ScLW4Q('R',RN(1),PBARQF,FSIGNQ,BOS,LBAR,LSIGN,
     $        LFLAVR,SQ00,SQ13,SQ24)
         
         call getRes4QW(res,fsignq,ip,pdf1,pdf2,SQ00,SQ13,
     $        SQ24,FLskipid,bosii)

C----------------------------------------------------------------------------

C     CLASS (2).  Q3 QB4 -> QBAR1 Q2 W-
c                 p1 p2     p3    p4     pythia labels
         idq(1) = 3
         idq(2) = 4
         idq(3) = 1
         idq(4) = 2
c     
C     PUT MY MOMENTA INTO DIETERS FORMAT
         DO J=0,3
            do i = 1,4
               PBARQ(J,i) = p(j,idq(i)) ! Q IN	
            enddo
         END DO	
	 
         
         FSIGNQ(1) = -1
         FSIGNQ(2) =  1
         FSIGNQ(3) =  1
         FSIGNQ(4) = -1

CCCCC TAKE Q FROM THE LEFT AND QB FROM THE RIGHT

         CALL ScLW4Q('R',RN(1),PBARQ,FSIGNQ,BOS,LBAR,LSIGN,
     $        LFLAVR,SQ00,SQ13,SQ24)
         call getRes4QW(res,fsignq,ip,pdf1,pdf2,SQ00,SQ13,
     $        SQ24,FLskipid,bosii)

CCCCC TAKE Q FROM THE RIGHT AND QB FROM THE LEFT
         idq(3) = 2
         idq(4) = 1
c
         DO J=0,3
            do i = 1,4
               PBARQF(J,i) = p(j,idq(i)) ! Q IN	
            enddo
         END DO	
c
         CALL ScLW4Q('R',RN(1),PBARQF,FSIGNQ,BOS,LBAR,LSIGN,
     $        LFLAVR,SQ00,SQ13,SQ24)
      
         call getRes4QW(res,fsignq,ip,pdf1,pdf2,SQ00,SQ13,
     $        SQ24,FLskipid,bosii)
      

C----------------------------------------------------------------------------

C     CLASS (3):  Q1 Q3 -> Q2 Q4  W- 
c                 p1 p2    p3 p4     pythia labels
         idq(1) = 1
         idq(2) = 3
         idq(3) = 2
         idq(4) = 4
c     
C     PUT MY MOMENTA INTO DIETERS FORMAT
         DO J=0,3
            do i = 1,4
               PBARQ(J,i) = p(j,idq(i)) ! Q IN	
            enddo
         END DO	
    	 
      
         FSIGNQ(1) = 1
         FSIGNQ(2) = 1
         FSIGNQ(3) = 1
         FSIGNQ(4) = 1

         CALL ScLW4Q('R',RN(1),PBARQ,FSIGNQ,BOS,LBAR,LSIGN,
     $        LFLAVR,SQ00,SQ13,SQ24)

CCCCC TAKE Q1 FROM THE LEFT AND Q3 FROM THE RIGHT
         call getRes4QW(res,fsignq,ip,pdf1,pdf2,SQ00,SQ13,
     $        SQ24,FLskipid,bosii)
         

CCCCC TAKE Q1 FROM THE RIGHT AND Q3 FROM THE LEFT
         idq(1) = 2
         idq(3) = 1
c
         DO J=0,3
            do i = 1,4            
               PBARQF(J,i) = p(j,idq(i)) ! Q IN	
            enddo
         END DO
c	
         CALL ScLW4Q('R',RN(1),PBARQF,FSIGNQ,BOS,LBAR,LSIGN,
     $        LFLAVR,SQ00,SQ13,SQ24)
      
         FLskipid(1) = .true.
         call getRes4QW(res,fsignq,ip,pdf1,pdf2,SQ00,SQ13,
     $        SQ24,FLskipid,bosii)

C----------------------------------------------------------------------------
         
C     CLASS (4):  Q1 QB4 -> Q2 QB3  W-
c                 p1 p2     p3 p4       pythia labels
         idq(1) = 1
         idq(2) = 3
         idq(3) = 4
         idq(4) = 2
c     
         FLskipid(1) = .true.
         FLskipid(2) = .true.
c     
C     PUT MY MOMENTA INTO DIETERS FORMAT
         DO J=0,3
            do i = 1,4
               PBARQ(J,i) = p(j,idq(i)) ! Q IN	
            enddo
         END DO	
	 

         FSIGNQ(1) =  1
         FSIGNQ(2) =  1
         FSIGNQ(3) = -1
         FSIGNQ(4) = -1

         CALL ScLW4Q('R',RN(1),PBARQ,FSIGNQ,BOS,LBAR,LSIGN,
     $        LFLAVR,SQ00,SQ13,SQ24)
         call getRes4QW(res,fsignq,ip,pdf1,pdf2,SQ00,SQ13,
     $        SQ24,FLskipid,bosii)


CCCCC TAKE Q FROM THE RIGHT AND QB FROM THE LEFT
C     (C).
         idq(1) = 2
         idq(4) = 1
c
         DO J=0,3
            do i = 1,4            
               PBARQF(J,i) = p(j,idq(i)) ! Q IN	
            enddo
         END DO	
c
         CALL ScLW4Q('R',RN(1),PBARQF,FSIGNQ,BOS,LBAR,LSIGN,
     $        LFLAVR,SQ00,SQ13,SQ24)
      
         call getRes4QW(res,fsignq,ip,pdf1,pdf2,SQ00,SQ13,
     $        SQ24,FLskipid,bosii)

C----------------------------------------------------------------------------

C     CLASS (5):  QBAR2 Q3 -> QBAR1 Q4  W-
c                 p1    p2    p3    p4     pythia labels
         idq(1) = 3
         idq(2) = 1
         idq(3) = 2
         idq(4) = 4 
C     PUT MY MOMENTA INTO DIETERS FORMAT
         DO J=0,3
            do i = 1,4            
               PBARQ(J,i) = p(j,idq(i)) ! Q IN	
            enddo
         END DO	
    	 
        
         FSIGNQ(1) = -1
         FSIGNQ(2) = -1
         FSIGNQ(3) =  1
         FSIGNQ(4) =  1

         CALL ScLW4Q('R',RN(1),PBARQ,FSIGNQ,BOS,LBAR,LSIGN,
     $        LFLAVR,SQ00,SQ13,SQ24)
         call getRes4QW(res,fsignq,ip,pdf1,pdf2,SQ00,SQ13,
     $        SQ24,FLskipid,bosii)
CCCCC TAKE QB FROM THE LEFT AND Q FROM THE RIGHT
CCCCC TAKE QB FROM THE RIGHT AND Q FROM THE LEFT
C     (C).
         idq(2) = 2
         idq(3) = 1
c
         DO J=0,3
            do i = 1,4            
               PBARQF(J,i) = p(j,idq(i)) ! Q IN	
            enddo
         END DO	
c
         CALL ScLW4Q('R',RN(1),PBARQF,FSIGNQ,BOS,LBAR,LSIGN,
     $        LFLAVR,SQ00,SQ13,SQ24)
     
         call getRes4QW(res,fsignq,ip,pdf1,pdf2,SQ00,SQ13,
     $        SQ24,FLskipid,bosii)

C----------------------------------------------------------------------------

C     CLASS (6):   QBAR2 QB4 -> QBAR1 QB3  W-
c                  p1    p2     p3    p4      pythia labels
         idq(1) = 3
         idq(2) = 1
         idq(3) = 4
         idq(4) = 2
c     
         FLskipid(1) = .false.
         FLskipid(2) = .false.
c     
C     PUT MY MOMENTA INTO DIETERS FORMAT
         DO J=0,3
            do i = 1,4            
               PBARQ(J,i) = p(j,idq(i)) ! Q IN	
            enddo
         END DO
c
         FSIGNQ(1) = -1
         FSIGNQ(2) = -1
         FSIGNQ(3) = -1
         FSIGNQ(4) = -1
         
         CALL ScLW4Q('R',RN(1),PBARQ,FSIGNQ,BOS,LBAR,LSIGN,
     $        LFLAVR,SQ00,SQ13,SQ24)
         call getRes4QW(res,fsignq,ip,pdf1,pdf2,SQ00,SQ13,
     $        SQ24,FLskipid,bosii)
CCCCC TAKE QBAR2 FROM THE LEFT AND QB4 FROM THE RIGHT      
CCCCC TAKE QBAR2 FROM THE RIGHT AND QB4 FROM THE LEFT
         idq(2) = 2
         idq(4) = 1
c
         DO J=0,3
            do i = 1,4            
               PBARQF(J,i) = p(j,idq(i)) ! Q IN	
            enddo
         END DO
c     
         CALL ScLW4Q('R',RN(1),PBARQF,FSIGNQ,BOS,LBAR,LSIGN,
     $        LFLAVR,SQ00,SQ13,SQ24)
     
         FLskipid(2) = .true.
         call getRes4QW(res,fsignq,ip,pdf1,pdf2,SQ00,SQ13,
     $        SQ24,FLskipid,bosii)

         
C--------end 4q subprocesses-------------------------------------------     
C--------end subprocess evaluation-------------------------------------
!       j=0
!       do i=0,maxnumsubproc
!          if(res(i).ne.0d0) then; j=j+1; print*,res(i); endif
!       enddo
!       print*,j
      enddo
c--------------end loop over W+/W- bosons------------------------------

c     Pick a subprocess
c---------------------------------------------------------------------- 
      if (firstTimeThrough) then
         write(6,*) 'number of subprocesses = ',numcolor
         write(6,*) 'number of decay channels = ',numdecay
         if (bosC.ne.34) then
            print*,' 2 gluon processes: ',num2gprocs
            print*,' 4 quark processes: ',numcolor-num2gprocs
         endif
         numcolor1 = numcolor
!          call writeHEPUPtablew
         firstTimeThrough = .false.
         goto 101
      endif
      if (ldebug) then
         print*,' ires limits are ',ires_min, ires_max
      endif
      wtot = 0.0d0
      do i = ires_min,ires_max
         wtot = wtot + res(i)
      enddo
!       print*
!       print*,'wtot = ',wtot
!       print*
!       print*
      ColorProcess=0
      weight=0.0d0
      i = ires_min
      do while((i.le.ires_max).and.(ColorProcess.eq.0))
         weight = weight + res(i)/wtot
         if(weight.ge.rn(2)) then
            ColorProcess = i
         endif
         i = i+1
      enddo
      if(ColorProcess.eq.0) then
         write(*,*)  'error in subprocess selection'
         stop
c      else
c      write(*,*) 'processNumber=',colorprocess 
      endif
c
c     Fill in rest of HEPEUP common block
c     Below runs from 1+numdecay to numcolor + numdecay
      colorprocess1 = colorprocess + numdecay
c
c     

      scalup = q_sf
      AQEDUP = ALPHA
      AQCDUP = ALS(1,1)

      do i=1,max_p
        idup(i)=lidup(i,ColorProcess1)
        istup(i)=listup(i,ColorProcess1)
        mothup(1,i)=lmothup(1,i,ColorProcess1)
        mothup(2,i)=lmothup(2,i,ColorProcess1)
        icolup(1,i)=licolup(1,i,ColorProcess1)
        icolup(2,i)=licolup(2,i,ColorProcess1)
        spinup(i)=9                          ! no polarization for partons
      enddo
c
!       print*,wtot, alfas,ALS(1,1),ALS(2,1)
!       print*,wtot
      m2s_w2j = wtot *(ALS(1,1)*ALS(2,1))/alfas**2        ! m2s_w2j
c     
      RETURN
      END
ccccccccccccccBegin Subroutine getRes2Q2Gcccccccccccccc
      subroutine getRes2Q2GW(res,fsignq,ip,pdf1,
     $     pdf2,CSAMSQ,Nbos)
      implicit none
!       include 'global.inc'
!       include 'hepup.inc'
#include "VBFNLO/utilities/global.inc"
#include "VBFNLO/utilities/lha.inc"
      integer FL4qcd
      external FL4qcd
c     commom block for diagrammatic labels:
      integer idq,idg !in: dia to pythia labels
      common/diagram/ idq(1:4),idg(1:2)
c
      real*8 res(1:maxNumSubProc)  !out: subprocess cross-sections
      integer fsignq(4)         !in: quark signs
      real*8 pdf1(-6:6),pdf2(-6:6) !in: pdf's
      real*8 CSAMSQ(0:6)        !in: amplitude for W2Q2G-make local
      real*8 POLCOL             ! ave over intial polarizations
      integer ip(1:2) !in: sign to distinguish incident proton or antiproton
      integer Nbos ! 4 for W- process 3 for W+ process 
c     local variables
      logical gluon
      integer colstr,d,u,i,j,k


      integer iflav(1:4)

c
      do colstr = 1,2           !Two color flows.
         do j = 1,2
            d = 2*j - 1         !d,s quarks
            u = d + 1           !u,c quarks
            if(Nbos.eq.4) then ! W- case
               iflav(idq(1)) = d*fsignq(1)
               iflav(idq(2)) = u*fsignq(2)
            elseif(Nbos.eq.3) then ! w+ case
               iflav(idq(1)) = u*fsignq(1)
              iflav(idq(2)) = d*fsignq(2)
            else
               stop
            endif

            iflav(idg(1)) = 21
            iflav(idg(2)) = 21
            k = FL4qcd(iflav(1),iflav(2),iflav(3),iflav(4),colstr)

c  pick polcol
            gluon = (iflav(1).eq.21)
            if(gluon) then      ! two spins 8 colors
               polcol = 1.0d0/(2.0d0 * 8.0d0)
            else
               polcol = 1.0d0/(2.0d0 * 3.0d0)  ! its a quark 
            endif
            gluon = (iflav(2).eq.21)
            if(gluon) then
               polcol = polcol * 1.0d0/(2.0d0 * 8.0d0)
            else
               polcol = polcol * 1.0d0/(2.0d0 * 3.0d0)
            endif
            if(iflav(3).eq.iflav(4)) polcol = polcol/2.0d0
c
c     pick parton distributions
c            write(*,*)'2Q2G sub proc k=',k
            do i = 1,4
               if(iflav(i).eq.21) then
                  iflav(i) = 0  ! pdf label for gluon
               endif
            enddo
            res(k) = CSAMSQ(colstr)*POLCOL*
     $           pdf1(ip(1)*iflav(1))*pdf2(ip(2)*
     $           iflav(2))

         enddo
      enddo
      return
      end
ccccccccccccccccccccccccc end subroutine getRes2Q3G
c
ccccccccccccccBegin Subroutine getRes4Qcccccccccccccc
      subroutine getRes4QW(res,fsignq,ip,pdf1,
     $     pdf2,SQ00,SQ13,SQ24,ifidFLskip,Nbos)
      implicit none
!       include 'global.inc'
!       include 'hepup.inc'
#include "VBFNLO/utilities/global.inc"
#include "VBFNLO/utilities/lha.inc"
      integer FL4qcd
      external FL4qcd
c     commom block for diagrammatic labels:
      integer idq,idg !in: dia to pythia labels
      common/diagram/ idq(1:4),idg(1:2)
c
      real*8 res(1:maxNumSubProc) !out: subprocess cross-sections
      integer fsignq(4) !in: quark signs
      real*8 pdf1(-6:6),pdf2(-6:6) !in: pdf's
      real*8 SQ00(0:4),
     $     SQ13(0:4),SQ24(0:4)  !in: amplitude for W4Q
      real*8 POLCOL, polcol0    ! ave over intial polarizations and colors
      integer ip(1:2) !in: sign to distinguish incident proton or antiproton
      integer Nbos ! 1 for w- ,2 for w+  
c     local variables
      integer colstr,d,u,q,j
      integer L,I,k,N
      integer iflav(1:4)
      logical q1equalq3,q2equalq4,ifidFLskip(1:2),all4Qdiff
      integer abflav(1:4)
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc          
c
      polcol0 = 1.0d0/(4.0d0 * 9.0d0) 
c    


      do j = 1,2
         d = 2*j-1              !d,s quarks
         u = d + 1              !u,c quarks
         do q =1,nfl         ! u,d,s,c,b quarks
            if(Nbos.eq.4) then  ! w- case
               iflav(idq(1)) = d*fsignq(1)
               iflav(idq(2)) = u*fsignq(2)
            elseif(Nbos.eq.3) then ! w+ case
               iflav(idq(1)) = u*fsignq(1)
               iflav(idq(2)) = d*fsignq(2)
            else
               stop
            endif
            
            iflav(idq(3)) = q * fsignq(3)
            iflav(idq(4)) = q * fsignq(4) 
c  pick polcol 
            if(iflav(3).eq.iflav(4)) then
               polcol = polcol0/2.0d0 
            else
               polcol = polcol0
            endif
c  pick amplitude
c
            do N= 1,4           ! absolute value
               abflav(N) = abs(iflav(N))
            enddo
c     
            q1equalq3 = abflav(idq(1)).eq.abflav(idq(3)) .and.
     $                  abflav(idq(2)).ne.abflav(idq(4))
c     
            q2equalq4 = abflav(idq(2)).eq.abflav(idq(4)) .and.
     $                  abflav(idq(1)).ne.abflav(idq(3))
c     
            all4Qdiff = abflav(idq(1)).ne.abflav(idq(3)) .and.
     $                  abflav(idq(2)).ne.abflav(idq(4))
c
            if(q1equalq3) then  ! q1 and q3 are same
               if(ifidFLskip(1)) goto 20
c     
               do colstr = 1,2  ! two color flows
                  k = FL4qcd(iflav(1),iflav(2),iflav(3),iflav(4),colstr)
                  res(k) = POLCOL * SQ13(colstr)

                  res(k) = res(k)*
     $                     pdf1(ip(1)*iflav(1))*pdf2(ip(2)*iflav(2))  
                    
                     
               enddo
            elseif(q2equalq4)  then !q2 and q4 are same
               if(ifidFLskip(2)) goto 20
             
               do colstr = 1,2  ! two color flows
                  k = FL4qcd(iflav(1),iflav(2),iflav(3),iflav(4),colstr)
                  res(k) = POLCOL * SQ24(colstr)

                  res(k) = res(k)*
     $                     pdf1(ip(1)*iflav(1))*pdf2(ip(2)*iflav(2))  
                     
                     
               enddo
            else
               if(all4Qdiff) then
c     
                  k = FL4qcd(iflav(1),iflav(2),iflav(3),iflav(4),1)
                  res(k) = POLCOL * SQ00(1)
                  res(k) = res(k)*
     $                     pdf1(ip(1)*iflav(1))*pdf2(ip(2)*iflav(2))  
                    
               endif
            endif            
 20         continue
         enddo
      enddo
      return
      end
ccccccccccccccccccccccccc end subroutine getRes4Q
