c
c	Dieter Zeppenfeld, <dieter@pheno.physics.wisc.edu>
c       Rob Szalapski, <robs@theory.kek.jp>
c       Terrance Figy, <terrance@pheno.physics.wisc.edu>
c	Initial version:  1995 March 24
c	Last modified:    2001 August 28
c
      real*8 function m2s_w3j(
     &                   bosC,  !in:  Id for W+ or W- or W+- cases
     &                   bosi,  !in:  Id W+ or W- for this particular event
     &                   xi,	!in:  Feynman x parameters of incoming fermions
     &                   p,	!in:  momenta associated with external fermions
     &                   v,	!in:  momenta associated with W decay fermions
     &                   rn!,	!in:  random numbers, first 2 used here
!     &                   qsq    !out:  generated event Q^2
     &                        )
      implicit none

c
c declare input/output variables
c
!       include 'global.inc'
!       include 'hepup.inc'
#include "VBFNLO/utilities/coupl.inc"
#include "VBFNLO/utilities/scales.inc"
#include "VBFNLO/utilities/global.inc"
#include "VBFNLO/utilities/lha.inc"
  
      logical ldebug
      parameter (ldebug = .false.)
cccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c     commom block for diagrammatic labels:
      integer idq,idg
      common/diagram/ idq(1:4),idg(1:3)
ccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      real*8
     $     xi(nx), p(0:3,max_p), v(0:3,max_v), rn(2), qsq
      integer bosi, bosC
c
c declare external functions
c
      integer  FL5qcd
      external FL5qcd
      external getRes4Q1GW
      external getRes2Q3GW
c
c
      real*8
     $     alphas5
      external
     $     alphas5
c  
      integer ProcessNumber
      logical firstTimeThrough
      save firstTimeThrough
      data firstTimeThrough /.true./
      
      logical FLskipid(1:2)     ! for skipping already calculated processes
      logical bquarkoff
      parameter (bquarkoff = .true.)
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c     Variables for use in summation over flavors and what not.

      INTEGER
     $     LFLAVR(6:7), bos, bosii    
      INTEGER
     $     FSIGNQ(4), GSIGN(3), LSIGN(2), I, J, ires_min, ires_max,
     $     numcolor1,colorprocess1,num3gprocs, num4q_gin,nco,colorprocess
      REAL*8
     $     PBARQ(0:3,4), QBAR(0:4,3), LBAR(0:3,2), CSAMSQ(0:6),
     $     PBARQF(0:3,4), QBARF(0:4,3), RES(1:maxnumsubproc),
     $     wtot,w4q,w2g,weight
      Real*8
     $     SQ00(0:4), SQ13(0:4),SQ24(0:4)

c save this
      integer upperbosi,lowerbosi
      save upperbosi,lowerbosi
c
c declare parton distribution variables
c
      real*8
     $     pdf1(-6:6), pdf2(-6:6)
      integer ip(2)
c
ccccccccccccccccccccccccccccccccccccccccc
c
      real*8
     $     qsq_al, qsq_sf, q_sf
!       include 'm2s_vnj.inc'
      ip(1)=sign1
      ip(2)=sign2
ccccccccccccccccccccccccccccccccccccccccc
!       if(.false.) then
!          do i=0,3; do j=1,5
!          print*,'         p(',i,',',j,') = ',p(i,j)
!          enddo; enddo
!          do i=0,3; do j=1,2
!          print*,'         v(',i,',',j,') = ',v(i,j)
!          enddo; enddo
!          print*,'         xi(1) = ',xi(1)
!          print*,'         xi(2) = ',xi(2)
!          print*,'         rn(1) = ',rn(1)
!          print*,'         rn(2) = ',rn(2)
!          print*,'         qsq_sf= ',mufsq(1,1)
!       endif
!       if(.false.) then
!           p(           0 ,           1 ) =    76.760762307919663
!           p(           0 ,           2 ) =    1699.3759774139344
!           p(           0 ,           3 ) =    192.77708463691403
!           p(           0 ,           4 ) =    1289.1171169216102
!           p(           0 ,           5 ) =    90.131272155721760
!           p(           1 ,           1 ) =    0.0000000000000000
!           p(           1 ,           2 ) =    0.0000000000000000
!           p(           1 ,           3 ) =    1.3451431082014993
!           p(           1 ,           4 ) =    32.846142359974081
!           p(           1 ,           5 ) =    69.239599616473498
!           p(           2 ,           1 ) =    0.0000000000000000
!           p(           2 ,           2 ) =    0.0000000000000000
!           p(           2 ,           3 ) =    44.648029946188664
!           p(           2 ,           4 ) =   -62.971269299822019
!           p(           2 ,           5 ) =    57.564858452177759
!           p(           3 ,           1 ) =    76.760762307919663
!           p(           3 ,           2 ) =   -1699.3759774139344
!           p(           3 ,           3 ) =   -187.53065982140257
!           p(           3 ,           4 ) =   -1287.1591553942046
!           p(           3 ,           5 ) =    3.9763220116038029
!           v(           0 ,           1 ) =    129.16084820352327
!           v(           0 ,           2 ) =    74.950417804084765
!           v(           1 ,           1 ) =   -94.297291598184714
!           v(           1 ,           2 ) =   -9.1335934864643633
!           v(           2 ,           1 ) =   -42.120301842115268
!           v(           2 ,           2 ) =    2.8786827435708631
!           v(           3 ,           1 ) =   -77.565621757513199
!           v(           3 ,           2 ) =   -74.336100144497905
!           xi(1) =   1.09658231868456670E-002
!           xi(2) =   0.24276799677341920
!           rn(1) =   8.87832641601562500E-002
!           rn(2) =   0.14288777112960815
!           qsq_sf=    8315.2513440000002
! 
!       endif
      if ( firstTimeThrough ) then
c
         write(6,*) ' '
         write(6,*) 'W3j  amplitude square information:'
         write(6,*) '--------------------------------------------------'
         call printnfl(.true.)
         if(bosC.eq.4) then
            write(6,*)'This is the W- case.'
            upperbosi = 4
            lowerbosi = 4

         elseif(bosC.eq.3) then
            write(6,*)'This is the W+ case.'
            upperbosi = 3
            lowerbosi = 3

         elseif(bosC.eq.34) then
            write(6,*)'This is the W+ and W- case'
            upperbosi = 4 ! upper boson index
            lowerbosi = 3 ! lower boson index

         else
            stop
         endif
!          write(6,*) ' first event at sqrt(s) = ',
!      &           sqrt(4*p(0,1)*p(0,2)/(xi(1)*xi(2)))
         write(6,*) ' '
         if (bquarkoff) write(6,*) ' WARNING: no initial b quarks!! '
c 
         do i = 1,2
            IDBMUP(i) = ip(i)*2212
            EBMUP(i) = p(0,i)/xi(i)
         enddo
         print*,IDBMUP,EBMUP
c
!          call calc_qsq(bosi,firstTimeThrough,def_qsq,p,v,qsq_al,qsq_sf)
c
         if (ldebug) then
            print*,' ip(1),ip(2),bosi = ', ip,bosi,bosC
         endif
!       call calc_qsq(bosi,.false.,def_qsq,p,v,qsq_al,qsq_sf)
      endif
      qsq_sf = mufsq(1,1)
      qsq = qsq_sf
c
c if desired, print output information
c
      if ( ldebug ) then
         write(6,*) ' '
 10      format( ' p(', i1, ') = ', 4(f8.1, 2x) )
 20      format( ' v(', i1, ') = ', 4(f8.1, 2x) )
c
         write(6,*) ' '
         do i = 1, n_p
            write(6,10) i, p(0,i), p(1,i), p(2,i), p(3,i)
         end do
         do i = 1, n_v
            write(6,20) i, v(0,i), v(1,i), v(2,i), v(3,i)
         end do
c
         write(6,*) ' '
         write(6,*) 'xi(1), xi(2) =', xi
         write(6,*) 'event Q^2 =', qsq_sf
      end if
c
c call PDF subroutine in order to determine parton
c distributions in the incoming (anti)protons.
c 
c
      q_sf = sqrt(qsq_sf)
      call pdfproton( xi(1), q_sf, pdf1 )
      do i = -6,6
         pdf1(i) = pdf1(i)/xi(1)
      enddo
c
      call pdfproton( xi(2), q_sf, pdf2 )
      do i = -6,6
         pdf2(i) = pdf2(i)/xi(2)
      enddo
c
      if(bquarkoff) then
         pdf1(5)  = 0
         pdf1(-5) = 0
         pdf2(5)  = 0
         pdf2(-5) = 0
      endif

      if (ldebug) then
         print*,' qsq_al = ',qsq_al,sqrt(qsq_al)
!          print*,' alphas = ',als,' alphas(m_Z) = ',alphas(91.189d0**2)
      endif

ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c    initialize counter in FL4qcd:
 101  if (firstTimeThrough .or. bosC.ne.34) then
         ires_min = FL5qcd(1,1,1,1,1,-100000)+1
         if (firstTimeThrough) then
            ires_max = maxnumsubproc
         else
            ires_max = numcolor1
         endif
      elseif (bosi.eq.3) then                    ! W+  case
         ires_min = FL5qcd(1,1,1,1,1,-100000)+1  ! start at head of color table
         ires_max = numcolor1/2
         upperbosi = bosi
         lowerbosi = bosi
      elseif (bosi.eq.4) then                      ! W-  case
         ires_min = FL5qcd(1,1,1,1,1,-numcolor1/2)+1 ! start in middle of table
         ires_max = numcolor1
         upperbosi = bosi
         lowerbosi = bosi
      endif
      if (ldebug) then
         print*,' ires_min = ',ires_min
         print*,' ires_max = ',ires_max
         print*,' boson loop limits are ',lowerbosi, upperbosi
         print*,' numcolor = ',numcolor,' numcolor1 = ',numcolor1
      endif
c
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
c
c
c
C	FROM JIM, ON 11/8/88
C	MODIFIED  ON 3/24/89 for the new Vjet code
C
C******************************************************************************
C
C	PATCH IN DIETERS SUBROUTINE TO EVALUATE SQUARED MATRIX ELEMENT FOR
C	
C	P P(PBAR) -> W + 3 JETS WITH W -> e nu
C
C*******************************************************************************
c
  
      do bosii = lowerbosi,upperbosi
C FIRST SET UP LEPTON
         IF(bosii.EQ.4) THEN
            LFLAVR(6) = 11      ! nubar
            LFLAVR(7) = 21      ! e
            bos = 40            !VIRTUAL W-
            DO j=0,3
               LBAR(J,1)  = v(j,1) ! nubar (anti-lepton)
               LBAR(J,2)  = v(j,2) ! e (lepton)
            END DO		 
         ELSEIF(bosii.EQ.3) THEN
            LFLAVR(6) = 21      ! e+
            LFLAVR(7) = 11      ! nu     
            BOS = 30            ! VIRTUAL W+
            DO j=0,3
               LBAR(J,1)  = v(j,2) ! e+ (anti-lepton)
               LBAR(J,2)  = v(j,1) ! nu (lepton)
            END DO		 
         ENDIF
c                
         LSIGN(1)  = -1
         LSIGN(2)  =  1
c
C----------------------------------------------------------------------------
         do i = 1,3
            qbar(4,i)  = 0.0d0  ! massless gluons
            qbarf(4,i) = 0.0d0 
         enddo

C--------begin subprocess evaluation-----------------------------------
c     First, use HcSLW2Q
c----------------------------------------------------------------------
c     g1 g2 -> qbar1 q2 g3 w-  diagramatic
c     p1 p2    p3    p4 p5     pythia
c
         if (ldebug) write(*,*)'g1 g2 -> qbar1 q2 g3 w-'
         idq(1) = 3
         idq(2) = 4
         idg(1) = 1
         idg(2) = 2
         idg(3) = 5
c     put my momenta into deiters format
         do j = 0,3
            do i = 1,3
               qbar(j,i) = p(j,idg(i)) ! G in
            enddo
            do i = 1,2
               pbarq(j,i) = p(j,idq(i)) ! qb out
            enddo
         enddo
c  Change momnentum convention:         
         fsignq(1) = -1
         fsignq(2) =  1
         gsign(1)  = -1
         gsign(2)  = -1
         gsign(3)  =  1

         call HcSLW2Q('R',rn(1),3,pbarq,fsignq,qbar,
     $        gsign,bos,lbar,lsign,lflavr,csamsq)

         call getRes2Q3GW(res,fsignq,ip,pdf1,pdf2,csamsq,bosii)
         if (ldebug) then
            do i=ires_min,numcolor
               write(6,511) i,res(i)
            enddo
            nco = numcolor+1
            print*,' ires_min = ',ires_min
            print*,' ires_max = ',ires_max
            !pause
         endif
 511     format(4hres(,i4,4h) = ,g14.4)
c----------------------------------------------------------------------
c     q1 qbar2 -> g1 g2 g3 w- diagramatic
c     p1 p2       p3 p4 p5    pythia
c
         if (ldebug) write(*,*) 'q1 qbar2 -> g1 g2 g3 w-'
         idq(1) = 1
         idq(2) = 2
         idg(1) = 3
         idg(2) = 4
         idg(3) = 5
c     put my momenta into dieters format
         do j = 0,3
            do i = 1,3
               qbar(j,i)   = p(j,idg(i)) ! G 
            enddo
            do i = 1,2
               pbarq(j,i)   = p(j,idq(i)) ! Q
            enddo
         enddo
         
         fsignq(1) =  1
         fsignq(2) = -1
         gsign(1)  =  1
         gsign(2)  =  1
         gsign(3)  =  1
        
         call HcSLW2Q('R',rn(1),3,pbarq,fsignq,qbar,
     $        gsign,bos,lbar,lsign,lflavr,csamsq)
         call getRes2Q3GW(res,fsignq,ip,pdf1,pdf2,csamsq,bosii)
         if (ldebug) then
            do i=nco,numcolor
               write(6,511) i,res(i)
            enddo
            nco = numcolor+1
         endif
c    
         idq(1) = 2
         idq(2) = 1
c
         do j = 0,3
            do i = 1,2
               pbarqf(j,i) = p(j,idq(i))
            enddo
         enddo
c
         call HcSLW2Q('R',rn(1),3,pbarqf,fsignq,qbar,
     $        gsign,bos,lbar,lsign,lflavr,csamsq)
         call getRes2Q3GW(res,fsignq,ip,pdf1,pdf2,csamsq,bosii)
         if (ldebug) then
            do i=nco,numcolor
               write(6,511) i,res(i)
            enddo
            nco = numcolor+1
         endif
c----------------------------------------------------------------------
c     g1 q1 -> q2 g2 g3 w- diagram
c     p1 p2    p3 p4 p5    pythia
         if (ldebug) write(*,*)'g1 q1 -> q2 g2 g3 w- '
         idq(1) = 2
         idq(2) = 3
         idg(1) = 1
         idg(2) = 4
         idg(3) = 5
c     put my momenta into dieters format
          do j = 0,3
             do i = 1,3
                qbar(j,i)   = p(j,idg(i)) ! G in
             enddo
            
            do i = 1,2
               pbarq(j,i)  = p(j,idq(i)) ! Q in
            enddo
           
         enddo
         
         fsignq(1) =  1
         fsignq(2) =  1
         gsign(1)  = -1
         gsign(2)  =  1
         gsign(3)  =  1
        
        
         call HcSLW2Q('R',rn(1),3,pbarq,fsignq,qbar,
     $        gsign,bos,lbar,lsign,lflavr,csamsq)
         call getRes2Q3GW(res,fsignq,ip,pdf1,pdf2,csamsq,bosii)
         if (ldebug) then
            do i=nco,numcolor
               write(6,511) i,res(i)
            enddo
            nco = numcolor+1
         endif
c    
         idq(1) = 1
         idg(1) = 2
c
         do j = 0,3
            do i = 1,3
               qbarf(j,i)   = p(j,idg(i)) ! G in
            enddo
            
            do i = 1,2
               pbarqf(j,i)  = p(j,idq(i)) ! Q in
            enddo
         enddo
c
         call HcSLW2Q('R',rn(1),3,pbarqf,fsignq,qbarf,
     $        gsign,bos,lbar,lsign,lflavr,csamsq)
         call getRes2Q3GW(res,fsignq,ip,pdf1,pdf2,csamsq,bosii)
         if (ldebug) then
            do i=nco,numcolor
               write(6,511) i,res(i)
            enddo
            nco = numcolor+1
         endif
c----------------------------------------------------------------------
c     g1 qbar2 -> qbar1 g2 g3 w-
c     p1 p2       p3    p4 p5
         if (ldebug) write(*,*)'g1 qbar2 -> qbar1 g2 g3 w-'
         idq(1) = 3
         idq(2) = 2 ! -> 1
         idg(1) = 1 ! -> 2
         idg(2) = 4
         idg(3) = 5
c     put my momenta into dieters format
         do j = 0,3
            do i = 1,3
               qbar(j,i)   = p(j,idg(i)) ! G in
            enddo
            do i = 1,2
               pbarq(j,i)  = p(j,idq(i)) ! Qbar out
            enddo           
         enddo
         
         fsignq(1) = -1
         fsignq(2) = -1
         gsign(1)  = -1
         gsign(2)  =  1
         gsign(3)  =  1
        
         call HcSLW2Q('R',rn(1),3,pbarq,fsignq,qbar,
     $        gsign,bos,lbar,lsign,lflavr,csamsq)
         call getRes2Q3GW(res,fsignq,ip,pdf1,pdf2,csamsq,bosii)
         if (ldebug) then
            do i=nco,numcolor
               write(6,511) i,res(i)
            enddo
            nco = numcolor+1
         endif
c    
         idq(2) = 1
         idg(1) = 2
c
         do j = 0,3
            do i = 1,3
               qbarf(j,i)   = p(j,idg(i)) ! G in
            enddo
            do i = 1,2
               pbarqf(j,i)  = p(j,idq(i)) ! Qbar out
            enddo
         enddo
c
         call HcSLW2Q('R',rn(1),3,pbarqf,fsignq,qbarf,
     $        gsign,bos,lbar,lsign,lflavr,csamsq)
         call getRes2Q3GW(res,fsignq,ip,pdf1,pdf2,csamsq,bosii)      
         if (ldebug) then
            do i=nco,numcolor
               write(6,511) i,res(i)
            enddo
            nco = numcolor+1
         endif
         
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c                         end 2q3g subprocesses  
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
         num3gprocs = numcolor  ! number of 2q3g subprocesses    
c----------------------------------------------------------------------
c     Next use L4Q1G
c     initialize FLskipid logical: the default is .false.
         FLskipid(1) = .false.  ! SQ13 true = process done already
         FLskipid(2) = .false.  ! SQ24 false = process not done yet
c     Classifications according to Z.&H.'s paper: MAD/PH/402
c     Class(1):
c     q1 qbar2 -> qb3 q4 g  w-  diagram
c     p1 p2       p3  p4 p5     pythia
c   
         if(ldebug) write(*,*) 'q1 qbar2 -> qb3 q4 g  w- '
         idq(1) = 1 ! -> 2
         idq(2) = 2 ! -> 1
         idq(3) = 3
         idq(4) = 4
         idg(1) = 5
c     Put my momenta in Dieter's format
         do j = 0,3
            do i = 1,4
               pbarq(j,i) = p(j,idq(i)) ! Q in
            enddo
            qbar(j,1)  = p(j,5) ! g out
         enddo
         
         fsignq(1) =  1
         fsignq(2) = -1
         fsignq(3) = -1
         fsignq(4) =  1
         
         gsign(1) = 1

         call ScLW4QG('R',rn(1),pbarq,fsignq,qbar,gsign,bos,
     $        lbar,lsign,lflavr,sq00,sq13,sq24)
        
         call getRes4Q1GW(res,fsignq,ip,pdf1,pdf2,
     $        SQ00,SQ13,SQ24,FLskipid,bosii)
         if (ldebug) then
            !pause
            print*,' class1 ',numcolor-nco+1
            do i=nco,numcolor
               write(6,511) i,res(i)
            enddo
            nco = numcolor+1
         endif
c
         idq(1) = 2
         idq(2) = 1
c     
         do j = 0,3
            do i = 1,4
               pbarqf(j,i) = p(j,idq(i)) ! Q in
            enddo
         enddo
c
         call ScLW4QG('R',rn(1),pbarqf,fsignq,qbar,gsign,bos,
     $         lbar,lsign,lflavr,sq00,sq13,sq24)

         call getRes4Q1GW(res,fsignq,ip,pdf1,pdf2,
     $         SQ00,SQ13,SQ24,FLskipid,bosii)
         if (ldebug) then
            print*,' class1, flipped ',numcolor-nco+1
            do i=nco,numcolor
               write(6,511) i,res(i)
            enddo
            nco = numcolor+1
            !pause
         endif

c----------------------------------------------------------------------
c     Class(2):
c     q3 qbar4 -> qb1 q2 g  w-  diagram
c     p1 p2       p3  p4 p5     pythia
c   
         if(ldebug) write(*,*) 'q3 qbar4 -> qb1 q2 g  w- '
         idq(1) = 3
         idq(2) = 4
         idq(3) = 1             !->2
         idq(4) = 2             !->1
         idg(1) = 5
c     Put my momenta in Dieter's format
         do j = 0,3
            do i = 1,4
               pbarq(j,i) = p(j,idq(i)) ! Qbar out
            enddo
         enddo
         
         fsignq(1) = -1
         fsignq(2) =  1
         fsignq(3) =  1
         fsignq(4) = -1

         call ScLW4QG('R',rn(1),pbarq,fsignq,qbar,gsign,bos,
     $         lbar,lsign,lflavr,sq00,sq13,sq24)
         call getRes4Q1GW(res,fsignq,ip,pdf1,pdf2,
     $         SQ00,SQ13,SQ24,FLskipid,bosii)
         if (ldebug) then
            print*,' class2 ',numcolor-nco+1
            do i=nco,numcolor
               write(6,511) i,res(i)
            enddo
            nco = numcolor+1
         endif
c     
         idq(3) = 2
         idq(4) = 1
c 
         do j = 0,3
            do i = 1,4
               pbarqf(j,i) = p(j,idq(i)) ! Qbar out
            enddo
         enddo
      
         call ScLW4QG('R',rn(1),pbarqf,fsignq,qbar,gsign,bos,
     $         lbar,lsign,lflavr,sq00,sq13,sq24)
         call getRes4Q1GW(res,fsignq,ip,pdf1,pdf2,
     $         SQ00,SQ13,SQ24,FLskipid,bosii)
         if (ldebug) then
            print*,' class2, flipped ',numcolor-nco+1
            do i=nco,numcolor
               write(6,511) i,res(i)
            enddo
            nco = numcolor+1
            !pause
         endif
c----------------------------------------------------------------------
c     Class(3):
c     q1 q3 -> q2  q4  g  w-  diagram
c     p1 p2    p3  p4  p5     pythia
c   
         if(ldebug) write(*,*)'q1 q3 -> q2  q4  g  w- '
         idq(1) = 1             !->2
         idq(2) = 3
         idq(3) = 2             !->1
         idq(4) = 4
         idg(1) = 5
c     Put my momenta in Dieter's format
         do j = 0,3
            do i =1,4
               pbarq(j,i) = p(j,idq(i)) ! Q1 in
            enddo
         enddo
          
         fsignq(1) =  1
         fsignq(2) =  1
         fsignq(3) =  1
         fsignq(4) =  1

         call ScLW4QG('R',rn(1),pbarq,fsignq,qbar,gsign,bos,
     $         lbar,lsign,lflavr,sq00,sq13,sq24)
         call getRes4Q1GW(res,fsignq,ip,pdf1,pdf2,
     $         SQ00,SQ13,SQ24,FLskipid,bosii)
         if (ldebug) then
            print*,' class3 ',numcolor-nco+1
            do i=nco,numcolor
               write(6,511) i,res(i)
            enddo
            nco = numcolor+1
         endif
c     
         idq(1) = 2
         idq(3) = 1
c 
         do j = 0,3
            do i =1,4
               pbarqf(j,i) = p(j,idq(i)) ! Q1 in
            enddo
         enddo
          
         call ScLW4QG('R',rn(1),pbarqf,fsignq,qbar,gsign,bos,
     $         lbar,lsign,lflavr,sq00,sq13,sq24)
c
         FLskipid(1) = .true.
c
         call getRes4Q1GW(res,fsignq,ip,pdf1,pdf2,
     $         SQ00,SQ13,SQ24,FLskipid,bosii)
         if (ldebug) then
            print*,' class3, flipped ',numcolor-nco+1
            do i=nco,numcolor
               write(6,511) i,res(i)
            enddo
            nco = numcolor+1
            !pause
         endif
c----------------------------------------------------------------------
c     Class(4):
c     q1 qb4 -> q2  qb3  g  w-  diagram
c     p1 p2     p3  p4   p5     pythia
c   
         if(ldebug) write(*,*) 'q1 qb4 -> q2  qb3  g  w- '
         idq(1) = 1             !->2
         idq(2) = 3
         idq(3) = 4 
         idq(4) = 2             !->1
         idg(1) = 5
c     Put my momenta in Dieter's format
         do j = 0,3
            do i =1,4
               pbarq(j,i) = p(j,idq(i)) ! Q1 in
            enddo
         enddo
         
         fsignq(1) =  1
         fsignq(2) =  1
         fsignq(3) = -1
         fsignq(4) = -1
c   
         call ScLW4QG('R',rn(1),pbarq,fsignq,qbar,gsign,bos,
     $        lbar,lsign,lflavr,sq00,sq13,sq24)
c
         FLskipid(1) = .true.
         FLskipid(2) = .true.
c
         call getRes4Q1GW(res,fsignq,ip,pdf1,pdf2,
     $        SQ00,SQ13,SQ24,FLskipid,bosii)
         if (ldebug) then
            print*,' class4 ',numcolor-nco+1
            do i=nco,numcolor
               write(6,511) i,res(i)
            enddo
            nco = numcolor+1
         endif
c
         idq(1) = 2
         idq(4) = 1
c  
         do j = 0,3
            do i =1,4
               pbarqf(j,i) = p(j,idq(i)) ! Q1 in
            enddo
         enddo  
  
         call ScLW4QG('R',rn(1),pbarqf,fsignq,qbar,gsign,bos,
     $        lbar,lsign,lflavr,sq00,sq13,sq24)
         call getRes4Q1GW(res,fsignq,ip,pdf1,pdf2,
     $        SQ00,SQ13,SQ24,FLskipid,bosii)
         if (ldebug) then
            print*,' class4, flipped ',numcolor-nco+1
            do i=nco,numcolor
               write(6,511) i,res(i)
            enddo
            nco = numcolor+1
            !pause
         endif
c----------------------------------------------------------------------
c     Class(5):
c     qbar2 q3 -> qbar1 q4 g  diagram
c     p1    p2     p3   p4 p5     pythia
c   
         if(ldebug) write(*,*)'qbar2 q3 -> qbar1 q4 g ' 
         idq(1) = 3
         idq(2) = 1
         idq(3) = 2
         idq(4) = 4
         idg(1) = 5
c     Put my momenta in Dieter's format
         do j = 0,3
            do i =1,4
               pbarq(j,i) = p(j,idq(i)) ! Q1 in
            enddo
         enddo
         
         fsignq(1) = -1
         fsignq(2) = -1
         fsignq(3) =  1
         fsignq(4) =  1

         call ScLW4QG('R',rn(1),pbarq,fsignq,qbar,gsign,bos,
     $        lbar,lsign,lflavr,sq00,sq13,sq24)
c
         FLskipid(1) = .true.
         FLskipid(2) = .true.
c
         call getRes4Q1GW(res,fsignq,ip,pdf1,pdf2,
     $        SQ00,SQ13,SQ24,FLskipid,bosii)
         if (ldebug) then
            print*,' class5 ',numcolor-nco+1
            do i=nco,numcolor
               write(6,511) i,res(i)
            enddo
            nco = numcolor+1
         endif
c
         idq(2) = 2
         idq(3) = 1
c
         do j = 0,3
            do i =1,4
               pbarqf(j,i) = p(j,idq(i)) ! Q1 in
            enddo
         enddo
  
         call ScLW4QG('R',rn(1),pbarqf,fsignq,qbar,gsign,bos,
     $         lbar,lsign,lflavr,sq00,sq13,sq24)
         call getRes4Q1GW(res,fsignq,ip,pdf1,pdf2,
     $         SQ00,SQ13,SQ24,FLskipid,bosii)
         if (ldebug) then
            print*,' class5, flipped ',numcolor-nco+1
            do i=nco,numcolor
               write(6,511) i,res(i)
            enddo
            nco = numcolor+1
            !pause
         endif
c----------------------------------------------------------------------
c     Class(6):
c     qbar2 qb4 -> qbar1 qb3 g  diagram
c     p1    p2     p3    p4  p5     pythia
c   
         if(ldebug) write(*,*) 'qbar2 qb4 -> qbar1 qb3 g'
         idq(1) = 3
         idq(2) = 1
         idq(3) = 4
         idq(4) = 2
         idg(1) = 5
c     Put my momenta in Dieter's format
         do j = 0,3
            do i =1,4
               pbarq(j,i) = p(j,idq(i)) ! Q1 in
            enddo
         enddo
         
         fsignq(1) = -1
         fsignq(2) = -1
         fsignq(3) = -1
         fsignq(4) = -1
          
         call ScLW4QG('R',rn(1),pbarq,fsignq,qbar,gsign,bos,
     $         lbar,lsign,lflavr,sq00,sq13,sq24)
c
         FLskipid(1) = .false.
         FLskipid(2) = .false.
c
         call getRes4Q1GW(res,fsignq,ip,pdf1,pdf2,
     $         SQ00,SQ13,SQ24,FLskipid,bosii)
         if (ldebug) then
            print*,' class6  ',numcolor-nco+1
            do i=nco,numcolor
               write(6,511) i,res(i)
            enddo
            nco = numcolor+1
         endif
c     
         idq(2) = 2
         idq(4) = 1
c
         do j = 0,3
            do i =1,4
               pbarqf(j,i) = p(j,idq(i)) ! Q1 in
            enddo
         enddo
c
         call ScLW4QG('R',rn(1),pbarqf,fsignq,qbar,gsign,bos,
     $         lbar,lsign,lflavr,sq00,sq13,sq24)
c
         FLskipid(1) = .false.
         FLskipid(2) = .true.
c 
         call getRes4Q1GW(res,fsignq,ip,pdf1,pdf2,
     $         SQ00,SQ13,SQ24,FLskipid,bosii)
         if (ldebug) then
            print*,' class6, flipped ',numcolor-nco+1
            do i=nco,numcolor
               write(6,511) i,res(i)
            enddo
            nco = numcolor+1
            !pause
         endif
c
         FLskipid(2) = .false.
         num4q_gin = numcolor
c
c          write(*,*) 'idq=',idq
c          write(*,*) 'idg=',idg
c----------------------------------------------------------------------
c     New channels, gq --> qqq W-
c     Class(7):
c     g  q1 --> q2 qb3 q4 w-  diagram
c     p1 p2     p3 p4  p5     pythia
c   
         if(ldebug) write(*,*) ' g  q1 --> q2 qb3 q4 w- '
         idq(1) = 2             !->1
         idq(2) = 3
         idq(3) = 4
         idq(4) = 5
         idg(1) = 1 !->2
c     Put my momenta in Dieter's format
         do j = 0,3
            qbar(j,1)  = p(j,idg(1)) ! g in (done once)
            do i = 1,4
               pbarq(j,i) = p(j,idq(i)) ! Q1 in
            enddo
         enddo
         
         fsignq(1) =  1
         fsignq(2) =  1
         fsignq(3) = -1
         fsignq(4) =  1

         gsign(1)  = -1 ! done once
         
         call ScLW4QG('R',rn(1),pbarq,fsignq,qbar,gsign,bos,
     $        lbar,lsign,lflavr,sq00,sq13,sq24)
c
         call getRes4Q1GW(res,fsignq,ip,pdf1,pdf2,
     $        SQ00,SQ13,SQ24,FLskipid,bosii)
         if (ldebug) then
            print*,' class7 ',numcolor-nco+1
            do i=nco,numcolor
               write(6,511) i,res(i)
            enddo
            nco = numcolor+1
         endif
c
         idg(1) = 2
         idq(1) = 1
         idq(2) = 3
         idq(3) = 4
         idq(4) = 5
c     
         do j = 0,3
c            write(*,*) 'idg=',idg
            qbarf(j,1)  = p(j,idg(1)) ! g in (done once)
            do i = 1,4
c               write(*,*)'idq=',idq
               pbarqf(j,i) = p(j,idq(i)) ! Q1 in
            enddo
         enddo
        
         call ScLW4QG('R',rn(1),pbarqf,fsignq,qbarf,gsign,bos,
     $        lbar,lsign,lflavr,sq00,sq13,sq24)
         call getRes4Q1GW(res,fsignq,ip,pdf1,pdf2,
     $        SQ00,SQ13,SQ24,FLskipid,bosii)
         if (ldebug) then
            print*,' class7, flipped ',numcolor-nco+1
            do i=nco,numcolor
               write(6,511) i,res(i)
            enddo
            nco = numcolor+1
            !pause
         endif
c----------------------------------------------------------------------
c     Class(8)
c     g  q3 --> qb1 q2 q4 w-  diagram
c     p1 p2     p3  p4 p5     pythia
c   
         idq(1) = 3
         idq(2) = 4
         idq(3) = 2 !->1
         idq(4) = 5
         idg(1) = 1 !->2
c     Put my momenta in Dieter's format
         do j = 0,3
            qbar(j,1)  = p(j,idg(1)) ! g in (done once)
            do i = 1,4
               pbarq(j,i) = p(j,idq(i)) ! Q1 in
            enddo
         enddo
 
         
         fsignq(1) = -1
         fsignq(2) =  1
         fsignq(3) =  1
         fsignq(4) =  1
         
         gsign(1) = -1

         call ScLW4QG('R',rn(1),pbarq,fsignq,qbar,gsign,bos,
     $        lbar,lsign,lflavr,sq00,sq13,sq24)
c
         FLskipid(1)=.true.
c
         call getRes4Q1GW(res,fsignq,ip,pdf1,pdf2,
     $        SQ00,SQ13,SQ24,FLskipid,bosii)
         if (ldebug) then
            print*,' class8 ',numcolor-nco+1
            do i=nco,numcolor
               write(6,511) i,res(i)
            enddo
            nco = numcolor+1
         endif
c
         idg(1) = 2
         idq(3) = 1
c     
         do j = 0,3
            qbarf(j,1)  = p(j,idg(1)) ! g in (done once)
            do i = 1,4
               pbarqf(j,i) = p(j,idq(i)) ! Q1 in
            enddo
         enddo
c     
    
         call ScLW4QG('R',rn(1),pbarqf,fsignq,qbarf,gsign,bos,
     $         lbar,lsign,lflavr,sq00,sq13,sq24)
         call getRes4Q1GW(res,fsignq,ip,pdf1,pdf2,
     $         SQ00,SQ13,SQ24,FLskipid,bosii)
         if (ldebug) then
            print*,' class8, flipped ',numcolor-nco+1
            do i=nco,numcolor
               write(6,511) i,res(i)
            enddo
            nco = numcolor+1
            !pause
         endif
c
         FLskipid(1)=.false.
         FLskipid(2)=.false.
c---------------------------------------------------------------------
c     Class(9):
c     g  qb2 --> qb1 qb3 q4 w-  diagram
c     p1 p2      p3  p4  p5     pythia
c   
         idq(1) = 3
         idq(2) = 2 !->1
         idq(3) = 4
         idq(4) = 5
         idg(1) = 1 !->2

c     Put my momenta in Dieter's format
         do j = 0,3
            qbar(j,1)  = p(j,idg(1)) ! g in (done once)
            do i = 1,4
               pbarq(j,i) = p(j,idq(i)) ! Q1 in
            enddo
         enddo
        
         
         fsignq(1) = -1
         fsignq(2) = -1
         fsignq(3) = -1
         fsignq(4) =  1

         gsign(1) = -1
         
         call ScLW4QG('R',rn(1),pbarq,fsignq,qbar,gsign,bos,
     $        lbar,lsign,lflavr,sq00,sq13,sq24)
         call getRes4Q1GW(res,fsignq,ip,pdf1,pdf2,
     $        SQ00,SQ13,SQ24,FLskipid,bosii)
         if (ldebug) then
            print*,' class9 ',numcolor-nco+1
            do i=nco,numcolor
               write(6,511) i,res(i)
            enddo
            nco = numcolor+1
         endif
c
         idg(1) = 2
         idq(2) = 1
c
         do j = 0,3
            qbarf(j,1)  = p(j,idg(1)) ! g in (done once)
c             write(*,*) 'qbarf = ',qbarf(j,1)
            do i = 1,4
               pbarqf(j,i) = p(j,idq(i)) ! Q1 in
c                write(*,*) 'pbarqf=',pbarqf(j,i)
            enddo
         enddo

         call ScLW4QG('R',rn(1),pbarqf,fsignq,qbarf,gsign,bos,
     $         lbar,lsign,lflavr,sq00,sq13,sq24)
         call getRes4Q1GW(res,fsignq,ip,pdf1,pdf2,
     $         SQ00,SQ13,SQ24,FLskipid,bosii)
         if (ldebug) then
            print*,' class9, flipped ',numcolor-nco+1
            do i=nco,numcolor
               write(6,511) i,res(i)
            enddo
            nco = numcolor+1
            !pause
         endif
c---------------------------------------------------------------------
c     Class(10):
c     g  qb4 --> qb1 q2 qb3 w-  diagram
c     p1 p2      p3  p4 p5     pythia
c   
         idq(1) = 3
         idq(2) = 4
         idq(3) = 5
         idq(4) = 2 !->1
         idg(1) = 1 !->2

c     Put my momenta in Dieter's format
         do j = 0,3
            qbar(j,1)  = p(j,idg(1)) ! g in (done once)
            do i = 1,4
               pbarq(j,i) = p(j,idq(i)) ! Q1 in
            enddo
         enddo
         
         
         fsignq(1) = -1
         fsignq(2) = 1
         fsignq(3) = -1
         fsignq(4) = -1

         gsign(1) = -1

         call ScLW4QG('R',rn(1),pbarq,fsignq,qbar,gsign,bos,
     $        lbar,lsign,lflavr,sq00,sq13,sq24)
c
         FLskipid(2) = .true.
c
         call getRes4Q1GW(res,fsignq,ip,pdf1,pdf2,
     $        SQ00,SQ13,SQ24,FLskipid,bosii)
         if (ldebug) then
            print*,' class10 ',numcolor-nco+1
            do i=nco,numcolor
               write(6,511) i,res(i)
            enddo
            nco = numcolor+1
         endif
c
         idg(1) = 2
         idq(4) = 1
c
         do j = 0,3
            qbarf(j,1)  = p(j,idg(1)) ! g in (done once)
            do i = 1,4
               pbarqf(j,i) = p(j,idq(i)) ! Q1 in
            enddo
         enddo
c
         call ScLW4QG('R',rn(1),pbarqf,fsignq,qbarf,gsign,bos,
     $         lbar,lsign,lflavr,sq00,sq13,sq24)
         call getRes4Q1GW(res,fsignq,ip,pdf1,pdf2,
     $         SQ00,SQ13,SQ24,FLskipid,bosii)
         if (ldebug) then
            print*,' class10, flipped ',numcolor-nco+1
            do i=nco,numcolor
               write(6,511) i,res(i)
            enddo
         endif
c
         FLskipid(2) = .false.
c
C--------end subprocess evaluation-------------------------------------
         if(ldebug) then
            write(6,*) 'number of subprocesses = ',numcolor
            write(6,*) 'number of decay channels = ',numdecay
            print*,' 3 gluon processes: ',num3gprocs
            print*,' 4 quark processes: ',num4q_gin-num3gprocs
            print*,' gQ-->3Q processes: ',numcolor-num4q_gin
         endif

      enddo
c--------------end loop over W+/W- bosons------------------------------
c     Pick a subprocess
c---------------------------------------------------------------------- 
      if (firstTimeThrough) then
         write(6,*) 'number of subprocesses = ',numcolor
         write(6,*) 'number of decay channels = ',numdecay
         if (bosC.ne.34) then
            print*,' 2 gluon processes: ',num3gprocs
            print*,' 4 quark processes: ',numcolor-num3gprocs
         endif
         numcolor1 = numcolor
!          call writeHEPUPtable
         firstTimeThrough = .false.
         goto 101
      endif
      if (ldebug) then
         write(*,*) 'ires_min=',ires_min
         write(*,*) 'ires_max=',ires_max
      endif
      wtot = 0.0d0
      do i = ires_min,ires_max
         wtot = wtot + res(i)
      enddo
!       print*,'wtot: ',wtot
!       print*
!       print*
!       stop
      
      ColorProcess=0
      weight=0.0d0
      i = ires_min
      do while((i.le.ires_max).and.(ColorProcess.eq.0))
         weight = weight + res(i)/wtot
         if(weight.ge.rn(2)) then
            ColorProcess = i
         endif
         i = i+1
      enddo
c     
c  Fill in rest of HEPEUP common block
      colorprocess1 = colorprocess + numdecay
c
      scalup = q_sf
      AQEDUP = ALPHA
      AQCDUP = ALS(1,1)
      
!       do i=1,n_p
!         idup(i)=lidup(i,ColorProcess1)
!         istup(i)=listup(i,ColorProcess1)
!         mothup(1,i)=lmothup(1,i,ColorProcess1)
!         mothup(2,i)=lmothup(2,i,ColorProcess1)
!         icolup(1,i)=licolup(1,i,ColorProcess1)
!         icolup(2,i)=licolup(2,i,ColorProcess1)
!         spinup(i)=9                          ! no polarization for partons
!       enddo
c
    
      m2s_w3j = wtot *(ALS(1,1)/alfas)**3        ! m2s_w3j
c   
      if (ldebug) then
         write(*,*)'m2s_w3j = ',m2s_w3j
         !pause 
      endif
      RETURN
      END
ccccccccccccccBegin Subroutine getRes2Q3Gcccccccccccccc
      subroutine getRes2Q3GW(res,fsignq,ip,pdf1,
     $     pdf2,CSAMSQ,Nbos)
      implicit none
!       include 'global.inc'
#include "VBFNLO/utilities/global.inc"
#include "VBFNLO/utilities/lha.inc"
      integer  FL5qcd
      external FL5qcd
      external calpolcol
c     commom block for diagrammatic labels:
      integer idq,idg !in: dia to pythia labels
      common/diagram/ idq(1:4),idg(1:3)
c
      real*8 res(1:maxNumSubProc)  !out: subprocess cross-sections
      integer fsignq(4)         !in: quark signs
      real*8 pdf1(-6:6),pdf2(-6:6) !in: pdf's
      real*8 CSAMSQ(0:6)        !in: amplitude for W2Q2G-make local
      integer ip(1:2) !in: sign to distinguish incident proton or antiproton
      integer Nbos ! 4 for W- process 3 for W+ process 
c     local variables
      logical gluon, ldebug
      parameter (ldebug=.false.)
      integer colstr,d,u,i,j,k

      integer iflav(1:5)
      
      double precision polcol(2000)
      common /polcolz/ polcol

      do colstr = 1,6           !six color flows.
         do j = 1,2
            d = 2*j - 1         !d,s quarks
            u = d + 1           !u,c quarks
            if(Nbos.eq.4) then  ! W- case
               iflav(idq(1)) = d*fsignq(1)
               iflav(idq(2)) = u*fsignq(2)
            elseif(Nbos.eq.3) then ! w+ case
               iflav(idq(1)) = u*fsignq(1)
               iflav(idq(2)) = d*fsignq(2)
            else
               stop
            endif
c
            iflav(idg(1)) = 21
            iflav(idg(2)) = 21
            iflav(idg(3)) = 21
            k = FL5qcd(iflav(1),iflav(2),iflav(3),iflav(4),
     $           iflav(5),colstr)
c
c     pick parton distributions
            if (ldebug) write(*,*)'2Q3G sub proc k=',k
            do i = 1,5
               if(iflav(i).eq.21) then
                  iflav(i) = 0  ! pdf label for gluon
               endif
            enddo
               res(k) = CSAMSQ(colstr)*POLCOL(k)*
     $              pdf1(ip(1)*iflav(1)) * pdf2(ip(2)*iflav(2))
            enddo
         enddo
      end
ccccccccccccccccccccccccc end subroutine getRes2Q3GW
c
ccccccccccccccBegin Subroutine getRes4Q1Gcccccccccccccc
      subroutine getRes4Q1GW(res,fsignq,ip,pdf1,
     $     pdf2,SQ00,SQ13,SQ24,ifidFLskip,Nbos)
      implicit none
!       include 'global.inc'
!       include 'hepup.inc'
#include "VBFNLO/utilities/global.inc"
#include "VBFNLO/utilities/lha.inc"
      integer  FL5qcd
      external FL5qcd
      external calpolcol
c     commom block for diagrammatic labels:
      integer idq,idg !in: dia to pythia labels
      common/diagram/ idq(1:4),idg(1:3)
c
      real*8 res(1:maxNumSubProc) !out: subprocess cross-sections
      integer fsignq(4) !in: quark signs
      real*8 pdf1(-6:6),pdf2(-6:6) !in: pdf's
      real*8 SQ00(0:4),
     $     SQ13(0:4),SQ24(0:4)  !in: amplitude for W4Q
      integer ip(1:2) !in: sign to distinguish incident proton or antiproton
      integer Nbos ! 4 for w- ,3 for w+  
c     local variables
      integer colstr,d,u,q,j
!       integer nflavs
!       parameter(nflavs = 4)     ! 4 or 5 number of flavors
      integer L,I,k,N,M
     
      integer iflav(1:5)
      logical q1equalq3,q2equalq4,ifidFLskip(1:2),all4Qdiff, ldebug
      parameter (ldebug=.false.)
      integer abflav(1:5),lflav(1:5)
      
      double precision polcol(2000)
      common /polcolz/ polcol
c     
      do j = 1,2
         d = 2*j-1              !d,s quarks
         u = d + 1              !u,c quarks
         do q =1,nfl         ! u,d,s,c,b quarks

            if(Nbos.eq.4) then  ! w- case
               iflav(idq(1)) = d*fsignq(1)
               iflav(idq(2)) = u*fsignq(2)
            elseif(Nbos.eq.3) then ! w+ case
               iflav(idq(1)) = u*fsignq(1)
               iflav(idq(2)) = d*fsignq(2)
            else
               stop
            endif
c
            iflav(idq(3)) = q * fsignq(3)
            iflav(idq(4)) = q * fsignq(4)
            iflav(idg(1)) = 21

c     pick amplitude
c
            do N= 1,5
               abflav(N) = abs(iflav(N))      ! absolute value
               lflav(N)  = iflav(N)           ! local flavour
            enddo
c     
            q1equalq3 = abflav(idq(1)).eq.abflav(idq(3)) .and.
     $                  abflav(idq(2)).ne.abflav(idq(4))
c     
            q2equalq4 = abflav(idq(2)).eq.abflav(idq(4)) .and.
     $                  abflav(idq(1)).ne.abflav(idq(3))
c     
            all4Qdiff = abflav(idq(1)).ne.abflav(idq(3)) .and.
     $                  abflav(idq(2)).ne.abflav(idq(4))
c
            if(q1equalq3) then  ! q1 and q3 are same
               if(ifidFLskip(1)) goto 20
c     
               do colstr = 1,4  ! 4 color flows
                  k = FL5qcd(iflav(1),iflav(2),iflav(3),iflav(4),
     $                       iflav(5),colstr)
                  do m = 1,2
                     if(lflav(m).eq.21) lflav(m) = 0
                  enddo
                  res(k) = POLCOL(k) * SQ13(colstr) *
     $                     pdf1(ip(1)*lflav(1))*pdf2(ip(2)*lflav(2))  
               enddo
            elseif(q2equalq4)  then !q2 and q4 are same
               if(ifidFLskip(2)) goto 20
c             
               do colstr = 1,4  ! 4 color flows
                  k = FL5qcd(iflav(1),iflav(2),iflav(3),iflav(4),
     $                       iflav(5),colstr)
                  do m = 1,2
                     if(lflav(m).eq.21) lflav(m) = 0
                  enddo
                  res(k) = POLCOL(k) * SQ24(colstr) *
     $                     pdf1(ip(1)*lflav(1))*pdf2(ip(2)*lflav(2))  
               enddo
            else
               if(all4Qdiff) then
c
                  do colstr = 1,4
                     k = FL5qcd(iflav(1),iflav(2),iflav(3),iflav(4),
     $                          iflav(5),colstr)
                     do m = 1,2
                        if(lflav(m).eq.21) lflav(m) = 0
                     enddo
                     res(k) = POLCOL(k) * SQ00(colstr) *
     $                        pdf1(ip(1)*lflav(1))*pdf2(ip(2)*lflav(2))  
                  enddo
               endif
            endif
 20         continue
         enddo
      enddo
   
      end
! ccccccccccccccccccccccccc end subroutine getRes4Q1GW
! ccccccc begin subroutine calpolcol ccccccccccc
!       subroutine calpolcol(flavor,factor)
!       implicit none
!       include 'global.inc'
!       integer flavor(np)        ! in: flavors
!       real*8 factor             ! out: polcol
! c local variables
!       integer idfl(np),i,j,nglu
!       real*8 lfactor
!       logical ldebug
!       parameter (ldebug=.false.)
! c
!       if (ldebug) then
!          print*,' '
!          print*,' Enter calpolcol '
!          print*,' flavor = ',flavor
!       endif
!       lfactor = 0.250d0         ! ave over initial state helicities
!       do i = nx+1,np            ! initialize identical flavor counter
!          idfl(i)=1
!       enddo
!       do i = nx+2,np
!          do j = nx+1,i-1
!             if ( flavor(i).eq.flavor(j) ) then
!                idfl(j)=idfl(j)+1
!             endif
!          enddo
!       enddo
!       if (ldebug) print*,' idfl = ',idfl
!       do i=nx+1,np-1
!          lfactor = lfactor/idfl(i)
!       enddo
!       if (ldebug) print*,' final S factor ',0.25d0/lfactor
! c The color average factor 
!       do i = 1,2
!          if(flavor(i).eq.21) then
!             lfactor = lfactor/8.0d0 ! gluon in i.s.
!          elseif (abs(flavor(i)).le.6 ) then
!             lfactor = lfactor/3.0d0 ! quark in i.s.
!          endif
!       enddo
!       if (ldebug) then
!          print*,' polcol = 1/',1/lfactor
!          !pause
!       endif
!       factor = lfactor
!       return
!       end 
! ccccccccccccc end subroutine ccccccccccccccccccccccccccccc


