c
c	Dieter Zeppenfeld, <dieter@pheno.physics.wisc.edu>
c       Rob Szalapski, <robs@theory.kek.jp>
c       Terrance Figy, <terrance@pheno.physics.wisc.edu>
c	Initial version:  1995 March 24
c	Last modified:    2001 June 14
c
      real*8 function m2s_z2j(
     &                   bosC,  !in:  Id for virtual Z/gamma case
     &                   lflavr,!in:  flavor ID for decay leptons
     &                   xi,	!in:  Feynman x parameters of incoming fermions
     &                   p,	!in:  momenta associated with external fermions
     &                   v,	!in:  momenta associated with WW decay fermions
     &                   rn	!in:  random numbers, first 2 used here
!!     &                   qsq    !out:  generated event Q^2
     &                        )
      implicit none

c
c declare input/output variables
c
#include "VBFNLO/utilities/global.inc"
#include "VBFNLO/utilities/lha.inc"
c      #include "hepup_add.inc"
#include "VBFNLO/utilities/tau_hel.inc"
cccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c     commom block for diagrammatic labels:
      integer idq,idg
      common/diagram/ idq(1:4),idg(1:2)
ccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      real*8
     $     xi(nx), p(0:3,max_p), v(0:3,max_v), rn(2), qsq
      integer doublid, bosC

c  For transformation of old notation
      integer njets,
     $     maxjets
      parameter (maxjets = max_p - nx)
c
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
C	VARIABLES FOR INPUT TO KOPPLN
c      REAL*8
c     $     K_ALFAS, K_XMT, K_ALFA, K_XMZ, K_XMW, K_SIN2W, K_XMH
c      COMMON /BKOPIN/
c     $     K_ALFAS, K_XMT, K_ALFA, K_XMZ, K_XMW, K_SIN2W, K_XMH
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c declare global variables
c
#include "VBFNLO/utilities/coupl.inc"
#include "VBFNLO/utilities/scales.inc"
c
c declare external functions
c
      integer  FL4qcd
      external FL4qcd
      external getRes4Q
      external getRes2Q2G
c
c
      real*8
     $     alphas5
      external
     $     alphas5
c  
      integer ProcessNumber
      logical firstTimeThrough
      save firstTimeThrough
      data firstTimeThrough /.true./
!       logical bquarkoff
!       parameter (bquarkoff = .true.)
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c     Variables for use in summation over flavors and what not.

      INTEGER
     $     LFLAVR(2), LPOL(2), bos, bosii    
      INTEGER
     $     FSIGNQ(4), GSIGN(3), LSIGN(2), I, J, ires_min, ires_max,
     $     num2gprocs
!, colorprocess1
      save ires_min, ires_max
      REAL*8
     $     PBARQ(0:3,4), QBAR(0:4,3), LBAR(0:3,2), RV(2,2,0:6),
     $     PBARQF(0:3,4), QBARF(0:4,3), RES(1:maxnumsubproc),
     $     wtot,w4q,w2g,weight
      Real*8
     $     RV4QI(-2:2,0:4),RV4QN(-2:2,-2:2,0:4)
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      integer ip(1:2)  ! determines type of accelerator
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c declare parton distribution variables
c     
      real*8
     $     pdf1(-6:6), pdf2(-6:6)
c
ccccccccccccccccccccccccccccccccccccccccc
c
      real*8
     $     qsq_al, qsq_sf, q_sf
      real*8
     $     ptmin,pt(maxjets)
cccccc      include 'm2s_Z2j.inc'
      logical ldebug	
      real*8 ptsa
      data ldebug /.false./		!output debug information
      data ptsa /0.00d0/
      real*8 rnumb,RandomNumber


		!scale for TSA, not used if < 1d-2

      ip(1) = sign1
      ip(2) = sign2

      njets = n_p - nx
ccccccccccccccccccccccccccccccccccccccccc
      if ( firstTimeThrough ) then
C     DEFINE COUPLINGS FOR KOPPEL
c         K_ALFAS = 0.119d0
c         K_XMT   = tmass
c         K_ALFA  = ALPHA	
c         K_XMZ   = zmass
c         K_XMW   = wmass
c         K_SIN2W = sin2w
c         K_XMH   = hmass
c
c         CALL KOPPLN(2)
c
         if(bosC.eq.2) then
            write(6,*)'This is the Z/gamma case.'
            call printnfl(.false.)
            bosii = 2
         else
            stop
         endif
c
         write(6,*) ' '
         write(6,*) 'Z2j  amplitude square information:'
         write(6,*) '--------------------------------------------------'
c         write(6,*) ' first event at sqrt(s) = ',
c     &           sqrt(4*p(0,1)*p(0,2)/(xi(1)*xi(2)))
c         write(6,*) ' '
c 
         do i = 1,2
            IDBMUP(i) = ip(i)*2212
            EBMUP(i) = p(0,i)/xi(i)
         enddo
c         print*,IDBMUP,EBMUP
c
!!!!!!!!!!!!!!         call calc_qsq(bosC,firstTimeThrough,def_qsq,p,v,qsq_al,qsq_sf)
c

         write (6,*) ' '
c         if (ptsa.gt.1d-2) then
c            write(6,171) ' 1-exp(-pt^2/p_TSA^2) TSA used with p_TSA =',
c     $          ptsa,' GeV.'
c 171        format(a,f8.2,a)
c         else
c            write(6,*) ' no TSA reduction factor used '
c         endif
c         print*,' alphas = ',alfas,' alphas(m_Z) = ',alphas5(91.189d0**2,0)
      endif
         
      if (ldebug) then
         print*,' ip(1),ip(2),bos = ', ip,bosii,bosC
         print*,' lflavr = ',lflavr
      endif

!!!!!!!!!!!!!      call calc_qsq(bosC,.false.,def_qsq,p,v,qsq_al,qsq_sf)
      qsq_sf = mufsq(1,1)

      qsq = qsq_sf
c
c if desired, print output information
c
      if ( ldebug ) then
         write(6,*) ' '
 10      format( ' p(', i1, ') = ', 4(f8.1, 2x) )
 20      format( ' v(', i1, ') = ', 4(f8.1, 2x) )
c
         write(6,*) ' '
         do i = 1, n_p
            write(6,10) i, p(0,i), p(1,i), p(2,i), p(3,i)
         end do
         do i = 1, n_v
            write(6,20) i, v(0,i), v(1,i), v(2,i), v(3,i)
         end do
c
         write(6,*) ' '
         write(6,*) 'xi(1), xi(2) =', xi
         write(6,*) 'event Q^2 =', qsq_sf
      end if
c
c call PDF subroutine in order to determine parton
c distributions in the incoming (anti)protons.
c ignore bottom and top contributions.
c
      q_sf = sqrt(qsq_sf)
      call pdfproton( xi(1), q_sf, pdf1 )
      do i = -6,6
         pdf1(i) = pdf1(i)/xi(1)
      enddo

      call pdfproton(xi(2), q_sf, pdf2 )
      do i = -6,6
         pdf2(i) = pdf2(i)/xi(2)
      enddo
c
!       if(bquarkoff) then
!          pdf1(5)  = 0
!          pdf1(-5) = 0
!          pdf2(5)  = 0
!          pdf2(-5) = 0
!       endif
c
c calculate alphas
c$$$      if (def_qsq.eq.6) then
c$$$         ALS = 1.0d0
c$$$         do i = 1, njets
c$$$            pt(i) = p(1,nx+i)**2 + p(2,nx+i)**2
c$$$            ALS  = ALS*alphas( pt(i) )
c$$$         enddo
c$$$         ALS = ALS**(1.0d0/dble(njets))
c$$$      else
c$$$         ALS = ALPHAS( qsq_al )
c$$$      endif
c$$$      if (ldebug) then
c$$$         print*,' qsq_al = ',qsq_al,sqrt(qsq_al)
c$$$         print*,' alphas = ',als,' alphas(m_Z) = ',alphas(91.189d0**2)
c$$$      endif

      ptmin = 1d33
      do i = 1, njets
         ptmin = min( ptmin, pt(i) )
      enddo
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c    initialize counter in FL4qcd:
      ires_min = FL4qcd(1,1,1,1,-100000)+1
c
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
c
c
c
C	FROM JIM, ON 11/8/88
C	MODIFIED  ON 3/24/89 for the new Vjet code
C
C******************************************************************************
C
C	PATCH IN DIETERS SUBROUTINE TO EVALUATE SQUARED MATRIX ELEMENT FOR
C	
C	P PBAR -> Z + 2 JETS WITH Z -> lepton anti-lepton
C
C*******************************************************************************
c
c       
C     FIRST SET UP LEPTON
         BOS=10
         DO j=0,3
            LBAR(J,1)  = v(j,1) ! (anti-lepton)
            LBAR(J,2)  = v(j,2) ! (lepton)
         END DO
	
         LSIGN(1)  = -1
         LSIGN(2)  =  1
c
C----------------------------------------------------------------------------
c     use HCSLV2Q
C     G1 G2 -> QBAR1 Q2 Z
c     p1 p2    p3    p4    pythia labels
         idg(1) = 1
         idg(2) = 2
         idq(1) = 3
         idq(2) = 4
         
C     PUT MY MOMENTA INTO DIETERS FORMAT
         DO j = 0,3
            do i = 1,2
               QBAR(J,i)  = p(j,idg(i)) ! G	
               PBARQ(J,i) = p(j,idq(i)) ! QB
            enddo
         ENDDO	
c     
         QBAR(4,1) = 0.0d0
         QBAR(4,2) = 0.0d0
         QBARF(4,1) = 0.0d0
         QBARF(4,2) = 0.0d0
         
         FSIGNQ(1) = -1
         FSIGNQ(2) =  1
         GSIGN(1)  = -1
         GSIGN(2)  = -1
         

C     G + G -> U UBAR Z  	G + G -> D DBAR Z
C     
         CALL HCLV2Q('R',RN(1),2,PBARQ,FSIGNQ,QBAR,GSIGN,BOS,LBAR,
     $        LSIGN,LFLAVR,LPOL,RV)
C     
         call getRes2Q2G(res,fsignq,ip,pdf1,pdf2,RV,.false.)
C
C----------------------------------------------------------------------------

C     Q1 QBAR2 -> G1 G2 Z
c     p1 p2       p3 p4    pythia labels
         idg(1) = 3
         idg(2) = 4
         idq(1) = 1
         idq(2) = 2
c     
C     PUT MY MOMENTA INTO DIETERS FORMAT
         DO j = 0,3
            do i = 1,2
               QBAR(J,i)  = p(j,idg(i)) ! G	
               PBARQ(J,i) = p(j,idq(i)) ! QB
            enddo
         ENDDO	
      
         FSIGNQ(1) =  1
         FSIGNQ(2) = -1
         GSIGN(1)  =  1
         GSIGN(2)  =  1
                 
C     U UBAR -> G G V  	 C CBAR -> G G V 
c     D DBAR -> G G V    S SBAR -> G G V        B BBAR->G G V
         CALL HCLV2Q('R',RN(1),2,PBARQ,FSIGNQ,QBAR,GSIGN,BOS,LBAR,
     $        LSIGN,LFLAVR,LPOL,RV)
         if (ldebug) print*,' LPOL = ',LPOL
         call getRes2Q2G(res,fsignq,ip,pdf1,pdf2,RV,.true.)
c         
c      
C     BEAM FLIPPED = charge conj. process
c     UBAR U -> G G V    CBAR C -> G G V 
c     DBAR D -> G G V    SBAR S -> G G V        BBAR B->G G V
c 
c
C----------------------------------------------------------------------------
C     G1 Q1 -> Q2 G2 Z  and G1 QBAR2 -> QBAR1 G2 Z     
c     p1 p2    p3 p4    pythia
         idq(1) = 2
         idq(2) = 3
         idg(1) = 1
         idg(2) = 4
c     
C     PUT MY MOMENTA INTO DIETERS FORMAT
         DO j = 0,3
            do i = 1,2
               QBAR(J,i)  = p(j,idg(i)) ! G	
               PBARQ(J,i) = p(j,idq(i)) ! QB
            enddo
         ENDDO
    
        
         FSIGNQ(1) =  1
         FSIGNQ(2) =  1
         GSIGN(1)  = -1
         GSIGN(2)  =  1


C     G U -> G U V  		G C -> G C V
C     g d -> g d V              g s -> g s V 
c     g b -> g b V         
C     G UB -> G UB V  		G CB -> G CB V
C     G DB -> G DB V            G SB -> G SB V 
C     G BB -> G BB V         
         CALL HCLV2Q('R',RN(1),2,PBARQ,FSIGNQ,QBAR,GSIGN,BOS,LBAR,
     $        LSIGN,LFLAVR,LPOL,RV)
         if (ldebug) print*,' LPOL = ',LPOL
         call getRes2Q2G(res,fsignq,ip,pdf1,pdf2,RV,.true.)
c     flipped beam
         idq(1) = 1
         idg(1) = 2
c
         DO j = 0,3
            do i = 1,2
               QBARF(J,i)  = p(j,idg(i)) ! G	
               PBARQF(J,i) = p(j,idq(i)) ! QB
            enddo
         ENDDO
c     
         CALL HCLV2Q('R',RN(1),2,PBARQF,FSIGNQ,QBARF,GSIGN,BOS,LBAR,
     $        LSIGN,LFLAVR,LPOL,RV)
         if (ldebug) print*,' LPOL = ',LPOL
         call getRes2Q2G(res,fsignq,ip,pdf1,pdf2,RV,.true.)
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c                         end 2q2g subprocesses  
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
         if (ldebug) num2gprocs = numcolor  ! number of 2q2g subprocesses
c
C----------------------------------------------------------------------------
C     use ScLV4Q
C     4 TYPES OF CLASSIFICATIONS ACCORDING TO Z.& H.'S PAPER: MAD/PH/402
C     NOTE: idq(1) and idq(2) have same flavor
c         
c     CLASS (1):  Q1 QBAR2 -> QB3 Q4 Z
c                 p1 p2       p3  p4    pythia labels
c     (Q QB anihilation)
c
         idq(1) = 1
         idq(2) = 2
         idq(3) = 3
         idq(4) = 4
c
C     PUT MY MOMENTA INTO DIETERS FORMAT
         DO J=0,3
            do i = 1,4
               PBARQ(J,i) = p(j,idq(i)) ! Q IN	
            enddo
         END DO		 

         FSIGNQ(1) =  1
         FSIGNQ(2) = -1
         FSIGNQ(3) = -1
         FSIGNQ(4) =  1

CCCCC TAKE Q FROM THE LEFT AND QB FROM THE RIGHT

         CALL ScLV4Q('R',RN(1),PBARQ,FSIGNQ,BOS,LBAR,LSIGN,
     $        LFLAVR,LPOL,RV4QI,RV4QN)
         if (ldebug) print*,' LPOL = ',LPOL
         call getRes4Q(res,fsignq,ip,pdf1,pdf2,RV4QI,RV4QN,.true.,.true.)

CCCCC Q FROM THE RIGHT AND QB FROM THE LEFT is included as C conjugate
c
C----------------------------------------------------------------------------
c
C     CLASS (2):  Q1 Q3 -> Q2 Q4  Z 
c     (quark -quark elatic scattering)
c                 p1 p2    p3 p4     pythia labels
c     By charge conjugation invariance I will include
c     here also QBAR2 QB4 -> QBAR1 QB3 Z 
c     (qbar qbar elastic scattering)         
         idq(1) = 1
         idq(2) = 3
         idq(3) = 2
         idq(4) = 4
c     
C     PUT MY MOMENTA INTO DIETERS FORMAT
         DO J=0,3
            do i = 1,4
               PBARQ(J,i) = p(j,idq(i)) ! Q IN	
            enddo
         END DO	
    	 
      
         FSIGNQ(1) = 1
         FSIGNQ(2) = 1
         FSIGNQ(3) = 1
         FSIGNQ(4) = 1

         CALL ScLV4Q('R',RN(1),PBARQ,FSIGNQ,BOS,LBAR,LSIGN,
     $        LFLAVR,LPOL,RV4QI,RV4QN)
         if (ldebug) print*,' LPOL = ',LPOL

CCCCC TAKE all flavor combinations: no flipped beams needed
         call getRes4Q(res,fsignq,ip,pdf1,pdf2,RV4QI,RV4QN,.true.,.true.)

CCCCC qbar qbar scattering included as C conjugate process
c
C----------------------------------------------------------------------------
         
C     CLASS (3):  Q1 QB4 -> Q2 QB3  Z (quark-antiquark elastic scattering)
c                 p1 p2     p3 p4       pythia labels
         idq(1) = 1
         idq(2) = 3
         idq(3) = 4
         idq(4) = 2
c     
c     
C     PUT MY MOMENTA INTO DIETERS FORMAT
         DO J=0,3
            do i = 1,4
               PBARQ(J,i) = p(j,idq(i)) ! Q IN	
            enddo
         END DO	
	 

         FSIGNQ(1) =  1
         FSIGNQ(2) =  1
         FSIGNQ(3) = -1
         FSIGNQ(4) = -1

         CALL ScLV4Q('R',RN(1),PBARQ,FSIGNQ,BOS,LBAR,LSIGN,
     $        LFLAVR,LPOL,RV4QI,RV4QN)
         if (ldebug) print*,' LPOL = ',LPOL
         call getRes4Q(res,fsignq,ip,pdf1,pdf2,RV4QI,RV4QN,.true.,.false.)

CCCCC flipped beams included as C conjugate
CCCCC skip processes with 4 identical flavors: they were handled in class 1
c
C----------------------------------------------------------------------------
c
C     CLASS (4):   QBAR2 QB4 -> QBAR1 QB3 Z
c                  p1    p2     p3    p4      pythia labels
c     Included as charge conjugate in class (2)
c
C--------end 4q subprocesses-------------------------------------------     
C--------end subprocess evaluation-------------------------------------
c     Pick a subprocess
c---------------------------------------------------------------------- 
      if (firstTimeThrough) then

c         write(6,*) 'number of subprocesses = ',numcolor
c         write(6,*) 'number of decay channels = ',numdecay
         ires_max = numcolor
         if (ldebug) then
            print*,' 2 gluon processes: ',num2gprocs
            print*,' 4 quark processes: ',numcolor-num2gprocs
            print*,' ires limits are ',ires_min, ires_max
         endif
!!!!!!!!!!!!!!!!!!!         call writeHEPUPtable
         firstTimeThrough = .false.
      endif
      wtot = 0.0d0
      do i = ires_min,ires_max
         wtot = wtot + res(i)
      enddo
      
c...Les Houches interface - the most propable subprocess   
      if ((lha.or.hepmc).and..not.doNLO) then
         i=0
         weight=0.d0
         rnumb=RandomNumber()
         do while((i.le.ires_max).and.(weight.le.rnumb*wtot))
            i=i+1
            weight=weight+res(i)
            iprocess=i
         enddo
      endif


      scalup = q_sf
      AQEDUP = ALPHA
      AQCDUP = ALS(1,1)

C include polarization of decay leptons. For C conjugate processes the 
C couplings are for opposite chiralities, i.e. physical polarizations 
C of antiparticles are also given by lpol
c      if (isFromC(ColorProcess1)) DecayProcess = mod(DecayProcess+2,3)+4
      do i=1,2
c         idup(n_p+1+i) = lidup(n_p+1+i,DecayProcess)
         helicity(i)=lpol(i)
      enddo

      tauchi(1)=lpol(1)
      tauchi(2)=-lpol(2)
c
c
      m2s_z2j = wtot * (ALS(1,1)/alfas)* (ALS(2,1)/alfas)       ! m2s_z2j
      
c     
      RETURN
      END

ccccccccccccccBegin Subroutine getRes2Q2Gcccccccccccccc

      subroutine getRes2Q2G(res,fsignq,ip,pdf1,
     $     pdf2,bosamp,ComCC)
      implicit none

#include "VBFNLO/utilities/global.inc"
#include "VBFNLO/utilities/lha.inc"
c      include 'hepup_add.inc'

      integer  FL4qcd
      external FL4qcd
c     commom block for diagrammatic labels:
      integer idq,idg !in: dia to pythia labels
      common/diagram/ idq(1:4),idg(1:2)
c
      real*8 res(1:maxNumSubProc)  !out: subprocess cross-sections
      integer fsignq(4)            !in: quark signs
      real*8 pdf1(-6:6),pdf2(-6:6) !in: pdf's
      real*8 bosamp(2,2,0:6)       !in: amplitude for Z2Q2G-make local
      logical ComCC                !in: true if charge conj is calculated
      real*8 POLCOL             ! ave over intial polarizations
      integer ip(1:2) !in: sign to distinguish incident proton or antiproton 
c     local variables
      logical gluon
      
      integer colstr,j,ifl,ic,k,i,icmax 
c     ic = 1,2 for direct, charge conjugate process
c     ifl = 1,2 for ddggV and uuggV 
      integer iflav(1:4)

c     Should I compute the CC? 
      if(ComCC) then
         icmax = 2
      else
         icmax = 1
      endif
c
      do ic = 1,icmax           ! direct and charge conjugate procs
         do colstr = 1,2        ! Two color flows.
            do j = 1,5          ! d,u,s,c,b quark
               if(ic.eq.1) then ! direct
                  iflav(idq(1)) = j*fsignq(1)
                  iflav(idq(2)) = j*fsignq(2)
               else             ! charge conjugate process
c let's try this
                  iflav(idq(1)) = -j*fsignq(1)
                  iflav(idq(2)) = -j*fsignq(2)
               endif
               ifl = mod(j+1,2)+1     ! = 1 for d,s,b, =2 for u,c
               iflav(idg(1)) = 21
               iflav(idg(2)) = 21
               k = FL4qcd(iflav(1),iflav(2),iflav(3),iflav(4),colstr)

c  pick polcol
               gluon = (iflav(1).eq.21)
               if(gluon) then   ! two spins 8 colors
                  polcol = 1.0d0/(2.0d0 * 8.0d0)
               else
                  polcol = 1.0d0/(2.0d0 * 3.0d0) ! its a quark 
               endif
               gluon = (iflav(2).eq.21)
               if(gluon) then
                  polcol = polcol * 1.0d0/(2.0d0 * 8.0d0)
               else
                  polcol = polcol * 1.0d0/(2.0d0 * 3.0d0)
               endif
               if(iflav(3).eq.iflav(4)) polcol = polcol/2.0d0
c
c     pick parton distributions
c     write(*,*)'2Q2G sub proc k=',k
               do i = 1,4
                  if(iflav(i).eq.21) then
                     iflav(i) = 0 ! pdf label for gluon
                  endif
               enddo
               res(k) = bosamp(ic,ifl,colstr)*POLCOL*
     $              pdf1(ip(1)*iflav(1)) * pdf2(ip(2)*iflav(2)) 
c               isFromC(k)=ic.eq.2
            enddo               ! colstr
         enddo                  ! quarks
      enddo                     ! ic
      return
      end
c 
ccccccccccccccccccccccccc end subroutine getRes2Q3G
c
ccccccccccccccBegin Subroutine getRes4Qcccccccccccccc

      subroutine getRes4Q(res,fsignq,ip,pdf1,
     $     pdf2,RVI,RVNI,ComCC,noskip)
      implicit none

#include "VBFNLO/utilities/global.inc"
#include "VBFNLO/utilities/lha.inc"
c      include 'hepup_add.inc'

      integer  FL4qcd
      external FL4qcd
c     commom block for diagrammatic labels:
      integer idq,idg !in: dia to pythia labels
      common/diagram/ idq(1:4),idg(1:2)
c
      real*8 res(1:maxNumSubProc) !out: subprocess cross-sections
      integer fsignq(4) !in: quark signs
      real*8 pdf1(-6:6),pdf2(-6:6) !in: pdf's
      real*8 
     $     RVNI(-2:2,-2:2,0:4),RVI(-2:2,0:4) !in: amplitude for Z4Q
      real*8 POLCOL, polcol0    ! ave over intial polarizations and colors
      integer ip(1:2) !in: sign to distinguish incident proton or antiproton
      logical ComCC             !true if the charge conj. is calculated
      logical noskip            !false if identical flavor processes ARE to
                                !be skipped because they were handled before
c     local variables
      integer colstr,q,j,icmax,ic
      integer k,ifl1,ifl3
      integer iflav(1:4)
      logical q1equalq3

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc          
c
      polcol0 = 1.0d0/(4.0d0 * 9.0d0) 
c    
c     Select icmax
      if(ComCC) then
         icmax = 2
      else 
         icmax = 1
      endif
c
      do ic = 1,icmax 
         do j = 1,nfl           ! u,d,s,c,b quarks
            do q =1,nfl         ! u,d,s,c,b quarks
               if(ic.eq.1) then ! direct process
                  iflav(idq(1)) = j *fsignq(1)
                  iflav(idq(2)) = j *fsignq(2)
                  iflav(idq(3)) = q * fsignq(3)
                  iflav(idq(4)) = q * fsignq(4)
                  
                  ifl1 = mod(j+1,2)+1
                  ifl3 = mod(q+1,2)+1
               else             ! charge conj process
c let's try this
                  iflav(idq(1)) = -j *fsignq(1)
                  iflav(idq(2)) = -j *fsignq(2)
                  iflav(idq(3)) = -q * fsignq(3)
                  iflav(idq(4)) = -q * fsignq(4)
                  
                  ifl1 = mod(j+1,2)+1
                  ifl1 = -ifl1
                  ifl3 = mod(q+1,2)+1
                  ifl3 = -ifl3
               endif
                     
c     pick polcol 
               if(iflav(3).eq.iflav(4)) then
                  polcol = polcol0/2.0d0 
               else
                  polcol = polcol0
               endif
c     pick amplitude
c     
c     Check if ifl1 and ifl3 are the same.
c
               q1equalq3 = j.eq.q
c     
               if(q1equalq3 .and. noskip) then ! q1 and q3 are same
c     
                  do colstr = 1,2 ! two color flows
                     k = FL4qcd(iflav(1),iflav(2),iflav(3),iflav(4),colstr)
                     res(k) = POLCOL * RVI(ifl1,colstr)
                     res(k) = res(k)*
     $                    pdf1(ip(1)*iflav(1))*pdf2(ip(2)*iflav(2))  
c                     isFromC(k)=ic.eq.2
                  enddo         ! colstr
               elseif ( .not.q1equalq3 ) then
                  colstr = 1
                  k = FL4qcd(iflav(1),iflav(2),iflav(3),iflav(4),colstr)
                  res(k) = POLCOL * RVNI(ifl1,ifl3,colstr)
                  res(k) = res(k)*
     $                     pdf1(ip(1)*iflav(1))*pdf2(ip(2)*iflav(2))  
c                  isFromC(k)=ic.eq.2
               endif
            enddo               ! quark flavors
         enddo                  ! quark flavors
      enddo                     ! ic
      return
      end

ccccccccccccccccccccccccc end subroutine getRes4Q

      integer function FL4qcd(if1,if2,if3,if4,colstr)
c     Terrance Figy
c     June 12,2001
c     if1,2 are flavor identifiers for incoming partons
c     if3,4 are flavor identifiers for outgoing partons
c
c     However, note that colstruc is also a flag:
c     if colstr = -1, then we are resetting the process counter to 0
c
      Implicit none
#include "VBFNLO/utilities/global.inc"
#include "VBFNLO/utilities/lha.inc"
c     COMMOM BLOCK FOR DIAGRAMMATIC LABELS
      integer idq,idg
      common/diagram/ idq(1:4),idg(1:2)
c     This commom block must be in m2s.
c
c     common block for the number of colored processes

      integer i,if1,if2,if3,if4,colstr
      integer listp
      save listp
      integer numresets
      save numresets
c      integer,save :: listp ! this is the list position
c      integer,save :: numresets
      data numresets /-1/
      data listp /0/

      if (colstr.le.-1) then  ! we are resetting
c     write(*,*) 'in FL4 we are resetting'
         if (colstr.gt.-10000) then
            listp = -colstr
         else
            listp = 0
         endif
         numresets = numresets+1
      else
c increment the counter regardless of whether or not it's the 1st
c time throught
         listp = listp + 1
         if(numresets.eq.0 ) then
!             call fillColoredPartons(if1,if2,if3,if4,colstr,listp)
         endif                  ! numresets.eq.0
      endif
      numcolor = listp ! common block info
      FL4qcd   = listp ! outputed function 
c     
      end

! 
! ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
! c     begin fillColoredPartons
! c
! c     the only processes here are the following:
! c     4Q  2Q2G
! c  
! c     For 4Q there are 2 color structures.
! c      
! c    q2 ------------------------q1
! c               9
! c               6
! c               9
! c               6
! c    q4 -----------------------q3
! c            colstr=1
! c   
! c    q4 ------------------------q1
! c               9
! c               6
! c               9
! c               6
! c    q2 -----------------------q3
! c            colstr=2
! c
!            subroutine fillColoredPartons(if1,if2,if3,if4,colstr,listp1)
!            implicit none
! #include "VBFNLO/utilities/global.inc"
! #include "VBFNLO/utilities/lha.inc"
!            
! c          COMMOM BLOCK FOR DIAGRAMMATIC LABELS
!            integer idq,idg
!            logical isCC ! is charge conj. state
!            common/diagram/ idq(1:4),idg(1:2)
!            integer i,if1,if2,if3,if4,colstr,listp1,listp
!            integer ngluon,npart
!            parameter (npart = 4)
!            integer iflav(npart),p_i(1:2)
!            integer col(1:2),cid(1:2)
! c     cid is the color index, it 1 or 2
!            listp = listp1 + numdecay
!            lnup(listp) = numParticles-1 
! c
! c         lidprup(listposition)=listposition so we don't need to use it.
! c         scalup is same for all subprocesses
! c         lwgtup(listposition) is already stored in res(fl(....)) so
! c         there's
! c         no need to worry about it here.
! c           write(*,*) 'writing to lhepup'
! c
!            
!            listup(1,listp)=-1   !incoming quark or gluon
!            listup(2,listp)=-1
!            listup(3,listp)=1    !outgoin quark or gluon
!            listup(4,listp)=1   
! 
! c
! c         The particle codes:
!           lidup(1,listp)=if1     
!           lidup(2,listp)=if2
!           lidup(3,listp)=if3
!           lidup(4,listp)=if4
! 
! 
! c         lSPINUP goes here:
! c          do i = 1,4                   ! quarks and gluons are unpolarized
! c             lspinup(i,listp) = 9      ! handle them in fillhepup.f
! c          enddo
! c
! c         mothers:
!           do i = 3,npart
!              lmothup(1,i,listp) = 1
!              lmothup(2,i,listp) = 2
!           enddo
! c
! c     4Q and 2Q2G are the possibilities.
! c     First, count the number of gluons to decide whether
! c     4Q or 2Q2G.
!           iflav(1) = if1
!           iflav(2) = if2
!           iflav(3) = if3
!           iflav(4) = if4
!           ngluon = 0
!           do i = 1, npart
!              if(iflav(i).eq.21) then 
!                 ngluon = ngluon + 1
!              endif
!           enddo
! c
! c          write(*,*) 'hello'
! c     flip color and anticolor if charge conj. state
!           isCC = ((idq(1).gt.2).and.(iflav(idq(1)).gt.0)).or.
!      $         ((idq(1).lt.3).and.(iflav(idq(1)).lt.0))
!           if(isCC) then
!              cid(1) = 2
!              cid(2) = 1
!           else
!              cid(1) = 1
!              cid(2) = 2
!           endif
! c
!           do i = 1,2
!              col(i) = 0
!           enddo
!           if(ngluon.eq.0) then ! 4Q case             
!              col(colstr) = 1 ! selects color structure
! c
! c
!              if(idq(1).lt.3) then ! 1 and 2 are incoming pythia labels
!                 licolup(cid(1),idq(1),listp) = 501*col(1) +   
!      $               501*col(2) ! color
!                 licolup(cid(2),idq(1),listp) = 0 ! anti-color 
!              else
!                 licolup(cid(1),idq(1),listp) = 0 ! color
!                 licolup(cid(2),idq(1),listp) =  501*col(1) +   
!      $               501*col(2) ! anti-color
!              endif
! c     
!              if(idq(2).lt.3) then
!                 licolup(cid(1),idq(2),listp) = 0 ! color
!                 licolup(cid(2),idq(2),listp) = 502*col(1) +
!      $               501*col(2) ! anti-color
!              else
!                 licolup(cid(1),idq(2),listp) =502*col(1) +
!      $               501*col(2) ! color
!                 licolup(cid(2),idq(2),listp) = 0 ! anti-color  
!              endif
! c     
!              if(idq(3).lt.3) then
!                 licolup(cid(1),idq(3),listp) = 502*col(1) +
!      $               502*col(2)  ! color
!                 licolup(cid(2),idq(3),listp) = 0 ! anti-color
!              else
!                 licolup(cid(1),idq(3),listp) = 0 ! color
!                 licolup(cid(2),idq(3),listp) =  502*col(1) +
!      $               502*col(2) ! anti-color  
!              endif
! c
!              if(idq(4).lt.3) then
!                 licolup(cid(1),idq(4),listp) = 0 ! color
!                 licolup(cid(2),idq(4),listp) = 501*col(1) +
!      $               502*col(2)   ! anti-color
!              else
!                 licolup(cid(1),idq(4),listp) = 501*col(1) +
!      $               502*col(2)  ! color
!                 licolup(cid(2),idq(4),listp) = 0 ! anti-color  
!              endif
! c 
! c
!           else  ! 2Q2G case
! c     The next case goes here.
! c
! c     
! c    q2 -----<----------------<-------q1 
! c             0             0       
! c             0             0       
! c             0             0        
! c           g_pi(1)       g_pi(2) 
! c
! c        pi = (1),(12)   See HZ
! c    colstr =  1,   2      
! c     
!              select case(colstr)
!              case(1)
!                 do i = 1,2
!                    p_i(i) = i
!                 enddo
!              case(2)
!                 p_i(1) = 2
!                 p_i(2) = 1
!              endselect
! c
!              if(idq(1).lt.3) then  ! 1,2 are incoming
!                 licolup(cid(1),idq(1),listp) = 501 ! color
!                 licolup(cid(2),idq(1),listp) = 0 !anti-color
!              else
!                 licolup(cid(1),idq(1),listp) = 0 ! color
!                 licolup(cid(2),idq(1),listp) = 501 !anti-color
!              endif
! c
!              if(idq(2).lt.3) then  ! 1,2 are incoming
!                 licolup(cid(1),idq(2),listp) = 0 ! color
!                 licolup(cid(2),idq(2),listp) = 503 !anti-color
!              else
!                 licolup(cid(1),idq(2),listp) = 503 ! color
!                 licolup(cid(2),idq(2),listp) = 0 !anti-color
!              endif
! c
!              if(idg(p_i(1)).lt.3) then
!                 licolup(cid(1),idg(p_i(1)),listp) = 503 ! color
!                 licolup(cid(2),idg(p_i(1)),listp) = 502 !anti-color
!              else
!                 licolup(cid(1),idg(p_i(1)),listp) = 502 ! color
!                 licolup(cid(2),idg(p_i(1)),listp) = 503 !anti-color
!              endif
!              if(idg(p_i(2)).lt.3) then
!                 licolup(cid(1),idg(p_i(2)),listp) = 502 ! color
!                 licolup(cid(2),idg(p_i(2)),listp) = 501 !anti-color
!              else
!                 licolup(cid(1),idg(p_i(2)),listp) = 501 ! color
!                 licolup(cid(2),idg(p_i(2)),listp) = 502 !anti-color
!              endif
! c
!           endif
!           end ! fillColoredPartons
! c
