c
c	Dieter Zeppenfeld, <dieter@pheno.physics.wisc.edu>
c       Rob Szalapski, <robs@theory.kek.jp>
c       Terrance Figy, <terrance@pheno.physics.wisc.edu>
c	Initial version:  1995 March 24
c	Last modified:    2001 June 14
c
      real*8 function m2s_z3j(
     &                   bosC,  !in:  Id for virtual Z/gamma case
     &                   lflavr,!in:  flavor ID for decay leptons
     &                   xi,	!in:  Feynman x parameters of incoming fermions
     &                   p,	!in:  momenta associated with external fermions
     &                   v,	!in:  momenta associated with WW decay fermions
     &                   rn	!in:  random numbers, first 2 used here
!!     &                   qsq    !out:  generated event Q^2
     &                        )
      implicit none

c
c declare input/output variables
c
#include "VBFNLO/utilities/global.inc"
#include "VBFNLO/utilities/lha.inc"
  
      logical ldebug
      parameter (ldebug=.false.)
cccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c     commom block for diagrammatic labels:
      integer idq,idg
      common/diagram/ idq(1:4),idg(1:3)
ccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      real*8
     $     xi(nx), p(0:3,max_p), v(0:3,max_v), rn(2), qsq
      integer doublid, bosC

c

#include "VBFNLO/utilities/coupl.inc"
#include "VBFNLO/utilities/scales.inc"
c
c declare external functions
c
      integer  FL5qcd
      external FL5qcd
      external getRes4QG
      external getRes2Q3G
c
c
      real*8
     $     alphas5
      external
     $     alphas5
c  
      integer ProcessNumber
      logical firstTimeThrough
      save firstTimeThrough
      data firstTimeThrough /.true./
!       logical bquarkoff
!       parameter (bquarkoff = .true.)
!       logical ldebug
!       parameter (ldebug=.false.)
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c     Variables for use in summation over flavors and what not.

      INTEGER
     $     LFLAVR(2), LPOL(2), bos, bosii    
      INTEGER
     $     FSIGNQ(4), GSIGN(3), LSIGN(2), I, J, ires_min, ires_max,
     $     num3gprocs, colorprocess1, colorprocess
      save ires_min, ires_max
      REAL*8
     $     PBARQ(0:3,4), QBAR(0:4,3), LBAR(0:3,2), RV(2,2,0:6),
     $     PBARQF(0:3,4), QBARF(0:4,3), RES(1:maxnumsubproc),
     $     wtot,w4q,w2g,weight,inmom(0:3),outmom(0:3)
      Real*8
     $     RV4QI(-2:2,0:4),RV4QN(-2:2,-2:2,0:4)
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      integer ip(1:2)  ! determines type of accelerator
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c declare parton distribution variables
c     
      real*8
     $     pdf1(-6:6), pdf2(-6:6)
c
ccccccccccccccccccccccccccccccccccccccccc
c
      real*8
     $     qsq_al, qsq_sf, q_sf
!       include 'm2s_Z3j.inc'
      ip(1)=sign1
      ip(2)=sign2
ccccccccccccccccccccccccccccccccccccccccc
      if ( firstTimeThrough ) then
         if(bosC.eq.2) then
            write(6,*)'This is the Z/gamma case.'
            call printnfl(.false.)
            bosii = 2
         else
            stop
         endif
c 
         write(6,*) ' '
         write(6,*) 'Z3j  amplitude square information:'
         write(6,*) '--------------------------------------------------'
         write(6,*) ' first event at sqrt(s) = ',
     &           sqrt(4*p(0,1)*p(0,2)/(xi(1)*xi(2)))
         write(6,*) ' '
c 
         do i = 1,2
            IDBMUP(i) = ip(i)*2212
            EBMUP(i) = p(0,i)/xi(i)
         enddo
         print*,IDBMUP,EBMUP
c
!          if (bquarkoff) print*,' WARNING: bottom pdf set to zero '
      endif
         
      if (ldebug) then
         print*,' ip(1),ip(2),bos = ', ip,bosii,bosC
         print*,' lflavr = ',lflavr
      endif

!       call calc_qsq(bosC,.false.,def_qsq,p,v,qsq_al,qsq_sf)
      qsq_sf = mufsq(1,1)
      qsq = qsq_sf
c
c if desired, print output information
c
      if ( ldebug ) then
         write(6,*) ' '
 10      format( ' p(', i1, ') = ', 4(f8.1, 2x) )
 20      format( ' v(', i1, ') = ', 4(f8.1, 2x) )
c
         write(6,*) ' '
         do i = 1, n_p
            write(6,10) i, p(0,i), p(1,i), p(2,i), p(3,i)
         end do
         do i = 1, n_v
            write(6,20) i, v(0,i), v(1,i), v(2,i), v(3,i)
         end do
c momentum check
         do i = 0,3
            inmom(i)=(p(i,1)+p(i,2)) 
            
            outmom(i)=(p(i,3) + p(i,4) + p(i,5) + v(i,1) + v(i,2))
            write(6,*) inmom(i)-outmom(i)
         enddo
c
         write(6,*) ' '
         write(6,*) 'xi(1), xi(2) =', xi
         write(6,*) 'event Q^2 =', qsq_sf
      end if
c
c call PDF subroutine in order to determine parton
c distributions in the incoming (anti)protons.
c ignore bottom and top contributions.
c
      q_sf = sqrt(qsq_sf)
      call pdfproton( xi(1), q_sf, pdf1 )
      do i = -6,6
         pdf1(i) = pdf1(i)/xi(1)
      enddo
c      
      call pdfproton(xi(2), q_sf, pdf2 )
      do i = -6,6
         pdf2(i) = pdf2(i)/xi(2)
      enddo
c
!       if(bquarkoff) then
!          pdf1(5)  = 0
!          pdf1(-5) = 0
!          pdf2(5)  = 0
!          pdf2(-5) = 0
!       endif

ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c    initialize counter in FL4qcd:
      ires_min = FL5qcd(1,1,1,1,1,-100000)+1
c
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
c
c
c
C	FROM JIM, ON 11/8/88
C	MODIFIED  ON 3/24/89 for the new Vjet code
C
C******************************************************************************
C
C	PATCH IN DIETERS SUBROUTINE TO EVALUATE SQUARED MATRIX ELEMENT FOR
C	
C	P PBAR -> Z + 3 JETS WITH Z -> lepton anti-lepton
C
C*******************************************************************************
c
c       
C     FIRST SET UP LEPTON
         BOS=10
         DO j=0,3
            LBAR(J,1)  = v(j,1) ! (anti-lepton)
            LBAR(J,2)  = v(j,2) ! (lepton)
         END DO
	
         LSIGN(1)  = -1
         LSIGN(2)  =  1
c
         do i = 1,3
            QBAR(4,i) = 0.0d0   ! massless particles
            QBARF(4,i) = 0.0d0
         enddo

C----------------------------------------------------------------------------
c     use HCSLV2Q
C     G1 G2 -> QBAR1 Q2 G3 Z
c     p1 p2    p3    p4 p5  pythia labels
         idg(1) = 1
         idg(2) = 2
         idq(1) = 3
         idq(2) = 4
         idg(3) = 5
         
C     PUT MY MOMENTA INTO DIETERS FORMAT
         DO j = 0,3
            do i = 1,3
               QBAR(J,i)  = p(j,idg(i)) ! G	
            enddo
            do i = 1,2
               PBARQ(J,i) = p(j,idq(i)) ! QB
            enddo
         ENDDO	
c     
         
         FSIGNQ(1) = -1
         FSIGNQ(2) =  1
         GSIGN(1)  = -1
         GSIGN(2)  = -1
         GSIGN(3)  =  1
         

C     G + G -> Q + QBAR G ,Q = u,d,s,c,b
C     
         CALL HCLV2Q('R',RN(1),3,PBARQ,FSIGNQ,QBAR,GSIGN,BOS,LBAR,
     $        LSIGN,LFLAVR,LPOL,RV)
C     
         if (ldebug) print*,' LPOL = ',LPOL
         call getRes2Q3G(res,fsignq,ip,pdf1,pdf2,RV,.false.)
C
C----------------------------------------------------------------------------

C     Q1 QBAR2 -> G1 G2 G3 Z
c     p1 p2       p3 p4 p5   pythia labels
         idg(1) = 3
         idg(2) = 4
         idg(3) = 5
         idq(1) = 1
         idq(2) = 2
c     
C     PUT MY MOMENTA INTO DIETERS FORMAT
         DO j = 0,3
            do i = 1,3
               QBAR(J,i)  = p(j,idg(i)) ! G	
            enddo
            do i = 1,2
               PBARQ(J,i) = p(j,idq(i)) ! QB
            enddo
         ENDDO	
      
         FSIGNQ(1) =  1
         FSIGNQ(2) = -1
         GSIGN(1)  =  1
         GSIGN(2)  =  1
         GSIGN(3)  =  1
                 
C     U UBAR -> G G G V    C CBAR -> G G G V 
c     D DBAR -> G G G V    S SBAR -> G G G V        B BBAR->G G GV
         CALL HCLV2Q('R',RN(1),3,PBARQ,FSIGNQ,QBAR,GSIGN,BOS,LBAR,
     $        LSIGN,LFLAVR,LPOL,RV)
         if (ldebug) print*,' LPOL = ',LPOL
         call getRes2Q3G(res,fsignq,ip,pdf1,pdf2,RV,.true.)
c         
c      
C     BEAM FLIPPED = charge conj. process
c     UBAR U -> G G G V    CBAR C -> G G G V 
c     DBAR D -> G G G V    SBAR S -> G G G V        BBAR B->G G G V
c 
c
C----------------------------------------------------------------------------
C     G1 Q1 -> Q2 G2 G3 Z  and G1 QBAR2 -> QBAR1 G2 G3 Z     
c     p1 p2    p3 p4 p5   pythia
         idq(1) = 2
         idq(2) = 3
         idg(1) = 1
         idg(2) = 4
         idg(3) = 5
c     
C     PUT MY MOMENTA INTO DIETERS FORMAT
         DO j = 0,3
            do i = 1,3
               QBAR(J,i)  = p(j,idg(i)) ! G	
            enddo
            do i = 1,2
               PBARQ(J,i) = p(j,idq(i)) ! QB
            enddo
         ENDDO
    
        
         FSIGNQ(1) =  1
         FSIGNQ(2) =  1
         GSIGN(1)  = -1
         GSIGN(2)  =  1
         GSIGN(3)  =  1


C     G U -> G U gV  		G C -> G C gV
C     g d -> g d gV              g s -> g s gV 
c     g b -> g b gV         
C     G UB -> G UB gV  		G CB -> G CB gV
C     G DB -> G DB gV            G SB -> G SB gV 
C     G BB -> G BB gV         
         CALL HCLV2Q('R',RN(1),3,PBARQ,FSIGNQ,QBAR,GSIGN,BOS,LBAR,
     $        LSIGN,LFLAVR,LPOL,RV)
         if (ldebug) print*,' LPOL = ',LPOL
         call getRes2Q3G(res,fsignq,ip,pdf1,pdf2,RV,.true.)
c     flipped beam
         idq(1) = 1
         idg(1) = 2
c
         DO j = 0,3
            do i = 1,3
               QBARF(J,i)  = p(j,idg(i)) ! G	
            enddo
            do i = 1,2
               PBARQF(J,i) = p(j,idq(i)) ! QB
            enddo
         ENDDO
c     
         CALL HCLV2Q('R',RN(1),3,PBARQF,FSIGNQ,QBARF,GSIGN,BOS,LBAR,
     $        LSIGN,LFLAVR,LPOL,RV)
         if (ldebug) print*,' LPOL = ',LPOL
         call getRes2Q3G(res,fsignq,ip,pdf1,pdf2,RV,.true.)
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c                         end 2q3g subprocesses  
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
         if (ldebug .or. firstTimethrough) 
     &       num3gprocs = numcolor  ! number of 2q3g subprocesses
c
C----------------------------------------------------------------------------
C     use ScLV4Q
C     6 TYPES OF CLASSIFICATIONS ACCORDING TO Z.& H.'S PAPER: MAD/PH/402
C     NOTE: idq(1) and idq(2) have same flavor
c         
c     CLASS (1):  Q1 QBAR2 -> QB3 Q4 G Z
c                 p1 p2       p3  p4 p5    pythia labels
c     (Q QB anihilation)
c
         idq(1) = 1
         idq(2) = 2
         idq(3) = 3
         idq(4) = 4
         idg(1) = 5
c
C     PUT MY MOMENTA INTO DIETERS FORMAT
         DO J=0,3
            do i = 1,4
               PBARQ(J,i) = p(j,idq(i)) ! Q IN	
            enddo
            QBAR(J,1) = p(j,idg(1)) ! gluon
         END DO		 

         FSIGNQ(1) =  1
         FSIGNQ(2) = -1
         FSIGNQ(3) = -1
         FSIGNQ(4) =  1
         GSIGN(1)  =  1

CCCCC TAKE Q FROM THE LEFT AND QB FROM THE RIGHT

         CALL ScLV4QG('R',RN(1),PBARQ,FSIGNQ,QBAR,GSIGN,BOS,
     $        LBAR,LSIGN,LFLAVR,LPOL,RV4QI,RV4QN)
         if (ldebug) print*,' LPOL = ',LPOL
         call getRes4QG(res,fsignq,ip,pdf1,pdf2,RV4QI,RV4QN,.true.,.true.)

         if (ldebug) print*,' after 4Q1g class 1:',numcolor
CCCCC Q FROM THE RIGHT AND QB FROM THE LEFT is included as C conjugate
c
C----------------------------------------------------------------------------
c
C     CLASS (2):  Q1 Q3 -> Q2 Q4 G  Z 
c     (quark -quark elatic scattering)
c                 p1 p2    p3 p4 p5    pythia labels
c     By charge conjugation invariance I will include
c     here also QBAR2 QB4 -> QBAR1 QB3 Z 
c     (qbar qbar elastic scattering)         
         idq(1) = 1
         idq(2) = 3
         idq(3) = 2
         idq(4) = 4
         idg(1) = 5
c     
C     PUT MY MOMENTA INTO DIETERS FORMAT
         DO J=0,3
            do i = 1,4
               PBARQ(J,i) = p(j,idq(i)) ! Q IN	
            enddo
            QBAR(J,1) = p(j,idg(1))
         END DO	
    	 
      
         FSIGNQ(1) = 1
         FSIGNQ(2) = 1
         FSIGNQ(3) = 1
         FSIGNQ(4) = 1
         GSIGN(1)  = 1

         CALL ScLV4QG('R',RN(1),PBARQ,FSIGNQ,QBAR,GSIGN,
     $        BOS,LBAR,LSIGN,LFLAVR,LPOL,RV4QI,RV4QN)
         if (ldebug) print*,' LPOL = ',LPOL

CCCCC TAKE all flavor combinations: no flipped beams needed
         call getRes4QG(res,fsignq,ip,pdf1,pdf2,RV4QI,RV4QN,.true.,
     $        .true.)

         if (ldebug) print*,' after 4Q1g class 2:',numcolor
CCCCC qbar qbar scattering included as C conjugate process
c
C----------------------------------------------------------------------------
         
C     CLASS (3):  Q1 QB4 -> Q2 QB3 G  Z (quark-antiquark elastic scattering)
c                 p1 p2     p3 p4  p5     pythia labels
         idq(1) = 1
         idq(2) = 3
         idq(3) = 4
         idq(4) = 2
         idg(1) = 5
c     
c     
C     PUT MY MOMENTA INTO DIETERS FORMAT
         DO J=0,3
            do i = 1,4
               PBARQ(J,i) = p(j,idq(i)) ! Q IN	
            enddo
            QBAR(J,1) = p(j,idg(1))
         END DO	
	 

         FSIGNQ(1) =  1
         FSIGNQ(2) =  1
         FSIGNQ(3) = -1
         FSIGNQ(4) = -1
         GSIGN(1) = 1


         CALL ScLV4QG('R',RN(1),PBARQ,FSIGNQ,QBAR,GSIGN,
     $        BOS,LBAR,LSIGN,LFLAVR,LPOL,RV4QI,RV4QN)
         if (ldebug) print*,' LPOL = ',LPOL
         call getRes4QG(res,fsignq,ip,pdf1,pdf2,RV4QI,RV4QN,.true.,
     $        .false.)

         if (ldebug) print*,' after 4Q1g class 3:',numcolor
CCCCC flipped beams included as C conjugate
CCCCC skip processes with 4 identical flavors: they were handled in class 1
c
C----------------------------------------------------------------------------
c
C     CLASS (4):   QBAR2 QB4 -> QBAR1 QB3 G Z
c                  p1    p2     p3    p4  p5    pythia labels
         if (ldebug) print*,' after 4Q1g class 4:',numcolor
c     Included as charge conjugate in class (2)
c----------------------------------------------------------------------
c     Class(5) : g q1 -> q2 qb3 q4 Z
c                p1 p2   p3 p4  p5
c     By charge conj.inv., put g qbar2 -> qbar1 qb3 q4 Z together
         idq(1) = 2
         idq(2) = 3
         idq(3) = 4
         idq(4) = 5
         idg(1) = 1
c
c PUT MY MOMENTA INTO DIETERS FORMAT
c
         DO J=0,3
            do i = 1,4
               PBARQ(J,i) = p(j,idq(i)) ! Q IN	
            enddo
            QBAR(J,1) = p(j,idg(1))
         END DO	
c	 
         FSIGNQ(1) =  1
         FSIGNQ(2) =  1
         FSIGNQ(3) = -1
         FSIGNQ(4) =  1
         GSIGN(1) = -1
c         
         CALL ScLV4QG('R',RN(1),PBARQ,FSIGNQ,QBAR,GSIGN,
     $        BOS,LBAR,LSIGN,LFLAVR,LPOL,RV4QI,RV4QN)
         if (ldebug) print*,' LPOL = ',LPOL
         call getRes4QG(res,fsignq,ip,pdf1,pdf2,RV4QI,RV4QN,.true.,
     $        .true.)
         if (ldebug) print*,' after 4Q1g class 5a:',numcolor
c beam flip
         idq(1) = 1
         idg(1) = 2
         DO J=0,3
            do i = 1,4
               PBARQF(J,i) = p(j,idq(i)) ! Q IN	
            enddo
            QBARF(J,1) = p(j,idg(1))
         END DO	
c
         CALL ScLV4QG('R',RN(1),PBARQF,FSIGNQ,QBARF,GSIGN,
     $        BOS,LBAR,LSIGN,LFLAVR,LPOL,RV4QI,RV4QN)
         if (ldebug) print*,' LPOL = ',LPOL
         call getRes4QG(res,fsignq,ip,pdf1,pdf2,RV4QI,RV4QN,.true.,
     $        .true.)
         if (ldebug) print*,' after 4Q1g class 5b:',numcolor
c----------------------------------------------------------------------
c class(6) : g q2bar -> qbar1 qb3 q4 Z 
c by charge conj. inv., this has been included in the above
c---------------------------------------------------------------------         
C--------end 4qg subprocesses-------------------------------------------     
C--------end subprocess evaluation-------------------------------------
c     Pick a subprocess
c---------------------------------------------------------------------- 
      if (firstTimeThrough) then

         write(6,*) 'number of subprocesses = ',numcolor
         write(6,*) 'number of decay channels = ',numdecay
         ires_max = numcolor
c         if (ldebug) then
            print*,' 2Q+3g processes: ',num3gprocs
            print*,' 4Q+1g processes: ',numcolor-num3gprocs
            print*,' ires limits are ',ires_min, ires_max
c         endif
!          call writeHEPUPtable
         firstTimeThrough = .false.
      endif
      wtot = 0.0d0
      do i = ires_min,ires_max
         wtot = wtot + res(i)
      enddo
      if(ldebug) then
         print*,'wtot =',wtot
!          pause
      endif
      ColorProcess=0
      weight=0.0d0
      i = ires_min
      do while((i.le.ires_max).and.(ColorProcess.eq.0))
            weight=weight+res(i)
         if(weight.ge.rn(2)*wtot) then
            ColorProcess = i
      endif
         i = i+1
      enddo

      if(ColorProcess.eq.0) then
         write(*,*)  'error in subprocess selection'
      elseif (ldebug) then
         write(*,*) 'processNumber=',colorprocess 
      endif
c
c     Fill in rest of HEPEUP common block
c     Below runs from 1+numdecay to numcolor + numdecay
      colorprocess1 = colorprocess + numdecay
c
      scalup = q_sf
      AQEDUP = ALPHA
      AQCDUP = ALS(1,1)

!       do i=1,max_p
!         idup(i)=lidup(i,ColorProcess1)
!         istup(i)=listup(i,ColorProcess1)
!         mothup(1,i)=lmothup(1,i,ColorProcess1)
!         mothup(2,i)=lmothup(2,i,ColorProcess1)
!         icolup(1,i)=licolup(1,i,ColorProcess1)
!         icolup(2,i)=licolup(2,i,ColorProcess1)
!         spinup(i)=9                          ! no polarization for partons
!       enddo
C include polarization of decay leptons. For C conjugate processes the 
C couplings are for opposite chiralities, i.e. physical polarizations 
C of antiparticles are also given by lpol
!       if (isFromC(ColorProcess1)) DecayProcess = mod(DecayProcess+2,3)+4
      do i=1,2
!          idup(max_p+1+i) = lidup(max_p+1+i,DecayProcess)
         spinup(n_p+1+i)=lpol(i)
      enddo
c
c
!       if(ldebug) pause
      m2s_z3j = wtot *(ALS(1,1)/alfas)**3        ! m2s_z3j
c     
      RETURN
      END
ccccccccccccccBegin Subroutine getRes2Q3Gcccccccccccccc
      subroutine getRes2Q3G(res,fsignq,ip,pdf1,
     $     pdf2,bosamp,ComCC)
      implicit none
#include "VBFNLO/utilities/global.inc"
#include "VBFNLO/utilities/lha.inc"
!       include 'hepup.inc'
      integer  FL5qcd
      external FL5qcd
c     commom block for diagrammatic labels:
      integer idq,idg !in: dia to pythia labels
      common/diagram/ idq(1:4),idg(1:3)
c
      real*8 res(1:maxNumSubProc)  !out: subprocess cross-sections
      integer fsignq(4)            !in: quark signs
      real*8 pdf1(-6:6),pdf2(-6:6) !in: pdf's
      real*8 bosamp(2,2,0:6)       !in: amplitude for Z2Q3G-make local
      logical ComCC                !in: true if charge conj is calculated
      integer ip(1:2) !in: sign to distinguish incident proton or antiproton 
c     local variables
      
      integer colstr,j,ifl,ic,k,i,icmax 
c     ic = 1,2 for direct, charge conjugate process
c     ifl = 1,2 for ddggV and uuggV 
      integer iflav(1:5)

      double precision polcol(2000)
      common /polcolz/ polcol
      
c     Should I compute the CC? 
      if(ComCC) then
         icmax = 2
      else
         icmax = 1
      endif
c
      do ic = 1,icmax           ! direct and charge conjugate procs
         do colstr = 1,6        ! six color flows.
            do j = 1,5          ! d,u,s,c,b quark
               if(ic.eq.1) then ! direct
                  iflav(idq(1)) = j*fsignq(1)
                  iflav(idq(2)) = j*fsignq(2)
               else             ! charge conjugate process
                  iflav(idq(1)) = -j*fsignq(1)
                  iflav(idq(2)) = -j*fsignq(2)
               endif
               ifl = mod(j+1,2)+1     ! = 1 for d,s,b, =2 for u,c
               iflav(idg(1)) = 21
               iflav(idg(2)) = 21
               iflav(idg(3)) = 21
               k = FL5qcd(iflav(1),iflav(2),iflav(3),iflav(4),iflav(5)
     $              ,colstr)
c
c     pick parton distributions
c     write(*,*)'2Q2G sub proc k=',k
               do i = 1,5
                  if(iflav(i).eq.21) then
                     iflav(i) = 0 ! pdf label for gluon
                  endif
               enddo
               res(k) = bosamp(ic,ifl,colstr)*polcol(k)*
     $              pdf1(ip(1)*iflav(1)) * pdf2(ip(2)*iflav(2)) 
!                isFromC(k)=ic.eq.2
            enddo               ! colstr
         enddo                  ! quarks
      enddo                     ! ic
      return
      end
c 
ccccccccccccccccccccccccc end subroutine getRes2Q3G
c
ccccccccccccccBegin Subroutine getRes4Q1Gcccccccccccccc
      subroutine getRes4QG(res,fsignq,ip,pdf1,
     $     pdf2,RVI,RVNI,ComCC,noskip)
      implicit none
#include "VBFNLO/utilities/global.inc"
#include "VBFNLO/utilities/lha.inc"
!       include 'hepup.inc'
      integer  FL5qcd
      external FL5qcd
c     commom block for diagrammatic labels:
      integer idq,idg !in: dia to pythia labels
      common/diagram/ idq(1:4),idg(1:3)
c
      real*8 res(1:maxNumSubProc) !out: subprocess cross-sections
      integer fsignq(4) !in: quark signs
      real*8 pdf1(-6:6),pdf2(-6:6) !in: pdf's
      real*8 
     $     RVNI(-2:2,-2:2,0:4),RVI(-2:2,0:4) !in: amplitude for Z4Q1G
      integer ip(1:2) !in: sign to distinguish incident proton or antiproton
      logical ComCC             !true if the charge conj. is calculated
      logical noskip            !false if identical flavor processes ARE to
                                !be skipped because they were handled before
c     local variables
      integer colstr,q,j,i,icmax,ic
      integer colstr1
      integer k,ifl1,ifl3
      integer iflav(1:5)
      logical q1equalq3
      
            double precision polcol(2000)
      common /polcolz/ polcol
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc          
 
c    
c     Select icmax
      if(ComCC) then
         icmax = 2
      else 
         icmax = 1
      endif
c
      do ic = 1,icmax 
         do j = 1,nfl        ! u,d,s,c,b quarks
            do q =1,nfl      ! u,d,s,c,b quarks
               do colstr = 1,4  ! 4 color flows
               if(ic.eq.1) then ! direct process
                  iflav(idq(1)) = j *fsignq(1)
                  iflav(idq(2)) = j *fsignq(2)
                  iflav(idq(3)) = q * fsignq(3)
                  iflav(idq(4)) = q * fsignq(4)
                     iflav(idg(1)) = 21 ! gluon
                  
                  ifl1 = mod(j+1,2)+1
                  ifl3 = mod(q+1,2)+1
               else             ! charge conj process
                  iflav(idq(1)) = -j *fsignq(1)
                  iflav(idq(2)) = -j *fsignq(2)
                  iflav(idq(3)) = -q * fsignq(3)
                  iflav(idq(4)) = -q * fsignq(4)
                     iflav(idg(1)) = 21 ! gluon
                  
                  ifl1 = mod(j+1,2)+1
                  ifl1 = -ifl1
                  ifl3 = mod(q+1,2)+1
                  ifl3 = -ifl3
               endif
                     
c     pick amplitude
c     
c     Check if ifl1 and ifl3 are the same.
c
               q1equalq3 = j.eq.q
c     
               if(q1equalq3 .and. noskip) then ! q1 and q3 are same
c     
                     k = FL5qcd(iflav(1),iflav(2),iflav(3),iflav(4),
     $                    iflav(5),colstr)
                     res(k) = polcol(k) * RVI(ifl1,colstr)
c     
                     iflav(idg(1)) = 0 ! pdf label for gluon
c     
                     res(k) = res(k)*
     $                    pdf1(ip(1)*iflav(1))*pdf2(ip(2)*iflav(2))  
!                      isFromC(k)=ic.eq.2
      
                     
               elseif ( .not.q1equalq3 ) then
  
                     k = FL5qcd(iflav(1),iflav(2),iflav(3),iflav(4),
     $                    iflav(5),colstr)
                     res(k) = polcol(k) * RVNI(ifl1,ifl3,colstr)
c     
                     iflav(idg(1)) = 0 ! pdf label for gluon
c     
                  res(k) = res(k)*
     $                     pdf1(ip(1)*iflav(1))*pdf2(ip(2)*iflav(2))  
!                      isFromC(k)=ic.eq.2
                  
               endif
            enddo               ! quark flavors
         enddo                  ! quark flavors
      enddo                     ! ic
      enddo                     !colstr
      return
      end
ccccccccccccccccccccccccc end subroutine getRes4Q
ccccccc begin subroutine calpolcol ccccccccccc
      subroutine calpolcol(flavor,factor)
      Implicit none
#include "VBFNLO/utilities/global.inc"
      integer flavor(n_p)        ! in: flavors
      real*8 factor             ! out: polcol
c local variables
      integer idfl(n_p),i,j,nglu
      real*8 lfactor
      logical ldebug
      parameter (ldebug=.false.)
c
      if (ldebug) then
         print*,' '
         print*,' Enter calpolcol '
         print*,' flavor = ',flavor
      endif
      lfactor = 0.250d0         ! ave over initial state helicities
      do i = nx+1,n_p            ! initialize identical flavor counter
         idfl(i)=1
          enddo
      do i = nx+2,n_p
         do j = nx+1,i-1
            if ( flavor(i).eq.flavor(j) ) then
               idfl(j)=idfl(j)+1
             endif
          enddo
          enddo
      if (ldebug) print*,' idfl = ',idfl
      do i=nx+1,n_p-1
         lfactor = lfactor/idfl(i)
                enddo
      if (ldebug) print*,' final S factor ',0.25d0/lfactor
c The color average factor 
      do i = 1,2
         if(flavor(i).eq.21.or.flavor(i).eq.0) then
            lfactor = lfactor/8.0d0 ! gluon in i.s.
         elseif (abs(flavor(i)).le.6 ) then
            lfactor = lfactor/3.0d0 ! quark in i.s.
             endif
      enddo
      if (ldebug) then
         print*,' polcol = 1/',1/lfactor
!          pause
          endif
      factor = lfactor
      return
      end 
ccccccccccccc end subroutine ccccccccccccccccccccccccccccc

      integer function FL5qcd(if1,if2,if3,if4,if5,colstr)
c     Terrance Figy
c     June 12,2001
c     if1,2 are flavor identifiers for incoming colored partons
c     if3,4,5 are flavor identifiers for outgoing colored partons
c
c     However, note that colstruc is also a flag:
c     if colstr = -1, then we are resetting.
c
      Implicit none
#include "VBFNLO/utilities/global.inc"
#include "VBFNLO/utilities/lha.inc"
c     COMMON BLOCK FOR DIAGRAMMATIC LABELS
      integer idq,idg    
      common/diagram/ idq(1:4),idg(1:3)
c     This common block must be in m2s.
c
      integer i,if1,if2,if3,if4,if5,colstr
      integer listp, iflav(5)
      save listp
      data listp /0/
      integer numresets
      save numresets
      data numresets /-1/
      
      double precision polcol(2000)
      common /polcolz/ polcol

      if (colstr.le.-1) then  ! we are resetting
c         write(*,*) 'in FL5 we are resetting'
         if (colstr.gt.-10000) then
            listp = -colstr
         else
            listp = 0
         endif
         numresets = numresets+1
      else
c increment the counter regardless of whether or not it's the 1st
c time throught
         listp = listp + 1
         if(numresets.eq.0) then
!             call fillColoredPartons(if1,if2,if3,if4,if5,
!      $           colstr,listp) 
            iflav(1) = if1
            iflav(2) = if2
            iflav(3) = if3
            iflav(4) = if4
            iflav(5) = if5
            call calpolcol(iflav,polcol(listp))
         endif                  ! numresets.eq.0
      endif
      numcolor = listp ! common block info
      FL5qcd = listp   ! output of function
c     
      end
